IMPLEMENTATION MODULE CDInit;
  (*/WIN:A*)
  
  IMPORT WDebugging,Windows,WResource;
  IMPORT MCParser,MCStruct,MParser;
  IMPORT NumberConversion;
  
  
  PROCEDURE DetermineCharacterInformation (instance : Windows.HINSTANCE; VAR result : MCStruct.CharacterResourceData);
    PROCEDURE InitializeCharacterBackground (instance : Windows.HINSTANCE; VAR result : ARRAY OF MCStruct.BackgroundInfoRecord);
      CONST
            BackgroundStringBase = 1000;
      
      VAR
          index : CARDINAL;
      
    BEGIN (* InitializeCharacterBackground *)
      FOR index := 0 TO HIGH (result) DO
        MCParser.LoadBackgroundInfoRecord (instance,BackgroundStringBase + index,result [index]);
      END; (* FOR *)
    END InitializeCharacterBackground;
    
    PROCEDURE InitializeCharacterClassInfo (instance : Windows.HINSTANCE; VAR result : ARRAY OF MCStruct.ClassAttributeRecord);
      CONST
            ClassAttributeStringBase = 850;
      
      VAR
          index : CARDINAL;
      
    BEGIN (* InitializeCharacterClassInfo *)
      FOR index := 0 TO HIGH (result) DO
        MCParser.LoadClassAttributeRecord (instance,ClassAttributeStringBase + index,result [index]);
      END; (* FOR *)
    END InitializeCharacterClassInfo;
    
    PROCEDURE InitializeCharacterClassTitles (instance : Windows.HINSTANCE; VAR result : ARRAY OF MCStruct.ClassTitleTable);
      CONST
            ClassTitleStringCursorBase = 200;
      
      VAR
          index : CARDINAL;
      
      PROCEDURE LoadClassTitleTable (instance : Windows.HINSTANCE; cursor : CARDINAL; VAR result : MCStruct.ClassTitleTable);
        VAR
            length : CARDINAL;
            index  : CARDINAL;
        
      BEGIN (* LoadClassTitleTable *)
        FOR index := 1 TO MCStruct.MaxPlayerLevel DO
          WResource.LoadString (instance,cursor + index - 1,result [index],length);
        END; (* FOR *)
      END LoadClassTitleTable;
      
    BEGIN (* InitializeCharacterClassTitles *)
      FOR index := 0 TO HIGH (result) DO
        LoadClassTitleTable (instance,ClassTitleStringCursorBase + 50 * index,result [index]);
      END; (* FOR *)
    END InitializeCharacterClassTitles;
    
    PROCEDURE InitializeCharacterExperienceTable (instance : Windows.HINSTANCE; VAR result : ARRAY OF LONGCARD);
      CONST
            ExperienceTableBaseCursor = 100;
      
      VAR
          index : CARDINAL;
      
      PROCEDURE LoadLongCardValue (instance : Windows.HINSTANCE; cursor : CARDINAL; VAR result : LONGCARD);
        VAR
            length : CARDINAL;
            temp   : ARRAY [0..31] OF CHAR;
            done   : BOOLEAN;
        
      BEGIN (* LoadLongCardValue *)
        WResource.LoadString (instance,cursor,temp,length);
        MParser.StringToLongCard (temp,result,done);
        
        IF NOT (done) THEN
          WDebugging.FatalAppExit ("Unable to convert string to LONGCARD value.");
        END; (* IF *)
      END LoadLongCardValue;
      
    BEGIN (* InitializeCharacterExperienceTable *)
      FOR index := 0 TO HIGH (result) DO
        LoadLongCardValue (instance,ExperienceTableBaseCursor + index,result [index]);
      END; (* FOR *)
    END InitializeCharacterExperienceTable;
    
    PROCEDURE InitializeCharacterRaceInfo (instance : Windows.HINSTANCE; VAR result : ARRAY OF MCStruct.RacialAttributeRecord);
      CONST
            RacialAttributeStringBase = 900;
      
      VAR
          index : CARDINAL;
      
    BEGIN (* InitializeCharacterRaceInfo *)
      FOR index := 0 TO HIGH (result) DO
        MCParser.LoadRacialAttributeRecord (instance,RacialAttributeStringBase + index,result [index]);
      END; (* FOR *)
    END InitializeCharacterRaceInfo;
    
    PROCEDURE InitializeCharacterSpellInfo (instance : Windows.HINSTANCE; VAR result : ARRAY OF MCStruct.SpellInfoTable);
      CONST
            SpellInfoStringBase = 600;
      
      VAR
          index : CARDINAL;
      
      PROCEDURE LoadSpellInfoTable (instance : Windows.HINSTANCE; cursor : CARDINAL; VAR result : MCStruct.SpellInfoTable);
        VAR
            index : CARDINAL;
        
      BEGIN (* LoadSpellInfoTable *)
        FOR index := 0 TO HIGH (result) DO
          MCParser.LoadSpellInfoRecord (instance,cursor + index,result [index]);
        END; (* FOR *)
      END LoadSpellInfoTable;
      
    BEGIN (* InitializeCharacterSpellInfo *)
      FOR index := 0 TO HIGH (result) DO
        LoadSpellInfoTable (instance,SpellInfoStringBase + 50 * index,result [index]);
      END; (* FOR *)
    END InitializeCharacterSpellInfo;
    
    PROCEDURE InitializeCharacterSpellNames (instance : Windows.HINSTANCE; VAR result : ARRAY OF MCStruct.SpellNameTable);
      CONST
            SpellNameStringBase = 500;
      
      VAR
          index : CARDINAL;
      
      PROCEDURE LoadSpellNameTable (instance : Windows.HINSTANCE; cursor : CARDINAL; VAR result : MCStruct.SpellNameTable);
        VAR
            length : CARDINAL;
            index  : CARDINAL;
        
      BEGIN (* LoadSpellNameTable *)
        FOR index := 0 TO HIGH (result) DO
          WResource.LoadString (instance,cursor + index,result [index],length);
        END; (* FOR *)
      END LoadSpellNameTable;
      
    BEGIN (* InitializeCharacterSpellNames *)
      FOR index := 0 TO HIGH (result) DO
        LoadSpellNameTable (instance,SpellNameStringBase + 50 * index,result [index]);
      END; (* FOR *)
    END InitializeCharacterSpellNames;
    
    PROCEDURE InitializeStoreResourceData (instance : Windows.HINSTANCE; VAR result : MCStruct.StoreResourceData);
      PROCEDURE InitializeStoreOwnerTable (instance : Windows.HINSTANCE; VAR result : ARRAY OF MCStruct.StoreOwnerRecord);
        CONST
              StoreOwnerCursorBase = 1200;
        
        VAR
            index : CARDINAL;
        
        PROCEDURE LoadStoreOwnerRecord (instance : Windows.HINSTANCE; cursor : CARDINAL; VAR result : MCStruct.StoreOwnerRecord);
          VAR
              length : CARDINAL;
              str    : ARRAY [0..255] OF CHAR;
          
          PROCEDURE ParsePlayerRaceMnemonic (VAR str : ARRAY OF CHAR; term : CHAR; VAR result : MCStruct.PlayerRaceMnemonic);
            VAR
                temp : CARDINAL;
            
          BEGIN (* ParsePlayerRaceMnemonic *)
            MParser.ParseCardinalValue (str,term,temp);
            result := VAL (MCStruct.PlayerRaceMnemonic,temp);
          END ParsePlayerRaceMnemonic;
          
        BEGIN (* LoadStoreOwnerRecord *)
          WResource.LoadString (instance,cursor,str,length);
          
          WITH result DO
            MParser.ParseLiteralString (str,MParser.StandardItemTerminator,description);
            MParser.ParseLongIntValue (str,MParser.StandardItemTerminator,priceLIMIT);
            MParser.ParseLongIntValue (str,MParser.StandardItemTerminator,inflateMAX);
            MParser.ParseLongIntValue (str,MParser.StandardItemTerminator,inflateMIN);
            MParser.ParseLongIntValue (str,MParser.StandardItemTerminator,haggleRATE);
            ParsePlayerRaceMnemonic (str,MParser.StandardItemTerminator,race);
            MParser.ParseCardinalValue (str,MParser.FinalItemTerminator,insultLIMIT);
          END; (* WITH *)
        END LoadStoreOwnerRecord;
        
      BEGIN (* InitializeStoreOwnerTable *)
        FOR index := 0 TO HIGH (result) DO
          LoadStoreOwnerRecord (instance,StoreOwnerCursorBase + index,result [index]);
        END; (* FOR *)
      END InitializeStoreOwnerTable;
      
      PROCEDURE InitializeStoreStockTables (instance : Windows.HINSTANCE; VAR result : ARRAY OF MCStruct.StoreStockTable);
        CONST
              StoreStockTableBase = 1150;
        
        VAR
            index : CARDINAL;
        
        PROCEDURE InitializeStoreStockTable (instance : Windows.HINSTANCE; cursor : CARDINAL; VAR result : ARRAY OF CARDINAL);
          VAR
              length : CARDINAL;
              index  : CARDINAL;
              str    : ARRAY [0..255] OF CHAR;
          
        BEGIN (* InitializeStoreStockTable *)
          WResource.LoadString (instance,cursor,str,length);
          
          FOR index := 0 TO HIGH (result) DO
            MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,result [index]);
          END; (* FOR *)
        END InitializeStoreStockTable;
        
      BEGIN (* InitializeStoreStockTables *)
        FOR index := 0 TO HIGH (result) DO
          InitializeStoreStockTable (instance,StoreStockTableBase + index,result [index]);
        END; (* FOR *)
      END InitializeStoreStockTables;
      
    BEGIN (* InitializeStoreResourceData *)
      InitializeStoreStockTables (instance,result.stock);
      InitializeStoreOwnerTable (instance,result.owners);
    END InitializeStoreResourceData;
    
  BEGIN (* DetermineCharacterInformation *)
    WITH result DO
      InitializeCharacterExperienceTable (instance,experience);
      InitializeCharacterClassTitles (instance,titles);
      
      InitializeCharacterSpellNames (instance,spellNAMES);
      InitializeCharacterSpellInfo (instance,spellINFO);
      
      InitializeCharacterClassInfo (instance,classATTRIBS);
      InitializeCharacterRaceInfo (instance,raceATTRIBS);
      
      InitializeCharacterBackground (instance,background);
      
      InitializeStoreResourceData (instance,stores);
    END; (* WITH *)
  END DetermineCharacterInformation;
END CDInit.
