IMPLEMENTATION MODULE CSpells2;
  (*/WIN:A*)
  
  IMPORT WMacro;
  
  IMPORT CSpells,MBalls,MCAttack,MCreatures,MMWindow,MPDamage,MPMovement,MRandom,MSUpdate;
  IMPORT DSActions,MSActions,MSActs2;
  IMPORT DStruct,MCStruct,MStruct;
  IMPORT MSpells2;
  
  
  PROCEDURE ExecuteBreathAcidSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    VAR
        hit,killed : CARDINAL;
        killer     : ARRAY [0..127] OF CHAR;
    
  BEGIN (* ExecuteBreathAcidSpell *)
    MCAttack.ReturnKillerDescription (player^.creatures^.table [creature.cursor],killer);
    
    CSpells.AddCreatureSpellMessageToList (player,"The %CREATURE breathes acid.",creature);
    MBalls.ExecuteMagicBallDamage (player,player^.character^.line,player^.character^.column,creature.hitpoints DIV 3,MBalls.ExecuteAcidDamage,FALSE,killer,hit,killed);
  END ExecuteBreathAcidSpell;
  
  PROCEDURE ExecuteBreathFireSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    VAR
        hit,killed : CARDINAL;
        killer     : ARRAY [0..127] OF CHAR;
    
  BEGIN (* ExecuteBreathFireSpell *)
    MCAttack.ReturnKillerDescription (player^.creatures^.table [creature.cursor],killer);
    
    CSpells.AddCreatureSpellMessageToList (player,"The %CREATURE breathes fire.",creature);
    MBalls.ExecuteMagicBallDamage (player,player^.character^.line,player^.character^.column,creature.hitpoints DIV 3,MBalls.ExecuteFireDamage,FALSE,killer,hit,killed);
  END ExecuteBreathFireSpell;
  
  PROCEDURE ExecuteBreathFrostSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    VAR
        hit,killed : CARDINAL;
        killer     : ARRAY [0..127] OF CHAR;
    
  BEGIN (* ExecuteBreathFrostSpell *)
    MCAttack.ReturnKillerDescription (player^.creatures^.table [creature.cursor],killer);
    
    CSpells.AddCreatureSpellMessageToList (player,"The %CREATURE breathes frost.",creature);
    MBalls.ExecuteMagicBallDamage (player,player^.character^.line,player^.character^.column,creature.hitpoints DIV 3,MBalls.ExecuteFrostDamage,FALSE,killer,hit,killed);
  END ExecuteBreathFrostSpell;
  
  PROCEDURE ExecuteBreathGasSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    VAR
        hit,killed : CARDINAL;
        killer     : ARRAY [0..127] OF CHAR;
    
  BEGIN (* ExecuteBreathGasSpell *)
    MCAttack.ReturnKillerDescription (player^.creatures^.table [creature.cursor],killer);
    
    CSpells.AddCreatureSpellMessageToList (player,"The %CREATURE breathes gas.",creature);
    MBalls.ExecuteMagicBallDamage (player,player^.character^.line,player^.character^.column,creature.hitpoints DIV 3,MBalls.ExecuteGasDamage,FALSE,killer,hit,killed);
  END ExecuteBreathGasSpell;
  
  PROCEDURE ExecuteBreathLightningSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    VAR
        hit,killed : CARDINAL;
        killer     : ARRAY [0..127] OF CHAR;
    
  BEGIN (* ExecuteBreathLightningSpell *)
    MCAttack.ReturnKillerDescription (player^.creatures^.table [creature.cursor],killer);
    
    CSpells.AddCreatureSpellMessageToList (player,"The %CREATURE breathes lightning.",creature);
    MBalls.ExecuteMagicBallDamage (player,player^.character^.line,player^.character^.column,creature.hitpoints DIV 4,MBalls.ExecuteLightningDamage,FALSE,killer,hit,killed);
  END ExecuteBreathLightningSpell;
  
  PROCEDURE ExecuteCauseBlindnessSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
  BEGIN (* ExecuteCauseBlindnessSpell *)
    IF MSActions.SuccessfulSavingsRoll (player) THEN
      MMWindow.AddMessageToList (player,"You resist the effects of the spell.");
    ELSIF player^.character^.variables.counters [MCStruct.BlindCOUNT] = 0 THEN
      INC (player^.character^.variables.counters [MCStruct.BlindCOUNT],MRandom.CardinalRandomRangeValue (13,15));
    ELSE
      INC (player^.character^.variables.counters [MCStruct.BlindCOUNT],6);
    END; (* IF *)
  END ExecuteCauseBlindnessSpell;
  
  PROCEDURE ExecuteCauseConfusionSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
  BEGIN (* ExecuteCauseConfusionSpell *)
    IF MSActions.SuccessfulSavingsRoll (player) THEN
      MMWindow.AddMessageToList (player,"You resist the effects of the spell.");
    ELSIF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] = 0 THEN
      INC (player^.character^.variables.counters [MCStruct.ConfusedCOUNT],MRandom.CardinalRandomRangeValue (4,8));
    ELSE
      INC (player^.character^.variables.counters [MCStruct.ConfusedCOUNT],2);
    END; (* IF *)
  END ExecuteCauseConfusionSpell;
  
  PROCEDURE ExecuteCauseFearSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
  BEGIN (* ExecuteCauseFearSpell *)
    IF MSActions.SuccessfulSavingsRoll (player) THEN
      MMWindow.AddMessageToList (player,"You resist the effects of the spell.");
    ELSIF player^.character^.variables.counters [MCStruct.AfraidCOUNT] = 0 THEN
      INC (player^.character^.variables.counters [MCStruct.AfraidCOUNT],MRandom.CardinalRandomRangeValue (4,8));
    ELSE
      INC (player^.character^.variables.counters [MCStruct.AfraidCOUNT],2);
    END; (* IF *)
  END ExecuteCauseFearSpell;
  
  PROCEDURE ExecuteCauseLightWoundsSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    VAR
        killer : ARRAY [0..127] OF CHAR;
    
  BEGIN (* ExecuteCauseLightWoundsSpell *)
    IF MSActions.SuccessfulSavingsRoll (player) THEN
      MMWindow.AddMessageToList (player,"You resist the effects of the spell.");
    ELSE
      MCAttack.ReturnKillerDescription (player^.creatures^.table [creature.cursor],killer);
      MPDamage.ReduceCharacterHitPoints (player,MRandom.CardinalRandomRangeValue (3,24),killer);
    END; (* IF *)
  END ExecuteCauseLightWoundsSpell;
  
  PROCEDURE ExecuteCauseParalysisSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
  BEGIN (* ExecuteCauseParalysisSpell *)
    IF MCStruct.FreeActionFLAG IN player^.character^.variables.status THEN
      MMWindow.AddMessageToList (player,"You are unaffected.");
    ELSIF MSActions.SuccessfulSavingsRoll (player) THEN
      MMWindow.AddMessageToList (player,"You resist the effects of the spell.");
    ELSIF player^.character^.variables.counters [MCStruct.ParalysisCOUNT] = 0 THEN
      INC (player^.character^.variables.counters [MCStruct.ParalysisCOUNT],MRandom.CardinalRandomRangeValue (5,9));
    ELSE
      INC (player^.character^.variables.counters [MCStruct.ParalysisCOUNT],2);
    END; (* IF *)
  END ExecuteCauseParalysisSpell;
  
  PROCEDURE ExecuteCauseSeriousWoundsSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    VAR
        killer : ARRAY [0..127] OF CHAR;
    
  BEGIN (* ExecuteCauseSeriousWoundsSpell *)
    IF MSActions.SuccessfulSavingsRoll (player) THEN
      MMWindow.AddMessageToList (player,"You resist the effects of the spell.");
    ELSE
      MCAttack.ReturnKillerDescription (player^.creatures^.table [creature.cursor],killer);
      MPDamage.ReduceCharacterHitPoints (player,MRandom.CardinalRandomRangeValue (8,64),killer);
    END; (* IF *)
  END ExecuteCauseSeriousWoundsSpell;
  
  PROCEDURE ExecuteDrainManaSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    VAR
        amount : REAL;
    
  BEGIN (* ExecuteDrainManaSpell *)
    IF player^.character^.variables.manaCUR > 0.0 THEN
      CSpells.AddCreatureSpellMessageToList (player,"The %CREATURE draws psychic energy from you!",creature);
      MSActs2.DisturbPlayer (player,TRUE);
      
      amount                               := WMacro.MinReal (FLOAT (player^.creatures^.table [creature.cursor].depth) / 2.0,player^.character^.variables.manaCUR);
      player^.character^.variables.manaCUR := player^.character^.variables.manaCUR - amount;
      creature.hitpoints                   := creature.hitpoints + TRUNC (6.0 * amount);
      
      IF creature.visible THEN
        CSpells.AddCreatureSpellMessageToList (player,"The %CREATURE appears healthier.",creature);
      END; (* IF *)
      
      MSUpdate.UpdateCurrentManaWindow (player);
    END; (* IF *)
  END ExecuteDrainManaSpell;
  
  PROCEDURE ExecuteSlowPlayerSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
  BEGIN (* ExecuteSlowPlayerSpell *)
    IF MCStruct.FreeActionFLAG IN player^.character^.variables.status THEN
      MMWindow.AddMessageToList (player,"You are unaffected.");
    ELSIF MSActions.SuccessfulSavingsRoll (player) THEN
      MMWindow.AddMessageToList (player,"You resist the effects of the spell.");
    ELSIF player^.character^.variables.counters [MCStruct.SlowCOUNT] = 0 THEN
      INC (player^.character^.variables.counters [MCStruct.SlowCOUNT],MRandom.CardinalRandomRangeValue (4,8));
    ELSE
      INC (player^.character^.variables.counters [MCStruct.SlowCOUNT],2);
    END; (* IF *)
  END ExecuteSlowPlayerSpell;
  
  PROCEDURE ExecuteSummonMonsterSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteSummonMonsterSpell *)
    CSpells.AddCreatureSpellMessageToList (player,"The %CREATURE magically summons a monster!",creature);
    MCreatures.SummonRandomMonster (player,player^.character^.line,player^.character^.column,FALSE,done);
  END ExecuteSummonMonsterSpell;
  
  PROCEDURE ExecuteSummonPlayerSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    VAR
        column,line : INTEGER;
    
    PROCEDURE DetermineNewPlayerLocation (VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; VAR resultLINE : INTEGER; VAR resultCOLUMN : INTEGER);
      VAR
          attempts : CARDINAL;
          distance : INTEGER;
      
      PROCEDURE ValidPlayerLocation (location : DStruct.PhysicalDungeonUnit) : BOOLEAN;
        CONST
              InvalidPlayerLocations = DStruct.DungeonWallElements + DStruct.DungeonElementSet {DStruct.BlockedFloor};
        
      BEGIN (* ValidPlayerLocation *)
        RETURN ((location.elements * InvalidPlayerLocations = DStruct.EmptyDungeonElementSet) AND (location.creature = DStruct.InvalidCreatureCursor));
      END ValidPlayerLocation;
      
    BEGIN (* DetermineNewPlayerLocation *)
      distance := 1;
      attempts := 0;
      
      REPEAT
        resultCOLUMN := centerCOLUMN + MRandom.IntegerRandomRangeValue (1,2 * distance + 1) - (distance + 1);
        resultLINE   := centerLINE + MRandom.IntegerRandomRangeValue (1,2 * distance + 1) - (distance + 1);
        attempts     := (attempts + 1) MOD 10;
        
        IF attempts = 0 THEN
          INC (distance);
        END; (* IF *)
      UNTIL (DSActions.LocationInBounds (dungeon,resultLINE,resultCOLUMN) AND ValidPlayerLocation (dungeon.physical [resultLINE]^ [resultCOLUMN]));
    END DetermineNewPlayerLocation;
    
  BEGIN (* ExecuteSummonPlayerSpell *)
    DetermineNewPlayerLocation (player^.dungeon^,creature.line,creature.column,line,column);
    MPMovement.MoveCharacterToLocation (player,line,column);
  END ExecuteSummonPlayerSpell;
  
  PROCEDURE ExecuteSummonUndeadSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteSummonUndeadSpell *)
    CSpells.AddCreatureSpellMessageToList (player,"The %CREATURE magically summons a monster!",creature);
    MCreatures.SummonRandomUndead (player,player^.character^.line,player^.character^.column,FALSE,done);
  END ExecuteSummonUndeadSpell;
  
  PROCEDURE ExecuteTeleportLongSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
  BEGIN (* ExecuteTeleportLongSpell *)
    MSpells2.TeleportCreatureAway (player,creature,MCStruct.MaxCharacterSightDistance);
  END ExecuteTeleportLongSpell;
  
  PROCEDURE ExecuteTeleportShortSpell (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
  BEGIN (* ExecuteTeleportShortSpell *)
    MSpells2.TeleportCreatureAway (player,creature,5);
  END ExecuteTeleportShortSpell;
END CSpells2.
