IMPLEMENTATION MODULE MBalls;
  (*/WIN:A*)
  
  IMPORT MBolts,MDPainting,MDWindow,MPAttk2,MPDamage,MSight,MTimer;
  IMPORT CStruct,DStruct,MStruct;
  IMPORT DSActions,OSActions;
  IMPORT WMacro;
  
  
  PROCEDURE ExecuteAcidDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; location : DStruct.PhysicalDungeonUnit; damage,distance : CARDINAL; experience : BOOLEAN; killer : ARRAY OF CHAR; VAR hit,killed : CARDINAL);
    PROCEDURE CreatureAcidDamage (creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord; damage,distance : CARDINAL) : CARDINAL;
    BEGIN (* CreatureAcidDamage *)
      IF CStruct.HurtByAcid IN creaturePASSIVE.defense THEN
        damage := damage * 2;
        
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.defense,CStruct.HurtByAcid);
        END; (* IF *)
      ELSIF CStruct.BreathAcid IN creaturePASSIVE.spells.known THEN
        damage := damage DIV 4;
        
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.spells,CStruct.BreathAcid);
        END; (* IF *)
      END; (* IF *)
      
      RETURN (WMacro.MaxInteger (damage DIV (distance + 1),1));
    END CreatureAcidDamage;
    
  BEGIN (* ExecuteAcidDamage *)
    IF ((location.artifact <> DStruct.InvalidArtifactCursor) AND OSActions.DamagedByAcid (player^.dungeon^.artifacts [location.artifact])) THEN
      DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
    END; (* IF *)
    
    IF ((player^.character^.line = line) AND (player^.character^.column = column)) THEN
      MPDamage.DamagePlayerWithAcid (player,WMacro.MaxCardinal (damage,1),killer);
    ELSIF location.creature <> DStruct.InvalidCreatureCursor THEN
      MagicBallDamageCreature (player,player^.dungeon^.creatures [location.creature],CreatureAcidDamage (player^.dungeon^.creatures [location.creature],player^.creatures^.table [player^.dungeon^.creatures [location.creature].cursor],damage,distance),experience,killed);
      INC (hit);
    END; (* IF *)
  END ExecuteAcidDamage;
  
  PROCEDURE ExecuteFireDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; location : DStruct.PhysicalDungeonUnit; damage,distance : CARDINAL; experience : BOOLEAN; killer : ARRAY OF CHAR; VAR hit,killed : CARDINAL);
    PROCEDURE CreatureFireDamage (creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord; damage,distance : CARDINAL) : CARDINAL;
    BEGIN (* CreatureFireDamage *)
      IF CStruct.HurtByFire IN creaturePASSIVE.defense THEN
        damage := damage * 2;
        
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.defense,CStruct.HurtByFire);
        END; (* IF *)
      ELSIF CStruct.BreathFire IN creaturePASSIVE.spells.known THEN
        damage := damage DIV 4;
        
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.spells,CStruct.BreathFire);
        END; (* IF *)
      END; (* IF *)
      
      RETURN (WMacro.MaxInteger (damage DIV (distance + 1),1));
    END CreatureFireDamage;
    
  BEGIN (* ExecuteFireDamage *)
    IF ((location.artifact <> DStruct.InvalidArtifactCursor) AND OSActions.DamagedByFlame (player^.dungeon^.artifacts [location.artifact])) THEN
      DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
    END; (* IF *)
    
    IF ((player^.character^.line = line) AND (player^.character^.column = column)) THEN
      MPDamage.DamagePlayerWithFire (player,WMacro.MaxCardinal (damage,1),killer);
    ELSIF location.creature <> DStruct.InvalidCreatureCursor THEN
      MagicBallDamageCreature (player,player^.dungeon^.creatures [location.creature],CreatureFireDamage (player^.dungeon^.creatures [location.creature],player^.creatures^.table [player^.dungeon^.creatures [location.creature].cursor],damage,distance),experience,killed);
      INC (hit);
    END; (* IF *)
  END ExecuteFireDamage;
  
  PROCEDURE ExecuteFrostDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; location : DStruct.PhysicalDungeonUnit; damage,distance : CARDINAL; experience : BOOLEAN; killer : ARRAY OF CHAR; VAR hit,killed : CARDINAL);
    PROCEDURE CreatureFrostDamage (creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord; damage,distance : CARDINAL) : CARDINAL;
    BEGIN (* CreatureFrostDamage *)
      IF CStruct.HurtByFrost IN creaturePASSIVE.defense THEN
        damage := damage * 2;
        
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.defense,CStruct.HurtByFrost);
        END; (* IF *)
      ELSIF CStruct.BreathFrost IN creaturePASSIVE.spells.known THEN
        damage := damage DIV 4;
        
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.spells,CStruct.BreathFrost);
        END; (* IF *)
      END; (* IF *)
      
      RETURN (WMacro.MaxInteger (damage DIV (distance + 1),1));
    END CreatureFrostDamage;
    
  BEGIN (* ExecuteFrostDamage *)
    IF ((location.artifact <> DStruct.InvalidArtifactCursor) AND OSActions.DamagedByCold (player^.dungeon^.artifacts [location.artifact])) THEN
      DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
    END; (* IF *)
    
    IF ((player^.character^.line = line) AND (player^.character^.column = column)) THEN
      MPDamage.DamagePlayerWithCold (player,WMacro.MaxCardinal (damage,1),killer);
    ELSIF location.creature <> DStruct.InvalidCreatureCursor THEN
      MagicBallDamageCreature (player,player^.dungeon^.creatures [location.creature],CreatureFrostDamage (player^.dungeon^.creatures [location.creature],player^.creatures^.table [player^.dungeon^.creatures [location.creature].cursor],damage,distance),experience,killed);
      INC (hit);
    END; (* IF *)
  END ExecuteFrostDamage;
  
  PROCEDURE ExecuteGasDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; location : DStruct.PhysicalDungeonUnit; damage,distance : CARDINAL; experience : BOOLEAN; killer : ARRAY OF CHAR; VAR hit,killed : CARDINAL);
    PROCEDURE CreatureGasDamage (creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord; damage,distance : CARDINAL) : CARDINAL;
    BEGIN (* CreatureGasDamage *)
      IF CStruct.HurtByPoison IN creaturePASSIVE.defense THEN
        damage := damage * 2;
        
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.defense,CStruct.HurtByPoison);
        END; (* IF *)
      ELSIF CStruct.BreathGas IN creaturePASSIVE.spells.known THEN
        damage := damage DIV 4;
        
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.spells,CStruct.BreathGas);
        END; (* IF *)
      END; (* IF *)
      
      RETURN (WMacro.MaxInteger (damage DIV (distance + 1),1));
    END CreatureGasDamage;
    
  BEGIN (* ExecuteGasDamage *)
    IF ((player^.character^.line = line) AND (player^.character^.column = column)) THEN
      MPDamage.DamagePlayerWithPoisonGas (player,WMacro.MaxCardinal (damage,1),killer);
    ELSIF location.creature <> DStruct.InvalidCreatureCursor THEN
      MagicBallDamageCreature (player,player^.dungeon^.creatures [location.creature],CreatureGasDamage (player^.dungeon^.creatures [location.creature],player^.creatures^.table [player^.dungeon^.creatures [location.creature].cursor],damage,distance),experience,killed);
      INC (hit);
    END; (* IF *)
  END ExecuteGasDamage;
  
  PROCEDURE ExecuteLightningDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; location : DStruct.PhysicalDungeonUnit; damage,distance : CARDINAL; experience : BOOLEAN; killer : ARRAY OF CHAR; VAR hit,killed : CARDINAL);
    PROCEDURE CreatureLightningDamage (creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord; damage,distance : CARDINAL) : CARDINAL;
    BEGIN (* CreatureLightningDamage *)
      IF CStruct.HurtByLightWand IN creaturePASSIVE.defense THEN
        damage := damage * 2;
        
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.defense,CStruct.HurtByLightWand);
        END; (* IF *)
      ELSIF CStruct.BreathLightning IN creaturePASSIVE.spells.known THEN
        damage := damage DIV 4;
        
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.spells,CStruct.BreathLightning);
        END; (* IF *)
      END; (* IF *)
      
      RETURN (WMacro.MaxInteger (damage DIV (distance + 1),1));
    END CreatureLightningDamage;
    
  BEGIN (* ExecuteLightningDamage *)
    IF ((location.artifact <> DStruct.InvalidArtifactCursor) AND OSActions.DamagedByLightning (player^.dungeon^.artifacts [location.artifact])) THEN
      DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
    END; (* IF *)
    
    IF ((player^.character^.line = line) AND (player^.character^.column = column)) THEN
      MPDamage.DamagePlayerWithLightning (player,WMacro.MaxCardinal (damage,1),killer);
    ELSIF location.creature <> DStruct.InvalidCreatureCursor THEN
      MagicBallDamageCreature (player,player^.dungeon^.creatures [location.creature],CreatureLightningDamage (player^.dungeon^.creatures [location.creature],player^.creatures^.table [player^.dungeon^.creatures [location.creature].cursor],damage,distance),experience,killed);
      INC (hit);
    END; (* IF *)
  END ExecuteLightningDamage;
  
  PROCEDURE ExecuteMagicBallDamage (player : MStruct.PlayerInfoPointer; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; damage : CARDINAL; ExecuteLocationDamage : MagicBallLocationDamageProcedure; experience : BOOLEAN; killer : ARRAY OF CHAR; VAR hit,killed : CARDINAL);
    CONST
          BlockedDungeonElements = DStruct.DungeonWallElements + DStruct.DungeonElementSet {DStruct.BlockedFloor};
          MaxBreathDistance      = 2;
    
    VAR
        column,minX,maxX : DStruct.DungeonColumnRange;
        line,minY,maxY   : DStruct.DungeonLineRange;
    
    PROCEDURE ValidMagicBallLocation (player : MStruct.PlayerInfoPointer; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; line,column : INTEGER) : BOOLEAN;
    BEGIN (* ValidMagicBallLocation *)
      IF NOT (DSActions.LocationInBounds (player^.dungeon^,line,column)) THEN
        RETURN (FALSE);
      ELSIF player^.dungeon^.physical [line]^ [column].elements * BlockedDungeonElements <> DStruct.EmptyDungeonElementSet THEN
        RETURN (FALSE);
      ELSIF DSActions.QuickDistance (centerLINE,centerCOLUMN,line,column) > MaxBreathDistance THEN
        RETURN (FALSE);
      ELSE
        RETURN (MSight.ClearLineOfSight (player,centerLINE,centerCOLUMN,line,column));
      END; (* IF *)
    END ValidMagicBallLocation;
    
  BEGIN (* ExecuteMagicBallDamage *)
    IF player^.dungeon^.physical [centerLINE]^ [centerCOLUMN].elements * BlockedDungeonElements <> DStruct.EmptyDungeonElementSet THEN
      centerCOLUMN := MBolts.PreviousBoltColumn;
      centerLINE   := MBolts.PreviousBoltLine;
    END; (* IF *)
    
    killed := 0;
    hit    := 0;
    
    maxX := WMacro.MinInteger (centerCOLUMN + MaxBreathDistance,player^.dungeon^.columns - 1);
    maxY := WMacro.MinInteger (centerLINE + MaxBreathDistance,player^.dungeon^.lines - 1);
    minX := WMacro.MaxInteger (centerCOLUMN - MaxBreathDistance,0);
    minY := WMacro.MaxInteger (centerLINE - MaxBreathDistance,0);
    
    FOR line := minY TO maxY DO
      FOR column := minX TO maxX DO
        IF ValidMagicBallLocation (player,centerLINE,centerCOLUMN,line,column) THEN
          ExecuteLocationDamage (player,line,column,player^.dungeon^.physical [line]^ [column],damage,DSActions.QuickDistance (centerLINE,centerCOLUMN,line,column),experience,killer,hit,killed);
          MDWindow.DisplayPassingMissile (player,line,column,'*',FALSE);
        END; (* IF *)
      END; (* FOR *)
    END; (* FOR *)
    
    MTimer.WaitForMilliseconds (100);
    MDPainting.InvalidateDungeonArea (player,minX,maxX,minY,maxY);
  END ExecuteMagicBallDamage;
  
  PROCEDURE ExecuteOrbOfDrainingDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; location : DStruct.PhysicalDungeonUnit; damage,distance : CARDINAL; experience : BOOLEAN; killer : ARRAY OF CHAR; VAR hit,killed : CARDINAL);
    PROCEDURE OrbOfDrainingDamage (creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord; damage,distance : CARDINAL) : CARDINAL;
    BEGIN (* OrbOfDrainingDamage *)
      IF CStruct.HurtBySlayEvil IN creaturePASSIVE.defense THEN
        damage := damage * 2;
        
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.defense,CStruct.HurtBySlayEvil);
        END; (* IF *)
      END; (* IF *)
      
      RETURN (WMacro.MaxInteger (damage DIV (distance + 1),1));
    END OrbOfDrainingDamage;
    
  BEGIN (* ExecuteOrbOfDrainingDamage *)
    IF location.creature <> DStruct.InvalidCreatureCursor THEN
      MagicBallDamageCreature (player,player^.dungeon^.creatures [location.creature],OrbOfDrainingDamage (player^.dungeon^.creatures [location.creature],player^.creatures^.table [player^.dungeon^.creatures [location.creature].cursor],damage,distance),experience,killed);
      INC (hit);
    END; (* IF *)
  END ExecuteOrbOfDrainingDamage;

  PROCEDURE MagicBallDamageCreature (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; experience : BOOLEAN; VAR killed : CARDINAL);
  BEGIN (* MagicBallDamageCreature *)
    MPAttk2.DamageCreature (creature,damage);
    
    IF creature.hitpoints = 0 THEN
      MPAttk2.KillCreatureAtLocation (player,creature.line,creature.column,player^.creatures^.table [creature.cursor],creature.visible,experience);
      INC (killed);
    END; (* IF *)
  END MagicBallDamageCreature;
END MBalls.
