IMPLEMENTATION MODULE MCATest;
  (*/WIN:A*)
  
  IMPORT CStruct,DStruct,MStruct;
  IMPORT MCSActions;
  IMPORT WDebugging;
  IMPORT MPAttacks;
  
  
  CONST
        CreatureStrikeAdjustment = 4;


  
  PROCEDURE InvalidAttackTest (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* InvalidAttackTest *)
    WDebugging.FatalAppExit ("Call to un-initialized creature attack test.");
    RETURN (FALSE);
  END InvalidAttackTest;
  
  PROCEDURE InvalidDamageProcedure (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* InvalidDamageProcedure *)
    WDebugging.FatalAppExit ("Call to un-initialized creature damage procedure.");
  END InvalidDamageProcedure;
  
  PROCEDURE SuccessfulArmorDefendedAttack (player : MStruct.PlayerInfoPointer; ability : INTEGER; depth : CARDINAL) : BOOLEAN;
  BEGIN (* SuccessfulArmorDefendedAttack *)
    RETURN (MPAttacks.SuccessfulAttack (player,ability,depth,0,player^.character^.variables.armorREAL + player^.character^.variables.bonusREAL.armor,MCSActions.ClassSaveLevelAdjustment (player^.character^.constants.class)));
  END SuccessfulArmorDefendedAttack;

  PROCEDURE TestAcidAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestAcidAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,0,depth));
  END TestAcidAttack;
  
  PROCEDURE TestAggravationAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestAggravationAttack *)
    RETURN (TRUE);
  END TestAggravationAttack;
  
  PROCEDURE TestBlindnessAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestBlindnessAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,2,depth));
  END TestBlindnessAttack;
  
  PROCEDURE TestChargesAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestChargesAttack *)
    RETURN ((player^.character^.inventory.counter > 0) AND SuccessfulArmorDefendedAttack (player,15,depth));
  END TestChargesAttack;
  
  PROCEDURE TestColdAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestColdAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,10,depth));
  END TestColdAttack;
  
  PROCEDURE TestConfusionAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestConfusionAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,10,depth));
  END TestConfusionAttack;
  
  PROCEDURE TestConstitutionAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestConstitutionAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,0,depth));
  END TestConstitutionAttack;
  
  PROCEDURE TestCorrosionAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestCorrosionAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,0,depth));
  END TestCorrosionAttack;
  
  PROCEDURE TestDexterityAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestDexterityAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,0,depth));
  END TestDexterityAttack;
  
  PROCEDURE TestDisenchantmentAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestDisenchantmentAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,20,depth));
  END TestDisenchantmentAttack;
  
  PROCEDURE TestExperienceAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestExperienceAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,5,depth));
  END TestExperienceAttack;
  
  PROCEDURE TestFearAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestFearAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,10,depth));
  END TestFearAttack;
  
  PROCEDURE TestFireAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestFireAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,10,depth));
  END TestFireAttack;
  
  PROCEDURE TestFoodAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestFoodAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,5,depth));
  END TestFoodAttack;
  
  PROCEDURE TestIntelligenceAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestIntelligenceAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,2,depth));
  END TestIntelligenceAttack;
  
  PROCEDURE TestLightAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestLightAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,5,depth));
  END TestLightAttack;
  
  PROCEDURE TestLightningAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestLightningAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,10,depth));
  END TestLightningAttack;
  
  PROCEDURE TestMoneyAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestMoneyAttack *)
    RETURN ((player^.character^.variables.currentGOLD > 0) AND MPAttacks.SuccessfulAttack (player,5,depth,0,player^.character^.variables.level,MCSActions.ClassSaveLevelAdjustment (player^.character^.constants.class)));
  END TestMoneyAttack;
  
  PROCEDURE TestNoAttackAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestNoAttackAttack *)
    RETURN (FALSE);
  END TestNoAttackAttack;
  
  PROCEDURE TestNormalAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestNormalAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,60,depth));
  END TestNormalAttack;
  
  PROCEDURE TestObjectAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestObjectAttack *)
    RETURN ((player^.character^.inventory.counter > 0) AND MPAttacks.SuccessfulAttack (player,2,depth,0,player^.character^.variables.level,MCSActions.ClassSaveLevelAdjustment (player^.character^.constants.class)));
  END TestObjectAttack;
  
  PROCEDURE TestParalysisAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestParalysisAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,2,depth));
  END TestParalysisAttack;
  
  PROCEDURE TestPoisonAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestPoisonAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,5,depth));
  END TestPoisonAttack;
  
  PROCEDURE TestRepelledAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestRepelledAttack *)
    RETURN (TRUE);
  END TestRepelledAttack;
  
  PROCEDURE TestStrengthAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestStrengthAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,-3,depth));
  END TestStrengthAttack;
  
  PROCEDURE TestWisdomAttack (player : MStruct.PlayerInfoPointer; depth : CARDINAL) : BOOLEAN;
  BEGIN (* TestWisdomAttack *)
    RETURN (SuccessfulArmorDefendedAttack (player,2,depth));
  END TestWisdomAttack;
  
  
  PROCEDURE InitializeCreatureHitsPlayerTable;
    VAR
        index : CStruct.CreatureAttackClass;
    
  BEGIN (* InitializeCreatureHitsPlayerTable *)
    FOR index := MIN (CStruct.CreatureAttackClass) TO MAX (CStruct.CreatureAttackClass) DO
      CreatureHitsPlayer [index] := InvalidAttackTest;
    END; (* FOR *)
    
    CreatureHitsPlayer [CStruct.acid] := TestAcidAttack;
    CreatureHitsPlayer [CStruct.aggravation] := TestAggravationAttack;
    CreatureHitsPlayer [CStruct.blindness] := TestBlindnessAttack;
    CreatureHitsPlayer [CStruct.charges] := TestChargesAttack;
    CreatureHitsPlayer [CStruct.cold] := TestColdAttack;
    CreatureHitsPlayer [CStruct.confusion] := TestConfusionAttack;
    CreatureHitsPlayer [CStruct.constitution] := TestConstitutionAttack;
    CreatureHitsPlayer [CStruct.corrosion] := TestCorrosionAttack;
    CreatureHitsPlayer [CStruct.dexterity] := TestDexterityAttack;
    CreatureHitsPlayer [CStruct.disenchantment] := TestDisenchantmentAttack;
    CreatureHitsPlayer [CStruct.experience] := TestExperienceAttack;
    CreatureHitsPlayer [CStruct.fear] := TestFearAttack;
    CreatureHitsPlayer [CStruct.fire] := TestFireAttack;
    CreatureHitsPlayer [CStruct.food] := TestFoodAttack;
    CreatureHitsPlayer [CStruct.intelligence] := TestIntelligenceAttack;
    CreatureHitsPlayer [CStruct.light] := TestLightAttack;
    CreatureHitsPlayer [CStruct.lightning] := TestLightningAttack;
    CreatureHitsPlayer [CStruct.money] := TestMoneyAttack;
    CreatureHitsPlayer [CStruct.noAttack] := TestNoAttackAttack;
    CreatureHitsPlayer [CStruct.normal] := TestNormalAttack;
    CreatureHitsPlayer [CStruct.object] := TestObjectAttack;
    CreatureHitsPlayer [CStruct.paralysis] := TestParalysisAttack;
    CreatureHitsPlayer [CStruct.poison] := TestPoisonAttack;
    CreatureHitsPlayer [CStruct.repelled] := TestRepelledAttack;
    CreatureHitsPlayer [CStruct.strength] := TestStrengthAttack;
    CreatureHitsPlayer [CStruct.wisdom] := TestWisdomAttack;
  END InitializeCreatureHitsPlayerTable;

BEGIN (* MCATest *)
  InitializeCreatureHitsPlayerTable;
END MCATest.
