IMPLEMENTATION MODULE MCAttack;
  (*/WIN:A*)
  
  IMPORT MCDamage,MCATest,MMWindow,MRandom,ODescriptions;
  IMPORT CStruct,DStruct,MCStruct,MStruct;
  IMPORT WinStart,WString;
  IMPORT MSActs2;
  IMPORT Strings;
  
  
  PROCEDURE ExecuteCreatureAttack (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    VAR
        attacks : CStruct.CreatureAttackTable;
        killer  : ARRAY [0..127] OF CHAR;
        index   : CARDINAL;
    
    PROCEDURE ExecuteSingleCreatureAttack (player : MStruct.PlayerInfoPointer; VAR creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord; attack : CStruct.CreatureAttackRecord; attackCURSOR : CARDINAL; killer : ARRAY OF CHAR);
      PROCEDURE DisplayCreatureAttackMessage (player : MStruct.PlayerInfoPointer; creature : ARRAY OF CHAR; visible : BOOLEAN; attack : CStruct.CreatureAttackDescription);
        VAR
            message : ARRAY [0..127] OF CHAR;
        
        PROCEDURE AttackDescriptionCursor (attack : CStruct.CreatureAttackDescription) : CARDINAL;
          CONST
                InsultingAttackStringCursor = 240;
                NormalAttackStringCursor    = 220;
          
        BEGIN (* AttackDescriptionCursor *)
          IF attack = CStruct.insults THEN
            RETURN (InsultingAttackStringCursor + MRandom.CardinalRandomRangeValue (0,8));
          ELSE
            RETURN (NormalAttackStringCursor + ORD (attack) - 1);
          END; (* IF *)
        END AttackDescriptionCursor;
        
      BEGIN (* DisplayCreatureAttackMessage *)
        IF attack = CStruct.slimes THEN
          Strings.Assign ("%DESCRIPTION",message);
        ELSIF visible THEN
          WString.ReplaceStringParameter ("The %CREATURE %DESCRIPTION","%CREATURE",creature,message);
        ELSE
          Strings.Assign ("It %DESCRIPTION",message);
        END; (* IF *)
        
        WString.ReplaceParameterWithStringResource (message,"%DESCRIPTION",WinStart.hInstance,AttackDescriptionCursor (attack),message);
        
        MMWindow.AddMessageToList (player,message);
      END DisplayCreatureAttackMessage;
      
      PROCEDURE DisplayMissedAttackMessage (player : MStruct.PlayerInfoPointer; creature : ARRAY OF CHAR; visible : BOOLEAN);
        VAR
            message : ARRAY [0..127] OF CHAR;
        
      BEGIN (* DisplayMissedAttackMessage *)
        IF visible THEN
          WString.ReplaceStringParameter ("The %CREATURE misses you.","%CREATURE",creature,message);
        ELSE
          message := "It misses you.";
        END; (* IF *)
        
        MMWindow.AddMessageToList (player,message);
      END DisplayMissedAttackMessage;
      
    BEGIN (* ExecuteSingleCreatureAttack *)
      IF ((player^.character^.variables.counters [MCStruct.ProtEvilCOUNT] > 0) AND (CStruct.HurtBySlayEvil IN creaturePASSIVE.defense) AND (VAL (CARDINAL,player^.character^.variables.level) >= creaturePASSIVE.depth)) THEN
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.defense,CStruct.HurtBySlayEvil);
        END; (* IF *)
        
        attack.description := CStruct.repelledDescrip;
        attack.class       := CStruct.repelled;
      END; (* IF *)
      
      IF MCATest.CreatureHitsPlayer [attack.class] (player,creaturePASSIVE.depth) THEN
        MSActs2.DisturbPlayer (player,TRUE);
        
        DisplayCreatureAttackMessage (player,creaturePASSIVE.description,creatureACTIVE.visible,attack.description);
        MCDamage.DeterminePlayerDamage (player,creatureACTIVE,creaturePASSIVE,killer,attackCURSOR,attack.class,MRandom.CardinalRandomRangeValue (attack.damage.min,attack.damage.max),creatureACTIVE.visible);
      ELSIF (((attack.description >= CStruct.hits) AND (attack.description <= CStruct.claws)) OR (attack.description = CStruct.kicks)) THEN
        MSActs2.DisturbPlayer (player,TRUE);
        
        DisplayMissedAttackMessage (player,creaturePASSIVE.description,creatureACTIVE.visible);
      END; (* IF *)
    END ExecuteSingleCreatureAttack;
    
  BEGIN (* ExecuteCreatureAttack *)
    ReturnKillerDescription (player^.creatures^.table [creature.cursor],killer);
    
    attacks := player^.creatures^.table [creature.cursor].attacks;
    index   := 0;
    
    REPEAT
      ExecuteSingleCreatureAttack (player,creature,player^.creatures^.table [creature.cursor],player^.creatures^.attacks [attacks [index]],index,killer);
      INC (index);
    UNTIL ((index = CStruct.MaxAttacksPerCreature) OR (player^.character^.variables.hpCUR = 0.0));
  END ExecuteCreatureAttack;
  
  PROCEDURE ReturnKillerDescription (creature : CStruct.PassiveCreatureInfoRecord; VAR result : ARRAY OF CHAR);
  BEGIN (* ReturnKillerDescription *)
    IF creature.balrog THEN
      Strings.Concat ("The ",creature.description,result);
    ELSIF ODescriptions.IsVowel (creature.description [0]) THEN
      Strings.Concat ("an ",creature.description,result);
    ELSE
      Strings.Concat ("a ",creature.description,result);
    END; (* IF *)
  END ReturnKillerDescription;
END MCAttack.
