IMPLEMENTATION MODULE MCDamage;
  (*/WIN:A*)
  
  IMPORT MMWindow,MPDamage,MRandom,MSpells,MSpells2,MSUpdate;
  IMPORT CStruct,DStruct,MCStruct,MStruct,OStruct;
  IMPORT WDebugging,WMacro;
  IMPORT MSActions,MSActs2;
  
  
  TYPE
       PlayerDamageProcedure = PROCEDURE (MStruct.PlayerInfoPointer,VAR DStruct.DungeonCreatureRecord,CARDINAL,ARRAY OF CHAR,VAR BOOLEAN);
  
  VAR
      EffectPlayerDamage : ARRAY CStruct.CreatureAttackClass OF PlayerDamageProcedure;
  
  
  PROCEDURE DeterminePlayerDamage (player : MStruct.PlayerInfoPointer; VAR creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord; killer : ARRAY OF CHAR; attackCURSOR : CARDINAL; attack : CStruct.CreatureAttackClass; damage : CARDINAL; noticed : BOOLEAN);
    PROCEDURE AttemptCreatureConfusion (player : MStruct.PlayerInfoPointer; VAR creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord);
      VAR
          confused : BOOLEAN;
          message  : ARRAY [0..127] OF CHAR;
      
    BEGIN (* AttemptCreatureConfusion *)
      MMWindow.AddMessageToList (player,"You hands stop glowing.");
      EXCL (player^.character^.variables.status,MCStruct.ConfuseMonsterFLAG);
      
      confused := ((CStruct.ResistCharms IN creaturePASSIVE.defense) OR (MRandom.CardinalRandomRangeValue (1,CStruct.MaxCreatureDepth) < creaturePASSIVE.depth));
      
      IF confused THEN
        creatureACTIVE.confused := TRUE;
        message                 := "The %CREATURE appears confused.";
      ELSE
        message := "The %CREATURE is unaffected.";
      END; (* IF *)
      
      IF creatureACTIVE.visible THEN
        IF ((CStruct.ResistCharms IN creaturePASSIVE.defense) AND (MRandom.CardinalRandomRangeValue (1,4) = 1)) THEN
          INCL (creaturePASSIVE.memory.defense,CStruct.ResistCharms);
        END; (* IF *)
      END; (* IF *)
      
      MMWindow.DisplayCreatureMessage (player,message,creaturePASSIVE.description,creatureACTIVE.visible,FALSE);
    END AttemptCreatureConfusion;
    
  BEGIN (* DeterminePlayerDamage *)
    EffectPlayerDamage [attack] (player,creatureACTIVE,damage,killer,noticed);
    
    IF attack <> CStruct.repelled THEN
      IF MCStruct.ConfuseMonsterFLAG IN player^.character^.variables.status THEN
        AttemptCreatureConfusion (player,creatureACTIVE,creaturePASSIVE);
      END; (* IF *)
      
      IF (noticed OR (creatureACTIVE.visible AND (creaturePASSIVE.memory.attacks [attackCURSOR] <> 0))) THEN
        creaturePASSIVE.memory.attacks [attackCURSOR] := WMacro.MinCardinal (creaturePASSIVE.memory.attacks [attackCURSOR] + 1,CStruct.MaxRememberedAttacks);
      END; (* IF *)
    END; (* IF *)
    
    IF player^.character^.variables.hpCUR = 0.0 THEN
      creaturePASSIVE.memory.deaths := WMacro.MinCardinal (creaturePASSIVE.memory.deaths + 1,CStruct.MaxRememberedDeaths);
    END; (* IF *)
  END DeterminePlayerDamage;
  
  PROCEDURE InvalidDamageProcedure (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* InvalidDamageProcedure *)
    WDebugging.FatalAppExit ("Call to un-initialized creature damage procedure.");
  END InvalidDamageProcedure;
  
  
  PROCEDURE EffectAcidDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectAcidDamage *)
    MMWindow.AddMessageToList (player,"You are covered in acid!");
    MPDamage.DamagePlayerWithAcid (player,damage,killer);
  END EffectAcidDamage;
  
  PROCEDURE EffectAggravationDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* EffectAggravationDamage *)
    MSpells.AggravateCreatures (player,20,done);
  END EffectAggravationDamage;
  
  PROCEDURE EffectBlindnessDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectBlindnessDamage *)
    MPDamage.ReduceCharacterHitPoints (player,damage,killer);
    
    IF player^.character^.variables.counters [MCStruct.BlindCOUNT] = 0 THEN
      player^.character^.variables.counters [MCStruct.BlindCOUNT] := MRandom.CardinalRandomRangeValue (1,player^.creatures^.table [creature.cursor].depth) + 10;
      MMWindow.AddMessageToList (player,"Your eyes begin to sting.");
    ELSE
      INC (player^.character^.variables.counters [MCStruct.BlindCOUNT],5);
      noticed := FALSE;
    END; (* IF *)
  END EffectBlindnessDamage;
  
  PROCEDURE EffectChargesDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectChargesDamage *)
    MPDamage.ReduceItemCharges (player,player^.character^.inventory.backpack [MRandom.CardinalRandomRangeValue (0,player^.character^.inventory.counter - 1)],creature,noticed);
  END EffectChargesDamage;
  
  PROCEDURE EffectColdDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectColdDamage *)
    MMWindow.AddMessageToList (player,"You are covered with frost!");
    MPDamage.DamagePlayerWithCold (player,damage,killer);
  END EffectColdDamage;
  
  PROCEDURE EffectConfusionDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectConfusionDamage *)
    MPDamage.ReduceCharacterHitPoints (player,damage,killer);
    
    IF MRandom.CardinalRandomRangeValue (1,2) = 1 THEN
      IF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] = 0 THEN
        MMWindow.AddMessageToList (player,"You feel confused.");
        INC (player^.character^.variables.counters [MCStruct.ConfusedCOUNT],MRandom.CardinalRandomRangeValue (1,player^.creatures^.table [creature.cursor].depth));
      ELSE
        noticed := FALSE;
      END; (* IF *)
      
      INC (player^.character^.variables.counters [MCStruct.ConfusedCOUNT],3);
    ELSE
      noticed := FALSE;
    END; (* IF *)
  END EffectConfusionDamage;
  
  PROCEDURE EffectConstitutionDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectConstitutionDamage *)
    MPDamage.ReduceCharacterHitPoints (player,damage,killer);
    
    IF MCStruct.SustainConFLAG IN player^.character^.variables.status THEN
      MMWindow.AddMessageToList (player,"Your body resists the effects of the disease.");
    ELSE
      MMWindow.AddMessageToList (player,"Your health is damaged!");
      MSActs2.DecrementStatistic (player,MCStruct.con);
    END; (* IF *)
  END EffectConstitutionDamage;
  
  PROCEDURE EffectCorrosionDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectCorrosionDamage *)
    MMWindow.AddMessageToList (player,"A stinging red gas swirls about you.");
    MPDamage.DamagePlayerWithCorrosion (player,killer);
    
    MPDamage.ReduceCharacterHitPoints (player,damage,killer);
  END EffectCorrosionDamage;
  
  PROCEDURE EffectDexterityDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectDexterityDamage *)
    MPDamage.ReduceCharacterHitPoints (player,damage,killer);
    
    IF MCStruct.SustainDexFLAG IN player^.character^.variables.status THEN
      MMWindow.AddMessageToList (player,"You feel clumsy for a moment, but it passes.");
    ELSE
      MMWindow.AddMessageToList (player,"You feel more clumsy.");
      MSActs2.DecrementStatistic (player,MCStruct.dex);
    END; (* IF *)
  END EffectDexterityDamage;
  
  PROCEDURE EffectDisenchantmentDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
    PROCEDURE RandomEquipmentObject () : MCStruct.PlayerEquipmentMnemonic;
    BEGIN (* RandomEquipmentObject *)
      CASE MRandom.CardinalRandomRangeValue (1,7) OF
        1 : RETURN (MCStruct.Weapon1); |
        2 : RETURN (MCStruct.Body);    |
        3 : RETURN (MCStruct.Arm);     |
        4 : RETURN (MCStruct.Outer);   |
        5 : RETURN (MCStruct.Hands);   |
        6 : RETURN (MCStruct.Head);    |
        7 : RETURN (MCStruct.Feet);    |
      END; (* CASE *)
    END RandomEquipmentObject;
    
  BEGIN (* EffectDisenchantmentDamage *)
    MPDamage.DisenchantObject (player,player^.character^.inventory.equipment [RandomEquipmentObject ()],noticed);
  END EffectDisenchantmentDamage;
  
  PROCEDURE EffectExperienceDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectExperienceDamage *)
    MMWindow.AddMessageToList (player,"You feel your life drainging away!");
    MSpells2.ReduceCharacterExperience (player,FLOAT (damage) + (player^.character^.variables.experCUR / 100.0) * 2.0);
  END EffectExperienceDamage;
  
  PROCEDURE EffectFearDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectFearDamage *)
    MPDamage.ReduceCharacterHitPoints (player,damage,killer);
    
    IF MSActions.SuccessfulSavingsRoll (player) THEN
      MMWindow.AddMessageToList (player,"You resist the effects!");
    ELSIF player^.character^.variables.counters [MCStruct.AfraidCOUNT] = 0 THEN
      MMWindow.AddMessageToList (player,"You are suddenly affraid!");
      INC (player^.character^.variables.counters [MCStruct.AfraidCOUNT],MRandom.CardinalRandomRangeValue (1,player^.creatures^.table [creature.cursor].depth) + 3);
    ELSE
      INC (player^.character^.variables.counters [MCStruct.AfraidCOUNT],3);
      noticed := FALSE;
    END; (* IF *)
  END EffectFearDamage;
  
  PROCEDURE EffectFireDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectFireDamage *)
    MMWindow.AddMessageToList (player,"You are enveloped in flames!");
    MPDamage.DamagePlayerWithFire (player,damage,killer);
  END EffectFireDamage;
  
  PROCEDURE EffectIntelligenceDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectIntelligenceDamage *)
    MMWindow.AddMessageToList (player,"You have trouble thinking clearly.");
    
    IF MCStruct.SustainIntFLAG IN player^.character^.variables.status THEN
      MMWindow.AddMessageToList (player,"But your mind quickly clears.");
    ELSE
      MSActs2.DecrementStatistic (player,MCStruct.int);
    END; (* IF *)
    
    MPDamage.ReduceCharacterHitPoints (player,damage,killer);
  END EffectIntelligenceDamage;
  
  PROCEDURE EffectLightDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectLightDamage *)
    IF player^.character^.inventory.equipment [MCStruct.Light].object.miscellaneous > 0 THEN
      player^.character^.inventory.equipment [MCStruct.Light].object.miscellaneous := WMacro.MaxInteger (player^.character^.inventory.equipment [MCStruct.Light].object.miscellaneous - (MRandom.IntegerRandomRangeValue (1,250) + 250),1);
      
      IF player^.character^.variables.counters [MCStruct.BlindCOUNT] = 0 THEN
        MMWindow.AddMessageToList (player,"Your light dims.");
      ELSE
        noticed := FALSE;
      END; (* IF *)
    ELSE
      noticed := FALSE;
    END; (* IF *)
  END EffectLightDamage;
  
  PROCEDURE EffectLightningDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectLightningDamage *)
    MMWindow.AddMessageToList (player,"Lightning strikes you!");
    MPDamage.DamagePlayerWithLightning (player,damage,killer);
  END EffectLightningDamage;
  
  PROCEDURE EffectMoneyDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
    PROCEDURE StolenMoneyAmount (gold : LONGINT) : LONGINT;
    BEGIN (* StolenMoneyAmount *)
      RETURN (WMacro.MinLongInt (gold DIV 10 + VAL (LONGINT,MRandom.CardinalRandomRangeValue (1,25)),gold));
    END StolenMoneyAmount;
    
  BEGIN (* EffectMoneyDamage *)
    IF ((player^.character^.variables.counters [MCStruct.ParalysisCOUNT] > 0) OR (MRandom.IntegerRandomRangeValue (1,124) >= player^.character^.statistics.used [MCStruct.dex])) THEN
      DEC (player^.character^.variables.currentGOLD,StolenMoneyAmount (player^.character^.variables.currentGOLD));
      
      MSUpdate.UpdateCurrentGoldWindow (player);
      MMWindow.AddMessageToList (player,"Your purse feels lighter.");
    ELSE
      MMWindow.AddMessageToList (player,"You quickly protect your money pouch!");
    END; (* IF *)
    
    IF MRandom.CardinalRandomRangeValue (1,2) = 1 THEN
      MSpells2.TeleportCreatureAway (player,creature,MCStruct.MaxCharacterSightDistance);
      MMWindow.AddMessageToList (player,"There is a puff of smoke!");
    END; (* IF *)
  END EffectMoneyDamage;
  
  PROCEDURE EffectNoAttackDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectNoAttackDamage *)
    noticed := FALSE;
  END EffectNoAttackDamage;
  
  PROCEDURE EffectNormalDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
    PROCEDURE NormalAttackDamage (player : MStruct.PlayerInfoPointer; damage : INTEGER) : CARDINAL;
    BEGIN (* NormalAttackDamage *)
      RETURN (WMacro.MaxInteger (damage - ((player^.character^.variables.armorREAL + player^.character^.variables.bonusREAL.armor) * damage) DIV 200,0));
    END NormalAttackDamage;
    
  BEGIN (* EffectNormalDamage *)
    MPDamage.ReduceCharacterHitPoints (player,NormalAttackDamage (player,damage),killer);
  END EffectNormalDamage;
  
  PROCEDURE EffectParalysisDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectParalysisDamage *)
    MPDamage.ReduceCharacterHitPoints (player,damage,killer);
    
    IF MSActions.SuccessfulSavingsRoll (player) THEN
      MMWindow.AddMessageToList (player,"You resist the effects!");
    ELSIF MCStruct.FreeActionFLAG IN player^.character^.variables.status THEN
      MMWindow.AddMessageToList (player,"You are unaffected.");
    ELSIF player^.character^.variables.counters [MCStruct.ParalysisCOUNT] = 0 THEN
      player^.character^.variables.counters [MCStruct.ParalysisCOUNT] := MRandom.CardinalRandomRangeValue (1,player^.creatures^.table [creature.cursor].depth) + 3;
      MMWindow.AddMessageToList (player,"You are paralyzed.");
    ELSE
      noticed := FALSE;
    END; (* IF *)
  END EffectParalysisDamage;
  
  PROCEDURE EffectPoisonDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectPoisonDamage *)
    MPDamage.ReduceCharacterHitPoints (player,damage,killer);
    
    INC (player^.character^.variables.counters [MCStruct.PoisonedCOUNT],MRandom.CardinalRandomRangeValue (1,player^.creatures^.table [creature.cursor].depth) + 5);
    MMWindow.AddMessageToList (player,"You feel very sick.");
  END EffectPoisonDamage;
  
  PROCEDURE EffectRepelledDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectRepelledDamage *)
    noticed := FALSE;
  END EffectRepelledDamage;
  
  PROCEDURE EffectStrengthDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectStrengthDamage *)
    MPDamage.ReduceCharacterHitPoints (player,damage,killer);
    
    IF MCStruct.SustainStrFLAG IN player^.character^.variables.status THEN
      MMWindow.AddMessageToList (player,"You feel weaker for a moment, but it passes.");
    ELSIF MRandom.CardinalRandomRangeValue (1,2) = 1 THEN
      MMWindow.AddMessageToList (player,"You feel weaker.");
      MSActs2.DecrementStatistic (player,MCStruct.str);
    ELSE
      noticed := FALSE;
    END; (* IF *)
  END EffectStrengthDamage;
  
  PROCEDURE EffectWisdomDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
  BEGIN (* EffectWisdomDamage *)
    MPDamage.ReduceCharacterHitPoints (player,damage,killer);
    
    IF MCStruct.SustainWisFLAG IN player^.character^.variables.status THEN
      MMWindow.AddMessageToList (player,"Your wisdom is sustained.");
    ELSE
      MMWindow.AddMessageToList (player,"Your wisdom is drained.");
      MSActs2.DecrementStatistic (player,MCStruct.wis);
    END; (* IF *)
  END EffectWisdomDamage;

  PROCEDURE InitializeEffectPlayerDamageTable;
    VAR
        index : CStruct.CreatureAttackClass;
    
  BEGIN (* InitializeEffectPlayerDamageTable *)
    FOR index := MIN (CStruct.CreatureAttackClass) TO MAX (CStruct.CreatureAttackClass) DO
      EffectPlayerDamage [index] := InvalidDamageProcedure;
    END; (* FOR *)
    
    EffectPlayerDamage [CStruct.acid] := EffectAcidDamage;
    EffectPlayerDamage [CStruct.aggravation] := EffectAggravationDamage;
    EffectPlayerDamage [CStruct.blindness] := EffectBlindnessDamage;
    EffectPlayerDamage [CStruct.charges] := EffectChargesDamage;
    EffectPlayerDamage [CStruct.cold] := EffectColdDamage;
    EffectPlayerDamage [CStruct.confusion] := EffectConfusionDamage;
    EffectPlayerDamage [CStruct.constitution] := EffectConstitutionDamage;
    EffectPlayerDamage [CStruct.corrosion] := EffectCorrosionDamage;
    EffectPlayerDamage [CStruct.dexterity] := EffectDexterityDamage;
    EffectPlayerDamage [CStruct.disenchantment] := EffectDisenchantmentDamage;
    EffectPlayerDamage [CStruct.experience] := EffectExperienceDamage;
    EffectPlayerDamage [CStruct.fear] := EffectFearDamage;
    EffectPlayerDamage [CStruct.fire] := EffectFireDamage;
    EffectPlayerDamage [CStruct.food] := MPDamage.EffectFoodDamage;
    EffectPlayerDamage [CStruct.intelligence] := EffectIntelligenceDamage;
    EffectPlayerDamage [CStruct.light] := EffectLightDamage;
    EffectPlayerDamage [CStruct.lightning] := EffectLightningDamage;
    EffectPlayerDamage [CStruct.money] := EffectMoneyDamage;
    EffectPlayerDamage [CStruct.noAttack] := EffectNoAttackDamage;
    EffectPlayerDamage [CStruct.normal] := EffectNormalDamage;
    EffectPlayerDamage [CStruct.object] := MPDamage.EffectObjectDamage;
    EffectPlayerDamage [CStruct.paralysis] := EffectParalysisDamage;
    EffectPlayerDamage [CStruct.poison] := EffectPoisonDamage;
    EffectPlayerDamage [CStruct.repelled] := EffectRepelledDamage;
    EffectPlayerDamage [CStruct.strength] := EffectStrengthDamage;
    EffectPlayerDamage [CStruct.wisdom] := EffectWisdomDamage;
  END InitializeEffectPlayerDamageTable;
  
BEGIN (* MCDamage *)
  InitializeEffectPlayerDamageTable;
END MCDamage.
