IMPLEMENTATION MODULE MCDDisplay;
  (*/WIN:A*)
  
  IMPORT WDialog,Windows,WMacro,WString;
  IMPORT MCSActions,MCSActs2;
  IMPORT MCStruct,MStruct;
  IMPORT Strings;
  
  
  PROCEDURE DisplayCharacterInformation (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
    PROCEDURE UpdatePlayerAbilitiesGroupBox (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
      CONST
            PerceptionAbilityControl = 158;
            MartialAbilityControl    = 152;
            MissileAbilityControl    = 153;
            StealthAbilityControl    = 155;
            DeviceAbilityControl     = 157;
            DisarmAbilityControl     = 156;
            SearchAbilityControl     = 159;
            SaveAbilityControl       = 154;
      
      CONST
            InfraVisionControl = 160;
      
      TYPE
           PlayerAbilityMnemonic = (VeryBad,Bad,Poor,Fair,Good,VeryGood,Excellent,Superb);
      
      PROCEDURE AbilityMnemonicFor (value : INTEGER) : PlayerAbilityMnemonic;
      BEGIN (* AbilityMnemonicFor *)
        CASE value OF
          -3,-2,-1 : RETURN (VeryBad);   |
              0,+1 : RETURN (Bad);       |
                +2 : RETURN (Poor);      |
             +3,+4 : RETURN (Fair);      |
                +5 : RETURN (Good);      |
                +6 : RETURN (VeryGood);  |
             +7,+8 : RETURN (Excellent); |
        ELSE
          RETURN (Superb);
        END; (* CASE *)
      END AbilityMnemonicFor;
      
      PROCEDURE DeviceAbilityMnemonic (player : MStruct.PlayerInfoPointer; ability : INTEGER) : PlayerAbilityMnemonic;
      BEGIN (* DeviceAbilityMnemonic *)
        RETURN (AbilityMnemonicFor ((ability + MCSActions.CharacterStatisticAdjustment (player^.character,MCStruct.int) + MCSActions.ClassDeviceLevelAdjustment (player^.character^.constants.class) * player^.character^.variables.level DIV 3) DIV 6));
      END DeviceAbilityMnemonic;
      
      PROCEDURE DisarmAbilityMnemonic (player : MStruct.PlayerInfoPointer; ability : INTEGER) : PlayerAbilityMnemonic;
      BEGIN (* DisarmAbilityMnemonic *)
        RETURN (AbilityMnemonicFor ((ability + 2 * MCSActions.CharacterDisarmingAdjustment (player^.character) + MCSActions.CharacterStatisticAdjustment (player^.character,MCStruct.int) + MCSActions.ClassDisarmingLevelAdjustment (player^.character^.constants.class) * player^.character^.variables.level DIV 3) DIV 8));
      END DisarmAbilityMnemonic;
      
      PROCEDURE MartialAbilityMnemonic (player : MStruct.PlayerInfoPointer; ability : INTEGER) : PlayerAbilityMnemonic;
      BEGIN (* MartialAbilityMnemonic *)
        RETURN (AbilityMnemonicFor ((ability + player^.character^.variables.bonusREAL.strike * MCStruct.MartialStrikeAdjustment + MCSActions.ClassMartialLevelAdjustment (player^.character^.constants.class) * player^.character^.variables.level) DIV 12));
      END MartialAbilityMnemonic;
      
      PROCEDURE MissileAbilityMnemonic (player : MStruct.PlayerInfoPointer; ability : INTEGER) : PlayerAbilityMnemonic;
        CONST
              MissileStrikeAdjustment = 3;
        
      BEGIN (* MissileAbilityMnemonic *)
        RETURN (AbilityMnemonicFor ((ability + player^.character^.variables.bonusREAL.strike * MissileStrikeAdjustment + MCSActions.ClassMissileLevelAdjustment (player^.character^.constants.class) * player^.character^.variables.level) DIV 12));
      END MissileAbilityMnemonic;
      
      PROCEDURE PerceptionAbilityMnemonic (player : MStruct.PlayerInfoPointer; ability : INTEGER) : PlayerAbilityMnemonic;
      BEGIN (* PerceptionAbilityMnemonic *)
        RETURN (AbilityMnemonicFor ((WMacro.MaxInteger (40 - ability,0)) DIV 3));
      END PerceptionAbilityMnemonic;
      
      PROCEDURE SaveAbilityMnemonic (player : MStruct.PlayerInfoPointer; ability : INTEGER) : PlayerAbilityMnemonic;
      BEGIN (* SaveAbilityMnemonic *)
        RETURN (AbilityMnemonicFor ((ability + MCSActions.CharacterStatisticAdjustment (player^.character,MCStruct.wis) + MCSActions.ClassSaveLevelAdjustment (player^.character^.constants.class) * player^.character^.variables.level DIV 3) DIV 6));
      END SaveAbilityMnemonic;
      
      PROCEDURE SearchAbilityMnemonic (player : MStruct.PlayerInfoPointer; ability : INTEGER) : PlayerAbilityMnemonic;
      BEGIN (* SearchAbilityMnemonic *)
        RETURN (AbilityMnemonicFor (ability DIV 6));
      END SearchAbilityMnemonic;
      
      PROCEDURE StealthAbilityMnemonic (player : MStruct.PlayerInfoPointer; ability : INTEGER) : PlayerAbilityMnemonic;
      BEGIN (* StealthAbilityMnemonic *)
        RETURN (AbilityMnemonicFor (ability + 1));
      END StealthAbilityMnemonic;
      
      PROCEDURE UpdateAbilityMnemonic (window : Windows.HWND; control : CARDINAL; ability : PlayerAbilityMnemonic);
      BEGIN (* UpdateAbilityMnemonic *)
        CASE ability OF
          VeryBad   : WDialog.SetDlgItemText (window,control,"Very Bad");  |
          Bad       : WDialog.SetDlgItemText (window,control,"Bad");       |
          Poor      : WDialog.SetDlgItemText (window,control,"Poor");      |
          Fair      : WDialog.SetDlgItemText (window,control,"Fair");      |
          Good      : WDialog.SetDlgItemText (window,control,"Good");      |
          VeryGood  : WDialog.SetDlgItemText (window,control,"Very Good"); |
          Excellent : WDialog.SetDlgItemText (window,control,"Excellent"); |
          Superb    : WDialog.SetDlgItemText (window,control,"Superb");    |
        END; (* CASE *)
      END UpdateAbilityMnemonic;
      
      PROCEDURE UpdateInfraVisionDistance (window : Windows.HWND; control : CARDINAL; infra : CARDINAL);
        VAR
            str : ARRAY [0..15] OF CHAR;
        
      BEGIN (* UpdateInfraVisionDistance *)
        WString.ReplaceCardinalParameter ("%VALUE feet","%VALUE",infra * 10,str);
        WDialog.SetDlgItemText (window,control,str);
      END UpdateInfraVisionDistance;
      
    BEGIN (* UpdatePlayerAbilitiesGroupBox *)
      UpdateAbilityMnemonic (window,PerceptionAbilityControl,PerceptionAbilityMnemonic (player,player^.character^.abilities.perception));
      UpdateAbilityMnemonic (window,MartialAbilityControl,MartialAbilityMnemonic (player,player^.character^.abilities.martial));
      UpdateAbilityMnemonic (window,MissileAbilityControl,MissileAbilityMnemonic (player,player^.character^.abilities.missile));
      UpdateAbilityMnemonic (window,StealthAbilityControl,StealthAbilityMnemonic (player,player^.character^.abilities.stealth));
      UpdateAbilityMnemonic (window,DeviceAbilityControl,DeviceAbilityMnemonic (player,player^.character^.abilities.save));
      UpdateAbilityMnemonic (window,DisarmAbilityControl,DisarmAbilityMnemonic (player,player^.character^.abilities.disarm));
      UpdateAbilityMnemonic (window,SearchAbilityControl,SearchAbilityMnemonic (player,player^.character^.abilities.search));
      UpdateAbilityMnemonic (window,SaveAbilityControl,SaveAbilityMnemonic (player,player^.character^.abilities.save));
      
      UpdateInfraVisionDistance (window,InfraVisionControl,player^.character^.abilities.infra);
    END UpdatePlayerAbilitiesGroupBox;
    
    PROCEDURE UpdatePlayerAgeGroupBox (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
      CONST
            PlayerAgeControl      = 114;
            PlayerHeightControl   = 115;
            PlayerWeightControl   = 116;
            PlayerStandingControl = 117;
      
    BEGIN (* UpdatePlayerAgeGroupBox *)
      WITH player^.character^.constants DO
        WDialog.SetDlgItemCardinal (window,PlayerAgeControl,age);
        WDialog.SetDlgItemCardinal (window,PlayerHeightControl,height);
        WDialog.SetDlgItemCardinal (window,PlayerWeightControl,weight);
        WDialog.SetDlgItemCardinal (window,PlayerStandingControl,standing);
      END; (* WITH *)
    END UpdatePlayerAgeGroupBox;
    
    PROCEDURE UpdatePlayerBonusGroupBox (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
      CONST
            StrikeBonusControl = 175;
            DamageBonusControl = 176;
            ArmorBonusControl  = 177;
            TotalArmorControl  = 178;
      
      PROCEDURE SetDlgItemSignedInteger (window : Windows.HWND; control : CARDINAL; value : INTEGER);
        VAR
            str : ARRAY [0..15] OF CHAR;
        
      BEGIN (* SetDlgItemSignedInteger *)
        WString.ReplaceIntegerParameter ("%VALUE","%VALUE",value,str);
        
        IF value >= 0 THEN
          Strings.Insert ("+",str,0);
        END; (* IF *)
        
        WDialog.SetDlgItemText (window,control,str);
      END SetDlgItemSignedInteger;
      
    BEGIN (* UpdatePlayerBonusGroupBox *)
      WITH player^.character^.variables DO
        SetDlgItemSignedInteger (window,StrikeBonusControl,bonusDISP.strike);
        SetDlgItemSignedInteger (window,DamageBonusControl,bonusDISP.damage);
        SetDlgItemSignedInteger (window,ArmorBonusControl,bonusDISP.armor);
        
        WDialog.SetDlgItemInteger (window,TotalArmorControl,armorDISP);
      END; (* WITH *)
    END UpdatePlayerBonusGroupBox;
    
    PROCEDURE UpdatePlayerHistoryGroupBox (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
      CONST
            HistoryStaticTextControl = 181;
      
    BEGIN (* UpdatePlayerHistoryGroupBox *)
      WDialog.SetDlgItemText (window,HistoryStaticTextControl,player^.character^.constants.history);
    END UpdatePlayerHistoryGroupBox;
    
    PROCEDURE UpdatePlayerHitPointsGroupBox (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
      CONST
            MaxHitPointsControl = 166;
            CurHitPointsControl = 167;
            MaxManaControl      = 168;
            CurManaControl      = 169;
      
    BEGIN (* UpdatePlayerHitPointsGroupBox *)
      WITH player^.character^.variables DO
        WDialog.SetDlgItemCardinal (window,MaxHitPointsControl,TRUNC (hpMAX));
        WDialog.SetDlgItemCardinal (window,CurHitPointsControl,TRUNC (hpCUR));
        WDialog.SetDlgItemCardinal (window,MaxManaControl,TRUNC (manaMAX));
        WDialog.SetDlgItemCardinal (window,CurManaControl,TRUNC (manaCUR));
      END; (* WITH *)
    END UpdatePlayerHitPointsGroupBox;
    
    PROCEDURE UpdatePlayerLevelGroupBox (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
      CONST
            CurrentLevelControl      = 137;
            CurrentExperienceControl = 138;
            MaximumExperienceControl = 139;
            AdvanceExperienceControl = 140;
            CurrentGoldControl       = 141;
      
    BEGIN (* UpdatePlayerLevelGroupBox *)
      WITH player^.character^.variables DO
        WDialog.SetDlgItemCardinal (window,CurrentLevelControl,level);
        WDialog.SetDlgItemLongCard (window,CurrentExperienceControl,LONGTRUNC (experCUR));
        WDialog.SetDlgItemLongCard (window,MaximumExperienceControl,LONGTRUNC (experMAX));
        
        IF level < MCStruct.MaxPlayerLevel THEN
          WDialog.SetDlgItemLongCard (window,AdvanceExperienceControl,LONGTRUNC (MCSActions.ExperienceNeededToAdvance (player^.character)));
        ELSE
          WDialog.SetDlgItemText (window,AdvanceExperienceControl,"******");
        END; (* IF *)
        
        WDialog.SetDlgItemLongCard (window,CurrentGoldControl,currentGOLD);
      END; (* WITH *)
    END UpdatePlayerLevelGroupBox;
    
    PROCEDURE UpdatePlayerStatisticsGroupBox (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
      CONST
            BaseStatisticValueControl = 125;
      
      VAR
          index : MCStruct.PlayerStatisticMnemonic;
      
      PROCEDURE UpdatePlayerStatisticValue (window : Windows.HWND; control : CARDINAL; value : MCStruct.PlayerStatisticRange);
        VAR
            str : ARRAY [0..15] OF CHAR;
        
      BEGIN (* UpdatePlayerStatisticValue *)
        MCSActs2.StatisticRangeToString (value,str);
        WDialog.SetDlgItemText (window,control,str);
      END UpdatePlayerStatisticValue;
      
    BEGIN (* UpdatePlayerStatisticsGroupBox *)
      FOR index := MIN (MCStruct.PlayerStatisticMnemonic) TO MAX (MCStruct.PlayerStatisticMnemonic) DO
        UpdatePlayerStatisticValue (window,BaseStatisticValueControl + ORD (index),player^.character^.statistics.used [index]);
      END; (* FOR *)
    END UpdatePlayerStatisticsGroupBox;
    
  BEGIN (* DisplayCharacterInformation *)
    UpdatePlayerStatisticsGroupBox (window,player);
    UpdatePlayerAbilitiesGroupBox (window,player);
    UpdatePlayerHitPointsGroupBox (window,player);
    UpdatePlayerHistoryGroupBox (window,player);
    UpdatePlayerBonusGroupBox (window,player);
    UpdatePlayerLevelGroupBox (window,player);
    UpdatePlayerAgeGroupBox (window,player);
  END DisplayCharacterInformation;
END MCDDisplay.
