IMPLEMENTATION MODULE MCDeath;
  (*/WIN:A*)
  
  IMPORT MCDialog,MDialogs,MHSDialog,MPInventory,MPRest,MSave,MScores;
  IMPORT MCStruct,MStruct;
  IMPORT WDialog,Windows;
  IMPORT MSActions;
  IMPORT Strings;
  
  
  PROCEDURE ExecuteTombstoneCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; command : CARDINAL);
    CONST
          HighscoresPushButtonControl = 814;
          CharacterPushButtonControl  = 815;
          InventoryPushButtonControl  = 816;
          ExitPushButtonControl       = 817;
    
  BEGIN (* ExecuteTombstoneCommand *)
    IF command = Windows.BN_CLICKED THEN
      CASE control OF
        HighscoresPushButtonControl,Windows.IDOK : MHSDialog.ExecuteHighScoresDialog (window);            |
        CharacterPushButtonControl               : MCDialog.DisplayCharacterInformation (window,player);  |
        InventoryPushButtonControl               : MPInventory.ExecuteInventoryDialog (window,player);    |
        ExitPushButtonControl,Windows.IDCANCEL   : TerminateTombstoneDialog (window,player);              |
      ELSE
        (* no action *)
      END; (* CASE *)
    END; (* CASE *)
  END ExecuteTombstoneCommand;
  
  PROCEDURE InitializeTombstoneDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
    CONST
          CharacterNameControl       = 803;
          CharacterLevelControl      = 805;
          CharacterExperienceControl = 807;
          CharacterGoldControl       = 809;
          CharacterDepthControl      = 811;
          CharacterKillerControl     = 813;
    
  BEGIN (* InitializeTombstoneDialog *)
    WDialog.SetDlgItemText (window,CharacterNameControl,player^.character^.constants.name);
    WDialog.SetDlgItemCardinal (window,CharacterLevelControl,player^.character^.variables.level);
    WDialog.SetDlgItemLongCard (window,CharacterExperienceControl,LONGTRUNC (player^.character^.variables.experCUR));
    WDialog.SetDlgItemLongCard (window,CharacterGoldControl,player^.character^.variables.currentGOLD);
    WDialog.SetDlgItemCardinal (window,CharacterDepthControl,player^.character^.variables.depthCUR);
    WDialog.SetDlgItemText (window,CharacterKillerControl,player^.killer);
  END InitializeTombstoneDialog;
  
  PROCEDURE KillCurrentCharacter (VAR player : MStruct.PlayerInfoPointer);
    VAR
        result : INTEGER;
    
  BEGIN (* KillCurrentCharacter *)
    IF player^.character^.variables.counters [MCStruct.RestCOUNT] > 0 THEN
      MPRest.StopPlayerResting (player);
    END; (* IF *)
    
    IF NOT (MCStruct.FormerWizardFLAG IN player^.character^.variables.status) THEN
      MScores.UpdateHighScoreInformation (player);
    END; (* IF *)
    
    MDialogs.ExecuteMoriaDialogBox (player^.windows.frame,"Character_Death_Dialog",player,InitializeTombstoneDialog,ExecuteTombstoneCommand,TerminateTombstoneDialog,result);
    
    IF Strings.Length (player^.fileNAME) > 0 THEN
      MSave.UpdateCreatureMemoryInformation (player);
    END; (* IF *)
    
    MSActions.DeallocateCharacterInformation (player);
  END KillCurrentCharacter;

  PROCEDURE TerminateTombstoneDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* TerminateTombstoneDialog *)
    WDialog.EndDialog (window,Windows.FALSE_BOOL);
  END TerminateTombstoneDialog;
END MCDeath.
