IMPLEMENTATION MODULE MCGenerator;
  (*/WIN:A*)
  
  IMPORT MCDialog,MDGenerator,MInventory,MResources;
  IMPORT MSActions,MSActs2,OSActions;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT Windows;
  
  
  PROCEDURE GenerateNewCharacter (window : Windows.HWND; VAR player : MStruct.PlayerInfoPointer);
    PROCEDURE InitializeCharacterInventory (player : MStruct.PlayerInfoPointer);
      PROCEDURE AssignInitialInventory (player : MStruct.PlayerInfoPointer; item1,item2,item3,item4,item5 : CARDINAL);
        PROCEDURE AddObjectToPlayerInventory (player : MStruct.PlayerInfoPointer; cursor : CARDINAL);
          VAR
              location : CARDINAL;
              item     : OStruct.InventoryItemRecord;
          
          PROCEDURE ReturnInitialInventoryObject (treasure : OStruct.TreasureInfoPointer; cursor : CARDINAL; VAR result : OStruct.InventoryItemRecord);
            PROCEDURE IdentifyInitialInventoryItem (treasure : OStruct.TreasureInfoPointer; VAR item : OStruct.InventoryItemRecord);
            BEGIN (* IdentifyInitialInventoryItem *)
              OSActions.IdentifyObjectAsStoreBought (treasure,item);
              
              IF item.object.class = OStruct.BladeWeapon THEN
                INCL (item.identification,OStruct.IdentShowHitDam);
              END; (* IF *)
            END IdentifyInitialInventoryItem;
            
          BEGIN (* ReturnInitialInventoryObject *)
            OSActions.ReturnInventoryItemRecord (treasure,cursor,result);
            IdentifyInitialInventoryItem (treasure,result);
          END ReturnInitialInventoryObject;
          
        BEGIN (* AddObjectToPlayerInventory *)
          ReturnInitialInventoryObject (player^.treasures,cursor,item);
          MInventory.AddObjectToPlayerInventory (player,item,location);
        END AddObjectToPlayerInventory;
        
      BEGIN (* AssignInitialInventory *)
        AddObjectToPlayerInventory (player,item1);
        AddObjectToPlayerInventory (player,item2);
        AddObjectToPlayerInventory (player,item3);
        AddObjectToPlayerInventory (player,item4);
        AddObjectToPlayerInventory (player,item5);
      END AssignInitialInventory;
      
    BEGIN (* InitializeCharacterInventory *)
      CASE player^.character^.constants.class OF
        MCStruct.Warrior : AssignInitialInventory (player,344, 365, 123,  30, 103); |
        MCStruct.Mage    : AssignInitialInventory (player,344, 365, 123,  30, 318); |
        MCStruct.Priest  : AssignInitialInventory (player,344, 365, 123,  30, 322); |
        MCStruct.Rogue   : AssignInitialInventory (player,344, 365, 123,  30, 318); |
        MCStruct.Ranger  : AssignInitialInventory (player,344, 365, 123,  30, 318); |
        MCStruct.Paladin : AssignInitialInventory (player,344, 365, 123,  30, 322); |
      END; (* CASE *)
    END InitializeCharacterInventory;
    
    PROCEDURE InitializeCharacterSpells (player : MStruct.PlayerInfoPointer);
      VAR
          ptr : MCStruct.CharacterResourceDataPointer;
      
    BEGIN (* InitializeCharacterSpells *)
      IF player^.character^.constants.class <> MCStruct.Warrior THEN
        ptr                             := MResources.LoadCharacterResources ();
        player^.character^.spells.table := ptr^.spellINFO [player^.character^.constants.class];
        
        IF player^.character^.constants.class IN MCStruct.PriestClasses THEN
          player^.character^.spells.names := ptr^.spellNAMES [MCStruct.Priest];
        ELSE
          player^.character^.spells.names := ptr^.spellNAMES [MCStruct.Mage];
        END; (* IF *)
        
        MResources.FreeCharacterResources;
      END; (* IF *)
    END InitializeCharacterSpells;
    
    PROCEDURE InitializeStoreInformation (player : MStruct.PlayerInfoPointer);
      VAR
          index : MCStruct.PlayerStoreMnemonic;
      
      PROCEDURE DetermineAcceptableObjects (store : MCStruct.PlayerStoreMnemonic; VAR result : OStruct.ObjectClassSet);
      BEGIN (* DetermineAcceptableObjects *)
        CASE store OF
          MCStruct.GeneralStore : result := OStruct.ObjectClassSet {OStruct.DiggingTool,OStruct.Boots,OStruct.Cloak,OStruct.Food,OStruct.Flask,OStruct.Light,OStruct.Spike};                                   |
          MCStruct.Armory       : result := OStruct.ObjectClassSet {OStruct.Boots,OStruct.Gloves,OStruct.Helm,OStruct.Shield,OStruct.HardBodyArmor,OStruct.SoftBodyArmor};                                     |
          MCStruct.Weaponsmith  : result := OStruct.ObjectClassSet {OStruct.SlingAmmo,OStruct.Bolt,OStruct.Arrow,OStruct.MissileWeapon,OStruct.HaftedWeapon,OStruct.PoleWeapon,OStruct.BladeWeapon};           |
          MCStruct.Temple       : result := OStruct.ObjectClassSet {OStruct.HaftedWeapon,OStruct.Scroll1,OStruct.Scroll2,OStruct.Potion1,OStruct.Potion2,OStruct.PrayerBook};                                  |
          MCStruct.Alchemist    : result := OStruct.ObjectClassSet {OStruct.Scroll1,OStruct.Scroll2,OStruct.Potion1,OStruct.Potion2};                                                                          |
          MCStruct.MagicShop    : result := OStruct.ObjectClassSet {OStruct.Amulet,OStruct.Ring,OStruct.Staff,OStruct.Wand,OStruct.Scroll1,OStruct.Scroll2,OStruct.Potion1,OStruct.Potion2,OStruct.MagicBook}; |
        END; (* CASE *)
      END DetermineAcceptableObjects;
      
      PROCEDURE StoreRacialAdjustment (owner,player : MCStruct.PlayerRaceMnemonic) : CARDINAL;
        PROCEDURE DwarfRacialPriceAdjustment (player : MCStruct.PlayerRaceMnemonic) : CARDINAL;
        BEGIN (* DwarfRacialPriceAdjustment *)
          CASE player OF
            MCStruct.Human     : RETURN (115); |
            MCStruct.HalfElf   : RETURN (120); |
            MCStruct.Elf       : RETURN (120); |
            MCStruct.Halfling  : RETURN (110); |
            MCStruct.Gnome     : RETURN (110); |
            MCStruct.Dwarf     : RETURN ( 95); |
            MCStruct.HalfOrc   : RETURN (125); |
            MCStruct.HalfTroll : RETURN (135); |
          END; (* CASE *)
        END DwarfRacialPriceAdjustment;
        
        PROCEDURE ElfRacialPriceAdjustment (player : MCStruct.PlayerRaceMnemonic) : CARDINAL;
        BEGIN (* ElfRacialPriceAdjustment *)
          CASE player OF
            MCStruct.Human     : RETURN (110); |
            MCStruct.HalfElf   : RETURN (105); |
            MCStruct.Elf       : RETURN (100); |
            MCStruct.Halfling  : RETURN (105); |
            MCStruct.Gnome     : RETURN (110); |
            MCStruct.Dwarf     : RETURN (120); |
            MCStruct.HalfOrc   : RETURN (125); |
            MCStruct.HalfTroll : RETURN (130); |
          END; (* CASE *)
        END ElfRacialPriceAdjustment;
        
        PROCEDURE GnomeRacialPriceAdjustment (player : MCStruct.PlayerRaceMnemonic) : CARDINAL;
        BEGIN (* GnomeRacialPriceAdjustment *)
          CASE player OF
            MCStruct.Human     : RETURN (115); |
            MCStruct.HalfElf   : RETURN (115); |
            MCStruct.Elf       : RETURN (110); |
            MCStruct.Halfling  : RETURN (105); |
            MCStruct.Gnome     : RETURN ( 95); |
            MCStruct.Dwarf     : RETURN (110); |
            MCStruct.HalfOrc   : RETURN (115); |
            MCStruct.HalfTroll : RETURN (130); |
          END; (* CASE *)
        END GnomeRacialPriceAdjustment;
        
        PROCEDURE HalfElfRacialPriceAdjustment (player : MCStruct.PlayerRaceMnemonic) : CARDINAL;
        BEGIN (* HalfElfRacialPriceAdjustment *)
          CASE player OF
            MCStruct.Human     : RETURN (110); |
            MCStruct.HalfElf   : RETURN (100); |
            MCStruct.Elf       : RETURN (100); |
            MCStruct.Halfling  : RETURN (105); |
            MCStruct.Gnome     : RETURN (110); |
            MCStruct.Dwarf     : RETURN (120); |
            MCStruct.HalfOrc   : RETURN (125); |
            MCStruct.HalfTroll : RETURN (130); |
          END; (* CASE *)
        END HalfElfRacialPriceAdjustment;
        
        PROCEDURE HalflingRacialPriceAdjustment (player : MCStruct.PlayerRaceMnemonic) : CARDINAL;
        BEGIN (* HalflingRacialPriceAdjustment *)
          CASE player OF
            MCStruct.Human     : RETURN (115); |
            MCStruct.HalfElf   : RETURN (110); |
            MCStruct.Elf       : RETURN (105); |
            MCStruct.Halfling  : RETURN ( 95); |
            MCStruct.Gnome     : RETURN (105); |
            MCStruct.Dwarf     : RETURN (110); |
            MCStruct.HalfOrc   : RETURN (115); |
            MCStruct.HalfTroll : RETURN (130); |
          END; (* CASE *)
        END HalflingRacialPriceAdjustment;
        
        PROCEDURE HalfOrcRacialPriceAdjustment (player : MCStruct.PlayerRaceMnemonic) : CARDINAL;
        BEGIN (* HalfOrcRacialPriceAdjustment *)
          CASE player OF
            MCStruct.Human     : RETURN (115); |
            MCStruct.HalfElf   : RETURN (120); |
            MCStruct.Elf       : RETURN (125); |
            MCStruct.Halfling  : RETURN (115); |
            MCStruct.Gnome     : RETURN (115); |
            MCStruct.Dwarf     : RETURN (130); |
            MCStruct.HalfOrc   : RETURN (110); |
            MCStruct.HalfTroll : RETURN (115); |
          END; (* CASE *)
        END HalfOrcRacialPriceAdjustment;
        
        PROCEDURE HalfTrollRacialPriceAdjustment (player : MCStruct.PlayerRaceMnemonic) : CARDINAL;
        BEGIN (* HalfTrollRacialPriceAdjustment *)
          CASE player OF
            MCStruct.Human     : RETURN (110); |
            MCStruct.HalfElf   : RETURN (115); |
            MCStruct.Elf       : RETURN (115); |
            MCStruct.Halfling  : RETURN (110); |
            MCStruct.Gnome     : RETURN (110); |
            MCStruct.Dwarf     : RETURN (130); |
            MCStruct.HalfOrc   : RETURN (110); |
            MCStruct.HalfTroll : RETURN (110); |
          END; (* CASE *)
        END HalfTrollRacialPriceAdjustment;
        
        PROCEDURE HumanRacialPriceAdjustment (player : MCStruct.PlayerRaceMnemonic) : CARDINAL;
        BEGIN (* HumanRacialPriceAdjustment *)
          CASE player OF
            MCStruct.Human     : RETURN (100); |
            MCStruct.HalfElf   : RETURN (105); |
            MCStruct.Elf       : RETURN (105); |
            MCStruct.Halfling  : RETURN (110); |
            MCStruct.Gnome     : RETURN (113); |
            MCStruct.Dwarf     : RETURN (115); |
            MCStruct.HalfOrc   : RETURN (120); |
            MCStruct.HalfTroll : RETURN (125); |
          END; (* CASE *)
        END HumanRacialPriceAdjustment;
        
      BEGIN (* StoreRacialAdjustment *)
        CASE owner OF
          MCStruct.Human     : RETURN (HumanRacialPriceAdjustment (player));     |
          MCStruct.HalfElf   : RETURN (HalfElfRacialPriceAdjustment (player));   |
          MCStruct.Elf       : RETURN (ElfRacialPriceAdjustment (player));       |
          MCStruct.Halfling  : RETURN (HalflingRacialPriceAdjustment (player));  |
          MCStruct.Gnome     : RETURN (GnomeRacialPriceAdjustment (player));     |
          MCStruct.Dwarf     : RETURN (DwarfRacialPriceAdjustment (player));     |
          MCStruct.HalfOrc   : RETURN (HalfOrcRacialPriceAdjustment (player));   |
          MCStruct.HalfTroll : RETURN (HalfTrollRacialPriceAdjustment (player)); |
        END; (* CASE *)
      END StoreRacialAdjustment;
      
    BEGIN (* InitializeStoreInformation *)
      FOR index := MIN (MCStruct.PlayerStoreMnemonic) TO MAX (MCStruct.PlayerStoreMnemonic) DO
        player^.character^.stores [index].owner.raceADJ := StoreRacialAdjustment (player^.character^.stores [index].owner.race,player^.character^.constants.race);
        DetermineAcceptableObjects (index,player^.character^.stores [index].acceptable);
      END; (* FOR *)
    END InitializeStoreInformation;
    
    PROCEDURE LoadClassTitleTable (player : MStruct.PlayerInfoPointer);
      VAR
          ptr : MCStruct.CharacterResourceDataPointer;
      
    BEGIN (* LoadClassTitleTable *)
      ptr                                     := MResources.LoadCharacterResources ();
      player^.character^.constants.titleTABLE := ptr^.titles [player^.character^.constants.class];
      
      MResources.FreeCharacterResources;
    END LoadClassTitleTable;
    
  BEGIN (* GenerateNewCharacter *)
    MSActions.AllocateCharacterInformation (player);
    MCDialog.ExecuteCharGenDialog (window);
    
    LoadClassTitleTable (player);
    
    InitializeCharacterInventory (player);
    InitializeStoreInformation (player);
    InitializeCharacterSpells (player);
    
    MDGenerator.GeneratePlayerDungeon (player);
    
    MSActs2.InitializeGamingWindows (window,player);
  END GenerateNewCharacter;
END MCGenerator.
