IMPLEMENTATION MODULE MCLoop;
  (*/WIN:A*)
  
  IMPORT WDebugging,WDialog,Windows,WInput,WinStart,WMessage;
  
  IMPORT MCDeath,MCreatures,MFiles,MMWindow,MPMovement,MPStatus;
  IMPORT DStruct,MCStruct,MStruct;
  IMPORT DSActions;
  
  
  PROCEDURE ExecuteFullTurnActions (player : MStruct.PlayerInfoPointer; VAR break : BOOLEAN);
  BEGIN (* ExecuteFullTurnActions *)
    MCreatures.ExecuteCreatureActions (player);
    MPStatus.UpdatePlayerStatusInformation (player);
    
    break := ((player^.character^.variables.counters [MCStruct.ParalysisCOUNT] > 0) AND (player^.character^.variables.hpCUR > 0.0));
  END ExecuteFullTurnActions;
  
  PROCEDURE ExecuteMoriaCommandLoop (window : Windows.HWND);
    PROCEDURE ExecuteCharacterCommand (VAR player : MStruct.PlayerInfoPointer);
      VAR
          translated : BOOLEAN;
          available  : BOOLEAN;
          message    : Windows.MSG;
          result     : Windows.LRESULT;
          quit       : BOOLEAN;
      
    BEGIN (* ExecuteCharacterCommand *)
      MStruct.CharacterTurnExecuted := FALSE;
      
      REPEAT
        WMessage.PeekMessage (Windows.NULL,MIN (CARDINAL),MAX (CARDINAL),Windows.PM_REMOVE,message,available);
        
        quit := (available AND (message.message = Windows.WM_QUIT));
        
        IF (available AND NOT (quit)) THEN
          IF ((player = NIL) OR (player^.windows.dialog = Windows.NULL) OR NOT (WDialog.IsDialogMessage (player^.windows.dialog,message))) THEN
            WMessage.TranslateMessage (message,translated);
            WMessage.DispatchMessage (message,result);
          ELSE
            MStruct.CharacterTurnExecuted := (player^.character^.variables.counters [MCStruct.RestCOUNT] > 0);
          END; (* IF *)
        END; (* IF *)
      UNTIL (quit OR MStruct.CharacterTurnExecuted);
    END ExecuteCharacterCommand;
    
    PROCEDURE ExecuteDistanceMovementCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
      CONST
            MaximumDistanceMovement = 100;
      
      VAR
          column : DStruct.DungeonColumnRange;
          line   : DStruct.DungeonLineRange;
      
    BEGIN (* ExecuteDistanceMovementCommand *)
      IF MCStruct.MoveToTarget IN player^.character^.movement.flags THEN
        MPMovement.MoveCharacterToLocation (player,player^.character^.movement.nextLINE,player^.character^.movement.nextCOLUMN);
      ELSIF player^.character^.movement.distance < MaximumDistanceMovement THEN
        DSActions.DetermineDungeonLocation (player^.character^.line,player^.character^.column,player^.character^.movement.directionCUR,line,column);
        MPMovement.MoveCharacterToLocation (player,line,column);
        
        INC (player^.character^.movement.distance);
      ELSE
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You stop running to catch your breath.");
        EXCL (player^.character^.variables.status,MCStruct.DistanceMoveFLAG);
      END; (* IF *)
    END ExecuteDistanceMovementCommand;
    
    PROCEDURE ShouldExecuteCharacterCommand (player : MStruct.PlayerInfoPointer) : BOOLEAN;
    BEGIN (* ShouldExecuteCharacterCommand *)
      IF player = NIL THEN
        RETURN (TRUE);
      ELSIF MStruct.CurrentCharacterQuit THEN
        RETURN (FALSE);
      ELSIF player^.character^.variables.counters [MCStruct.ParalysisCOUNT] > 0 THEN
        RETURN (FALSE);
      ELSE
        RETURN (TRUE);
      END; (* IF *)
    END ShouldExecuteCharacterCommand;
    
  BEGIN (* ExecuteMoriaCommandLoop *)
    IF MFiles.ShouldLoadInitialCharacter (MFiles.CommandTailPointer (WinStart.lpCmdLine)) THEN
      MFiles.LoadInitialCharacter (MStruct.CurrentPlayerFrameWindow,MStruct.CurrentPlayerInformation,MFiles.CommandTailPointer (WinStart.lpCmdLine));
    END; (* IF *)
    
    MStruct.CurrentCharacterQuit := FALSE;
    
    REPEAT
      IF ((MStruct.CurrentPlayerInformation <> NIL) AND (MStruct.CurrentPlayerInformation^.character^.variables.hpCUR > 0.0)) THEN
        MPStatus.UpdatePlayerStatusInformation (MStruct.CurrentPlayerInformation);
      END; (* IF *)
      
      IF ((MStruct.CurrentPlayerInformation <> NIL) AND (MStruct.CurrentPlayerInformation^.character^.variables.hpCUR = 0.0)) THEN
        MCDeath.KillCurrentCharacter (MStruct.CurrentPlayerInformation);
      END; (* IF *)
      
      IF ShouldExecuteCharacterCommand (MStruct.CurrentPlayerInformation) THEN
        IF ((MStruct.CurrentPlayerInformation <> NIL) AND (MCStruct.DistanceMoveFLAG IN MStruct.CurrentPlayerInformation^.character^.variables.status)) THEN
          ExecuteDistanceMovementCommand (window,MStruct.CurrentPlayerInformation);
        ELSE
          ExecuteCharacterCommand (MStruct.CurrentPlayerInformation);
        END; (* IF *)
      END; (*IF *)
      
      IF (NOT (MStruct.CurrentCharacterQuit) AND (MStruct.CurrentPlayerInformation^.character^.variables.hpCUR > 0.0)) THEN
        MCreatures.ExecuteCreatureActions (MStruct.CurrentPlayerInformation);
      END; (* IF *)
    UNTIL MStruct.CurrentCharacterQuit;
  END ExecuteMoriaCommandLoop;
  
  PROCEDURE SetCurrentModelessDialog (player : MStruct.PlayerInfoPointer; dialog : Windows.HWND);
    VAR
        previous : BOOLEAN;
    
  BEGIN (* SetCurrentModelessDialog *)
    IF player^.windows.dialog <> Windows.NULL THEN
      WDebugging.FatalAppExit ("Attempt to use multiple modeless dialogs.");
    END; (* IF *)
    
    player^.windows.dialog := dialog;
    
    WInput.EnableWindow (player^.windows.frame,FALSE,previous);
  END SetCurrentModelessDialog;
END MCLoop.
