IMPLEMENTATION MODULE MCMove2;
  (*/WIN:A*)
  
  IMPORT MCAttack,MCreatures,MDPainting,MDWindow,MMWindow,MRandom,MTraps;
  IMPORT CStruct,DStruct,MStruct,OStruct;
  IMPORT DSActions,MSActs2,OSActions;
  IMPORT WDebugging;
  
  
  PROCEDURE ExecuteCreatureMove (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; table : MovementTable; VAR movement : CStruct.CreatureMovementInformation);
    VAR
        column : DStruct.DungeonColumnRange;
        index  : CARDINAL;
        line   : DStruct.DungeonLineRange;
        done   : BOOLEAN;
    
    PROCEDURE AttemptCreatureMove (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR movement : CStruct.CreatureMovementInformation; VAR done : BOOLEAN);
      VAR
          location : DStruct.PhysicalDungeonUnit;
          attempt  : BOOLEAN;
      
      PROCEDURE ArtifactIsRuneOfProtection (item : OStruct.InventoryItemRecord) : BOOLEAN;
      BEGIN (* ArtifactIsRuneOfProtection *)
        RETURN ((item.object.class = OStruct.VisibleTrap) AND (item.object.subclass = MTraps.RuneOfProtectionSubclass));
      END ArtifactIsRuneOfProtection;
      
      PROCEDURE AttackAnotherCreature (player : MStruct.PlayerInfoPointer; creature : CStruct.PassiveCreatureInfoRecord; visible : BOOLEAN; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR movement : CStruct.CreatureMovementInformation; VAR attempt : BOOLEAN);
        PROCEDURE CreatureAtLocationExperience (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange) : CARDINAL;
        BEGIN (* CreatureAtLocationExperience *)
          RETURN (player^.creatures^.table [player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].cursor].experience);
        END CreatureAtLocationExperience;
        
      BEGIN (* AttackAnotherCreature *)
        IF ((CStruct.MoveThroughCreature IN creature.movement) AND (creature.experience >= CreatureAtLocationExperience (player,line,column))) THEN
          DSActions.DeleteCreatureAtLocation (player^.dungeon^,line,column);
          
          IF visible THEN
            INCL (movement,CStruct.MoveThroughCreature);
          END; (* IF *)
        ELSE
          attempt := FALSE;
        END; (* IF *)
      END AttackAnotherCreature;
      
      PROCEDURE AttemptDoorMovement (player : MStruct.PlayerInfoPointer; VAR creatureACTIVE : DStruct.DungeonCreatureRecord; creaturePASSIVE : CStruct.PassiveCreatureInfoRecord; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR door : OStruct.InventoryItemRecord; VAR movement : CStruct.CreatureMovementInformation; VAR attempt,done : BOOLEAN);
        PROCEDURE AttemptCreatureBashDoor (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR door : OStruct.InventoryItemRecord; VAR done : BOOLEAN);
          PROCEDURE CreatureBreaksDoor (creature,door : LONGINT) : BOOLEAN;
          BEGIN (* CreatureBreaksDoor *)
            RETURN (VAL (LONGINT,MRandom.IntegerRandomRangeValue (1,creature + 1)) * 80 * door < 40 * (creature - 20 - door));
          END CreatureBreaksDoor;
          
        BEGIN (* AttemptCreatureBashDoor *)
          IF CreatureBreaksDoor (creature.hitpoints,ABS (door.object.miscellaneous)) THEN
            MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You hear a door burst open!");
            MSActs2.DisturbPlayer (player,TRUE);
            
            OSActions.ReturnInventoryItemRecord (player^.treasures,OStruct.OpenDoorObjectCursor,door);
            
            player^.dungeon^.physical [line]^ [column].elements := player^.dungeon^.physical [line]^ [column].elements - DStruct.DungeonElementSet {DStruct.NullWall..DStruct.BoundaryWall} + DStruct.DungeonElementSet {DStruct.CorridorFloor};
            door.object.miscellaneous                           := 1 - MRandom.IntegerRandomRangeValue (1,2);
            
            MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
          END; (* IF *)
          
          done := TRUE;
        END AttemptCreatureBashDoor;
        
        PROCEDURE AttemptCreatureOpenDoor (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR door : OStruct.InventoryItemRecord; VAR movement : CStruct.CreatureMovementInformation; VAR attempt,done : BOOLEAN);
          VAR
              stuck : BOOLEAN;
          
        BEGIN (* AttemptCreatureOpenDoor *)
          stuck := FALSE;
          
          IF door.object.class = OStruct.ClosedDoor THEN
            IF door.object.miscellaneous = 0 THEN
              attempt := TRUE;
            ELSIF ((door.object.miscellaneous > 0) AND (MRandom.IntegerRandomRangeValue (1,creature.hitpoints + 1) * (door.object.miscellaneous + 50) < 40 * (VAL (INTEGER,creature.hitpoints) - 10 - door.object.miscellaneous))) THEN
              door.object.miscellaneous := 0;
            ELSIF ((door.object.miscellaneous < 0) AND (MRandom.IntegerRandomRangeValue (1,creature.hitpoints + 1) * (door.object.miscellaneous - 50) < 40 * (VAL (INTEGER,creature.hitpoints) - 10 + door.object.miscellaneous))) THEN
              MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You hear a door burst open!");
              MSActs2.DisturbPlayer (player,TRUE);
              
              attempt := TRUE;
              stuck   := TRUE;
            END; (* IF *)
            
            done := TRUE;
          ELSIF door.object.class = OStruct.SecretDoor THEN
            attempt := TRUE;
            done    := TRUE;
          ELSE
            WDebugging.FatalAppExit ("Attempt to move through un-recognized door class.");
          END; (* IF *)
          
          IF attempt THEN
            OSActions.ReturnInventoryItemRecord (player^.treasures,OStruct.OpenDoorObjectCursor,door);
            
            IF stuck THEN
              door.object.miscellaneous := 1 - MRandom.IntegerRandomRangeValue (1,2);
            END; (* IF *)
            
            player^.dungeon^.physical [line]^ [column].elements := player^.dungeon^.physical [line]^ [column].elements - DStruct.DungeonElementSet {DStruct.NullWall..DStruct.BoundaryWall} + DStruct.DungeonElementSet {DStruct.CorridorFloor};
            attempt                                             := FALSE;
            
            MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
            INCL (movement,CStruct.MoveThroughDoor);
          END; (* IF *)
        END AttemptCreatureOpenDoor;
        
      BEGIN (* AttemptDoorMovement *)
        IF CStruct.MoveThroughDoor IN creaturePASSIVE.movement THEN
          AttemptCreatureOpenDoor (player,creatureACTIVE,line,column,door,movement,attempt,done);
        ELSE
          AttemptCreatureBashDoor (player,creatureACTIVE,line,column,door,done);
        END; (* IF *)
      END AttemptDoorMovement;
      
      PROCEDURE AttemptRuneOfProtectionMovement (player : MStruct.PlayerInfoPointer; creature : CStruct.PassiveCreatureInfoRecord; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR attempt,done : BOOLEAN);
      BEGIN (* AttemptRuneOfProtectionMovement *)
        IF MRandom.CardinalRandomRangeValue (1,3000) < creature.depth THEN
          IF ((line = player^.character^.line) AND (column = player^.character^.column)) THEN
            MMWindow.AddMessageToList (player,"The rune of protection is broken!");
          END; (* IF *)
          
          DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
        ELSE
          attempt := FALSE;
          done    := (done OR (CStruct.AttackOnly IN creature.movement));
        END; (* IF *)
      END AttemptRuneOfProtectionMovement;
      
    BEGIN (* AttemptCreatureMove *)
      location := player^.dungeon^.physical [line]^ [column];
      done     := FALSE;
      
      IF location.elements * DStruct.FreeSpaceElements <> DStruct.EmptyDungeonElementSet THEN
        attempt := TRUE;
      ELSIF CStruct.MoveThroughWall IN player^.creatures^.table [creature.cursor].movement THEN
        INCL (movement,CStruct.MoveThroughWall);
        attempt := TRUE;
      ELSIF ((location.artifact <> DStruct.InvalidArtifactCursor) AND (player^.dungeon^.artifacts [location.artifact].object.class IN OStruct.ObjectClassSet {OStruct.ClosedDoor,OStruct.SecretDoor})) THEN
        AttemptDoorMovement (player,creature,player^.creatures^.table [creature.cursor],line,column,player^.dungeon^.artifacts [location.artifact],movement,attempt,done);
        attempt := FALSE;
      ELSE
        attempt := FALSE;
      END; (* IF *)
      
      IF (attempt AND (location.artifact <> DStruct.InvalidArtifactCursor) AND ArtifactIsRuneOfProtection (player^.dungeon^.artifacts [location.artifact])) THEN
        AttemptRuneOfProtectionMovement (player,player^.creatures^.table [creature.cursor],line,column,attempt,done);
      END; (* IF *)
      
      IF attempt THEN
        IF ((line = player^.character^.line) AND (column = player^.character^.column)) THEN
          IF NOT (creature.visible) THEN
            MCreatures.UpdateCreatureDisplayInformation (player,creature,TRUE);
          END; (* IF *)
          
          MCAttack.ExecuteCreatureAttack (player,creature);
          
          attempt := FALSE;
          done    := TRUE;
        ELSIF ((location.creature <> DStruct.InvalidCreatureCursor) AND ((line <> creature.line) OR (column <> creature.column))) THEN
          AttackAnotherCreature (player,player^.creatures^.table [creature.cursor],creature.visible,line,column,movement,attempt);
        END; (* IF *)
      END; (* IF *)
      
      IF attempt THEN
        MoveCreatureToLocation (player,creature,line,column,movement);
        done := TRUE;
      END; (* IF *)
    END AttemptCreatureMove;
    
  BEGIN (* ExecuteCreatureMove *)
    index := 0;
    done  := FALSE;
    
    REPEAT
      DSActions.DetermineDungeonLocation (creature.line,creature.column,table [index],line,column);
      
      IF NOT (DStruct.BoundaryWall IN player^.dungeon^.physical [line]^ [column].elements) THEN
        AttemptCreatureMove (player,creature,line,column,movement,done);
      END; (* IF *)
      
      INC (index);
    UNTIL (done OR (index = NumberMovementDirections) OR (table [index] = InvalidCreatureDirection));
  END ExecuteCreatureMove;
  
  PROCEDURE MoveCreatureToLocation (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR movement : CStruct.CreatureMovementInformation);
    CONST
          MaxCreatureCarryObject = OStruct.PrayerBook;
    
  BEGIN (* MoveCreatureToLocation *)
    IF ((player^.dungeon^.physical [line]^ [column].artifact <> DStruct.InvalidArtifactCursor) AND (player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact].object.class <= MaxCreatureCarryObject) AND (CStruct.MoveThroughObject IN player^.creatures^.table [creature.cursor].movement)) THEN
      DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
      INCL (movement,CStruct.MoveThroughObject);
    END; (* IF *)
    
    IF ((creature.line <> line) OR (creature.column <> column)) THEN
      player^.dungeon^.physical [line]^ [column].creature                   := player^.dungeon^.physical [creature.line]^ [creature.column].creature;
      player^.dungeon^.physical [creature.line]^ [creature.column].creature := DStruct.InvalidCreatureCursor;
      
      IF creature.visible THEN
        MDPainting.InvalidateDungeonLocation (player,creature.line,creature.column,FALSE,TRUE);
        creature.visible := FALSE;
      END; (* IF *)
      
      creature.column := column;
      creature.line   := line;
      
      MCreatures.UpdateCreatureDisplayInformation (player,creature,TRUE);
    END; (* IF *)
  END MoveCreatureToLocation;
END MCMove2.
