IMPLEMENTATION MODULE MCMovement;
  (*/WIN:A*)
  
  IMPORT CSpells,MCMove2,MCreatures,MMWindow,MPAttk2,MRandom,MTunnel;
  IMPORT CStruct,DStruct,MCStruct,MStruct;
  IMPORT WDebugging;
  IMPORT DSActions;
  
  
  PROCEDURE DetermineNormalMovementTable (initialLINE : DStruct.DungeonLineRange; initialCOLUMN : DStruct.DungeonColumnRange; targetLINE : DStruct.DungeonLineRange; targetCOLUMN : DStruct.DungeonColumnRange; VAR result : MCMove2.MovementTable);
    VAR
        deltaX,deltaY : INTEGER;
        value         : CARDINAL;
    
    PROCEDURE AssignCreatureMovementTable (VAR table : MCMove2.MovementTable; dir1,dir2,dir3,dir4,dir5 : CARDINAL);
    BEGIN (* AssignCreatureMovementTable *)
      table [0] := dir1;
      table [1] := dir2;
      table [2] := dir3;
      table [3] := dir4;
      table [4] := dir5;
    END AssignCreatureMovementTable;
    
  BEGIN (* DetermineNormalMovementTable *)
    deltaX := initialCOLUMN - targetCOLUMN;
    deltaY := initialLINE - targetLINE;
    
    IF deltaY < 0 THEN
      value := 8;
    ELSE
      value := 0;
    END; (* IF *)
    
    IF deltaX > 0 THEN
      INC (value,4);
    END; (* IF *)
    
    IF ABS (deltaY) > 2 * ABS (deltaX) THEN
      INC (value,2);
    ELSIF ABS (deltaX) > 2 * ABS (deltaY) THEN
      INC (value);
    END; (* IF *)
    
    CASE value OF
      0 : IF ABS (deltaY) > ABS (deltaX) THEN
            AssignCreatureMovementTable (result,9,8,6,7,3);
          ELSE
            AssignCreatureMovementTable (result,9,6,8,3,7);
          END; (* IF *)                                     |
      
      4 : IF ABS (deltaY) > ABS (deltaX) THEN
            AssignCreatureMovementTable (result,7,8,4,9,1);
          ELSE
            AssignCreatureMovementTable (result,7,4,8,1,9);
          END; (* IF *)                                     |
      
      8 : IF ABS (deltaY) > ABS (deltaX) THEN
            AssignCreatureMovementTable (result,3,2,6,1,9);
          ELSE
            AssignCreatureMovementTable (result,3,6,2,9,1);
          END; (* IF *)                                     |
      
      12 : IF ABS (deltaY) > ABS (deltaX) THEN
             AssignCreatureMovementTable (result,1,2,4,3,7);
           ELSE
             AssignCreatureMovementTable (result,1,4,2,7,3);
           END; (* IF *)                                     |
      
      
      1,9 : IF deltaY < 0 THEN
              AssignCreatureMovementTable (result,6,3,9,2,8);
            ELSE
              AssignCreatureMovementTable (result,6,9,3,8,2);
            END; (* IF *)                                     |
      
      5,13 : IF deltaY < 0 THEN
               AssignCreatureMovementTable (result,4,1,7,2,8);
             ELSE
               AssignCreatureMovementTable (result,4,7,1,8,2);
             END; (* IF *)                                     |
      
      
      2,6 : IF deltaX < 0 THEN
              AssignCreatureMovementTable (result,8,9,7,6,4);
            ELSE
              AssignCreatureMovementTable (result,8,7,9,4,6);
            END; (* IF *)                                     |
      
      10,14 : IF deltaX < 0 THEN
                AssignCreatureMovementTable (result,2,3,1,6,4);
              ELSE
                AssignCreatureMovementTable (result,2,1,3,4,6);
              END; (* IF *)                                     |
    ELSE
      WDebugging.FatalAppExit ("Invalid creature movement table.");
    END; (* CASE *)
  END DetermineNormalMovementTable;
  
  PROCEDURE ExecuteCreatureMovement (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; VAR movement : CStruct.CreatureMovementInformation);
    VAR
        multiplied : BOOLEAN;
    
    PROCEDURE AttemptCreatureWallEscape (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; VAR movement : CStruct.CreatureMovementInformation);
      VAR
          directions : CARDINAL;
          table      : MCMove2.MovementTable;
      
      PROCEDURE DetermineWallEscapeMovementTable (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; VAR table : MCMove2.MovementTable; VAR number : CARDINAL);
        VAR
            direction : CARDINAL;
            column    : DStruct.DungeonColumnRange;
            line      : DStruct.DungeonLineRange;
        
        PROCEDURE ClearMovementTable (VAR table : MCMove2.MovementTable);
          VAR
              index : CARDINAL;
          
        BEGIN (* ClearMovementTable *)
          FOR index := 0 TO MCMove2.NumberMovementDirections - 1 DO
            table [index] := MCMove2.InvalidCreatureDirection;
          END; (* FOR *)
        END ClearMovementTable;
        
        PROCEDURE SwapMovementDirections (VAR direction1,direction2 : CARDINAL);
          VAR
              temp : CARDINAL;
          
        BEGIN (* SwapMovementDirections *)
          temp       := direction1;
          direction1 := direction2;
          direction2 := temp;
        END SwapMovementDirections;
        
      BEGIN (* DetermineWallEscapeMovementTable *)
        ClearMovementTable (table);
        
        direction := 1;
        number    := 0;
        
        FOR line := centerLINE - 1 TO centerLINE + 1 DO
          FOR column := centerCOLUMN - 1 TO centerCOLUMN + 1 DO
            IF ((direction <> 5) AND (line <> player^.character^.line) AND (column <> player^.character^.column) AND (dungeon.physical [line]^ [column].elements * DStruct.DungeonFloorElements <> DStruct.EmptyDungeonElementSet)) THEN
              table [number] := direction;
              number         := number + 1;
            END; (* IF *)
            
            INC (direction);
          END; (* FOR *)
        END; (* FOR *)
        
        IF number > 1 THEN
          SwapMovementDirections (table [0],table [MRandom.CardinalRandomRangeValue (0,number - 1)]);
        END; (* IF *)
      END DetermineWallEscapeMovementTable;
      
      PROCEDURE WallDamagedCreature (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
      BEGIN (* WallDamagedCreature *)
        MPAttk2.DamageCreature (creature,MRandom.CardinalRandomRangeValue (8,64));
        
        IF creature.hitpoints > 0 THEN
          MMWindow.AddMessageToList (player,"A creature digs itself out from the rock!");
          MTunnel.MeltWallAtLocation (player,creature.line,creature.column,player^.dungeon^.physical [creature.line]^ [creature.column],FALSE);
        ELSE
          MMWindow.AddMessageToList (player,"You hear a scream muffled by rock!");
          MPAttk2.KillCreatureAtLocation (player,creature.line,creature.column,player^.creatures^.table [creature.cursor],creature.visible,TRUE);
        END; (* IF *)
      END WallDamagedCreature;
      
    BEGIN (* AttemptCreatureWallEscape *)
      IF creature.hitpoints > 0 THEN
        DetermineWallEscapeMovementTable (player,player^.dungeon^,creature.line,creature.column,table,directions);
        
        IF directions > 0 THEN
          MCMove2.ExecuteCreatureMove (player,creature,table,movement);
        END; (* IF *)
        
        IF player^.dungeon^.physical [creature.line]^ [creature.column].elements * DStruct.DungeonWallElements <> DStruct.EmptyDungeonElementSet THEN
          WallDamagedCreature (player,creature);
        END; (* IF *)
      END; (* IF *)
    END AttemptCreatureWallEscape;
    
    PROCEDURE MakeConfusedCreatureMove (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; VAR movement : CStruct.CreatureMovementInformation);
      VAR
          table : MCMove2.MovementTable;
      
      PROCEDURE DetermineConfusedMovementTable (VAR table : MCMove2.MovementTable);
        VAR
            index : CARDINAL;
        
      BEGIN (* DetermineConfusedMovementTable *)
        FOR index := 0 TO MCMove2.NumberMovementDirections - 1 DO
          table [index] := MRandom.CardinalRandomRangeValue (1,9);
        END; (* FOR *)
      END DetermineConfusedMovementTable;
      
    BEGIN (* MakeConfusedCreatureMove *)
      IF NOT (CStruct.AttackOnly IN player^.creatures^.table [creature.cursor].movement) THEN
        DetermineConfusedMovementTable (table);
        
        MCMove2.ExecuteCreatureMove (player,creature,table,movement);
      END; (* IF *)
      
      creature.confused := (MRandom.CardinalRandomRangeValue (1,8) > 1);
    END MakeConfusedCreatureMove;
    
    PROCEDURE MakeStandardCreatureMove (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; VAR movement : CStruct.CreatureMovementInformation);
      PROCEDURE MakeNormalCreatureMove (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; VAR movement : CStruct.CreatureMovementInformation);
        VAR
            table : MCMove2.MovementTable;
        
      BEGIN (* MakeNormalCreatureMove *)
        DetermineNormalMovementTable (creature.line,creature.column,player^.character^.line,player^.character^.column,table);
        MCMove2.ExecuteCreatureMove (player,creature,table,movement);
      END MakeNormalCreatureMove;
      
      PROCEDURE MakeRandomCreatureMove (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; VAR movement : CStruct.CreatureMovementInformation);
        VAR
            table : MCMove2.MovementTable;
        
        PROCEDURE DetermineRandomMovementTable (VAR table : MCMove2.MovementTable);
          VAR
              index : CARDINAL;
          
        BEGIN (* DetermineRandomMovementTable *)
          FOR index := 0 TO MCMove2.NumberMovementDirections - 1 DO
            table [index] := MRandom.CardinalRandomRangeValue (1,9);
          END; (* FOR *)
        END DetermineRandomMovementTable;
        
      BEGIN (* MakeRandomCreatureMove *)
        DetermineRandomMovementTable (table);
        MCMove2.ExecuteCreatureMove (player,creature,table,movement);
      END MakeRandomCreatureMove;
      
      PROCEDURE UpdateMagicOnlyMemory (player : MStruct.PlayerInfoPointer; VAR creature : CStruct.PassiveCreatureInfoRecord);
      BEGIN (* UpdateMagicOnlyMemory *)
        IF creature.memory.attacks [0] < CStruct.MaxRememberedAttacks THEN
          INC (creature.memory.attacks [0]);
        END; (* IF *)
        
        IF creature.memory.attacks [0] > 20 THEN
          INCL (creature.memory.movement,CStruct.MagicOnly);
        END; (* IF *)
      END UpdateMagicOnlyMemory;
      
    BEGIN (* MakeStandardCreatureMove *)
      IF ((CStruct.MoveRandom75 IN player^.creatures^.table [creature.cursor].movement) AND (MRandom.CardinalRandomRangeValue (1,100) < 75)) THEN
        MakeRandomCreatureMove (player,creature,movement);
        INCL (movement,CStruct.MoveRandom75);
      ELSIF ((CStruct.MoveRandom40 IN player^.creatures^.table [creature.cursor].movement) AND (MRandom.CardinalRandomRangeValue (1,100) < 40)) THEN
        MakeRandomCreatureMove (player,creature,movement);
        INCL (movement,CStruct.MoveRandom40);
      ELSIF ((CStruct.MoveRandom20 IN player^.creatures^.table [creature.cursor].movement) AND (MRandom.CardinalRandomRangeValue (1,100) < 20)) THEN
        MakeRandomCreatureMove (player,creature,movement);
        INCL (movement,CStruct.MoveRandom20);
      ELSIF CStruct.MoveNormally IN player^.creatures^.table [creature.cursor].movement THEN
        IF MRandom.CardinalRandomRangeValue (1,200) = 1 THEN
          MakeRandomCreatureMove (player,creature,movement);
        ELSE
          MakeNormalCreatureMove (player,creature,movement);
        END; (* IF *)
        
        INCL (movement,CStruct.MoveNormally);
      ELSIF CStruct.AttackOnly IN player^.creatures^.table [creature.cursor].movement THEN
        IF creature.distance < 2 THEN
          MakeNormalCreatureMove (player,creature,movement);
        ELSE
          INCL (movement,CStruct.AttackOnly);
        END; (* IF *)
      ELSIF ((CStruct.MagicOnly IN player^.creatures^.table [creature.cursor].movement) AND (creature.distance < 2)) THEN
        UpdateMagicOnlyMemory (player,player^.creatures^.table [creature.cursor]);
      END; (* IF *)
    END MakeStandardCreatureMove;
    
    PROCEDURE NumberAdjacentCreatures (VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange) : CARDINAL;
      VAR
          number : CARDINAL;
          column : DStruct.DungeonColumnRange;
          line   : DStruct.DungeonLineRange;
      
    BEGIN (* NumberAdjacentCreatures *)
      number := 0;
      
      FOR line := centerLINE - 1 TO centerLINE + 1 DO
        FOR column := centerCOLUMN - 1 TO centerCOLUMN + 1 DO
          IF dungeon.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor THEN
            INC (number);
          END; (* IF *)
        END; (* FOR *)
      END; (* FOR *)
      
      RETURN (number);
    END NumberAdjacentCreatures;
    
    PROCEDURE ShouldEscapeFromWall (player : MStruct.PlayerInfoPointer; creature : DStruct.DungeonCreatureRecord) : BOOLEAN;
    BEGIN (* ShouldEscapeFromWall *)
      RETURN (NOT (CStruct.MoveThroughWall IN player^.creatures^.table [creature.cursor].movement) AND (player^.dungeon^.physical [creature.line]^ [creature.column].elements * DStruct.DungeonWallElements <> DStruct.EmptyDungeonElementSet));
    END ShouldEscapeFromWall;
    
    PROCEDURE ShouldMultiplyMonster (player : MStruct.PlayerInfoPointer; creature : CStruct.PassiveCreatureInfoRecord; number : CARDINAL) : BOOLEAN;
      CONST
            MonsterMultiplicationRate = 7;
      
    BEGIN (* ShouldMultiplyMonster *)
      IF NOT (CStruct.MultiplyMonster IN creature.movement) THEN
        RETURN (FALSE);
      ELSIF player^.dungeon^.multipliedCreatures > DStruct.MaxMultipliedCreatures THEN
        RETURN (FALSE);
      ELSIF player^.character^.variables.counters [MCStruct.RestCOUNT] MOD MonsterMultiplicationRate <> 0 THEN
        RETURN (FALSE);
      ELSIF number >= 4 THEN
        RETURN (FALSE);
      ELSE
        RETURN (MRandom.CardinalRandomRangeValue (1,number * MonsterMultiplicationRate) = 1);
      END; (* IF *)
    END ShouldMultiplyMonster;
    
  BEGIN (* ExecuteCreatureMovement *)
    IF ShouldMultiplyMonster (player,player^.creatures^.table [creature.cursor],NumberAdjacentCreatures (player^.dungeon^,creature.line,creature.column)) THEN
      MultiplyCreature (player,creature,movement,multiplied);
    END; (* IF *)
    
    IF ShouldEscapeFromWall (player,creature) THEN
      AttemptCreatureWallEscape (player,creature,movement);
    ELSIF creature.confused THEN
      MakeConfusedCreatureMove (player,creature,movement);
    ELSIF CSpells.CreatureShouldCastSpell (player,creature) THEN
      CSpells.CastCreatureSpell (player,creature);
    ELSE
      MakeStandardCreatureMove (player,creature,movement);
    END; (* IF *)
  END ExecuteCreatureMovement;

  PROCEDURE MultiplyCreature (player : MStruct.PlayerInfoPointer; creature : DStruct.DungeonCreatureRecord; VAR movement : CStruct.CreatureMovementInformation; VAR done : BOOLEAN);
    VAR
        position : CARDINAL;
        column   : DStruct.DungeonColumnRange;
        line     : DStruct.DungeonLineRange;
    
    PROCEDURE DetermineNewCreatureLocation (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; VAR resultLINE : DStruct.DungeonLineRange; VAR resultCOLUMN : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
      VAR
          attempts : CARDINAL;
      
      PROCEDURE ValidMultipliedCreatureLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; location : DStruct.PhysicalDungeonUnit) : BOOLEAN;
      BEGIN (* ValidMultipliedCreatureLocation *)
        IF ((player^.character^.line <> line) OR (player^.character^.column <> column)) THEN
          RETURN ((location.creature = DStruct.InvalidCreatureCursor) AND (location.elements * (DStruct.DungeonWallElements + DStruct.DungeonElementSet {DStruct.BlockedFloor}) = DStruct.EmptyDungeonElementSet));
        ELSE
          RETURN (FALSE);
        END; (* IF *)
      END ValidMultipliedCreatureLocation;
      
    BEGIN (* DetermineNewCreatureLocation *)
      attempts := 0;
      
      REPEAT
        resultCOLUMN := centerCOLUMN - 2 + MRandom.IntegerRandomRangeValue (1,3);
        resultLINE   := centerLINE - 2 + MRandom.IntegerRandomRangeValue (1,3);
        
        attempts := attempts + 1;
        done     := ValidMultipliedCreatureLocation (player,resultLINE,resultCOLUMN,player^.dungeon^.physical [resultLINE]^ [resultCOLUMN]);
      UNTIL (done OR (attempts = 18));
    END DetermineNewCreatureLocation;
    
    PROCEDURE PlaceCreatureAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; cursor : CARDINAL; VAR position : CARDINAL; VAR done : BOOLEAN);
      VAR
          creature : DStruct.DungeonCreatureRecord;
      
    BEGIN (* PlaceCreatureAtLocation *)
      MCreatures.DetermineCreatureInformation (player^.creatures,cursor,FALSE,player^.character^.variables.speed,creature);
      DSActions.PlaceCreatureAtLocation (player,player^.dungeon^,line,column,creature,position,done);
    END PlaceCreatureAtLocation;
    
  BEGIN (* MultiplyCreature *)
    DetermineNewCreatureLocation (player,player^.dungeon^,creature.line,creature.column,line,column,done);
    
    IF NOT (done) THEN
      RETURN;
    END; (* IF *)
    
    PlaceCreatureAtLocation (player,line,column,creature.cursor,position,done);
    
    IF NOT (done) THEN
      RETURN;
    END; (* IF *)
    
    MCreatures.UpdateCreatureDisplayInformation (player,player^.dungeon^.creatures [position],TRUE);
    
    IF player^.dungeon^.creatures [position].visible THEN
      INCL (movement,CStruct.MultiplyMonster);
    END; (* IF *)
    
    INC (player^.dungeon^.multipliedCreatures);
  END MultiplyCreature;
END MCMovement.
