IMPLEMENTATION MODULE MCommands;
  (*/WIN:A*)
  
  IMPORT MCSpells,MDColors,MDistMove,MDPainting,MFiles,MFoods,MHelp,MHSDialog,MLook,MMouse,MOptions,MPBash,MPBooks,MPComm1,MPComm2,MPInventory,MPInven3,MPMovement,MPotions,MPrayers,MPRest,MPSearch,MPThrow,MSColors,MScribe,MScrolls,MStaff,MTunnel,MWands,MWizard,MWizard2;
  IMPORT MDWindow,MMTranslator,MMWindow;
  IMPORT MStruct;
  
  
  TYPE
       MoriaCommandProcedure = PROCEDURE (MStruct.PlayerInfoPointer);
  
  VAR
      CommandActionTable : ARRAY MoriaCommandMnemonic OF MoriaCommandProcedure;
  
  
  PROCEDURE ConvertMenuItemToCommandMnemonic (player : MStruct.PlayerInfoPointer; control : CARDINAL; VAR result : MoriaCommandMnemonic; VAR done : BOOLEAN);
  BEGIN (* ConvertMenuItemToCommandMnemonic *)
    done := TRUE;
    
    CASE control OF
      100 : result := OpenCharacterCommand;   |
      110 : result := NewCharacterCommand;    |
      120 : result := SaveCharacterCommand;   |
      130 : result := SaveCharacterAsCommand; |
      140 : result := MenuExitCommand;        |
      
      200 : result := UseWand;           |
      210 : result := QuaffPotion;       |
      220 : result := ReadScroll;        |
      230 : result := UseStaff;          |
      240 : result := ThrowObject;       |
      250 : result := DropObject;        |
      260 : result := ExchangeWeapons;   |
      270 : result := InventoryCommands; |
      
      300 : result := DescendStairs;     |
      310 : result := AscendStairs;      |
      320 : result := RestOneTurn;       |
      330 : result := RestMultipleTurns; |
      340 : result := Tunnel;            |
      350 : result := Bash;              |
      360 : result := MoveAtRun;         |
      
      400 : result := CloseObject;          |
      410 : result := DisarmTrap;           |
      420 : result := SpikeDoor;            |
      430 : result := OpenObject;           |
      440 : result := FillLamp;             |
      450 : result := Eat;                  |
      460 : result := SearchToggle;         |
      470 : result := BrowseBook;           |
      480 : result := CharacterInformation; |
      490 : result := InscribeObject;       |
      500 : result := Options;              |
      510 : result := ViewScores;           |
      
      520 : result := MenuDefineMouse;      |
      530 : result := DungeonColorsCommand; |
      540 : result := MenuRedrawDungeon;    |
      550 : result := MenuStatusColors;     |
      560 : result := StartMaximizedToggle; |
      
      600 : result := ReadHolyPrayer; |
      700 : result := CastMagicSpell; |
      
      1000 : result := HelpContents; |
      1010 : result := HelpHowToUse; |
      1020 : result := HelpHistory;  |
      1030 : result := HelpAbout;    |
      
      1100 : result := WizardExperience;      |
      1110 : result := WizardChangeCharacter; |
      1120 : result := WizardDepthChange;     |
      1130 : result := WizardCureAll;         |
      1140 : result := WizardTeleport;        |
      1150 : result := WizardIdentify;        |
      1160 : result := WizardCreateObject;    |
      1170 : result := WizardSummon;          |
      1180 : result := WizardGenocide;        |
      1190 : result := WizardLight;           |
      1200 : result := WizardMap;             |
    ELSE
      done := FALSE;
    END; (* CASE *)
  END ConvertMenuItemToCommandMnemonic;
  
  PROCEDURE ConvertToCommandMnemonic (player : MStruct.PlayerInfoPointer; value : CARDINAL; VAR result : MoriaCommandMnemonic; VAR done : BOOLEAN);
    CONST
          ControlA = CHR (1);
          ControlD = CHR (4);
          ControlE = CHR (5);
          ControlF = CHR (6);
          ControlG = CHR (7);
          ControlI = CHR (9);
          ControlJ = CHR (10);
          ControlK = CHR (11);
          ControlL = CHR (12);
          ControlT = CHR (20);
          ControlW = CHR (23);
          ControlX = CHR (24);
    
  BEGIN (* ConvertToCommandMnemonic *)
    done := TRUE;
    
    CASE CHR (value) OF
      ControlA : result := WizardCureAll;            |
      ControlD : result := WizardDepthChange;        |
      ControlE : result := WizardChangeCharacter;    |
      ControlF : result := WizardGenocide;           |
      ControlG : result := WizardTreasure;           |
      ControlI : result := WizardIdentify;           |
      ControlJ : result := WizardExperience;         |
      ControlK : result := Quit;                     |
      ControlL : result := WizardLight;              |
      ControlT : result := WizardTeleport;           |
      ControlW : result := WizardMode;               |
      ControlX : result := Exit;                     |
      '@'      : result := WizardCreateObject;       |
      ':'      : result := WizardMap;                |
      '&'      : result := WizardSummon;             |
      
      'C' : result := CharacterInformation; |
      '>' : result := DescendStairs;        |
      '<' : result := AscendStairs;         |
      '5' : result := RestOneTurn;          |
      '{' : result := InscribeObject;       |
      '=' : result := Options;              |
      '?' : result := HelpContents;         |
      'B' : result := Bash;                 |
      'D' : result := DisarmTrap;           |
      'E' : result := Eat;                  |
      'F' : result := FillLamp;             |
      'G' : result := LearnSpells;          |
      'V' : result := ViewScores;           |
      'R' : result := RestMultipleTurns;    |
      'S' : result := SearchToggle;         |
      '.' : result := MoveAtRun;            |
      'T' : result := Tunnel;               |
      'a' : result := UseWand;              |
      'b' : result := BrowseBook;           |
      'c' : result := CloseObject;          |
      'd' : result := DropObject;           |
      'f' : result := ThrowObject;          |
      'i' : result := InventoryCommands;    |
      'j' : result := SpikeDoor;            |
      'l' : result := Look;                 |
      'm' : result := CastMagicSpell;       |
      'o' : result := OpenObject;           |
      'p' : result := ReadHolyPrayer;       |
      'q' : result := QuaffPotion;          |
      'r' : result := ReadScroll;           |
      's' : result := SearchLocation;       |
      'u' : result := UseStaff;             |
      'x' : result := ExchangeWeapons;      |
      
      '1' : result := WalkSouthWest; |
      '2' : result := WalkSouth;     |
      '3' : result := WalkSouthEast; |
      '4' : result := WalkWest;      |
      '6' : result := WalkEast;      |
      '7' : result := WalkNorthWest; |
      '8' : result := WalkNorth;     |
      '9' : result := WalkNorthEast; |
    ELSE
      done := FALSE;
    END; (* CASE *)
  END ConvertToCommandMnemonic;
  
  PROCEDURE ExecuteCharacterCommand (player : MStruct.PlayerInfoPointer; command : MoriaCommandMnemonic);
  BEGIN (* ExecuteCharacterCommand *)
    MStruct.CharacterTurnExecuted := TRUE;
    CommandActionTable [command] (player);
  END ExecuteCharacterCommand;
  
  PROCEDURE ExecuteBashCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteBashCommand *)
    MMTranslator.ExecuteDirectedCommand (player,"Bash in which direction? ",MPBash.ExecuteBashAction);
  END ExecuteBashCommand;
  
  PROCEDURE ExecuteCloseObjectCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteCloseObjectCommand *)
    MMTranslator.ExecuteDirectedCommand (player,"Close in which direction?",MPComm1.ExecuteCloseAction);
  END ExecuteCloseObjectCommand;
  
  PROCEDURE ExecuteDisarmTrapCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteDisarmTrapCommand *)
    MMTranslator.ExecuteDirectedCommand (player,"Disarm in which direction?",MPComm1.ExecuteDisarmAction);
  END ExecuteDisarmTrapCommand;
  
  PROCEDURE ExecuteHelpCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteHelpCommand *)
    MMWindow.DisplayPopupMessage (MStruct.CurrentPlayerFrameWindow,player,"Help not yet implemented.");
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteHelpCommand;
  
  PROCEDURE ExecuteMoveAtRunCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteMoveAtRunCommand *)
    MMTranslator.ExecuteDirectedCommand (player,"Run in which direction?",MDistMove.InitializeDistanceMovement);
  END ExecuteMoveAtRunCommand;
  
  PROCEDURE ExecuteMoveToLocationCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteMoveToLocationCommand *)
    MMTranslator.ExecuteTargetedCommand (player,"Move to which location?",MDistMove.InitializeLocatedDistanceMovement);
  END ExecuteMoveToLocationCommand;
  
  PROCEDURE ExecuteNewCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteNewCommand *)
    MFiles.ExecuteNewCommand (MStruct.CurrentPlayerFrameWindow,MStruct.CurrentPlayerInformation);
  END ExecuteNewCommand;
  
  PROCEDURE ExecuteNoOperationCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteNoOperationCommand *)
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteNoOperationCommand;
  
  PROCEDURE ExecuteOpenCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteOpenCommand *)
    MFiles.ExecuteOpenCommand (MStruct.CurrentPlayerFrameWindow,MStruct.CurrentPlayerInformation);
  END ExecuteOpenCommand;
  
  PROCEDURE ExecuteOpenObjectCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteOpenObjectCommand *)
    MMTranslator.ExecuteDirectedCommand (player,"Open in which direction?",MPComm1.ExecuteOpenAction);
  END ExecuteOpenObjectCommand;
  
  PROCEDURE ExecuteRedrawDungeonCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteRedrawDungeonCommand *)
    MDPainting.InvalidateDungeonWindow (player);
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteRedrawDungeonCommand;
  
  PROCEDURE ExecuteTunnelCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteTunnelCommand *)
    MMTranslator.ExecuteDirectedCommand (player,"Tunnel in which direction?",MTunnel.ExecuteTunnelAction);
  END ExecuteTunnelCommand;
  
  PROCEDURE ExecuteViewScoresCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteViewScoresCommand *)
    MHSDialog.ExecuteHighScoresDialog (player^.windows.frame);
  END ExecuteViewScoresCommand;
  
  PROCEDURE InitializeCommandActionTable;
    PROCEDURE ClearCommandActionTable (VAR table : ARRAY OF MoriaCommandProcedure);
      VAR
          index : CARDINAL;
      
    BEGIN (* ClearCommandActionTable *)
      FOR index := 0 TO HIGH (table) DO
        table [index] := UndefinedMoriaCommand;
      END; (* FOR *)
    END ClearCommandActionTable;
    
  BEGIN (* InitializeCommandActionTable *)
    ClearCommandActionTable (CommandActionTable);
    
    CommandActionTable [DungeonColorsCommand]   := MDColors.ExecuteDungeonColorsCommand;
    CommandActionTable [MenuExitCommand]        := MFiles.ExecuteExitCommand;
    CommandActionTable [MenuDefineMouse]        := MMouse.ExecuteDefineMouseCommand;
    CommandActionTable [MenuRedrawDungeon]      := ExecuteRedrawDungeonCommand;
    CommandActionTable [OpenCharacterCommand]   := ExecuteOpenCommand;
    CommandActionTable [NewCharacterCommand]    := ExecuteNewCommand;
    CommandActionTable [SaveCharacterAsCommand] := MFiles.ExecuteSaveAsCommand;
    CommandActionTable [SaveCharacterCommand]   := MFiles.ExecuteSaveCommand;
    CommandActionTable [MenuStatusColors]       := MSColors.ExecuteStatusColorsCommand;
    CommandActionTable [StartMaximizedToggle]   := MPComm2.ExecuteStartMaximizedToggle;
    
    CommandActionTable [AscendStairs]         := MPComm1.AscendStairs;
    CommandActionTable [Bash]                 := ExecuteBashCommand;
    CommandActionTable [BrowseBook]           := MPBooks.ExecuteBrowseBookCommand;
    CommandActionTable [CastMagicSpell]       := MCSpells.ExecuteCastMagicSpellCommand;
    CommandActionTable [CharacterInformation] := MPComm2.ExecuteCharacterInformationCommand;
    CommandActionTable [CloseObject]          := ExecuteCloseObjectCommand;
    CommandActionTable [DescendStairs]        := MPComm1.ExecuteDescendStairsCommand;
    CommandActionTable [DisarmTrap]           := ExecuteDisarmTrapCommand;
    CommandActionTable [DropObject]           := MPInven3.ExecuteDropObjectCommand;
    CommandActionTable [Eat]                  := MFoods.ExecuteEatCommand;
    CommandActionTable [ExchangeWeapons]      := MPComm2.ExecuteExchangeWeaponsCommand;
    CommandActionTable [Exit]                 := MFiles.ExecuteExitCommand;
    CommandActionTable [FillLamp]             := MPComm1.ExecuteFillLampCommand;
    CommandActionTable [InscribeObject]       := MScribe.ExecuteInscribeObjectCommand;
    CommandActionTable [LearnSpells]          := MPBooks.ExecuteLearnSpellsCommand;
    CommandActionTable [Look]                 := MLook.ExecuteLookCommand;
    CommandActionTable [MoveAtRun]            := ExecuteMoveAtRunCommand;
    CommandActionTable [MoveToLocation]       := ExecuteMoveToLocationCommand;
    CommandActionTable [NoOperation]          := ExecuteNoOperationCommand;
    CommandActionTable [OpenObject]           := ExecuteOpenObjectCommand;
    CommandActionTable [QuaffPotion]          := MPotions.ExecuteQuaffPotionCommand;
    CommandActionTable [ReadHolyPrayer]       := MPrayers.ExecuteReadHolyPrayerCommand;
    CommandActionTable [ReadScroll]           := MScrolls.ExecuteReadScrollCommand;
    CommandActionTable [RestMultipleTurns]    := MPRest.ExecuteRestMultipleTurnsCommand;
    CommandActionTable [RestOneTurn]          := MPMovement.ExecuteStandStillCommand;
    CommandActionTable [SearchLocation]       := MPSearch.SearchCurrentLocation;
    CommandActionTable [SearchToggle]         := MPSearch.ExecuteSearchToggleCommand;
    CommandActionTable [SpikeDoor]            := MPComm2.ExecuteSpikeDoorCommand;
    CommandActionTable [ThrowObject]          := MPThrow.ExecuteThrowObjectCommand;
    CommandActionTable [Tunnel]               := ExecuteTunnelCommand;
    CommandActionTable [UseStaff]             := MStaff.ExecuteUseStaffCommand;
    CommandActionTable [UseWand]              := MWands.ExecuteUseWandCommand;
    CommandActionTable [Options]              := MOptions.ExecuteOptionsCommand;
    CommandActionTable [Quit]                 := MFiles.ExecuteQuitCommand;
    CommandActionTable [ViewScores]           := ExecuteViewScoresCommand;
    
    CommandActionTable [WalkNorthEast] := MPMovement.WalkNorthEast;
    CommandActionTable [WalkNorthWest] := MPMovement.WalkNorthWest;
    CommandActionTable [WalkSouthEast] := MPMovement.WalkSouthEast;
    CommandActionTable [WalkSouthWest] := MPMovement.WalkSouthWest;
    CommandActionTable [WalkNorth]     := MPMovement.WalkNorth;
    CommandActionTable [WalkSouth]     := MPMovement.WalkSouth;
    CommandActionTable [WalkEast]      := MPMovement.WalkEast;
    CommandActionTable [WalkWest]      := MPMovement.WalkWest;
    
    CommandActionTable [InventoryCommands] := MPInventory.ExecuteInventoryCommands;
    CommandActionTable [AscendStairs]      := MPComm1.AscendStairs;
    
    CommandActionTable [WizardChangeCharacter] := MWizard.WizardChangeCharacter;
    CommandActionTable [WizardCreateObject]    := MWizard.ExecuteWizardCreateObjectCommand;
    CommandActionTable [WizardDepthChange]     := MWizard.WizardDepthChange;
    CommandActionTable [WizardExperience]      := MWizard2.ExecuteWizardExperienceCommand;
    CommandActionTable [WizardGenocide]        := MWizard2.ExecuteWizardGenocideCommand;
    CommandActionTable [WizardIdentify]        := MWizard2.ExecuteWizardIdentifyCommand;
    CommandActionTable [WizardTeleport]        := MWizard2.ExecuteWizardTeleportCommand;
    CommandActionTable [WizardTreasure]        := MWizard2.ExecuteWizardTreasureCommand;
    CommandActionTable [WizardCureAll]         := MWizard2.ExecuteWizardCureAllCommand;
    CommandActionTable [WizardSummon]          := MWizard.ExecuteWizardSummonCommand;
    CommandActionTable [WizardLight]           := MWizard2.WizardDungeonLight;
    CommandActionTable [WizardMode]            := MWizard.ToggleWizardMode;
    CommandActionTable [WizardMap]             := MWizard2.ExecuteWizardMapCommand;
    
    CommandActionTable [HelpContents] := MHelp.ExecuteHelpContents;
    CommandActionTable [HelpHowToUse] := MHelp.ExecuteHelpHowToUseHelp;
    CommandActionTable [HelpHistory]  := MHelp.ExecuteHelpHistory;
    CommandActionTable [HelpAbout]    := MHelp.ExecuteHelpAboutMoria;
  END InitializeCommandActionTable;
  
  PROCEDURE UndefinedMoriaCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* UndefinedMoriaCommand *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Undefined procedure for command character.");
    MStruct.CharacterTurnExecuted := FALSE;
  END UndefinedMoriaCommand;

BEGIN (* MCommands *)
  InitializeCommandActionTable;
END MCommands.
