IMPLEMENTATION MODULE MCParser;
  (*/WIN:A*)
  
  IMPORT Windows,WResource;
  IMPORT MCStruct,MParser;
  
  
  PROCEDURE LoadBackgroundInfoRecord (instance : Windows.HINSTANCE; cursor : CARDINAL; VAR result : MCStruct.BackgroundInfoRecord);
    VAR
        length : CARDINAL;
        str    : ARRAY [0..255] OF CHAR;
    
  BEGIN (* LoadBackgroundInfoRecord *)
    WResource.LoadString (instance,cursor,str,length);
    
    WITH result DO
      MParser.ParseLiteralString (str,MParser.StandardItemTerminator,text);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,roll);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,cursor);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,next);
      MParser.ParseIntegerValue (str,MParser.FinalItemTerminator,bonus);
    END; (* WITH *)
  END LoadBackgroundInfoRecord;
  
  PROCEDURE LoadClassAttributeRecord (instance : Windows.HINSTANCE; cursor : CARDINAL; VAR result : MCStruct.ClassAttributeRecord);
    VAR
        length : CARDINAL;
        str    : ARRAY [0..127] OF CHAR;
    
  BEGIN (* LoadClassAttributeRecord *)
    WResource.LoadString (instance,cursor,str,length);
    
    WITH result DO
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,hitdie);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,disarm);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,search);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,stealth);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,perception);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,martial);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,missile);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,save);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,statMODIFIERS [MCStruct.str]);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,statMODIFIERS [MCStruct.int]);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,statMODIFIERS [MCStruct.wis]);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,statMODIFIERS [MCStruct.dex]);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,statMODIFIERS [MCStruct.con]);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,statMODIFIERS [MCStruct.chr]);
      MParser.ParseLongCardValue (str,MParser.StandardItemTerminator,experience);
      MParser.ParseCardinalValue (str,MParser.FinalItemTerminator,spell);
    END; (* WITH *)
  END LoadClassAttributeRecord;
  
  PROCEDURE LoadRacialAttributeRecord (instance : Windows.HINSTANCE; cursor : CARDINAL; VAR result : MCStruct.RacialAttributeRecord);
    VAR
        length : CARDINAL;
        str    : ARRAY [0..127] OF CHAR;
    
  BEGIN (* LoadRacialAttributeRecord *)
    WResource.LoadString (instance,cursor,str,length);
    
    WITH result DO
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,statMODIFIERS [MCStruct.str]);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,statMODIFIERS [MCStruct.int]);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,statMODIFIERS [MCStruct.wis]);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,statMODIFIERS [MCStruct.dex]);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,statMODIFIERS [MCStruct.con]);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,statMODIFIERS [MCStruct.chr]);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,ageBASE);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,ageRANGE);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,heightBASE [MCStruct.Male]);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,heightRANGE [MCStruct.Male]);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,weightBASE [MCStruct.Male]);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,weightRANGE [MCStruct.Male]);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,heightBASE [MCStruct.Female]);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,heightRANGE [MCStruct.Female]);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,weightBASE [MCStruct.Female]);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,weightRANGE [MCStruct.Female]);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,disarm);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,search);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,stealth);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,perception);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,martial);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,missile);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,save);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,hitdie);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,infra);
      MParser.ParseCardinalValue (str,MParser.FinalItemTerminator,experience);
    END; (* WITH *)
  END LoadRacialAttributeRecord;
  
  PROCEDURE LoadSpellInfoRecord (instance : Windows.HINSTANCE; cursor : CARDINAL; VAR result : MCStruct.PlayerSpellInfoRecord);
    VAR
        length : CARDINAL;
        str    : ARRAY [0..127] OF CHAR;
    
  BEGIN (* LoadSpellInfoRecord *)
    WResource.LoadString (instance,cursor,str,length);
    
    WITH result DO
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,level);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,mana);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,difficulty);
      MParser.ParseCardinalValue (str,MParser.FinalItemTerminator,experience);
    END; (* WITH *)
  END LoadSpellInfoRecord;
  
END MCParser.
