IMPLEMENTATION MODULE MCSpell2;
  (*/WIN:A*)
  
  IMPORT MCSpells,MCSpell3,MCSpell4,MGenocide,MRandom,MScrl2,MScrl3,MSpells,MSpells2,MSpells3;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT WDebugging;
  
  
  PROCEDURE ExecuteCreateFoodSpell (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteCreateFoodSpell *)
    MScrl2.ExecuteCreateFoodScrollAction (player,done);
    
    IF done THEN
      MCSpells.DecreasePlayerMana (player,16,TRUE);
    END; (* IF *)
  END ExecuteCreateFoodSpell;
  
  PROCEDURE ExecuteCureLightWoundsSpell (player : MStruct.PlayerInfoPointer);
    VAR
        noticed : BOOLEAN;
    
  BEGIN (* ExecuteCureLightWoundsSpell *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (4,16),noticed);
    MCSpells.DecreasePlayerMana (player,4,TRUE);
  END ExecuteCureLightWoundsSpell;
  
  PROCEDURE ExecuteCurePoisonSpell (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteCurePoisonSpell *)
    MSpells2.CurePoison (player,done);
    MCSpells.DecreasePlayerMana (player,11,TRUE);
  END ExecuteCurePoisonSpell;
  
  PROCEDURE ExecuteDetectMonstersSpell (player : MStruct.PlayerInfoPointer);
    VAR
        detected : BOOLEAN;
    
  BEGIN (* ExecuteDetectMonstersSpell *)
    MSpells.DetectMonsters (player,detected);
    MCSpells.DecreasePlayerMana (player,1,TRUE);
  END ExecuteDetectMonstersSpell;
  
  PROCEDURE ExecuteFindHiddenTrapsDoorsSpell (player : MStruct.PlayerInfoPointer);
    VAR
        detected : BOOLEAN;
    
  BEGIN (* ExecuteFindHiddenTrapsDoorsSpell *)
    MSpells.DetectHiddenDoors (player,detected,TRUE);
    MSpells.DetectHiddenTraps (player,detected,FALSE);
    
    MCSpells.DecreasePlayerMana (player,5,TRUE);
  END ExecuteFindHiddenTrapsDoorsSpell;
  
  PROCEDURE ExecuteGenocideSpell (player : MStruct.PlayerInfoPointer);
    VAR
        symbol : CHAR;
        done   : BOOLEAN;
    
  BEGIN (* ExecuteGenocideSpell *)
    MGenocide.ExecuteGenocideSelectDialog (player,symbol,done);
    
    IF done THEN
      MSpells3.ExterminateCreatureClass (player,symbol);
      MCSpells.DecreasePlayerMana (player,30,TRUE);
    END; (* IF *)
  END ExecuteGenocideSpell;
  
  PROCEDURE ExecuteHasteSelfSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteHasteSelfSpell *)
    INC (player^.character^.variables.counters [MCStruct.FastCOUNT],player^.character^.variables.level + MRandom.IntegerRandomRangeValue (1,20));
    INCL (player^.character^.variables.status,MCStruct.FastFLAG);
    
    MCSpells.DecreasePlayerMana (player,27,TRUE);
  END ExecuteHasteSelfSpell;
  
  PROCEDURE ExecuteIdentifySpell (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteIdentifySpell *)
    MScrl2.ExecuteIdentifyScrollAction (player,done);
    
    IF done THEN
      MCSpells.DecreasePlayerMana (player,20,TRUE);
    END; (* IF *)
  END ExecuteIdentifySpell;
  
  PROCEDURE ExecuteLightAreaSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteLightAreaSpell *)
    MScrl3.ExecuteLightAreaScrollAction (player);
    MCSpells.DecreasePlayerMana (player,3,TRUE);
  END ExecuteLightAreaSpell;
  
  PROCEDURE ExecutePhaseDoorSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecutePhaseDoorSpell *)
    MScrl2.ExecuteTeleportScrollAction (player,10);
    MCSpells.DecreasePlayerMana (player,2,TRUE);
  END ExecutePhaseDoorSpell;
  
  PROCEDURE ExecuteRechargeItem1Spell (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRechargeItem1Spell *)
    MScrl2.ExecuteRechargeScrollAction (player,20,done);
    
    IF done THEN
      MCSpells.DecreasePlayerMana (player,17,TRUE);
    END; (* IF *)
  END ExecuteRechargeItem1Spell;
  
  PROCEDURE ExecuteRechargeItem2Spell (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRechargeItem2Spell *)
    MScrl2.ExecuteRechargeScrollAction (player,60,done);
    
    IF done THEN
      MCSpells.DecreasePlayerMana (player,25,TRUE);
    END; (* IF *)
  END ExecuteRechargeItem2Spell;
  
  PROCEDURE ExecuteRemoveCurseSpell (player : MStruct.PlayerInfoPointer);
    VAR
        position : MCStruct.PlayerEquipmentMnemonic;
    
  BEGIN (* ExecuteRemoveCurseSpell *)
    FOR position := MIN (MCStruct.PlayerEquipmentMnemonic) TO MAX (MCStruct.PlayerEquipmentMnemonic) DO
      EXCL (player^.character^.inventory.equipment [position].object.attributes,OStruct.Cursed);
    END; (* FOR *)
    
    MCSpells.DecreasePlayerMana (player,13,TRUE);
  END ExecuteRemoveCurseSpell;
  
  PROCEDURE ExecuteSleep2Spell (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteSleep2Spell *)
    MSpells.SleepAdjacentCreatures (player,done);
    MCSpells.DecreasePlayerMana (player,18,TRUE);
  END ExecuteSleep2Spell;
  
  PROCEDURE ExecuteSleep3Spell (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteSleep3Spell *)
    MSpells.SleepAllVisibleCreatures (player,done);
    MCSpells.DecreasePlayerMana (player,21,TRUE);
  END ExecuteSleep3Spell;
  
  PROCEDURE ExecuteTeleportSelfSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteTeleportSelfSpell *)
    MScrl2.ExecuteTeleportScrollAction (player,5 * player^.character^.variables.level);
    MCSpells.DecreasePlayerMana (player,12,TRUE);
  END ExecuteTeleportSelfSpell;
  
  PROCEDURE ExecuteTrapDoorDestructionSpell (player : MStruct.PlayerInfoPointer);
    VAR
        identified : BOOLEAN;
    
  BEGIN (* ExecuteTrapDoorDestructionSpell *)
    MScrl3.ExecuteTrapDoorDestructionAction (player,identified);
    MCSpells.DecreasePlayerMana (player,9,TRUE);
  END ExecuteTrapDoorDestructionSpell;
  
  PROCEDURE ExecuteWordOfDestructionSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteWordOfDestructionSpell *)
    MSpells3.ExecuteDestructionAction (player,player^.character^.line,player^.character^.column);
    MCSpells.DecreasePlayerMana (player,29,TRUE);
  END ExecuteWordOfDestructionSpell;
  
  PROCEDURE ExecuteInvalidMagicSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteInvalidMagicSpell *)
    WDebugging.FatalAppExit ("Attempt to execute un-initialized Magic Spell.");
  END ExecuteInvalidMagicSpell;
  
  PROCEDURE InitializeExecuteMagicSpellTable;
    VAR
        index : MCStruct.PlayerSpellRange;
    
  BEGIN (* InitializeExecuteMagicSpellTable *)
    FOR index := MIN (MCStruct.PlayerSpellRange) TO MAX (MCStruct.PlayerSpellRange) DO
      ExecuteMagicSpell [index] := ExecuteInvalidMagicSpell;
    END; (* IF *)
    
    ExecuteMagicSpell [ 0] := MCSpell3.ExecuteMagicMissileSpell;
    ExecuteMagicSpell [ 1] := ExecuteDetectMonstersSpell;
    ExecuteMagicSpell [ 2] := ExecutePhaseDoorSpell;
    ExecuteMagicSpell [ 3] := ExecuteLightAreaSpell;
    ExecuteMagicSpell [ 4] := ExecuteCureLightWoundsSpell;
    ExecuteMagicSpell [ 5] := ExecuteFindHiddenTrapsDoorsSpell;
    ExecuteMagicSpell [ 6] := MCSpell4.ExecuteStinkingCloudSpell;
    ExecuteMagicSpell [ 7] := MCSpell3.ExecuteConfusionSpell;
    ExecuteMagicSpell [ 8] := MCSpell3.ExecuteLightningBoltSpell;
    ExecuteMagicSpell [ 9] := ExecuteTrapDoorDestructionSpell;
    ExecuteMagicSpell [10] := MCSpell3.ExecuteSleep1Spell;
    ExecuteMagicSpell [11] := ExecuteCurePoisonSpell;
    ExecuteMagicSpell [12] := ExecuteTeleportSelfSpell;
    ExecuteMagicSpell [13] := ExecuteRemoveCurseSpell;
    ExecuteMagicSpell [14] := MCSpell3.ExecuteFrostBoltSpell;
    ExecuteMagicSpell [15] := MCSpell3.ExecuteTurnStoneToMudSpell;
    ExecuteMagicSpell [16] := ExecuteCreateFoodSpell;
    ExecuteMagicSpell [17] := ExecuteRechargeItem1Spell;
    ExecuteMagicSpell [18] := ExecuteSleep2Spell;
    ExecuteMagicSpell [19] := MCSpell3.ExecutePolymorphOtherSpell;
    ExecuteMagicSpell [20] := ExecuteIdentifySpell;
    ExecuteMagicSpell [21] := ExecuteSleep3Spell;
    ExecuteMagicSpell [22] := MCSpell3.ExecuteFireBoltSpell;
    ExecuteMagicSpell [23] := MCSpell3.ExecuteSlowMonsterSpell;
    ExecuteMagicSpell [24] := MCSpell4.ExecuteFrostBallSpell;
    ExecuteMagicSpell [25] := ExecuteRechargeItem2Spell;
    ExecuteMagicSpell [26] := MCSpell3.ExecuteTeleportOtherSpell;
    ExecuteMagicSpell [27] := ExecuteHasteSelfSpell;
    ExecuteMagicSpell [28] := MCSpell4.ExecuteFireBallSpell;
    ExecuteMagicSpell [29] := ExecuteWordOfDestructionSpell;
    ExecuteMagicSpell [30] := ExecuteGenocideSpell;
  END InitializeExecuteMagicSpellTable;

BEGIN (* MCSpells *)
  InitializeExecuteMagicSpellTable;
END MCSpell2.
