IMPLEMENTATION MODULE MCSpell3;
  (*/WIN:A*)
  
  IMPORT MBolts,MCreatures,MCSpells,MDPainting,MDWindow,MMTranslator,MMWindow,MPAttk2,MRandom,MSpells,MSpells2,MTunnel;
  IMPORT CStruct,DStruct,MCStruct,MStruct,OStruct;
  IMPORT DSActions,OSActions;
  
  
  PROCEDURE ExecuteConfusionAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteConfusionAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteConfusionDamage,done);
    MCSpells.DecreasePlayerMana (player,7,TRUE);
  END ExecuteConfusionAction;
  
  PROCEDURE ExecuteConfusionDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
    PROCEDURE ConfuseCreature (player : MStruct.PlayerInfoPointer; VAR creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord);
    BEGIN (* ConfuseCreature *)
      IF ((CStruct.ResistCharms IN creaturePASSIVE.defense) OR (MRandom.CardinalRandomRangeValue (1,CStruct.MaxCreatureDepth) < creaturePASSIVE.depth)) THEN
        IF CStruct.ResistCharms IN creaturePASSIVE.defense THEN
          IF creatureACTIVE.visible THEN
            INCL (creaturePASSIVE.memory.defense,CStruct.ResistCharms);
          END; (* IF *)
        ELSE
          creatureACTIVE.sleep := 0;
        END; (* IF *)
        
        MMWindow.DisplayCreatureMessage (player,"The %CREATURE is unaffected.",creaturePASSIVE.description,creatureACTIVE.visible,TRUE);
      ELSE
        creatureACTIVE.confused := TRUE;
        creatureACTIVE.sleep    := 0;
        
        MMWindow.DisplayCreatureMessage (player,"The %CREATURE appears confused.",creaturePASSIVE.description,creatureACTIVE.visible,TRUE);
      END; (* IF *)
    END ConfuseCreature;
    
  BEGIN (* ExecuteConfusionDamage *)
    identified := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF identified THEN
      ConfuseCreature (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],player^.creatures^.table [player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].cursor]);
    END; (* IF *)
  END ExecuteConfusionDamage;
  
  PROCEDURE ExecuteConfusionSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteConfusionSpell *)
    MMTranslator.ExecuteTargetedCommand (player,"Confuse which creature?",ExecuteConfusionAction);
  END ExecuteConfusionSpell;
  
  PROCEDURE ExecuteFireBoltAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteFireBoltAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteFireBoltDamage,done);
    MCSpells.DecreasePlayerMana (player,22,TRUE);
  END ExecuteFireBoltAction;
  
  PROCEDURE ExecuteFireBoltDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
  BEGIN (* ExecuteFireBoltDamage *)
    done := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF done THEN
      MBolts.DamageCreatureWithMagicBolt (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],player^.creatures^.table [player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].cursor],MRandom.CardinalRandomRangeValue (9,72),CStruct.CreatureDefenseInformation {CStruct.HurtByFire},CStruct.CreatureSpellSet {CStruct.BreathFire},"Fire Bolt");
    END; (* IF *)
  END ExecuteFireBoltDamage;
  
  PROCEDURE ExecuteFireBoltSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteFireBoltSpell *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Fire Bolt?",ExecuteFireBoltAction);
  END ExecuteFireBoltSpell;
  
  PROCEDURE ExecuteFrostBoltAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteFrostBoltAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteFrostBoltDamage,done);
    MCSpells.DecreasePlayerMana (player,14,TRUE);
  END ExecuteFrostBoltAction;
  
  PROCEDURE ExecuteFrostBoltDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
  BEGIN (* ExecuteFrostBoltDamage *)
    done := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF done THEN
      MBolts.DamageCreatureWithMagicBolt (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],player^.creatures^.table [player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].cursor],MRandom.CardinalRandomRangeValue (6,48),CStruct.CreatureDefenseInformation {CStruct.HurtByFrost},CStruct.CreatureSpellSet {CStruct.BreathFrost},"Frost Bolt");
    END; (* IF *)
  END ExecuteFrostBoltDamage;
  
  PROCEDURE ExecuteFrostBoltSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteFrostBoltSpell *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Frost Bolt?",ExecuteFrostBoltAction);
  END ExecuteFrostBoltSpell;
  
  PROCEDURE ExecuteLightningBoltAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteLightningBoltAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteLightningBoltDamage,done);
    MCSpells.DecreasePlayerMana (player,8,TRUE);
  END ExecuteLightningBoltAction;
  
  PROCEDURE ExecuteLightningBoltDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
  BEGIN (* ExecuteLightningBoltDamage *)
    done := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF done THEN
      MBolts.DamageCreatureWithMagicBolt (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],player^.creatures^.table [player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].cursor],MRandom.CardinalRandomRangeValue (4,32),CStruct.CreatureDefenseInformation {CStruct.HurtByLightWand},CStruct.CreatureSpellSet {CStruct.BreathLightning},"Lightning Bolt");
    END; (* IF *)
  END ExecuteLightningBoltDamage;
  
  PROCEDURE ExecuteLightningBoltSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteLightningBoltSpell *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Lightning Bolt?",ExecuteLightningBoltAction);
  END ExecuteLightningBoltSpell;
  
  PROCEDURE ExecuteMagicMissileAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteMagicMissileAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteMagicMissileDamage,done);
    MCSpells.DecreasePlayerMana (player,0,TRUE);
  END ExecuteMagicMissileAction;
  
  PROCEDURE ExecuteMagicMissileDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
  BEGIN (* ExecuteMagicMissileDamage *)
    done := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF done THEN
      MBolts.DamageCreatureWithMagicBolt (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],player^.creatures^.table [player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].cursor],MRandom.CardinalRandomRangeValue (2,12),CStruct.CreatureDefenseInformation {},CStruct.CreatureSpellSet {},"Magic Missile");
    END; (* IF *)
  END ExecuteMagicMissileDamage;

  PROCEDURE ExecuteMagicMissileSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteMagicMissileSpell *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Magic Missile?",ExecuteMagicMissileAction);
  END ExecuteMagicMissileSpell;
  
  PROCEDURE ExecutePolymorphOtherAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecutePolymorphOtherAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecutePloymorphOtherDamage,done);
    MCSpells.DecreasePlayerMana (player,19,TRUE);
  END ExecutePolymorphOtherAction;
  
  PROCEDURE ExecutePloymorphOtherDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
    PROCEDURE PolymorphCreature (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; creaturePASSIVE : CStruct.PassiveCreatureInfoRecord; visible : BOOLEAN);
      VAR
          creature : DStruct.DungeonCreatureRecord;
          position : CARDINAL;
          done     : BOOLEAN;
      
    BEGIN (* PolymorphCreature *)
      IF MRandom.CardinalRandomRangeValue (1,CStruct.MaxCreatureDepth) > creaturePASSIVE.depth THEN
        DSActions.DeleteCreatureAtLocation (player^.dungeon^,line,column);
        
        MCreatures.DetermineRandomCreatureForDepth (player^.creatures,CStruct.MaxCreatureDepth,FALSE,player^.character^.variables.speed,creature);
        DSActions.PlaceCreatureAtLocation (player,player^.dungeon^,line,column,creature,position,done);
        
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
      ELSE
        MMWindow.DisplayCreatureMessage (player,"The %CREATURE is unaffected.",creaturePASSIVE.description,visible,TRUE);
      END; (* IF *)
    END PolymorphCreature;
    
  BEGIN (* ExecutePloymorphOtherDamage *)
    done := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF done THEN
      PolymorphCreature (player,line,column,player^.creatures^.table [player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].cursor],player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].visible);
    END; (* IF *)
  END ExecutePloymorphOtherDamage;
  
  PROCEDURE ExecutePolymorphOtherSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecutePolymorphOtherSpell *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Polymorph Other?",ExecutePolymorphOtherAction);
  END ExecutePolymorphOtherSpell;
  
  PROCEDURE ExecuteSleep1Action (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteSleep1Action *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteSleep1Damage,done);
    MCSpells.DecreasePlayerMana (player,10,TRUE);
  END ExecuteSleep1Action;
  
  PROCEDURE ExecuteSleep1Damage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
    VAR
        slept : BOOLEAN;
    
  BEGIN (* ExecuteSleep1Damage *)
    done := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF done THEN
      MSpells2.AttemptCreatureSleep (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],player^.creatures^.table [player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].cursor],slept);
    END; (* IF *)
  END ExecuteSleep1Damage;
  
  PROCEDURE ExecuteSleep1Spell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteSleep1Spell *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Sleep I?",ExecuteSleep1Action);
  END ExecuteSleep1Spell;
  
  PROCEDURE ExecuteSlowMonsterAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteSlowMonsterAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteSlowMonsterDamage,done);
    MCSpells.DecreasePlayerMana (player,23,TRUE);
  END ExecuteSlowMonsterAction;
  
  PROCEDURE ExecuteSlowMonsterDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
  BEGIN (* ExecuteSlowMonsterDamage *)
    done := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF done THEN
      MSpells2.AttemptCreatureSpeedChange (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],player^.creatures^.table [player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].cursor],-1);
    END; (* IF *)
  END ExecuteSlowMonsterDamage;
  
  PROCEDURE ExecuteSlowMonsterSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteSlowMonsterSpell *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Slow Monster?",ExecuteSlowMonsterAction);
  END ExecuteSlowMonsterSpell;
  
  PROCEDURE ExecuteTeleportOtherAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteTeleportOtherAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteTeleportOtherDamage,done);
    MCSpells.DecreasePlayerMana (player,26,TRUE);
  END ExecuteTeleportOtherAction;
  
  PROCEDURE ExecuteTeleportOtherDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
  BEGIN (* ExecuteTeleportOtherDamage *)
    done := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF done THEN
      MSpells2.TeleportCreatureAway (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],MCStruct.MaxCharacterSightDistance);
    END; (* IF *)
  END ExecuteTeleportOtherDamage;
  
  PROCEDURE ExecuteTeleportOtherSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteTeleportOtherSpell *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Teleport Other?",ExecuteTeleportOtherAction);
  END ExecuteTeleportOtherSpell;
  
  PROCEDURE ExecuteStoneToMudAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteStoneToMudAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteStoneToMudDamage,done);
    MCSpells.DecreasePlayerMana (player,15,TRUE);
  END ExecuteStoneToMudAction;
  
  PROCEDURE ExecuteStoneToMudDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
    PROCEDURE DamageCreatureWithStoneToMud (player : MStruct.PlayerInfoPointer; VAR creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord);
    BEGIN (* DamageCreatureWithStoneToMud *)
      IF CStruct.HurtByStoneToMud IN creaturePASSIVE.defense THEN
        MPAttk2.DamageCreature (creatureACTIVE,100);
        
        IF creatureACTIVE.hitpoints > 0 THEN
          MMWindow.DisplayCreatureMessage (player,"The %CRETURE grunts in pain!",creaturePASSIVE.description,creatureACTIVE.visible,TRUE);
        ELSE
          MMWindow.DisplayCreatureMessage (player,"The %CRETURE dissolves!",creaturePASSIVE.description,creatureACTIVE.visible,TRUE);
          MPAttk2.KillCreatureAtLocation (player,creatureACTIVE.line,creatureACTIVE.column,creaturePASSIVE,creatureACTIVE.visible,TRUE);
        END; (* IF *)
        
        INCL (creaturePASSIVE.memory.defense,CStruct.HurtByStoneToMud);
      END; (* IF *)
    END DamageCreatureWithStoneToMud;
    
  BEGIN (* ExecuteStoneToMudDamage *)
    done := TRUE;
    
    IF player^.dungeon^.physical [line]^ [column].elements * (DStruct.DungeonWallElements - DStruct.DungeonElementSet {DStruct.BoundaryWall}) <> DStruct.EmptyDungeonElementSet THEN
      IF DSActions.LocationHasLight (player^.dungeon^,line,column) THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The wall turns to mud.");
      END; (* IF *)
      
      MTunnel.MeltWallAtLocation (player,line,column,player^.dungeon^.physical [line]^ [column],TRUE);
    ELSIF ((player^.dungeon^.physical [line]^ [column].artifact <> DStruct.InvalidArtifactCursor) AND (player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact].object.class IN OStruct.ObjectClassSet {OStruct.Rubble,OStruct.OpenDoor,OStruct.ClosedDoor,OStruct.SecretDoor})) THEN
      IF DSActions.LocationHasLight (player^.dungeon^,line,column) THEN
        OSActions.DisplayObjectMessage (player^.windows.frame,player,"The %OBJECT turns to mud.","%OBJECT",player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact],FALSE,TRUE);
      END; (* IF *)
      
      DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
      MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
    ELSE
      done := FALSE;
    END; (* IF *)
    
    IF player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor THEN
      DamageCreatureWithStoneToMud (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],player^.creatures^.table [player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].cursor]);
      done := TRUE;
    END; (* IF *)
  END ExecuteStoneToMudDamage;
  
  PROCEDURE ExecuteTurnStoneToMudSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteTurnStoneToMudSpell *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Stone to Mud?",ExecuteStoneToMudAction);
  END ExecuteTurnStoneToMudSpell;
END MCSpell3.
