IMPLEMENTATION MODULE MCSpell4;
  (*/WIN:A*)
  
  IMPORT MBalls,MBolts,MCSpells,MMTranslator,MMWindow;
  IMPORT CStruct,DStruct,MStruct;
  IMPORT WString;
  
  
  PROCEDURE ExecuteFireBallAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteFireBallAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteFireBallDamage,done);
    MCSpells.DecreasePlayerMana (player,28,TRUE);
  END ExecuteFireBallAction;
  
  PROCEDURE ExecuteFireBallDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
  BEGIN (* ExecuteFireBallDamage *)
    ExecutePlayerMagicBallDamage (player,line,column,72,MBalls.ExecuteFireDamage,"Collateral Fire Ball Damage","Fire Ball");
    done := TRUE;
  END ExecuteFireBallDamage;
  
  PROCEDURE ExecuteFireBallSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteFireBallSpell *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Fire Ball?",ExecuteFireBallAction);
  END ExecuteFireBallSpell;
  
  PROCEDURE ExecuteFrostBallAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteFrostBallAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteFrostBallDamage,done);
    MCSpells.DecreasePlayerMana (player,24,TRUE);
  END ExecuteFrostBallAction;
  
  PROCEDURE ExecuteFrostBallDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
  BEGIN (* ExecuteFrostBallDamage *)
    ExecutePlayerMagicBallDamage (player,line,column,48,MBalls.ExecuteFrostDamage,"Collateral Frost Ball Damage","Frost Ball");
    done := TRUE;
  END ExecuteFrostBallDamage;
  
  PROCEDURE ExecuteFrostBallSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteFrostBallSpell *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Frost Ball?",ExecuteFrostBallAction);
  END ExecuteFrostBallSpell;
  
  PROCEDURE ExecutePlayerMagicBallDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; damage : CARDINAL; ExecuteLocationDamage : MBalls.MagicBallLocationDamageProcedure; killer,description : ARRAY OF CHAR);
    VAR
        hit,killed : CARDINAL;
    
    PROCEDURE AddMagicBallMessageToList (player : MStruct.PlayerInfoPointer; text,actual : ARRAY OF CHAR);
      VAR
          message : ARRAY [0..127] OF CHAR;
      
    BEGIN (* AddMagicBallMessageToList *)
      WString.ReplaceStringParameter (text,"%DESCRIPTION",description,message);
      MMWindow.AddMessageToList (player,message);
    END AddMagicBallMessageToList;
    
  BEGIN (* ExecutePlayerMagicBallDamage *)
    MBalls.ExecuteMagicBallDamage (player,line,column,damage,ExecuteLocationDamage,TRUE,killer,hit,killed);
    
    IF hit > 1 THEN
      AddMagicBallMessageToList (player,"The %DESCRIPTION envelops several creatures!",description);
    ELSIF hit = 1 THEN
      AddMagicBallMessageToList (player,"The %DESCRIPTION envelops a creature!",description);
    END; (* IF *)
    
    IF killed > 1 THEN
      MMWindow.AddMessageToList (player,"There are several screams of agony!");
    ELSIF killed = 1 THEN
      MMWindow.AddMessageToList (player,"There is a scream of agony!");
    END; (* IF *)
  END ExecutePlayerMagicBallDamage;
  
  PROCEDURE ExecuteStinkingCloudAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteStinkingCloudAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteStinkingCloudDamage,done);
    MCSpells.DecreasePlayerMana (player,6,TRUE);
  END ExecuteStinkingCloudAction;
  
  PROCEDURE ExecuteStinkingCloudDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
  BEGIN (* ExecuteStinkingCloudDamage *)
    ExecutePlayerMagicBallDamage (player,line,column,12,MBalls.ExecuteGasDamage,"Collateral Stinking Cloud Damage","Stinking Cloud");
    done := TRUE;
  END ExecuteStinkingCloudDamage;

  PROCEDURE ExecuteStinkingCloudSpell (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteStinkingCloudSpell *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Stinking Cloud?",ExecuteStinkingCloudAction);
  END ExecuteStinkingCloudSpell;
END MCSpell4.
