IMPLEMENTATION MODULE MDGRooms;
  (*/WIN:A*)
  
  IMPORT MCreatures,MDGAlloc,MDGenerator,MDGDoors,MRandom;
  IMPORT DStruct,MStruct,OStruct;
  IMPORT DSActions;
  
  
  CONST
        RoomWallElements = DStruct.DungeonElementSet {DStruct.GraniteWall,DStruct.lrFLAG};
  
  
  PROCEDURE DungeonFloorMnemonic (depth : CARDINAL) : DStruct.DungeonElementMnemonic;
  BEGIN (* DungeonFloorMnemonic *)
    IF depth <= MRandom.CardinalRandomRangeValue (1,25) THEN
      RETURN (DStruct.LightFloor);
    ELSE
      RETURN (DStruct.DarkFloor);
    END; (* IF *)
  END DungeonFloorMnemonic;
  
  PROCEDURE GenerateDungeonRooms (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; depth : CARDINAL; VAR info : MDGenerator.DungeonGeneratorInformation);
    CONST
          MaxHorizontalRoomSlots = 20;
          MaxVerticalRoomSlots   = 20;
    
    TYPE
         DungeonRoomMap = ARRAY [0..MaxVerticalRoomSlots - 1],[0..MaxHorizontalRoomSlots - 1] OF BOOLEAN;
    
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
        map    : DungeonRoomMap;
    
    PROCEDURE GenerateDungeonRoom (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; depth : CARDINAL; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : MDGenerator.DungeonLocation);
      PROCEDURE GenerateInnerRoomCreatures (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; number : CARDINAL);
        VAR
            done : BOOLEAN;
        
      BEGIN (* GenerateInnerRoomCreatures *)
        WHILE number > 0 DO
          MCreatures.SummonRandomMonster (player,line,column,TRUE,done);
          DEC (number);
        END; (* WHILE *)
      END GenerateInnerRoomCreatures;
      
      PROCEDURE GenerateInnerRoomTraps (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; deltaLINE,deltaCOLUMN : INTEGER; number : CARDINAL);
        PROCEDURE GenerateInnerRoomTrap (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; deltaLINE,deltaCOLUMN : INTEGER);
          VAR
              attempts : CARDINAL;
              column   : DStruct.DungeonColumnRange;
              line     : DStruct.DungeonLineRange;
              done     : BOOLEAN;
          
          PROCEDURE ValidTrapLocation (location : DStruct.PhysicalDungeonUnit) : BOOLEAN;
          BEGIN (* ValidTrapLocation *)
            RETURN ((location.elements * DStruct.DungeonFloorElements <> DStruct.EmptyDungeonElementSet) AND (location.artifact = DStruct.InvalidArtifactCursor));
          END ValidTrapLocation;
          
        BEGIN (* GenerateInnerRoomTrap *)
          attempts := 0;
          done     := FALSE;
          
          REPEAT
            column := centerCOLUMN - deltaCOLUMN - 1 + MRandom.IntegerRandomRangeValue (1,2 * deltaCOLUMN + 1);
            line   := centerLINE - deltaLINE - 1 + MRandom.IntegerRandomRangeValue (1,2 * deltaLINE + 1);
            
            IF ValidTrapLocation (dungeon.physical [line]^ [column]) THEN
              MDGAlloc.PlaceTrapAtLocation (player^.treasures,dungeon,line,column);
              done := TRUE;
            END; (* IF *)
            
            INC (attempts);
          UNTIL (done OR (attempts = 5));
        END GenerateInnerRoomTrap;
        
      BEGIN (* GenerateInnerRoomTraps *)
        WHILE number > 0 DO
          GenerateInnerRoomTrap (player,dungeon,centerLINE,centerCOLUMN,deltaLINE,deltaCOLUMN);
          DEC (number);
        END; (* WHILE *)
      END GenerateInnerRoomTraps;
      
      PROCEDURE GenerateStandardRoom (VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; depth : CARDINAL);
        VAR
            minX,maxX : DStruct.DungeonColumnRange;
            minY,maxY : DStruct.DungeonLineRange;
        
      BEGIN (* GenerateStandardRoom *)
        minX := column - MRandom.IntegerRandomRangeValue (1,11);
        maxX := column + MRandom.IntegerRandomRangeValue (1,11);
        minY := line - MRandom.IntegerRandomRangeValue (1,4);
        maxY := line + MRandom.IntegerRandomRangeValue (1,3);
        
        GenerateStandardRoomFloor (dungeon,minX,maxX,minY,maxY,DungeonFloorMnemonic (depth));
        GenerateStandardRoomWalls (dungeon,minX - 1,maxX + 1,minY - 1,maxY + 1);
      END GenerateStandardRoom;
      
      PROCEDURE GenerateUnusualRoomClass1 (VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; floor : DStruct.DungeonElementMnemonic);
        VAR
            room : CARDINAL;
        
        PROCEDURE GenerateSingleRoom (VAR dungeon : DStruct.DungeonInformation; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange; floor : DStruct.DungeonElementMnemonic);
          PROCEDURE GenerateClass1Walls (VAR dungeon : DStruct.DungeonInformation; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange; floor : DStruct.DungeonElementMnemonic);
            VAR
                column : DStruct.DungeonColumnRange;
                line   : DStruct.DungeonLineRange;
            
            PROCEDURE SetClass1WallElement (VAR elements : DStruct.DungeonElementSet; floor : DStruct.DungeonElementMnemonic);
            BEGIN (* SetClass1WallElement *)
              IF NOT (floor IN elements) THEN
                elements := (elements - DStruct.DungeonFValElements) + RoomWallElements;
              END; (* IF *)
            END SetClass1WallElement;
            
          BEGIN (* GenerateClass1Walls *)
            FOR column := minX TO maxX DO
              SetClass1WallElement (dungeon.physical [minY - 1]^ [column].elements,floor);
              SetClass1WallElement (dungeon.physical [maxY + 1]^ [column].elements,floor);
            END; (* FOR *)
            
            FOR line := minY - 1 TO maxY + 1 DO
              SetClass1WallElement (dungeon.physical [line]^ [minX - 1].elements,floor);
              SetClass1WallElement (dungeon.physical [line]^ [maxX + 1].elements,floor);
            END; (* FOR *)
          END GenerateClass1Walls;
          
        BEGIN (* GenerateSingleRoom *)
          GenerateStandardRoomFloor (dungeon,minX,maxX,minY,maxY,floor);
          GenerateClass1Walls (dungeon,minX,maxX,minY,maxY,floor);
        END GenerateSingleRoom;
        
      BEGIN (* GenerateUnusualRoomClass1 *)
        FOR room := 1 TO MRandom.CardinalRandomRangeValue (2,3) DO
          GenerateSingleRoom (dungeon,column - MRandom.IntegerRandomRangeValue (1,11),column + MRandom.IntegerRandomRangeValue (1,11),line - MRandom.IntegerRandomRangeValue (1,4),line + MRandom.IntegerRandomRangeValue (1,3),floor);
        END; (* FOR *)
      END GenerateUnusualRoomClass1;
      
      PROCEDURE GenerateUnusualRoomClass2 (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; depth : CARDINAL; floor : DStruct.DungeonElementMnemonic);
        CONST
              HalfClass2Height = 4;
              HalfClass2Width  = 11;
        
        PROCEDURE GenerateClass2RoomDoor (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange);
        BEGIN (* GenerateClass2RoomDoor *)
          CASE MRandom.CardinalRandomRangeValue (1,4) OF
            1 : MDGDoors.GenerateSecretDoor (player^.treasures,dungeon,minY - 1,centerCOLUMN); |
            2 : MDGDoors.GenerateSecretDoor (player^.treasures,dungeon,maxY + 1,centerCOLUMN); |
            3 : MDGDoors.GenerateSecretDoor (player^.treasures,dungeon,centerLINE,minX - 1);   |
            4 : MDGDoors.GenerateSecretDoor (player^.treasures,dungeon,centerLINE,maxX + 1);   |
          END; (* CASE *)
        END GenerateClass2RoomDoor;
        
        PROCEDURE GenerateEmptyClass2Room (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange);
        BEGIN (* GenerateEmptyClass2Room *)
          GenerateInnerRoomCreatures (player,dungeon,line,column,1);
          GenerateClass2RoomDoor (player,dungeon,line,column,minX,maxX,minY,maxY);
        END GenerateEmptyClass2Room;
        
        PROCEDURE GenerateFourSmallRooms (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange; depth : CARDINAL);
          PROCEDURE GenerateInnerWalls (VAR dunegon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange);
            VAR
                column : DStruct.DungeonColumnRange;
                line   : DStruct.DungeonLineRange;
            
          BEGIN (* GenerateInnerWalls *)
            FOR line := minY TO maxY DO
              DSActions.SetDungeonLocationFVal (dungeon.physical [line]^ [centerCOLUMN],DStruct.TemporaryWall1);
            END; (* FOR *)
            
            FOR column := minX TO maxX DO
              DSActions.SetDungeonLocationFVal (dungeon.physical [centerLINE]^ [column],DStruct.TemporaryWall1);
            END; (* FOR *)
          END GenerateInnerWalls;
          
          PROCEDURE GenerateRoomDoors (treasures : OStruct.TreasureInfoPointer; VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange);
            VAR
                offset : INTEGER;
            
          BEGIN (* GenerateRoomDoors *)
            IF MRandom.CardinalRandomRangeValue (1,2) = 1 THEN
              offset := MRandom.IntegerRandomRangeValue (1,10);
              
              MDGDoors.GenerateSecretDoor (treasures,dungeon,minY - 1,centerCOLUMN - offset);
              MDGDoors.GenerateSecretDoor (treasures,dungeon,minY - 1,centerCOLUMN + offset);
              MDGDoors.GenerateSecretDoor (treasures,dungeon,maxY + 1,centerCOLUMN - offset);
              MDGDoors.GenerateSecretDoor (treasures,dungeon,maxY + 1,centerCOLUMN + offset);
            ELSE
              offset := MRandom.IntegerRandomRangeValue (1,3);
              
              MDGDoors.GenerateSecretDoor (treasures,dungeon,centerLINE + offset,minX - 1);
              MDGDoors.GenerateSecretDoor (treasures,dungeon,centerLINE - offset,minX - 1);
              MDGDoors.GenerateSecretDoor (treasures,dungeon,centerLINE + offset,maxX + 1);
              MDGDoors.GenerateSecretDoor (treasures,dungeon,centerLINE - offset,maxX + 1);
            END; (* IF *)
          END GenerateRoomDoors;
          
        BEGIN (* GenerateFourSmallRooms *)
          GenerateInnerWalls (dungeon,line,column,minX,maxX,minY,maxY);
          GenerateRoomDoors (player^.treasures,dungeon,line,column,minX,maxX,minY,maxY);
          
          MDGAlloc.GenerateRandomTreasures (player,dungeon,line,column,depth,MRandom.CardinalRandomRangeValue (1,2) + 2);
          
          GenerateInnerRoomCreatures (player,dungeon,line + 2,column - 4,MRandom.CardinalRandomRangeValue (1,2));
          GenerateInnerRoomCreatures (player,dungeon,line + 2,column + 4,MRandom.CardinalRandomRangeValue (1,2));
          GenerateInnerRoomCreatures (player,dungeon,line - 2,column - 4,MRandom.CardinalRandomRangeValue (1,2));
          GenerateInnerRoomCreatures (player,dungeon,line - 2,column + 4,MRandom.CardinalRandomRangeValue (1,2));
        END GenerateFourSmallRooms;
        
        PROCEDURE GenerateInnerMaze (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange; depth : CARDINAL);
          PROCEDURE GenerateMazePattern (VAR dungeon : DStruct.DungeonInformation; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange);
            VAR
                column : DStruct.DungeonColumnRange;
                line   : DStruct.DungeonLineRange;
            
          BEGIN (* GenerateMazePattern *)
            FOR line := minY TO maxY DO
              FOR column := minX TO maxX DO
                IF ODD (line + column) THEN
                  DSActions.SetDungeonLocationFVal (dungeon.physical [line]^ [column],DStruct.TemporaryWall1);
                END; (* IF *)
              END; (* FOR *)
            END; (* FOR *)
          END GenerateMazePattern;
          
        BEGIN (* GenerateInnerMaze *)
          GenerateClass2RoomDoor (player,dungeon,centerLINE,centerCOLUMN,minX,maxX,minY,maxY);
          GenerateMazePattern (dungeon,minX,maxX,minY,maxY);
          
          GenerateInnerRoomCreatures (player,dungeon,centerLINE,centerCOLUMN - 5,MRandom.CardinalRandomRangeValue (1,3));
          GenerateInnerRoomCreatures (player,dungeon,centerLINE,centerCOLUMN + 5,MRandom.CardinalRandomRangeValue (1,3));
          
          GenerateInnerRoomTraps (player,dungeon,centerLINE,centerCOLUMN - 3,2,8,MRandom.CardinalRandomRangeValue (1,3));
          GenerateInnerRoomTraps (player,dungeon,centerLINE,centerCOLUMN + 3,2,8,MRandom.CardinalRandomRangeValue (1,3));
          
          MDGAlloc.GenerateRandomTreasures (player,dungeon,centerLINE,centerCOLUMN,depth,MRandom.CardinalRandomRangeValue (1,3));
        END GenerateInnerMaze;
        
        PROCEDURE GenerateInnerPillars (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange; depth : CARDINAL);
          PROCEDURE GenerateInnerPillar (VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange);
            VAR
                column : DStruct.DungeonColumnRange;
                line   : DStruct.DungeonLineRange;
            
          BEGIN (* GenerateInnerPillar *)
            FOR line := centerLINE - 1 TO centerLINE + 1 DO
              FOR column := centerCOLUMN - 1 TO centerCOLUMN + 1 DO
                DSActions.SetDungeonLocationFVal (dungeon.physical [line]^ [column],DStruct.TemporaryWall1);
              END; (* FOR *)
            END; (* FOR *)
          END GenerateInnerPillar;
          
          PROCEDURE GenerateOutterPillars (VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange);
            VAR
                offset : INTEGER;
            
          BEGIN (* GenerateOutterPillars *)
            offset := MRandom.IntegerRandomRangeValue (1,2);
            
            GenerateInnerPillar (dungeon,centerLINE,centerCOLUMN - 4 - offset);
            GenerateInnerPillar (dungeon,centerLINE,centerCOLUMN + 4 + offset);
          END GenerateOutterPillars;
          
          PROCEDURE GeneratePillarRooms (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; depth : CARDINAL);
            CONST
                  HalfPillarRoomWidth = 5;
            
            VAR
                column : DStruct.DungeonColumnRange;
            
          BEGIN (* GeneratePillarRooms *)
            DSActions.SetDungeonLocationFVal (dungeon.physical [centerLINE]^ [centerCOLUMN - HalfPillarRoomWidth],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [centerLINE]^ [centerCOLUMN + HalfPillarRoomWidth],DStruct.TemporaryWall1);
            
            FOR column := centerCOLUMN - HalfPillarRoomWidth TO centerCOLUMN + HalfPillarRoomWidth DO
              DSActions.SetDungeonLocationFVal (dungeon.physical [centerLINE - 1]^ [column],DStruct.TemporaryWall1);
              DSActions.SetDungeonLocationFVal (dungeon.physical [centerLINE + 1]^ [column],DStruct.TemporaryWall1);
            END; (* FOR *)
            
            MDGDoors.GenerateSecretDoor (player^.treasures,dungeon,centerLINE - 3 + (MRandom.IntegerRandomRangeValue (1,2) * 2),centerCOLUMN - 3);
            MDGDoors.GenerateSecretDoor (player^.treasures,dungeon,centerLINE - 3 + (MRandom.IntegerRandomRangeValue (1,2) * 2),centerCOLUMN + 3);
            
            IF MRandom.CardinalRandomRangeValue (1,3) = 1 THEN
              MDGAlloc.GenerateRandomTreasures (player,dungeon,centerLINE,centerCOLUMN - 2,depth,1);
            END; (* IF *)
            
            IF MRandom.CardinalRandomRangeValue (1,3) = 1 THEN
              MDGAlloc.GenerateRandomTreasures (player,dungeon,centerLINE,centerCOLUMN + 2,depth,1);
            END; (* IF *)
            
            GenerateInnerRoomCreatures (player,dungeon,centerLINE,centerCOLUMN - 2,MRandom.CardinalRandomRangeValue (1,2));
            GenerateInnerRoomCreatures (player,dungeon,centerLINE,centerCOLUMN + 2,MRandom.CardinalRandomRangeValue (1,2));
          END GeneratePillarRooms;
          
        BEGIN (* GenerateInnerPillars *)
          GenerateClass2RoomDoor (player,dungeon,centerLINE,centerCOLUMN,minX,maxX,minY,maxY);
          GenerateInnerPillar (dungeon,centerLINE,centerCOLUMN);
          
          IF MRandom.CardinalRandomRangeValue (1,2) = 1 THEN
            GenerateOutterPillars (dungeon,centerLINE,centerCOLUMN);
          END; (* IF *)
          
          IF MRandom.CardinalRandomRangeValue (1,3) = 1 THEN
            GeneratePillarRooms (player,dungeon,centerLINE,centerCOLUMN,depth);
          END; (* IF *)
        END GenerateInnerPillars;
        
        PROCEDURE GenerateInnerRoomWall (VAR dungeon : DStruct.DungeonInformation; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange);
          VAR
              column : DStruct.DungeonColumnRange;
              line   : DStruct.DungeonLineRange;
          
        BEGIN (* GenerateInnerRoomWall *)
          FOR line := minY - 1 TO maxY + 1 DO
            DSActions.SetDungeonLocationFVal (dungeon.physical [line]^ [minX - 1],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [line]^ [maxX + 1],DStruct.TemporaryWall1);
          END; (* FOR *)
          
          FOR column := minX TO maxX DO
            DSActions.SetDungeonLocationFVal (dungeon.physical [minY - 1]^ [column],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [maxY + 1]^ [column],DStruct.TemporaryWall1);
          END; (* FOR *)
        END GenerateInnerRoomWall;
        
        PROCEDURE GenerateTreasureVault (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange; depth : CARDINAL);
        BEGIN (* GenerateTreasureVault *)
          GenerateClass2RoomDoor (player,dungeon,centerLINE,centerCOLUMN,minX,maxX,minY,maxY);
          GenerateVaultWalls (player,dungeon,centerLINE,centerCOLUMN);
          
          CASE MRandom.CardinalRandomRangeValue (1,10) OF
            1     : MDGenerator.PlaceDownStair (player^.treasures,dungeon,centerLINE,centerCOLUMN);       |
            2     : MDGenerator.PlaceUpStair (player^.treasures,dungeon,centerLINE,centerCOLUMN);         |
            3..10 : MDGAlloc.PlaceRandomObject (player,dungeon,centerLINE,centerCOLUMN,depth,FALSE);      |
          END; (* CASE *)
          
          GenerateInnerRoomCreatures (player,dungeon,centerLINE,centerCOLUMN,MRandom.CardinalRandomRangeValue (3,5));
          GenerateInnerRoomTraps (player,dungeon,centerLINE,centerCOLUMN,4,10,MRandom.CardinalRandomRangeValue (3,5));
        END GenerateTreasureVault;
        
      BEGIN (* GenerateUnusualRoomClass2 *)
        GenerateStandardRoomWalls (dungeon,column - HalfClass2Width - 1,column + HalfClass2Width + 1,line - HalfClass2Height - 1,line + HalfClass2Height + 1);
        GenerateStandardRoomFloor (dungeon,column - HalfClass2Width,column + HalfClass2Width,line - HalfClass2Height,line + HalfClass2Height,floor);
        
        GenerateInnerRoomWall (dungeon,column - HalfClass2Width + 2,column + HalfClass2Width - 2,line - HalfClass2Height + 2,line + HalfClass2Height - 2);
        
        CASE MRandom.CardinalRandomRangeValue (1,5) OF
          1 : GenerateEmptyClass2Room (player,dungeon,line,column,column - HalfClass2Width + 2,column + HalfClass2Width - 2,line - HalfClass2Height + 2,line + HalfClass2Height - 2);       |
          2 : GenerateTreasureVault (player,dungeon,line,column,column - HalfClass2Width + 2,column + HalfClass2Width - 2,line - HalfClass2Height + 2,line + HalfClass2Height - 2,depth);   |
          3 : GenerateInnerPillars (player,dungeon,line,column,column - HalfClass2Width + 2,column + HalfClass2Width - 2,line - HalfClass2Height + 2,line + HalfClass2Height - 2,depth);    |
          4 : GenerateInnerMaze (player,dungeon,line,column,column - HalfClass2Width + 2,column + HalfClass2Width - 2,line - HalfClass2Height + 2,line + HalfClass2Height - 2,depth);       |
          5 : GenerateFourSmallRooms (player,dungeon,line,column,column - HalfClass2Width + 2,column + HalfClass2Width - 2,line - HalfClass2Height + 2,line + HalfClass2Height - 2,depth);  |
        END; (* CASE *)
      END GenerateUnusualRoomClass2;
      
      PROCEDURE GenerateUnusualRoomClass3 (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; depth : CARDINAL);
        PROCEDURE GenerateInnerRooms (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
        BEGIN (* GenerateInnerRooms *)
          IF MRandom.CardinalRandomRangeValue (1,3) = 1 THEN
            DSActions.SetDungeonLocationFVal (dungeon.physical [line - 1]^ [column - 2],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [line + 1]^ [column - 2],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [line - 1]^ [column + 2],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [line + 1]^ [column + 2],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [line - 2]^ [column + 1],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [line - 2]^ [column - 1],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [line + 2]^ [column + 1],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [line + 2]^ [column - 1],DStruct.TemporaryWall1);
            
            IF MRandom.CardinalRandomRangeValue (1,3) = 1 THEN
              MDGDoors.GenerateSecretDoor (player^.treasures,dungeon,line,column - 2);
              MDGDoors.GenerateSecretDoor (player^.treasures,dungeon,line,column + 2);
              MDGDoors.GenerateSecretDoor (player^.treasures,dungeon,line - 2,column);
              MDGDoors.GenerateSecretDoor (player^.treasures,dungeon,line + 2,column);
            END; (* IF *)
          ELSIF MRandom.CardinalRandomRangeValue (1,3) = 1 THEN
            DSActions.SetDungeonLocationFVal (dungeon.physical [line + 0]^ [column + 0],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [line + 0]^ [column - 1],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [line + 0]^ [column + 1],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [line - 1]^ [column + 0],DStruct.TemporaryWall1);
            DSActions.SetDungeonLocationFVal (dungeon.physical [line + 1]^ [column + 0],DStruct.TemporaryWall1);
          ELSIF MRandom.CardinalRandomRangeValue (1,3) = 1 THEN
            DSActions.SetDungeonLocationFVal (dungeon.physical [line + 0]^ [column + 0],DStruct.TemporaryWall1);
          END; (* IF *)
        END GenerateInnerRooms;
        
        PROCEDURE GenerateLargeMiddlePillar (VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange);
          VAR
              column : DStruct.DungeonColumnRange;
              line   : DStruct.DungeonLineRange;
          
        BEGIN (* GenerateLargeMiddlePillar *)
          FOR line := centerLINE - 1 TO centerLINE + 1 DO
            FOR column := centerCOLUMN - 1 TO centerCOLUMN + 1 DO
              DSActions.SetDungeonLocationFVal (dungeon.physical [line]^ [column],DStruct.TemporaryWall1);
            END; (* FOR *)
          END; (* FOR *)
        END GenerateLargeMiddlePillar;
        
        PROCEDURE GenerateStandardClass3Room (VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; floor : DStruct.DungeonElementMnemonic);
          PROCEDURE GenerateClass3Wall (VAR dungeon : DStruct.DungeonInformation; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange; floor : DStruct.DungeonElementMnemonic);
            VAR
                column : DStruct.DungeonColumnRange;
                line   : DStruct.DungeonLineRange;
            
          BEGIN (* GenerateClass3Wall *)
            FOR line := minY - 1 TO maxY + 1 DO
              IF NOT (floor IN dungeon.physical [line]^ [minX - 1].elements) THEN
                SetRoomWallElements (dungeon.physical [line]^ [minX - 1].elements);
              END; (* IF *)
              
              IF NOT (floor IN dungeon.physical [line]^ [maxX + 1].elements) THEN
                SetRoomWallElements (dungeon.physical [line]^ [maxX + 1].elements);
              END; (* IF *)
            END; (* FOR *)
            
            FOR column := minX TO maxX DO
              IF NOT (floor IN dungeon.physical [minY - 1]^ [column].elements) THEN
                SetRoomWallElements (dungeon.physical [minY - 1]^ [column].elements);
              END; (* IF *)
              
              IF NOT (floor IN dungeon.physical [maxY + 1]^ [column].elements) THEN
                SetRoomWallElements (dungeon.physical [maxY + 1]^ [column].elements);
              END; (* IF *)
            END; (* FOR *)
          END GenerateClass3Wall;
          
          PROCEDURE GenerateHorizontalBeam (VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; offset : INTEGER; floor : DStruct.DungeonElementMnemonic);
          BEGIN (* GenerateHorizontalBeam *)
            GenerateStandardRoomFloor (dungeon,column - offset,column + offset,line - 1,line + 1,floor);
            GenerateClass3Wall (dungeon,column - offset,column + offset,line - 1,line + 1,floor);
          END GenerateHorizontalBeam;
          
          PROCEDURE GenerateVerticalBeam (VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; offset : INTEGER; floor : DStruct.DungeonElementMnemonic);
          BEGIN (* GenerateVerticalBeam *)
            GenerateStandardRoomFloor (dungeon,column - 1,column + 1,line - offset,line + offset,floor);
            GenerateClass3Wall (dungeon,column - 1,column + 1,line - offset,line + offset,floor);
          END GenerateVerticalBeam;
          
        BEGIN (* GenerateStandardClass3Room *)
          GenerateHorizontalBeam (dungeon,line,column,MRandom.IntegerRandomRangeValue (3,11),floor);
          GenerateVerticalBeam (dungeon,line,column,MRandom.IntegerRandomRangeValue (1,4),floor);
        END GenerateStandardClass3Room;
        
        PROCEDURE GenerateTreasureVault (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; depth : CARDINAL);
        BEGIN (* GenerateTreasureVault *)
          GenerateVaultWalls (player,dungeon,line,column);
          
          MDGAlloc.PlaceRandomObject (player,dungeon,line,column,depth,FALSE);
          
          GenerateInnerRoomCreatures (player,dungeon,line,column,MRandom.CardinalRandomRangeValue (3,4));
          GenerateInnerRoomTraps (player,dungeon,line,column,4,4,MRandom.CardinalRandomRangeValue (2,4));
        END GenerateTreasureVault;
        
      BEGIN (* GenerateUnusualRoomClass3 *)
        GenerateStandardClass3Room (dungeon,line,column,DungeonFloorMnemonic (depth));
        
        CASE MRandom.CardinalRandomRangeValue (1,4) OF
          1 : GenerateLargeMiddlePillar (dungeon,line,column);          |
          2 : GenerateTreasureVault (player,dungeon,line,column,depth); |
          3 : GenerateInnerRooms (player,dungeon,line,column);          |
          4 : (* no action *)                                           |
        END; (* CASE *)
      END GenerateUnusualRoomClass3;
      
      PROCEDURE GenerateVaultWalls (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange);
        VAR
            value : INTEGER;
            line  : DStruct.DungeonLineRange;
        
      BEGIN (* GenerateVaultWalls *)
        DSActions.SetDungeonLocationFVal (dungeon.physical [centerLINE - 1]^ [centerCOLUMN],DStruct.TemporaryWall1);
        DSActions.SetDungeonLocationFVal (dungeon.physical [centerLINE + 1]^ [centerCOLUMN],DStruct.TemporaryWall1);
        
        FOR line := centerLINE - 1 TO centerLINE + 1 DO
          DSActions.SetDungeonLocationFVal (dungeon.physical [line]^ [centerCOLUMN - 1],DStruct.TemporaryWall1);
          DSActions.SetDungeonLocationFVal (dungeon.physical [line]^ [centerCOLUMN + 1],DStruct.TemporaryWall1);
        END; (* FOR *)
        
        value := MRandom.IntegerRandomRangeValue (1,4);
        
        IF value < 3 THEN
          MDGDoors.GenerateLockedDoor (player^.treasures,dungeon,centerLINE - 3 + 2 * value,centerCOLUMN);
        ELSE
          MDGDoors.GenerateLockedDoor (player^.treasures,dungeon,centerLINE,centerCOLUMN - 7 + 2 * value);
        END; (* IF *)
      END GenerateVaultWalls;
      
    BEGIN (* GenerateDungeonRoom *)
      IF depth > MRandom.CardinalRandomRangeValue (1,300) THEN
        CASE MRandom.CardinalRandomRangeValue (1,3) OF
          1 : GenerateUnusualRoomClass1 (dungeon,line,column,DungeonFloorMnemonic (depth));              |
          2 : GenerateUnusualRoomClass2 (player,dungeon,line,column,depth,DungeonFloorMnemonic (depth)); |
          3 : GenerateUnusualRoomClass3 (player,dungeon,line,column,depth);                              |
        END; (* CASE *)
      ELSE
        GenerateStandardRoom (dungeon,line,column,depth);
      END; (* IF *)
      
      location.column := column;
      location.line   := line;
    END GenerateDungeonRoom;
    
    PROCEDURE InitializeDungeonRoomMap (VAR map : DungeonRoomMap);
      VAR
          columnLIMIT,lineLIMIT : CARDINAL;
          counter               : INTEGER;
      
      PROCEDURE ClearDungeonRoomMap (VAR result : DungeonRoomMap);
        VAR
            line : CARDINAL;
        
        PROCEDURE ClearBooleanTable (VAR table : ARRAY OF BOOLEAN);
          VAR
              index : CARDINAL;
          
        BEGIN (* ClearBooleanTable *)
          FOR index := 0 TO HIGH (table) DO
            table [index] := FALSE;
          END; (* FOR *)
        END ClearBooleanTable;
        
      BEGIN (* ClearDungeonRoomMap *)
        ClearBooleanTable (result [0]);
        
        FOR line := 1 TO MaxVerticalRoomSlots - 1 DO
          result [line] := result [0];
        END; (* IF *)
      END ClearDungeonRoomMap;
      
    BEGIN (* InitializeDungeonRoomMap *)
      ClearDungeonRoomMap (map);
      
      columnLIMIT := 2 * (DStruct.NumberDungeonColumns DIV 66) - 1;
      lineLIMIT   := 2 * (DStruct.NumberDungeonLines DIV 22) - 1;
      
      FOR counter := 1 TO MRandom.RandomNormalValue (32,2) DO
        map [MRandom.CardinalRandomRangeValue (0,lineLIMIT),MRandom.CardinalRandomRangeValue (0,columnLIMIT)] := TRUE;
      END; (* FOR *)
    END InitializeDungeonRoomMap;
    
  BEGIN (* GenerateDungeonRooms *)
    InitializeDungeonRoomMap (map);
    
    info.roomCOUNTER := 0;
    
    FOR line := 0 TO MaxVerticalRoomSlots - 1 DO
      FOR column := 0 TO MaxHorizontalRoomSlots - 1 DO
        IF map [line,column] THEN
          GenerateDungeonRoom (player,dungeon,depth,line * DStruct.AverageRoomHeight + DStruct.AverageRoomHeight DIV 2,column * DStruct.AverageRoomWidth + DStruct.AverageRoomWidth DIV 2,info.roomTABLE [info.roomCOUNTER]);
          INC (info.roomCOUNTER);
        END; (* IF *)
      END; (* FOR *)
    END; (* FOR *)
  END GenerateDungeonRooms;

  PROCEDURE GenerateStandardRoomFloor (VAR dungeon : DStruct.DungeonInformation; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange; floor : DStruct.DungeonElementMnemonic);
    VAR
        line : DStruct.DungeonLineRange;
    
    PROCEDURE IncludeInDungeonLine (VAR line : ARRAY OF DStruct.PhysicalDungeonUnit; minX,maxX : CARDINAL; element : DStruct.DungeonElementMnemonic);
      VAR
          index : CARDINAL;
      
    BEGIN (* IncludeInDungeonLine *)
      FOR index := minX TO maxX DO
        DSActions.SetDungeonLocationFVal (line [index],floor);
        INCL (line [index].elements,DStruct.lrFLAG);
      END; (* FOR *)
    END IncludeInDungeonLine;
    
  BEGIN (* GenerateStandardRoomFloor *)
    FOR line := minY TO maxY DO
      IncludeInDungeonLine (dungeon.physical [line]^,minX,maxX,floor);
    END; (* FOR *)
  END GenerateStandardRoomFloor;
        
  PROCEDURE GenerateStandardRoomWalls (VAR dungeon : DStruct.DungeonInformation; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange);
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
    
  BEGIN (* GenerateStandardRoomWalls *)
    FOR line := minY TO maxY DO
      SetRoomWallElements (dungeon.physical [line]^ [minX].elements);
      SetRoomWallElements (dungeon.physical [line]^ [maxX].elements);
    END; (* FOR *)
    
    FOR column := minX TO maxX DO
      SetRoomWallElements (dungeon.physical [minY]^ [column].elements);
      SetRoomWallElements (dungeon.physical [maxY]^ [column].elements);
    END; (* FOR *)
  END GenerateStandardRoomWalls;
  
  PROCEDURE SetRoomWallElements (VAR elements : DStruct.DungeonElementSet);
  BEGIN (* SetRoomWallElements *)
    elements := (elements - DStruct.DungeonFValElements) + RoomWallElements;
  END SetRoomWallElements;
END MDGRooms.
