IMPLEMENTATION MODULE MDGTown;
  (*/WIN:A*)
  
  IMPORT MDGAlloc,MDGenerator,MRandom,MStores;
  IMPORT DStruct,MStruct,OStruct;
  IMPORT DSActions,OSActions;
  
  
  PROCEDURE GenerateDungeonTown (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation);
    CONST
          NumberTownColumns = 66;
          NumberTownLines   = 22;
    
    PROCEDURE GenerateFixedTownElements (treasures : OStruct.TreasureInfoPointer; VAR dungeon : DStruct.DungeonInformation);
      PROCEDURE GenerateTownBoundary (VAR dungeon : DStruct.DungeonInformation);
        VAR
            column : DStruct.DungeonColumnRange;
            line   : DStruct.DungeonLineRange;
        
      BEGIN (* GenerateTownBoundary *)
        FOR column := 0 TO NumberTownColumns - 1 DO
          DSActions.SetDungeonLocationFVal (dungeon.physical [NumberTownLines - 1]^ [column],DStruct.BoundaryWall);
          DSActions.SetDungeonLocationFVal (dungeon.physical [0]^ [column],DStruct.BoundaryWall);
          
          INCL (dungeon.physical [NumberTownLines - 1]^ [column].elements,DStruct.plFLAG);
          INCL (dungeon.physical [0]^ [column].elements,DStruct.plFLAG);
        END; (* FOR *)
        
        FOR line := 0 TO NumberTownLines - 1 DO
          DSActions.SetDungeonLocationFVal (dungeon.physical [line]^ [NumberTownColumns - 1],DStruct.BoundaryWall);
          DSActions.SetDungeonLocationFVal (dungeon.physical [line]^ [0],DStruct.BoundaryWall);
          
          INCL (dungeon.physical [line]^ [NumberTownColumns - 1].elements,DStruct.plFLAG);
          INCL (dungeon.physical [line]^ [0].elements,DStruct.plFLAG);
        END; (* FOR *)
      END GenerateTownBoundary;
      
      PROCEDURE GenerateTownFloor (VAR dungeon : DStruct.DungeonInformation);
        VAR
            column : DStruct.DungeonColumnRange;
            line   : DStruct.DungeonLineRange;
        
      BEGIN (* GenerateTownFloor *)
        FOR line := 1 TO dungeon.lines - 2 DO
          FOR column := 1 TO dungeon.columns - 2 DO
            IF DStruct.NullWall IN dungeon.physical [line]^ [column].elements THEN
              dungeon.physical [line]^ [column].elements := dungeon.physical [line]^ [column].elements / DStruct.DungeonElementSet {DStruct.NullWall,DStruct.DarkFloor};
            END; (* IF *)
          END; (* FOR *)
        END; (* FOR *)
      END GenerateTownFloor;
      
      PROCEDURE GenerateTownStair (treasures : OStruct.TreasureInfoPointer; VAR dungeon : DStruct.DungeonInformation);
        VAR
            column : DStruct.DungeonColumnRange;
            line   : DStruct.DungeonLineRange;
      
      BEGIN (* GenerateTownStair *)
        MDGenerator.DetermineRandomStairLocation (dungeon,0,line,column);
        MDGenerator.PlaceDownStair (treasures,dungeon,line,column);
      END GenerateTownStair;
      
      PROCEDURE GenerateTownStores (treasures : OStruct.TreasureInfoPointer; VAR dungeon : DStruct.DungeonInformation);
        CONST
              NumberTownStores = 6;
        
        VAR
            index : CARDINAL;
            list  : ARRAY [0..NumberTownStores - 1] OF OStruct.InventoryItemRecord;
        
        PROCEDURE GenerateTownStore (VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; store : OStruct.InventoryItemRecord);
          VAR
              minX,maxX : [0..NumberTownColumns - 1];
              minY,maxY : [0..NumberTownLines - 1];
          
          PROCEDURE AddToPhysicalDungeonElements (VAR dungeon : DStruct.DungeonInformation; minX,maxX : DStruct.DungeonColumnRange; minY,maxY : DStruct.DungeonLineRange; element : DStruct.DungeonElementSet);
            VAR
                column : DStruct.DungeonColumnRange;
                line   : DStruct.DungeonLineRange;
            
          BEGIN (* AddToPhysicalDungeonElements *)
            FOR line := minY TO maxY DO
              FOR column := minX TO maxX DO
                dungeon.physical [line]^ [column].elements := dungeon.physical [line]^ [column].elements / element;
              END; (* FOR *)
            END; (* FOR *)
          END AddToPhysicalDungeonElements;
          
          PROCEDURE PlaceStoreDoor (VAR dunegon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; store : OStruct.InventoryItemRecord);
          BEGIN (* PlaceStoreDoor *)
            dungeon.physical [line]^ [column].elements := dungeon.physical [line]^ [column].elements / DStruct.DungeonElementSet {DStruct.CorridorFloor,DStruct.BoundaryWall};
            
            DSActions.PlaceDungeonArtifact (dungeon,line,column,store);
          END PlaceStoreDoor;
          
        BEGIN (* GenerateTownStore *)
          minX := column - MRandom.IntegerRandomRangeValue (1,6);
          maxX := column + MRandom.IntegerRandomRangeValue (1,6);
          minY := line - MRandom.IntegerRandomRangeValue (1,3);
          maxY := line + MRandom.IntegerRandomRangeValue (1,4);
          
          AddToPhysicalDungeonElements (dungeon,minX,maxX,minY,maxY,DStruct.DungeonElementSet {DStruct.BoundaryWall,DStruct.plFLAG,DStruct.NullWall});
          
          CASE MRandom.CardinalRandomRangeValue (1,4) OF
            1 : PlaceStoreDoor (dungeon,minY,MRandom.CardinalRandomRangeValue (minX,maxX),store); |
            2 : PlaceStoreDoor (dungeon,maxY,MRandom.CardinalRandomRangeValue (minX,maxX),store); |
            3 : PlaceStoreDoor (dungeon,MRandom.CardinalRandomRangeValue (minY,maxY),minX,store); |
            4 : PlaceStoreDoor (dungeon,MRandom.CardinalRandomRangeValue (minY,maxY),maxX,store); |
          END; (* CASE *)
        END GenerateTownStore;
        
        PROCEDURE ReturnRandomStoreList (treasures : OStruct.TreasureInfoPointer; VAR list : ARRAY OF OStruct.InventoryItemRecord);
          CONST
                StoreDoorObjectBaseCursor = 372;
          
          VAR
              index : CARDINAL;
          
          PROCEDURE SwapInventoryItemRecords (VAR value1,value2 : OStruct.InventoryItemRecord);
            VAR
                temp : OStruct.InventoryItemRecord;
            
          BEGIN (* SwapInventoryItemRecords *)
            temp   := value1;
            value1 := value2;
            value2 := temp;
          END SwapInventoryItemRecords;
          
        BEGIN (* ReturnRandomStoreList *)
          FOR index := 0 TO HIGH (list) DO
            OSActions.ReturnInventoryItemRecord (treasures,StoreDoorObjectBaseCursor + index,list [index]);
          END; (* FOR *)
          
          FOR index := 0 TO HIGH (list) DO
            SwapInventoryItemRecords (list [index],list [MRandom.CardinalRandomRangeValue (0,HIGH (list))]);
          END; (* FOR *)
        END ReturnRandomStoreList;
        
      BEGIN (* GenerateTownStores *)
        ReturnRandomStoreList (treasures,list);
        
        FOR index := 0 TO NumberTownStores - 1 DO
          GenerateTownStore (dungeon,(index DIV 3) * 10 + 5,(index MOD 3) * 16 + 16,list [index]);
        END; (* FOR *)
      END GenerateTownStores;
      
    BEGIN (* GenerateFixedTownElements *)
      MRandom.SetRandomSeed (dungeon.town);
      
      GenerateTownBoundary (dungeon);
      GenerateTownStores (treasures,dungeon);
      GenerateTownFloor (dungeon);
      
      GenerateTownStair (treasures,dungeon);
      
      
      MRandom.Randomize;
    END GenerateFixedTownElements;
    
    PROCEDURE GenerateRandomElements (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation);
      PROCEDURE LightEntireTown (VAR dungeon : DStruct.DungeonInformation);
        VAR
            column : DStruct.DungeonColumnRange;
            line   : DStruct.DungeonLineRange;
        
      BEGIN (* LightEntireTown *)
        FOR line := 0 TO dungeon.lines - 1 DO
          FOR column := 0 TO dungeon.columns - 1 DO
            INCL (dungeon.physical [line]^ [column].elements,DStruct.plFLAG);
          END; (* FOR *)
        END; (* FOR *)
      END LightEntireTown;
      
    BEGIN (* GenerateRandomElements *)
      MDGAlloc.DetermineRandomCharacterLocation (dungeon,player^.character^.line,player^.character^.column);
      
      IF ODD (player^.character^.turn DIV 5000) THEN
        MDGAlloc.AllocateRandomCreatures (player,dungeon,8,3,TRUE);
      ELSE
        MDGAlloc.AllocateRandomCreatures (player,dungeon,4,3,TRUE);
        LightEntireTown (dungeon);
      END; (* IF *)
    END GenerateRandomElements;
    
  BEGIN (* GenerateDungeonTown *)
    dungeon.columns := NumberTownColumns;
    dungeon.lines   := NumberTownLines;
    
    GenerateFixedTownElements (player^.treasures,dungeon);
    GenerateRandomElements (player,dungeon);
    
    MStores.ExecuteStoreMaintainance (player);
  END GenerateDungeonTown;
END MDGTown.
