IMPLEMENTATION MODULE MDistMove;
  (*/WIN:A*)
  
  IMPORT MCMovement,MCMove2,MDSymbols,MPMovement;
  IMPORT DStruct,MCStruct,MStruct,OStruct;
  IMPORT DSActions,MSActions;
  
  
  CONST
        InvalidDirection = 0;
        
  
  PROCEDURE EndDistanceMovement (player : MStruct.PlayerInfoPointer);
  BEGIN (* EndDistanceMovement *)
    EXCL (player^.character^.variables.status,MCStruct.DistanceMoveFLAG);
  END EndDistanceMovement;
  
  PROCEDURE InitializeDistanceMovement (player : MStruct.PlayerInfoPointer; direction : CARDINAL);
    VAR
        newCOLUMN : DStruct.DungeonColumnRange;
        newLINE   : DStruct.DungeonLineRange;
    
    PROCEDURE SetDistanceMoveTerminationFlags (player : MStruct.PlayerInfoPointer; direction : CARDINAL; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR movement : MCStruct.PlayerMovementInformation);
      VAR
          shortLEFT,shortRIGHT : BOOLEAN;
          deepLEFT,deepRIGHT   : BOOLEAN;
          cursor               : CARDINAL;
      
    BEGIN (* SetDistanceMoveTerminationFlags *)
      cursor := movement.chome [direction];
      
      shortRIGHT := FALSE;
      shortLEFT  := FALSE;
      deepRIGHT  := FALSE;
      deepLEFT   := FALSE;
      
      IF WallSymbolAtOffset (player,movement.cycle [cursor + 1],InvalidDirection,player^.character^.line,player^.character^.column) THEN
        INCL (movement.flags,MCStruct.FindBreakLeft);
        shortLEFT := TRUE;
      ELSIF WallSymbolAtOffset (player,movement.cycle [cursor + 1],InvalidDirection,line,column) THEN
        INCL (movement.flags,MCStruct.FindBreakLeft);
        deepLEFT := TRUE;
      END; (* IF *)
      
      IF WallSymbolAtOffset (player,movement.cycle [cursor - 1],InvalidDirection,player^.character^.line,player^.character^.column) THEN
        INCL (movement.flags,MCStruct.FindBreakRight);
        shortRIGHT := TRUE;
      ELSIF WallSymbolAtOffset (player,movement.cycle [cursor - 1],InvalidDirection,line,column) THEN
        INCL (movement.flags,MCStruct.FindBreakRight);
        deepRIGHT := TRUE;
      END; (* IF *)
      
      IF movement.flags * MCStruct.PlayerMovementFlags {MCStruct.FindBreakLeft,MCStruct.FindBreakRight} <> MCStruct.PlayerMovementFlags {MCStruct.FindBreakLeft,MCStruct.FindBreakRight} THEN
        INCL (movement.flags,MCStruct.FindOpenArea);
      ELSIF ODD (direction) THEN
        IF (deepLEFT AND NOT (deepRIGHT)) THEN
          movement.directionPREV := movement.cycle [cursor - 1];
        ELSIF (deepRIGHT AND NOT (deepLEFT)) THEN
          movement.directionPREV := movement.cycle [cursor + 1];
        END; (* IF *)
      ELSIF WallSymbolAtOffset (player,movement.cycle [cursor],InvalidDirection,line,column) THEN
        IF (shortLEFT AND NOT (shortRIGHT)) THEN
          movement.directionPREV := movement.cycle [cursor - 2];
        ELSIF (shortRIGHT AND NOT (shortLEFT)) THEN
          movement.directionPREV := movement.cycle [cursor + 2];
        END; (* IF *)
      END; (* IF *)
    END SetDistanceMoveTerminationFlags;
    
  BEGIN (* InitializeDistanceMovement *)
    WITH player^.character^ DO
      DSActions.DetermineDungeonLocation (line,column,direction,newLINE,newCOLUMN);
      
      movement.directionPREV := direction;
      movement.directionCUR  := direction;
      movement.distance      := 0;
      movement.flags         := movement.flags - MCStruct.PlayerMovementFlags {MCStruct.FindOpenArea..MCStruct.FindBreakLeft,MCStruct.MoveToTarget} + MCStruct.PlayerMovementFlags {MCStruct.MoveInDirection};
      
      IF variables.counters [MCStruct.BlindCOUNT] = 0 THEN
        SetDistanceMoveTerminationFlags (player,direction,newLINE,newCOLUMN,movement);
      END; (* IF *)
      
      INCL (variables.status,MCStruct.DistanceMoveFLAG);
    END; (* WITH *)
    
    MPMovement.MoveCharacterToLocation (player,newLINE,newCOLUMN);
    
    MStruct.CharacterTurnExecuted := TRUE;
  END InitializeDistanceMovement;
  
  PROCEDURE InitializeLocatedDistanceMovement (player : MStruct.PlayerInfoPointer; targetLINE : DStruct.DungeonLineRange; targetCOLUMN : DStruct.DungeonColumnRange);
  BEGIN (* InitializeLocatedDistanceMovement *)
    WITH player^.character^ DO
      movement.targetCOLUMN := targetCOLUMN;
      movement.targetLINE   := targetLINE;
      movement.flags        := movement.flags - MCStruct.PlayerMovementFlags {MCStruct.FindOpenArea..MCStruct.FindBreakLeft,MCStruct.MoveInDirection} + MCStruct.PlayerMovementFlags {MCStruct.MoveToTarget};
      
      INCL (variables.status,MCStruct.DistanceMoveFLAG);
    END; (* WITH *)
    
    UpdateDistanceMoveInformation (player,MIN (DStruct.DungeonLineRange),MIN (DStruct.DungeonColumnRange));
    
    IF MCStruct.DistanceMoveFLAG IN player^.character^.variables.status THEN
      MPMovement.MoveCharacterToLocation (player,player^.character^.movement.nextLINE,player^.character^.movement.nextCOLUMN);
    END; (* IF *)
  END InitializeLocatedDistanceMovement;
  
  PROCEDURE UpdateDistanceMoveInformation (player : MStruct.PlayerInfoPointer; prevLINE : DStruct.DungeonLineRange; prevCOLUMN : DStruct.DungeonColumnRange);
    PROCEDURE UpdateDirectionDistanceMoveInformation (player : MStruct.PlayerInfoPointer);
      VAR
          checkDIR,direction1,direction2 : CARDINAL;
          stopped                        : BOOLEAN;
      
      PROCEDURE DetermineMovementOptions (player : MStruct.PlayerInfoPointer; VAR movement : MCStruct.PlayerMovementInformation; VAR direction1,direction2 : CARDINAL; VAR checkDIR : CARDINAL; VAR stopped : BOOLEAN);
        VAR
            cursor,index : [-2..+3];
        
        PROCEDURE EvaluateDirectionOptions (player : MStruct.PlayerInfoPointer; VAR movement : MCStruct.PlayerMovementInformation; index : INTEGER; directionNEW,directionOLD : CARDINAL; VAR result1,result2 : CARDINAL; VAR checkDIR : CARDINAL; VAR stopped : BOOLEAN);
          VAR
              invisible : BOOLEAN;
              location  : DStruct.PhysicalDungeonUnit;
              column    : DStruct.DungeonColumnRange;
              line      : DStruct.DungeonLineRange;
          
          PROCEDURE CheckForOpenAreaStop (player : MStruct.PlayerInfoPointer; VAR movement : MCStruct.PlayerMovementInformation; index : INTEGER; VAR stopped : BOOLEAN);
          BEGIN (* CheckForOpenAreaStop *)
            IF index < 0 THEN
              IF MCStruct.FindBreakLeft IN movement.flags THEN
                stopped := TRUE;
              ELSE
                INCL (movement.flags,MCStruct.FindBreakRight);
              END; (* IF *)
            ELSIF index > 0 THEN
              IF MCStruct.FindBreakRight IN movement.flags THEN
                stopped := TRUE;
              ELSE
                INCL (movement.flags,MCStruct.FindBreakLeft);
              END; (* IF *)
            END; (* IF *)
          END CheckForOpenAreaStop;
          
          PROCEDURE DetermineNewDirectionInformation (player : MStruct.PlayerInfoPointer; VAR movement : MCStruct.PlayerMovementInformation; index : INTEGER; directionNEW,directionOLD : CARDINAL; VAR result1,result2 : CARDINAL; VAR checkDIR : CARDINAL; VAR stopped : BOOLEAN);
          BEGIN (* DetermineNewDirectionInformation *)
            IF MCStruct.FindOpenArea IN movement.flags THEN
              stopped := (((index < 0) AND (MCStruct.FindBreakRight IN movement.flags)) OR ((index > 0) AND (MCStruct.FindBreakLeft IN movement.flags)));
            ELSIF result1 = InvalidDirection THEN
              result1 := directionNEW;
            ELSIF result2 <> InvalidDirection THEN
              stopped := TRUE;
            ELSIF result1 <> movement.cycle [movement.chome [directionOLD] + index - 1] THEN
              stopped := TRUE;
            ELSIF ODD (directionNEW) THEN
              checkDIR := movement.cycle [movement.chome [directionOLD] + index - 2];
              result2  := directionNEW;
            ELSE
              checkDIR := movement.cycle [movement.chome [directionOLD] + index + 1];
              result2  := result1;
              result1  := directionNEW;
            END; (* IF *)
          END DetermineNewDirectionInformation;
          
          PROCEDURE ShouldStopForLocation (player : MStruct.PlayerInfoPointer; location : DStruct.PhysicalDungeonUnit) : BOOLEAN;
            PROCEDURE ShouldStopForArtifact (player : MStruct.PlayerInfoPointer; artifact : OStruct.InventoryItemRecord) : BOOLEAN;
            BEGIN (* ShouldStopForArtifact *)
              IF artifact.object.class <> OStruct.OpenDoor THEN
                RETURN ((artifact.object.class <> OStruct.InvisibleTrap) AND (artifact.object.class <> OStruct.SecretDoor));
              ELSE
                RETURN (NOT (MCStruct.FindIgnoreDoors IN player^.character^.movement.flags));
              END; (* IF *)
            END ShouldStopForArtifact;
            
          BEGIN (* ShouldStopForLocation *)
            IF ((location.creature = DStruct.InvalidCreatureCursor) OR NOT (player^.dungeon^.creatures [location.creature].visible)) THEN
              RETURN ((location.artifact <> DStruct.InvalidArtifactCursor) AND ShouldStopForArtifact (player,player^.dungeon^.artifacts [location.artifact]));
            ELSE
              RETURN (FALSE);
            END; (* IF *)
          END ShouldStopForLocation;
          
        BEGIN (* EvaluateDirectionOptions *)
          DSActions.DetermineDungeonLocation (player^.character^.line,player^.character^.column,directionNEW,line,column);
          
          location  := player^.dungeon^.physical [line]^ [column];
          invisible := NOT ((MCStruct.PlayerLightFLAG IN player^.character^.variables.status) OR (location.elements * DStruct.DungeonElementSet {DStruct.tlFLAG,DStruct.plFLAG,DStruct.fmFLAG} <> DStruct.EmptyDungeonElementSet));
          stopped   := (NOT (invisible) AND ShouldStopForLocation (player,location));
          
          IF (NOT (stopped) AND (invisible OR (location.elements * DStruct.DungeonFloorElements <> DStruct.EmptyDungeonElementSet))) THEN
            DetermineNewDirectionInformation (player,movement,index,directionNEW,directionOLD,result1,result2,checkDIR,stopped);
          ELSIF MCStruct.FindOpenArea IN movement.flags THEN
            CheckForOpenAreaStop (player,movement,index,stopped);
          END; (* IF *)
        END EvaluateDirectionOptions;
        
      BEGIN (* DetermineMovementOptions *)
        direction1 := InvalidDirection;
        direction2 := InvalidDirection;
        stopped    := FALSE;
        cursor     := ORD (ODD (movement.directionPREV)) + 1;
        index      := -cursor;
        
        REPEAT
          EvaluateDirectionOptions (player,movement,index,movement.cycle [movement.chome [movement.directionPREV] + index],movement.directionPREV,direction1,direction2,checkDIR,stopped);
          INC (index);
        UNTIL (stopped OR (index > cursor));
      END DetermineMovementOptions;
      
      PROCEDURE SelectNewDirection (player : MStruct.PlayerInfoPointer; VAR movement : MCStruct.PlayerMovementInformation; direction1,direction2 : CARDINAL; checkDIR : CARDINAL; VAR stopped : BOOLEAN);
        PROCEDURE EmptySymbolAtOffset (player : MStruct.PlayerInfoPointer; direction1,direction2 : CARDINAL; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange) : BOOLEAN;
        BEGIN (* EmptySymbolAtOffset *)
          DSActions.DetermineDungeonLocation (line,column,direction1,line,column);
          
          IF direction2 <> InvalidDirection THEN
            DSActions.DetermineDungeonLocation (line,column,direction2,line,column);
          END; (* IF *)
          
          RETURN (MDSymbols.DungeonSymbolForLocation (player,line,column) = ' ');
        END EmptySymbolAtOffset;
        
      BEGIN (* SelectNewDirection *)
        IF ((direction2 = InvalidDirection) OR (movement.flags * MCStruct.PlayerMovementFlags {MCStruct.FindExamine,MCStruct.FindCut} = MCStruct.PlayerMovementFlags {MCStruct.FindExamine})) THEN
          IF direction1 <> InvalidDirection THEN
            movement.directionCUR := direction1;
          END; (* IF *)
          
          IF direction2 = InvalidDirection THEN
            movement.directionPREV := direction1;
          ELSE
            movement.directionPREV := direction2;
          END; (* IF *)
        ELSIF NOT (WallSymbolAtOffset (player,direction1,direction1,player^.character^.line,player^.character^.column) AND WallSymbolAtOffset (player,direction1,checkDIR,player^.character^.line,player^.character^.column)) THEN
          IF ((MCStruct.FindExamine IN movement.flags) AND EmptySymbolAtOffset (player,direction1,direction1,player^.character^.line,player^.character^.column) AND EmptySymbolAtOffset (player,direction1,direction2,player^.character^.line,player^.character^.column)) THEN
            movement.directionPREV := direction2;
            movement.directionCUR  := direction1;
          ELSE
            stopped := TRUE;
          END; (* IF *)
        ELSIF MCStruct.FindCut IN movement.flags THEN
          movement.directionPREV := direction2;
          movement.directionCUR  := direction2;
        ELSE
          movement.directionPREV := direction2;
          movement.directionCUR  := direction1;
        END; (* IF *)
      END SelectNewDirection;
      
    BEGIN (* UpdateDistanceMoveInformation *)
      DetermineMovementOptions (player,player^.character^.movement,direction1,direction2,checkDIR,stopped);
      
      IF NOT (stopped OR (MCStruct.FindOpenArea IN player^.character^.movement.flags)) THEN
        SelectNewDirection (player,player^.character^.movement,direction1,direction2,checkDIR,stopped);
      END; (* IF *)
      
      IF stopped THEN
        EndDistanceMovement (player);
      END; (* IF *)
    END UpdateDirectionDistanceMoveInformation;
    
    PROCEDURE UpdateTargetDistanceMoveInformation (player : MStruct.PlayerInfoPointer; prevLINE : DStruct.DungeonLineRange; prevCOLUMN : DStruct.DungeonColumnRange);
      VAR
          table : MCMove2.MovementTable;
          index : CARDINAL;
          done  : BOOLEAN;
      
      PROCEDURE AttemptTargetMovement (player : MStruct.PlayerInfoPointer; direction : CARDINAL; VAR resultLINE : DStruct.DungeonLineRange; VAR resultCOLUMN : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
      BEGIN (* AttemptTargetMovement *)
        DSActions.DetermineDungeonLocation (player^.character^.line,player^.character^.column,direction,resultLINE,resultCOLUMN);
        done := (player^.dungeon^.physical [resultLINE]^ [resultCOLUMN].elements * (DStruct.DungeonWallElements + DStruct.DungeonElementSet {DStruct.BlockedFloor}) = DStruct.EmptyDungeonElementSet);
      END AttemptTargetMovement;
      
    BEGIN (* UpdateTargetDistanceMoveInformation *)
      MCMovement.DetermineNormalMovementTable (player^.character^.line,player^.character^.column,player^.character^.movement.targetLINE,player^.character^.movement.targetCOLUMN,table);
      
      index := 0;
      
      LOOP
        AttemptTargetMovement (player,table [index],player^.character^.movement.nextLINE,player^.character^.movement.nextCOLUMN,done);
        
        IF (done OR (index = MCMove2.NumberMovementDirections - 1)) THEN
          EXIT;
        END; (* IF *)
        
        INC (index);
      END; (* LOOP *)
      
      IF (NOT (done) OR ((player^.character^.movement.nextLINE = prevLINE) AND (player^.character^.movement.nextCOLUMN = prevCOLUMN))) THEN
        EndDistanceMovement (player);
      END; (* IF *)
    END UpdateTargetDistanceMoveInformation;
    
  BEGIN (* UpdateDisplayMoveInformation *)
    IF MCStruct.MoveInDirection IN player^.character^.movement.flags THEN
      UpdateDirectionDistanceMoveInformation (player);
    ELSIF ((player^.character^.line <> player^.character^.movement.targetLINE) OR (player^.character^.column <> player^.character^.movement.targetCOLUMN)) THEN
      UpdateTargetDistanceMoveInformation (player,prevLINE,prevCOLUMN);
    ELSE
      EndDistanceMovement (player);
    END; (* IF *)
  END UpdateDistanceMoveInformation;

  PROCEDURE WallSymbolAtOffset (player : MStruct.PlayerInfoPointer; direction1,direction2 : CARDINAL; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange) : BOOLEAN;
  BEGIN (* WallSymbolAtOffset *)
    DSActions.DetermineDungeonLocation (line,column,direction1,line,column);
    
    IF direction2 <> InvalidDirection THEN
      DSActions.DetermineDungeonLocation (line,column,direction2,line,column);
    END; (* IF *)
    
    RETURN (MDSymbols.DungeonSymbolForLocation (player,line,column) = DStruct.DungeonWallSymbol);
  END WallSymbolAtOffset;
END MDistMove.
