IMPLEMENTATION MODULE MDScrolling;
  (*/WIN:A*)
  
  IMPORT WMacro,WPainting,WScrolling,Windows;
  IMPORT MDPainting,MDWindow,MFonts,MStruct;
  IMPORT DStruct;
  
  
  PROCEDURE ExecuteHorizontalDungeonScroll (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL; position : CARDINAL);
    PROCEDURE ExecuteLineRightScroll (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
      VAR
          previous : INTEGER;
      
    BEGIN (* ExecuteLineRightScroll *)
      IF player^.dungeon^.firstCOLUMN < player^.dungeon^.columns - 1 THEN
        INC (player^.dungeon^.firstCOLUMN);
        
        WScrolling.SetScrollPos (window,Windows.SB_HORZ,player^.dungeon^.firstCOLUMN,TRUE,previous);
        ScrollDungeonWindow (window,-1,0);
      END; (* IF *)
    END ExecuteLineRightScroll;
    
    PROCEDURE ExecuteLineLeftScroll (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
      VAR
          previous : INTEGER;
      
    BEGIN (* ExecuteLineLeftScroll *)
      IF player^.dungeon^.firstCOLUMN > 0 THEN
        DEC (player^.dungeon^.firstCOLUMN);
        
        WScrolling.SetScrollPos (window,Windows.SB_HORZ,player^.dungeon^.firstCOLUMN,TRUE,previous);
        ScrollDungeonWindow (window,+1,0);
      END; (* IF *)
    END ExecuteLineLeftScroll;
    
    PROCEDURE ExecutePageLeftScroll (player : MStruct.PlayerInfoPointer);
    BEGIN (* ExecutePageLeftScroll *)
      IF player^.dungeon^.firstCOLUMN > 0 THEN
        player^.dungeon^.firstCOLUMN := WMacro.MaxInteger (player^.dungeon^.firstCOLUMN - MDWindow.CurrentDungeonWindowWidth (player),0);
        MDPainting.InvalidateDungeonWindow (player);
      END; (* IF *)
    END ExecutePageLeftScroll;
    
    PROCEDURE ExecutePageRightScroll (player : MStruct.PlayerInfoPointer);
      PROCEDURE FinalDungeonWindowColumn (player : MStruct.PlayerInfoPointer) : DStruct.DungeonColumnRange;
        VAR
            minX,maxX : DStruct.DungeonColumnRange;
            minY,maxY : DStruct.DungeonLineRange;
        
      BEGIN (* FinalDungeonWindowColumn *)
        MDWindow.DetermineDungeonWindowExtent (player,minX,maxX,minY,maxY,FALSE,FALSE);
        RETURN (maxX);
      END FinalDungeonWindowColumn;
      
    BEGIN (* ExecutePageRightScroll *)
      IF player^.dungeon^.firstCOLUMN < player^.dungeon^.columns - 1 THEN
        player^.dungeon^.firstCOLUMN := WMacro.MinInteger (FinalDungeonWindowColumn (player),player^.dungeon^.columns - 1);
        MDPainting.InvalidateDungeonWindow (player);
      END; (* IF *)
    END ExecutePageRightScroll;
    
    PROCEDURE ExecuteThumbPositionScroll (window : Windows.HWND; player : MStruct.PlayerInfoPointer; position : CARDINAL);
      VAR
          previous : INTEGER;
      
    BEGIN (* ExecuteThumbPositionScroll *)
      player^.dungeon^.firstCOLUMN := position;
      
      WScrolling.SetScrollPos (window,Windows.SB_HORZ,position,TRUE,previous);
      WPainting.InvalidateEntireWindow (window,TRUE);
    END ExecuteThumbPositionScroll;
    
  BEGIN (* ExecuteHorizontalDungeonScroll *)
    CASE command OF
      Windows.SB_LINERIGHT : ExecuteLineRightScroll (window,player); |
      Windows.SB_PAGERIGHT : ExecutePageRightScroll (player);        |
      Windows.SB_LINELEFT  : ExecuteLineLeftScroll (window,player);  |
      Windows.SB_PAGELEFT  : ExecutePageLeftScroll (player);         |
      
      Windows.SB_THUMBPOSITION : ExecuteThumbPositionScroll (window,player,position); |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteHorizontalDungeonScroll;
  
  PROCEDURE ExecuteVerticalDungeonScroll (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL; position : CARDINAL);
    PROCEDURE ExecuteLineDownScroll (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
      VAR
          previous : INTEGER;
      
    BEGIN (* ExecuteLineDownScroll *)
      IF player^.dungeon^.firstLINE < player^.dungeon^.lines - 1 THEN
        INC (player^.dungeon^.firstLINE);
        
        WScrolling.SetScrollPos (window,Windows.SB_VERT,player^.dungeon^.firstLINE,TRUE,previous);
        ScrollDungeonWindow (window,0,-1);
      END; (* IF *)
    END ExecuteLineDownScroll;
    
    PROCEDURE ExecuteLineUpScroll (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
      VAR
          previous : INTEGER;
      
    BEGIN (* ExecuteLineUpScroll *)
      IF player^.dungeon^.firstLINE > 0 THEN
        DEC (player^.dungeon^.firstLINE);
        
        WScrolling.SetScrollPos (window,Windows.SB_VERT,player^.dungeon^.firstLINE,TRUE,previous);
        ScrollDungeonWindow (window,0,+1);
      END; (* IF *)
    END ExecuteLineUpScroll;
    
    PROCEDURE ExecutePageDownScroll (player : MStruct.PlayerInfoPointer);
      PROCEDURE FinalDungeonWindowLine (player : MStruct.PlayerInfoPointer) : DStruct.DungeonLineRange;
        VAR
            minX,maxX : DStruct.DungeonColumnRange;
            minY,maxY : DStruct.DungeonLineRange;
        
      BEGIN (* FinalDungeonWindowLine *)
        MDWindow.DetermineDungeonWindowExtent (player,minX,maxX,minY,maxY,FALSE,FALSE);
        RETURN (maxY);
      END FinalDungeonWindowLine;
      
    BEGIN (* ExecutePageDownScroll *)
      IF player^.dungeon^.firstLINE < player^.dungeon^.lines - 1 THEN
        player^.dungeon^.firstLINE := WMacro.MinInteger (FinalDungeonWindowLine (player),player^.dungeon^.lines - 1);
        MDPainting.InvalidateDungeonWindow (player);
      END; (* IF *)
    END ExecutePageDownScroll;
    
    PROCEDURE ExecutePageUpScroll (player : MStruct.PlayerInfoPointer);
    BEGIN (* ExecutePageUpScroll *)
      IF player^.dungeon^.firstLINE > 0 THEN
        player^.dungeon^.firstLINE := WMacro.MaxInteger (player^.dungeon^.firstLINE - MDWindow.CurrentDungeonWindowHeight (player),0);
        MDPainting.InvalidateDungeonWindow (player);
      END; (* IF *)
    END ExecutePageUpScroll;
    
    PROCEDURE ExecuteThumbPositionScroll (window : Windows.HWND; player : MStruct.PlayerInfoPointer; position : CARDINAL);
      VAR
          previous : INTEGER;
      
    BEGIN (* ExecuteThumbPositionScroll *)
      player^.dungeon^.firstLINE := position;
      
      WScrolling.SetScrollPos (window,Windows.SB_VERT,position,TRUE,previous);
      WPainting.InvalidateEntireWindow (window,TRUE);
    END ExecuteThumbPositionScroll;
    
  BEGIN (* ExecuteVerticalDungeonScroll *)
    CASE command OF
      Windows.SB_LINEDOWN : ExecuteLineDownScroll (window,player); |
      Windows.SB_PAGEDOWN : ExecutePageDownScroll (player);        |
      Windows.SB_LINEUP   : ExecuteLineUpScroll (window,player);   |
      Windows.SB_PAGEUP   : ExecutePageUpScroll (player);          |
      
      Windows.SB_THUMBPOSITION : ExecuteThumbPositionScroll (window,player,position); |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteVerticalDungeonScroll;
  
  PROCEDURE ResetDungeonScrollBars (player : MStruct.PlayerInfoPointer);
    VAR
        previous : INTEGER;
    
  BEGIN (* ResetDungeonScrollBars *)
    WScrolling.SetScrollRange (player^.windows.dungeon,Windows.SB_HORZ,0,player^.dungeon^.columns - 1,FALSE);
    WScrolling.SetScrollRange (player^.windows.dungeon,Windows.SB_VERT,0,player^.dungeon^.lines - 1,FALSE);
    
    WScrolling.SetScrollPos (player^.windows.dungeon,Windows.SB_HORZ,player^.dungeon^.firstCOLUMN,TRUE,previous);
    WScrolling.SetScrollPos (player^.windows.dungeon,Windows.SB_VERT,player^.dungeon^.firstLINE,TRUE,previous);
  END ResetDungeonScrollBars;

  PROCEDURE ScrollDungeonWindow (window : Windows.HWND; deltaX,deltaY : INTEGER);
    VAR
        height,width : INTEGER;
    
  BEGIN (* ScrollDungeonWindow *)
    MFonts.DetermineWindowCharacterMetrics (window,MDPainting.DungeonWindowFont,height,width);
    WScrolling.ScrollEntireWindow (window,deltaX * width,deltaY * height);
  END ScrollDungeonWindow;
END MDScrolling.
