IMPLEMENTATION MODULE MFiles;
  (*/WIN:A*)
  
  IMPORT MCGenerator,MMenu,MMWindow,MOpen,MOpen2,MSave,MSWindow;
  IMPORT WCreation,WCursor,Windows,WinFiles;
  IMPORT MSActions,MSActs2,OSActions;
  IMPORT MCStruct,MStruct;
  IMPORT Strings;
  
  
  PROCEDURE ExecuteCloseAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
    VAR
        cancel : BOOLEAN;
        done   : BOOLEAN;
    
  BEGIN (* ExecuteCloseAction *)
    IF player <> NIL THEN
      OptionallySaveCharacter (player,cancel);
    ELSE
      cancel := FALSE;
    END; (* IF *)
    
    IF NOT (cancel) THEN
      WCreation.DestroyWindow (window,done);
      MStruct.CurrentCharacterQuit := TRUE;
    END; (* IF *)
  END ExecuteCloseAction;
  
  PROCEDURE ExecuteExitCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteExitCommand *)
    ExecuteCloseAction (MStruct.CurrentPlayerFrameWindow,player);
  END ExecuteExitCommand;
  
  PROCEDURE ExecuteNewCommand (window : Windows.HWND; VAR player : MStruct.PlayerInfoPointer);
    VAR
        cancel : BOOLEAN;
    
  BEGIN (* ExecuteNewCommand *)
    IF player <> NIL THEN
      OptionallySaveCharacter (player,cancel);
      
      IF NOT (cancel) THEN
        MSActions.DeallocateCharacterInformation (player);
      END; (* IF *)
    ELSE
      cancel := FALSE;
    END; (* IF *)
    
    IF NOT (cancel) THEN
      MCGenerator.GenerateNewCharacter (window,player);
      MMenu.SetStandardMenu (player);
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteNewCommand;
  
  PROCEDURE ExecuteOpenCommand (window : Windows.HWND; VAR player : MStruct.PlayerInfoPointer);
    VAR
        cancel : BOOLEAN;
        done   : BOOLEAN;
    
  BEGIN (* ExecuteOpenCommand *)
    IF player <> NIL THEN
      OptionallySaveCharacter (player,cancel);
      
      IF NOT (cancel) THEN
        MSActions.DeallocateCharacterInformation (player);
      END; (* IF *)
    ELSE
      cancel := FALSE;
    END; (* IF *)
    
    IF NOT (cancel) THEN
      MOpen.LoadCharacterInformation (window,player,done);
      
      IF done THEN
        MMenu.SetStandardMenu (player);
      ELSE
        MSActions.DeallocateCharacterInformation (player);
      END; (* IF *)
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteOpenCommand;
  
  PROCEDURE ExecuteQuitCommand (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteQuitCommand *)
    IF MMWindow.QueryYesNo (player^.windows.frame,player,"Really quit without saving character?",TRUE) THEN
      WCreation.DestroyWindow (player^.windows.frame,done);
      
      MStruct.CharacterTurnExecuted := TRUE;
      MStruct.CurrentCharacterQuit  := TRUE;
    END; (* IF *)
  END ExecuteQuitCommand;
  
  PROCEDURE ExecuteSaveCommand (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteSaveCommand *)
    MSave.SaveCharacterInformation (player,done);
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteSaveCommand;
  
  PROCEDURE ExecuteSaveAsCommand (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteSaveAsCommand *)
    MSave.DeterminePlayerSaveFileName (player,done);
    
    IF done THEN
      MSave.SaveCharacterInformation (player,done);
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteSaveAsCommand;
  
  PROCEDURE LoadInitialCharacter (window : Windows.HWND; VAR player : MStruct.PlayerInfoPointer; file : CommandTailPointer);
    VAR
        previous : Windows.HCURSOR;
        done     : BOOLEAN;
    
  BEGIN (* LoadInitialCharacter *)
    WCursor.SetCursor (WCursor.StandardCursorHandle (Windows.IDC_WAIT),previous);
    
    MSActions.AllocateCharacterInformation (player);
    Strings.Assign (file^,player^.fileNAME);
    player^.windows.frame := window;
    
    MOpen2.InputPlayerInformationFile (player,done);
    
    IF done THEN
      OSActions.InitializeObjectNames (player^.treasures^,player^.treasures^.seed);
      MSActs2.InitializeGamingWindows (window,player);
      
      MSWindow.SetMainWindowTitle (player^.windows.frame,player);
      MMenu.SetStandardMenu (player);
    ELSE
      MSActions.DeallocateCharacterInformation (player);
    END; (* IF *)
    
    WCursor.SetCursor (previous,previous);
  END LoadInitialCharacter;

  PROCEDURE OptionallySaveCharacter (player : MStruct.PlayerInfoPointer; VAR cancel : BOOLEAN);
    VAR
        accept : BOOLEAN;
        done   : BOOLEAN;
    
  BEGIN (* OptionallySaveCharacter *)
    MMWindow.QueryYesNoCancel (player^.windows.frame,player,"Save current character?",accept,cancel);
    
    IF accept THEN
      MSave.SaveCharacterInformation (player,done);
      cancel := NOT (done);
    END; (* IF *)
  END OptionallySaveCharacter;
  
  PROCEDURE ShouldLoadInitialCharacter (file : CommandTailPointer) : BOOLEAN;
    VAR
        message : ARRAY [0..255] OF CHAR;
    
  BEGIN (* ShouldLoadInitialCharacter *)
    IF Strings.Length (file^) = 0 THEN
      RETURN (FALSE);
    ELSIF WinFiles.FileExists (file^) THEN
      RETURN (TRUE);
    ELSE
      Strings.Concat ("Unable to find character file: ",file^,message);
      MMWindow.DisplayPopupMessage (MStruct.CurrentPlayerFrameWindow,NIL,message);
      
      RETURN (FALSE);
    END; (* IF *)
  END ShouldLoadInitialCharacter;
END MFiles.
