IMPLEMENTATION MODULE MFonts;
  (*/WIN:A*)
  
  IMPORT WDContext,WDebugging,WDTool,Windows,WMacro,WText;
  
  
  PROCEDURE DetermineContextCharacterMetrics (context : Windows.HDC; VAR height : INTEGER; VAR width : INTEGER);
    VAR
        metrics : Windows.TEXTMETRIC;
        done    : BOOLEAN;
    
  BEGIN (* DetermineContextCharacterMetrics *)
    WText.GetTextMetrics (context,metrics,done);
    
    IF NOT (done) THEN
      WDebugging.FatalAppExit ("Unable to get text metrics for Dungeon window.");
    END; (* IF *)
    
    height := metrics.tmExternalLeading + metrics.tmHeight;
    width  := metrics.tmAveCharWidth;
  END DetermineContextCharacterMetrics;
  
  PROCEDURE DetermineWindowCharacterMetrics (window : Windows.HWND; font : INTEGER; VAR height,width : INTEGER);
    VAR
        previous : Windows.HGDIOBJ;
        context  : Windows.HDC;
        done     : BOOLEAN;
    
  BEGIN (* DetermineWindowCharacterMetrics *)
    context := WDContext.GetDC (window);
    
    WDTool.SelectObject (context,WDTool.GetStockObject (font),previous);
        
    DetermineContextCharacterMetrics (context,height,width);
    WDContext.ReleaseDC (window,context,done);
  END DetermineWindowCharacterMetrics;
  
  PROCEDURE StockFontHandle (font : INTEGER) : Windows.HFONT;
  BEGIN (* StockFontHandle *)
    RETURN (WDTool.GetStockObject (font));
  END StockFontHandle;

  PROCEDURE WindowTextStringWidth (window : Windows.HWND; text : ARRAY OF CHAR) : CARDINAL;
    VAR
        context : Windows.HDC;
        height  : CARDINAL;
        extent  : CARDINAL;
        done    : BOOLEAN;
    
  BEGIN (* WindowTextStringWidth *)
    context := WDContext.GetDC (window);
    
    WText.GetTextExtent (context,text,height,extent);
    WDContext.ReleaseDC (window,context,done);
    
    IF NOT (done) THEN
      HALT;
    END; (* IF *)
    
    RETURN (extent);
  END WindowTextStringWidth;
END MFonts.
