IMPLEMENTATION MODULE MFoods;
  (*/WIN:A*)
  
  IMPORT MDPainting,MDWindow,MInventory,MISelect,MMWindow,MPDamage,MRandom,MSpells,MSpells2,MSUpdate;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT WDebugging,WMacro;
  IMPORT MSActs2,OSActions;
  
  
  TYPE
       FoodAttributeRange = [0..26];
  
  VAR
      ExecuteFoodAction : ARRAY FoodAttributeRange OF PROCEDURE (MStruct.PlayerInfoPointer,OStruct.InventoryItemRecord,VAR BOOLEAN);
      
  
  PROCEDURE AddNutritionValue (player : MStruct.PlayerInfoPointer; value : INTEGER);
    CONST
          MaximumPlayerFoodValue = 15000;
          FullPlayerFoodValue    = 10000;
    
    VAR
        penalty : INTEGER;
    
  BEGIN (* AddNutritionValue *)
    player^.character^.variables.food := WMacro.MaxInteger (player^.character^.variables.food,0) + value;
    
    IF player^.character^.variables.food > MaximumPlayerFoodValue THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are bloated from overeating.");
      
      penalty                           := WMacro.MinInteger (player^.character^.variables.food - MaximumPlayerFoodValue,value) DIV 50;
      player^.character^.variables.food := MaximumPlayerFoodValue + penalty;
      
      INC (player^.character^.variables.counters [MCStruct.SlowCOUNT],penalty);
    ELSIF player^.character^.variables.food > FullPlayerFoodValue THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are full.");
    END; (* IF *)
    
    EXCL (player^.character^.variables.status,MCStruct.HungryFLAG);
    EXCL (player^.character^.variables.status,MCStruct.WeakFLAG);
    
    MSUpdate.UpdateHungerStatusWindow (player);
  END AddNutritionValue;
  
  PROCEDURE ExecuteEatCommand (player : MStruct.PlayerInfoPointer);
    VAR
        position : CARDINAL;
    
    PROCEDURE ExecuteFoodActions (player : MStruct.PlayerInfoPointer; food : OStruct.InventoryItemRecord; position : CARDINAL);
      VAR
          deleted : BOOLEAN;
      
      PROCEDURE ExecuteMagicFoodActions (player : MStruct.PlayerInfoPointer; food : OStruct.InventoryItemRecord; VAR position : CARDINAL);
        VAR
            identified : BOOLEAN;
            index      : FoodAttributeRange;
        
      BEGIN (* ExecuteMagicFoodActions *)
        identified := FALSE;
        
        FOR index := MIN (FoodAttributeRange) TO MAX (FoodAttributeRange) DO
          IF VAL (OStruct.ObjectAttributeMnemonic,index) IN food.object.attributes THEN
            ExecuteFoodAction [index] (player,food,identified);
          END; (* IF *)
        END; (* FOR *)
        
        IF NOT (OSActions.InventoryItemIsKnown1 (player^.treasures,food)) THEN
          IF identified THEN
            MSpells2.IdentifyPlayerInventoryItem (player,position);
            MSActs2.IncreasePlayerExperience (player,(FLOAT (food.object.depth) + player^.character^.variables.experCUR / 2.0) / player^.character^.variables.experCUR);
          ELSE
            OSActions.SampleInventoryItem (player^.treasures,food);
          END; (* IF *)
        END; (* IF *)
      END ExecuteMagicFoodActions;
      
    BEGIN (* ExecuteFoodActions *)
      ExecuteMagicFoodActions (player,food,position);
      
      OSActions.DescribeRemainingObjectQuantity (player,player^.character^.inventory.backpack [position]);
      MInventory.DecrementInventoryItemQuantity (player,position,deleted);
      
      AddNutritionValue (player,food.object.miscellaneous);
    END ExecuteFoodActions;
    
  BEGIN (* ExecuteEatCommand *)
    MStruct.CharacterTurnExecuted := MInventory.AnyObjectsWithClasses (player^.character^.inventory.backpack,OStruct.ObjectClassSet {OStruct.Food});
    
    IF MStruct.CharacterTurnExecuted THEN
      MISelect.SelectInventoryItem (player,"Eat what?",OStruct.ObjectClassSet {OStruct.Food},position,MStruct.CharacterTurnExecuted);
      
      IF MStruct.CharacterTurnExecuted THEN
        ExecuteFoodActions (player,player^.character^.inventory.backpack [position],position);
      END; (* IF *)
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are not carrying any food.");
    END; (* IF *)
  END ExecuteEatCommand;
  
  
  
  PROCEDURE ExecuteBlindnessAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
  BEGIN (* ExecuteBlindnessAction *)
    INC (player^.character^.variables.counters [MCStruct.BlindCOUNT],MRandom.CardinalRandomRangeValue (1,250) + 100 + 10 * item.object.depth);
    
    MDPainting.InvalidateDungeonWindow (player);
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A veil of darkness surrounds you.");
    
    identified := TRUE;
  END ExecuteBlindnessAction;
  
  PROCEDURE ExecuteBoldnessAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
  BEGIN (* ExecuteBoldnessAction *)
    IF player^.character^.variables.counters [MCStruct.AfraidCOUNT] > 1 THEN
      player^.character^.variables.counters [MCStruct.AfraidCOUNT] := 1;
      identified                                                   := TRUE;
    END; (* IF *)
  END ExecuteBoldnessAction;
  
  PROCEDURE ExecuteConfusionAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
  BEGIN (* ExecuteConfusionAction *)
    INC (player^.character^.variables.counters [MCStruct.ConfusedCOUNT],MRandom.CardinalRandomRangeValue (1,10) + item.object.depth);
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel drugged.");
    
    identified := TRUE;
  END ExecuteConfusionAction;
  
  PROCEDURE ExecuteCureBlindnessAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteCureBlindnessAction *)
    MSpells2.CureBlindness (player,done);
    identified := (identified OR done);
  END ExecuteCureBlindnessAction;
  
  PROCEDURE ExecuteCureConfusionAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteCureConfusionAction *)
    MSpells2.CureConfusion (player,done);
    identified := (identified OR done);
  END ExecuteCureConfusionAction;
  
  PROCEDURE ExecuteCurePoisonAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteCurePoisonAction *)
    MSpells2.CurePoison (player,done);
    identified := (identified OR done);
  END ExecuteCurePoisonAction;
  
  PROCEDURE ExecuteFearAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
  BEGIN (* ExecuteFearAction *)
    INC (player^.character^.variables.counters [MCStruct.AfraidCOUNT],MRandom.CardinalRandomRangeValue (1,10) + item.object.depth);
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel terrified!");
    
    identified := TRUE;
  END ExecuteFearAction;
  
  PROCEDURE ExecuteFirstAidAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteFirstAidAction *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (1,6),done);
    identified := (identified OR done);
  END ExecuteFirstAidAction;
  
  PROCEDURE ExecuteHallucinationAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
  BEGIN (* ExecuteHallucinationAction *)
    INC (player^.character^.variables.counters [MCStruct.ImageCOUNT],MRandom.CardinalRandomRangeValue (1,200) + 25 * item.object.depth + 200);
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel drugded.");
    
    identified := TRUE;
  END ExecuteHallucinationAction;
  
  PROCEDURE ExecuteLightCuresAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteLightCuresAction *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (1,18),done);
    identified := (identified OR done);
  END ExecuteLightCuresAction;
  
  PROCEDURE ExecuteMinorCuresAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteMinorCuresAction *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (1,12),done);
    identified := (identified OR done);
  END ExecuteMinorCuresAction;
  
  PROCEDURE ExecutePoisonAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
  BEGIN (* ExecutePoisonAction *)
    INC (player^.character^.variables.counters [MCStruct.PoisonedCOUNT],MRandom.CardinalRandomRangeValue (1,10) + item.object.depth);
    identified := TRUE;
  END ExecutePoisonAction;
  
  PROCEDURE ExecutePoisonConstitutionAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
  BEGIN (* ExecutePoisonConstitutionAction *)
    MSpells2.DecreasePlayerConstitution (player);
    identified := TRUE;
  END ExecutePoisonConstitutionAction;
  
  PROCEDURE ExecutePoisonStrengthAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
  BEGIN (* ExecutePoisonStrengthAction *)
    MSpells2.DecreasePlayerStrength (player);
    identified := TRUE;
  END ExecutePoisonStrengthAction;
  
  PROCEDURE ExecuteRestoreCharismaAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoreCharismaAction *)
    MSActs2.RestoreStatisticToMaximum (player,MCStruct.chr,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Your skin stops itching.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteRestoreCharismaAction;
  
  PROCEDURE ExecuteRestoreConstitutionAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoreConstitutionAction *)
    MSActs2.RestoreStatisticToMaximum (player,MCStruct.con,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel your health returning.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteRestoreConstitutionAction;
  
  PROCEDURE ExecuteRestoreDexterityAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoreDexterityAction *)
    MSActs2.RestoreStatisticToMaximum (player,MCStruct.dex,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel more dexterous.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteRestoreDexterityAction;
  
  PROCEDURE ExecuteRestoreIntelligenceAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoreIntelligenceAction *)
    MSActs2.RestoreStatisticToMaximum (player,MCStruct.int,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Your head spins for a moment.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteRestoreIntelligenceAction;
  
  PROCEDURE ExecuteRestoreStrengthAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoreStrengthAction *)
    MSActs2.RestoreStatisticToMaximum (player,MCStruct.str,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel your strength returning.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteRestoreStrengthAction;
  
  PROCEDURE ExecuteRestoreWisdomAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoreWisdomAction *)
    MSActs2.RestoreStatisticToMaximum (player,MCStruct.wis,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel your wisdom returning.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteRestoreWisdomAction;
  
  PROCEDURE ExecuteRestoringAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoringAction *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (3,36),done);
    identified := (identified OR done);
  END ExecuteRestoringAction;
  
  PROCEDURE ExecuteUnhealthAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
  BEGIN (* ExecuteUnhealthAction *)
    MPDamage.ReduceCharacterHitPoints (player,MRandom.CardinalRandomRangeValue (1,18),"poisonous food.");
    identified := TRUE;
  END ExecuteUnhealthAction;
  
  PROCEDURE InitializeExecuteFoodActionTable;
    VAR
        index : FoodAttributeRange;
    
  BEGIN (* InitializeExecuteFoodActionTable *)
    FOR index := MIN (FoodAttributeRange) TO MAX (FoodAttributeRange) DO
      ExecuteFoodAction [index] := InvalidFoodAction;
    END; (* FOR *)
    
    ExecuteFoodAction [0]  := ExecutePoisonAction;
    ExecuteFoodAction [1]  := ExecuteBlindnessAction;
    ExecuteFoodAction [2]  := ExecuteFearAction;
    ExecuteFoodAction [3]  := ExecuteConfusionAction;
    ExecuteFoodAction [4]  := ExecuteHallucinationAction;
    ExecuteFoodAction [5]  := ExecuteCurePoisonAction;
    ExecuteFoodAction [6]  := ExecuteCureBlindnessAction;
    ExecuteFoodAction [7]  := ExecuteBoldnessAction;
    ExecuteFoodAction [8]  := ExecuteCureConfusionAction;
    ExecuteFoodAction [9]  := ExecutePoisonStrengthAction;
    ExecuteFoodAction [10] := ExecutePoisonConstitutionAction;
    ExecuteFoodAction [15] := ExecuteRestoreStrengthAction;
    ExecuteFoodAction [16] := ExecuteRestoreConstitutionAction;
    ExecuteFoodAction [17] := ExecuteRestoreIntelligenceAction;
    ExecuteFoodAction [18] := ExecuteRestoreWisdomAction;
    ExecuteFoodAction [19] := ExecuteRestoreDexterityAction;
    ExecuteFoodAction [20] := ExecuteRestoreCharismaAction;
    ExecuteFoodAction [21] := ExecuteFirstAidAction;
    ExecuteFoodAction [22] := ExecuteMinorCuresAction;
    ExecuteFoodAction [23] := ExecuteLightCuresAction;
    ExecuteFoodAction [25] := ExecuteRestoringAction;
    ExecuteFoodAction [26] := ExecuteUnhealthAction;
  END InitializeExecuteFoodActionTable;
  
  PROCEDURE InvalidFoodAction (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
  BEGIN (* InvalidFoodAction *)
    WDebugging.FatalAppExit ("Call to un-initialized food action procedure.");
  END InvalidFoodAction;

BEGIN (* MFoods *)
  InitializeExecuteFoodActionTable;
END MFoods.
