IMPLEMENTATION MODULE MHSDialog;
  (*/WIN:A*)
  
  FROM WMemory IMPORT ALLOCATE,DEALLOCATE;
  
  IMPORT WDebugging,WDialog,Windows,WListBox,WString;
  IMPORT MDialogs,MScores;
  IMPORT MCStruct,MStruct;
  IMPORT ASCII,Strings;
  IMPORT MCSActs2;
  
  
  PROCEDURE CloseHighScoreDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* CloseHighScoreDialog *)
    ExecuteHighScoreCommand (window,player,0,Windows.BN_CLICKED);
  END CloseHighScoreDialog;
  
  PROCEDURE ExecuteHighScoresDialog (window : Windows.HWND);
    VAR
        result : INTEGER;
    
  BEGIN (* ExecuteHighScoresDialog *)
    MDialogs.ExecuteMoriaDialogBox (window,"High_Score_Dialog",NIL,InitializeHighScoreDialog,ExecuteHighScoreCommand,CloseHighScoreDialog,result);
  END ExecuteHighScoresDialog;
  
  PROCEDURE ExecuteHighScoreCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; command : CARDINAL);
  BEGIN (* ExecuteHighScoreCommand *)
    IF command = Windows.BN_CLICKED THEN
      WDialog.EndDialog (window,Windows.TRUE_BOOL);
    END; (* IF *)
  END ExecuteHighScoreCommand;
  
  PROCEDURE InitializeHighScoreDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
    CONST
          ScoreTableListBox = 901;
    
    VAR
        table : MScores.MoriaScoreTablePointer;
        name  : ARRAY [0..127] OF CHAR;
    
    PROCEDURE InitializeScoreListBox (control : Windows.HWND; VAR table : ARRAY OF MScores.MoriaScoreEntry);
      VAR
          index : CARDINAL;
      
      PROCEDURE AddMoriaScoreEntryToListBox (control : Windows.HWND; rank : CARDINAL; entry : MScores.MoriaScoreEntry);
        VAR
            position : Windows.LRESULT;
            text     : ARRAY [0..127] OF CHAR;
        
        PROCEDURE ReplaceClassParameter (text : ARRAY OF CHAR; formal : ARRAY OF CHAR; actual : MCStruct.PlayerClassMnemonic; VAR result : ARRAY OF CHAR);
          VAR
              temp : ARRAY [0..31] OF CHAR;
          
        BEGIN (* ReplaceClassParameter *)
          MCSActs2.ReturnClassMnemonicString (actual,temp);
          WString.ReplaceStringParameter (text,formal,temp,result);
        END ReplaceClassParameter;
        
        PROCEDURE ReplaceRaceParameter (text : ARRAY OF CHAR; formal : ARRAY OF CHAR; actual : MCStruct.PlayerRaceMnemonic; VAR result : ARRAY OF CHAR);
          VAR
              temp : ARRAY [0..31] OF CHAR;
          
        BEGIN (* ReplaceRaceParameter *)
          MCSActs2.ReturnRaceMnemonicString (actual,temp);
          WString.ReplaceStringParameter (text,formal,temp,result);
        END ReplaceRaceParameter;
        
        PROCEDURE ReplaceSexParameter (text : ARRAY OF CHAR; formal : ARRAY OF CHAR; actual : MCStruct.PlayerSexMnemonic; VAR result : ARRAY OF CHAR);
        BEGIN (* ReplaceSexParameter *)
          IF actual = MCStruct.Female THEN
            WString.ReplaceStringParameter (text,formal,"F",result);
          ELSE
            WString.ReplaceStringParameter (text,formal,"M",result);
          END; (* IF *)
        END ReplaceSexParameter;
        
      BEGIN (* AddMoriaScoreEntryToListBox *)
        WString.ReplaceCardinalParameter ("%RANK|%POINTS|%NAME|%SEX|%RACE|%CLASS|%LVL|%KILLER","%RANK",rank,text);
        WString.ReplaceCardinalParameter (text,"%LVL",entry.level,text);
        
        WString.ReplaceLongIntParameter (text,"%POINTS",entry.points,text);
        
        WString.ReplaceStringParameter (text,"%KILLER",entry.killer,text);
        WString.ReplaceStringParameter (text,"%NAME",entry.name,text);
        
        ReplaceClassParameter (text,"%CLASS",entry.class,text);
        ReplaceRaceParameter (text,"%RACE",entry.race,text);
        ReplaceSexParameter (text,"%SEX",entry.sex,text);
        
        WString.ReplaceCharParameter (text,"|",ASCII.ht,text);
        
        WListBox.AddString (control,text,position);
      END AddMoriaScoreEntryToListBox;
      
      PROCEDURE InitializeTabStops (control : Windows.HWND);
        CONST
              NumberTabStops = 7;
        
        VAR
            tabs : ARRAY [0..NumberTabStops - 1] OF INTEGER;
            done : BOOLEAN;
        
      BEGIN (* InitializeTabStops *)
        tabs [0] :=  6 * WListBox.DialogUnitsPerCharacter;
        tabs [1] := 13 * WListBox.DialogUnitsPerCharacter;
        tabs [2] := 31 * WListBox.DialogUnitsPerCharacter;
        tabs [3] := 35 * WListBox.DialogUnitsPerCharacter;
        tabs [4] := 45 * WListBox.DialogUnitsPerCharacter;
        tabs [5] := 54 * WListBox.DialogUnitsPerCharacter;
        tabs [6] := 62 * WListBox.DialogUnitsPerCharacter;
        
        WListBox.SetTabStops (control,NumberTabStops,tabs,done);
        
        IF NOT (done) THEN
          WDebugging.FatalAppExit ("Unable to set high scores list box tab stops.");
        END; (* IF *)
      END InitializeTabStops;
      
    BEGIN (* InitializeScoreListBox *)
      InitializeTabStops (control);
      
      index := 0;
      
      WHILE ((index <= HIGH (table)) AND (Strings.Length (table [index].killer) > 0)) DO
        AddMoriaScoreEntryToListBox (control,index + 1,table [index]);
        INC (index);
      END; (* WHILE *)
    END InitializeScoreListBox;
    
  BEGIN (* InitializeHighScoreDialog *)
    NEW (table);
    
    MScores.LoadMoriaScoreTable (window,name,table^);
    
    InitializeScoreListBox (WDialog.GetDlgItem (window,ScoreTableListBox),table^);
    
    DISPOSE (table);
  END InitializeHighScoreDialog;
END MHSDialog.
