IMPLEMENTATION MODULE MIDamage;
  (*/WIN:A*)
  
  IMPORT MInventory,MRandom,MMWindow,ODescriptions;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT MCSActions,OSActions;
  
  
  PROCEDURE DamageRandomArmorObject (player : MStruct.PlayerInfoPointer; resistance : OStruct.ObjectAttributeMnemonic; VAR damaged : BOOLEAN);
    VAR
        position : MCStruct.PlayerEquipmentMnemonic;
    
    PROCEDURE DamageEquipmentArmor (player : MStruct.PlayerInfoPointer; resistance : OStruct.ObjectAttributeMnemonic; VAR item : OStruct.InventoryItemRecord; VAR damaged : BOOLEAN);
    BEGIN (* DamageEquipmentArmor *)
      IF resistance IN item.object.attributes THEN
        OSActions.DisplayObjectMessage (player^.windows.frame,player,"Your %OBJECT resists damage!","%OBJECT",item,FALSE,TRUE);
        damaged := FALSE;
      ELSIF item.object.armor + item.object.armorMOD > 0 THEN
        OSActions.DisplayObjectMessage (player^.windows.frame,player,"Your %OBJECT is damaged!","%OBJECT",item,FALSE,TRUE);
        
        item.object.armorMOD := item.object.armorMOD - 1;
        damaged              := TRUE;
        
        MCSActions.CalculatePlayerBonuses (player^.character);
      ELSE
        damaged := FALSE;
      END; (* IF *)
    END DamageEquipmentArmor;
    
    PROCEDURE SelectRandomEquipmentArmor (player : MStruct.PlayerInfoPointer; VAR position : MCStruct.PlayerEquipmentMnemonic; VAR done : BOOLEAN);
      VAR
          number : CARDINAL;
          table  : ARRAY [0..5] OF MCStruct.PlayerEquipmentMnemonic;
      
      PROCEDURE DetermineCurrentArmorEquipment (player : MStruct.PlayerInfoPointer; VAR table : ARRAY OF MCStruct.PlayerEquipmentMnemonic; VAR number : CARDINAL);
        TYPE
             PlayerEquipmentSet = SET OF MCStruct.PlayerEquipmentMnemonic;
        
        CONST
              ArmorEquipment = PlayerEquipmentSet {MCStruct.Body,MCStruct.Arm,MCStruct.Outer,MCStruct.Hands,MCStruct.Head,MCStruct.Feet};
        
        VAR
            index : MCStruct.PlayerEquipmentMnemonic;
        
      BEGIN (* DetermineCurrentArmorEquipment *)
        number := 0;
        
        FOR index := MIN (MCStruct.PlayerEquipmentMnemonic) TO MAX (MCStruct.PlayerEquipmentMnemonic) DO
          IF ((index IN ArmorEquipment) AND (player^.character^.inventory.equipment [index].object.class <> OStruct.Nothing)) THEN
            table [number] := index;
            number         := number + 1;
          END; (* IF *)
        END; (* FOR *)
      END DetermineCurrentArmorEquipment;
      
    BEGIN (* SelectRandomEquipmentArmor *)
      DetermineCurrentArmorEquipment (player,table,number);
      done := (number > 0);
      
      IF done THEN
        position := table [MRandom.CardinalRandomRangeValue (0,number - 1)];
      END; (* IF *)
    END SelectRandomEquipmentArmor;
    
  BEGIN (* DamageRandomArmorObject *)
    SelectRandomEquipmentArmor (player,position,damaged);
    
    IF damaged THEN
      DamageEquipmentArmor (player,resistance,player^.character^.inventory.equipment [position],damaged);
    END; (* IF *)
  END DamageRandomArmorObject;
  
  PROCEDURE DamageRandomBackpackObject (player : MStruct.PlayerInfoPointer; DamagedByAffect : DamageTestProcedure; chance : CARDINAL; message : ARRAY OF CHAR);
    VAR
        deleted : BOOLEAN;
        damage  : BOOLEAN;
        index   : CARDINAL;
    
  BEGIN (* DamageRandomBackpackObject *)
    damage := FALSE;
    index  := 0;
    
    WHILE index < player^.character^.inventory.counter DO
      IF (DamagedByAffect (player^.character^.inventory.backpack [index]) AND (MRandom.CardinalRandomRangeValue (1,100) < chance)) THEN
        MInventory.DecrementInventoryItemQuantity (player,index,deleted);
        damage := TRUE;
      ELSE
        deleted := FALSE;
      END; (* IF *)
      
      IF NOT (deleted) THEN
        INC (index);
      END; (* IF *)
    END; (* WHILE *)
    
    IF damage THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,message);
    END; (* IF *)
  END DamageRandomBackpackObject;
END MIDamage.
