IMPLEMENTATION MODULE MInitFile;
  (*/WIN:A*)
  
  IMPORT WinFiles,Windows,WInitFile,WinStart,WModule,WString;
  IMPORT Strings,SYSTEM;
  
    
  CONST
        DungeonColorsSection = "Dungeon_Colors";
        StatusColorsSection  = "Status_Colors";
  
  CONST
        MoriaInitializationFile = "MORIA.INI";
  
  CONST
        MouseDefinitionSection = "Mouse_Definitions";
        StartupOptionsSection  = "Startup_Options";
        MoriaFilesSection      = "Files";
  
  CONST
        MouseDefinitionIdentifier = "Mouse_%NUMBER";
        MaximizedStartupEntry     = "Cmd_Show";
  
  
  PROCEDURE DetermineDungeonColorEntry (entry : ARRAY OF CHAR; default : Windows.COLORREF; VAR result : Windows.COLORREF);
  BEGIN (* DetermineDungeonColorEntry *)
    WInitFile.GetPrivateProfileLongInt (MoriaInitializationFile,DungeonColorsSection,entry,default,result);
  END DetermineDungeonColorEntry;
  
  PROCEDURE DetermineStatusColorEntry (entry : ARRAY OF CHAR; default : Windows.COLORREF; VAR result : Windows.COLORREF);
  BEGIN (* DetermineStatusColorEntry *)
    WInitFile.GetPrivateProfileLongInt (MoriaInitializationFile,StatusColorsSection,entry,default,result);
  END DetermineStatusColorEntry;
  
  PROCEDURE DetermineMoriaScoreTableFileName (VAR result : ARRAY OF CHAR);
    CONST
          DefaultScoreFileName = "Invalid score file name.";
          ScoreFileNameEntry   = "Score_File";
    
    VAR
        length : CARDINAL;
    
    PROCEDURE DetermineDefaultScoreFileName (VAR result : ARRAY OF CHAR);
      VAR
          length : CARDINAL;
      
    BEGIN (* DetermineDefaultScoreFileName *)
      WModule.GetModuleFileName (WinStart.hInstance,result,length);
      
      WinFiles.DetermineFileDirectory (result,result);
      Strings.Concat (result,"MORIA.SCR",result);
    END DetermineDefaultScoreFileName;
    
    PROCEDURE SetMoriaScoreTableFileName (name : ARRAY OF CHAR);
      VAR
          done : BOOLEAN;
      
    BEGIN (* SetMoriaScoreTableFileName *)
      WInitFile.WritePrivateProfileString (MoriaInitializationFile,MoriaFilesSection,ScoreFileNameEntry,name,done);
    END SetMoriaScoreTableFileName;
    
  BEGIN (* DetermineMoriaScoreTableFileName *)
    WInitFile.GetPrivateProfileString (MoriaInitializationFile,MoriaFilesSection,ScoreFileNameEntry,DefaultScoreFileName,result,length);
    
    IF Strings.CompareStr (result,DefaultScoreFileName) = 0 THEN
      DetermineDefaultScoreFileName (result);
      SetMoriaScoreTableFileName (result);
    END; (* IF *)
  END DetermineMoriaScoreTableFileName;

  PROCEDURE DetermineMouseActionValue (mnemonic : CARDINAL; VAR result : INTEGER);
    VAR
        entry : ARRAY [0..31] OF CHAR;
    
  BEGIN (* DetermineMouseActionValue *)
    WString.ReplaceCardinalParameter (MouseDefinitionIdentifier,"%NUMBER",mnemonic,entry);
    WInitFile.GetPrivateProfileInt (MoriaInitializationFile,MouseDefinitionSection,entry,MIN (INTEGER),result);
  END DetermineMouseActionValue;
  
  PROCEDURE SetDungeonColorEntry (entry : ARRAY OF CHAR; color : Windows.COLORREF);
    VAR
        done : BOOLEAN;
    
  BEGIN (* SetDungeonColorEntry *)
    WInitFile.WritePrivateProfileLongInt (MoriaInitializationFile,DungeonColorsSection,entry,color,done);
  END SetDungeonColorEntry;
  
  PROCEDURE SetStartupDisplayOption (option : INTEGER);
    VAR
        done : BOOLEAN;
    
  BEGIN (* SetStartupDisplayOption *)
    WInitFile.WritePrivateProfileInt (MoriaInitializationFile,StartupOptionsSection,MaximizedStartupEntry,option,done);
  END SetStartupDisplayOption;
  
  PROCEDURE SetMouseActionValue (mnemonic : CARDINAL; command : CARDINAL);
    VAR
        entry : ARRAY [0..31] OF CHAR;
        done  : BOOLEAN;
    
  BEGIN (* SetMouseActionValue *)
    WString.ReplaceCardinalParameter (MouseDefinitionIdentifier,"%NUMBER",mnemonic,entry);
    WInitFile.WritePrivateProfileInt (MoriaInitializationFile,MouseDefinitionSection,entry,command,done);
  END SetMouseActionValue;
  
  PROCEDURE SetStatusColorEntry (entry : ARRAY OF CHAR; color : Windows.COLORREF);
    VAR
        done : BOOLEAN;
    
  BEGIN (* SetStatusColorEntry *)
    WInitFile.WritePrivateProfileLongInt (MoriaInitializationFile,StatusColorsSection,entry,color,done);
  END SetStatusColorEntry;
  
  PROCEDURE StartupDisplayOption () : INTEGER;
    VAR
        result : INTEGER;
    
  BEGIN (* StartupDisplayOption *)
    WInitFile.GetPrivateProfileInt (MoriaInitializationFile,StartupOptionsSection,MaximizedStartupEntry,WinStart.cmdShow,result);
    RETURN (result);
  END StartupDisplayOption;
END MInitFile.
