IMPLEMENTATION MODULE MISelect;
  (*/WIN:A*)
  
  IMPORT WDialog,WDisplay,Windows,WListBox;
  IMPORT Strings,SYSTEM;
  
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT MDialogs,MPInven2;
  
  
  CONST
        BackpackListBoxControl = 1002;
  
  CONST
        SelectPushButtonControl = 1003;
        CancelPushButtonControl = 1004;
  
  TYPE
       SelectDialogParameters = RECORD
                                  classes : OStruct.ObjectClassSet;
                                  prompt  : ARRAY [0..127] OF CHAR;
                                END; (* SelectionDialogParameters *)
  
  PROCEDURE CloseSelectionDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
  BEGIN (* CloseSelectionDialog *)
    ExecuteCancelButton (window,Windows.BN_CLICKED);
  END CloseSelectionDialog;
  
  PROCEDURE ExecuteCancelButton (window : Windows.HWND; command : CARDINAL);
  BEGIN (* ExecuteCancelButton *)
    IF command = Windows.BN_CLICKED THEN
      WDialog.EndDialog (window,MCStruct.MaxInventoryItems);
    END; (* IF *)
  END ExecuteCancelButton;
  
  PROCEDURE ExecuteSelectionDialogCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS; control : CARDINAL; command : CARDINAL);
    PROCEDURE ExecuteBackpackListBoxCommand (window : Windows.HWND; command : CARDINAL);
    BEGIN (* ExecuteBackpackListBoxCommand *)
      IF command = Windows.LBN_SELCHANGE THEN
        WDialog.EnableDialogControl (window,SelectPushButtonControl,TRUE);
      ELSIF command = Windows.LBN_DBLCLK THEN
        ExecuteSelectButton (window,Windows.BN_CLICKED);
      END; (* IF *)
    END ExecuteBackpackListBoxCommand;
    
    PROCEDURE ExecuteSelectButton (window : Windows.HWND; command : CARDINAL);
    BEGIN (* ExecuteSelectButton *)
      IF command = Windows.BN_CLICKED THEN
        WDialog.EndDialog (window,WListBox.CurrentlySelectedItemData (WDialog.GetDlgItem (window,BackpackListBoxControl)));
      END; (* IF *)
    END ExecuteSelectButton;
    
  BEGIN (* ExecuteSelectionDialogCommand *)
    CASE control OF
      CancelPushButtonControl,Windows.IDCANCEL : ExecuteCancelButton (window,command); |
      SelectPushButtonControl,Windows.IDOK     : ExecuteSelectButton (window,command); |
      
      BackpackListBoxControl : ExecuteBackpackListBoxCommand (window,command);
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteSelectionDialogCommand;
  
  PROCEDURE InitializeInvenSelectDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
    TYPE
         SelectionParametersPointer = POINTER TO SelectDialogParameters;
    
    VAR
        ptr : SelectionParametersPointer;
    
  BEGIN (* InitializeInvenSelectDialog *)
    ptr := SelectionParametersPointer (data);
    
    MPInven2.InitializeBackpackListBox (WDialog.GetDlgItem (window,BackpackListBoxControl),player,ptr^.classes);
    WDisplay.SetWindowText (window,ptr^.prompt);
  END InitializeInvenSelectDialog;
  
  PROCEDURE SelectInventoryItem (player : MStruct.PlayerInfoPointer; prompt : ARRAY OF CHAR; classes : OStruct.ObjectClassSet; VAR position : CARDINAL; VAR done : BOOLEAN);
    VAR
        params : SelectDialogParameters;
        result : INTEGER;
    
  BEGIN (* SelectInventoryItem *)
    Strings.Assign (prompt,params.prompt);
    params.classes := classes;
    
    MDialogs.ExecuteMoriaDialogBoxParam (player^.windows.frame,"Inventory_Selection_Dialog",player,SYSTEM.ADR (params),InitializeInvenSelectDialog,ExecuteSelectionDialogCommand,CloseSelectionDialog,result);
    
    position := result;
    done     := (position < MCStruct.MaxInventoryItems);
  END SelectInventoryItem;
END MISelect.
