IMPLEMENTATION MODULE MMemory;
  (*/WIN:A*)
  
  FROM WMemory IMPORT ALLOCATE,DEALLOCATE;
  
  IMPORT WDialog,Windows,WMacro;
  IMPORT SYSTEM;
  
  IMPORT CStruct,MCStruct,MStruct;
  IMPORT MMemory2,MMemory3;
  IMPORT MDialogs;
  
  
  PROCEDURE CloseRecallDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
  BEGIN (* CloseRecallDialog *)
    WDialog.EndDialog (window,Windows.FALSE_BOOL);
  END CloseRecallDialog;
  
  PROCEDURE ExecuteRecallDialogCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS; control : CARDINAL; command : CARDINAL);
    CONST
          CloseButtonControl = Windows.IDOK;
    
  BEGIN (* ExecuteRecallDialogCommand *)
    IF (((control = CloseButtonControl) OR (control = Windows.IDCANCEL)) AND (command = Windows.BN_CLICKED)) THEN
      CloseRecallDialog (window,player,data);
    END; (* IF *)
  END ExecuteRecallDialogCommand;
  
  PROCEDURE InitializeRecallDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
    CONST
          MemoryEditTextControl = 1701;
    
    CONST
          MaxRecallTextSize = 2 * 1024;
    
    VAR
        buffer : POINTER TO ARRAY [0..MaxRecallTextSize - 1] OF CHAR;
    
    PROCEDURE InitializeRecallBuffer (player : MStruct.PlayerInfoPointer; creature : MMemory2.CreatureInfoPointer; VAR result : ARRAY OF CHAR);
      CONST
            EmptyCreatureMovement = CStruct.CreatureMovementInformation {};
      
      VAR
          memory : CStruct.CreatureRecallInformation;
      
      PROCEDURE AppendBalrogInformation (creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation; VAR result : ARRAY OF CHAR);
      BEGIN (* AppendBalrogInformation *)
        MMemory2.AppendString (result,"Killing one of these wins the game!");
      END AppendBalrogInformation;
      
      PROCEDURE AppendConflictInformation (creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation; VAR result : ARRAY OF CHAR);
      BEGIN (* AppendConflictInformation *)
        IF memory.deaths > 0 THEN
          MMemory2.AppendCardinalParameterString (result,"%NUMBER of the contributors to your race memory ","%NUMBER",memory.deaths);
          
          IF memory.deaths > 1 THEN
            MMemory2.AppendString (result,"have ");
          ELSE
            MMemory2.AppendString (result,"has ");
          END; (* IF *)
          
          MMemory2.AppendString (result,"been killed by this creature, and ");
          
          IF memory.kills > 0 THEN
            MMemory2.AppendCardinalParameterString (result,"at least %NUMBER of the beasts ","%NUMBER",memory.kills);
            
            IF memory.kills > 1 THEN
              MMemory2.AppendString (result,"have ");
            ELSE
              MMemory2.AppendString (result,"has ");
            END; (* IF *)
            
            MMemory2.AppendString (result,"been exterminated.  ");
          ELSE
            MMemory2.AppendString (result,"it is not ever known to have been defeated.  ");
          END; (* IF *)
        ELSIF memory.kills > 0 THEN
          MMemory2.AppendCardinalParameterString (result,"At least %d of these creatures ","%d",memory.kills);
          
          IF memory.kills > 1 THEN
            MMemory2.AppendString (result,"have ");
          ELSE
            MMemory2.AppendString (result,"has ");
          END; (* IF *)
          
          MMemory2.AppendString (result,"been killed by contributors to your monster memory.  ");
        ELSE
          MMemory2.AppendString (result,"No known battles to the death are recalled.  ");
        END; (* IF *)
      END AppendConflictInformation;
      
      PROCEDURE AppendDefenseInformation (creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation; VAR result : ARRAY OF CHAR);
        CONST
              DefenseStringBase = 350;
        
        VAR
            defense : CStruct.CreatureDefenseInformation;
            index   : CStruct.CreatureDefenseMnemonic;
            first   : BOOLEAN;
        
      BEGIN (* AppendDefenseInformation *)
        defense := memory.defense * CStruct.CreatureDefenseInformation {CStruct.HurtByFrost..CStruct.HurtByStoneToMud};
        
        IF defense <> CStruct.CreatureDefenseInformation {} THEN
          first := TRUE;
          
          FOR index := CStruct.HurtByFrost TO CStruct.HurtByStoneToMud DO
            IF index IN defense THEN
              EXCL (defense,index);
              
              IF first THEN
                MMemory2.AppendString (result,"It is susceptible to ");
                first := FALSE;
              ELSIF defense = CStruct.CreatureDefenseInformation {} THEN
                MMemory2.AppendString (result," and ");
              ELSE
                MMemory2.AppendString (result,", ");
              END; (* IF *)
              
              MMemory2.AppendResourceString (result,DefenseStringBase + (ORD (index) - ORD (CStruct.HurtByFrost)));
            END; (* IF *)
          END; (* FOR *)
          
          MMemory2.AppendString (result,".  ");
        END; (* IF *)
        
        IF CStruct.Endothermic IN memory.defense THEN
          MMemory2.AppendString (result,"It is warm blooded");
        END; (* IF *)
        
        IF CStruct.ResistCharms IN memory.defense THEN
          IF CStruct.Endothermic IN memory.defense THEN
            MMemory2.AppendString (result,", and ");
          ELSE
            MMemory2.AppendString (result,"It ");
          END; (* IF *)
          
          MMemory2.AppendString (result,"cannot be charmed or slept");
        END; (* IF *)
        
        IF memory.defense * CStruct.CreatureDefenseInformation {CStruct.Endothermic,CStruct.ResistCharms} <> CStruct.CreatureDefenseInformation {} THEN
          MMemory2.AppendString (result,".  ");
        END; (* IF *)
      END AppendDefenseInformation;
      
      PROCEDURE AppendDepthInformation (creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation; VAR result : ARRAY OF CHAR);
      BEGIN (* AppendDepthInformation *)
        IF creature.depth = 0 THEN
          MMemory2.AppendString (result,"It lives in the town");
        ELSIF memory.kills > 0 THEN
          MMemory2.AppendCardinalParameterString (result,"It is normally found at depths of %d feet","%d",WMacro.MinCardinal (creature.depth,CStruct.MaxCreatureDepth) * 50);
        END; (* IF *)
      END AppendDepthInformation;
      
      PROCEDURE AppendMovementInformation (creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation; VAR result : ARRAY OF CHAR);
        CONST
              RandomCreatureMovement = CStruct.CreatureMovementInformation {CStruct.MoveRandom20..CStruct.MoveRandom75};
        
        VAR
            continue : BOOLEAN;
            speed    : INTEGER;
        
        PROCEDURE RandomMovementResourceCursor (movement : CStruct.CreatureMovementInformation) : CARDINAL;
          CONST
                HowMuchStringCursorBase = 250;
          
        BEGIN (* RandomMovementResourceCursor *)
          RETURN (HowMuchStringCursorBase + CARDINAL (movement * RandomCreatureMovement) DIV 8);
        END RandomMovementResourceCursor;
        
      BEGIN (* AppendMovementInformation *)
        continue := ((creature.depth = 0) OR (memory.kills > 0));
        
        IF memory.movement <> EmptyCreatureMovement THEN
          IF continue THEN
            MMemory2.AppendString (result,", and");
          ELSE
            MMemory2.AppendString (result,"It");
            continue := TRUE;
          END; (* IF *)
          
          MMemory2.AppendString (result," moves ");
          
          IF memory.movement * RandomCreatureMovement <> EmptyCreatureMovement THEN
            MMemory2.AppendResourceString (result,RandomMovementResourceCursor (memory.movement));
            MMemory2.AppendString (result," erratically");
          END; (* IF *)
          
          speed := creature.speed - 10;
          
          IF speed = 1 THEN
            MMemory2.AppendString (result," at normal speed");
          ELSE
            IF memory.movement * RandomCreatureMovement <> EmptyCreatureMovement THEN
              MMemory2.AppendString (result,", and");
            END; (* IF *)
            
            IF speed <= 0 THEN
              IF speed = -1 THEN
                MMemory2.AppendString (result," incredibly");
              ELSIF speed < -1 THEN
                MMemory2.AppendString (result," very");
              END; (* IF *)
              
              MMemory2.AppendString (result," slowly");
            ELSE
              IF speed = 3 THEN
                MMemory2.AppendString (result," very");
              ELSIF speed > 3 THEN
                MMemory2.AppendString (result," unbelievably");
              END; (* IF *)
              
              MMemory2.AppendString (result," quickly");
            END; (* IF *)
          END; (* IF *)
        END; (* IF *)
        
        IF CStruct.AttackOnly IN memory.movement THEN
          IF continue THEN
            MMemory2.AppendString (result,", but");
          ELSE
            MMemory2.AppendString (result,"It");
            continue := TRUE;
          END; (* IF *)
          
          MMemory2.AppendString (result," does not deign to chase intruders");
        END; (* IF *)
        
        IF CStruct.MagicOnly IN memory.movement THEN
          IF continue THEN
            MMemory2.AppendString (result,", but");
          ELSE
            MMemory2.AppendString (result,"It");
            continue := TRUE;
          END; (* IF *)
          
          MMemory2.AppendString (result," always moves and attacks by using magic");
        END; (* IF *)
        
        IF continue THEN
          MMemory2.AppendString (result,".  ");
        END; (* IF *)
      END AppendMovementInformation;
      
      PROCEDURE AppendMovementSpecials (creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation; VAR result : ARRAY OF CHAR);
        CONST
              SpecialMovementStringBase = 325;
        
        VAR
            movement : CStruct.CreatureMovementInformation;
            index    : CStruct.CreatureMovementMnemonic;
            first    : BOOLEAN;
        
      BEGIN (* AppendMovementSpecials *)
        movement := memory.movement * CStruct.CreatureMovementInformation {CStruct.MoveInvisible..CStruct.MultiplyMonster};
        
        IF movement <> EmptyCreatureMovement THEN
          first := TRUE;
          
          FOR index := CStruct.MoveInvisible TO CStruct.MultiplyMonster DO
            IF index IN movement THEN
              EXCL (movement,index);
              
              IF first THEN
                MMemory2.AppendString (result,"It can ");
                first := FALSE;
              ELSIF movement = EmptyCreatureMovement THEN
                MMemory2.AppendString (result," and ");
              ELSE
                MMemory2.AppendString (result,", ");
              END; (* IF *)
              
              MMemory2.AppendResourceString (result,SpecialMovementStringBase + (ORD (index) - ORD (CStruct.MoveInvisible)));
            END; (* IF *)
          END; (* FOR *)
          
          MMemory2.AppendString (result,".  ");
        END; (* IF *)
      END AppendMovementSpecials;
      
      PROCEDURE AppendSpellInformation (creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation; VAR result : ARRAY OF CHAR);
        CONST
              StandardCreatureSpells = CStruct.CreatureSpellSet {CStruct.TeleportShort..CStruct.DrainMana};
              EmptyCreatureSpellSet  = CStruct.CreatureSpellSet {};
              CreatureBreaths        = CStruct.CreatureSpellSet {CStruct.BreathLightning..CStruct.BreathFire};
        
        PROCEDURE AppendCreatureBreaths (spells : CStruct.CreatureSpellSet; VAR result : ARRAY OF CHAR);
          CONST
                BreathDescriptionStringBase = 275;
          
          VAR
              index : [CStruct.BreathLightning..CStruct.BreathFire];
              first : BOOLEAN;
          
        BEGIN (* AppendCreatureBreaths *)
          first := TRUE;
          
          FOR index := CStruct.BreathLightning TO CStruct.BreathFire DO
            IF index IN spells THEN
              EXCL (spells,index);
              
              IF first THEN
                MMemory2.AppendString (result,"It can breathe ");
                first := FALSE;
              ELSIF spells = EmptyCreatureSpellSet THEN
                MMemory2.AppendString (result," and ");
              ELSE
                MMemory2.AppendString (result,", ");
              END; (* IF *)
              
              MMemory2.AppendResourceString (result,BreathDescriptionStringBase + (ORD (index) - ORD (CStruct.BreathLightning)));
            END; (* IF *)
          END; (* FOR *)
        END AppendCreatureBreaths;
        
        PROCEDURE AppendCreatureSpells (spells : CStruct.CreatureSpellSet; breaths : BOOLEAN; VAR result : ARRAY OF CHAR);
          CONST
                SpellDescriptionStringBase = 300;
          
          VAR
              index : [CStruct.TeleportShort..CStruct.DrainMana];
              first : BOOLEAN;
          
        BEGIN (* AppendCreatureSpells *)
          first := TRUE;
          
          FOR index := CStruct.TeleportShort TO CStruct.DrainMana DO
            IF index IN spells THEN
              EXCL (spells,index);
              
              IF first THEN
                first := FALSE;
                
                IF breaths THEN
                  MMemory2.AppendString (result,", and is also");
                ELSE
                  MMemory2.AppendString (result,"It is");
                END; (*IF *)
                
                MMemory2.AppendString (result," magical, casting spells which ");
              ELSIF spells = EmptyCreatureSpellSet THEN
                MMemory2.AppendString (result," or ");
              ELSE
                MMemory2.AppendString (result,", ");
              END; (* IF *)
              
              MMemory2.AppendResourceString (result,SpellDescriptionStringBase + ORD (index) - ORD (CStruct.TeleportShort));
            END; (* IF *)
          END; (* FOR *)
        END AppendCreatureSpells;
        
      BEGIN (* AppendSpellInformation *)
        IF memory.spells * CreatureBreaths <> EmptyCreatureSpellSet THEN
          AppendCreatureBreaths (memory.spells * CreatureBreaths,result);
        END; (* IF *)
        
        IF memory.spells * StandardCreatureSpells <> EmptyCreatureSpellSet THEN
          AppendCreatureSpells (memory.spells * StandardCreatureSpells,memory.spells * CreatureBreaths <> EmptyCreatureSpellSet,result);
        END; (* IF *)
        
        IF memory.spells <> EmptyCreatureSpellSet THEN
          MMemory2.AppendCardinalParameterString (result,"; 1 time in %VALUE.  ","%VALUE",creature.spells.chance);
        END; (* IF *)
      END AppendSpellInformation;
      
      PROCEDURE ReturnCompleteCreatureMemory (creature : CStruct.PassiveCreatureInfoRecord; VAR memory : CStruct.CreatureRecallInformation);
      BEGIN (* ReturnCompleteCreatureMemory *)
        WITH memory DO
          movement := creature.movement;
          treasure := creature.treasure;
          defense  := creature.defense;
          spells   := creature.spells.known;
          
          attacks [0] := CStruct.MaxRememberedAttacks;
          attacks [1] := CStruct.MaxRememberedAttacks;
          attacks [2] := CStruct.MaxRememberedAttacks;
          attacks [3] := CStruct.MaxRememberedAttacks;
          
          ignored := CStruct.MaxCreatureIgnored;
          awoken  := CStruct.MaxCreatureAwakenings;
          deaths  := CStruct.MaxRememberedDeaths;
          kills   := CStruct.MaxRememberedKills;
        END; (* WITH *)
      END ReturnCompleteCreatureMemory;
      
    BEGIN (* InitializeRecallBuffer *)
      IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
        ReturnCompleteCreatureMemory (creature^,memory);
      ELSE
        memory := creature^.memory;
      END; (* IF *)
      
      result [0] := 0C;
      
      AppendConflictInformation (creature^,memory,result);
      AppendDepthInformation (creature^,memory,result);
      AppendMovementInformation (creature^,memory,result);
      MMemory2.AppendExperienceInformation (player,creature^,memory,result);
      AppendSpellInformation (creature^,memory,result);
      MMemory3.AppendArmorInformation (creature^,memory,result);
      AppendMovementSpecials (creature^,memory,result);
      AppendDefenseInformation (creature^,memory,result);
      MMemory2.AppendSleepInformation (creature^,memory,result);
      MMemory2.AppendTreasureInformation (creature^,memory,result);
      MMemory3.AppendAttackInformation (player^.creatures,creature^,memory,result);
      
      IF creature^.balrog THEN
        AppendBalrogInformation (creature^,memory,result);
      END; (* IF *)
    END InitializeRecallBuffer;
    
  BEGIN (* InitializeRecallDialog *)
    NEW (buffer);
    
    InitializeRecallBuffer (player,MMemory2.CreatureInfoPointer (data),buffer^);
    
    MMemory2.SetRecallCreatureTitle (window,MMemory2.CreatureInfoPointer (data));
    WDialog.SetDlgItemText (window,MemoryEditTextControl,buffer^);
    
    DISPOSE (buffer);
  END InitializeRecallDialog;
  
  PROCEDURE RecallCreatureInformation (player : MStruct.PlayerInfoPointer; creature : CStruct.PassiveCreatureInfoRecord);
    VAR
        result : INTEGER;
    
  BEGIN (* RecallCreatureInformation *)
    MDialogs.ExecuteMoriaDialogBoxParam (player^.windows.frame,"Recall_Dialog",player,SYSTEM.ADR (creature),InitializeRecallDialog,ExecuteRecallDialogCommand,CloseRecallDialog,result);
  END RecallCreatureInformation;
END MMemory.
