IMPLEMENTATION MODULE MMemory2;
  (*/WIN:A*)
  
  IMPORT WDialog,Windows,WinStart,WMacro,WResource,WString;
  IMPORT CStruct,MStruct;
  IMPORT MPAttk2;
  IMPORT Strings;
  
  
  PROCEDURE AppendCardinalParameterString (VAR str : ARRAY OF CHAR; text : ARRAY OF CHAR; formal : ARRAY OF CHAR; actual : CARDINAL);
    VAR
        temp : ARRAY [0..127] OF CHAR;
    
  BEGIN (* AppendCardinalParameterString *)
    WString.ReplaceCardinalParameter (text,formal,actual,temp);
    AppendString (str,temp);
  END AppendCardinalParameterString;
  
  PROCEDURE AppendExperienceInformation (player : MStruct.PlayerInfoPointer; creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation; VAR result : ARRAY OF CHAR);
    PROCEDURE AppendExperienceAmount (VAR str : ARRAY OF CHAR; amount : REAL);
    BEGIN (* AppendExperienceAmount *)
      AppendRealParameterString (str,"creature is worth %AMOUNT ","%AMOUNT",amount,2,0);
      
      IF amount <> 1.0 THEN
        AppendString (str,"points ");
      ELSE
        AppendString (str,"point ");
      END; (* IF *)
    END AppendExperienceAmount;
    
    PROCEDURE AppendLevelInformation (VAR str : ARRAY OF CHAR; level : CARDINAL);
      VAR
          term : ARRAY [0..7] OF CHAR;
      
    BEGIN (* AppendLevelInformation *)
      IF ((level = 8) OR (level = 11) OR (level = 18)) THEN
        AppendCardinalParameterString (str,"for an %LEVEL","%LEVEL",level);
      ELSE
        AppendCardinalParameterString (str,"for a %LEVEL","%LEVEL",level);
      END; (* IF *)
      
      IF ((level >= 10) AND (level <= 19)) THEN
        term := "th ";
      ELSE
        CASE level MOD 10 OF
          1 : term := "st "; |
          2 : term := "nd "; |
          3 : term := "rd "; |
        ELSE
          term := "th ";
        END; (* CASE *)
      END; (* IF *)
      
      AppendString (str,term);
      AppendString (str,"level character.  ");
    END AppendLevelInformation;
    
  BEGIN (* AppendExperienceInformation *)
    IF memory.kills > 0 THEN
      AppendString (result,"A kill of this ");
      
      IF CStruct.HurtBySlayAnimal IN creature.defense THEN
        AppendString (result,"natural ");
      END; (* IF *)
      
      IF CStruct.HurtBySlayEvil IN creature.defense THEN
        AppendString (result,"evil ");
      END; (* IF *)
      
      IF CStruct.HurtBySlayUndead IN creature.defense THEN
        AppendString (result,"undead ");
      END; (* IF *)
      
      AppendExperienceAmount (result,MPAttk2.ExperienceForCreature (creature.experience,player^.character^.variables.level,player^.character^.variables.depthCUR));
      AppendLevelInformation (result,player^.character^.variables.level);
    END; (* IF *)
  END AppendExperienceInformation;
  
  PROCEDURE AppendRealParameterString (VAR str : ARRAY OF CHAR; text : ARRAY OF CHAR; formal : ARRAY OF CHAR; actual : REAL; precision,width : CARDINAL);
    VAR
        temp : ARRAY [0..127] OF CHAR;
    
  BEGIN (* AppendRealParameterString *)
    WString.ReplaceLongRealParameter (text,formal,actual,precision,width,temp);
    AppendString (str,temp);
  END AppendRealParameterString;
  
  PROCEDURE AppendResourceString (VAR str : ARRAY OF CHAR; cursor : CARDINAL);
    VAR
        length : CARDINAL;
        text   : ARRAY [0..127] OF CHAR;
    
  BEGIN (* AppendResourceString *)
    WResource.LoadString (WinStart.hInstance,cursor,text,length);
    AppendString (str,text);
  END AppendResourceString;
  
  PROCEDURE AppendSleepInformation (creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation; VAR result : ARRAY OF CHAR);
    PROCEDURE ShouldNoticePerception (creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation) : BOOLEAN;
    BEGIN (* ShouldNoticePerception *)
      IF ((memory.awoken = CStruct.MaxCreatureAwakenings) OR (memory.awoken * memory.awoken > creature.sleep)) THEN
        RETURN (TRUE);
      ELSIF ((creature.sleep = 0) AND (memory.kills > 10)) THEN
        RETURN (TRUE);
      ELSE
        RETURN (memory.ignored = CStruct.MaxCreatureIgnored);
      END; (* IF *)
    END ShouldNoticePerception;
    
  BEGIN (* AppendSleepInformation *)
    IF ShouldNoticePerception (creature,memory) THEN
      AppendString (result,"It ");
      
      CASE creature.sleep OF
        96..199 : AppendString (result,"pays very little attention to "); |
        76..95  : AppendString (result,"pays little attention to ");      |
        46..75  : AppendString (result,"tends to overlook ");             |
        26..45  : AppendString (result,"takes quite a while to see ");    |
        11..25  : AppendString (result,"takes a while to see ");          |
        6..10   : AppendString (result,"is fairly observant of ");        |
        4..5    : AppendString (result,"is observant of ");               |
        2..3    : AppendString (result,"is very observant of ");          |
        1       : AppendString (result,"is vigilant for ");               |
        0       : AppendString (result,"is ever vigilant for ");          |
      ELSE
        AppendString (result,"prefers to ignore ");
      END; (* CASE *)
      
      AppendCardinalParameterString (result,"intruders, which it may notice from %d feet.  ","%d",creature.perception * 10);
    END; (* IF *)
  END AppendSleepInformation;
  
  PROCEDURE AppendString (VAR str : ARRAY OF CHAR; text : ARRAY OF CHAR);
  BEGIN (* AppendString *)
    Strings.Insert (text,str,HIGH (str));
  END AppendString;

  PROCEDURE AppendTreasureInformation (creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation; VAR result : ARRAY OF CHAR);
    CONST
          TreasureQuantityInformation = CStruct.CreatureTreasureInformation {CStruct.TreasureChance60..CStruct.TreasureQuantity4d2};
          EmptyTreasureInformation    = CStruct.CreatureTreasureInformation {};
          OnlyTreasureChance60        = CStruct.CreatureTreasureInformation {CStruct.TreasureChance60};
          RandomTreasuresOnly         = CStruct.CreatureTreasureInformation {CStruct.TreasureChance60,CStruct.TreasureChance90};
    
    VAR
        quantity : CStruct.CreatureTreasureInformation;
        temp     : ARRAY [0..15] OF CHAR;
    
    PROCEDURE MaximumCarriedTreasure (quantity : CStruct.CreatureTreasureInformation) : CARDINAL;
      VAR
          amount : CARDINAL;
          index  : CStruct.CreatureTreasureMnemonic;
      
    BEGIN (* MaximumCarriedTreasure *)
      amount := 0;
      
      FOR index := CStruct.TreasureChance60 TO CStruct.TreasureQuantity4d2 DO
        IF index IN quantity THEN
          amount := WMacro.MaxCardinal (amount * 2,1);
        END; (* IF *)
      END; (* FOR *)
      
      RETURN (amount);
    END MaximumCarriedTreasure;
    
  BEGIN (* AppendTreasureInformation *)
    IF memory.treasure * TreasureQuantityInformation <> EmptyTreasureInformation THEN
      AppendString (result,"It may ");
      
      quantity := memory.treasure * TreasureQuantityInformation;
      
      IF quantity = OnlyTreasureChance60 THEN
        IF creature.treasure * TreasureQuantityInformation = OnlyTreasureChance60 THEN
          AppendString (result,"sometimes ");
        ELSE
          AppendString (result,"often ");
        END; (* IF *)
      ELSIF ((quantity = RandomTreasuresOnly) AND (creature.treasure * TreasureQuantityInformation = RandomTreasuresOnly)) THEN
        AppendString (result,"often ");
      END; (* IF *)
      
      AppendString (result,"carry ");
      
      temp := "objects ";
      
      IF quantity = OnlyTreasureChance60 THEN
        temp := "an object ";
      ELSIF quantity = RandomTreasuresOnly THEN
        AppendString (result,"one or two ");
      ELSE
        AppendCardinalParameterString (result,"up to %d ","%d",MaximumCarriedTreasure (quantity));
      END; (* IF *)
      
      IF CStruct.CarriesObjects IN memory.treasure THEN
        AppendString (result,temp);
        
        IF CStruct.CarriesGold IN memory.treasure THEN
          IF quantity <> OnlyTreasureChance60 THEN
            AppendString (result,"or treasures");
          ELSE
            AppendString (result,"or treasure");
          END; (* IF *)
        END; (* IF *)
      ELSIF quantity <> OnlyTreasureChance60 THEN
        AppendString (result,"or treasures");
      ELSE
        AppendString (result,"or treasure");
      END; (* IF *)
      
      AppendString (result,".  ");
    END; (* IF *)
  END AppendTreasureInformation;
  
  PROCEDURE SetRecallCreatureTitle (window : Windows.HWND; creature : CreatureInfoPointer);
    CONST
          CreatureNameStaticTextControl = 1702;
    
    VAR
        title : ARRAY [0..127] OF CHAR;
    
  BEGIN (* SetRecallCreatureTitle *)
    WString.ReplaceStringParameter ("The %CREATURE:","%CREATURE",creature^.description,title);
    WDialog.SetDlgItemText (window,CreatureNameStaticTextControl,title);
  END SetRecallCreatureTitle;
END MMemory2.
