IMPLEMENTATION MODULE MMemory3;
  (*/WIN:A*)
  
  IMPORT MMemory2;
  IMPORT CStruct;
  
  
  PROCEDURE AppendArmorInformation (creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation; VAR result : ARRAY OF CHAR);
  BEGIN (* AppendArmorInformation *)
    IF memory.kills > 304 DIV (4 + creature.depth) THEN
      MMemory2.AppendCardinalParameterString (result,"It has an armor rating of %ARMOR ","%ARMOR",creature.armor);
      
      IF CStruct.MaxHitPoints IN creature.defense THEN
        MMemory2.AppendString (result,"and a maximized ");
      ELSE
        MMemory2.AppendString (result,"and a ");
      END; (* IF *)
      
      MMemory2.AppendCardinalParameterString (result,"life rating of %VALUEd","%VALUE",creature.hitdie.min);
      MMemory2.AppendCardinalParameterString (result,"%VALUE.  ","%VALUE",creature.hitdie.max DIV creature.hitdie.min);
    END; (* IF *)
  END AppendArmorInformation;
  
  PROCEDURE AppendAttackInformation (creatures : CStruct.CreatureInfoPointer; creature : CStruct.PassiveCreatureInfoRecord; memory : CStruct.CreatureRecallInformation; VAR result : ARRAY OF CHAR);
    VAR
        numberKnownAttacks,numberPrintedAttacks : CARDINAL;
        index                                   : CARDINAL;
    
    PROCEDURE AppendAttackDescription (VAR result : ARRAY OF CHAR; creature : CStruct.PassiveCreatureInfoRecord; identified : CARDINAL; attack : CStruct.CreatureAttackRecord);
      CONST
            AttackMethodStringBase = 375;
            AttackClassStringBase  = 400;
      
      PROCEDURE PlayerKnowsDamage (depth : CARDINAL; identified : CARDINAL; damage : CARDINAL) : BOOLEAN;
      BEGIN (* PlayerKnowsDamage *)
        RETURN (4 + depth * identified > 80 * damage);
      END PlayerKnowsDamage;
      
    BEGIN (* AppendAttackDescription *)
      MMemory2.AppendResourceString (result,AttackMethodStringBase + ORD (attack.description));
      
      IF ((attack.class <> CStruct.normal) OR (attack.damage.max > 0)) THEN
        MMemory2.AppendString (result," to ");
        MMemory2.AppendResourceString (result,AttackClassStringBase + ORD (attack.class));
        
        IF ((attack.damage.max > 0) AND PlayerKnowsDamage (creature.depth,identified,attack.damage.max)) THEN
          IF attack.class = CStruct.experience THEN
            MMemory2.AppendString (result," by");
          ELSE
            MMemory2.AppendString (result," with damage");
          END; (* IF *)
          
          MMemory2.AppendCardinalParameterString (result," %dd","%d",attack.damage.min);
          MMemory2.AppendCardinalParameterString (result,"%d","%d",attack.damage.max DIV attack.damage.min);
        END; (* IF *)
      END; (* IF *)
    END AppendAttackDescription;
    
    PROCEDURE NumberObservedAttacks (creatures : CStruct.CreatureInfoPointer; creature : CStruct.PassiveCreatureInfoRecord; table : ARRAY OF CARDINAL) : CARDINAL;
      VAR
          count : CARDINAL;
          index : CARDINAL;
      
    BEGIN (* NumberObservedAttacks *)
      count := 0;
      
      FOR index := 0 TO HIGH (table) DO
        IF ((table [index] > 0) AND (creatures^.attacks [creature.attacks [index]].class <> CStruct.noAttack)) THEN
          INC (count);
        END; (* IF *)
      END; (* FOR *)
      
      RETURN (count);
    END NumberObservedAttacks;
    
  BEGIN (* AppendAttackInformation *)
    numberPrintedAttacks := 0;
    numberKnownAttacks   := NumberObservedAttacks (creatures,creature,memory.attacks);
    
    FOR index := 0 TO CStruct.MaxAttacksPerCreature - 1 DO
      IF ((memory.attacks [index] > 0) AND (creatures^.attacks [creature.attacks [index]].class <> CStruct.noAttack)) THEN
        INC (numberPrintedAttacks);
        
        IF numberPrintedAttacks = 1 THEN
          MMemory2.AppendString (result,"It can ");
        ELSIF numberPrintedAttacks < numberKnownAttacks THEN
          MMemory2.AppendString (result,", ");
        ELSE
          MMemory2.AppendString (result," and ");
        END; (* IF *)
        
        AppendAttackDescription (result,creature,memory.attacks [index],creatures^.attacks [creature.attacks [index]]);
      END; (* IF *)
    END; (* FOR *)
    
    IF numberPrintedAttacks > 0 THEN
      MMemory2.AppendString (result,".  ");
    ELSIF ((numberKnownAttacks > 0) AND (memory.attacks [0] >= 10)) THEN
      MMemory2.AppendString (result,"It has no physical attacks.  ");
    ELSE
      MMemory2.AppendString (result,"Nothing is known about its attack.  ");
    END; (* IF *)
  END AppendAttackInformation;
END MMemory3.
