IMPLEMENTATION MODULE MMenu;
  (*/WIN:A*)
  
  IMPORT WDebugging,WinStart,WMenu,Windows;
  
  IMPORT MInitFile,MMTranslator;
  IMPORT MCStruct,MStruct;
  
  
  PROCEDURE AppendWizardMenu (window : Windows.HWND);
    CONST
          HelpCommandControl = 1000;
    
    VAR
        done : BOOLEAN;
    
  BEGIN (* AppendWizardMenu *)
    WMenu.InsertMenu (WMenu.GetMenu (window),HelpCommandControl,Windows.MF_BYCOMMAND + Windows.MF_POPUP,WMenu.LoadMenu (WinStart.hInstance,"Wizard_Menu"),"&Wizard",done);
    
    IF NOT (done) THEN
      WDebugging.FatalAppExit ("Unable to add Wizard menu.");
    END; (* IF *)
    
    WMenu.DrawMenuBar (window);
  END AppendWizardMenu;
  
  PROCEDURE EnableMainWindowMenu (window : Windows.HWND; enable : BOOLEAN);
    VAR
        position : CARDINAL;
        result   : INTEGER;
        menu     : Windows.HMENU;
    
  BEGIN (* EnableMainWindowMenu *)
    position := 0;
    menu     := WMenu.GetMenu (window);
    
    REPEAT
      IF enable THEN
        WMenu.EnableMenuItem (menu,position,Windows.MF_BYPOSITION + Windows.MF_ENABLED,result);
      ELSE
        WMenu.EnableMenuItem (menu,position,Windows.MF_BYPOSITION + Windows.MF_GRAYED,result);
      END; (* IF *)
      
      INC (position);
    UNTIL result = -1;
    
    WMenu.DrawMenuBar (window);
  END EnableMainWindowMenu;
  
  PROCEDURE ResetNonPlayerMenu (window : Windows.HWND);
  BEGIN (* ResetNonPlayerMenu *)
    SelectMoriaMenu (window,"Main_Menu");
  END ResetNonPlayerMenu;
  
  PROCEDURE SelectMoriaMenu (window : Windows.HWND; template : ARRAY OF CHAR);
    VAR
        done : BOOLEAN;
    
  BEGIN (* SelectMoriaMenu *)
    WMenu.DestroyMenu (WMenu.GetMenu (window),done);
    WMenu.SetMenu (window,WMenu.LoadMenu (WinStart.hInstance,template),done);
    
    SetMaximizedMarker (window,MInitFile.StartupDisplayOption () = Windows.SW_SHOWMAXIMIZED);
  END SelectMoriaMenu;
  
  PROCEDURE SetMaximizedMarker (window : Windows.HWND; maximized : BOOLEAN);
    CONST
          StartMaximizedCommandControl = 560;
    
    VAR
        result : INTEGER;
    
  BEGIN (* SetMaximizedMarker *)
    IF maximized THEN
      WMenu.CheckMenuItem (WMenu.GetMenu (window),StartMaximizedCommandControl,Windows.MF_BYCOMMAND + Windows.MF_CHECKED,result);
    ELSE
      WMenu.CheckMenuItem (WMenu.GetMenu (window),StartMaximizedCommandControl,Windows.MF_BYCOMMAND + Windows.MF_UNCHECKED,result);
    END; (* IF *)
  END SetMaximizedMarker;
  
  PROCEDURE SetSearchMarker (window : Windows.HWND; check : BOOLEAN);
    CONST
          SearchToggleCommandControl = 460;
    
    VAR
        result : INTEGER;
    
  BEGIN (* SetSearchMarker *)
    IF check THEN
      WMenu.CheckMenuItem (WMenu.GetMenu (window),SearchToggleCommandControl,Windows.MF_BYCOMMAND + Windows.MF_CHECKED,result);
    ELSE
      WMenu.CheckMenuItem (WMenu.GetMenu (window),SearchToggleCommandControl,Windows.MF_BYCOMMAND + Windows.MF_UNCHECKED,result);
    END; (* IF *)
  END SetSearchMarker;
  
  PROCEDURE SetStandardMenu (player : MStruct.PlayerInfoPointer);
    CONST
          RecitePrayerControl = 600;
          CastSpellControl    = 700;
    
    VAR
        done : BOOLEAN;
    
  BEGIN (* SetStandardMenu *)
    SelectMoriaMenu (player^.windows.frame,"Player_Menu");
    
    IF player^.character^.constants.class IN MCStruct.PriestClasses THEN
      WMenu.InsertMenu (WMenu.GetMenu (player^.windows.frame),1,Windows.MF_BYPOSITION + Windows.MF_STRING,RecitePrayerControl,"&Prayers",done);
    ELSIF player^.character^.constants.class IN MCStruct.MageClasses THEN
      WMenu.InsertMenu (WMenu.GetMenu (player^.windows.frame),1,Windows.MF_BYPOSITION + Windows.MF_STRING,CastSpellControl,"&Spells",done);
    END; (* IF *)
    
    IF player^.character^.constants.class <> MCStruct.Warrior THEN
      WMenu.DrawMenuBar (player^.windows.frame);
    END; (* IF *)
    
    SetSearchMarker (player^.windows.frame,MCStruct.SearchFLAG IN player^.character^.variables.status);
    
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      AppendWizardMenu (player^.windows.frame);
    END; (* IF *)
  END SetStandardMenu;
  
  PROCEDURE UpdateWizardMenu (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
    PROCEDURE WizardMenuPosition (player : MStruct.PlayerInfoPointer) : CARDINAL;
      CONST
            NonWarriorWizardMenuPosition = 6;
            WarriorWizardMenuPosition    = 5;
      
    BEGIN (* WizardMenuPosition *)
      IF player^.character^.constants.class <> MCStruct.Warrior THEN
        RETURN (NonWarriorWizardMenuPosition);
      ELSE
        RETURN (WarriorWizardMenuPosition);
      END; (* IF *)
    END WizardMenuPosition;
    
  BEGIN (* UpdateWizardMenu *)
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      AppendWizardMenu (player^.windows.frame);
    ELSE
      WMenu.DeleteMenu (WMenu.GetMenu (player^.windows.frame),WizardMenuPosition (player),Windows.MF_BYPOSITION,done);
      WMenu.DrawMenuBar (player^.windows.frame);
    END; (* IF *)
  END UpdateWizardMenu;
END MMenu.
