IMPLEMENTATION MODULE MMouse;
  (*/WIN:A*)
  
  IMPORT WDialog,Windows,WListBox;
  IMPORT SYSTEM;
  
  IMPORT MCommands,MCommStr,MDialogs,MInitFile;
  IMPORT DStruct,MStruct;
  IMPORT MMouse2;
  
  
  CONST
        MoriaCommandTableListBoxControl = 1815;
        MouseActionTableListBoxControl  = 1802;
  
  TYPE
       MouseDefinitionPointer = POINTER TO MouseDefinitions;
       MouseDefinitions       = ARRAY MouseButtonMnemonic,ShiftKeyMnemonic OF MCommands.MoriaCommandMnemonic;
  
  CONST
        NumberShiftKeys = ORD (MAX (ShiftKeyMnemonic)) + 1;
  
  VAR
      MouseActionTable : MouseDefinitions;
  
  
  PROCEDURE CloseMouseDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
  BEGIN (* CloseMouseDialog *)
    WDialog.EndDialog (window,Windows.FALSE_BOOL);
  END CloseMouseDialog;
  
  PROCEDURE CurrentShiftKey (flags : CARDINAL) : ShiftKeyMnemonic;
  BEGIN (* CurrentShiftKey *)
    IF (ODD (flags DIV Windows.MK_CONTROL) AND ODD (flags DIV Windows.MK_SHIFT)) THEN
      RETURN (ControlShift);
    ELSIF ODD (flags DIV Windows.MK_CONTROL) THEN
      RETURN (ControlKey);
    ELSIF ODD (flags DIV Windows.MK_SHIFT) THEN
      RETURN (ShiftKey);
    ELSE
      RETURN (NotShifted);
    END; (* IF *)
  END CurrentShiftKey;
  
  PROCEDURE ExecuteDefineMouseCommand (player : MStruct.PlayerInfoPointer);
    VAR
        result : INTEGER;
        temp   : MouseDefinitions;
    
  BEGIN (* ExecuteDefineMouseCommand *)
    temp := MouseActionTable;
    
    MDialogs.ExecuteMoriaDialogBoxParam (MStruct.CurrentPlayerFrameWindow,"Mouse_Dialog",player,SYSTEM.ADR (temp),InitializeMouseDialog,ExecuteMouseDialogCommand,CloseMouseDialog,result);
    
    IF result = Windows.TRUE_BOOL THEN
      MouseActionTable := temp;
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteDefineMouseCommand;
  
  PROCEDURE ExecuteMouseDialogCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS; control : CARDINAL; command : CARDINAL);
    CONST
          ControlCheckBoxControl = 1809;
          ShiftCheckBoxControl   = 1808;
    
    CONST
          RightButtonRadioButtonControl = 1805;
          LeftButtonRadioButtonControl  = 1804;
    
    CONST
          AcceptAllPushButtonControl = 1812;
          CancelAllPushButtonControl = Windows.IDCANCEL;
          SaveAllPushButtonControl   = 1811;
          DefinePushButtonControl    = Windows.IDOK;
    
    PROCEDURE ExecuteAcceptAllButtonAction (window : Windows.HWND; command : CARDINAL);
    BEGIN (* ExecuteAcceptAllButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        WDialog.EndDialog (window,Windows.TRUE_BOOL);
      END; (* IF *)
    END ExecuteAcceptAllButtonAction;
    
    PROCEDURE ExecuteCancelAllButtonAction (window : Windows.HWND; command : CARDINAL);
    BEGIN (* ExecuteCancelAllButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        WDialog.EndDialog (window,Windows.FALSE_BOOL);
      END; (* IF *)
    END ExecuteCancelAllButtonAction;
    
    PROCEDURE ExecuteDefineButtonAction (window : Windows.HWND; table : MouseDefinitionPointer; command : CARDINAL);
      VAR
          position : CARDINAL;
      
      PROCEDURE UpdateMouseActionTableListBox (control : Windows.HWND; position : CARDINAL; button : MouseButtonMnemonic; shift : ShiftKeyMnemonic; command : MCommands.MoriaCommandMnemonic);
        VAR
            result : Windows.LRESULT;
        
      BEGIN (* UpdateMouseActionTableListBox *)
        WListBox.DeleteString (control,position,result);
        MMouse2.InsertMouseAction (control,position,button,shift,command);
      END UpdateMouseActionTableListBox;
      
    BEGIN (* ExecuteDefineButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        position := WListBox.GetCurSel (WDialog.GetDlgItem (window,MouseActionTableListBoxControl));
        
        table^ [VAL (MouseButtonMnemonic,position DIV NumberShiftKeys),VAL (ShiftKeyMnemonic,position MOD NumberShiftKeys)] := VAL (MCommands.MoriaCommandMnemonic,WListBox.CurrentlySelectedItemData (WDialog.GetDlgItem (window,MoriaCommandTableListBoxControl)));
        
        UpdateMouseActionTableListBox (WDialog.GetDlgItem (window,MouseActionTableListBoxControl),position,VAL (MouseButtonMnemonic,position DIV NumberShiftKeys),VAL (ShiftKeyMnemonic,position MOD NumberShiftKeys),table^ [VAL (MouseButtonMnemonic,position DIV NumberShiftKeys),VAL (ShiftKeyMnemonic,position MOD NumberShiftKeys)]);
        
        WDialog.EnableDialogControl (window,MoriaCommandTableListBoxControl,FALSE);
        WDialog.EnableDialogControl (window,DefinePushButtonControl,FALSE);
      END; (* IF *)
    END ExecuteDefineButtonAction;
    
    PROCEDURE ExecuteMouseActionTableCommand (window : Windows.HWND; table : MouseDefinitionPointer; command : CARDINAL);
      PROCEDURE SelectMouseAction (window : Windows.HWND; table : MouseDefinitions; position : CARDINAL);
        PROCEDURE SelectMouseCommand (control : Windows.HWND; command : MCommands.MoriaCommandMnemonic);
          VAR
              result : Windows.LRESULT;
              text   : ARRAY [0..127] OF CHAR;
          
        BEGIN (* SelectMouseCommand *)
          MCommStr.CommandMnemonicToString (command,text);
          
          WListBox.FindStringExact (control,-1,text,result);
          WListBox.SetCurSel (control,result,result);
        END SelectMouseCommand;
        
        PROCEDURE SetActionButton (window : Windows.HWND; button : MouseButtonMnemonic);
        BEGIN (* SetActionButton *)
          IF button = RightButton THEN
            WDialog.CheckRadioButton (window,LeftButtonRadioButtonControl,RightButtonRadioButtonControl,RightButtonRadioButtonControl);
          ELSE
            WDialog.CheckRadioButton (window,LeftButtonRadioButtonControl,RightButtonRadioButtonControl,LeftButtonRadioButtonControl);
          END; (* IF *)
        END SetActionButton;
        
        PROCEDURE SetActionShiftStatus (window : Windows.HWND; status : ShiftKeyMnemonic);
        BEGIN (* SetActionShiftStatus *)
          WDialog.CheckDlgButton (window,ControlCheckBoxControl,Windows.FALSE_BOOL);
          WDialog.CheckDlgButton (window,ShiftCheckBoxControl,Windows.FALSE_BOOL);
          
          CASE status OF
            ControlShift : WDialog.CheckDlgButton (window,ControlCheckBoxControl,Windows.TRUE_BOOL); 
                           WDialog.CheckDlgButton (window,ShiftCheckBoxControl,Windows.TRUE_BOOL);   |
            ControlKey   : WDialog.CheckDlgButton (window,ControlCheckBoxControl,Windows.TRUE_BOOL); |
            ShiftKey     : WDialog.CheckDlgButton (window,ShiftCheckBoxControl,Windows.TRUE_BOOL);   |
            
            NotShifted   : (* no action *) |
          END; (* CASE *)
        END SetActionShiftStatus;
        
      BEGIN (* SelectMouseAction *)
        SetActionShiftStatus (window,VAL (ShiftKeyMnemonic,position MOD NumberShiftKeys));
        SetActionButton (window,VAL (MouseButtonMnemonic,position DIV NumberShiftKeys));
        
        SelectMouseCommand (WDialog.GetDlgItem (window,MoriaCommandTableListBoxControl),table [VAL (MouseButtonMnemonic,position DIV NumberShiftKeys),VAL (ShiftKeyMnemonic,position MOD NumberShiftKeys)]);
      END SelectMouseAction;
      
    BEGIN (* ExecuteMouseActionTableCommand *)
      IF command = Windows.LBN_SELCHANGE THEN
        SelectMouseAction (window,table^,WListBox.GetCurSel (WDialog.GetDlgItem (window,MouseActionTableListBoxControl)));
        
        WDialog.EnableDialogControl (window,MoriaCommandTableListBoxControl,TRUE);
        WDialog.EnableDialogControl (window,DefinePushButtonControl,TRUE);
      END; (* IF *)
    END ExecuteMouseActionTableCommand;
    
    PROCEDURE ExecuteSaveAllButtonAction (window : Windows.HWND; table : MouseDefinitionPointer; command : CARDINAL);
      VAR
          button : MouseButtonMnemonic;
          shift  : ShiftKeyMnemonic;
      
      PROCEDURE SaveUserMouseAction (button : MouseButtonMnemonic; shift : ShiftKeyMnemonic; command : MCommands.MoriaCommandMnemonic);
      BEGIN (* SaveUserMouseAction *)
        MInitFile.SetMouseActionValue (ORD (button) * NumberShiftKeys + ORD (shift),ORD (command));
      END SaveUserMouseAction;
      
    BEGIN (* ExecuteSaveAllButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        FOR button := MIN (MouseButtonMnemonic) TO MAX (MouseButtonMnemonic) DO
          FOR shift := MIN (ShiftKeyMnemonic) TO MAX (ShiftKeyMnemonic) DO
            SaveUserMouseAction (button,shift,table^ [button,shift]);
          END; (* FOR *)
        END; (* FOR *)
        
        WDialog.EndDialog (window,Windows.TRUE_BOOL);
      END; (* IF *)
    END ExecuteSaveAllButtonAction;
    
  BEGIN (* ExecuteMouseDialogCommand *)
    CASE control OF
      MouseActionTableListBoxControl : ExecuteMouseActionTableCommand (window,MouseDefinitionPointer (data),command); |
      
      AcceptAllPushButtonControl : ExecuteAcceptAllButtonAction (window,command);                             |
      CancelAllPushButtonControl : ExecuteCancelAllButtonAction (window,command);                             |
      SaveAllPushButtonControl   : ExecuteSaveAllButtonAction (window,MouseDefinitionPointer (data),command); |
      
      DefinePushButtonControl    : ExecuteDefineButtonAction (window,MouseDefinitionPointer (data),command); |
      
      LeftButtonRadioButtonControl,RightButtonRadioButtonControl : (* no action *) |
      ShiftCheckBoxControl..ControlCheckBoxControl               : (* no action *) |
      MoriaCommandTableListBoxControl                            : (* no action *) |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteMouseDialogCommand;
  
  PROCEDURE ExecuteRightMouseButtonAction (player : MStruct.PlayerInfoPointer; flags : CARDINAL; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
  BEGIN (* ExecuteRightMouseButtonAction *)
    player^.target.defined := TRUE;
    player^.target.column  := column;
    player^.target.line    := line;
    
    MCommands.ExecuteCharacterCommand (player,MouseActionTable [RightButton,CurrentShiftKey (flags)]);
    
    player^.target.defined := FALSE;
  END ExecuteRightMouseButtonAction;
  
  PROCEDURE ExecuteStandardLeftMouseButtonAction (player : MStruct.PlayerInfoPointer; flags : CARDINAL; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
  BEGIN (* ExecuteStandardLeftMouseButtonAction *)
    player^.target.defined := TRUE;
    player^.target.column  := column;
    player^.target.line    := line;
    
    MCommands.ExecuteCharacterCommand (player,MouseActionTable [LeftButton,CurrentShiftKey (flags)]);
    
    player^.target.defined := FALSE;
  END ExecuteStandardLeftMouseButtonAction;
  
  PROCEDURE InitializeMouseDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
    PROCEDURE InitializeMoriaCommandTable (control : Windows.HWND);
      TYPE
           CommandActionRange = [MCommands.AscendStairs..MCommands.ViewScores];
      
      VAR
          index : CommandActionRange;
      
    BEGIN (* InitializeMoriaCommandTable *)
      WListBox.ResetContent (control);
      
      FOR index := MIN (CommandActionRange) TO MAX (CommandActionRange) DO
        MMouse2.AddMoriaCommandMnemonic (control,index);
      END; (* FOR *)
    END InitializeMoriaCommandTable;
    
    PROCEDURE InitializeMouseActionTable (control : Windows.HWND; table : MouseDefinitionPointer);
      VAR
          button : MouseButtonMnemonic;
          shift  : ShiftKeyMnemonic;
          done   : BOOLEAN;
      
    BEGIN (* InitializeMouseActionTable *)
      WListBox.SetTabDistance (control,16 * WListBox.DialogUnitsPerCharacter,done);
      WListBox.ResetContent (control);
      
      FOR button := MIN (MouseButtonMnemonic) TO MAX (MouseButtonMnemonic) DO
        FOR shift := MIN (ShiftKeyMnemonic) TO MAX (ShiftKeyMnemonic) DO
          MMouse2.InsertMouseAction (control,ORD (button) * NumberShiftKeys + ORD (shift),button,shift,table^ [button,shift]);
        END; (* FOR *)
      END; (* FOR *)
    END InitializeMouseActionTable;
    
  BEGIN (* InitializeMouseDialog *)
    InitializeMoriaCommandTable (WDialog.GetDlgItem (window,MoriaCommandTableListBoxControl));
    InitializeMouseActionTable (WDialog.GetDlgItem (window,MouseActionTableListBoxControl),MouseDefinitionPointer (data));
  END InitializeMouseDialog;
  
  PROCEDURE InitializeStandardMouseActionTable (VAR table : MouseDefinitions);
  BEGIN (* InitializeStandardMouseActionTable *)
    table [LeftButton,NotShifted]   := MCommands.MoveToLocation;
    table [RightButton,NotShifted]  := MCommands.Look;
    
    table [LeftButton,ControlKey]   := MCommands.OpenObject;
    table [RightButton,ControlKey]  := MCommands.CloseObject;
    
    table [LeftButton,ShiftKey]   := MCommands.CastMagicSpell;
    table [RightButton,ShiftKey]  := MCommands.UseWand;
    
    table [LeftButton,ControlShift]  := MCommands.Tunnel;
    table [RightButton,ControlShift] := MCommands.RestMultipleTurns;
  END InitializeStandardMouseActionTable;
  
  PROCEDURE LoadUserMouseActions (VAR table : MouseDefinitions);
    VAR
        button : MouseButtonMnemonic;
        shift  : ShiftKeyMnemonic;
    
    PROCEDURE LoadUserMouseAction (button : MouseButtonMnemonic; shift : ShiftKeyMnemonic; VAR result : MCommands.MoriaCommandMnemonic);
      VAR
          temp : INTEGER;
      
    BEGIN (* LoadUserMouseAction *)
      MInitFile.DetermineMouseActionValue (ORD (button) * NumberShiftKeys + ORD (shift),temp);
      
      IF temp >= 0 THEN
        result := VAL (MCommands.MoriaCommandMnemonic,temp);
      END; (* IF *)
    END LoadUserMouseAction;
    
  BEGIN (* LoadUserMouseActions *)
    FOR button := MIN (MouseButtonMnemonic) TO MAX (MouseButtonMnemonic) DO
      FOR shift := MIN (ShiftKeyMnemonic) TO MAX (ShiftKeyMnemonic) DO
        LoadUserMouseAction (button,shift,table [button,shift]);
      END; (* FOR *)
    END; (* FOR *)
  END LoadUserMouseActions;

BEGIN (* MMouse *)
  ExecuteLeftMouseButtonAction := ExecuteStandardLeftMouseButtonAction;
  
  InitializeStandardMouseActionTable (MouseActionTable);
  LoadUserMouseActions (MouseActionTable);
END MMouse.
