IMPLEMENTATION MODULE MMTrans2;
  (*/WIN:A*)

  IMPORT WDebugging,Windows;
  
  IMPORT MKeys,MMenu,MMouse,MMTranslator,MMWindow;
  IMPORT DStruct,MCStruct,MStruct;
  IMPORT DSActions;
  
  
  PROCEDURE ExecuteDirectedMouseAction (player : MStruct.PlayerInfoPointer; flags : CARDINAL; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    PROCEDURE DirectionForLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange) : CARDINAL;
    BEGIN (* DirectionForLocation *)
      IF line < player^.character^.line THEN
        IF column < player^.character^.column THEN
          RETURN (7);
        ELSIF column > player^.character^.column THEN
          RETURN (9);
        ELSE
          RETURN (8);
        END; (* IF *)
      ELSIF line > player^.character^.line THEN
        IF column < player^.character^.column THEN
          RETURN (1);
        ELSIF column > player^.character^.column THEN
          RETURN (3);
        ELSE
          RETURN (2);
        END; (* IF *)
      ELSIF column < player^.character^.column THEN
        RETURN (4);
      ELSIF column > player^.character^.column THEN
        RETURN (6);
      END; (* IF *)
      
      WDebugging.FatalAppExit ("Invalid mouse direction.");
    END DirectionForLocation;
    
    PROCEDURE ValidDirectionLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange) : BOOLEAN;
    BEGIN (* ValidDirectionLocation *)
      IF ((ABS (player^.character^.line - line) <= 1) AND (ABS (player^.character^.column - column) <= 1)) THEN
        RETURN ((player^.character^.line <> line) OR (player^.character^.column <> column));
      ELSE
        RETURN (FALSE);
      END; (* IF *)
    END ValidDirectionLocation;
    
  BEGIN (* ExecuteDirectedMouseAction *)
    IF ValidDirectionLocation (player,line,column) THEN
      MMTranslator.ExecuteDirectionCommand (player,DirectionForLocation (player,line,column));
      
      MMouse.ExecuteLeftMouseButtonAction := MMouse.ExecuteStandardLeftMouseButtonAction;
      MMTranslator.ExecuteKeyDownAction   := MMTranslator.ExecuteStandardKeyDownAction;
      MMTranslator.ExecuteCharAction      := MMTranslator.ExecuteStandardCharAction;
      
      MMenu.EnableMainWindowMenu (player^.windows.frame,TRUE);
    END; (* IF *)
  END ExecuteDirectedMouseAction;
  
  PROCEDURE ExecuteTargetedCharAction (player : MStruct.PlayerInfoPointer; value : CARDINAL);
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
    
    PROCEDURE DetermineDirectedTarget (player : MStruct.PlayerInfoPointer; direction : CARDINAL; VAR resultLINE : DStruct.DungeonLineRange; VAR resultCOLUMN : DStruct.DungeonColumnRange);
      VAR
          tempCOLUMN,tempLINE : INTEGER;
          distance            : CARDINAL;
      
    BEGIN (* DetermineDirectedTarget *)
      resultCOLUMN := player^.character^.column;
      resultLINE   := player^.character^.line;
      distance     := 0;
      
      LOOP
        DSActions.DetermineDungeonLocation (resultLINE,resultCOLUMN,direction,tempLINE,tempCOLUMN);
        INC (distance);
        
        IF ((distance = MCStruct.MaxCharacterSightDistance) OR NOT (DSActions.LocationInBounds (player^.dungeon^,tempLINE,tempCOLUMN))) THEN
          EXIT;
        END; (* IF *)
        
        resultCOLUMN := tempCOLUMN;
        resultLINE   := tempLINE;
      END; (* LOOP *)
    END DetermineDirectedTarget;
    
  BEGIN (* ExecuteTargetedCharAction *)
    IF MKeys.ValidDirectionCharacter (value) THEN
      DetermineDirectedTarget (player,MKeys.DirectionForCharacter (value),line,column);
      MMTranslator.ExecuteTargetCommand (player,line,column);
      
      MMouse.ExecuteLeftMouseButtonAction := MMouse.ExecuteStandardLeftMouseButtonAction;
      MMTranslator.ExecuteKeyDownAction   := MMTranslator.ExecuteStandardKeyDownAction;
      MMTranslator.ExecuteCharAction      := MMTranslator.ExecuteStandardCharAction;
      
      MMenu.EnableMainWindowMenu (player^.windows.frame,TRUE);
    ELSIF value = Windows.VK_ESCAPE THEN
      MMWindow.AddMessageToList (player,"Directed command canceled.");
      
      MMouse.ExecuteLeftMouseButtonAction := MMouse.ExecuteStandardLeftMouseButtonAction;
      MMTranslator.ExecuteKeyDownAction   := MMTranslator.ExecuteStandardKeyDownAction;
      MMTranslator.ExecuteCharAction      := MMTranslator.ExecuteStandardCharAction;
      
      MMenu.EnableMainWindowMenu (player^.windows.frame,TRUE);
    END; (* IF *)
  END ExecuteTargetedCharAction;
  
  PROCEDURE ExecuteTargetedMouseAction (player : MStruct.PlayerInfoPointer; flags : CARDINAL; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
  BEGIN (* ExecuteTargetedMouseAction *)
    IF ((line <> player^.character^.line) OR (column <> player^.character^.column)) THEN
      MMTranslator.ExecuteTargetCommand (player,line,column);
      
      MMouse.ExecuteLeftMouseButtonAction := MMouse.ExecuteStandardLeftMouseButtonAction;
      MMTranslator.ExecuteKeyDownAction   := MMTranslator.ExecuteStandardKeyDownAction;
      MMTranslator.ExecuteCharAction      := MMTranslator.ExecuteStandardCharAction;
      
      MMenu.EnableMainWindowMenu (player^.windows.frame,TRUE);
    END; (* IF *)
  END ExecuteTargetedMouseAction;
END MMTrans2.
