IMPLEMENTATION MODULE MOParser;
  (*/WIN:A*)
  
  IMPORT WDebugging,Windows,WResource;
  IMPORT MParser,OStruct;
  IMPORT Strings;
  
  
  PROCEDURE ParseObjectInfoRecord (instance : Windows.HINSTANCE; cursor : CARDINAL; VAR result : OStruct.ObjectInfoRecord);
    VAR
        length : CARDINAL;
        str    : ARRAY [0..255] OF CHAR;
    
    PROCEDURE ParseObjectFlagsField (VAR str : ARRAY OF CHAR; term : CHAR; VAR result : OStruct.ObjectAttributeFlags);
      VAR
          value : LONGCARD;
      
      PROCEDURE DetermineObjectAttributeFlags (value : LONGCARD; VAR result : OStruct.ObjectAttributeFlags);
        VAR
            index : OStruct.ObjectAttributeMnemonic;
        
      BEGIN (* DetermineObjectAttributeFlags *)
        result := OStruct.ObjectAttributeFlags {};
        index  := MIN (OStruct.ObjectAttributeMnemonic);
        
        WHILE value <> 0 DO
          IF ODD (value) THEN
            INCL (result,index);
          END; (* IF *)
          
          value := value DIV 2;
          INC (index);
        END; (* WHILE *)
      END DetermineObjectAttributeFlags;
      
    BEGIN (* ParseObjectFlagsField *)
      MParser.ParseHexLongCardValue (str,term,value);
      DetermineObjectAttributeFlags (value,result);
    END ParseObjectFlagsField;
    
    PROCEDURE ParseObjectTValField (VAR str : ARRAY OF CHAR; term : CHAR; VAR result : OStruct.ObjectClassMnemonic);
      VAR
          value : ARRAY [0..127] OF CHAR;
      
    BEGIN (* ParseObjectTValField *)
      MParser.ParseNextSymbol (str,term,value);
      
      IF Strings.CompareStr (value,"TV_NOTHING") = 0 THEN
        result := OStruct.Nothing;
      ELSIF Strings.CompareStr (value,"TV_MISC") = 0 THEN
        result := OStruct.Miscellaneous;
      ELSIF Strings.CompareStr (value,"TV_CHEST") = 0 THEN
        result := OStruct.Chest;
      ELSIF Strings.CompareStr (value,"TV_SLING_AMMO") = 0 THEN
        result := OStruct.SlingAmmo;
      ELSIF Strings.CompareStr (value,"TV_BOLT") = 0 THEN
        result := OStruct.Bolt;
      ELSIF Strings.CompareStr (value,"TV_ARROW") = 0 THEN
        result := OStruct.Arrow;
      ELSIF Strings.CompareStr (value,"TV_SPIKE") = 0 THEN
        result := OStruct.Spike;
      ELSIF Strings.CompareStr (value,"TV_LIGHT") = 0 THEN
        result := OStruct.Light;
      ELSIF Strings.CompareStr (value,"TV_BOW") = 0 THEN
        result := OStruct.MissileWeapon;
      ELSIF Strings.CompareStr (value,"TV_HAFTED") = 0 THEN
        result := OStruct.HaftedWeapon;
      ELSIF Strings.CompareStr (value,"TV_POLEARM") = 0 THEN
        result := OStruct.PoleWeapon;
      ELSIF Strings.CompareStr (value,"TV_SWORD") = 0 THEN
        result := OStruct.BladeWeapon;
      ELSIF Strings.CompareStr (value,"TV_DIGGING") = 0 THEN
        result := OStruct.DiggingTool;
      ELSIF Strings.CompareStr (value,"TV_BOOTS") = 0 THEN
        result := OStruct.Boots;
      ELSIF Strings.CompareStr (value,"TV_GLOVES") = 0 THEN
        result := OStruct.Gloves;
      ELSIF Strings.CompareStr (value,"TV_CLOAK") = 0 THEN
        result := OStruct.Cloak;
      ELSIF Strings.CompareStr (value,"TV_HELM") = 0 THEN
        result := OStruct.Helm;
      ELSIF Strings.CompareStr (value,"TV_SHIELD") = 0 THEN
        result := OStruct.Shield;
      ELSIF Strings.CompareStr (value,"TV_HARD_ARMOR") = 0 THEN
        result := OStruct.HardBodyArmor;
      ELSIF Strings.CompareStr (value,"TV_SOFT_ARMOR") = 0 THEN
        result := OStruct.SoftBodyArmor;
      ELSIF Strings.CompareStr (value,"TV_AMULET") = 0 THEN
        result := OStruct.Amulet;
      ELSIF Strings.CompareStr (value,"TV_RING") = 0 THEN
        result := OStruct.Ring;
      ELSIF Strings.CompareStr (value,"TV_STAFF") = 0 THEN
        result := OStruct.Staff;
      ELSIF Strings.CompareStr (value,"TV_WAND") = 0 THEN
        result := OStruct.Wand;
      ELSIF Strings.CompareStr (value,"TV_SCROLL1") = 0 THEN
        result := OStruct.Scroll1;
      ELSIF Strings.CompareStr (value,"TV_SCROLL2") = 0 THEN
        result := OStruct.Scroll2;
      ELSIF Strings.CompareStr (value,"TV_POTION1") = 0 THEN
        result := OStruct.Potion1;
      ELSIF Strings.CompareStr (value,"TV_POTION2") = 0 THEN
        result := OStruct.Potion2;
      ELSIF Strings.CompareStr (value,"TV_FLASK") = 0 THEN
        result := OStruct.Flask;
      ELSIF Strings.CompareStr (value,"TV_FOOD") = 0 THEN
        result := OStruct.Food;
      ELSIF Strings.CompareStr (value,"TV_MAGIC_BOOK") = 0 THEN
        result := OStruct.MagicBook;
      ELSIF Strings.CompareStr (value,"TV_PRAYER_BOOK") = 0 THEN
        result := OStruct.PrayerBook;
      ELSIF Strings.CompareStr (value,"TV_GOLD") = 0 THEN
        result := OStruct.Gold;
      ELSIF Strings.CompareStr (value,"TV_INVIS_TRAP") = 0 THEN
        result := OStruct.InvisibleTrap;
      ELSIF Strings.CompareStr (value,"TV_VIS_TRAP") = 0 THEN
        result := OStruct.VisibleTrap;
      ELSIF Strings.CompareStr (value,"TV_RUBBLE") = 0 THEN
        result := OStruct.Rubble;
      ELSIF Strings.CompareStr (value,"TV_OPEN_DOOR") = 0 THEN
        result := OStruct.OpenDoor;
      ELSIF Strings.CompareStr (value,"TV_CLOSED_DOOR") = 0 THEN
        result := OStruct.ClosedDoor;
      ELSIF Strings.CompareStr (value,"TV_UP_STAIR") = 0 THEN
        result := OStruct.UpStair;
      ELSIF Strings.CompareStr (value,"TV_DOWN_STAIR") = 0 THEN
        result := OStruct.DownStair;
      ELSIF Strings.CompareStr (value,"TV_SECRET_DOOR") = 0 THEN
        result := OStruct.SecretDoor;
      ELSIF Strings.CompareStr (value,"TV_STORE_DOOR") = 0 THEN
        result := OStruct.StoreDoor;
      ELSE
        WDebugging.FatalAppExit ("Unrecognized object tval while parsing Moria treasure data.");
      END; (* IF *)
    END ParseObjectTValField;
    
  BEGIN (* ParseObjectInfoRecord *)
    WResource.LoadString (instance,cursor,str,length);
    
    WITH result DO
      MParser.ParseLiteralString (str,MParser.StandardItemTerminator,description);
      ParseObjectFlagsField (str,MParser.StandardItemTerminator,attributes);
      ParseObjectTValField (str,MParser.StandardItemTerminator,class);
      MParser.ParseLiteralChar (str,MParser.StandardItemTerminator,symbol);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,miscellaneous);
      MParser.ParseLongIntValue (str,MParser.StandardItemTerminator,value);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,subclass);
      MParser.ParseCardinalValue (str,MParser.StandardItemTerminator,quantity);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,weight);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,strikeMOD);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,damageMOD);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,armor);
      MParser.ParseIntegerValue (str,MParser.StandardItemTerminator,armorMOD);
      MParser.ParseRandomRangeSpecifier (str,MParser.StandardItemTerminator,TRUE,damage);
      MParser.ParseCardinalValue (str,MParser.FinalItemTerminator,depth);
    END; (* WITH *)
  END ParseObjectInfoRecord;
END MOParser.
