IMPLEMENTATION MODULE MOpen2;
  (*/WIN:A*)
  
  IMPORT CStruct,DStruct,MCStruct,MStruct,OStruct;
  IMPORT WError,WinFiles,Windows;
  IMPORT FileSystem,Strings;
  
  
  PROCEDURE InputPlayerInformationFile (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
    VAR
        f : FileSystem.File;
    
  BEGIN (* InputPlayerInformationFile *)
    WinFiles.OpenFile (f,player^.fileNAME);
    
    IF f.res = FileSystem.done THEN
      ReadPlayerInformationFile (f,player,done);
      
      IF NOT (done) THEN
        WError.DisplayInformationBox (player^.windows.frame,MStruct.MainWindowTitle,"Unable to read character file.");
      END; (* IF *)
      
      WinFiles.CloseFile (f);
    ELSE
      WError.DisplayInformationBox (player^.windows.frame,MStruct.MainWindowTitle,"Unable to open character file.");
    END; (* IF *)
  END InputPlayerInformationFile;
  
  PROCEDURE ReadPlayerInformationFile (VAR f : FileSystem.File; player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
    PROCEDURE ReadCharacterInformation (VAR f : FileSystem.File; character : MCStruct.CharacterInfoPointer; VAR done : BOOLEAN);
    BEGIN (* ReadCharacterInformation *)
      WinFiles.ReadDataStructure (f,character^);
      done := (f.res = FileSystem.done);
    END ReadCharacterInformation;
    
    PROCEDURE ReadCreatureInformation (VAR f : FileSystem.File; creatures : CStruct.CreatureInfoPointer; VAR done : BOOLEAN);
      VAR
          index : CARDINAL;
      
    BEGIN (* ReadCreatureInformation *)
      index := 0;
      
      REPEAT
        WinFiles.ReadDataStructure (f,creatures^.table [index].memory);
        INC (index);
      UNTIL ((index = CStruct.MaxNumberCreatures) OR (f.res <> FileSystem.done));
      
      done := (f.res = FileSystem.done);
    END ReadCreatureInformation;
    
    PROCEDURE ReadDungeonInformation (VAR f : FileSystem.File; VAR dungeon : DStruct.DungeonInformation; VAR done : BOOLEAN);
      PROCEDURE ReadOtherDungeonInformation (VAR f : FileSystem.File; VAR dungeon : DStruct.DungeonInformation; VAR done : BOOLEAN);
      BEGIN (* ReadOtherDungeonInformation *)
        done := FALSE;
        
        WinFiles.ReadDataStructure (f,dungeon.columns);
        
        IF f.res <> FileSystem.done THEN
          RETURN;
        END; (* IF *)
        
        WinFiles.ReadDataStructure (f,dungeon.lines);
        
        IF f.res <> FileSystem.done THEN
          RETURN;
        END; (* IF *)
        
        WinFiles.ReadDataStructure (f,dungeon.artifacts);
        
        IF f.res <> FileSystem.done THEN
          RETURN;
        END; (* IF *)
        
        WinFiles.ReadDataStructure (f,dungeon.creatures);
        
        IF f.res <> FileSystem.done THEN
          RETURN;
        END; (* IF *)
        
        WinFiles.ReadDataStructure (f,dungeon.multipliedCreatures);
        
        IF f.res <> FileSystem.done THEN
          RETURN;
        END; (* IF *)
        
        WinFiles.ReadDataStructure (f,dungeon.firstCOLUMN);
        
        IF f.res <> FileSystem.done THEN
          RETURN;
        END; (* IF *)
        
        WinFiles.ReadDataStructure (f,dungeon.firstLINE);
        
        IF f.res <> FileSystem.done THEN
          RETURN;
        END; (* IF *)
        
        WinFiles.ReadDataStructure (f,dungeon.town);
        
        IF f.res <> FileSystem.done THEN
          RETURN;
        END; (* IF *)
        
        done := TRUE;
      END ReadOtherDungeonInformation;
      
      PROCEDURE ReadPhysicalDungeonInformation (VAR f : FileSystem.File; VAR lines : ARRAY OF DStruct.PhysicalDungeonLinePointer; VAR done : BOOLEAN);
        VAR
            index : CARDINAL;
        
      BEGIN (* ReadPhysicalDungeonInformation *)
        index := 0;
        
        REPEAT
          WinFiles.ReadDataStructure (f,lines [index]^);
          INC (index);
        UNTIL ((index = DStruct.NumberDungeonLines) OR (f.res <> FileSystem.done));
        
        done := (f.res = FileSystem.done);
      END ReadPhysicalDungeonInformation;
      
    BEGIN (* ReadDungeonInformation *)
      ReadPhysicalDungeonInformation (f,dungeon.physical,done);
      
      IF done THEN
        ReadOtherDungeonInformation (f,dungeon,done);
      END; (* IF *)
    END ReadDungeonInformation;
    
    PROCEDURE ReadTreasureInformation (VAR f : FileSystem.File; treasures : OStruct.TreasureInfoPointer; VAR done : BOOLEAN);
    BEGIN (* ReadTreasureInformation *)
      WinFiles.ReadDataStructure (f,treasures^.identification);
      
      IF f.res = FileSystem.done THEN
        WinFiles.ReadDataStructure (f,treasures^.seed);
      END; (* IF *)
      
      done := (f.res = FileSystem.done);
    END ReadTreasureInformation;
    
    PROCEDURE VerifyVersionInformation (VAR f : FileSystem.File; window : Windows.HWND; VAR done : BOOLEAN);
      VAR
          text : ARRAY [0..127] OF CHAR;
      
    BEGIN (* VerifyVersionInformation *)
      WinFiles.ReadFileString (f,text);
      
      IF ((f.res = FileSystem.done) AND (Strings.CompareStr (MStruct.CurrentVersionInformation,text) <> 0)) THEN
        WError.DisplayInformationBox (window,MStruct.MainWindowTitle,"Incorrect Moria character file version or not a Moria character file.");
        done := FALSE;
      ELSE
        done := (f.res = FileSystem.done);
      END; (* IF *)
    END VerifyVersionInformation;
    
  BEGIN (* ReadPlayerInformationFile *)
    VerifyVersionInformation (f,player^.windows.frame,done);
    
    IF NOT (done) THEN
      RETURN;
    END; (* IF *)
    
    ReadCharacterInformation (f,player^.character,done);
    
    IF NOT (done) THEN
      RETURN;
    END; (* IF *)
    
    ReadCreatureInformation (f,player^.creatures,done);
    
    IF NOT (done) THEN
      RETURN;
    END; (* IF *)
    
    ReadTreasureInformation (f,player^.treasures,done);
    
    IF NOT (done) THEN
      RETURN;
    END; (* IF *)
    
    ReadDungeonInformation (f,player^.dungeon^,done);
  END ReadPlayerInformationFile;
END MOpen2.
