IMPLEMENTATION MODULE MOptions;
  (*/WIN:A*)
  
  IMPORT MCStruct,MStruct;
  IMPORT WDialog,Windows;
  IMPORT MDialogs;
  
  
  CONST
        FindCutControl        = 1402;
        FindExamineControl    = 1403;
        FindIgnoreControl     = 1404;
        PromptCarryControl    = 1405;
        HighlightSeamsControl = 1407;
  
  
  PROCEDURE CloseOptionsDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* CloseOptionsDialog *)
    WDialog.EndDialog (window,Windows.FALSE_BOOL);
  END CloseOptionsDialog;
  
  PROCEDURE ExecuteOptionsDialogCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; command : CARDINAL);
    CONST
          AcceptPushButtonControl = 1408;
          CancelPushButtonControl = 1409;
    
    PROCEDURE ExecuteAcceptButtonAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
      PROCEDURE DeterminePlayerOptions (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
        PROCEDURE DeterminePlayerMovementFlag (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; option : MCStruct.PlayerMovementMnemonic);
        BEGIN (* DeterminePlayerMovementFlag *)
          IF WDialog.IsDlgButtonChecked (window,control) = Windows.FALSE_BOOL THEN
            EXCL (player^.character^.movement.flags,option);
          ELSE
            INCL (player^.character^.movement.flags,option);
          END; (* IF *)
        END DeterminePlayerMovementFlag;
        
        PROCEDURE DeterminePlayerStatusFlag (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; option : MCStruct.PlayerStatusMnemonic);
        BEGIN (* DeterminePlayerStatusFlag *)
          IF WDialog.IsDlgButtonChecked (window,control) = Windows.FALSE_BOOL THEN
            EXCL (player^.character^.variables.status,option);
          ELSE
            INCL (player^.character^.variables.status,option);
          END; (* IF *)
        END DeterminePlayerStatusFlag;
        
      BEGIN (* DeterminePlayerOptions *)
        DeterminePlayerMovementFlag (window,player,FindCutControl,MCStruct.FindCut);
        DeterminePlayerMovementFlag (window,player,FindExamineControl,MCStruct.FindExamine);
        DeterminePlayerMovementFlag (window,player,FindIgnoreControl,MCStruct.FindIgnoreDoors);
        DeterminePlayerStatusFlag (window,player,PromptCarryControl,MCStruct.PromptCarryFLAG);
        DeterminePlayerStatusFlag (window,player,HighlightSeamsControl,MCStruct.HighlightSeamsFLAG);
      END DeterminePlayerOptions;
      
    BEGIN (* ExecuteAcceptButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        DeterminePlayerOptions (window,player);
        WDialog.EndDialog (window,Windows.TRUE_BOOL);
      END; (* IF *)
    END ExecuteAcceptButtonAction;
    
    PROCEDURE ExecuteCancelButtonAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteCancelButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        CloseOptionsDialog (window,player);
      END; (* IF *)
    END ExecuteCancelButtonAction;
    
  BEGIN (* ExecuteOptionsDialogCommand *)
    CASE control OF
      Windows.IDCANCEL,CancelPushButtonControl : ExecuteCancelButtonAction (window,player,command); |
      Windows.IDOK,AcceptPushButtonControl     : ExecuteAcceptButtonAction (window,player,command); |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteOptionsDialogCommand;
  
  PROCEDURE ExecuteOptionsCommand (player : MStruct.PlayerInfoPointer);
    VAR
        result : INTEGER;
    
  BEGIN (* ExecuteOptionsCommand *)
    MDialogs.ExecuteMoriaDialogBox (player^.windows.frame,"Options_Dialog",player,InitializeOptionsDialog,ExecuteOptionsDialogCommand,CloseOptionsDialog,result);
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteOptionsCommand;
  
  PROCEDURE InitializeOptionsDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
    PROCEDURE CheckMoriaOptionBox (window : Windows.HWND; control : CARDINAL; set : BOOLEAN);
    BEGIN (* CheckMoriaOptionBox *)
      WDialog.CheckDlgButton (window,control,ORD (set));
    END CheckMoriaOptionBox;
    
  BEGIN (* InitializeOptionsDialog *)
    CheckMoriaOptionBox (window,FindCutControl,MCStruct.FindCut IN player^.character^.movement.flags);
    CheckMoriaOptionBox (window,FindExamineControl,MCStruct.FindExamine IN player^.character^.movement.flags);
    CheckMoriaOptionBox (window,FindIgnoreControl,MCStruct.FindIgnoreDoors IN player^.character^.movement.flags);
    CheckMoriaOptionBox (window,PromptCarryControl,MCStruct.PromptCarryFLAG IN player^.character^.variables.status);
    CheckMoriaOptionBox (window,HighlightSeamsControl,MCStruct.HighlightSeamsFLAG IN player^.character^.variables.status);
  END InitializeOptionsDialog;
END MOptions.
