(*                          Windows 3.1 Moria version 1.0

   This software may be copied and distributed for educational, research, and
   not for profit purposes provided that this copyright and statement are
   included in all such copies.
*)


(* Original copyright message follows. *)

(* Moria Version 4.8     COPYRIGHT (c) Robert Alan Koeneke          *)
(*                                                                  *)
(*      I lovingly dedicate this game to hackers and adventurers    *)
(*      everywhere...                                               *)
(*                                                                  *)
(*                                                                  *)
(*      Designer and Programmer : Robert Alan Koeneke               *)
(*                       University of Oklahoma                     *)
(*                                                                  *)
(*      Assistant Programmers      : Jimmey Wayne Todd              *)
(*                       University of Oklahoma                     *)
(*                                                                  *)
(*                       Gary D. McAdoo                             *)
(*                       University of Oklahoma                     *)
(*                                                                  *)
(*      UNIX Port           : James E. Wilson                       *)
(*                       UC Berkeley                                *)
(*                       wilson@kithrup.com                         *)
(*                                                                  *)
(*      MSDOS Port           : Don Kneller                          *)
(*                       1349 - 10th ave                            *)
(*                       San Francisco, CA 94122                    *)
(*                       kneller@cgl.ucsf.EDU                       *)
(*                       ...ucbvax!ucsfcgl!kneller                  *)
(*                       kneller@ucsf-cgl.BITNET                    *)
(*                                                                  *)
(*      BRUCE Moria           : Christopher Stuart                  *)
(*                       Monash University                          *)
(*                       Melbourne, Victoria, AUSTRALIA             *)
(*                       cjs@moncsbruce.oz                          *)
(*                                                                  *)
(*       Amiga Port              : Corey Gehman                     *)
(*                                 Clemson University               *)
(*                                 cg377170@eng.clemson.edu         *)
(*                                                                  *)
(*      Version 5.5           : David Grabiner                      *)
(*                       Harvard University                         *)
(*                       grabiner@math.harvard.edu                  *)
(*                                                                  *)
(*      Windows/Modula-2 Port:     Narti Kitiyakara                 *)
(*                                 2917 Ursulines Ave.              *)
(*                                 New Orleans, LA 70119            *)
(*                                 narti@cris.com                   *)

(*                                                                        *)
(*      Moria may be copied and modified freely as long as the above      *)
(*      credits are retained.     No one who-so-ever may sell or market   *)
(*      this software in any form without the expressed written consent   *)
(*      of the author Robert Alan Koeneke.                                *)
(*                                                                        *)


MODULE Moria;
  (*/WIN:A*)
  
  IMPORT Windows,WCreation,WDContext,WDisplay,WDTool,Windows,WInformation,WinStart,WResource;
  IMPORT MCLoop,MInitFile,MMenu,MStruct,MWClasses;
  
  
  PROCEDURE AllocateMainWindow (VAR window : Windows.HWND);
    CONST
          MainWindowStyle = Windows.WS_OVERLAPPEDWINDOW;
    
    VAR
        shown : BOOLEAN;
    
  BEGIN (* AllocateMainWindow *)
    WCreation.CreateDefaultWindow (MWClasses.MainWindowClassName,MStruct.MainWindowTitle,MainWindowStyle,Windows.NULL,WinStart.hInstance,window);
    WDisplay.ShowWindow (window,MInitFile.StartupDisplayOption (),shown);
    
    MMenu.SetMaximizedMarker (window,MInitFile.StartupDisplayOption () = Windows.SW_SHOWMAXIMIZED);
  END AllocateMainWindow;
  
  
BEGIN (* Moria *)
  MStruct.CurrentPlayerFrameWindow := WInformation.FindWindow (MWClasses.MainWindowClassName,"");
  
  IF MStruct.CurrentPlayerFrameWindow = Windows.NULL THEN
    MWClasses.AllocateMoriaClassData (WinStart.hInstance);
    AllocateMainWindow (MStruct.CurrentPlayerFrameWindow);
    
    MCLoop.ExecuteMoriaCommandLoop (MStruct.CurrentPlayerFrameWindow);
  ELSE
    WDisplay.RedisplayExistingInstance (MStruct.CurrentPlayerFrameWindow);
  END; (* IF *)
END Moria.
