IMPLEMENTATION MODULE MPAttacks;
  (*/WIN:A*)
  
  IMPORT MCSActions,MSActions,MSActs2,OSActions;
  IMPORT CStruct,DStruct,MCStruct,MStruct,OStruct;
  IMPORT MPAttk2,MRandom;
  IMPORT WMacro,WString;
  IMPORT MMWindow;
  IMPORT SYSTEM;
  
  
  VAR
      WeaponBlowsTable : ARRAY [0..6],[0..5] OF CARDINAL;
  
  
  PROCEDURE AttackCreatureAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    TYPE
         DungeonCreaturePointer = POINTER TO DStruct.DungeonCreatureRecord;
    
    TYPE
         PlayerAttackInformation = RECORD
                                     description : ARRAY [0..127] OF CHAR;
                                     creature    : DungeonCreaturePointer;
                                     column      : DStruct.DungeonColumnRange;
                                     line        : DStruct.DungeonLineRange;
                                     
                                     modifier : INTEGER;
                                     weapon   : OStruct.InventoryItemRecord;
                                     strike   : INTEGER;
                                     
                                     player : MStruct.PlayerInfoPointer;
                                     blows  : CARDINAL;
                                   END; (* PlayerAttackInformation *)
    
    VAR
        info : PlayerAttackInformation;
    
    PROCEDURE ExecutePlayerAttack (info : PlayerAttackInformation);
      PROCEDURE DetermineCreatureDamage (info : PlayerAttackInformation);
        PROCEDURE DestroyAttackingWeapon (player : MStruct.PlayerInfoPointer);
        BEGIN (* DestroyAttackingWeapon *)
          DEC (player^.character^.inventory.equipment [MCStruct.Weapon1].object.quantity);
          DEC (player^.character^.inventory.weight,player^.character^.inventory.equipment [MCStruct.Weapon1].object.weight);
          
          IF player^.character^.inventory.equipment [MCStruct.Weapon1].object.quantity = 0 THEN
            MSActions.RecomputeEquipmentBonuses (player,player^.character^.inventory.equipment [MCStruct.Weapon1],MSActions.RemoveEquipmentBonuses);
            
            OSActions.ReturnInventoryItemRecord (player^.treasures,OStruct.EmptyObjectCursor,player^.character^.inventory.equipment [MCStruct.Weapon1]);
            MCSActions.CalculatePlayerBonuses (player^.character);
          END; (* IF *)
          
          INCL (player^.character^.variables.status,MCStruct.StrWgtFLAG);
        END DestroyAttackingWeapon;
        
        PROCEDURE ExecuteConfuseMonsterAttack (info : PlayerAttackInformation; VAR creature : CStruct.PassiveCreatureInfoRecord);
        BEGIN (* ExecuteConfuseMonsterAttack *)
          EXCL (player^.character^.variables.status,MCStruct.ConfuseMonsterFLAG);
          MMWindow.AddMessageToList (info.player,"Your hands stop glowing.");
          
          IF ((CStruct.ResistCharms IN creature.defense) OR (MRandom.CardinalRandomRangeValue (1,CStruct.MaxCreatureDepth) < creature.depth)) THEN
            DisplayPlayerAttackMessage (info.player,"%CREATURE is unaffected.","%CREATURE",info.description,FALSE);
          ELSE
            DisplayPlayerAttackMessage (info.player,"%CREATURE appears confused.","%CREATURE",info.description,FALSE);
            info.creature^.confused := TRUE;
          END; (* IF *)
          
          IF (info.creature^.visible AND (CStruct.ResistCharms IN creature.defense) AND (MRandom.CardinalRandomRangeValue (1,4) = 1)) THEN
            INCL (creature.memory.defense,CStruct.ResistCharms);
          END; (* IF *)
        END ExecuteConfuseMonsterAttack;
        
        PROCEDURE PlayerAttackDamage (player : MStruct.PlayerInfoPointer; creature : CARDINAL; weapon : OStruct.InventoryItemRecord; strikeMODIFIER : INTEGER) : CARDINAL;
          PROCEDURE PlayerHandDamage (player : MStruct.PlayerInfoPointer) : INTEGER;
          BEGIN (* PlayerHandDamage *)
            RETURN (MPAttk2.CriticalBlowDamage (player,1,0,1,MCSActions.ClassMartialLevelAdjustment (info.player^.character^.constants.class)));
          END PlayerHandDamage;
          
          PROCEDURE PlayerWeaponDamage (player : MStruct.PlayerInfoPointer; creature : CARDINAL; weapon : OStruct.InventoryItemRecord; strikeMODIFIER : INTEGER) : INTEGER;
            VAR
                damage : INTEGER;
            
          BEGIN (* PlayerWeaponDamage *)
            damage := MRandom.CardinalRandomRangeValue (weapon.object.damage.min,weapon.object.damage.max);
            damage := MPAttk2.SpecialWeaponDamage (player,creature,weapon,damage);
            damage := MPAttk2.CriticalBlowDamage (player,weapon.object.weight,strikeMODIFIER,damage,MCSActions.ClassMartialLevelAdjustment (player^.character^.constants.class));
            
            RETURN (damage);
          END PlayerWeaponDamage;
          
        BEGIN (* PlayerAttackDamage *)
          IF weapon.object.class <> OStruct.Nothing THEN
            RETURN (WMacro.MaxInteger (PlayerWeaponDamage (player,creature,weapon,strikeMODIFIER) + player^.character^.variables.bonusREAL.damage,0));
          ELSE
            RETURN (WMacro.MaxInteger (PlayerHandDamage (player) + player^.character^.variables.bonusREAL.damage,0));
          END; (* IF *)
        END PlayerAttackDamage;
        
      BEGIN (* DetermineCreatureDamage *)
        IF MCStruct.ConfuseMonsterFLAG IN info.player^.character^.variables.status THEN
          ExecuteConfuseMonsterAttack (info,info.player^.creatures^.table [info.creature^.cursor]);
        END; (* IF *)
        
        MPAttk2.DamageCreature (info.creature^,PlayerAttackDamage (info.player,info.creature^.cursor,info.weapon,info.modifier));
        
        IF info.creature^.hitpoints = 0 THEN
          DisplayPlayerAttackMessage (player,"You have slain %s.","%s",info.description,TRUE);
          MPAttk2.KillCreatureAtLocation (info.player,info.line,info.column,info.player^.creatures^.table [info.creature^.cursor],info.creature^.visible,TRUE);
        END; (* IF *)
        
        IF ((info.weapon.object.class >= OStruct.SlingAmmo) AND (info.weapon.object.class <= OStruct.Spike)) THEN
          DestroyAttackingWeapon (player);
        END; (* IF *)
      END DetermineCreatureDamage;
      
      PROCEDURE DisplayPlayerAttackMessage (player : MStruct.PlayerInfoPointer; text : ARRAY OF CHAR; formal,actual : ARRAY OF CHAR; popup : BOOLEAN);
        VAR
            message : ARRAY [0..127] OF CHAR;
        
      BEGIN (* DisplayPlayerAttackMessage *)
        WString.ReplaceStringParameter (text,formal,actual,message);
        
        IF popup THEN
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,message);
        ELSE
          MMWindow.AddMessageToList (player,message);
        END; (* IF *)
      END DisplayPlayerAttackMessage;
      
    BEGIN (* ExecutePlayerAttack *)
      IF SuccessfulAttack (info.player,info.strike,info.player^.character^.variables.level,info.modifier,info.creature^.armor,MCSActions.ClassMartialLevelAdjustment (info.player^.character^.constants.class)) THEN
        DisplayPlayerAttackMessage (info.player,"You hit %s.","%s",info.description,FALSE);
        DetermineCreatureDamage (info);
      ELSE
        DisplayPlayerAttackMessage (info.player,"You miss %s.","%s",info.description,FALSE);
      END; (* IF *)
    END ExecutePlayerAttack;
    
    PROCEDURE InitializeAttackInformation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR result : PlayerAttackInformation);
      PROCEDURE CreatureForLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange) : DungeonCreaturePointer;
        PROCEDURE LocationCreatureCursor (VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange) : CARDINAL;
        BEGIN (* LocationCreatureCursor *)
          RETURN (dungeon.physical [line]^ [column].creature);
        END LocationCreatureCursor;
        
      BEGIN (* CreatureForLocation *)
        RETURN (SYSTEM.ADR (player^.dungeon^.creatures [LocationCreatureCursor (player^.dungeon^,line,column)]));
      END CreatureForLocation;
      
      PROCEDURE ReturnPlayerAttackInfo (player : MStruct.PlayerInfoPointer; weapon : OStruct.InventoryItemRecord; VAR blows : CARDINAL; VAR strike,modifier : INTEGER);
        PROCEDURE TotalPlayerBlows (player : MStruct.PlayerInfoPointer; weapon : OStruct.InventoryItemRecord) : CARDINAL;
          PROCEDURE DexterityBlowsCursor (dexterity : MCStruct.PlayerStatisticRange) : CARDINAL;
          BEGIN (* DexterityBlowsCursor *)
            CASE dexterity OF
              3..9     : RETURN (0); |
              10..18   : RETURN (1); |
              19..67   : RETURN (2); |
              68..107  : RETURN (3); |
              108..117 : RETURN (4); |
              118      : RETURN (5); |
            END; (* CASE *)
          END DexterityBlowsCursor;
          
          PROCEDURE StrengthBlowsCursor (strength : MCStruct.PlayerStatisticRange; weight : INTEGER) : CARDINAL;
          BEGIN (* StrengthBlowsCursor *)
            CASE strength * 10 DIV weight OF
              0..1 : RETURN (0); |
              2    : RETURN (1); |
              3    : RETURN (2); |
              4    : RETURN (3); |
              5..6 : RETURN (4); |
              7..8 : RETURN (5); |
            ELSE
              RETURN (6);
            END; (* CASE *)
          END StrengthBlowsCursor;
          
        BEGIN (* TotalPlayerBlows *)
          IF ((weapon.object.class >= OStruct.SlingAmmo) AND (weapon.object.class <= OStruct.Spike)) THEN
            RETURN (1);
          ELSIF weapon.object.class = OStruct.Nothing THEN
            RETURN (2);
          ELSIF player^.character^.statistics.used [MCStruct.str] * 15 < weapon.object.weight THEN
            RETURN (1);
          END; (* IF *)
          
          RETURN (WeaponBlowsTable [StrengthBlowsCursor (player^.character^.statistics.used [MCStruct.str],weapon.object.weight),DexterityBlowsCursor (player^.character^.statistics.used [MCStruct.dex])]);
        END TotalPlayerBlows;
        
        PROCEDURE TotalPlayerStrikeModifier (player : MStruct.PlayerInfoPointer; weapon : OStruct.InventoryItemRecord) : INTEGER;
        BEGIN (* TotalPlayerStrikeModifier *)
          IF weapon.object.class = OStruct.Nothing THEN
            RETURN (-3);
          ELSIF player^.character^.statistics.used [MCStruct.str] * 15 < weapon.object.weight THEN
            RETURN (player^.character^.statistics.used [MCStruct.str] * 15 - weapon.object.weight);
          ELSE
            RETURN (0);
          END; (* IF *)
        END TotalPlayerStrikeModifier;
        
      BEGIN (* ReturnPlayerAttackInfo *)
        modifier := TotalPlayerStrikeModifier (player,weapon);
        strike   := player^.character^.abilities.martial;
        blows    := TotalPlayerBlows (player,weapon);
      END ReturnPlayerAttackInfo;
      
    BEGIN (* InitializeAttackInformation *)
      result.creature := CreatureForLocation (player,line,column);
      result.weapon   := player^.character^.inventory.equipment [MCStruct.Weapon1];
      result.player   := player;
      result.column   := column;
      result.line     := line;
      
      MPAttk2.ReturnCreatureDescription (player,result.creature^.cursor,result.creature^.visible,result.description);
      ReturnPlayerAttackInfo (player,result.weapon,result.blows,result.strike,result.modifier);
      
      IF NOT (result.creature^.visible) THEN
        result.strike := result.strike DIV 2 - (result.modifier * (MCStruct.MartialStrikeAdjustment - 1)) - (player^.character^.variables.level * MCSActions.ClassMartialLevelAdjustment (player^.character^.constants.class) DIV 2);
      END; (* IF *)
    END InitializeAttackInformation;
    
  BEGIN (* AttackCreatureAtLocation *)
    MStruct.CharacterTurnExecuted := (player^.character^.variables.counters [MCStruct.AfraidCOUNT] = 0);
    
    IF MStruct.CharacterTurnExecuted THEN
      InitializeAttackInformation (player,line,column,info);
      
      REPEAT
        ExecutePlayerAttack (info);
        DEC (info.blows);
      UNTIL ((info.blows = 0) OR (info.creature^.hitpoints = 0));
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are too afraid!");
    END; (* IF *)
  END AttackCreatureAtLocation;
  
  PROCEDURE InitializeWeaponBlowsTable;
    PROCEDURE AssignWeaponBlowsList (VAR table : ARRAY OF CARDINAL; value1,value2,value3,value4,value5,value6 : CARDINAL);
    BEGIN (* AssignWeaponBlowsList *)
      table [0] := value1;
      table [1] := value2;
      table [2] := value3;
      table [3] := value4;
      table [4] := value5;
      table [5] := value6;
    END AssignWeaponBlowsList;
    
  BEGIN (* InitializeWeaponBlowsTable *)
    AssignWeaponBlowsList (WeaponBlowsTable [0],1,1,1,1,1,1);
    AssignWeaponBlowsList (WeaponBlowsTable [1],1,1,1,1,2,2);
    AssignWeaponBlowsList (WeaponBlowsTable [2],1,1,1,2,2,3);
    AssignWeaponBlowsList (WeaponBlowsTable [3],1,1,2,2,3,3);
    AssignWeaponBlowsList (WeaponBlowsTable [4],1,2,2,3,3,4);
    AssignWeaponBlowsList (WeaponBlowsTable [5],1,2,2,3,4,4);
    AssignWeaponBlowsList (WeaponBlowsTable [6],2,2,3,3,4,4);
  END InitializeWeaponBlowsTable;
  
  PROCEDURE SuccessfulAttack (player : MStruct.PlayerInfoPointer; strikeBASE : INTEGER; level : INTEGER; strikeMODIFIER : INTEGER; armor : INTEGER; adjustment : INTEGER) : BOOLEAN;
    VAR
        chance : INTEGER;
        roll   : CARDINAL;
    
    PROCEDURE SuccessfulAttackChance (strikeBASE : INTEGER; level : INTEGER; strikeMODIFIER : INTEGER; adjustment : INTEGER) : INTEGER;
    BEGIN (* SuccessfulAttackChance *)
      RETURN (strikeBASE + strikeMODIFIER * MCStruct.MartialStrikeAdjustment + level * adjustment);
    END SuccessfulAttackChance;
    
  BEGIN (* SuccessfulAttack *)
    MSActs2.DisturbPlayer (player,TRUE);
    
    chance := SuccessfulAttackChance (strikeBASE,level,strikeMODIFIER,adjustment);
    roll   := MRandom.CardinalRandomRangeValue (1,20);
    
    IF ((roll = 1) OR (chance < 1)) THEN
      RETURN (FALSE);
    ELSIF roll = 20 THEN
      RETURN (TRUE);
    ELSE
      RETURN (MRandom.IntegerRandomRangeValue (1,chance) > armor);
    END; (* IF *)
  END SuccessfulAttack;
  
BEGIN (* MPAttacks *)
  InitializeWeaponBlowsTable;
END MPAttacks.
