IMPLEMENTATION MODULE MPAttk2;
  (*/WIN:A*)
  
  IMPORT CStruct,DStruct,MCStruct,MStruct,OStruct;
  IMPORT MDPainting,MDWindow,MMWindow,MSUpdate;
  IMPORT MDGAlloc,MRandom,MSight;
  IMPORT DSActions,MSActs2;
  IMPORT Strings;
  IMPORT WMacro;
  
  
  PROCEDURE CriticalBlowDamage (player : MStruct.PlayerInfoPointer; weight,strikeMODIFIER,damage,adjustment : INTEGER) : INTEGER;
    PROCEDURE StrikesCriticalBlow (player : MStruct.PlayerInfoPointer; weight,modifier,adjustment : INTEGER) : BOOLEAN;
    BEGIN (* StrikesCriticalBlow *)
      RETURN (MRandom.IntegerRandomRangeValue (1,5000) <= weight + 5 * modifier + player^.character^.variables.level * adjustment);
    END StrikesCriticalBlow;
    
  BEGIN (* CriticalBlowDamage *)
    IF StrikesCriticalBlow (player,weight,strikeMODIFIER,adjustment) THEN
      CASE weight + MRandom.IntegerRandomRangeValue (1,650) OF
        1..399   : MMWindow.AddMessageToList (player,"It was a good hit! (x2 damage)"); 
                   damage := 2 * damage + 5;                                                  |
        400..699 : MMWindow.AddMessageToList (player,"It was an excellent hit! (x3 damage)"); 
                   damage := 3 * damage + 10;                                                 |
        700..899 : MMWindow.AddMessageToList (player,"It was a superb hit! (x4 damage)"); 
                   damage := 4 * damage + 15;                                                 |
      ELSE
        MMWindow.AddMessageToList (player,"It was a *GREAT* hit! (x5 damage)"); 
        damage := 5 * damage + 20;
      END; (* CASE *)
    END; (* IF *)
    
    RETURN (damage);
  END CriticalBlowDamage;
  
  PROCEDURE DamageCreature (VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL);
  BEGIN (* DamageCreature *)
    creature.hitpoints := creature.hitpoints - WMacro.MinCardinal (damage,creature.hitpoints);
    creature.sleep     := 0;
  END DamageCreature;
  
  PROCEDURE ExperienceForCreature (creature : CARDINAL; level : CARDINAL; depth : CARDINAL) : REAL;
  BEGIN (* ExperienceForCreature *)
    RETURN ((FLOAT (creature) * FLOAT (depth)) / FLOAT (level));
  END ExperienceForCreature;
  
  PROCEDURE GenerateCreatureTreasures (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; treasures : CStruct.CreatureTreasureInformation; VAR memory : CStruct.CreatureTreasureInformation);
    VAR
        count : CARDINAL;
    
    PROCEDURE GeneratCreatureTreasure (player : MStruct.PlayerInfoPointer; lineCENTER : DStruct.DungeonLineRange; columnCENTER : DStruct.DungeonColumnRange; treasures : CStruct.CreatureTreasureInformation; VAR memory : CStruct.CreatureTreasureInformation);
      VAR
          column : DStruct.DungeonColumnRange;
          class  : CStruct.CreatureTreasureMnemonic;
          line   : DStruct.DungeonLineRange;
          done   : BOOLEAN;
          
      PROCEDURE DetermineTreasurePosition (player : MStruct.PlayerInfoPointer; lineCENTER : DStruct.DungeonLineRange; columnCENTER : DStruct.DungeonColumnRange; VAR resultLINE : DStruct.DungeonLineRange; VAR resultCOLUMN : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
        VAR
            tempCOLUMN,tempLINE : INTEGER;
            attempts            : CARDINAL;
        
        PROCEDURE ValidTreasureLocation (player : MStruct.PlayerInfoPointer; lineCENTER : DStruct.DungeonLineRange; columnCENTER : DStruct.DungeonColumnRange; resultLINE,resultCOLUMN : INTEGER) : BOOLEAN;
        BEGIN (* ValidTreasureLocation *)
          IF NOT (DSActions.LocationInBounds (player^.dungeon^,resultLINE,resultCOLUMN)) THEN
            RETURN (FALSE);
          ELSIF player^.dungeon^.physical [resultLINE]^ [resultCOLUMN].elements * DStruct.DungeonFloorElements = DStruct.EmptyDungeonElementSet THEN
            RETURN (FALSE);
          ELSIF player^.dungeon^.physical [resultLINE]^ [resultCOLUMN].artifact <> DStruct.InvalidArtifactCursor THEN
            RETURN (FALSE);
          ELSE
            RETURN (MSight.ClearLineOfSight (player,lineCENTER,columnCENTER,resultLINE,resultCOLUMN));
          END; (* IF *)
        END ValidTreasureLocation;
        
      BEGIN (* DetermineTreasurePosition *)
        attempts := 0;
        
        REPEAT
          tempCOLUMN := columnCENTER - 3 + MRandom.IntegerRandomRangeValue (1,5);
          tempLINE   := lineCENTER - 3 + MRandom.IntegerRandomRangeValue (1,5);
          
          attempts := attempts + 1;
          done     := ValidTreasureLocation (player,lineCENTER,columnCENTER,tempLINE,tempCOLUMN);
        UNTIL (done OR (attempts = 20));
        
        IF done THEN
          resultCOLUMN := tempCOLUMN;
          resultLINE   := tempLINE;
        END; (* IF *)
      END DetermineTreasurePosition;
      
      PROCEDURE ShouldGenerateTreasure (treasures : CStruct.CreatureTreasureInformation) : BOOLEAN;
      BEGIN (* ShouldGenerateTreasure *)
        IF treasures * CStruct.CreatureTreasureInformation {CStruct.CarriesGold,CStruct.CarriesObjects} = CStruct.CreatureTreasureInformation {CStruct.CarriesGold,CStruct.CarriesObjects} THEN
          RETURN (MRandom.CardinalRandomRangeValue (1,100) >= 50);
        ELSE
          RETURN (CStruct.CarriesGold IN treasures);
        END; (* IF *)
      END ShouldGenerateTreasure;
      
    BEGIN (* GeneratCreatureTreasure *)
      DetermineTreasurePosition (player,lineCENTER,columnCENTER,line,column,done);
      
      IF done THEN
        IF ShouldGenerateTreasure (treasures) THEN
          MDGAlloc.PlaceRandomTreasure (player,player^.dungeon^,line,column,player^.character^.variables.depthCUR,TRUE);
          class := CStruct.CarriesGold;
        ELSE
          MDGAlloc.PlaceRandomObject (player,player^.dungeon^,line,column,player^.character^.variables.depthCUR,TRUE);
          class := CStruct.CarriesObjects;
        END; (* IF *)
        
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
        
        IF DSActions.LocationHasLight (player^.dungeon^,line,column) THEN
          INCL (memory,class);
        END; (* IF *)
      END; (* IF *)
    END GeneratCreatureTreasure;
    
    PROCEDURE NumberCreatureTreasures (treasures : CStruct.CreatureTreasureInformation) : CARDINAL;
      VAR
          number : CARDINAL;
    
    BEGIN (* NumberCreatureTreasures *)
      number := 0;
      
      IF ((CStruct.TreasureChance60 IN treasures) AND (MRandom.CardinalRandomRangeValue (1,100) < 60)) THEN
        INC (number);
      END; (* IF *)
      
      IF ((CStruct.TreasureChance90 IN treasures) AND (MRandom.CardinalRandomRangeValue (1,100) < 90)) THEN
        INC (number);
      END; (* IF *)
      
      IF CStruct.TreasureQuantity1d2 IN treasures THEN
        INC (number,MRandom.CardinalRandomRangeValue (1,2));
      END; (* IF *)
      
      IF CStruct.TreasureQuantity2d2 IN treasures THEN
        INC (number,MRandom.CardinalRandomRangeValue (2,4));
      END; (* IF *)
      
      IF CStruct.TreasureQuantity4d2 IN treasures THEN
        INC (number,MRandom.CardinalRandomRangeValue (4,8));
      END; (* IF *)
      
      RETURN (number);
    END NumberCreatureTreasures;
    
  BEGIN (* GenerateCreatureTreasures *)
    memory := CStruct.CreatureTreasureInformation {};
    
    FOR count := 1 TO NumberCreatureTreasures (treasures) DO
      GeneratCreatureTreasure (player,line,column,treasures,memory);
    END; (* FOR *)
  END GenerateCreatureTreasures;

  PROCEDURE KillCreatureAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR creature : CStruct.PassiveCreatureInfoRecord; visible : BOOLEAN; experience : BOOLEAN);
    VAR
        memory : CStruct.CreatureTreasureInformation;
    
    PROCEDURE IncreasePlayerExperience (player : MStruct.PlayerInfoPointer; creature : CStruct.PassiveCreatureInfoRecord);
    BEGIN (* IncreasePlayerExperience *)
      IF creature.balrog THEN
        MSUpdate.UpdateTotalWinnerStatusWindow (player);
        
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"*** CONGRATULATIONS *** You have won the game.");
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You cannot save this game, but you may retire when ready.");
        
        INCL (player^.character^.variables.status,MCStruct.TotalWinnerFLAG);
      END; (* IF *)
      
      MSActs2.IncreasePlayerExperience (player,ExperienceForCreature (creature.experience,player^.character^.variables.level,player^.character^.variables.depthCUR));
    END IncreasePlayerExperience;
    
    PROCEDURE UpdateCreatureMemory (player : MStruct.PlayerInfoPointer; VAR creature : CStruct.PassiveCreatureInfoRecord; visible : BOOLEAN; memory : CStruct.CreatureTreasureInformation; experience : BOOLEAN);
    BEGIN (* UpdateCreatureMemory *)
      IF ((player^.character^.variables.counters [MCStruct.BlindCOUNT] = 0) AND (visible OR creature.balrog)) THEN
        creature.memory.treasure := creature.memory.treasure + memory;
        
        IF experience THEN
          INC (creature.memory.kills);
        END; (* IF *)
      END; (* IF *)
    END UpdateCreatureMemory;
    
  BEGIN (* KillCreatureAtLocation *)
    GenerateCreatureTreasures (player,line,column,creature.treasure,memory);
    
    IF experience THEN
      IncreasePlayerExperience (player,creature);
    END; (* IF *)
    
    UpdateCreatureMemory (player,creature,visible,memory,experience);
    
    DSActions.DeleteCreatureAtLocation (player^.dungeon^,line,column);
    MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
  END KillCreatureAtLocation;

  PROCEDURE ReturnCreatureDescription (player : MStruct.PlayerInfoPointer; creature : CARDINAL; visible : BOOLEAN; VAR result : ARRAY OF CHAR);
  BEGIN (* ReturnCreatureDescription *)
    IF visible THEN
      Strings.Concat ("the ",player^.creatures^.table [creature].description,result);
    ELSE
      Strings.Assign ("it",result);
    END; (* IF *)
  END ReturnCreatureDescription;
  
  PROCEDURE SpecialWeaponDamage (player : MStruct.PlayerInfoPointer; creature : CARDINAL; weapon : OStruct.InventoryItemRecord; damage : INTEGER) : INTEGER;
    VAR
        defense : CStruct.CreatureDefenseInformation;
        memory  : CStruct.CreatureDefenseInformation;
    
    PROCEDURE HasEgoAttributes (attributes : OStruct.ObjectAttributeFlags) : BOOLEAN;
      CONST
            EgoWeaponAttributes = OStruct.ObjectAttributeFlags {OStruct.SlayDragon..OStruct.FlameTongue};
      
      VAR
          index : OStruct.ObjectAttributeMnemonic;
      
    BEGIN (* HasEgoAttributes *)
      FOR index := MIN (OStruct.ObjectAttributeMnemonic) TO MAX (OStruct.ObjectAttributeMnemonic) DO
        IF ((index IN EgoWeaponAttributes) AND (index IN attributes)) THEN
          RETURN (TRUE);
        END; (* IF *)
      END; (* FOR *)
      
      RETURN (FALSE);
    END HasEgoAttributes;
    
    PROCEDURE IsWeaponClass (class : OStruct.ObjectClassMnemonic) : BOOLEAN;
      CONST
            ValidWeaponClasses = OStruct.ObjectClassSet {OStruct.SlingAmmo..OStruct.Arrow,OStruct.HaftedWeapon..OStruct.BladeWeapon,OStruct.Flask};
      
    BEGIN (* IsWeaponClass *)
      RETURN (class IN ValidWeaponClasses);
    END IsWeaponClass;
    
  BEGIN (* SpecialWeaponDamage *)
    IF (IsWeaponClass (weapon.object.class) AND HasEgoAttributes (weapon.object.attributes)) THEN
      defense := player^.creatures^.table [creature].defense;
      memory  := CStruct.CreatureDefenseInformation {};
      
      IF ((OStruct.SlayDragon IN weapon.object.attributes) AND (CStruct.HurtBySlayDragon IN defense)) THEN
        INCL (memory,CStruct.HurtBySlayDragon);
        damage := damage * 4;
      END; (* IF *)
        
      IF ((OStruct.SlayUndead IN weapon.object.attributes) AND (CStruct.HurtBySlayUndead IN defense)) THEN
        INCL (memory,CStruct.HurtBySlayUndead);
        damage := damage * 3;
      END; (* IF *)
        
      IF ((OStruct.SlayAnimal IN weapon.object.attributes) AND (CStruct.HurtBySlayAnimal IN defense)) THEN
        INCL (memory,CStruct.HurtBySlayAnimal);
        damage := damage * 2;
      END; (* IF *)
        
      IF ((OStruct.SlayEvil IN weapon.object.attributes) AND (CStruct.HurtBySlayEvil IN defense)) THEN
        INCL (memory,CStruct.HurtBySlayEvil);
        damage := damage * 2;
      END; (* IF *)
        
      IF ((OStruct.FrostBrand IN weapon.object.attributes) AND (CStruct.HurtByFrost IN defense)) THEN
        INCL (memory,CStruct.HurtByFrost);
        damage := damage * 3 DIV 2;
      END; (* IF *)
        
      IF ((OStruct.FlameTongue IN weapon.object.attributes) AND (CStruct.HurtByFire IN defense)) THEN
        INCL (memory,CStruct.HurtByFire);
        damage := damage * 3 DIV 2;
      END; (* IF *)
    END; (* IF *)
    
    player^.creatures^.table [creature].memory.defense := player^.creatures^.table [creature].memory.defense + defense;
    
    RETURN (damage);
  END SpecialWeaponDamage;
END MPAttk2.
