IMPLEMENTATION MODULE MPBash;
  (*/WIN:A*)
  
  IMPORT MDPainting,MDWindow,MMWindow,MPAttacks,MPAttk2,MPMovement,MRandom;
  IMPORT CStruct,DStruct,MCStruct,MStruct,OStruct;
  IMPORT DSActions,MCSActions,OSActions;
  IMPORT WMacro,WString;
  
  
  PROCEDURE BashCreatureAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR creature : DStruct.DungeonCreatureRecord);
    PROCEDURE BashDamageCreature (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR creature : DStruct.DungeonCreatureRecord);
      PROCEDURE StunCreature (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
        PROCEDURE CreatureStunResistance (creature : CStruct.PassiveCreatureInfoRecord) : CARDINAL;
        BEGIN (* CreatureStunResistance *)
          IF CStruct.MaxHitPoints IN creature.defense THEN
            RETURN (creature.hitdie.max);
          ELSE
            RETURN (creature.hitdie.max DIV 2);
          END; (* IF *)
        END CreatureStunResistance;
        
        PROCEDURE DisplayStunMessage (player : MStruct.PlayerInfoPointer; text : ARRAY OF CHAR; formal : ARRAY OF CHAR; creature : DStruct.DungeonCreatureRecord);
          VAR
              description : ARRAY [0..127] OF CHAR;
              message     : ARRAY [0..127] OF CHAR;
          
        BEGIN (* DisplayStunMessage *)
          MPAttk2.ReturnCreatureDescription (player,creature.cursor,creature.visible,description);
          description [0] := CAP (description [0]);
          
          WString.ReplaceStringParameter (text,formal,description,message);
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,message);
        END DisplayStunMessage;
        
      BEGIN (* StunCreature *)
        IF 100 + MRandom.CardinalRandomRangeValue (1,400) + MRandom.CardinalRandomRangeValue (1,400) > CreatureStunResistance (player^.creatures^.table [creature.cursor]) THEN
          creature.stunned := WMacro.MinCardinal (creature.stunned + MRandom.CardinalRandomRangeValue (2,4),24);
          DisplayStunMessage (player,"%CREATURE appears stunned!","%CREATURE",creature);
        ELSE
          DisplayStunMessage (player,"%CREATURE ignores your bash!","%CREATURE",creature);
        END; (* IF *)
      END StunCreature;
      
      PROCEDURE TotalBashDamage (player : MStruct.PlayerInfoPointer; shield : OStruct.InventoryItemRecord) : CARDINAL;
      BEGIN (* TotalBashDamage *)
        RETURN (WMacro.MaxInteger (MPAttk2.CriticalBlowDamage (player,shield.object.weight DIV 4 + player^.character^.statistics.used [MCStruct.str],0,MRandom.CardinalRandomRangeValue (shield.object.damage.min,shield.object.damage.max),MCSActions.ClassMartialLevelAdjustment (player^.character^.constants.class)) + VAL (INTEGER,player^.character^.constants.weight DIV 60 + 3),0));
      END TotalBashDamage;
      
    BEGIN (* BashDamageCreature *)
      DisplayBashMessage (player,"You hit %CREATURE.","%CREATURE",creature);
      
      MPAttk2.DamageCreature (creature,TotalBashDamage (player,player^.character^.inventory.equipment [MCStruct.Arm]));
      
      IF creature.hitpoints = 0 THEN
        DisplayBashMessage (player,"You have slain %CREATURE.","%CREATURE",creature);
        MPAttk2.KillCreatureAtLocation (player,line,column,player^.creatures^.table [creature.cursor],creature.visible,TRUE);
      ELSE
        StunCreature (player,creature);
      END; (* IF *)
    END BashDamageCreature;
    
    PROCEDURE BashStrikeBase (player : MStruct.PlayerInfoPointer; creature : DStruct.DungeonCreatureRecord) : INTEGER;
      VAR
          result : INTEGER;
      
    BEGIN (* BashStrikeBase *)
      result := player^.character^.statistics.used [MCStruct.str] + player^.character^.inventory.equipment [MCStruct.Weapon1].object.weight DIV 2 + VAL (INTEGER,player^.character^.constants.weight DIV 10);
      
      IF NOT (creature.visible) THEN
        result := (result DIV 2) - (player^.character^.statistics.used [MCStruct.dex] * (MCStruct.MartialStrikeAdjustment - 1)) - (player^.character^.variables.level * MCSActions.ClassMartialLevelAdjustment (player^.character^.constants.class) DIV 2);
      END; (* IF *)
      
      RETURN (result);
    END BashStrikeBase;
    
    PROCEDURE DisplayBashMessage (player : MStruct.PlayerInfoPointer; text : ARRAY OF CHAR; formal : ARRAY OF CHAR; creature : DStruct.DungeonCreatureRecord);
      VAR
          description : ARRAY [0..127] OF CHAR;
          message     : ARRAY [0..127] OF CHAR;
      
    BEGIN (* DisplayBashMessage *)
      MPAttk2.ReturnCreatureDescription (player,creature.cursor,creature.visible,description);
      WString.ReplaceStringParameter (text,formal,description,message);
      
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,message);
    END DisplayBashMessage;
    
  BEGIN (* BashCreatureAtLocation *)
    IF player^.character^.variables.counters [MCStruct.AfraidCOUNT] = 0 THEN
      creature.sleep := 0;
      
      IF MPAttacks.SuccessfulAttack (player,BashStrikeBase (player,creature),player^.character^.variables.level,player^.character^.statistics.used [MCStruct.dex],creature.armor,MCSActions.ClassMartialLevelAdjustment (player^.character^.constants.class)) THEN
        BashDamageCreature (player,line,column,creature);
      ELSE
        DisplayBashMessage (player,"You miss %CREATURE.","%CREATURE",creature);
      END; (* IF *)
      
      IF MRandom.IntegerRandomRangeValue (1,150) > player^.character^.statistics.used [MCStruct.dex] THEN
        INC (player^.character^.variables.counters [MCStruct.ParalysisCOUNT],MRandom.CardinalRandomRangeValue (2,3));
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are off balance.");
      END; (* IF *)
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are afraid!");
    END; (* IF *)
  END BashCreatureAtLocation;

  PROCEDURE ExecuteBashAction (player : MStruct.PlayerInfoPointer; direction : CARDINAL);
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
    
    PROCEDURE BashAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; location : DStruct.PhysicalDungeonUnit);
      CONST
            WallBashMessage = "You bash it, but nothing interesting happens.";
      
      PROCEDURE BashArtifactAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR artifact : OStruct.InventoryItemRecord);
        PROCEDURE BashChestAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR artifact : OStruct.InventoryItemRecord);
          CONST
                RuinedChestCursor = 418;
          
        BEGIN (* BashChestAtLocation *)
          IF MRandom.CardinalRandomRangeValue (1,10) = 1 THEN
            MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You have destroyed the chest...");
            MMWindow.DisplayPopupMessage (player^.windows.frame,player,"and its contents!");
            
            artifact.object.attributes := OStruct.ObjectAttributeFlags {};
            artifact.cursor            := RuinedChestCursor;
          ELSIF ((OStruct.ChestLocked IN artifact.object.attributes) AND (MRandom.CardinalRandomRangeValue (1,10) = 1)) THEN
            MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The lock breaks open!");
            EXCL (artifact.object.attributes,OStruct.ChestLocked);
          ELSE
            MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The chest holds firm.");
          END; (* IF *)
        END BashChestAtLocation;
        
        PROCEDURE BashDoorAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR artifact : OStruct.InventoryItemRecord);
          PROCEDURE BashOpenDoorAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR artifact : OStruct.InventoryItemRecord);
          BEGIN (* BashOpenDoorAtLocation *)
            OSActions.ReturnInventoryItemRecord (player^.treasures,OStruct.OpenDoorObjectCursor,artifact);
            MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The door crashes open!");
            
            player^.dungeon^.physical [line]^ [column].elements := player^.dungeon^.physical [line]^ [column].elements / DStruct.DungeonElementSet {DStruct.BlockedFloor,DStruct.CorridorFloor};
            artifact.object.miscellaneous                       := 1 - MRandom.IntegerRandomRangeValue (1,2);
            
            IF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] = 0 THEN
              MPMovement.MoveCharacterToLocation (player,line,column);
            ELSE
              MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
            END; (* IF *)
          END BashOpenDoorAtLocation;
          
          PROCEDURE BashOpensDoor (ability : INTEGER; lock : INTEGER) : BOOLEAN;
          BEGIN (* BashOpensDoor *)
            RETURN (MRandom.IntegerRandomRangeValue (1,ability * (20 + ABS (lock))) < 10 * (ability - lock));
          END BashOpensDoor;
          
        BEGIN (* BashDoorAtLocation *)
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You smash into the door!");
          
          IF BashOpensDoor (player^.character^.statistics.used [MCStruct.str] + VAL (INTEGER,player^.character^.constants.weight DIV 2),ABS (artifact.object.miscellaneous)) THEN
            BashOpenDoorAtLocation (player,line,column,artifact);
          ELSIF MRandom.IntegerRandomRangeValue (1,150) > player^.character^.statistics.used [MCStruct.dex] THEN
            INC (player^.character^.variables.counters [MCStruct.ParalysisCOUNT],MRandom.CardinalRandomRangeValue (2,3));
            MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are off-balance.");
          ELSE
            MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The door holds firm.");
          END; (* IF *)
        END BashDoorAtLocation;
        
      BEGIN (* BashArtifactAtLocation *)
        IF artifact.object.class = OStruct.ClosedDoor THEN
          BashDoorAtLocation (player,line,column,artifact);
        ELSIF artifact.object.class = OStruct.Chest THEN
          BashChestAtLocation (player,line,column,artifact);
        ELSE
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,WallBashMessage);
        END; (* IF *)
      END BashArtifactAtLocation;
      
    BEGIN (* BashAtLocation *)
      IF location.creature <> DStruct.InvalidCreatureCursor THEN
        BashCreatureAtLocation (player,line,column,player^.dungeon^.creatures [location.creature]);
      ELSIF location.artifact <> DStruct.InvalidArtifactCursor THEN
        BashArtifactAtLocation (player,line,column,player^.dungeon^.artifacts [location.artifact]);
      ELSIF location.elements * DStruct.DungeonFloorElements <> DStruct.EmptyDungeonElementSet THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You bash at empty space.");
      ELSE
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,WallBashMessage);
      END; (* IF *)
    END BashAtLocation;
    
  BEGIN (* ExecuteBashAction *)
    IF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0 THEN
      MPMovement.DetermineConfusedDirection (player,"You are confused.",direction);
    END; (* IF *)
    
    DSActions.DetermineDungeonLocation (player^.character^.line,player^.character^.column,direction,line,column);
    BashAtLocation (player,line,column,player^.dungeon^.physical [line]^ [column]);
    
    MStruct.CharacterTurnExecuted := TRUE;
  END ExecuteBashAction;
END MPBash.
