IMPLEMENTATION MODULE MPBDialog;
  (*/WIN:A*)
  
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT MPBDlg2,MPBooks,MPInven2;
  IMPORT WDialog,WDisplay,Windows;
  IMPORT SYSTEM;
  
  
  CONST
        SpellBookPromptControl = 1101;
        SpellListPromptControl = 1103;
  
  CONST
        SpellBookListBoxControl = 1102;
        SpellListListBoxControl = 1104;
  
  CONST
        ExecutePushButtonControl = 1105;
        CancelPushButtonControl  = 1106;
  
 
  CONST
        ClosePushButtonControl = CancelPushButtonControl;


  TYPE
       SpellSetPointer = POINTER TO MCStruct.PlayerSpellSet;
  
  
  PROCEDURE AllAvailableSpells (player : MStruct.PlayerInfoPointer; class : OStruct.ObjectClassMnemonic) : MCStruct.PlayerSpellSet;
    PROCEDURE SpellsInAvailableSpellBooks (inventory : ARRAY OF OStruct.InventoryItemRecord; class : OStruct.ObjectClassMnemonic) : MCStruct.PlayerSpellSet;
      VAR
          result : MCStruct.PlayerSpellSet;
          index  : CARDINAL;
      
      PROCEDURE AddPlayerSpellSets (value1,value2 : MCStruct.PlayerSpellSet; VAR result : MCStruct.PlayerSpellSet);
      BEGIN (* AddPlayerSpellSets *)
        result := value1 + value2;
      END AddPlayerSpellSets;
      
    BEGIN (* SpellsInAvailableSpellBooks *)
      result := MCStruct.PlayerSpellSet {};
      
      FOR index := 0 TO HIGH (inventory) DO
        IF inventory [index].object.class = class THEN
          AddPlayerSpellSets (result,MPBooks.AllSpellsInBook (inventory [index]),result);
        END; (* IF *)
      END; (* FOR *)
      
      RETURN (result);
    END SpellsInAvailableSpellBooks;
    
  BEGIN (* AllAvailableSpells *)
    RETURN (SpellsInAvailableSpellBooks (player^.character^.inventory.backpack,class) * player^.character^.spells.learned);
  END AllAvailableSpells;
  
  PROCEDURE CloseDisplaySpellsDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* CloseDisplaySpellsDialog *)
    WDialog.EndDialog (window,Windows.FALSE_BOOL);
  END CloseDisplaySpellsDialog;
  
  PROCEDURE CloseLearnSpellDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
  BEGIN (* CloseLearnSpellDialog *)
    WDialog.EndDialog (window,Windows.FALSE_BOOL);
  END CloseLearnSpellDialog;
  
  PROCEDURE CloseSelectSpellDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* CloseSelectSpellDialog *)
    WDialog.EndDialog (window,-1);
  END CloseSelectSpellDialog;
  
  PROCEDURE ExecuteDisplaySpellsCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; command : CARDINAL);
    PROCEDURE ExecuteCancelButton (window : Windows.HWND; command : CARDINAL);
    BEGIN (* ExecuteCancelButton *)
      WDialog.EndDialog (window,Windows.FALSE_BOOL);
    END ExecuteCancelButton;
    
    PROCEDURE ExecuteSpellBookCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteSpellBookCommand *)
      IF command = Windows.LBN_SELCHANGE THEN
        MPBDlg2.InitializeSpellListListBox (WDialog.GetDlgItem (window,SpellListListBoxControl),player,MPBooks.AllSpellsInBook (player^.character^.inventory.backpack [MPBDlg2.SelectedSpellBookCursor (WDialog.GetDlgItem (window,SpellBookListBoxControl))]));
      END; (* IF *)
    END ExecuteSpellBookCommand;
    
  BEGIN (* ExecuteDisplaySpellsCommand *)
    CASE control OF
      SpellBookListBoxControl : ExecuteSpellBookCommand (window,player,command); |
      SpellListListBoxControl : (* no action *)                                  |
      
      ClosePushButtonControl,Windows.IDCANCEL : ExecuteCancelButton (window,command); |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteDisplaySpellsCommand;
  
  PROCEDURE ExecuteLearnSpellDialogCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS; control : CARDINAL; command : CARDINAL);
    CONST
          LearnPushButtonControl = ExecutePushButtonControl;
    
    PROCEDURE ExecuteCloseButton (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteCloseButton *)
      IF command = Windows.BN_CLICKED THEN
        WDialog.EndDialog (window,Windows.FALSE_BOOL);
      END; (* IF *)
    END ExecuteCloseButton;
    
    PROCEDURE ExecuteLearnButton (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : Windows.HWND; available : SpellSetPointer; command : CARDINAL);
      VAR
          spell : MCStruct.PlayerSpellRange;
      
    BEGIN (* ExecuteLearnButton *)
      IF command = Windows.BN_CLICKED THEN
        spell := MPBDlg2.CurrentlySelectedSpell (control);
        
        player^.character^.spells.order [player^.character^.spells.known] := spell;
        
        INCL (player^.character^.spells.learned,spell);
        DEC (player^.character^.spells.available);
        INC (player^.character^.spells.known);
        EXCL (available^,spell);
        
        IF ((player^.character^.spells.available = 0) OR (available^ = MCStruct.PlayerSpellSet {})) THEN
          WDialog.EndDialog (window,Windows.TRUE_BOOL);
        ELSE
          MPBDlg2.DeleteCurrentlySelectedSpell (window,control,LearnPushButtonControl);
        END; (* IF *)
      END; (* IF *)
    END ExecuteLearnButton;
    
    PROCEDURE ExecuteSpellListCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; available : SpellSetPointer; command : CARDINAL);
    BEGIN (* ExecuteSpellListCommand *)
      IF command = Windows.LBN_SELCHANGE THEN
        WDialog.EnableDialogControl (window,LearnPushButtonControl,TRUE);
      ELSIF command = Windows.LBN_DBLCLK THEN
        ExecuteLearnButton (window,player,WDialog.GetDlgItem (window,SpellListListBoxControl),available,Windows.BN_CLICKED);
      END; (* IF *)
    END ExecuteSpellListCommand;
    
  BEGIN (* ExecuteLearnSpellDialogCommand *)
    CASE control OF
      SpellListListBoxControl : ExecuteSpellListCommand (window,player,SpellSetPointer (data),command); |
      
      ClosePushButtonControl,Windows.IDCANCEL : ExecuteCloseButton (window,player,command);                                                                            |
      LearnPushButtonControl,Windows.IDOK     : ExecuteLearnButton (window,player,WDialog.GetDlgItem (window,SpellListListBoxControl),SpellSetPointer (data),command); |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteLearnSpellDialogCommand;
  
  PROCEDURE ExecuteSelectSpellDialogCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; command : CARDINAL);
    PROCEDURE ExecuteCancelButton (window : Windows.HWND; command : CARDINAL);
    BEGIN (* ExecuteCancelButton *)
      IF command = Windows.BN_CLICKED THEN
        WDialog.EndDialog (window,-1);
      END; (* IF *)
    END ExecuteCancelButton;
    
    PROCEDURE ExecuteExecuteButton (window : Windows.HWND; command : CARDINAL);
    BEGIN (* ExecuteExecuteButton *)
      IF command = Windows.BN_CLICKED THEN
        WDialog.EndDialog (window,MPBDlg2.CurrentlySelectedSpell (WDialog.GetDlgItem (window,SpellListListBoxControl)));
      END; (* IF *)
    END ExecuteExecuteButton;
    
    PROCEDURE ExecuteSpellListCommand (window : Windows.HWND; command : CARDINAL);
    BEGIN (* ExecuteSpellListCommand *)
      IF command = Windows.LBN_SELCHANGE THEN
        WDialog.EnableDialogControl (window,ExecutePushButtonControl,TRUE);
      ELSIF command = Windows.LBN_DBLCLK THEN
        ExecuteExecuteButton (window,Windows.BN_CLICKED);
      END; (* IF *)
    END ExecuteSpellListCommand;
    
  BEGIN (* ExecuteSelectSpellDialogCommand *)
    CASE control OF
      CancelPushButtonControl,Windows.IDCANCEL : ExecuteCancelButton (window,command);  |
      ExecutePushButtonControl,Windows.IDOK    : ExecuteExecuteButton (window,command); |
      SpellListListBoxControl                  : ExecuteSpellListCommand (window,command);        |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteSelectSpellDialogCommand;
  
  PROCEDURE InitializeDisplaySpellsDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* InitializeDisplaySpellsDialog *)
    IF player^.character^.constants.class IN MCStruct.PriestClasses THEN
      WDisplay.SetWindowText (window,"Browse Prayer Books");
    ELSE
      WDisplay.SetWindowText (window,"Browse Spell Books");
    END; (* IF *)
    
    InitializeSpellBookListBox (window,player);
    
    WDialog.ShowDialogControl (window,ExecutePushButtonControl,FALSE);
    WDialog.SetDlgItemText (window,ClosePushButtonControl,"&Close");
  END InitializeDisplaySpellsDialog;
  
  PROCEDURE InitializeLearnSpellDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
    VAR
        available : SpellSetPointer;
    
  BEGIN (* InitializeLearnSpellDialog *)
    available := SpellSetPointer (data);
    
    MPBDlg2.InitializeSpellListListBox (WDialog.GetDlgItem (window,SpellListListBoxControl),player,available^);
    InitializeSpellBookListBox (window,player);
    
    WDialog.EnableDialogControl (window,ExecutePushButtonControl,FALSE);
    WDialog.SetDlgItemText (window,ExecutePushButtonControl,"&Learn");
  END InitializeLearnSpellDialog;
  
  PROCEDURE InitializeSelectPrayerDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* InitializeSelectPrayerDialog *)
    MPBDlg2.InitializeSpellListListBox (WDialog.GetDlgItem (window,SpellListListBoxControl),player,AllAvailableSpells (player,OStruct.PrayerBook));
    WDisplay.SetWindowText (window,"Execute which prayer?");
    
    WDialog.EnableDialogControl (window,ExecutePushButtonControl,FALSE);
    InitializeSpellBookListBox (window,player);
  END InitializeSelectPrayerDialog;
  
  PROCEDURE InitializeSelectSpellDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* InitializeSelectSpellDialog *)
    MPBDlg2.InitializeSpellListListBox (WDialog.GetDlgItem (window,SpellListListBoxControl),player,AllAvailableSpells (player,OStruct.MagicBook));
    InitializeSpellBookListBox (window,player);
    
    WDialog.EnableDialogControl (window,ExecutePushButtonControl,FALSE);
    WDialog.EnableDialogControl (window,SpellBookListBoxControl,FALSE);
  END InitializeSelectSpellDialog;
  
  PROCEDURE InitializeSpellBookListBox (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* InitializeSpellBookListBox *)
    IF player^.character^.constants.class IN MCStruct.PriestClasses THEN
      WDialog.SetDlgItemText (window,SpellBookPromptControl,"Prayer &Books");
      WDialog.SetDlgItemText (window,SpellListPromptControl,"&Prayers");
      
      MPInven2.InitializeBackpackListBox (WDialog.GetDlgItem (window,SpellBookListBoxControl),player,OStruct.ObjectClassSet {OStruct.PrayerBook});
    ELSE
      WDialog.SetDlgItemText (window,SpellBookPromptControl,"Spell &Books");
      WDialog.SetDlgItemText (window,SpellListPromptControl,"&Spells");
      
      MPInven2.InitializeBackpackListBox (WDialog.GetDlgItem (window,SpellBookListBoxControl),player,OStruct.ObjectClassSet {OStruct.MagicBook});
    END; (* IF *)
  END InitializeSpellBookListBox;
END MPBDialog.
