IMPLEMENTATION MODULE MPBDlg2;
  (*/WIN:A*)
  
  IMPORT Windows,WDialog,WListBox,WString;
  IMPORT MCStruct,MStruct;
  IMPORT MCSActions;
  IMPORT ASCII;
  
  
  PROCEDURE CurrentlySelectedSpell (control : Windows.HWND) : MCStruct.PlayerSpellRange;
  BEGIN (* CurrentlySelectedSpell *)
    RETURN (WListBox.CurrentlySelectedItemData (control));
  END CurrentlySelectedSpell;
  
  PROCEDURE DeleteCurrentlySelectedSpell (dialog : Windows.HWND; control : Windows.HWND; button : CARDINAL);
    VAR
        result : Windows.LRESULT;
    
  BEGIN (* DeleteCurrentlySelectedSpell *)
    WListBox.DeleteString (control,WListBox.GetCurSel (control),result);
    WDialog.EnableDialogControl (dialog,button,FALSE);
  END DeleteCurrentlySelectedSpell;

  PROCEDURE InitializeSpellListListBox (control : Windows.HWND; player : MStruct.PlayerInfoPointer; available : MCStruct.PlayerSpellSet);
    VAR
        spell : MCStruct.PlayerSpellRange;
    
    PROCEDURE AddSpellToListBox (control : Windows.HWND; player : MStruct.PlayerInfoPointer; spell : MCStruct.PlayerSpellInfoRecord; position : MCStruct.PlayerSpellRange);
      VAR
          description : ARRAY [0..127] OF CHAR;
          result      : Windows.LRESULT;
      
      PROCEDURE ReturnSpellDescriptionString (player : MStruct.PlayerInfoPointer; spell : MCStruct.PlayerSpellInfoRecord; position : MCStruct.PlayerSpellRange; VAR result : ARRAY OF CHAR);
        VAR
            info : MCStruct.PlayerSpellInformation;
        
      BEGIN (* ReturnSpellDescriptionString *)
        WString.ReplaceStringParameter ("%NAME|%LEVEL|%MANA|%CHANCE|%COMMENT","%NAME",player^.character^.spells.names [position],result);
        
        info := player^.character^.spells;
        
        IF position IN info.forgotten THEN
          WString.ReplaceStringParameter (result,"%COMMENT","forgotten",result);
        ELSIF NOT (position IN info.learned) THEN
          WString.ReplaceStringParameter (result,"%COMMENT","unknown",result);
        ELSIF NOT (position IN info.worked) THEN
          WString.ReplaceStringParameter (result,"%COMMENT","untried",result);
        ELSE
          WString.ReplaceStringParameter (result,"|%COMMENT","",result);
        END; (* IF *)
        
        WString.ReplaceCardinalParameter (result,"%CHANCE",MCSActions.CharacterSpellFailureChance (player^.character,spell),result);
        WString.ReplaceCardinalParameter (result,"%LEVEL",spell.level,result);
        WString.ReplaceCardinalParameter (result,"%MANA",spell.mana,result);
        
        WString.ReplaceCharParameter (result,"|",ASCII.ht,result);
      END ReturnSpellDescriptionString;
      
    BEGIN (* AddSpellToListBox *)
      IF spell.level <> MCStruct.InvalidSpellLevel THEN
        ReturnSpellDescriptionString (player,spell,position,description);
        WListBox.AddStringAndData (control,description,position,result);
      END; (* IF *)
    END AddSpellToListBox;
    
    PROCEDURE SetSpellListTabs (control : Windows.HWND);
      CONST
            NumberTabStops = 4;
      
      VAR
          tabs : ARRAY [0..NumberTabStops - 1] OF INTEGER;
          done : BOOLEAN;
      
    BEGIN (* SetSpellListTabs *)
      tabs [0] := 35 * WListBox.DialogUnitsPerCharacter;
      tabs [1] := 42 * WListBox.DialogUnitsPerCharacter;
      tabs [2] := 48 * WListBox.DialogUnitsPerCharacter;
      tabs [3] := 54 * WListBox.DialogUnitsPerCharacter;
        
      WListBox.SetTabStops (control,NumberTabStops,tabs,done);
    END SetSpellListTabs;
    
  BEGIN (* InitializeSpellListListBox *)
    WListBox.ResetContent (control);
    SetSpellListTabs (control);
    
    FOR spell := MIN (MCStruct.PlayerSpellRange) TO MAX (MCStruct.PlayerSpellRange) DO
      IF spell IN available THEN
        AddSpellToListBox (control,player,player^.character^.spells.table [spell],spell);
      END; (* IF *)
    END; (* FOR *)
  END InitializeSpellListListBox;
  
  PROCEDURE SelectedSpellBookCursor (control : Windows.HWND) : CARDINAL;
  BEGIN (* SelectedSpellBookCursor *)
    RETURN (WListBox.CurrentlySelectedItemData (control));
  END SelectedSpellBookCursor;
END MPBDlg2.
