IMPLEMENTATION MODULE MPBooks;
  (*/WIN:A*)
  
  IMPORT MCSpells,MDialogs,MInventory,MMWindow,MPBDialog,MRandom,MSUpdate;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT DSActions;
  IMPORT WString;
  IMPORT SYSTEM;
  
  
  PROCEDURE AllSpellsInBook (book : OStruct.InventoryItemRecord) : MCStruct.PlayerSpellSet;
    VAR
        result : MCStruct.PlayerSpellSet;
        index  : OStruct.ObjectAttributeMnemonic;
    
  BEGIN (* AllSpellsInBook *)
    result := MCStruct.PlayerSpellSet {};
    
    FOR index := OStruct.Strength TO OStruct.Cursed DO
      IF index IN book.object.attributes THEN
        INCL (result,ORD (index));
      END; (* IF *)
    END; (* FOR *)
    
    RETURN (result);
  END AllSpellsInBook;
  
  PROCEDURE ExecuteBrowseBookCommand (player : MStruct.PlayerInfoPointer);
    VAR
        result : INTEGER;
    
    PROCEDURE PlayerCarryingAppropriateBook (inventory : ARRAY OF OStruct.InventoryItemRecord; class : MCStruct.PlayerClassMnemonic) : BOOLEAN;
      VAR
          index : CARDINAL;
      
    BEGIN (* PlayerCarryingAppropriateBook *)
      IF class IN MCStruct.PriestClasses THEN
        RETURN (MInventory.AnyObjectsWithClasses (inventory,OStruct.ObjectClassSet {OStruct.PrayerBook}));
      ELSIF class IN MCStruct.MageClasses THEN
        RETURN (MInventory.AnyObjectsWithClasses (inventory,OStruct.ObjectClassSet {OStruct.MagicBook}));
      ELSE
        RETURN (FALSE);
      END; (* IF *)
    END PlayerCarryingAppropriateBook;
    
  BEGIN (* ExecuteBrowseBookCommand *)
    IF NOT (PlayerCarryingAppropriateBook (player^.character^.inventory.backpack,player^.character^.constants.class)) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are not carrying any book that you could read.");
    ELSIF player^.character^.variables.counters [MCStruct.BlindCOUNT] > 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You can't see to read your spell book!");
    ELSIF NOT (DSActions.PlayerHasLight (player)) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You have no light to read by.");
    ELSIF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are too confused.");
    ELSE
      MDialogs.ExecuteMoriaDialogBox (player^.windows.frame,MPBDialog.CharacterSpellDialogTemplate,player,MPBDialog.InitializeDisplaySpellsDialog,MPBDialog.ExecuteDisplaySpellsCommand,MPBDialog.CloseDisplaySpellsDialog,result);
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteBrowseBookCommand;
  
  PROCEDURE ExecuteLearnSpellsCommand (player : MStruct.PlayerInfoPointer);
    PROCEDURE LearnMageSpells (player : MStruct.PlayerInfoPointer);
      PROCEDURE AvailableUnlearnedSpells (player : MStruct.PlayerInfoPointer) : MCStruct.PlayerSpellSet;
        PROCEDURE SpellsInAvailableSpellBooks (VAR inventory : ARRAY OF OStruct.InventoryItemRecord) : MCStruct.PlayerSpellSet;
          VAR
              available : MCStruct.PlayerSpellSet;
              index     : CARDINAL;
          
          PROCEDURE AddPlayerSpellSets (set1,set2 : MCStruct.PlayerSpellSet; VAR result : MCStruct.PlayerSpellSet);
          BEGIN (* AddPlayerSpellSets *)
            result := set1 + set2;
          END AddPlayerSpellSets;
          
        BEGIN (* SpellsInAvailableSpellBooks *)
          available := MCStruct.PlayerSpellSet {};
          
          FOR index := 0 TO HIGH (inventory) DO
            IF inventory [index].object.class = OStruct.MagicBook THEN
              AddPlayerSpellSets (available,AllSpellsInBook (inventory [index]),available);
            END; (* IF *)
          END; (* FOR *)
          
          RETURN (available);
        END SpellsInAvailableSpellBooks;
        
      BEGIN (* AvailableUnlearnedSpells *)
        RETURN (SpellsInAvailableSpellBooks (player^.character^.inventory.backpack) - SpellsAboveLevel (player^.character^.spells.table,player^.character^.variables.level) - player^.character^.spells.learned);
      END AvailableUnlearnedSpells;
      
      PROCEDURE SelectSpellsToLearn (player : MStruct.PlayerInfoPointer; available : MCStruct.PlayerSpellSet);
        VAR
            result : INTEGER;
        
      BEGIN (* SelectSpellsToLearn *)
        IF available <> MCStruct.PlayerSpellSet {} THEN
          MDialogs.ExecuteMoriaDialogBoxParam (player^.windows.frame,MPBDialog.CharacterSpellDialogTemplate,player,SYSTEM.ADR (available),MPBDialog.InitializeLearnSpellDialog,MPBDialog.ExecuteLearnSpellDialogCommand,MPBDialog.CloseLearnSpellDialog,result);
          
          IF player^.character^.spells.available = 0 THEN
            EXCL (player^.character^.variables.status,MCStruct.StudyFLAG);
            MSUpdate.UpdateStudyStatusWindow (player);
          END; (* IF *)
        END; (* IF *)
      END SelectSpellsToLearn;
      
    BEGIN (* LearnMageSpells *)
      IF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0 THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are too confused.");
      ELSIF player^.character^.variables.counters [MCStruct.BlindCOUNT] > 0 THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You can't see to read your spell book!");
      ELSIF NOT (DSActions.PlayerHasLight (player)) THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You have no light to read by.");
      ELSIF player^.character^.spells.available = 0 THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You can't learn any new spells!");
      ELSE
        SelectSpellsToLearn (player,AvailableUnlearnedSpells (player));
      END; (* IF *)
    END LearnMageSpells;
    
    PROCEDURE LearnPriestSpells (player : MStruct.PlayerInfoPointer);
      PROCEDURE AvailableUnlearnedPrayers (player : MStruct.PlayerInfoPointer) : MCStruct.PlayerSpellSet;
      BEGIN (* AvailableUnlearnedPrayers *)
        RETURN (MCStruct.PlayerSpellSet {MIN (MCStruct.PlayerSpellRange)..MAX (MCStruct.PlayerSpellRange)} - SpellsAboveLevel (player^.character^.spells.table,player^.character^.variables.level) - player^.character^.spells.learned);
      END AvailableUnlearnedPrayers;
      
      PROCEDURE SelectPrayersToLearn (player : MStruct.PlayerInfoPointer; available : MCStruct.PlayerSpellSet);
        VAR
            table : ARRAY MCStruct.PlayerSpellRange OF MCStruct.PlayerSpellRange;
            index : CARDINAL;
        
        PROCEDURE DetermineRandomSpellTable (available : MCStruct.PlayerSpellSet; VAR table : ARRAY OF MCStruct.PlayerSpellRange);
          VAR
              spell : MCStruct.PlayerSpellRange;
              index : CARDINAL;
          
          PROCEDURE RandomizeSpellTable (VAR table : ARRAY OF MCStruct.PlayerSpellRange; number : CARDINAL);
            VAR
                index : CARDINAL;
            
            PROCEDURE SwapPlayerSpellRangeValues (VAR value1,value2 : MCStruct.PlayerSpellRange);
              VAR
                  temp : MCStruct.PlayerSpellRange;
              
            BEGIN (* SwapPlayerSpellRangeValues *)
              temp   := value1;
              value1 := value2;
              value2 := temp;
            END SwapPlayerSpellRangeValues;
            
          BEGIN (* RandomizeSpellTable *)
            FOR index := 0 TO number - 1 DO
              SwapPlayerSpellRangeValues (table [index],table [MRandom.CardinalRandomRangeValue (0,number - 1)]);
            END; (* FOR *)
          END RandomizeSpellTable;
          
        BEGIN (* DetermineRandomSpellTable *)
          index := 0;
          
          FOR spell := MIN (MCStruct.PlayerSpellRange) TO MAX (MCStruct.PlayerSpellRange) DO
            IF spell IN available THEN
              table [index] := spell;
              index         := index + 1;
            END; (* IF *)
          END; (* FOR *)
          
          IF index > 0 THEN
            RandomizeSpellTable (table,index);
          END; (* IF *)
        END DetermineRandomSpellTable;
        
        PROCEDURE LearnNewPrayer (player : MStruct.PlayerInfoPointer; prayer : MCStruct.PlayerSpellRange);
          VAR
              message : ARRAY [0..127] OF CHAR;
          
        BEGIN (* LearnNewPrayer *)
          WString.ReplaceStringParameter ("You have learned the prayer of %PRAYER.","%PRAYER",player^.character^.spells.names [prayer],message);
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,message);
          
          player^.character^.spells.order [player^.character^.spells.known] := prayer;
          
          INCL (player^.character^.spells.learned,prayer);
          DEC (player^.character^.spells.available);
          INC (player^.character^.spells.known);
        END LearnNewPrayer;
        
      BEGIN (* SelectPrayersToLearn *)
        DetermineRandomSpellTable (available,table);
        
        index := 0;
        
        WHILE ((player^.character^.spells.available > 0) AND (available <> MCStruct.PlayerSpellSet {})) DO
          LearnNewPrayer (player,table [index]);
          
          EXCL (available,table [index]);
          INC (index);
        END; (* WHILE *)
        
        IF player^.character^.spells.available = 0 THEN
          EXCL (player^.character^.variables.status,MCStruct.StudyFLAG);
          MSUpdate.UpdateStudyStatusWindow (player);
        END; (* IF *)
      END SelectPrayersToLearn;
      
    BEGIN (* LearnPriestSpells *)
      IF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0 THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are too confused.");
      ELSIF player^.character^.spells.available = 0 THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You can't learn any new prayers!");
      ELSE
        SelectPrayersToLearn (player,AvailableUnlearnedPrayers (player));
      END; (* IF *)
    END LearnPriestSpells;
    
    PROCEDURE SpellsAboveLevel (VAR spells : ARRAY OF MCStruct.PlayerSpellInfoRecord; level : INTEGER) : MCStruct.PlayerSpellSet;
      VAR
          result : MCStruct.PlayerSpellSet;
          index  : CARDINAL;
      
    BEGIN (* SpellsAboveLevel *)
      result := MCStruct.PlayerSpellSet {};
      
      FOR index := 0 TO HIGH (spells) DO
        IF spells [index].level > level THEN
          INCL (result,index);
        END; (* IF *)
      END; (* FOR *)
      
      RETURN (result);
    END SpellsAboveLevel;
    
  BEGIN (* ExecuteLearnSpellsCommand *)
    IF player^.character^.constants.class IN MCStruct.PriestClasses THEN
      LearnPriestSpells (player);
    ELSIF player^.character^.constants.class IN MCStruct.MageClasses THEN
      LearnMageSpells (player);
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Warriors can't learn spells or prayers.");
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
    
    IF player^.character^.constants.class <> MCStruct.Warrior THEN
      IF player^.character^.variables.manaMAX = 0.0 THEN
        MCSpells.CalculatePlayerMana (player);
      END; (* IF *)
      
      MSUpdate.UpdateStudyStatusWindow (player);
    END; (* IF *)
  END ExecuteLearnSpellsCommand;
END MPBooks.
