IMPLEMENTATION MODULE MPComm1;
  (*/WIN:A*)
  
  IMPORT MChests,MDGenerator,MDPainting,MDWindow,MInventory,MMWindow,MPMovement,MRandom,MSUpdate,MTraps;
  IMPORT DSActions,MCSActions,MSActs2,OSActions;
  IMPORT DStruct,MCStruct,MStruct,OStruct;
  IMPORT WString;
  
  
  PROCEDURE AscendStairs (player : MStruct.PlayerInfoPointer);
    PROCEDURE UpStairsAtLocation (player : MStruct.PlayerInfoPointer; location : DStruct.PhysicalDungeonUnit) : BOOLEAN;
    BEGIN (* UpStairsAtLocation *)
      RETURN ((location.artifact <> DStruct.InvalidArtifactCursor) AND (player^.dungeon^.artifacts [location.artifact].object.class = OStruct.UpStair));
    END UpStairsAtLocation;
    
  BEGIN (* AscendStairs *)
    MStruct.CharacterTurnExecuted := UpStairsAtLocation (player,player^.dungeon^.physical [player^.character^.line]^ [player^.character^.column]);
    
    IF MStruct.CharacterTurnExecuted THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You enter a maze of up staircase.");
      
      DEC (player^.character^.variables.depthCUR);
      
      MSUpdate.UpdateCurrentDepthWindow (player);
      MDGenerator.GeneratePlayerDungeon (player);
      
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You pass through a one-way door.");
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"I see no up staircase here.");
    END; (* IF *)
  END AscendStairs;

  PROCEDURE DisplayBlockingCreatureMessage (player : MStruct.PlayerInfoPointer; creature : DStruct.DungeonCreatureRecord);
    VAR
        message : ARRAY [0..127] OF CHAR;
    
  BEGIN (* DisplayBlockingCreatureMessage *)
    IF creature.visible THEN
      WString.ReplaceStringParameter ("The %CREATURE is in your way!","%CREATURE",player^.creatures^.table [creature.cursor].description,message);
    ELSE
      message := "Something is in your way!";
    END; (* IF *)
    
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,message);
  END DisplayBlockingCreatureMessage;
  
  PROCEDURE ExecuteCloseAction (player : MStruct.PlayerInfoPointer; direction : CARDINAL);
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
    
    PROCEDURE AttemptToCloseDoor (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR artifact : OStruct.InventoryItemRecord);
      PROCEDURE CloseDoorAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR artifact : OStruct.InventoryItemRecord);
      BEGIN (* CloseDoorAtLocation *)
        player^.dungeon^.physical [line]^ [column].elements := player^.dungeon^.physical [line]^ [column].elements - DStruct.DungeonFloorElements + DStruct.DungeonElementSet {DStruct.BlockedFloor};
        OSActions.ReturnInventoryItemRecord (player^.treasures,OStruct.ClosedDoorObjectCursor,artifact);
        
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
      END CloseDoorAtLocation;
      
    BEGIN (* AttemptToCloseDoor *)
      IF player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor THEN
        DisplayBlockingCreatureMessage (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature]);
      ELSIF artifact.object.miscellaneous <> 0 THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The door appears to be broken.");
      ELSE
        CloseDoorAtLocation (player,line,column,artifact);
      END; (* IF *)
    END AttemptToCloseDoor;
    
    PROCEDURE OpenDoorAtLocation (VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange) : BOOLEAN;
    BEGIN (* OpenDoorAtLocation *)
      RETURN ((dungeon.physical [line]^ [column].artifact <> DStruct.InvalidArtifactCursor) AND (dungeon.artifacts [dungeon.physical [line]^ [column].artifact].object.class = OStruct.OpenDoor));
    END OpenDoorAtLocation;
    
  BEGIN (* ExecuteCloseAction *)
    DSActions.DetermineDungeonLocation (player^.character^.line,player^.character^.column,direction,line,column);
    MStruct.CharacterTurnExecuted := OpenDoorAtLocation (player^.dungeon^,line,column);
    
    IF MStruct.CharacterTurnExecuted THEN
      AttemptToCloseDoor (player,line,column,player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact]);
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"I do not see anything you can close there.");
    END; (* IF *)
  END ExecuteCloseAction;
  
  PROCEDURE ExecuteDescendStairsCommand (player : MStruct.PlayerInfoPointer);
    PROCEDURE DownStairsAtLocation (player : MStruct.PlayerInfoPointer; location : DStruct.PhysicalDungeonUnit) : BOOLEAN;
    BEGIN (* DownStairsAtLocation *)
      RETURN ((location.artifact <> DStruct.InvalidArtifactCursor) AND (player^.dungeon^.artifacts [location.artifact].object.class = OStruct.DownStair));
    END DownStairsAtLocation;
    
  BEGIN (* ExecuteDescendStairsCommand *)
    MStruct.CharacterTurnExecuted := DownStairsAtLocation (player,player^.dungeon^.physical [player^.character^.line]^ [player^.character^.column]);
    
    IF MStruct.CharacterTurnExecuted THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You enter a maze of down staircase.");
      
      INC (player^.character^.variables.depthCUR);
      
      MSUpdate.UpdateCurrentDepthWindow (player);
      MDGenerator.GeneratePlayerDungeon (player);
      
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You pass through a one-way door.");
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"I see no down staircase here.");
    END; (* IF *)
  END ExecuteDescendStairsCommand;
  
  PROCEDURE ExecuteDisarmAction (player : MStruct.PlayerInfoPointer; direction : CARDINAL);
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
    
    PROCEDURE AnythingToDisarmAtLocation (VAR dungeon : DStruct.DungeonInformation; location : DStruct.PhysicalDungeonUnit) : BOOLEAN;
    BEGIN (* AnythingToDisarmAtLocation *)
      RETURN ((location.artifact <> DStruct.InvalidArtifactCursor) AND ((dungeon.artifacts [location.artifact].object.class = OStruct.VisibleTrap) OR (dungeon.artifacts [location.artifact].object.class = OStruct.Chest)));
    END AnythingToDisarmAtLocation;
    
    PROCEDURE PlayerDisarmingAbility (player : MStruct.PlayerInfoPointer) : INTEGER;
      VAR
          ability : INTEGER;
      
    BEGIN (* PlayerDisarmingAbility *)
      ability := player^.character^.abilities.disarm + 2 * MCSActions.CharacterDisarmingAdjustment (player^.character) + MCSActions.CharacterStatisticAdjustment (player^.character,MCStruct.int) + MCSActions.ClassDisarmingLevelAdjustment (player^.character^.constants.class) * player^.character^.variables.level DIV 3;
      
      IF ((player^.character^.variables.counters [MCStruct.BlindCOUNT] > 0) OR NOT (DSActions.PlayerHasLight (player))) THEN
        ability := ability DIV 10;
      END; (* IF *)
      
      IF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0 THEN
        ability := ability DIV 10;
      END; (* IF *)
      
      IF player^.character^.variables.counters [MCStruct.ImageCOUNT] > 0 THEN
        ability := ability DIV 10;
      END; (* IF *)
      
      RETURN (ability);
    END PlayerDisarmingAbility;
    
  BEGIN (* ExecuteDisarmAction *)
    DSActions.DetermineDungeonLocation (player^.character^.line,player^.character^.column,direction,line,column);
    
    IF NOT (AnythingToDisarmAtLocation (player^.dungeon^,player^.dungeon^.physical [line]^ [column])) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"I do not see anything to disarm there.");
      MStruct.CharacterTurnExecuted := FALSE;
    ELSIF player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor THEN
      DisplayBlockingCreatureMessage (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature]);
    ELSIF player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact].object.class = OStruct.VisibleTrap THEN
      MTraps.DisarmFloorTrapAtLocation (player,PlayerDisarmingAbility (player),line,column,player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact]);
    ELSE
      MChests.DisarmChestTrapAtLocation (player,PlayerDisarmingAbility (player),line,column,player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact]);
    END; (* IF *)
  END ExecuteDisarmAction;
  
  PROCEDURE ExecuteFillLampCommand (player : MStruct.PlayerInfoPointer);
    PROCEDURE FillLampWithOil (player : MStruct.PlayerInfoPointer; VAR lamp : OStruct.InventoryItemRecord; flask : CARDINAL);
      CONST
            MaximumLampOil = 15000;
      
      VAR
          deleted : BOOLEAN;
      
    BEGIN (* FillLampWithOil *)
      INC (lamp.object.miscellaneous,player^.character^.inventory.backpack [flask].object.miscellaneous);
      
      IF lamp.object.miscellaneous > MaximumLampOil THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You lamp overflows, spilling oil on the ground.");
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You lamp is full.");
        
        lamp.object.miscellaneous := MaximumLampOil;
      ELSIF lamp.object.miscellaneous > MaximumLampOil DIV 2 THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You lamp is more than half full.");
      ELSIF lamp.object.miscellaneous = MaximumLampOil DIV 2 THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You lamp is half full.");
      ELSE
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You lamp is less than full.");
      END; (* IF *)
      
      OSActions.DescribeRemainingObjectQuantity (player,player^.character^.inventory.backpack [flask]);
      MInventory.DecrementInventoryItemQuantity (player,flask,deleted);
    END FillLampWithOil;
    
  BEGIN (* ExecuteFillLampCommand *)
    IF player^.character^.inventory.equipment [MCStruct.Light].object.subclass <> 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"But you are not using a lamp.");
      MStruct.CharacterTurnExecuted := FALSE;
    ELSIF NOT (MInventory.AnyObjectsWithClasses (player^.character^.inventory.backpack,OStruct.ObjectClassSet {OStruct.Flask})) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You have no oil.");
      MStruct.CharacterTurnExecuted := FALSE;
    ELSE
      FillLampWithOil (player,player^.character^.inventory.equipment [MCStruct.Light],MInventory.ObjectClassPosition (player^.character^.inventory.backpack,OStruct.Flask));
      MStruct.CharacterTurnExecuted := TRUE;
    END; (* IF *)
  END ExecuteFillLampCommand;
  
  PROCEDURE ExecuteOpenAction (player : MStruct.PlayerInfoPointer; direction : CARDINAL);
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
    
    PROCEDURE ArtifactCanBeOpened (VAR dungeon : DStruct.DungeonInformation; location : DStruct.PhysicalDungeonUnit) : BOOLEAN;
    BEGIN (* ArtifactCanBeOpened *)
      RETURN ((location.artifact <> DStruct.InvalidArtifactCursor) AND ((dungeon.artifacts [location.artifact].object.class = OStruct.ClosedDoor) OR (dungeon.artifacts [location.artifact].object.class = OStruct.Chest)));
    END ArtifactCanBeOpened;
    
    PROCEDURE AttemptToOpenArtifact (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR artifact : OStruct.InventoryItemRecord);
      PROCEDURE AttemptToOpenDoor (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR artifact : OStruct.InventoryItemRecord);
        PROCEDURE OpenDoorAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR artifact : OStruct.InventoryItemRecord);
        BEGIN (* OpenDoorAtLocation *)
          player^.dungeon^.physical [line]^ [column].elements := player^.dungeon^.physical [line]^ [column].elements / DStruct.DungeonElementSet {DStruct.BlockedFloor,DStruct.CorridorFloor};
          
          OSActions.ReturnInventoryItemRecord (player^.treasures,OStruct.OpenDoorObjectCursor,artifact);
          MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
        END OpenDoorAtLocation;
        
        PROCEDURE SuccessfullyPicksDoorLock (player : MStruct.PlayerInfoPointer; artifact : OStruct.InventoryItemRecord) : BOOLEAN;
        BEGIN (* SuccessfullyPicksDoorLock *)
          RETURN (LockPickAbility (player) - artifact.object.miscellaneous > MRandom.IntegerRandomRangeValue (1,100));
        END SuccessfullyPicksDoorLock;
        
      BEGIN (* AttemptToOpenDoor *)
        IF artifact.object.miscellaneous < 0 THEN
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,"It appears to be stuck.");
        ELSIF artifact.object.miscellaneous = 0 THEN
          OpenDoorAtLocation (player,line,column,artifact);
        ELSIF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0 THEN
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are too confused to pick the lock.");
        ELSIF SuccessfullyPicksDoorLock (player,artifact) THEN
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You have picked the lock.");
          MSActs2.IncreasePlayerExperience (player,1.0);
          
          OpenDoorAtLocation (player,line,column,artifact);
        ELSE
          MMWindow.AddMessageToList (player,"You failed to pick the lock.");
        END; (* IF *)
      END AttemptToOpenDoor;
      
      PROCEDURE LockPickAbility (player : MStruct.PlayerInfoPointer) : INTEGER;
      BEGIN (* LockPickAbility *)
        RETURN (player^.character^.abilities.disarm + 2 * MCSActions.CharacterDisarmingAdjustment (player^.character) + MCSActions.CharacterStatisticAdjustment (player^.character,MCStruct.int) + MCSActions.ClassDisarmingLevelAdjustment (player^.character^.constants.class) * player^.character^.variables.level DIV 3);
      END LockPickAbility;
      
    BEGIN (* AttemptToOpenArtifact *)
      IF player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor THEN
        DisplayBlockingCreatureMessage (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature]);
      ELSIF artifact.object.class = OStruct.Chest THEN
        MChests.AttemptToOpenChest (player,line,column,LockPickAbility (player),artifact);
      ELSE
        AttemptToOpenDoor (player,line,column,artifact);
      END; (* IF *)
    END AttemptToOpenArtifact;
    
  BEGIN (* ExecuteOpenAction *)
    DSActions.DetermineDungeonLocation (player^.character^.line,player^.character^.column,direction,line,column);
    
    MStruct.CharacterTurnExecuted := ArtifactCanBeOpened (player^.dungeon^,player^.dungeon^.physical [line]^ [column]);
    
    IF MStruct.CharacterTurnExecuted THEN
      AttemptToOpenArtifact (player,line,column,player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact]);
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"I do not see anything you could open there.");
    END; (* IF *)
  END ExecuteOpenAction;
  
  PROCEDURE ExecuteSpikeAction (player : MStruct.PlayerInfoPointer; direction : CARDINAL);
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
    
    PROCEDURE PlaceSpikeAtLocation (player : MStruct.PlayerInfoPointer; VAR location : DStruct.PhysicalDungeonUnit; spike : CARDINAL);
    BEGIN (* PlaceSpikeAtLocation *)
      IF ((location.artifact = DStruct.InvalidArtifactCursor) OR NOT (player^.dungeon^.artifacts [location.artifact].object.class IN OStruct.ObjectClassSet {OStruct.ClosedDoor,OStruct.OpenDoor})) THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"That isn't a door!");
        MStruct.CharacterTurnExecuted := FALSE;
      ELSIF player^.dungeon^.artifacts [location.artifact].object.class = OStruct.OpenDoor THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The door must be closed first.");
        MStruct.CharacterTurnExecuted := FALSE;
      ELSIF location.creature <> DStruct.InvalidCreatureCursor THEN
        DisplayBlockingCreatureMessage (player,player^.dungeon^.creatures [location.creature]);
        MStruct.CharacterTurnExecuted := FALSE;
      ELSE
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You jam the door with a spike.");
        
        player^.dungeon^.artifacts [location.artifact].object.miscellaneous := -ABS (player^.dungeon^.artifacts [location.artifact].object.miscellaneous) - (1 + 190 DIV (10 + ABS (player^.dungeon^.artifacts [location.artifact].object.miscellaneous)));
        MStruct.CharacterTurnExecuted                                       := TRUE;
        
        OSActions.DescribeRemainingObjectQuantity (player,player^.character^.inventory.backpack [spike]);
        
        IF player^.character^.inventory.backpack [spike].object.quantity > 1 THEN
          DEC (player^.character^.inventory.weight,player^.character^.inventory.backpack [spike].object.weight);
          DEC (player^.character^.inventory.backpack [spike].object.quantity);
        ELSE
          MInventory.DeleteInventoryItem (player,spike);
        END; (* IF *)
      END; (* IF *)
    END PlaceSpikeAtLocation;
    
  BEGIN (* ExecuteSpikeAction *)
    DSActions.DetermineDungeonLocation (player^.character^.line,player^.character^.column,direction,line,column);
    PlaceSpikeAtLocation (player,player^.dungeon^.physical [line]^ [column],MInventory.ObjectClassPosition (player^.character^.inventory.backpack,OStruct.Spike));
  END ExecuteSpikeAction;
END MPComm1.
