IMPLEMENTATION MODULE MPDamage;
  (*/WIN:A*)
  
  IMPORT MIDamage,MInventory,MMWindow,MRandom,MSpells2,MSUpdate;
  IMPORT DStruct,MCStruct,MStruct,OStruct;
  IMPORT MCSActions,OSActions;
  IMPORT Strings;
  IMPORT WMacro;
  
  
  PROCEDURE DamagePlayerWithAcid (player : MStruct.PlayerInfoPointer; damage : CARDINAL; killer : ARRAY OF CHAR);
    VAR
        damaged : BOOLEAN;
    
    PROCEDURE AcidDamageModifier (player : MStruct.PlayerInfoPointer; damagedARMOR : BOOLEAN) : CARDINAL;
    BEGIN (* AcidDamageModifier *)
      RETURN (ORD (damagedARMOR) + 2 * ORD (MCStruct.ResistAcidFLAG IN player^.character^.variables.status) + 1);
    END AcidDamageModifier;
    
  BEGIN (* DamagePlayerWithAcid *)
    MIDamage.DamageRandomBackpackObject (player,OSActions.DamagedByAcid,3,"There is an acrid smell coming from your pack!");
    MIDamage.DamageRandomArmorObject (player,OStruct.ResistAcid,damaged);
    
    ReduceCharacterHitPoints (player,damage DIV AcidDamageModifier (player,damaged),killer);
  END DamagePlayerWithAcid;
  
  PROCEDURE DamagePlayerWithCold (player : MStruct.PlayerInfoPointer; damage : CARDINAL; killer : ARRAY OF CHAR);
    PROCEDURE ColdDamageModifier (player : MStruct.PlayerInfoPointer) : CARDINAL;
      VAR
          modifier : CARDINAL;
      
    BEGIN (* ColdDamageModifier *)
      IF MCStruct.ResistColdFLAG IN player^.character^.variables.status THEN
        modifier := 3;
      ELSE
        modifier := 1;
      END; (* IF *)
      
      IF player^.character^.variables.counters [MCStruct.ResistColdCOUNT] > 0 THEN
        modifier := modifier * 3;
      END; (* IF *)
      
      RETURN (modifier);
    END ColdDamageModifier;
    
  BEGIN (* DamagePlayerWithCold *)
    MIDamage.DamageRandomBackpackObject (player,OSActions.DamagedByCold,5,"Something shatters inside your pack!");
    ReduceCharacterHitPoints (player,damage DIV ColdDamageModifier (player),killer);
  END DamagePlayerWithCold;
  
  PROCEDURE DamagePlayerWithCorrosion (player : MStruct.PlayerInfoPointer; killer : ARRAY OF CHAR);
    VAR
        damaged : BOOLEAN;
    
  BEGIN (* DamagePlayerWithCorrosion *)
    MIDamage.DamageRandomBackpackObject (player,OSActions.DamagedByCorrosion,5,"There is an arcid smell coming from your pack.");
    MIDamage.DamageRandomArmorObject (player,OStruct.ResistAcid,damaged);
    
    IF damaged THEN
      ReduceCharacterHitPoints (player,MRandom.CardinalRandomRangeValue (1,8),killer);
    END; (* IF *)
  END DamagePlayerWithCorrosion;
  
  PROCEDURE DamagePlayerWithFire (player : MStruct.PlayerInfoPointer; damage : CARDINAL; killer : ARRAY OF CHAR);
    PROCEDURE FireDamageModifier (player : MStruct.PlayerInfoPointer) : CARDINAL;
      VAR
          modifier : CARDINAL;
      
    BEGIN (* FireDamageModifier *)
      IF MCStruct.ResistFireFLAG IN player^.character^.variables.status THEN
        modifier := 3;
      ELSE
        modifier := 1;
      END; (* IF *)
      
      IF player^.character^.variables.counters [MCStruct.ResistHeatCOUNT] > 0 THEN
        modifier := modifier * 3;
      END; (* IF *)
      
      RETURN (modifier);
    END FireDamageModifier;
    
  BEGIN (* DamagePlayerWithFire *)
    MIDamage.DamageRandomBackpackObject (player,OSActions.DamagedByFlame,3,"There is smoke coming from your pack!");
    ReduceCharacterHitPoints (player,damage DIV FireDamageModifier (player),killer);
  END DamagePlayerWithFire;
  
  PROCEDURE DamagePlayerWithLightning (player : MStruct.PlayerInfoPointer; damage : CARDINAL; killer : ARRAY OF CHAR);
    PROCEDURE LightningModifier (player : MStruct.PlayerInfoPointer) : CARDINAL;
    BEGIN (* LightningModifier *)
      IF MCStruct.ResistLightningFLAG IN player^.character^.variables.status THEN
        RETURN (3);
      ELSE
        RETURN (1);
      END; (* IF *)
    END LightningModifier;
    
  BEGIN (* DamagePlayerWithLightning *)
    MIDamage.DamageRandomBackpackObject (player,OSActions.DamagedByLightning,3,"There are sparks coming from your pack!");
    ReduceCharacterHitPoints (player,damage DIV LightningModifier (player),killer);
  END DamagePlayerWithLightning;
  
  PROCEDURE DamagePlayerWithPoisonGas (player : MStruct.PlayerInfoPointer; damage : CARDINAL; killer : ARRAY OF CHAR);
  BEGIN (* DamagePlayerWithPoisonGas *)
    INC (player^.character^.variables.counters [MCStruct.PoisonedCOUNT],MRandom.CardinalRandomRangeValue (1,damage) + 12);
    ReduceCharacterHitPoints (player,damage,killer);
  END DamagePlayerWithPoisonGas;
  
  PROCEDURE DisenchantObject (player : MStruct.PlayerInfoPointer; VAR item : OStruct.InventoryItemRecord; VAR noticed : BOOLEAN);
  BEGIN (* DisenchantObject *)
    IF ((item.object.strikeMOD > 0) OR (item.object.damageMOD > 0) OR (item.object.armorMOD > 0)) THEN
      DEC (item.object.strikeMOD,WMacro.MaxCardinal (MRandom.CardinalRandomRangeValue (1,2),item.object.strikeMOD));
      DEC (item.object.damageMOD,WMacro.MaxCardinal (MRandom.CardinalRandomRangeValue (1,2),item.object.damageMOD));
      DEC (item.object.armorMOD,WMacro.MaxCardinal (MRandom.CardinalRandomRangeValue (1,2),item.object.armorMOD));
      
      MMWindow.AddMessageToList (player,"There is a static feeling in the air.");
      
      MCSActions.CalculatePlayerBonuses (player^.character);
    ELSE
      noticed := FALSE;
    END; (* IF *)
  END DisenchantObject;
  
  PROCEDURE EffectFoodDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
    VAR
        deleted : BOOLEAN;
    
    PROCEDURE RandomFoodObject (inventory : ARRAY OF OStruct.InventoryItemRecord) : CARDINAL;
      VAR
          first,final : CARDINAL;
      
    BEGIN (* RandomFoodObject *)
      first := OSActions.FirstObjectWithClass (inventory,OStruct.Food);
      final := OSActions.FinalObjectWithClass (inventory,OStruct.Food);
      
      IF first <> final THEN
        RETURN (MRandom.CardinalRandomRangeValue (first,final));
      ELSE
        RETURN (first);
      END; (* IF *)
    END RandomFoodObject;
    
  BEGIN (* EffectFoodDamage *)
    IF MInventory.AnyObjectsWithClasses (player^.character^.inventory.backpack,OStruct.ObjectClassSet {OStruct.Food}) THEN
      MInventory.DecrementInventoryItemQuantity (player,RandomFoodObject (player^.character^.inventory.backpack),deleted);
      MMWindow.AddMessageToList (player,"It got at your rations!");
    ELSE
      noticed := FALSE;
    END; (* IF *)
  END EffectFoodDamage;
  
  PROCEDURE EffectObjectDamage (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; killer : ARRAY OF CHAR; VAR noticed : BOOLEAN);
    VAR
        deleted : BOOLEAN;
    
    PROCEDURE RandomBackpackObject (VAR inventory : MCStruct.PlayerInventoryInformation) : CARDINAL;
    BEGIN (* RandomBackpackObject *)
      RETURN (MRandom.CardinalRandomRangeValue (0,inventory.counter - 1));
    END RandomBackpackObject;
    
  BEGIN (* EffectObjectDamage *)
    IF ((player^.character^.variables.counters [MCStruct.ParalysisCOUNT] > 1) OR (MRandom.IntegerRandomRangeValue (1,124) >= player^.character^.statistics.used [MCStruct.dex])) THEN
      MInventory.DecrementInventoryItemQuantity (player,RandomBackpackObject (player^.character^.inventory),deleted);
      MMWindow.AddMessageToList (player,"Your backpack feels lighter.");
    ELSE
      MMWindow.AddMessageToList (player,"You grab hold of your backpack!");
    END; (* IF *)
    
    IF MRandom.CardinalRandomRangeValue (1,2) = 1 THEN
      MSpells2.TeleportCreatureAway (player,creature,MCStruct.MaxCharacterSightDistance);
      MMWindow.AddMessageToList (player,"There is a puff of smoke!");
    END; (* IF *)
  END EffectObjectDamage;
  
  PROCEDURE ReduceCharacterHitPoints (player : MStruct.PlayerInfoPointer; damage : CARDINAL; killer : ARRAY OF CHAR);
  BEGIN (* ReduceCharacterHitPoints *)
    IF player^.character^.variables.counters [MCStruct.InvulnCOUNT] = 0 THEN
      player^.character^.variables.hpCUR := WMacro.MaxReal (player^.character^.variables.hpCUR - FLOAT (damage),0.0);
      
      IF player^.character^.variables.hpCUR = 0.0 THEN
        Strings.Assign (killer,player^.killer);
      END; (* IF *)
      
      MSUpdate.UpdateCurrentHitPointsWindow (player);
    END; (* IF *)
  END ReduceCharacterHitPoints;

  PROCEDURE ReduceItemCharges (player : MStruct.PlayerInfoPointer; VAR item : OStruct.InventoryItemRecord; VAR creature : DStruct.DungeonCreatureRecord; VAR noticed : BOOLEAN);
  BEGIN (* ReduceItemCharges *)
    IF ((item.object.class IN OStruct.ObjectClassSet {OStruct.Staff,OStruct.Wand}) AND (item.object.miscellaneous > 0)) THEN
      creature.hitpoints        := creature.hitpoints + player^.creatures^.table [creature.cursor].depth * VAL (CARDINAL,item.object.miscellaneous);
      item.object.miscellaneous := 0;
      
      IF NOT (OSActions.InventoryItemIsKnown2 (item)) THEN
        INCL (item.identification,OStruct.IdentEmpty);
      END; (* IF *)
      
      MMWindow.AddMessageToList (player,"Energy drains from your pack!");
    ELSE
      noticed := FALSE;
    END; (* IF *)
  END ReduceItemCharges;
END MPDamage.
