IMPLEMENTATION MODULE MPInven3;
  (*/WIN:A*)
  
  IMPORT MCLoop,MInventory,MISelect,MMWindow,MPInventory,MPInven2,MPInven4,MPInven5,MPInven6;
  IMPORT DStruct,MCStruct,MStruct,OStruct;
  IMPORT MCSActions,MSActions,MSActs3;
  IMPORT WDialog,Windows,WListBox;
  
  
  PROCEDURE DetermineDropQuantity (window : Windows.HWND; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR dropALL : BOOLEAN; VAR cancel : BOOLEAN);
    VAR
        message : ARRAY [0..127] OF CHAR;
    
  BEGIN (* DetermineDropQuantity *)
    IF item.object.quantity > 1 THEN
      MPInven5.FormatDropAllMessage (player,item,message);
      MMWindow.QueryYesNoCancel (window,player,message,dropALL,cancel);
    ELSE
      dropALL := TRUE;
      cancel  := FALSE;
    END; (* IF *)
  END DetermineDropQuantity;
  
  PROCEDURE ExecuteDropButtonCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    VAR
        position : CARDINAL;
        dropALL  : BOOLEAN;
        result   : Windows.LRESULT;
        cancel   : BOOLEAN;
        break    : BOOLEAN;
        item     : OStruct.InventoryItemRecord;
    
  BEGIN (* ExecuteDropButtonCommand *)
    IF command = Windows.BN_CLICKED THEN
      IF player^.dungeon^.physical [player^.character^.line]^ [player^.character^.column].artifact = DStruct.InvalidArtifactCursor THEN
        position := WListBox.GetCurSel (WDialog.GetDlgItem (window,MPInventory.BackpackListBoxControl));
        item     := player^.character^.inventory.backpack [position];
        
        DetermineDropQuantity (window,player,item,dropALL,cancel);
        
        IF NOT (cancel) THEN
          MSActs3.DropBackpackItem (window,player,position,dropALL);
          
          MPInventory.UpdateCarriedWeightControl (window,MPInventory.CarriedWeightStaticTextControl,player^.character^.inventory.weight);
          MPInven2.InitializeBackpackListBox (WDialog.GetDlgItem (window,MPInventory.BackpackListBoxControl),player,OStruct.AllBackpackObjects);
          
          WDialog.EnableDialogControl (window,MPInventory.WearWieldPushButtonControl,FALSE);
          WDialog.EnableDialogControl (window,MPInventory.DropPushButtonControl,FALSE);
          
          MPInven5.DisplayDropMessage (window,player,item,dropALL);
          
          MCLoop.ExecuteFullTurnActions (player,break);
          
          IF break THEN
            MPInventory.TerminateCharInvenDialog (window,player);
          END; (* IF *)
        END; (* IF *)
      ELSE
        MMWindow.DisplayPopupMessage (window,player,"There's no room to drop anything here.");
      END; (* IF *)
    END; (* IF *)
  END ExecuteDropButtonCommand;
  
  PROCEDURE ExecuteDropObjectCommand (player : MStruct.PlayerInfoPointer);
    VAR
        position : CARDINAL;
        done     : BOOLEAN;
    
    PROCEDURE DropInventoryItem (player : MStruct.PlayerInfoPointer; position : CARDINAL);
      VAR
          dropALL : BOOLEAN;
          cancel  : BOOLEAN;
      
    BEGIN (* DropInventoryItem *)
      DetermineDropQuantity (player^.windows.frame,player,player^.character^.inventory.backpack [position],dropALL,cancel);
      
      IF NOT (cancel) THEN
        MSActs3.DropBackpackItem (player^.windows.frame,player,position,dropALL);
      END; (* IF *)
    END DropInventoryItem;
    
  BEGIN (* ExecuteDropObjectCommand *)
    IF player^.dungeon^.physical [player^.character^.line]^ [player^.character^.column].artifact = DStruct.InvalidArtifactCursor THEN
      MISelect.SelectInventoryItem (player,"Drop which item?",OStruct.AllBackpackObjects,position,done);
      
      IF done THEN
        DropInventoryItem (player,position);
      END; (* IF *)
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"There's no room to drop anything here.");
    END; (* IF *)
  END ExecuteDropObjectCommand;
  
  PROCEDURE ExecuteExchangeButtonCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
  BEGIN (* ExecuteExchangeButtonCommand *)
    IF command = Windows.BN_CLICKED THEN
      MPInven4.ExchangePlayerWeapons (window,player,TRUE);
    END; (* IF *)
  END ExecuteExchangeButtonCommand;
  
  PROCEDURE ExecuteExitButtonCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
  BEGIN (* ExecuteExitButtonCommand *)
    IF command = Windows.BN_CLICKED THEN
      MPInventory.TerminateCharInvenDialog (window,player);
    END; (* IF *)
  END ExecuteExitButtonCommand;
  
  PROCEDURE ExecuteRemoveButtonCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    VAR
        position : MCStruct.PlayerEquipmentMnemonic;
        break    : BOOLEAN;
        item     : OStruct.InventoryItemRecord;
    
  BEGIN (* ExecuteRemoveButtonCommand *)
    position := VAL (MCStruct.PlayerEquipmentMnemonic,WListBox.CurrentlySelectedItemData (WDialog.GetDlgItem (window,MPInventory.EquipmentListBoxControl)));
    item     := player^.character^.inventory.equipment [position];
    
    IF OStruct.Cursed IN item.object.attributes THEN
      MMWindow.DisplayPopupMessage (window,player,"Hmmm, it seems to be cursed.");
    ELSIF NOT (MInventory.ObjectFitsInInventory (player^.treasures,item,player^.character^.inventory.backpack)) THEN
      MMWindow.DisplayPopupMessage (window,player,"You can't carry it.");
    ELSE
      TransferEquipmentToBackpack (window,player,position);
      
      MCSActions.CalculatePlayerBonuses (player^.character);
      MCLoop.ExecuteFullTurnActions (player,break);
      
      IF break THEN
        MPInventory.TerminateCharInvenDialog (window,player);
      END; (* IF *)
    END; (* IF *)
  END ExecuteRemoveButtonCommand;
  
  PROCEDURE ExecuteWearWieldButtonCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    VAR
        positionBACKPACK : CARDINAL;
        positionEQUIP    : MCStruct.PlayerEquipmentMnemonic;
        break            : BOOLEAN;
        item             : OStruct.InventoryItemRecord;
        done             : BOOLEAN;
    
    PROCEDURE DetermineSelectedBackpackObject (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR item : OStruct.InventoryItemRecord; VAR position : CARDINAL);
    BEGIN (* DetermineSelectedBackpackObject *)
      position := WListBox.GetCurSel (WDialog.GetDlgItem (window,MPInventory.BackpackListBoxControl));
      item     := player^.character^.inventory.backpack [position];
    END DetermineSelectedBackpackObject;
    
    PROCEDURE RemoveObjectFromBackpack (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR item : OStruct.InventoryItemRecord; position : CARDINAL);
      VAR
          deleted : BOOLEAN;
          result  : Windows.LRESULT;
      
    BEGIN (* RemoveObjectFromBackpack *)
      IF ((item.object.quantity > 1) AND (item.object.subclass <= OStruct.ObjectMaximumSingleStackSubclass)) THEN
        item.object.quantity := 1;
      END; (* IF *)
      
      MInventory.DecrementInventoryItemQuantity (player,position,deleted);
      MPInven2.InitializeBackpackListBox (WDialog.GetDlgItem (window,MPInventory.BackpackListBoxControl),player,OStruct.AllBackpackObjects);
    END RemoveObjectFromBackpack;
    
  BEGIN (* ExecuteWearWieldButtonCommand *)
    IF command = Windows.BN_CLICKED THEN
      DetermineSelectedBackpackObject (window,player,item,positionBACKPACK);
      MPInven4.DetermineEquipmentPosition (window,player,item,positionEQUIP,done);
      
      IF done THEN
        RemoveObjectFromBackpack (window,player,item,positionBACKPACK);
        
        TransferEquipmentToBackpack (window,player,positionEQUIP);
        MPInven4.AddObjectToEquipment (window,player,item,positionEQUIP);
        
        MCSActions.CalculatePlayerBonuses (player^.character);
        MCLoop.ExecuteFullTurnActions (player,break);
        
        IF break THEN
          MPInventory.TerminateCharInvenDialog (window,player);
        ELSE
          WDialog.EnableDialogControl (window,MPInventory.WearWieldPushButtonControl,FALSE);
          WDialog.EnableDialogControl (window,MPInventory.DropPushButtonControl,FALSE);
        END; (* IF *)
      END; (* IF *)
    END; (* IF *)
  END ExecuteWearWieldButtonCommand;

  PROCEDURE TransferEquipmentToBackpack (window : Windows.HWND; player : MStruct.PlayerInfoPointer; position : MCStruct.PlayerEquipmentMnemonic);
    VAR
        location : CARDINAL;
    
  BEGIN (* TransferEquipmentToBackpack *)
    IF player^.character^.inventory.equipment [position].object.class <> OStruct.Nothing THEN
      MInventory.AddObjectToPlayerInventory (player,player^.character^.inventory.equipment [position],location);
      
      MPInven2.InitializeBackpackListBox (WDialog.GetDlgItem (window,MPInventory.BackpackListBoxControl),player,OStruct.AllBackpackObjects);
      MPInven6.RemoveObjectFromEquipment (window,player,player^.character^.inventory.equipment [position],position);
    END; (* IF *)
  END TransferEquipmentToBackpack;
END MPInven3.
