IMPLEMENTATION MODULE MPInven4;
  (*/WIN:A*)
  
  IMPORT MCLoop,MInventory,MMWindow,MPInventory,MPInven3,MPInven5,MPInven7;
  IMPORT MCSActions,MSActions,MSActs2;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT WDialog,Windows,WListBox;
  
  
  PROCEDURE AddObjectToEquipment (window : Windows.HWND; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; position : MCStruct.PlayerEquipmentMnemonic);
  BEGIN (* AddObjectToEquipment *)
    player^.character^.inventory.equipment [position] := item;
    player^.character^.inventory.weight               := player^.character^.inventory.weight + item.object.quantity * VAL (CARDINAL,item.object.weight);
    
    MSActions.RecomputeEquipmentBonuses (player,item,MSActions.AddEquipmentBonuses);
    
    AddObjectToEquipmentListBox (WDialog.GetDlgItem (window,MPInventory.EquipmentListBoxControl),player,item,position);
    MPInven5.DisplayNewEquipmentMessage (window,player,item,position);
    
    IF position = MCStruct.Weapon1 THEN
      EXCL (player^.character^.variables.status,MCStruct.WeaponHeavyFLAG);
      MSActs2.CheckStrength (window,player);
    END; (* IF *)
    
    IF ((position = MCStruct.Weapon1) OR (position = MCStruct.Weapon2)) THEN
      WDialog.EnableDialogControl (window,MPInventory.ExchangePushButtonControl,TRUE);
    END; (* IF *)
    
    IF OStruct.Cursed IN item.object.attributes THEN
      MMWindow.DisplayPopupMessage (window,player,"Oops! It feels deathly cold!");
      
      INCL (player^.character^.inventory.equipment [position].identification,OStruct.IdentDamaged);
      player^.character^.inventory.equipment [position].object.value := -1;
    END; (* IF *)
  END AddObjectToEquipment;
  
  PROCEDURE AddObjectToEquipmentListBox (control : Windows.HWND; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; position : MCStruct.PlayerEquipmentMnemonic);
    VAR
        text : ARRAY [0..127] OF CHAR;
    
    PROCEDURE InsertStringAndPosition (control : Windows.HWND; cursor : CARDINAL; text : ARRAY OF CHAR; position : MCStruct.PlayerEquipmentMnemonic);
      VAR
          result : Windows.LRESULT;
          done   : BOOLEAN;
      
    BEGIN (* InsertStringAndPosition *)
      WListBox.InsertString (control,cursor,text,result);
      WListBox.SetItemData (control,cursor,ORD (position),done);
    END InsertStringAndPosition;
    
  BEGIN (* AddObjectToEquipmentListBox *)
    MPInven5.FormatEquipmentDescriptionString (player,item,position,text);
    InsertStringAndPosition (control,EquipmentDisplayCursor (control,position),text,position);
  END AddObjectToEquipmentListBox;
  
  PROCEDURE DetermineEquipmentPosition (window : Windows.HWND; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR position : MCStruct.PlayerEquipmentMnemonic; VAR done : BOOLEAN);
  BEGIN (* DetermineEquipmentPosition *)
    done := TRUE;
    
    CASE item.object.class OF
      OStruct.SlingAmmo..OStruct.Spike,OStruct.MissileWeapon..OStruct.DiggingTool : position := MCStruct.Weapon1; |
      OStruct.HardBodyArmor,OStruct.SoftBodyArmor                                 : position := MCStruct.Body;    |
      
      OStruct.Amulet : position := MCStruct.Neck;  |
      OStruct.Gloves : position := MCStruct.Hands; |
      OStruct.Shield : position := MCStruct.Arm;   |
      OStruct.Boots  : position := MCStruct.Feet;  |
      OStruct.Cloak  : position := MCStruct.Outer; |
      OStruct.Light  : position := MCStruct.Light; |
      OStruct.Helm   : position := MCStruct.Head;  |
      
      OStruct.Ring : MPInven7.DetermineRingPosition (window,player,item,position,done); |
    ELSE
      MMWindow.DisplayPopupMessage (window,player,"IMPOSSIBLE: I don't see how you can use that.");
      done := FALSE;
    END; (* CASE *)
    
    IF (done AND (player^.character^.inventory.equipment [position].object.class <> OStruct.Nothing)) THEN
      IF OStruct.Cursed IN player^.character^.inventory.equipment [position].object.attributes THEN
        MPInven5.DisplayCursedEquipmentMessage (window,player,player^.character^.inventory.equipment [position],position);
        done := FALSE;
      ELSIF NOT (MInventory.ObjectFitsInInventory (player^.treasures,player^.character^.inventory.equipment [position],player^.character^.inventory.backpack)) THEN
        MMWindow.DisplayPopupMessage (window,player,"You will have to drop something first.");
        done := FALSE;
      END; (* IF *)
    END; (* IF *)
  END DetermineEquipmentPosition;
  
  PROCEDURE EquipmentDisplayCursor (control : Windows.HWND; position : MCStruct.PlayerEquipmentMnemonic) : INTEGER;
    VAR
        cursor,limit : CARDINAL;
    
  BEGIN (* EquipmentDisplayCursor *)
    cursor := 0;
    limit  := WListBox.GetCount (control);
    
    WHILE ((cursor < limit) AND (position > VAL (MCStruct.PlayerEquipmentMnemonic,WListBox.GetItemData (control,cursor)))) DO
      INC (cursor);
    END; (* WHILE *)
    
    RETURN (cursor);
  END EquipmentDisplayCursor;
  
  PROCEDURE ExchangePlayerWeapons (window : Windows.HWND; player : MStruct.PlayerInfoPointer; update : BOOLEAN);
    VAR
        break : BOOLEAN;
    
    PROCEDURE SwapInventoryItemRecords (VAR weapon1,weapon2 : OStruct.InventoryItemRecord);
      VAR
          temp : OStruct.InventoryItemRecord;
      
    BEGIN (* SwapInventoryItemRecords *)
      temp    := weapon1;
      weapon1 := weapon2;
      weapon2 := temp;
    END SwapInventoryItemRecords;
    
    PROCEDURE UpdateEquipmentListBoxObject (window,control : Windows.HWND; player : MStruct.PlayerInfoPointer);
      VAR
          result : Windows.LRESULT;
      
      PROCEDURE EquipmentListHasPosition (control : Windows.HWND; position : MCStruct.PlayerEquipmentMnemonic) : BOOLEAN;
        VAR
            cursor,limit : CARDINAL;
        
      BEGIN (* EquipmentListHasPosition *)
        cursor := 0;
        limit  := WListBox.GetCount (control);
        
        WHILE cursor < limit DO
          IF position = VAL (MCStruct.PlayerEquipmentMnemonic,WListBox.GetItemData (control,cursor)) THEN
            RETURN (TRUE);
          END; (* IF *)
          
          INC (cursor);
        END; (* WHILE *)
        
        RETURN (FALSE);
      END EquipmentListHasPosition;
      
    BEGIN (* UpdateEquipmentListBoxObject *)
      IF EquipmentListHasPosition (control,MCStruct.Weapon1) THEN
        WListBox.DeleteString (control,EquipmentDisplayCursor (control,MCStruct.Weapon1),result);
      END; (* IF *)
      
      IF EquipmentListHasPosition (control,MCStruct.Weapon2) THEN
        WListBox.DeleteString (control,EquipmentDisplayCursor (control,MCStruct.Weapon2),result);
      END; (* IF *)
      
      IF player^.character^.inventory.equipment [MCStruct.Weapon1].object.class <> OStruct.Nothing THEN
        AddObjectToEquipmentListBox (control,player,player^.character^.inventory.equipment [MCStruct.Weapon1],MCStruct.Weapon1);
      END; (* IF *)
      
      IF player^.character^.inventory.equipment [MCStruct.Weapon2].object.class <> OStruct.Nothing THEN
        AddObjectToEquipmentListBox (control,player,player^.character^.inventory.equipment [MCStruct.Weapon2],MCStruct.Weapon2);
      END; (* IF *)
      
      WDialog.EnableDialogControl (window,MPInventory.RemovePushButtonControl,FALSE);
    END UpdateEquipmentListBoxObject;
    
  BEGIN (* ExchangePlayerWeapons *)
    IF OStruct.Cursed IN player^.character^.inventory.equipment [MCStruct.Weapon1].object.attributes THEN
      MPInven5.DisplayCursedEquipmentMessage (window,player,player^.character^.inventory.equipment [MCStruct.Weapon1],MCStruct.Weapon1);
    ELSE
      SwapInventoryItemRecords (player^.character^.inventory.equipment [MCStruct.Weapon1],player^.character^.inventory.equipment [MCStruct.Weapon2]);
      
      MSActions.RecomputeEquipmentBonuses (player,player^.character^.inventory.equipment [MCStruct.Weapon2],MSActions.RemoveEquipmentBonuses);
      MSActions.RecomputeEquipmentBonuses (player,player^.character^.inventory.equipment [MCStruct.Weapon1],MSActions.AddEquipmentBonuses);
      
      MPInven5.DisplayExchangedWeaponMessage (window,player,player^.character^.inventory.equipment [MCStruct.Weapon1]);
      
      EXCL (player^.character^.variables.status,MCStruct.WeaponHeavyFLAG);
      MSActs2.CheckStrength (window,player);
      
      MCSActions.CalculatePlayerBonuses (player^.character);
      
      IF update THEN
        UpdateEquipmentListBoxObject (window,WDialog.GetDlgItem (window,MPInventory.EquipmentListBoxControl),player);
        
        MCLoop.ExecuteFullTurnActions (player,break);
        
        IF break THEN
          MPInventory.TerminateCharInvenDialog (window,player);
        END; (* IF *)
      END; (* IF *)
    END; (* IF *)
  END ExchangePlayerWeapons;
  
  PROCEDURE ExecuteEquipmentListCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
  BEGIN (* ExecuteEquipmentListCommand *)
    IF command = Windows.LBN_SELCHANGE THEN
      WDialog.EnableDialogControl (window,MPInventory.RemovePushButtonControl,TRUE);
    ELSIF command = Windows.LBN_DBLCLK THEN
      MPInven3.ExecuteRemoveButtonCommand (window,player,Windows.BN_CLICKED);
    END; (* IF *)
  END ExecuteEquipmentListCommand;
END MPInven4.
