IMPLEMENTATION MODULE MPInven5;
  (*/WIN:A*)
  
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT MMWindow,ODescriptions;
  IMPORT Windows,WString;
  IMPORT ASCII,Strings;
  
  
  PROCEDURE DisplayCursedEquipmentMessage (window : Windows.HWND; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; position : MCStruct.PlayerEquipmentMnemonic);
    VAR
        message : ARRAY [0..127] OF CHAR;
    
    PROCEDURE ReplaceEquipmentMnemonicPosition (text : ARRAY OF CHAR; formal : ARRAY OF CHAR; position : MCStruct.PlayerEquipmentMnemonic; VAR result : ARRAY OF CHAR);
    BEGIN (* ReplaceEquipmentMnemonicPosition *)
      IF position = MCStruct.Weapon1 THEN
        WString.ReplaceStringParameter (text,formal,"wielding",result);
      ELSE
        WString.ReplaceStringParameter (text,formal,"wearing",result);
      END; (* IF *)
    END ReplaceEquipmentMnemonicPosition;
    
  BEGIN (* DisplayCursedEquipmentMessage *)
    ODescriptions.ReplaceObjectDescription ("The %OBJECT you are %POSITION appears to be cursed.","%OBJECT",player,item,FALSE,message);
    ReplaceEquipmentMnemonicPosition (message,"%POSITION",position,message);
    
    MMWindow.DisplayPopupMessage (window,player,message);
  END DisplayCursedEquipmentMessage;
  
  PROCEDURE DisplayDropMessage (window : Windows.HWND; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; dropALL : BOOLEAN);
    VAR
        message : ARRAY [0..127] OF CHAR;
    
  BEGIN (* DisplayDropMessage *)
    IF NOT (dropALL) THEN
      item.object.quantity := 1;
    END; (* IF *)
    
    ODescriptions.ReplaceObjectDescription ("Dropped %OBJECT","%OBJECT",player,item,TRUE,message);
    MMWindow.AddMessageToList (player,message);
  END DisplayDropMessage;
  
  PROCEDURE DisplayExchangedWeaponMessage (window : Windows.HWND; player : MStruct.PlayerInfoPointer; weapon1 : OStruct.InventoryItemRecord);
    VAR
        message : ARRAY [0..127] OF CHAR;
    
  BEGIN (* DisplayExchangedWeaponMessage *)
    IF weapon1.object.class <> OStruct.Nothing THEN
      ODescriptions.ReplaceObjectDescription ("Primary weapon: %OBJECT","%OBJECT",player,weapon1,TRUE,message);
      MMWindow.AddMessageToList (player,message);
    ELSE
      MMWindow.AddMessageToList (player,"No primary weapon.");
    END; (* IF *)
  END DisplayExchangedWeaponMessage;
  
  PROCEDURE DisplayNewEquipmentMessage (window : Windows.HWND; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; position : MCStruct.PlayerEquipmentMnemonic);
    VAR
        message : ARRAY [0..127] OF CHAR;
    
    PROCEDURE ReplaceEquipmentPositionMnemonic (text : ARRAY OF CHAR; parameter : ARRAY OF CHAR; position : MCStruct.PlayerEquipmentMnemonic; VAR result : ARRAY OF CHAR);
    BEGIN (* ReplaceEquipmentPositionMnemonic *)
      IF position = MCStruct.Weapon1 THEN
        WString.ReplaceStringParameter (text,parameter,"You are wielding",result);
      ELSIF position = MCStruct.Light THEN
        WString.ReplaceStringParameter (text,parameter,"Your light source is",result);
      ELSE
        WString.ReplaceStringParameter (text,parameter,"You are wearing",result);
      END; (* IF *)
    END ReplaceEquipmentPositionMnemonic;
    
  BEGIN (* DisplayNewEquipmentMessage *)
    ReplaceEquipmentPositionMnemonic ("%POSITION %OBJECT","%POSITION",position,message);
    ODescriptions.ReplaceObjectDescription (message,"%OBJECT",player,item,TRUE,message);
    
    MMWindow.AddMessageToList (player,message);
  END DisplayNewEquipmentMessage;
  
  PROCEDURE DisplayObjectRemovalMessage (window : Windows.HWND; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; position : MCStruct.PlayerEquipmentMnemonic);
    VAR
        message : ARRAY [0..127] OF CHAR;
    
  BEGIN (* DisplayObjectRemovalMessage *)
    IF ((position = MCStruct.Weapon1) OR (position = MCStruct.Weapon2)) THEN
      ODescriptions.ReplaceObjectDescription ("Was wielding %OBJECT","%OBJECT",player,item,TRUE,message);
    ELSIF position = MCStruct.Light THEN
      ODescriptions.ReplaceObjectDescription ("Light source was %OBJECT","%OBJECT",player,item,TRUE,message);
    ELSE
      ODescriptions.ReplaceObjectDescription ("Was wearing %OBJECT","%OBJECT",player,item,TRUE,message);
    END; (* IF *)
    
    MMWindow.AddMessageToList (player,message);
  END DisplayObjectRemovalMessage;
  
  PROCEDURE FormatDropAllMessage (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR result : ARRAY OF CHAR);
  BEGIN (* FormatDropAllMessage *)
    ODescriptions.ReplaceObjectDescription ("Drop all %OBJECT","%OBJECT",player,item,TRUE,result);
    result [Strings.Length (result) - 1] := '?';
  END FormatDropAllMessage;
  
  PROCEDURE FormatEquipmentDescriptionString (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; position : MCStruct.PlayerEquipmentMnemonic; VAR result : ARRAY OF CHAR);
    PROCEDURE ReplaceParameterWithEquipmentDescription (text : ARRAY OF CHAR; parameter : ARRAY OF CHAR; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR result : ARRAY OF CHAR);
      VAR
          temp : ARRAY [0..127] OF CHAR;
      
    BEGIN (* ReplaceParameterWithEquipmentDescription *)
      ODescriptions.ReturnObjectDescription (player,item,TRUE,temp);
      WString.ReplaceStringParameter (text,parameter,temp,result);
    END ReplaceParameterWithEquipmentDescription;
    
    PROCEDURE ReplaceParameterWithEquipmentPosition (text : ARRAY OF CHAR; parameter : ARRAY OF CHAR; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; position : MCStruct.PlayerEquipmentMnemonic; VAR result : ARRAY OF CHAR);
      PROCEDURE ReplacePrimaryWeaponParameter (text : ARRAY OF CHAR; parameter : ARRAY OF CHAR; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR result : ARRAY OF CHAR);
      BEGIN (* ReplacePrimaryWeaponParameter *)
        IF player^.character^.statistics.used [MCStruct.str] * 15 >= item.object.weight THEN
          WString.ReplaceStringParameter (text,parameter,"Wielding:",result);
        ELSE
          WString.ReplaceStringParameter (text,parameter,"Just lifting:",result);
        END; (* IF *)
      END ReplacePrimaryWeaponParameter;
      
    BEGIN (* ReplaceParameterWithEquipmentPosition *)
      CASE position OF
        MCStruct.Weapon1 : ReplacePrimaryWeaponParameter (text,parameter,player,item,result); |
        
        MCStruct.Head      : WString.ReplaceStringParameter (text,parameter,"On head: ",result);       |
        MCStruct.Neck      : WString.ReplaceStringParameter (text,parameter,"Around neck: ",result);   |
        MCStruct.Body      : WString.ReplaceStringParameter (text,parameter,"On body: ",result);       |
        MCStruct.Arm       : WString.ReplaceStringParameter (text,parameter,"On arm: ",result);        |
        MCStruct.Hands     : WString.ReplaceStringParameter (text,parameter,"On hands: ",result);      |
        MCStruct.RingRight : WString.ReplaceStringParameter (text,parameter,"On right hand: ",result); |
        MCStruct.RingLeft  : WString.ReplaceStringParameter (text,parameter,"On left hand: ",result);  |
        MCStruct.Feet      : WString.ReplaceStringParameter (text,parameter,"On feet: ",result);       |
        MCStruct.Outer     : WString.ReplaceStringParameter (text,parameter,"About body: ",result);    |
        MCStruct.Light     : WString.ReplaceStringParameter (text,parameter,"Light source: ",result);  |
        MCStruct.Weapon2   : WString.ReplaceStringParameter (text,parameter,"Spare weapon: ",result);  |
      ELSE
        HALT;
      END; (* CASE *)
    END ReplaceParameterWithEquipmentPosition;
    
  BEGIN (* FormatEquipmentDescriptionString *)
    ReplaceParameterWithEquipmentDescription ("%POSITION|%DESCRIPTION","%DESCRIPTION",player,item,result);
    ReplaceParameterWithEquipmentPosition (result,"%POSITION",player,item,position,result);
    
    WString.ReplaceCharParameter (result,'|',ASCII.ht,result);
  END FormatEquipmentDescriptionString;
END MPInven5.
