IMPLEMENTATION MODULE MPInven6;
  (*/WIN:A*)
  
  IMPORT WDebugging,WDialog,Windows,WListBox;
  IMPORT MPInventory,MPInven4,MPInven5;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT MSActions,OSActions;
  
  
  PROCEDURE InitializeEquipmentListBox (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
    VAR
        index : MCStruct.PlayerEquipmentMnemonic;
        count : CARDINAL;
        done  : BOOLEAN;
    
  BEGIN (* InitializeEquipmentListBox *)
    WListBox.SetHorizontalExtent (WDialog.GetDlgItem (window,MPInventory.EquipmentListBoxControl),1024);
    WListBox.SetTabDistance (WDialog.GetDlgItem (window,MPInventory.EquipmentListBoxControl),64,done);
    
    IF NOT (done) THEN
      WDebugging.FatalAppExit ("Unable to set list box tab distance.");
    END; (* IF *)
    
    count := 0;
    
    FOR index := MIN (MCStruct.PlayerEquipmentMnemonic) TO MAX (MCStruct.PlayerEquipmentMnemonic) DO
      IF player^.character^.inventory.equipment [index].object.class <> OStruct.Nothing THEN
        MPInven4.AddObjectToEquipmentListBox (WDialog.GetDlgItem (window,MPInventory.EquipmentListBoxControl),player,player^.character^.inventory.equipment [index],index);
        INC (count);
      END; (* IF *)
    END; (* FOR *)
    
    IF ((player^.character^.inventory.equipment [MCStruct.Weapon1].object.class = OStruct.Nothing) AND (player^.character^.inventory.equipment [MCStruct.Weapon2].object.class = OStruct.Nothing)) THEN
      WDialog.EnableDialogControl (window,MPInventory.ExchangePushButtonControl,FALSE);
    END; (* IF *)
  END InitializeEquipmentListBox;
  
  PROCEDURE RemoveObjectFromEquipment (window : Windows.HWND; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; position : MCStruct.PlayerEquipmentMnemonic);
    VAR
        control : Windows.HWND;
        result  : Windows.LRESULT;
    
  BEGIN (* RemoveObjectFromEquipment *)
    control := WDialog.GetDlgItem (window,MPInventory.EquipmentListBoxControl);
    
    WListBox.DeleteString (control,MPInven4.EquipmentDisplayCursor (control,position),result);
    
    MPInven5.DisplayObjectRemovalMessage (window,player,item,position);
    
    IF position <> MCStruct.Weapon2 THEN
      MSActions.RecomputeEquipmentBonuses (player,item,MSActions.RemoveEquipmentBonuses);
    END; (* IF *)
    
    OSActions.ReturnInventoryItemRecord (player^.treasures,OStruct.EmptyObjectCursor,player^.character^.inventory.equipment [position]);
    DEC (player^.character^.inventory.weight,VAL (CARDINAL,item.object.weight) * item.object.quantity);
    
    INCL (player^.character^.variables.status,MCStruct.StrWgtFLAG);
  END RemoveObjectFromEquipment;
END MPInven6.
