IMPLEMENTATION MODULE MPInventory;
  (*/WIN:A*)
  
  IMPORT MDialogs,MPInven2,MPInven3,MPInven4,MPInven6;
  IMPORT WDebugging,WDialog,Windows,WString;
  IMPORT MStruct,OStruct;
  
  
  PROCEDURE ExecuteCharInventoryCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; command : CARDINAL);
  BEGIN (* ExecuteCharInventoryCommand *)
    CASE control OF
      EquipmentListBoxControl : MPInven4.ExecuteEquipmentListCommand (window,player,command); |
      BackpackListBoxControl  : MPInven2.ExecuteBackpackListCommand (window,player,command);  |

      WearWieldPushButtonControl : MPInven3.ExecuteWearWieldButtonCommand (window,player,command); |
      ExchangePushButtonControl  : MPInven3.ExecuteExchangeButtonCommand (window,player,command);           |
      RemovePushButtonControl    : MPInven3.ExecuteRemoveButtonCommand (window,player,command);             |
      DropPushButtonControl      : MPInven3.ExecuteDropButtonCommand (window,player,command);               |
      ExitPushButtonControl      : MPInven3.ExecuteExitButtonCommand (window,player,command);               |
      
      Windows.IDCANCEL : MPInven3.ExecuteExitButtonCommand (window,player,command); |
      Windows.IDOK     : (* no action *)                                   |
    ELSE
      WDebugging.FatalAppExit ("Unrecognized character inventory dialog control.");
    END; (* CASE *)
  END ExecuteCharInventoryCommand;
  
  PROCEDURE ExecuteInventoryCommands (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteInventoryCommands *)
    ExecuteInventoryDialog (player^.windows.frame,player);
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteInventoryCommands;
  
  PROCEDURE ExecuteInventoryDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
    VAR
        result : INTEGER;
    
  BEGIN (* ExecuteInventoryDialog *)
    MDialogs.ExecuteMoriaDialogBox (window,"Char_Inven_Dialog",player,InitializeCharInventoryDialog,ExecuteCharInventoryCommand,TerminateCharInvenDialog,result);
  END ExecuteInventoryDialog;

  PROCEDURE InitializeCharInventoryDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* InitializeCharInventoryDialog *)
    MPInven6.InitializeEquipmentListBox (window,player);
    MPInven2.InitializeBackpackListBox (WDialog.GetDlgItem (window,BackpackListBoxControl),player,OStruct.AllBackpackObjects);
    
    UpdateCarriedWeightControl (window,CarriedWeightStaticTextControl,player^.character^.inventory.weight);
    
    IF player^.character^.variables.hpCUR = 0.0 THEN
      WDialog.ShowDialogControl (window,WearWieldPushButtonControl,FALSE);
      WDialog.ShowDialogControl (window,ExchangePushButtonControl,FALSE);
      WDialog.ShowDialogControl (window,RemovePushButtonControl,FALSE);
      WDialog.ShowDialogControl (window,DropPushButtonControl,FALSE);
    END; (* IF *)
  END InitializeCharInventoryDialog;

  PROCEDURE TerminateCharInvenDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* TerminateCharInvenDialog *)
    WDialog.EndDialog (window,Windows.TRUE_BOOL);
  END TerminateCharInvenDialog;
  
  PROCEDURE UpdateCarriedWeightControl (window : Windows.HWND; control : CARDINAL; weight : CARDINAL);
    VAR
        text : ARRAY [0..127] OF CHAR;
    
  BEGIN (* UpdateCarriedWeightControl *)
    WString.ReplaceCardinalParameter ("You are carrying %MAJOR.%MINOR pounds.","%MAJOR",weight DIV 10,text);
    WString.ReplaceCardinalParameter (text,"%MINOR",weight MOD 10,text);
    
    WDialog.SetDlgItemText (window,control,text);
  END UpdateCarriedWeightControl;
END MPInventory.
