IMPLEMENTATION MODULE MPMove2;
  (*/WIN:A*)
  
  IMPORT WString;
  IMPORT Strings;
  
  IMPORT MDistMove,MInventory,MMWindow,MPMovement,MStores,MSUpdate,MTraps,ODescriptions;
  IMPORT DSActions,MSActions,MSActs3,OSActions;
  IMPORT DStruct,MCStruct,MStruct,OStruct;
  
  
  
  PROCEDURE ArtifactIsAlwaysVisible (item : OStruct.InventoryItemRecord) : BOOLEAN;
  BEGIN (* ArtifactIsAlwaysVisible *)
    RETURN ((item.object.class >= OStruct.VisibleTrap) AND (item.object.class <= OStruct.StoreDoor));
  END ArtifactIsAlwaysVisible;
  
  PROCEDURE ExecuteDungeonArtifactAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR item : OStruct.InventoryItemRecord; prevLINE : DStruct.DungeonLineRange; prevCOLUMN : DStruct.DungeonColumnRange);
    PROCEDURE AttemptArtifactPickup (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; item : OStruct.InventoryItemRecord);
      PROCEDURE AttemptObjectPickup (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; item : OStruct.InventoryItemRecord);
        PROCEDURE ConfirmedPickup (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord) : BOOLEAN;
          VAR
              message : ARRAY [0..127] OF CHAR;
          
        BEGIN (* ConfirmedPickup *)
          ODescriptions.ReplaceObjectDescription ("Pick up %OBJECT","%OBJECT",player,item,TRUE,message);
          message [Strings.Length (message) - 1] := '?';
          
          RETURN (MMWindow.QueryYesNo (player^.windows.frame,player,message,FALSE));
        END ConfirmedPickup;
        
        PROCEDURE HeavyItemPickupConfirmed (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord) : BOOLEAN;
          PROCEDURE ItemWouldChangePlayerSpeed (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord) : BOOLEAN;
            VAR
                weight,limit : INTEGER;
                change       : INTEGER;
            
          BEGIN (* ItemWouldChangePlayerSpeed *)
            weight := player^.character^.inventory.weight + item.object.quantity * VAL (CARDINAL,item.object.weight);
            limit  := MSActions.PlayerBackpackWeightLimit (player);
            
            IF limit < weight THEN
              change := weight DIV (limit + 1);
            ELSE
              change := 0;
            END; (* IF *)
            
            RETURN (change <> player^.character^.inventory.heavyPACK);
          END ItemWouldChangePlayerSpeed;
          
          PROCEDURE ObjectConfirmation (player : MStruct.PlayerInfoPointer; text : ARRAY OF CHAR; formal : ARRAY OF CHAR; item : OStruct.InventoryItemRecord; prefix : BOOLEAN) : BOOLEAN;
            VAR
                message : ARRAY [0..255] OF CHAR;
            
          BEGIN (* ObjectConfirmation *)
            ODescriptions.ReplaceObjectDescription (text,formal,player,item,prefix,message);
            RETURN (MMWindow.QueryYesNo (player^.windows.frame,player,message,TRUE));
          END ObjectConfirmation;
          
        BEGIN (* HeavyItemPickupConfirmed *)
          RETURN (NOT (ItemWouldChangePlayerSpeed (player,item)) OR ObjectConfirmation (player,"Exceed your weight limit to pick up %s","%s",item,TRUE));
        END HeavyItemPickupConfirmed;
        
        PROCEDURE PickupObjectAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; item : OStruct.InventoryItemRecord);
          VAR
              location : CARDINAL;
          
        BEGIN (* PickupObjectAtLocation *)
          MInventory.AddObjectToPlayerInventory (player,item,location);
          DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
          
          OSActions.DisplayObjectMessage (player^.windows.frame,player,"You have %s","%s",player^.character^.inventory.backpack [location],TRUE,TRUE);
        END PickupObjectAtLocation;
        
      BEGIN (* AttemptObjectPickup *)
        IF NOT (MInventory.ObjectFitsInInventory (player^.treasures,item,player^.character^.inventory.backpack)) THEN
          OSActions.DisplayObjectMessage (player^.windows.frame,player,"You can't carry %s","%s",item,TRUE,TRUE);
        ELSIF ((NOT (MCStruct.PromptCarryFLAG IN player^.character^.variables.status) OR ConfirmedPickup (player,item)) AND HeavyItemPickupConfirmed (player,item)) THEN
          PickupObjectAtLocation (player,line,column,item);
        END; (* IF *)
      END AttemptObjectPickup;
      
      PROCEDURE PickupTreasure (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; item : OStruct.InventoryItemRecord);
        PROCEDURE DisplayTreasurePickupMessage (player : MStruct.PlayerInfoPointer; item :  OStruct.InventoryItemRecord);
          VAR
              message : ARRAY [0..127] OF CHAR;
          
        BEGIN (* DisplayTreasurePickupMessage *)
          ODescriptions.ReplaceObjectDescription ("You have found %ld gold pieces worth of %s","%s",player,item,TRUE,message);
          WString.ReplaceLongIntParameter (message,"%ld",item.object.value,message);
          
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,message);
        END DisplayTreasurePickupMessage;
        
      BEGIN (* PickupTreasure *)
        INC (player^.character^.variables.currentGOLD,item.object.value);
        
        MSUpdate.UpdateCurrentGoldWindow (player);
        DisplayTreasurePickupMessage (player,item);
        
        MSActs3.DeleteArtifactAtLocation (player,line,column);
      END PickupTreasure;
      
    BEGIN (* AttemptArtifactPickup *)
      MDistMove.EndDistanceMovement (player);
      
      IF item.object.class <> OStruct.Gold THEN
        AttemptObjectPickup (player,line,column,item);
      ELSE
        PickupTreasure (player,line,column,item);
      END; (* IF *)
    END AttemptArtifactPickup;
    
  BEGIN (* ExecuteDungeonArtifactAction *)
    IF item.object.class <= OStruct.MaximumPortableObjectClass THEN
      AttemptArtifactPickup (player,line,column,item);
    ELSIF ((item.object.class = OStruct.InvisibleTrap) OR (item.object.class = OStruct.VisibleTrap)) THEN
      MTraps.ExecuteTrapAction (player,item);
    ELSIF item.object.class = OStruct.StoreDoor THEN
      MStores.EnterDungeonStore (player);
    ELSIF item.object.class = OStruct.Rubble THEN
      MPMovement.MoveCharacterToLocation (player,prevLINE,prevCOLUMN);
    END; (* IF *)
  END ExecuteDungeonArtifactAction;
END MPMove2.
