IMPLEMENTATION MODULE MPMovement;
  (*/WIN:A*)
  
  IMPORT Strings;
  
  IMPORT MDistMove,MDPainting,MDWindow,MMWindow,MPAttacks,MPSearch,MRandom;
  IMPORT DStruct,MCStruct,MStruct,OStruct;
  IMPORT DSActions;
  IMPORT MPMove2;
  
  
  PROCEDURE DetermineConfusedDirection (player : MStruct.PlayerInfoPointer; message : ARRAY OF CHAR; VAR direction : CARDINAL);
  BEGIN (* DetermineConfusedDirection *)
    IF Strings.Length (message) > 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,message);
    END; (* IF *)
    
    direction := MRandom.CardinalRandomRangeValue (1,8);
    
    IF direction >= 5 THEN
      INC (direction);
    END; (* IF *)
  END DetermineConfusedDirection;
  
  PROCEDURE ExecuteStandStillCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteStandStillCommand *)
    MoveCharacterToLocation (player,player^.character^.line,player^.character^.column);
    MStruct.CharacterTurnExecuted := TRUE;
  END ExecuteStandStillCommand;
  
  PROCEDURE LightDungeonRoom (player : MStruct.PlayerInfoPointer; lineCENTER : DStruct.DungeonLineRange; columnCENTER : DStruct.DungeonColumnRange);
    VAR
        column,minX,maxX : DStruct.DungeonColumnRange;
        line,minY,maxY   : DStruct.DungeonLineRange;
    
    PROCEDURE OptionallyLightDungeonLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : DStruct.PhysicalDungeonUnit);
    BEGIN (* OptionallyLightDungeonLocation *)
      IF location.elements * DStruct.DungeonElementSet {DStruct.lrFLAG,DStruct.plFLAG} = DStruct.DungeonElementSet {DStruct.lrFLAG} THEN
        INCL (location.elements,DStruct.plFLAG);
        
        IF DStruct.DarkFloor IN location.elements THEN
          location.elements := location.elements / DStruct.DungeonElementSet {DStruct.DarkFloor,DStruct.LightFloor};
        END; (* IF *)
        
        IF ((location.artifact <> DStruct.InvalidArtifactCursor) AND NOT (DStruct.fmFLAG IN location.elements) AND MPMove2.ArtifactIsAlwaysVisible (player^.dungeon^.artifacts [location.artifact])) THEN
          INCL (location.elements,DStruct.fmFLAG);
        END; (* IF *)
        
        MDPainting.InvalidateDungeonLocation (player,line,column,TRUE,FALSE);
      END; (* IF *)
    END OptionallyLightDungeonLocation;
    
  BEGIN (* LightDungeonRoom *)
    minX := (columnCENTER DIV DStruct.AverageRoomWidth) * DStruct.AverageRoomWidth;
    maxX := minX + DStruct.AverageRoomWidth - 1;
    
    minY := (lineCENTER DIV DStruct.AverageRoomHeight) * DStruct.AverageRoomHeight;
    maxY := minY + DStruct.AverageRoomHeight - 1;
    
    FOR line := minY TO maxY DO
      FOR column := minX TO maxX DO
        OptionallyLightDungeonLocation (player,line,column,player^.dungeon^.physical [line]^ [column]);
      END; (* FOR *)
    END; (* FOR *)
  END LightDungeonRoom;
  
  PROCEDURE MakeConfusedMove (player : MStruct.PlayerInfoPointer);
    VAR
        direction : CARDINAL;
        column    : DStruct.DungeonColumnRange;
        line      : DStruct.DungeonLineRange;
    
  BEGIN (* MakeConfusedMove *)
    MDistMove.EndDistanceMovement (player);
    DetermineConfusedDirection (player,"",direction);
    
    DSActions.DetermineDungeonLocation (player^.character^.line,player^.character^.column,direction,line,column);
    MoveCharacterToLocation (player,line,column);
  END MakeConfusedMove;
  
  PROCEDURE MoveCharacterToLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    PROCEDURE ExecuteCharacterMove (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
      VAR
          prevLINE,prevCOLUMN : CARDINAL;
          location            : DStruct.PhysicalDungeonUnit;
      
      PROCEDURE ShouldRedrawDungeonWindow (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange) : BOOLEAN;
      BEGIN (* ShouldRedrawDungeonWindow *)
        RETURN (NOT (MDWindow.LocationIsInWindow (player,line - 1,column) AND MDWindow.LocationIsInWindow (player,line + 1,column) AND MDWindow.LocationIsInWindow (player,line,column - 1) AND MDWindow.LocationIsInWindow (player,line,column + 1)));
      END ShouldRedrawDungeonWindow;
      
    BEGIN (* ExecuteCharacterMove *)
      location := player^.dungeon^.physical [line]^ [column];
      
      IF location.elements * DStruct.DungeonElementSet {DStruct.BlockedFloor..DStruct.BoundaryWall} = DStruct.EmptyDungeonElementSet THEN
        prevCOLUMN := player^.character^.column;
        prevLINE   := player^.character^.line;
        
        player^.character^.column := column;
        player^.character^.line   := line;
        
        IF ((MCStruct.DistanceMoveFLAG IN player^.character^.variables.status) AND (player^.character^.variables.counters [MCStruct.BlindCOUNT] = 0)) THEN
          MDistMove.UpdateDistanceMoveInformation (player,prevLINE,prevCOLUMN);
        END; (* IF *)
        
        IF MPSearch.ShouldSearchCurrentLocation (player) THEN
          MPSearch.SearchCurrentLocation (player);
        END; (* IF *)
        
        UpdatePlayerLightDisplay (player,prevLINE,prevCOLUMN);
        
        IF location.artifact <> DStruct.InvalidArtifactCursor THEN
          MPMove2.ExecuteDungeonArtifactAction (player,line,column,player^.dungeon^.artifacts [location.artifact],prevLINE,prevCOLUMN);
        END; (* IF *)
        
        MStruct.CharacterTurnExecuted := TRUE;
      ELSIF MCStruct.DistanceMoveFLAG IN player^.character^.variables.status THEN
        MStruct.CharacterTurnExecuted := FALSE;
        MDistMove.EndDistanceMovement (player);
      ELSIF ((location.artifact <> DStruct.InvalidArtifactCursor) AND (player^.dungeon^.artifacts [location.artifact].object.class = OStruct.ClosedDoor)) THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"There is a closed door blocking your way.");
        MStruct.CharacterTurnExecuted := FALSE;
      ELSIF ((location.artifact <> DStruct.InvalidArtifactCursor) AND (player^.dungeon^.artifacts [location.artifact].object.class = OStruct.Rubble)) THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"There is rubble blocking your way.");
        MStruct.CharacterTurnExecuted := FALSE;
      ELSE
        MStruct.CharacterTurnExecuted := FALSE;
      END; (* IF *)
      
      IF MStruct.CharacterTurnExecuted THEN
        IF ShouldRedrawDungeonWindow (player,player^.character^.line,player^.character^.column) THEN
          MDWindow.CenterDungeonOnLocation (player,player^.character^.line,player^.character^.column,TRUE);
          MDPainting.InvalidateDungeonWindow (player);
        ELSE
          MDPainting.InvalidateDungeonLocation (player,player^.character^.line,player^.character^.column,TRUE,TRUE);
        END; (* IF *)
      END; (* IF *)
    END ExecuteCharacterMove;
    
    PROCEDURE ShouldAttackCreatureAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange) : BOOLEAN;
      VAR
          location : DStruct.PhysicalDungeonUnit;
      
    BEGIN (* ShouldAttackCreatureAtLocation *)
      location := player^.dungeon^.physical [line]^ [column];
      
      IF DStruct.DungeonElementSet {DStruct.TemporaryWall1..DStruct.BoundaryWall} * location.elements <> DStruct.EmptyDungeonElementSet THEN
        RETURN ((location.creature <> DStruct.InvalidCreatureCursor) AND player^.dungeon^.creatures [location.creature].visible);
      ELSE
        RETURN (location.creature <> DStruct.InvalidCreatureCursor);
      END; (* IF *)
    END ShouldAttackCreatureAtLocation;
    
  BEGIN (* MoveCharacterToLocation *)
    IF ShouldAttackCreatureAtLocation (player,line,column) THEN
      MPAttacks.AttackCreatureAtLocation (player,line,column);
    ELSE
      ExecuteCharacterMove (player,line,column);
    END; (* IF *)
  END MoveCharacterToLocation;
  
  PROCEDURE ShouldMakeConfusedMove (player : MStruct.PlayerInfoPointer) : BOOLEAN;
  BEGIN (* ShouldMakeConfusedMove *)
    RETURN ((player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0) AND (MRandom.CardinalRandomRangeValue (1,4) > 1));
  END ShouldMakeConfusedMove;
  
  PROCEDURE UpdatePlayerLightDisplay (player : MStruct.PlayerInfoPointer; prevLINE : DStruct.DungeonLineRange; prevCOLUMN : DStruct.DungeonColumnRange);
    PROCEDURE ClearPlayerLightInformation (player : MStruct.PlayerInfoPointer; lineCENTER : DStruct.DungeonLineRange; columnCENTER : DStruct.DungeonColumnRange);
      VAR
          column : DStruct.DungeonColumnRange;
          line   : DStruct.DungeonLineRange;
      
    BEGIN (* ClearPlayerLightInformation *)
      FOR line := lineCENTER - 1 TO lineCENTER + 1 DO
        FOR column := columnCENTER - 1 TO columnCENTER + 1 DO
          EXCL (player^.dungeon^.physical [line]^ [column].elements,DStruct.tlFLAG);
        END; (* FOR *)
      END; (* FOR *)
      
      MDPainting.InvalidateDungeonArea (player,columnCENTER - 1,columnCENTER + 1,lineCENTER - 1,lineCENTER + 1);
    END ClearPlayerLightInformation;
    
    PROCEDURE MoveDarkPlayerLight (player : MStruct.PlayerInfoPointer; prevLINE : DStruct.DungeonLineRange; prevCOLUMN : DStruct.DungeonColumnRange);
    BEGIN (* MoveDarkPlayerLight *)
      IF MCStruct.PlayerLightFLAG IN player^.character^.variables.status THEN
        ClearPlayerLightInformation (player,prevLINE,prevCOLUMN);
      ELSE
        MDPainting.InvalidateDungeonLocation (player,prevLINE,prevCOLUMN,FALSE,TRUE);
      END; (* IF *)
      
      MDPainting.InvalidateDungeonLocation (player,player^.character^.line,player^.character^.column,TRUE,TRUE);
    END MoveDarkPlayerLight;
    
    PROCEDURE MoveNormalPlayerLight (player : MStruct.PlayerInfoPointer; prevLINE : DStruct.DungeonLineRange; prevCOLUMN : DStruct.DungeonColumnRange);
      VAR
          column : DStruct.DungeonColumnRange;
          line   : DStruct.DungeonLineRange;
      
      PROCEDURE UpdateLocationLightInformation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : DStruct.PhysicalDungeonUnit);
      BEGIN (* UpdateLocationLightInformation *)
        IF location.elements * DStruct.DungeonWallElements <> DStruct.EmptyDungeonElementSet THEN
          INCL (location.elements,DStruct.plFLAG);
        ELSIF DStruct.LightFloor IN location.elements THEN
          LightDungeonRoom (player,line,column);
        END; (* IF *)
        
        INCL (location.elements,DStruct.tlFLAG);
        
        IF (NOT (DStruct.fmFLAG IN location.elements) AND (location.artifact <> DStruct.InvalidArtifactCursor) AND (player^.dungeon^.artifacts [location.artifact].object.class >= OStruct.FirstAlwaysVisibleObject) AND (player^.dungeon^.artifacts [location.artifact].object.class <= OStruct.FinalAlwaysVisibleObject)) THEN
          INCL (location.elements,DStruct.fmFLAG);
        END; (* IF *)
      END UpdateLocationLightInformation;
      
    BEGIN (* MoveNormalPlayerLight *)
      ClearPlayerLightInformation (player,prevLINE,prevCOLUMN);
      
      FOR line := player^.character^.line - 1 TO player^.character^.line + 1 DO
        FOR column := player^.character^.column - 1 TO player^.character^.column + 1 DO
          UpdateLocationLightInformation (player,line,column,player^.dungeon^.physical [line]^ [column]);
        END; (* FOR *)
      END; (* FOR *)
      
      MDPainting.InvalidateDungeonArea (player,player^.character^.column - 1,player^.character^.column + 1,player^.character^.line - 1,player^.character^.line + 1);
    END MoveNormalPlayerLight;
    
  BEGIN (* UpdatePlayerLightDisplay *)
    IF ((player^.character^.variables.counters [MCStruct.BlindCOUNT] = 0) AND (MCStruct.PlayerLightFLAG IN player^.character^.variables.status)) THEN
      MoveNormalPlayerLight (player,prevLINE,prevCOLUMN);
    ELSE
      MoveDarkPlayerLight (player,prevLINE,prevCOLUMN);
    END; (* IF *)
  END UpdatePlayerLightDisplay;
  
  PROCEDURE WalkEast (player : MStruct.PlayerInfoPointer);
  BEGIN (* WalkEast *)
    IF ShouldMakeConfusedMove (player) THEN
      MakeConfusedMove (player);
    ELSE
      MoveCharacterToLocation (player,player^.character^.line,player^.character^.column + 1);
    END; (* IF *)
  END WalkEast;
  
  PROCEDURE WalkNorth (player : MStruct.PlayerInfoPointer);
  BEGIN (* WalkNorth *)
    IF ShouldMakeConfusedMove (player) THEN
      MakeConfusedMove (player);
    ELSE
      MoveCharacterToLocation (player,player^.character^.line - 1,player^.character^.column);
    END; (* IF *)
  END WalkNorth;
  
  PROCEDURE WalkNorthEast (player : MStruct.PlayerInfoPointer);
  BEGIN (* WalkNorthEast *)
    IF ShouldMakeConfusedMove (player) THEN
      MakeConfusedMove (player);
    ELSE
      MoveCharacterToLocation (player,player^.character^.line - 1,player^.character^.column + 1);
    END; (* IF *)
  END WalkNorthEast;
  
  PROCEDURE WalkNorthWest (player : MStruct.PlayerInfoPointer);
  BEGIN (* WalkNorthWest *)
    IF ShouldMakeConfusedMove (player) THEN
      MakeConfusedMove (player);
    ELSE
      MoveCharacterToLocation (player,player^.character^.line - 1,player^.character^.column - 1);
    END; (* IF *)
  END WalkNorthWest;
  
  PROCEDURE WalkSouth (player : MStruct.PlayerInfoPointer);
  BEGIN (* WalkSouth *)
    IF ShouldMakeConfusedMove (player) THEN
      MakeConfusedMove (player);
    ELSE
      MoveCharacterToLocation (player,player^.character^.line + 1,player^.character^.column);
    END; (* IF *)
  END WalkSouth;
  
  PROCEDURE WalkSouthEast (player : MStruct.PlayerInfoPointer);
  BEGIN (* WalkSouthEast *)
    IF ShouldMakeConfusedMove (player) THEN
      MakeConfusedMove (player);
    ELSE
      MoveCharacterToLocation (player,player^.character^.line + 1,player^.character^.column + 1);
    END; (* IF *)
  END WalkSouthEast;
  
  PROCEDURE WalkSouthWest (player : MStruct.PlayerInfoPointer);
  BEGIN (* WalkSouthWest *)
    IF ShouldMakeConfusedMove (player) THEN
      MakeConfusedMove (player);
    ELSE
      MoveCharacterToLocation (player,player^.character^.line + 1,player^.character^.column - 1);
    END; (* IF *)
  END WalkSouthWest;
  
  PROCEDURE WalkWest (player : MStruct.PlayerInfoPointer);
  BEGIN (* WalkWest *)
    IF ShouldMakeConfusedMove (player) THEN
      MakeConfusedMove (player);
    ELSE
      MoveCharacterToLocation (player,player^.character^.line,player^.character^.column - 1);
    END; (* IF *)
  END WalkWest;
END MPMovement.
