IMPLEMENTATION MODULE MPotions;
  (*/WIN:A*)
  
  IMPORT MFoods,MInventory,MISelect,MMWindow,MRandom,MSpells,MSpells2,MSUpdate;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT MSActs2,OSActions;
  IMPORT WDebugging,WMacro;
  
  
  TYPE
       PotionActionRange = [0..46];
  
  VAR
      ExecutePotionAction : ARRAY PotionActionRange OF PROCEDURE (MStruct.PlayerInfoPointer,VAR BOOLEAN);
  
  
  PROCEDURE ExecuteQuaffPotionCommand (player : MStruct.PlayerInfoPointer);
    CONST
          PotionClasses = OStruct.ObjectClassSet {OStruct.Potion1,OStruct.Potion2};
    
    VAR
        position : CARDINAL;
    
    PROCEDURE QuaffPotion (player : MStruct.PlayerInfoPointer; potion : OStruct.InventoryItemRecord; position : CARDINAL);
      VAR
          identified : BOOLEAN;
          deleted    : BOOLEAN;
      
      PROCEDURE ExecutePotionActions (player : MStruct.PlayerInfoPointer; potion : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
        TYPE
             PotionActionFlags = SET OF PotionActionRange;
        
        VAR
            flags : PotionActionFlags;
            index : PotionActionRange;
        
        PROCEDURE DeterminePotionActionFlags (potion : OStruct.InventoryItemRecord; VAR result : PotionActionFlags);
          VAR
              bit : CARDINAL;
          
        BEGIN (* DeterminePotionActionFlags *)
          result := PotionActionFlags {};
          
          FOR bit := 0 TO 31 DO
            IF VAL (OStruct.ObjectAttributeMnemonic,bit) IN potion.object.attributes THEN
              IF potion.object.class = OStruct.Potion1 THEN
                INCL (result,bit);
              ELSE
                INCL (result,bit + 32);
              END; (* IF *)
            END; (* IF *)
          END; (* FOR *)
        END DeterminePotionActionFlags;
        
      BEGIN (* ExecutePotionActions *)
        DeterminePotionActionFlags (potion,flags);
        
        IF flags <> PotionActionFlags {} THEN
          identified := FALSE;
          
          FOR index := MIN (PotionActionRange) TO MAX (PotionActionRange) DO
            IF index IN flags THEN
              ExecutePotionAction [index] (player,identified);
            END; (* IF *)
          END; (* FOR *)
        ELSE
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel less thirsty.");
          identified := TRUE;
        END; (* IF *)
      END ExecutePotionActions;
      
    BEGIN (* QuaffPotion *)
      ExecutePotionActions (player,potion,identified);
      
      IF NOT (OSActions.InventoryItemIsKnown1 (player^.treasures,potion)) THEN
        IF identified THEN
          MSActs2.IncreasePlayerExperience (player,FLOAT (VAL (INTEGER,potion.object.depth) + player^.character^.variables.level DIV 2) / FLOAT (player^.character^.variables.level));
          MSpells2.IdentifyPlayerInventoryItem (player,position);
        ELSE
          OSActions.SampleInventoryItem (player^.treasures,potion);
        END; (* IF *)
      END; (* IF *)
      
      MFoods.AddNutritionValue (player,potion.object.miscellaneous);
      
      OSActions.DescribeRemainingObjectQuantity (player,player^.character^.inventory.backpack [position]);
      MInventory.DecrementInventoryItemQuantity (player,position,deleted);
    END QuaffPotion;
    
  BEGIN (* ExecuteQuaffPotionCommand *)
    IF MInventory.AnyObjectsWithClasses (player^.character^.inventory.backpack,PotionClasses) THEN
      MISelect.SelectInventoryItem (player,"Quaff which potion?",PotionClasses,position,MStruct.CharacterTurnExecuted);
      
      IF MStruct.CharacterTurnExecuted THEN
        QuaffPotion (player,player^.character^.inventory.backpack [position],position);
      END; (* IF *)
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are not carrying any potions.");
      MStruct.CharacterTurnExecuted := FALSE;
    END; (* IF *)
  END ExecuteQuaffPotionCommand;
  
  
  
  PROCEDURE ExecuteBlindnessPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteBlindnessPotion *)
    IF player^.character^.variables.counters [MCStruct.BlindCOUNT] = 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are covered by a veil of darkness.");
      identified := TRUE;
    END; (* IF *)
    
    INC (player^.character^.variables.counters [MCStruct.BlindCOUNT],MRandom.CardinalRandomRangeValue (1,100) + 100);
  END ExecuteBlindnessPotion;
  
  PROCEDURE ExecuteConfusionPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteConfusionPotion *)
    IF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] = 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Hey!  This is good stuff!  * Hick! *");
      identified := TRUE;
    END; (* IF *)
    
    INC (player^.character^.variables.counters [MCStruct.ConfusedCOUNT],MRandom.CardinalRandomRangeValue (1,20) + 12);
  END ExecuteConfusionPotion;
  
  PROCEDURE ExecuteCureBlindnessPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteCureBlindnessPotion *)
    MSpells2.CureBlindness (player,identified);
  END ExecuteCureBlindnessPotion;
  
  PROCEDURE ExecuteCureConfusionPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteCureConfusionPotion *)
    MSpells2.CureConfusion (player,identified);
  END ExecuteCureConfusionPotion;
  
  PROCEDURE ExecuteCureCriticalWoundsPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteCureCriticalWoundsPotion *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (6,42),identified);
  END ExecuteCureCriticalWoundsPotion;
  
  PROCEDURE ExecuteCureLightWoundsPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteCureLightWoundsPotion *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (2,14),identified);
  END ExecuteCureLightWoundsPotion;
  
  PROCEDURE ExecuteCurePoisonPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteCurePoisonPotion *)
    MSpells2.CurePoison (player,identified);
  END ExecuteCurePoisonPotion;
  
  PROCEDURE ExecuteCureSeriousWoundsPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteCureSeriousWoundsPotion *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (4,28),identified);
  END ExecuteCureSeriousWoundsPotion;
  
  PROCEDURE ExecuteDetectInvisiblePotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteDetectInvisiblePotion *)
    identified := (identified OR (player^.character^.variables.counters [MCStruct.DetectInvisCOUNT] = 0));
    INC (player^.character^.variables.counters [MCStruct.DetectInvisCOUNT],MRandom.CardinalRandomRangeValue (1,12) + 12);
  END ExecuteDetectInvisiblePotion;
  
  PROCEDURE ExecuteGainCharismaPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteGainCharismaPotion *)
    MSActs2.IncrementStatistic (player,MCStruct.chr,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Gee, ain't you cute!");
      identified := TRUE;
    END; (* IF *)
  END ExecuteGainCharismaPotion;
  
  PROCEDURE ExecuteGainDexterityPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteGainDexterityPotion *)
    MSActs2.IncrementStatistic (player,MCStruct.dex,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel more limber!");
      identified := TRUE;
    END; (* IF *)
  END ExecuteGainDexterityPotion;
  
  PROCEDURE ExecuteGainIntelligencePotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteGainIntelligencePotion *)
    MSActs2.IncrementStatistic (player,MCStruct.int,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Aren't you brilliant!");
      identified := TRUE;
    END; (* IF *)
  END ExecuteGainIntelligencePotion;
  
  PROCEDURE ExecuteGainStrengthPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteGainStrengthPotion *)
    MSActs2.IncrementStatistic (player,MCStruct.str,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Wow!  What bulging muscles!");
      identified := TRUE;
    END; (* IF *)
  END ExecuteGainStrengthPotion;
  
  PROCEDURE ExecuteGainWisdomPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteGainWisdomPotion *)
    MSActs2.IncrementStatistic (player,MCStruct.wis,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You suddenly have a profound thought!");
      identified := TRUE;
    END; (* IF *)
  END ExecuteGainWisdomPotion;
  
  PROCEDURE ExecuteHealingPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteHealingPotion *)
    MSpells2.MagicallyHealPlayer (player,1000,identified);
  END ExecuteHealingPotion;
  
  PROCEDURE ExecuteHeroismPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteHeroismPotion *)
    identified := (identified OR (player^.character^.variables.counters [MCStruct.HeroCOUNT] = 0));
    INC (player^.character^.variables.counters [MCStruct.HeroCOUNT],MRandom.CardinalRandomRangeValue (1,25) + 25);
  END ExecuteHeroismPotion;
  
  PROCEDURE ExecuteIncreaseConstitutionPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteIncreaseConstitutionPotion *)
    MSActs2.IncrementStatistic (player,MCStruct.con,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel tingly for a moment.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteIncreaseConstitutionPotion;
  
  PROCEDURE ExecuteIncreaseExperiencePotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteIncreaseExperiencePotion *)
    IF player^.character^.variables.experCUR < MCStruct.MaxPlayerExperience THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel more experienced.");
      MSActs2.IncreasePlayerExperience (player,WMacro.MinReal (player^.character^.variables.experCUR / 2.0 + 10.0,100000.0));
      
      identified := TRUE;
    END; (* IF *)
  END ExecuteIncreaseExperiencePotion;
  
  PROCEDURE ExecuteInfraVisionPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteInfraVisionPotion *)
    IF player^.character^.variables.counters [MCStruct.TimedInfraCOUNT] = 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Your eyes begin to tingle.");
      identified := TRUE;
    END; (* IF *)
    
    INC (player^.character^.variables.counters [MCStruct.TimedInfraCOUNT],MRandom.CardinalRandomRangeValue (1,100) + 100);
  END ExecuteInfraVisionPotion;
  
  PROCEDURE ExecuteInvulnerabilityPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteInvulnerabilityPotion *)
    identified := (identified OR (player^.character^.variables.counters [MCStruct.InvulnCOUNT] = 0));
    INC (player^.character^.variables.counters [MCStruct.InvulnCOUNT],MRandom.CardinalRandomRangeValue (1,10) + 10);
  END ExecuteInvulnerabilityPotion;
  
  PROCEDURE ExecuteLoseCharismaPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteLoseCharismaPotion *)
    MSpells2.DecreasePlayerCharisma (player);
    identified := TRUE;
  END ExecuteLoseCharismaPotion;
  
  PROCEDURE ExecuteLoseExperiencePotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        amount : REAL;
    
  BEGIN (* ExecuteLoseExperiencePotion *)
    IF player^.character^.variables.experCUR > 0.0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel your memories fade.");
      
      identified := TRUE;
      amount     := player^.character^.variables.experCUR / 5.0;
      amount     := amount + (amount * MRandom.RandomRealValue ());
      
      MSpells2.ReduceCharacterExperience (player,amount);
    END; (* IF *)
  END ExecuteLoseExperiencePotion;
  
  PROCEDURE ExecuteLoseIntelligencePotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteLoseIntelligencePotion *)
    MSpells2.DecreasePlayerIntelligence (player);
    identified := TRUE;
  END ExecuteLoseIntelligencePotion;
  
  PROCEDURE ExecuteLoseStrengthPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteLoseStrengthPotion *)
    MSpells2.DecreasePlayerStrength (player);
    identified := TRUE;
  END ExecuteLoseStrengthPotion;
  
  PROCEDURE ExecuteLoseWisdomPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteLoseWisdomPotion *)
    MSpells2.DecreasePlayerWisdom (player);
    identified := TRUE;
  END ExecuteLoseWisdomPotion;
  
  PROCEDURE ExecutePoisonPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecutePoisonPotion *)
    IF player^.character^.variables.counters [MCStruct.PoisonedCOUNT] = 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel very sick.");
      identified := TRUE;
    END; (* IF *)
    
    INC (player^.character^.variables.counters [MCStruct.PoisonedCOUNT],MRandom.CardinalRandomRangeValue (1,15) + 10);
  END ExecutePoisonPotion;
  
  PROCEDURE ExecuteRemoveFearPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteRemoveFearPotion *)
    MSpells2.CureFear (player,identified);
  END ExecuteRemoveFearPotion;
  
  PROCEDURE ExecuteResistColdPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteResistColdPotion *)
    identified := (identified OR (player^.character^.variables.counters [MCStruct.ResistColdCOUNT] = 0));
    INC (player^.character^.variables.counters [MCStruct.ResistColdCOUNT],MRandom.CardinalRandomRangeValue (1,10) + 10);
  END ExecuteResistColdPotion;
  
  PROCEDURE ExecuteResistHeatPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteResistHeatPotion *)
    identified := (identified OR (player^.character^.variables.counters [MCStruct.ResistHeatCOUNT] = 0));
    INC (player^.character^.variables.counters [MCStruct.ResistHeatCOUNT],MRandom.CardinalRandomRangeValue (1,10) + 10);
  END ExecuteResistHeatPotion;
  
  PROCEDURE ExecuteRestoreCharismaPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoreCharismaPotion *)
    MSActs2.RestoreStatisticToMaximum (player,MCStruct.chr,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel your looks returning.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteRestoreCharismaPotion;
  
  PROCEDURE ExecuteRestoreConstitionPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoreConstitionPotion *)
    MSActs2.RestoreStatisticToMaximum (player,MCStruct.con,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel your health returning.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteRestoreConstitionPotion;
  
  PROCEDURE ExecuteRestoreDexterityPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoreDexterityPotion *)
    MSActs2.RestoreStatisticToMaximum (player,MCStruct.dex,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel less clumsy.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteRestoreDexterityPotion;
  
  PROCEDURE ExecuteRestoreExperiencePotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteRestoreExperiencePotion *)
    WHILE player^.character^.variables.experCUR < player^.character^.variables.experMAX DO
      MSActs2.IncreasePlayerExperience (player,player^.character^.variables.experMAX - player^.character^.variables.experCUR);
      identified := TRUE;
    END; (* WHILE *)
  END ExecuteRestoreExperiencePotion;
  
  PROCEDURE ExecuteRestoreIntelligencePotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoreIntelligencePotion *)
    MSActs2.RestoreStatisticToMaximum (player,MCStruct.int,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You have a warm feeling.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteRestoreIntelligencePotion;
  
  PROCEDURE ExecuteRestoreManaPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteRestoreManaPotion *)
    IF player^.character^.variables.manaCUR < player^.character^.variables.manaMAX THEN
      player^.character^.variables.manaCUR := player^.character^.variables.manaMAX;
      identified                           := TRUE;
      
      MSUpdate.UpdateCurrentManaWindow (player);
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel your head clear.");
    END; (* IF *)
  END ExecuteRestoreManaPotion;
  
  PROCEDURE ExecuteRestoreStrengthPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoreStrengthPotion *)
    MSActs2.RestoreStatisticToMaximum (player,MCStruct.str,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel warm all over.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteRestoreStrengthPotion;
  
  PROCEDURE ExecuteRestoreWisdomPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRestoreWisdomPotion *)
    MSActs2.RestoreStatisticToMaximum (player,MCStruct.wis,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel your wisdom returning.");
      identified := TRUE;
    END; (* IF *)
  END ExecuteRestoreWisdomPotion;
  
  PROCEDURE ExecuteSaltWaterPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteSaltWaterPotion *)
    MSpells2.CurePoison (player,done);
    
    player^.character^.variables.counters [MCStruct.ParalysisCOUNT] := 4;
    player^.character^.variables.food                               := WMacro.MinInteger (player^.character^.variables.food,150);
    identified                                                      := TRUE;
    
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The potion makes you vomit.");
  END ExecuteSaltWaterPotion;
  
  PROCEDURE ExecuteSleepPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSleepPotion *)
    IF NOT (MCStruct.FreeActionFLAG IN player^.character^.variables.status) THEN
      player^.character^.variables.counters [MCStruct.ParalysisCOUNT] := MRandom.CardinalRandomRangeValue (1,4) + 4;
      identified                                                      := TRUE;
      
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You fall asleep.");
    END; (* IF *)
  END ExecuteSleepPotion;
  
  PROCEDURE ExecuteSlownessPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSlownessPotion *)
    identified := (identified OR (player^.character^.variables.counters [MCStruct.SlowCOUNT] = 0));
    INC (player^.character^.variables.counters [MCStruct.SlowCOUNT],MRandom.CardinalRandomRangeValue (1,25) + 15);
  END ExecuteSlownessPotion;
  
  PROCEDURE ExecuteSlowPoisonPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSlowPoisonPotion *)
    MSpells2.SlowPoison (player,identified);
  END ExecuteSlowPoisonPotion;
  
  PROCEDURE ExecuteSpeedPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSpeedPotion *)
    identified := (identified OR (player^.character^.variables.counters [MCStruct.FastCOUNT] = 0));
    INC (player^.character^.variables.counters [MCStruct.FastCOUNT],MRandom.CardinalRandomRangeValue (1,25) + 15);
  END ExecuteSpeedPotion;
  
  PROCEDURE ExecuteSuperHeroismPotion (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSuperHeroismPotion *)
    identified := (identified OR (player^.character^.variables.counters [MCStruct.SuperHeroCOUNT] = 0));
    INC (player^.character^.variables.counters [MCStruct.SuperHeroCOUNT],MRandom.CardinalRandomRangeValue (1,25) + 25);
  END ExecuteSuperHeroismPotion;
  
  PROCEDURE InitializeExecutePotionActionTable;
    VAR
        index : PotionActionRange;
    
  BEGIN (* InitializeExecutePotionActionTable *)
    FOR index := MIN (PotionActionRange) TO MAX (PotionActionRange) DO
      ExecutePotionAction [index] := InvalidPotionProcedure;
    END; (* IF *)
    
    ExecutePotionAction [ 0] := ExecuteGainStrengthPotion;
    ExecutePotionAction [ 1] := ExecuteLoseStrengthPotion;
    ExecutePotionAction [ 2] := ExecuteRestoreStrengthPotion;
    ExecutePotionAction [ 3] := ExecuteGainIntelligencePotion;
    ExecutePotionAction [ 4] := ExecuteLoseIntelligencePotion;
    ExecutePotionAction [ 5] := ExecuteRestoreIntelligencePotion;
    ExecutePotionAction [ 6] := ExecuteGainWisdomPotion;
    ExecutePotionAction [ 7] := ExecuteLoseWisdomPotion;
    ExecutePotionAction [ 8] := ExecuteRestoreWisdomPotion;
    ExecutePotionAction [ 9] := ExecuteGainCharismaPotion;
    ExecutePotionAction [10] := ExecuteLoseCharismaPotion;
    ExecutePotionAction [11] := ExecuteRestoreCharismaPotion;
    ExecutePotionAction [12] := ExecuteCureLightWoundsPotion;
    ExecutePotionAction [13] := ExecuteCureSeriousWoundsPotion;
    ExecutePotionAction [14] := ExecuteCureCriticalWoundsPotion;
    ExecutePotionAction [15] := ExecuteHealingPotion;
    ExecutePotionAction [16] := ExecuteIncreaseConstitutionPotion;
    ExecutePotionAction [17] := ExecuteIncreaseExperiencePotion;
    ExecutePotionAction [18] := ExecuteSleepPotion;
    ExecutePotionAction [19] := ExecuteBlindnessPotion;
    ExecutePotionAction [20] := ExecuteConfusionPotion;
    ExecutePotionAction [21] := ExecutePoisonPotion;
    ExecutePotionAction [22] := ExecuteSpeedPotion;
    ExecutePotionAction [23] := ExecuteSlownessPotion;
    ExecutePotionAction [25] := ExecuteGainDexterityPotion;
    ExecutePotionAction [26] := ExecuteRestoreDexterityPotion;
    ExecutePotionAction [27] := ExecuteRestoreConstitionPotion;
    ExecutePotionAction [28] := ExecuteCureBlindnessPotion;
    ExecutePotionAction [29] := ExecuteCureConfusionPotion;
    ExecutePotionAction [30] := ExecuteCurePoisonPotion;
    ExecutePotionAction [33] := ExecuteLoseExperiencePotion;
    ExecutePotionAction [34] := ExecuteSaltWaterPotion;
    ExecutePotionAction [35] := ExecuteInvulnerabilityPotion;
    ExecutePotionAction [36] := ExecuteHeroismPotion;
    ExecutePotionAction [37] := ExecuteSuperHeroismPotion;
    ExecutePotionAction [38] := ExecuteRemoveFearPotion;
    ExecutePotionAction [39] := ExecuteRestoreExperiencePotion;
    ExecutePotionAction [40] := ExecuteResistHeatPotion;
    ExecutePotionAction [41] := ExecuteResistColdPotion;
    ExecutePotionAction [42] := ExecuteDetectInvisiblePotion;
    ExecutePotionAction [43] := ExecuteSlowPoisonPotion;
    ExecutePotionAction [44] := ExecuteCurePoisonPotion;
    ExecutePotionAction [45] := ExecuteRestoreManaPotion;
    ExecutePotionAction [46] := ExecuteInfraVisionPotion;
  END InitializeExecutePotionActionTable;
  
  PROCEDURE InvalidPotionProcedure (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* InvalidPotionProcedure *)
    WDebugging.FatalAppExit ("Attempt to use un-initialized potion procedure.");
  END InvalidPotionProcedure;

BEGIN (* MPotions *)
  InitializeExecutePotionActionTable;
END MPotions.
