IMPLEMENTATION MODULE MPrayers;
  (*/WIN:A*)
  
  IMPORT MCSpells,MDialogs,MInventory,MMWindow,MPBDialog,MPray2,MRandom,MScrl2,MScrl3,MSpells,MSpells2,MSpells3;
  IMPORT CStruct,MCStruct,MStruct,OStruct;
  IMPORT DSActions,MCSActions;
  IMPORT WDebugging;
  
  
  VAR
      ExecuteHolyPrayer : ARRAY MCStruct.PlayerSpellRange OF PROCEDURE (MStruct.PlayerInfoPointer);
  
  
  PROCEDURE ExecuteReadHolyPrayerCommand (player : MStruct.PlayerInfoPointer);
    PROCEDURE SelectAndExecuteHolyPrayer (player : MStruct.PlayerInfoPointer);
      VAR
          result : INTEGER;
      
    BEGIN (* SelectAndExecuteHolyPrayer *)
      MDialogs.ExecuteMoriaDialogBox (player^.windows.frame,MPBDialog.CharacterSpellDialogTemplate,player,MPBDialog.InitializeSelectPrayerDialog,MPBDialog.ExecuteSelectSpellDialogCommand,MPBDialog.CloseSelectSpellDialog,result);
      
      IF result >= 0 THEN
        IF MRandom.CardinalRandomRangeValue (1,100) >= MCSActions.CharacterSpellFailureChance (player^.character,player^.character^.spells.table [result]) THEN
          ExecuteHolyPrayer [result] (player);
        ELSE
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You lost your concentration!");
          MCSpells.DecreasePlayerMana (player,result,FALSE);
          
          MStruct.CharacterTurnExecuted := TRUE;
        END; (* IF *)
      END; (* IF *)
    END SelectAndExecuteHolyPrayer;
    
  BEGIN (* ExecuteReadHolyPrayerCommand *)
    MStruct.CharacterTurnExecuted := FALSE;
    
    IF player^.character^.variables.counters [MCStruct.BlindCOUNT] > 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You can't see to read your prayer!");
    ELSIF NOT (DSActions.PlayerHasLight (player)) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You have no light to read by.");
    ELSIF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are too confused.");
    ELSIF NOT (player^.character^.constants.class IN MCStruct.PriestClasses) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Pray hard enough and your prayers may be answered.");
    ELSIF NOT (MInventory.AnyObjectsWithClasses (player^.character^.inventory.backpack,OStruct.ObjectClassSet {OStruct.PrayerBook})) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are not carrying any Holy Books!");
    ELSE
      SelectAndExecuteHolyPrayer (player);
    END; (* IF *)
  END ExecuteReadHolyPrayerCommand;
  
  
  PROCEDURE ExecuteBlessPrayer (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteBlessPrayer *)
    INC (player^.character^.variables.counters [MCStruct.BlessedCOUNT],MRandom.CardinalRandomRangeValue (1,12) + 12);
    MCSpells.DecreasePlayerMana (player,2,TRUE);
  END ExecuteBlessPrayer;
  
  PROCEDURE ExecuteCallLightPrayer (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteCallLightPrayer *)
    MScrl3.ExecuteLightAreaScrollAction (player);
    MCSpells.DecreasePlayerMana (player,4,TRUE);
  END ExecuteCallLightPrayer;

  PROCEDURE ExecuteChantPrayer (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteChantPrayer *)
    INC (player^.character^.variables.counters [MCStruct.BlessedCOUNT],MRandom.CardinalRandomRangeValue (1,24) + 24);
    MCSpells.DecreasePlayerMana (player,11,TRUE);
  END ExecuteChantPrayer;

  PROCEDURE ExecuteCreateFoodPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteCreateFoodPrayer *)
    MScrl2.ExecuteCreateFoodScrollAction (player,done);
    
    IF done THEN
      MCSpells.DecreasePlayerMana (player,13,TRUE);
    END; (* IF *)
  END ExecuteCreateFoodPrayer;

  PROCEDURE ExecuteCureCriticalWoundsPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        noticed : BOOLEAN;
    
  BEGIN (* ExecuteCureCriticalWoundsPrayer *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (16,64),noticed);
    MCSpells.DecreasePlayerMana (player,23,TRUE);
  END ExecuteCureCriticalWoundsPrayer;

  PROCEDURE ExecuteCureLightWoundsPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        noticed : BOOLEAN;
    
  BEGIN (* ExecuteCureLightWoundsPrayer *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (3,9),noticed);
    MCSpells.DecreasePlayerMana (player,1,TRUE);
  END ExecuteCureLightWoundsPrayer;

  PROCEDURE ExecuteCureMediumWoundsPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        noticed : BOOLEAN;
    
  BEGIN (* ExecuteCureMediumWoundsPrayer *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (4,16),noticed);
    MCSpells.DecreasePlayerMana (player,10,TRUE);
  END ExecuteCureMediumWoundsPrayer;

  PROCEDURE ExecuteCureSeriousWoundsPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        noticed : BOOLEAN;
    
  BEGIN (* ExecuteCureSeriousWoundsPrayer *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (8,32),noticed);
    MCSpells.DecreasePlayerMana (player,18,TRUE);
  END ExecuteCureSeriousWoundsPrayer;

  PROCEDURE ExecuteDetectDoorsPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        detected : BOOLEAN;
    
  BEGIN (* ExecuteDetectDoorsPrayer *)
    MSpells.DetectHiddenDoors (player,detected,TRUE);
    MCSpells.DecreasePlayerMana (player,6,TRUE);
  END ExecuteDetectDoorsPrayer;

  PROCEDURE ExecuteDetectEvilPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        detected : BOOLEAN;
    
  BEGIN (* ExecuteDetectEvilPrayer *)
    MSpells.DetectEvilCreatures (player,detected);
    MCSpells.DecreasePlayerMana (player,0,TRUE);
  END ExecuteDetectEvilPrayer;

  PROCEDURE ExecuteDetectTrapsPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        detected : BOOLEAN;
    
  BEGIN (* ExecuteDetectTrapsPrayer *)
    MSpells.DetectHiddenTraps (player,detected,TRUE);
    MCSpells.DecreasePlayerMana (player,5,TRUE);
  END ExecuteDetectTrapsPrayer;

  PROCEDURE ExecuteDispelEvilPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteDispelEvilPrayer *)
    MSpells.DispelCreatures (player,CStruct.HurtBySlayEvil,3 * player^.character^.variables.level,done);
    MCSpells.DecreasePlayerMana (player,28,TRUE);
  END ExecuteDispelEvilPrayer;

  PROCEDURE ExecuteDispelUndeadPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteDispelUndeadPrayer *)
    MSpells.DispelCreatures (player,CStruct.HurtBySlayUndead,3 * player^.character^.variables.level,done);
    MCSpells.DecreasePlayerMana (player,26,TRUE);
  END ExecuteDispelUndeadPrayer;

  PROCEDURE ExecuteEarthquakePrayer (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteEarthquakePrayer *)
    MSpells3.ExecuteEarthquakeSpell (player);
    MCSpells.DecreasePlayerMana (player,21,TRUE);
  END ExecuteEarthquakePrayer;

  PROCEDURE ExecuteGlyphOfWardingPrayer (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteGlyphOfWardingPrayer *)
    MSpells3.CreateGlyphOfWarding (player);
    MCSpells.DecreasePlayerMana (player,29,TRUE);
  END ExecuteGlyphOfWardingPrayer;

  PROCEDURE ExecuteHealPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        noticed : BOOLEAN;
    
  BEGIN (* ExecuteHealPrayer *)
    MSpells2.MagicallyHealPlayer (player,200,noticed);
    MCSpells.DecreasePlayerMana (player,27,TRUE);
  END ExecuteHealPrayer;

  PROCEDURE ExecuteHolyWordPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteHolyWordPrayer *)
    MSpells.DispelCreatures (player,CStruct.HurtBySlayEvil,4 * player^.character^.variables.level,done);
    
    MSpells2.MagicallyHealPlayer (player,1000,done);
    MSpells2.CurePoison (player,done);
    MSpells2.CureFear (player,done);
    
    MCSpells.DecreasePlayerMana (player,30,TRUE);
  END ExecuteHolyWordPrayer;

  PROCEDURE ExecuteNeutralizePoisonPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteNeutralizePoisonPrayer *)
    MSpells2.CurePoison (player,done);
    MCSpells.DecreasePlayerMana (player,16,TRUE);
  END ExecuteNeutralizePoisonPrayer;
  
  PROCEDURE ExecutePortalPrayer (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecutePortalPrayer *)
    MScrl2.ExecuteTeleportScrollAction (player,player^.character^.variables.level * 3);
    MCSpells.DecreasePlayerMana (player,9,TRUE);
  END ExecutePortalPrayer;

  PROCEDURE ExecutePrayerPrayer (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecutePrayerPrayer *)
    INC (player^.character^.variables.counters [MCStruct.BlessedCOUNT],MRandom.CardinalRandomRangeValue (1,48) + 48);
    MCSpells.DecreasePlayerMana (player,25,TRUE);
  END ExecutePrayerPrayer;

  PROCEDURE ExecuteProtectionFromEvilPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteProtectionFromEvilPrayer *)
    MSpells.ExecuteProtectionFromEvilSpell (player,done);
    MCSpells.DecreasePlayerMana (player,20,TRUE);
  END ExecuteProtectionFromEvilPrayer;

  PROCEDURE ExecuteRemoveCursePrayer (player : MStruct.PlayerInfoPointer);
    PROCEDURE RemoveCurseFromItems (VAR inventory : ARRAY OF OStruct.InventoryItemRecord);
      VAR
          index : CARDINAL;
      
    BEGIN (* RemoveCurseFromItems *)
      FOR index := 0 TO HIGH (inventory) DO
        IF inventory [index].object.class IN OStruct.ObjectClassSet {OStruct.SlingAmmo..OStruct.Ring} THEN
          EXCL (inventory [index].object.attributes,OStruct.Cursed);
        END; (* IF *)
      END; (* FOR *)
    END RemoveCurseFromItems;
    
  BEGIN (* ExecuteRemoveCursePrayer *)
    RemoveCurseFromItems (player^.character^.inventory.equipment);
    RemoveCurseFromItems (player^.character^.inventory.backpack);
    
    MCSpells.DecreasePlayerMana (player,14,TRUE);
  END ExecuteRemoveCursePrayer;

  PROCEDURE ExecuteRemoveFearPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteRemoveFearPrayer *)
    MSpells2.CureFear (player,done);
    MCSpells.DecreasePlayerMana (player,3,TRUE);
  END ExecuteRemoveFearPrayer;

  PROCEDURE ExecuteResistHeatAndColdPrayer (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteResistHeatAndColdPrayer *)
    INC (player^.character^.variables.counters [MCStruct.ResistColdCOUNT],MRandom.CardinalRandomRangeValue (1,10) + 10);
    INC (player^.character^.variables.counters [MCStruct.ResistHeatCOUNT],MRandom.CardinalRandomRangeValue (1,10) + 10);
    
    MCSpells.DecreasePlayerMana (player,15,TRUE);
  END ExecuteResistHeatAndColdPrayer;

  PROCEDURE ExecuteSanctuaryPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteSanctuaryPrayer *)
    MSpells.SleepAdjacentCreatures (player,done);
    MCSpells.DecreasePlayerMana (player,12,TRUE);
  END ExecuteSanctuaryPrayer;

  PROCEDURE ExecuteSenseInvisiblePrayer (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteSenseInvisiblePrayer *)
    INC (player^.character^.variables.counters [MCStruct.DetectInvisCOUNT],MRandom.CardinalRandomRangeValue (1,24) + 24);
    MCSpells.DecreasePlayerMana (player,19,TRUE);
  END ExecuteSenseInvisiblePrayer;

  PROCEDURE ExecuteSenseSurroundingsPrayer (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteSenseSurroundingsPrayer *)
    MScrl3.ExecuteMapAreaScrollAction (player);
    MCSpells.DecreasePlayerMana (player,22,TRUE);
  END ExecuteSenseSurroundingsPrayer;

  PROCEDURE ExecuteSlowPoisonPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteSlowPoisonPrayer *)
    MSpells2.SlowPoison (player,done);
    MCSpells.DecreasePlayerMana (player,7,TRUE);
  END ExecuteSlowPoisonPrayer;

  PROCEDURE ExecuteTurnUndeadPrayer (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteTurnUndeadPrayer *)
    MSpells.TurnUndeadCreatures (player,done);
    MCSpells.DecreasePlayerMana (player,24,TRUE);
  END ExecuteTurnUndeadPrayer;

  PROCEDURE InitializeExecuteHolyPrayerTable;
    VAR
        index : MCStruct.PlayerSpellRange;
    
  BEGIN (* InitializeExecuteHolyPrayerTable *)
    FOR index := MIN (MCStruct.PlayerSpellRange) TO MAX (MCStruct.PlayerSpellRange) DO
      ExecuteHolyPrayer [index] := InvalidPrayerProcedure;
    END; (* IF *)
    
    ExecuteHolyPrayer [ 0] := ExecuteDetectEvilPrayer;
    ExecuteHolyPrayer [ 1] := ExecuteCureLightWoundsPrayer;
    ExecuteHolyPrayer [ 2] := ExecuteBlessPrayer;
    ExecuteHolyPrayer [ 3] := ExecuteRemoveFearPrayer;
    ExecuteHolyPrayer [ 4] := ExecuteCallLightPrayer;
    ExecuteHolyPrayer [ 5] := ExecuteDetectTrapsPrayer;
    ExecuteHolyPrayer [ 6] := ExecuteDetectDoorsPrayer;
    ExecuteHolyPrayer [ 7] := ExecuteSlowPoisonPrayer;
    ExecuteHolyPrayer [ 8] := MPray2.ExecuteBlindCreaturePrayer;
    ExecuteHolyPrayer [ 9] := ExecutePortalPrayer;
    ExecuteHolyPrayer [10] := ExecuteCureMediumWoundsPrayer;
    ExecuteHolyPrayer [11] := ExecuteChantPrayer;
    ExecuteHolyPrayer [12] := ExecuteSanctuaryPrayer;
    ExecuteHolyPrayer [13] := ExecuteCreateFoodPrayer;
    ExecuteHolyPrayer [14] := ExecuteRemoveCursePrayer;
    ExecuteHolyPrayer [15] := ExecuteResistHeatAndColdPrayer;
    ExecuteHolyPrayer [16] := ExecuteNeutralizePoisonPrayer;
    ExecuteHolyPrayer [17] := MPray2.ExecuteOrbOfDrainingPrayer;
    ExecuteHolyPrayer [18] := ExecuteCureSeriousWoundsPrayer;
    ExecuteHolyPrayer [19] := ExecuteSenseInvisiblePrayer;
    ExecuteHolyPrayer [20] := ExecuteProtectionFromEvilPrayer;
    ExecuteHolyPrayer [21] := ExecuteEarthquakePrayer;
    ExecuteHolyPrayer [22] := ExecuteSenseSurroundingsPrayer;
    ExecuteHolyPrayer [23] := ExecuteCureCriticalWoundsPrayer;
    ExecuteHolyPrayer [24] := ExecuteTurnUndeadPrayer;
    ExecuteHolyPrayer [25] := ExecutePrayerPrayer;
    ExecuteHolyPrayer [26] := ExecuteDispelUndeadPrayer;
    ExecuteHolyPrayer [27] := ExecuteHealPrayer;
    ExecuteHolyPrayer [28] := ExecuteDispelEvilPrayer;
    ExecuteHolyPrayer [29] := ExecuteGlyphOfWardingPrayer;
    ExecuteHolyPrayer [30] := ExecuteHolyWordPrayer;
  END InitializeExecuteHolyPrayerTable;
  
  PROCEDURE InvalidPrayerProcedure (player : MStruct.PlayerInfoPointer);
  BEGIN (* InvalidPrayerProcedure *)
    WDebugging.FatalAppExit ("Call to un-initialized Holy Prayer procedure.");
  END InvalidPrayerProcedure;

BEGIN (* MPrayers *)
  InitializeExecuteHolyPrayerTable;
END MPrayers.
