IMPLEMENTATION MODULE MPRest;
  (*/WIN:A*)
  
  IMPORT WDebugging,WDialog,Windows,WInput;
  IMPORT MDialogs,MMWindow,MPSearch;
  IMPORT MCStruct,MStruct;
  IMPORT MSActions;
  
  
  CONST
        NumberTurnsEditTextControl = 1302;
  
  CONST
        HealPushButtonControl   = 1303;
        TurnsPushButtonControl  = Windows.IDOK;
        CancelPushButtonControl = Windows.IDCANCEL;
  
  
  PROCEDURE CloseRestDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* CloseRestDialog *)
    IF player^.character^.variables.counters [MCStruct.RestCOUNT] > 0 THEN
      StopPlayerResting (player);
    ELSE
      MDialogs.DestroyCurrentModelessDialog (player);
    END; (* IF *)
  END CloseRestDialog;
  
  PROCEDURE ExecuteRestDialogCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; command : CARDINAL);
    PROCEDURE ExecuteCancelButtonAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteCancelButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        CloseRestDialog (window,player);
      END; (* IF *)
    END ExecuteCancelButtonAction;
    
    PROCEDURE ExecuteHealButtonAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
      VAR
          previous : BOOLEAN;
      
    BEGIN (* ExecuteHealButtonAction *)
      INCL (player^.character^.variables.status,MCStruct.RestUntilHealedFLAG);
      
      player^.character^.variables.counters [MCStruct.RestCOUNT] := MAX (CARDINAL);
      player^.character^.variables.digestion                     := player^.character^.variables.digestion - 1;
      MStruct.CharacterTurnExecuted                              := TRUE;
      
      IF MCStruct.SearchFLAG IN player^.character^.variables.status THEN
        MPSearch.PlayerSearchingOff (player);
      END; (* IF *)
      
      WDialog.ShowDialogControl (window,TurnsPushButtonControl,FALSE);
      WDialog.ShowDialogControl (window,HealPushButtonControl,FALSE);
      
      WDialog.EnableDialogControl (window,NumberTurnsEditTextControl,FALSE);
      WDialog.SetDlgItemText (window,NumberTurnsEditTextControl,"Until Healed");
      
      WInput.EnableWindow (player^.windows.frame,FALSE,previous);
    END ExecuteHealButtonAction;
    
    PROCEDURE ExecuteTurnsButtonAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
      VAR
          previous : BOOLEAN;
          temp     : CARDINAL;
          done     : BOOLEAN;
      
    BEGIN (* ExecuteTurnsButtonAction *)
      WDialog.GetDlgItemCardinal (window,NumberTurnsEditTextControl,temp,done);
      
      IF done THEN
        IF MCStruct.SearchFLAG IN player^.character^.variables.status THEN
          MPSearch.PlayerSearchingOff (player);
        END; (* IF *)
        
        player^.character^.variables.counters [MCStruct.RestCOUNT] := temp;
        player^.character^.variables.digestion                     := player^.character^.variables.digestion - 1;
        MStruct.CharacterTurnExecuted                              := TRUE;
        
        WDialog.ShowDialogControl (window,TurnsPushButtonControl,FALSE);
        WDialog.ShowDialogControl (window,HealPushButtonControl,FALSE);
        
        WDialog.EnableDialogControl (window,NumberTurnsEditTextControl,FALSE);
        WInput.EnableWindow (player^.windows.frame,FALSE,previous);
      ELSE
        MMWindow.DisplayPopupMessage (window,player,"Invalid or missing number of resting turns.");
      END; (* IF *)
    END ExecuteTurnsButtonAction;
    
  BEGIN (* ExecuteRestDialogCommand *)
    CASE control OF
      CancelPushButtonControl : ExecuteCancelButtonAction (window,player,command); |
      TurnsPushButtonControl  : ExecuteTurnsButtonAction (window,player,command);  |
      HealPushButtonControl   : ExecuteHealButtonAction (window,player,command);   |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteRestDialogCommand;
  
  PROCEDURE ExecuteRestMultipleTurnsCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteRestMultipleTurnsCommand *)
    MDialogs.ExecuteModelessMoriaDialogBox (player^.windows.frame,"Rest_Dialog",player,InitializeRestDialog,ExecuteRestDialogCommand,CloseRestDialog);
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteRestMultipleTurnsCommand;
  
  PROCEDURE InitializeRestDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* InitializeRestDialog *)
    (* no action *)
  END InitializeRestDialog;
  
  PROCEDURE StopPlayerResting (player : MStruct.PlayerInfoPointer);
    VAR
        previous : BOOLEAN;
    
  BEGIN (* StopPlayerResting *)
    WInput.EnableWindow (player^.windows.frame,TRUE,previous);
    MDialogs.DestroyCurrentModelessDialog (player);
    
    player^.character^.variables.counters [MCStruct.RestCOUNT] := 0;
    player^.character^.variables.digestion                     := player^.character^.variables.digestion + 1;
    
    EXCL (player^.character^.variables.status,MCStruct.RestUntilHealedFLAG);
  END StopPlayerResting;
  
  PROCEDURE UpdateRestCOUNT (player : MStruct.PlayerInfoPointer);
    PROCEDURE ShouldStopPlayerResting (player : MStruct.PlayerInfoPointer) : BOOLEAN;
      PROCEDURE WaitForAnyCounters (player : MStruct.PlayerInfoPointer) : BOOLEAN;
        TYPE
             PlayerCounterSet = SET OF MCStruct.PlayerCounterMnemonic;
        
        CONST
              ExcludedCounters = PlayerCounterSet {MCStruct.RestCOUNT,MCStruct.ProtectionCOUNT,MCStruct.FastCOUNT,MCStruct.ProtEvilCOUNT,MCStruct.InvulnCOUNT,MCStruct.HeroCOUNT,MCStruct.SuperHeroCOUNT,MCStruct.DetectInvisCOUNT,MCStruct.TimedInfraCOUNT};
        
        VAR
            index : MCStruct.PlayerCounterMnemonic;
        
      BEGIN (* WaitForAnyCounters *)
        FOR index := MIN (MCStruct.PlayerCounterMnemonic) TO MAX (MCStruct.PlayerCounterMnemonic) DO
          IF (NOT (index IN ExcludedCounters) AND (player^.character^.variables.counters [index] > 0)) THEN
            RETURN (TRUE);
          END; (* IF *)
        END; (* FOR *)
        
        RETURN (FALSE);
      END WaitForAnyCounters;
      
    BEGIN (* ShouldStopPlayerResting *)
      IF player^.character^.variables.hpCUR < player^.character^.variables.hpMAX THEN
        RETURN (FALSE);
      ELSIF player^.character^.variables.manaCUR < player^.character^.variables.manaMAX THEN
        RETURN (FALSE);
      ELSE
        RETURN (NOT (WaitForAnyCounters (player)));
      END; (* IF *)
    END ShouldStopPlayerResting;
    
  BEGIN (* UpdateRestCOUNT *)
    IF ((MCStruct.RestUntilHealedFLAG IN player^.character^.variables.status) AND ShouldStopPlayerResting (player)) THEN
      StopPlayerResting (player);
    ELSE
      DEC (player^.character^.variables.counters [MCStruct.RestCOUNT]);
      
      IF player^.character^.variables.counters [MCStruct.RestCOUNT] > 0 THEN
        WDialog.SetDlgItemCardinal (player^.windows.dialog,NumberTurnsEditTextControl,player^.character^.variables.counters [MCStruct.RestCOUNT]);
      ELSE
        StopPlayerResting (player);
      END; (* IF *)
    END; (* IF *)
  END UpdateRestCOUNT;
END MPRest.
