IMPLEMENTATION MODULE MPStat2;
  (*/WIN:A*)
  
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT MSActs2,OSActions;
  IMPORT MMWindow,MRandom;
  IMPORT WString;
  
  
  PROCEDURE CheckForEnchantments (player : MStruct.PlayerInfoPointer);
    CONST
          EnchantmentMessage = "There's something about what you are %POSITION...";
    
    PROCEDURE CheckForBackpackEnchantments (player : MStruct.PlayerInfoPointer);
      VAR
          index : CARDINAL;
      
    BEGIN (* CheckForBackpackEnchantments *)
      FOR index := 1 TO player^.character^.inventory.counter DO
        IF (ObjectIsEnchanted (player^.character^.inventory.backpack [index - 1]) AND (MRandom.CardinalRandomRangeValue (1,50) = 1)) THEN
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,"There's something about what you are carrying...");
          MarkEnchantedObject (player,player^.character^.inventory.backpack [index - 1]);
        END; (* IF *)
      END; (* FOR *)
    END CheckForBackpackEnchantments;
    
    PROCEDURE CheckForEquipmentEnchantments (player : MStruct.PlayerInfoPointer);
      VAR
          index : MCStruct.PlayerEquipmentMnemonic;
      
      PROCEDURE DisplayEnchantmentEquipmentMessage (player : MStruct.PlayerInfoPointer; position : MCStruct.PlayerEquipmentMnemonic);
        VAR
            message : ARRAY [0..127] OF CHAR;
        
        PROCEDURE ReplaceEquipmentParameter (text : ARRAY OF CHAR; formal : ARRAY OF CHAR; actual : MCStruct.PlayerEquipmentMnemonic; VAR result : ARRAY OF CHAR);
          VAR
              temp : ARRAY [0..127] OF CHAR;
          
        BEGIN (* ReplaceEquipmentParameter *)
          CASE actual OF
            MCStruct.Weapon1   : temp := "wielding";                   |
            MCStruct.Head      : temp := "wearing on your head";       |
            MCStruct.Neck      : temp := "wearing around your neck";   |
            MCStruct.Body      : temp := "wearing on your body";       |
            MCStruct.Arm       : temp := "wearing on your arm";        |
            MCStruct.Hands     : temp := "wearing on your hands";      |
            MCStruct.RingRight : temp := "wearing on your right hand"; |
            MCStruct.RingLeft  : temp := "wearing on your left hand";  |
            MCStruct.Feet      : temp := "wearing on your feet";       |
            MCStruct.Outer     : temp := "wearing about your body";    |
            MCStruct.Light     : temp := "using to light the way";     |
            MCStruct.Weapon2   : temp := "holding ready by your side"; |
          END; (* CASE *)
          
          WString.ReplaceStringParameter (text,formal,temp,result);
        END ReplaceEquipmentParameter;
        
      BEGIN (* DisplayEnchantmentEquipmentMessage *)
        ReplaceEquipmentParameter (EnchantmentMessage,"%POSITION",position,message);
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,message);
      END DisplayEnchantmentEquipmentMessage;
      
    BEGIN (* CheckForEquipmentEnchantments *)
      FOR index := MIN (MCStruct.PlayerEquipmentMnemonic) TO MAX (MCStruct.PlayerEquipmentMnemonic) DO
        IF ((player^.character^.inventory.equipment [index].object.class <> OStruct.Nothing) AND ObjectIsEnchanted (player^.character^.inventory.equipment [index]) AND (MRandom.CardinalRandomRangeValue (1,10) = 1)) THEN
          DisplayEnchantmentEquipmentMessage (player,index);
          MarkEnchantedObject (player,player^.character^.inventory.equipment [index]);
        END; (* IF *)
      END; (* FOR *)
    END CheckForEquipmentEnchantments;
    
    PROCEDURE MarkEnchantedObject (player : MStruct.PlayerInfoPointer; VAR item : OStruct.InventoryItemRecord);
    BEGIN (* MarkEnchantedObject *)
      INCL (item.identification,OStruct.IdentMagic);
      MSActs2.DisturbPlayer (player,FALSE);
    END MarkEnchantedObject;
    
    PROCEDURE ObjectIsEnchanted (item : OStruct.InventoryItemRecord) : BOOLEAN;
      CONST
            EnchantableObjects = OStruct.ObjectClassSet {OStruct.SlingAmmo..OStruct.SoftBodyArmor};
      
      PROCEDURE ObjectAttributeIntersection (value1,value2 : OStruct.ObjectAttributeFlags) : BOOLEAN;
        VAR
            index : OStruct.ObjectAttributeMnemonic;
        
      BEGIN (* ObjectAttributeIntersection *)
        FOR index := MIN (OStruct.ObjectAttributeMnemonic) TO MAX (OStruct.ObjectAttributeMnemonic) DO
          IF ((index IN value1) AND (index IN value2)) THEN
            RETURN (TRUE);
          END; (* IF *)
        END; (* FOR *)
        
        RETURN (FALSE);
      END ObjectAttributeIntersection;
      
    BEGIN (* ObjectIsEnchanted *)
      IF ((OStruct.Cursed IN item.object.attributes) OR NOT (item.object.class IN EnchantableObjects) OR (OStruct.IdentMagic IN item.identification) OR OSActions.InventoryItemIsKnown2 (item)) THEN
        RETURN (FALSE);
      END; (* IF *)
      
      IF ((item.object.armorMOD > 0) OR (item.object.damageMOD > 0) OR (item.object.strikeMOD > 0)) THEN
        RETURN (TRUE);
      END; (* IF *)
      
      IF ((item.object.miscellaneous > 0) AND ObjectAttributeIntersection (item.object.attributes,OStruct.ObjectAttributeFlags {OStruct.Strength..OStruct.Search,OStruct.Speed,OStruct.InfraVision})) THEN
        RETURN (TRUE);
      END; (* IF *)
      
      RETURN (ObjectAttributeIntersection (item.object.attributes,OStruct.ObjectAttributeFlags {OStruct.SlowDigestion,OStruct.Stealth,OStruct.Regeneration,OStruct.SlayDragon..OStruct.FeatherFalling}));
    END ObjectIsEnchanted;
    
  BEGIN (* CheckForEnchantments *)
    CheckForEquipmentEnchantments (player);
    CheckForBackpackEnchantments (player);
  END CheckForEnchantments;
  
  PROCEDURE ShouldCheckForEnchantments (player : MStruct.PlayerInfoPointer) : BOOLEAN;
  BEGIN (* ShouldCheckForEnchantments *)
    RETURN ((player^.character^.turn MOD 15 = 0) AND NOT (MCStruct.ConfusedFLAG IN player^.character^.variables.status) AND (MRandom.CardinalRandomRangeValue (1,10 + 750 DIV (player^.character^.variables.level + 5)) = 1));
  END ShouldCheckForEnchantments;
END MPStat2.
