IMPLEMENTATION MODULE MPStatus;
  (*/WIN:A*)
  
  IMPORT MCreatures,MDGAlloc,MMWindow,MPCounters,MPDamage,MPMovement,MPStat2,MRandom,MScrl2,MStores,MSUpdate;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT MSActs2;
  IMPORT WMacro;
  
  
  PROCEDURE UpdatePlayerStatusInformation (player : MStruct.PlayerInfoPointer);
    CONST
          RandomMonsterChance = 160;
    
    CONST
          AlertPlayerFoodValue = 2000;
          WeakPlayerFoodValue  = 1000;
          FaintPlayerFoodValue = 300;
    
    PROCEDURE ExecuteRandomTeleportation (player : MStruct.PlayerInfoPointer);
    BEGIN (* ExecuteRandomTeleportation *)
      MScrl2.ExecuteTeleportScrollAction (player,40);
      MSActs2.DisturbPlayer (player,TRUE);
    END ExecuteRandomTeleportation;
    
    PROCEDURE RegeneratePlayerHitPoints (player : MStruct.PlayerInfoPointer; percent : REAL);
      CONST
            MinimumHPRegeneration = 0.0220031;
      
      VAR
          currentHP : REAL;
      
    BEGIN (* RegeneratePlayerHitPoints *)
      currentHP                          := player^.character^.variables.hpCUR;
      player^.character^.variables.hpCUR := WMacro.MinReal (player^.character^.variables.hpCUR + player^.character^.variables.hpMAX * percent + MinimumHPRegeneration,player^.character^.variables.hpMAX);
      
      IF TRUNC (currentHP) <> TRUNC (player^.character^.variables.hpCUR) THEN
        MSUpdate.UpdateCurrentHitPointsWindow (player);
      END; (* IF *)
    END RegeneratePlayerHitPoints;
    
    PROCEDURE RegeneratePlayerMana (player : MStruct.PlayerInfoPointer; percent : REAL);
      CONST
            MinimumManaRegeneration = 7.9956055E-3;
      
      VAR
          currentMANA : REAL;
      
    BEGIN (* RegeneratePlayerMana *)
      currentMANA                          := player^.character^.variables.manaCUR;
      player^.character^.variables.manaCUR := WMacro.MinReal (player^.character^.variables.manaCUR + player^.character^.variables.manaMAX * percent + MinimumManaRegeneration,player^.character^.variables.manaMAX);
      
      IF TRUNC (currentMANA) <> TRUNC (player^.character^.variables.manaCUR) THEN
        MSUpdate.UpdateCurrentManaWindow (player);
      END; (* IF *)
    END RegeneratePlayerMana;
    
    PROCEDURE RegenerationAmount (player : MStruct.PlayerInfoPointer) : REAL;
      CONST
            NormalRegenerationAmount = 3.0059814E-3;
            FaintRegenerationAmount  = 5.0354004E-4;
            WeakRegenerationAmount   = 1.4953613E-3;
      
      VAR
          amount : REAL;
      
    BEGIN (* RegenerationAmount *)
      IF player^.character^.variables.food < 0 THEN
        amount := 0.0;
      ELSIF player^.character^.variables.food < FaintPlayerFoodValue THEN
        amount := FaintRegenerationAmount;
      ELSIF player^.character^.variables.food < WeakPlayerFoodValue THEN
        amount := WeakRegenerationAmount;
      ELSE
        amount := NormalRegenerationAmount;
      END; (* IF *)
      
      IF MCStruct.RegenerationFLAG IN player^.character^.variables.status THEN
        amount := amount * 1.5;
      END; (* IF *)
      
      IF ((player^.character^.variables.counters [MCStruct.RestCOUNT] > 0) OR (MCStruct.SearchFLAG IN player^.character^.variables.status)) THEN
        amount := amount * 2.0;
      END; (* IF *)
      
      RETURN (amount);
    END RegenerationAmount;
    
    PROCEDURE UpdatePlayerFoodStatus (player : MStruct.PlayerInfoPointer);
      PROCEDURE DisplayFoodMessages (player : MStruct.PlayerInfoPointer; food : INTEGER);
        VAR
            disturb,update : BOOLEAN;
        
      BEGIN (* DisplayFoodMessages *)
        IF food < AlertPlayerFoodValue THEN
          disturb := FALSE;
          update  := FALSE;
          
          IF food < WeakPlayerFoodValue THEN
            IF NOT (MCStruct.WeakFLAG IN player^.character^.variables.status) THEN
              MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are getting weak from hunger.");
              INCL (player^.character^.variables.status,MCStruct.WeakFLAG);
              
              disturb := TRUE;
              update  := TRUE;
            END; (* IF *)
            
            IF ((food < FaintPlayerFoodValue) AND (MRandom.CardinalRandomRangeValue (1,8) = 1)) THEN
              INC (player^.character^.variables.counters [MCStruct.ParalysisCOUNT],MRandom.CardinalRandomRangeValue (1,5));
              MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You faint from lack of food.");
              
              disturb := TRUE;
            END; (* IF *)
          ELSIF NOT (MCStruct.HungryFLAG IN player^.character^.variables.status) THEN
            MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are getting hungry.");
            INCL (player^.character^.variables.status,MCStruct.HungryFLAG);
            
            disturb := TRUE;
            update  := TRUE;
          END; (* IF *)
          
          IF disturb THEN
            MSActs2.DisturbPlayer (player,TRUE);
          END; (* IF *)
          
          IF update THEN
            MSUpdate.UpdateHungerStatusWindow (player);
          END; (* IF *)
        END; (* IF *)
      END DisplayFoodMessages;
      
    BEGIN (* UpdatePlayerFoodStatus *)
      DisplayFoodMessages (player,player^.character^.variables.food);
      
      IF player^.character^.variables.speed < 0 THEN
        DEC (player^.character^.variables.food,player^.character^.variables.speed * player^.character^.variables.speed);
      END; (* IF *)
      
      DEC (player^.character^.variables.food,player^.character^.variables.digestion);
      
      IF player^.character^.variables.food < 0 THEN
        MPDamage.ReduceCharacterHitPoints (player,-player^.character^.variables.food DIV 16,"starvation");
      END; (* IF *)
    END UpdatePlayerFoodStatus;
    
    PROCEDURE UpdatePlayerLightStatus (player : MStruct.PlayerInfoPointer; VAR light : OStruct.InventoryItemRecord);
      VAR
          change,warning : BOOLEAN;
      
      PROCEDURE UpdateCurrentLightStatus (player : MStruct.PlayerInfoPointer; VAR light : OStruct.InventoryItemRecord; VAR warning,change : BOOLEAN);
      BEGIN (* UpdateCurrentLightStatus *)
        warning := FALSE;
        
        IF light.object.miscellaneous > 0 THEN
          DEC (light.object.miscellaneous);
          
          IF light.object.miscellaneous = 0 THEN
            MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Your light has gone out!");
            warning := TRUE;
          ELSIF ((light.object.miscellaneous < 40) AND NOT (MCStruct.BlindFLAG IN player^.character^.variables.status) AND (MRandom.CardinalRandomRangeValue (1,5) = 1)) THEN
            MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Your light is growing faint.");
            warning := TRUE;
          END; (* IF *)
        END; (* IF *)
        
        change := (light.object.miscellaneous = 0);
        
        IF change THEN
          EXCL (player^.character^.variables.status,MCStruct.PlayerLightFLAG);
        END; (* IF *)
      END UpdateCurrentLightStatus;
      
    BEGIN (* UpdatePlayerLightStatus *)
      IF MCStruct.PlayerLightFLAG IN player^.character^.variables.status THEN
        UpdateCurrentLightStatus (player,light,warning,change);
      ELSIF ((light.object.class <> OStruct.Nothing) AND (light.object.miscellaneous > 0)) THEN
        INCL (player^.character^.variables.status,MCStruct.PlayerLightFLAG);
        DEC (light.object.miscellaneous);
        
        MPMovement.UpdatePlayerLightDisplay (player,player^.character^.line,player^.character^.column);
        
        warning := FALSE;
        change  := TRUE;
      ELSE
        warning := FALSE;
        change  := FALSE;
      END; (* IF *)
      
      IF change THEN
        MCreatures.ComputeCreatureVisibility (player,TRUE);
        MSActs2.DisturbPlayer (player,TRUE);
      ELSIF warning THEN
        MSActs2.DisturbPlayer (player,TRUE);
      END; (* IF *)
    END UpdatePlayerLightStatus;
    
    PROCEDURE UpdateStatusDisplay (player : MStruct.PlayerInfoPointer);
      PROCEDURE AnyStatisticsFlags (status : MCStruct.PlayerStatusFlags) : BOOLEAN;
        VAR
            index : MCStruct.PlayerStatusMnemonic;
        
      BEGIN (* AnyStatisticsFlags *)
        FOR index := MCStruct.StrFLAG TO MCStruct.ChrFLAG DO
          IF index IN status THEN
            RETURN (TRUE);
          END; (* IF *)
        END; (* FOR *)
        
        RETURN (FALSE);
      END AnyStatisticsFlags;
      
    BEGIN (* UpdateStatusDisplay *)
      IF MCStruct.StrWgtFLAG IN player^.character^.variables.status THEN
        MSActs2.CheckStrength (player^.windows.frame,player);
      END; (* IF *)
      
      IF MCStruct.StudyFLAG IN player^.character^.variables.status THEN
        MSUpdate.UpdateStudyStatusWindow (player);
      END; (* IF *)
      
      IF MCStruct.SpeedFLAG IN player^.character^.variables.status THEN
        EXCL (player^.character^.variables.status,MCStruct.SpeedFLAG);
        MSUpdate.UpdateCurrentSpeedWindow (player);
      END; (* IF *)
      
      IF ((MCStruct.ParalysedFLAG IN player^.character^.variables.status) AND (player^.character^.variables.counters [MCStruct.ParalysisCOUNT] = 0)) THEN
        EXCL (player^.character^.variables.status,MCStruct.ParalysedFLAG);
        MSUpdate.UpdateSearchRestStatusWindow (player);
      ELSIF player^.character^.variables.counters [MCStruct.ParalysisCOUNT] > 0 THEN
        INCL (player^.character^.variables.status,MCStruct.ParalysedFLAG);
        MSUpdate.UpdateSearchRestStatusWindow (player);
      ELSIF player^.character^.variables.counters [MCStruct.RestCOUNT] > 0 THEN
        MSUpdate.UpdateSearchRestStatusWindow (player);
      END; (* IF *)
      
      IF MCStruct.ArmorFLAG IN player^.character^.variables.status THEN
        EXCL (player^.character^.variables.status,MCStruct.ArmorFLAG);
        MSUpdate.UpdateCurrentArmorClassWindow (player);
      END; (* IF *)
      
      IF AnyStatisticsFlags (player^.character^.variables.status) THEN
        MSUpdate.UpdateMarkedStatisticWindows (player);
      END; (* IF *)
      
      IF MCStruct.HpFLAG IN player^.character^.variables.status THEN
        EXCL (player^.character^.variables.status,MCStruct.HpFLAG);
        
        MSUpdate.UpdateCurrentHitPointsWindow (player);
        MSUpdate.UpdateMaximumHitPointsWindow (player);
      END; (* IF *)
      
      IF MCStruct.ManaFLAG IN player^.character^.variables.status THEN
        EXCL (player^.character^.variables.status,MCStruct.ManaFLAG);
        MSUpdate.UpdateCurrentManaWindow (player);
      END; (* IF *)
    END UpdateStatusDisplay;
    
  BEGIN (* UpdatePlayerStatusInformation *)
    INC (player^.character^.turn);
    
    IF ((player^.character^.variables.depthCUR > 0) AND (player^.character^.turn MOD 1000 = 0)) THEN
      MStores.ExecuteStoreMaintainance (player);
    END; (* IF *)
    
    IF MRandom.CardinalRandomRangeValue (1,RandomMonsterChance) = 1 THEN
      MDGAlloc.AllocateRandomCreatures (player,player^.dungeon^,1,MCStruct.MaxCharacterSightDistance,FALSE);
    END; (* IF *)
    
    UpdatePlayerLightStatus (player,player^.character^.inventory.equipment [MCStruct.Light]);
    UpdatePlayerFoodStatus (player);
    
    IF ((player^.character^.variables.counters [MCStruct.PoisonedCOUNT] = 0) AND (player^.character^.variables.hpCUR < player^.character^.variables.hpMAX)) THEN
      RegeneratePlayerHitPoints (player,RegenerationAmount (player));
    END; (* IF *)
    
    IF player^.character^.variables.manaCUR < player^.character^.variables.manaMAX THEN
      RegeneratePlayerMana (player,RegenerationAmount (player));
    END; (* IF *)
    
    MPCounters.UpdateCountedConditions (player);
    
    IF ((MCStruct.TeleportFLAG IN player^.character^.variables.status) AND (MRandom.CardinalRandomRangeValue (1,100) = 1)) THEN
      ExecuteRandomTeleportation (player);
    END; (* IF *)
    
    UpdateStatusDisplay (player);
    
    IF MPStat2.ShouldCheckForEnchantments (player) THEN
      MPStat2.CheckForEnchantments (player);
    END; (* IF *)
  END UpdatePlayerStatusInformation;
END MPStatus.
