IMPLEMENTATION MODULE MPThrow;
  (*/WIN:A*)
  
  IMPORT DLineDDA,MDPainting,MDWindow,MInventory,MISelect,MMTranslator,MMWindow,MPAttacks,MPAttk2,MRandom;
  IMPORT DStruct,MCStruct,MStruct,OStruct;
  IMPORT DSActions,MCSActions,OSActions;
  IMPORT WMacro,WString;
  
  
  CONST
        HeavyCrossbow = 6;
        LightCrossbow = 5;
  
  CONST
        CompositeBow = 4;
        ShortBow     = 2;
        LongBow      = 3;
  
  CONST
        Sling = 1;
  
  VAR
      CurrentMissileDistance,MaximumMissileDistance : CARDINAL;
      MissileTerminated                             : BOOLEAN;
  
  
  PROCEDURE DetermineConfusedLocation (player : MStruct.PlayerInfoPointer; VAR line : DStruct.DungeonLineRange; VAR column : DStruct.DungeonColumnRange);
    VAR
        testLINE,testCOLUMN : INTEGER;
    
  BEGIN (* DetermineConfusedLocation *)
    MMWindow.AddMessageToList (player,"You feel confused.");
    
    REPEAT
      testCOLUMN := column + 4 - MRandom.IntegerRandomRangeValue (1,8);
      testLINE   := line + 4 - MRandom.IntegerRandomRangeValue (1,8);
    UNTIL DSActions.LocationInBounds (player^.dungeon^,testLINE,testCOLUMN);
    
    column := testCOLUMN;
    line   := testLINE;
  END DetermineConfusedLocation;
  
  PROCEDURE DropThrownMissile (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; missile : OStruct.InventoryItemRecord);
    VAR
        done : BOOLEAN;
    
    PROCEDURE DetermineMissileLocation (VAR dungeon : DStruct.DungeonInformation; VAR line : DStruct.DungeonLineRange; VAR column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
      VAR
          tempCOLUMN : INTEGER;
          tempLINE   : INTEGER;
          tries      : CARDINAL;
      
    BEGIN (* DetermineMissileLocation *)
      done := FALSE;
      
      IF MRandom.CardinalRandomRangeValue (1,10) > 1 THEN
        tempCOLUMN := column;
        tempLINE   := line;
        tries      := 0;
        
        LOOP
          done := (DSActions.LocationInBounds (dungeon,tempLINE,tempCOLUMN) AND (dungeon.physical [tempLINE]^ [tempCOLUMN].elements * DStruct.FreeSpaceElements <> DStruct.EmptyDungeonElementSet) AND (dungeon.physical [tempLINE]^ [tempCOLUMN].artifact = DStruct.InvalidArtifactCursor));
          
          IF (done OR (tries = 10)) THEN
            EXIT;
          END; (* IF *)
          
          tempCOLUMN := column + MRandom.IntegerRandomRangeValue (1,3) - 2;
          tempLINE   := line + MRandom.IntegerRandomRangeValue (1,3) - 2;
          tries      := tries + 1;
        END; (* LOOP *)
      END; (* IF *)
      
      IF done THEN
        column := tempCOLUMN;
        line   := tempLINE;
      END; (* IF *)
    END DetermineMissileLocation;
    
  BEGIN (* DropThrownMissile *)
    DetermineMissileLocation (player^.dungeon^,line,column,done);
    
    missile.object.quantity := 1;
    
    IF done THEN
      DSActions.PlaceDungeonArtifact (player^.dungeon^,line,column,missile);
      MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
    ELSE
      OSActions.DisplayObjectMessage (player^.windows.frame,player,"The %MISSILE disappears.","%MISSILE",missile,FALSE,TRUE);
    END; (* IF *)
  END DropThrownMissile;
  
  PROCEDURE ExecuteThrowObjectAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
    PROCEDURE DecrementThrownItemQuantity (player : MStruct.PlayerInfoPointer; position : CARDINAL);
    BEGIN (* DecrementThrownItemQuantity *)
      IF player^.character^.inventory.backpack [position].object.quantity > 1 THEN
        DEC (player^.character^.inventory.weight,player^.character^.inventory.backpack [position].object.weight);
        DEC (player^.character^.inventory.backpack [position].object.quantity);
        
        INCL (player^.character^.variables.status,MCStruct.StrWgtFLAG);
      ELSE
        MInventory.DeleteInventoryItem (player,position);
      END; (* IF *)
    END DecrementThrownItemQuantity;
    
    PROCEDURE MaximumThrowingDistance (player : MStruct.PlayerInfoPointer; weapon,missile : OStruct.InventoryItemRecord) : CARDINAL;
    BEGIN (* MaximumThrowingDistance *)
      IF WeaponUsesMissile (weapon,missile) THEN
        CASE weapon.object.miscellaneous OF
          HeavyCrossbow : RETURN (35); |
          LightCrossbow : RETURN (25); |
    
          CompositeBow : RETURN (35); |
          ShortBow     : RETURN (25); |
          LongBow      : RETURN (30); |
    
          Sling : RETURN (20); |
        END; (* CASE *)
      ELSE
        RETURN (WMacro.MinInteger ((player^.character^.statistics.used [MCStruct.str] + 20) * 10 DIV WMacro.MinInteger (missile.object.weight,1),10));
      END; (* IF *)
    END MaximumThrowingDistance;
    
  BEGIN (* ExecuteThrowObjectAction *)
    OSActions.DescribeRemainingObjectQuantity (player,player^.character^.inventory.backpack [player^.character^.inventory.selection]);
    
    IF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0 THEN
      DetermineConfusedLocation (player,line,column);
    END; (* IF *)
    
    MaximumMissileDistance := MaximumThrowingDistance (player,player^.character^.inventory.equipment [MCStruct.Weapon1],player^.character^.inventory.backpack [player^.character^.inventory.selection]);
    CurrentMissileDistance := 0;
    MissileTerminated      := FALSE;
    
    DLineDDA.ExecuteDungeonTraceProcedure (player,player^.character^.line,player^.character^.column,line,column,PlotPhysicalMissileLocation,done);
    
    IF NOT (MissileTerminated) THEN
      PlotPhysicalMissileLocation (player,line,column,done);
      
      IF NOT (MissileTerminated) THEN
        DropThrownMissile (player,line,column,player^.character^.inventory.backpack [player^.character^.inventory.selection]);
      END; (* IF *)
    END; (* IF *)
    
    DecrementThrownItemQuantity (player,player^.character^.inventory.selection);
    MStruct.CharacterTurnExecuted := TRUE;
  END ExecuteThrowObjectAction;
  
  PROCEDURE ExecuteThrowObjectCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteThrowObjectCommand *)
    MISelect.SelectInventoryItem (player,"Fire/Throw which object?",OStruct.AllBackpackObjects,player^.character^.inventory.selection,MStruct.CharacterTurnExecuted);
    
    IF MStruct.CharacterTurnExecuted THEN
      MMTranslator.ExecuteTargetedCommand (player,"Fire/Throw at which location?",ExecuteThrowObjectAction);
    END; (* IF *)
  END ExecuteThrowObjectCommand;
  
  PROCEDURE PlotPhysicalMissileLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
    PROCEDURE MissileStrikeModifier (player : MStruct.PlayerInfoPointer; weapon,missile : OStruct.InventoryItemRecord) : INTEGER;
      VAR
          modifier : INTEGER;
      
    BEGIN (* MissileStrikeModifier *)
      modifier := player^.character^.variables.bonusREAL.strike + missile.object.strikeMOD;
      
      IF weapon.object.class = OStruct.Nothing THEN
        modifier := modifier + weapon.object.strikeMOD;
      ELSE
        modifier := modifier - weapon.object.strikeMOD;
      END; (* IF *)
      
      RETURN (modifier);
    END MissileStrikeModifier;
    
    PROCEDURE MissileStrikesCreature (player : MStruct.PlayerInfoPointer; weapon,missile : OStruct.InventoryItemRecord; creature : DStruct.DungeonCreatureRecord; distance : CARDINAL) : BOOLEAN;
      PROCEDURE MissileStrikeBase (player : MStruct.PlayerInfoPointer; weapon,missile : OStruct.InventoryItemRecord; distance : INTEGER; visible : BOOLEAN) : INTEGER;
        VAR
            ability : INTEGER;
        
        PROCEDURE StandardMissileStrikeBase (player : MStruct.PlayerInfoPointer; weapon,missile : OStruct.InventoryItemRecord) : INTEGER;
        BEGIN (* StandardMissileStrikeBase *)
          IF WeaponUsesMissile (weapon,missile) THEN
            RETURN (player^.character^.abilities.missile);
          ELSE
            RETURN (player^.character^.abilities.missile * 75 DIV 100);
          END; (* IF *)
        END StandardMissileStrikeBase;
        
      BEGIN (* MissileStrikeBase *)
        ability := StandardMissileStrikeBase (player,weapon,missile) - distance;
        
        IF NOT (visible) THEN
          ability := ability DIV (distance + 2) - (player^.character^.variables.level * MCSActions.ClassMissileLevelAdjustment (player^.character^.constants.class) DIV 2) - (MissileStrikeModifier (player,weapon,missile) * (MCStruct.MartialStrikeAdjustment - 1));
        END; (* IF *)
        
        RETURN (ability);
      END MissileStrikeBase;
      
    BEGIN (* MissileStrikesCreature *)
      RETURN (MPAttacks.SuccessfulAttack (player,MissileStrikeBase (player,weapon,missile,distance,creature.visible),player^.character^.variables.level,MissileStrikeModifier (player,weapon,missile),player^.creatures^.table [creature.cursor].armor,MCSActions.ClassMissileLevelAdjustment (player^.character^.constants.class)));
    END MissileStrikesCreature;
    
    PROCEDURE StrikeCreatureWithMissile (player : MStruct.PlayerInfoPointer; weapon,missile : OStruct.InventoryItemRecord; VAR creature : DStruct.DungeonCreatureRecord);
      PROCEDURE DisplayKilledCreatureMessage (player : MStruct.PlayerInfoPointer; creature : DStruct.DungeonCreatureRecord);
        VAR
            message : ARRAY [0..127] OF CHAR;
        
      BEGIN (* DisplayKilledCreatureMessage *)
        IF creature.visible THEN
          WString.ReplaceStringParameter ("You have killed the %s.","%s",player^.creatures^.table [creature.cursor].description,message);
        ELSE
          message := "You have killed something!";
        END; (* IF *)
        
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,message);
      END DisplayKilledCreatureMessage;
      
      PROCEDURE DisplaySuccessfulHitMessage (player : MStruct.PlayerInfoPointer; missile : OStruct.InventoryItemRecord; creature : ARRAY OF CHAR; visible : BOOLEAN);
        VAR
            message : ARRAY [0..127] OF CHAR;
        
      BEGIN (* DisplaySuccessfulHitMessage *)
        IF visible THEN
          WString.ReplaceStringParameter ("The %OBJECT hits the %CREATURE.","%CREATURE",creature,message);
        ELSE
          message := "You hear a cry as the %OBJECT finds a mark.";
        END; (* IF *)
        
        OSActions.DisplayObjectMessage (player^.windows.frame,player,message,"%OBJECT",missile,FALSE,TRUE);
      END DisplaySuccessfulHitMessage;
      
      PROCEDURE TotalMissileDamage (player : MStruct.PlayerInfoPointer; weapon,missile : OStruct.InventoryItemRecord; creature : CARDINAL) : CARDINAL;
        VAR
            damage : INTEGER;
        
        PROCEDURE StandardMissileDamage (weapon,missile : OStruct.InventoryItemRecord) : INTEGER;
          VAR
              damage : INTEGER;
          
          PROCEDURE MissileWeaponDamageMultiplier (weapon : CARDINAL) : INTEGER;
          BEGIN (* MissileWeaponDamageMultiplier *)
            CASE weapon OF
              Sling,ShortBow             : RETURN (2); |
              LongBow,LightCrossbow      : RETURN (3); |
              CompositeBow,HeavyCrossbow : RETURN (4); |
            END; (* CASE *)
          END MissileWeaponDamageMultiplier;
          
        BEGIN (* StandardMissileDamage *)
          damage := MRandom.IntegerRandomRangeValue (missile.object.damage.min,missile.object.damage.max) + missile.object.damageMOD;
          
          IF WeaponUsesMissile (weapon,missile) THEN
            damage := (damage + weapon.object.damageMOD) * MissileWeaponDamageMultiplier (weapon.object.miscellaneous);
          END; (* IF *)
          
          RETURN (damage);
        END StandardMissileDamage;
        
      BEGIN (* TotalMissileDamage *)
        damage := StandardMissileDamage (weapon,missile);
        damage := MPAttk2.SpecialWeaponDamage (player,creature,missile,damage);
        damage := MPAttk2.CriticalBlowDamage (player,missile.object.weight,MissileStrikeModifier (player,weapon,missile),damage,MCSActions.ClassMissileLevelAdjustment (player^.character^.constants.class));
        
        RETURN (WMacro.MaxInteger (damage,0));
      END TotalMissileDamage;
      
    BEGIN (* StrikeCreatureWithMissile *)
      DisplaySuccessfulHitMessage (player,missile,player^.creatures^.table [creature.cursor].description,creature.visible);
      
      MPAttk2.DamageCreature (creature,TotalMissileDamage (player,weapon,missile,creature.cursor));
      
      IF creature.hitpoints = 0 THEN
        DisplayKilledCreatureMessage (player,creature);
        MPAttk2.KillCreatureAtLocation (player,creature.line,creature.column,player^.creatures^.table [creature.cursor],creature.visible,TRUE);
      END; (* IF *)
    END StrikeCreatureWithMissile;
    
  BEGIN (* PlotPhysicalMissileLocation *)
    IF NOT (MissileTerminated) THEN
      CurrentMissileDistance := CurrentMissileDistance + 1;
      
      IF ((CurrentMissileDistance > MaximumMissileDistance) OR (player^.dungeon^.physical [line]^ [column].elements * DStruct.DungeonWallElements <> DStruct.EmptyDungeonElementSet)) THEN
        DropThrownMissile (player,line,column,player^.character^.inventory.backpack [player^.character^.inventory.selection]);
        MissileTerminated := TRUE;
      ELSIF ((player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor) AND MissileStrikesCreature (player,player^.character^.inventory.equipment [MCStruct.Weapon1],player^.character^.inventory.backpack [player^.character^.inventory.selection],player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],CurrentMissileDistance)) THEN
        StrikeCreatureWithMissile (player,player^.character^.inventory.equipment [MCStruct.Weapon1],player^.character^.inventory.backpack [player^.character^.inventory.selection],player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature]);
        MissileTerminated := TRUE;
      END; (* IF *)
      
      MDWindow.DisplayPassingMissile (player,line,column,player^.character^.inventory.backpack [player^.character^.inventory.selection].object.symbol,TRUE);
    END; (* IF *)
    
    done := FALSE;
  END PlotPhysicalMissileLocation;
  
  PROCEDURE WeaponUsesMissile (weapon,missile : OStruct.InventoryItemRecord) : BOOLEAN;
  BEGIN (* WeaponUsesMissile *)
    IF weapon.object.class = OStruct.MissileWeapon THEN
      IF missile.object.class = OStruct.SlingAmmo THEN
        RETURN (weapon.object.miscellaneous = Sling);
      ELSIF missile.object.class = OStruct.Arrow THEN
        RETURN ((weapon.object.miscellaneous = ShortBow) OR (weapon.object.miscellaneous = LongBow) OR (weapon.object.miscellaneous = CompositeBow));
      ELSIF missile.object.class = OStruct.Bolt THEN
        RETURN ((weapon.object.miscellaneous = HeavyCrossbow) OR (weapon.object.miscellaneous = LightCrossbow));
      END; (* IF *)
    END; (* IF *)
    
    RETURN (FALSE);
  END WeaponUsesMissile;
END MPThrow.
