IMPLEMENTATION MODULE MResources;
  (*/WIN:A*)
  
  IMPORT Windows,Windows,WinStart,WResource;
  IMPORT CStruct,MCStruct,OStruct;
  
  
  VAR
      CharacterResourceHandle : Windows.HGLOBAL;
      CreatureResourceHandle  : Windows.HGLOBAL;
      TreasureResourceHandle  : Windows.HGLOBAL;
  
  
  PROCEDURE FreeCharacterResources;
    VAR
        done : BOOLEAN;
    
  BEGIN (* FreeCharacterResources *)
    WResource.FreeResource (CharacterResourceHandle,done);
  END FreeCharacterResources;
  
  PROCEDURE FreeCreatureResources;
    VAR
        done : BOOLEAN;
    
  BEGIN (* FreeCreatureResources *)
    WResource.FreeResource (CreatureResourceHandle,done);
  END FreeCreatureResources;
  
  PROCEDURE FreeTreasureResources;
    VAR
        done : BOOLEAN;
    
  BEGIN (* FreeTreasureResources *)
    WResource.FreeResource (TreasureResourceHandle,done);
  END FreeTreasureResources;
  
  PROCEDURE LoadCharacterResources () : MCStruct.CharacterResourceDataPointer;
  BEGIN (* LoadCharacterResources *)
    WResource.LoadResource (WinStart.hInstance,WResource.FindResource (WinStart.hInstance,MCStruct.CharacterResourceDataName,MCStruct.CharacterResourceDataType),CharacterResourceHandle);
    
    IF CharacterResourceHandle <> Windows.NULL THEN
      RETURN (MCStruct.CharacterResourceDataPointer (WResource.LockResource (CharacterResourceHandle)));
    ELSE
      RETURN (NIL);
    END; (* IF *)
  END LoadCharacterResources;
  
  PROCEDURE LoadCreatureResources () : CStruct.CreatureInfoPointer;
  BEGIN (* LoadCreatureResources *)
    WResource.LoadResource (WinStart.hInstance,WResource.FindResource (WinStart.hInstance,CStruct.CreatureResourceDataName,CStruct.CreatureResourceDataType),CreatureResourceHandle);
    
    IF CreatureResourceHandle <> Windows.NULL THEN
      RETURN (CStruct.CreatureInfoPointer (WResource.LockResource (CreatureResourceHandle)));
    ELSE
      RETURN (NIL);
    END; (* IF *)
  END LoadCreatureResources;
  
  PROCEDURE LoadTreasureResources () : OStruct.TreasureInfoPointer;
  BEGIN (* LoadTreasureResources *)
    WResource.LoadResource (WinStart.hInstance,WResource.FindResource (WinStart.hInstance,OStruct.TreasureResourceDataName,OStruct.TreasureResourceDataType),TreasureResourceHandle);
    
    IF CreatureResourceHandle <> Windows.NULL THEN
      RETURN (OStruct.TreasureInfoPointer (WResource.LockResource (TreasureResourceHandle)));
    ELSE
      RETURN (NIL);
    END; (* IF *)
  END LoadTreasureResources;

BEGIN (* MResources *)
  CharacterResourceHandle := Windows.NULL;
  CreatureResourceHandle  := Windows.NULL;
  TreasureResourceHandle  := Windows.NULL;
END MResources.
