IMPLEMENTATION MODULE MSActs2;
  (*/WIN:A*)
  
  IMPORT Windows,WInput,WMacro,WString;
  
  IMPORT MCSpells,MDWindow,MMWindow,MPRest,MPSearch,MRandom,MSUpdate,MSWindow;
  IMPORT MCSActions,MSActions,MSActs3;
  IMPORT MCStruct,MStruct;
  
  
  PROCEDURE CheckStrength (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* CheckStrength *)
    MSActs3.CheckBackpackStrength (window,player);
    MSActs3.CheckWeaponStrength (window,player);
    
    EXCL (player^.character^.variables.status,MCStruct.StrWgtFLAG);
  END CheckStrength;
  
  PROCEDURE DecrementStatistic (player : MStruct.PlayerInfoPointer; statistic : MCStruct.PlayerStatisticMnemonic);
    PROCEDURE RandomStatisticLoss (value : MCStruct.PlayerStatisticRange) : INTEGER;
      VAR
          amount : INTEGER;
      
    BEGIN (* RandomStatisticLoss *)
      amount := ((MAX (MCStruct.PlayerStatisticRange) - value) DIV 2 + 1) DIV 2;
      RETURN (amount + MRandom.IntegerRandomRangeValue (1,amount));
    END RandomStatisticLoss;
    
  BEGIN (* DecrementStatistic *)
    IF player^.character^.statistics.current [statistic] > MIN (MCStruct.PlayerStatisticRange) THEN
      INCL (player^.character^.variables.status,VAL (MCStruct.PlayerStatusMnemonic,ORD (statistic) + ORD (MCStruct.StrFLAG)));
      
      IF ((player^.character^.statistics.current [statistic] > 18) AND (player^.character^.statistics.current [statistic] < 117)) THEN
        player^.character^.statistics.current [statistic] := WMacro.MaxCardinal (player^.character^.statistics.current [statistic] - RandomStatisticLoss (player^.character^.statistics.current [statistic]),18);
      ELSE
        DEC (player^.character^.statistics.current [statistic]);
      END; (* IF *)
      
      MSActions.ComputePlayerUseStatistic (player,statistic);
      MSUpdate.UpdateStatisticWindow (player,statistic);
    END; (* IF *)
  END DecrementStatistic;
  
  PROCEDURE DisturbPlayer (player : MStruct.PlayerInfoPointer; disturbREST : BOOLEAN);
    VAR
        previous : Windows.HWND;
    
  BEGIN (* DisturbPlayer *)
    IF MCStruct.SearchFLAG IN player^.character^.variables.status THEN
      MPSearch.PlayerSearchingOff (player);
    ELSIF player^.character^.variables.counters [MCStruct.RestCOUNT] > 0 THEN
      IF disturbREST THEN
        MPRest.StopPlayerResting (player);
      ELSE
        WInput.SetFocus (player^.windows.dialog,previous);
      END; (* IF *)
    END; (* IF *)
    
    IF MCStruct.DistanceMoveFLAG IN player^.character^.variables.status THEN
      EXCL (player^.character^.variables.status,MCStruct.DistanceMoveFLAG);
    END; (* IF *)
  END DisturbPlayer;
  
  PROCEDURE IncreasePlayerExperience (player : MStruct.PlayerInfoPointer; change : REAL);
    PROCEDURE IncrementPlayerLevel (player : MStruct.PlayerInfoPointer);
      PROCEDURE DisplayNewExperienceLevelMessage (player : MStruct.PlayerInfoPointer);
        VAR
            message : ARRAY [0..127] OF CHAR;
        
      BEGIN (* DisplayNewExperienceLevelMessage *)
        WString.ReplaceCardinalParameter ("Welcome to level %LEVEL.","%LEVEL",player^.character^.variables.level,message);
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,message);
      END DisplayNewExperienceLevelMessage;
      
      PROCEDURE ResetCurrentExperience (VAR current : REAL; required : REAL);
      BEGIN (* ResetCurrentExperience *)
        IF current > required THEN
          current := current - (current - required) / 2.0;
        END; (* IF *)
      END ResetCurrentExperience;
      
    BEGIN (* IncrementPlayerLevel *)
      INC (player^.character^.variables.level);
      
      MCSActions.CalculatePlayerHitPoints (player^.character);
      
      MSUpdate.UpdateCurrentHitPointsWindow (player);
      MSUpdate.UpdateMaximumHitPointsWindow (player);
      MSUpdate.UpdateCurrentLevelWindows (player);
      
      DisplayNewExperienceLevelMessage (player);
      
      IF player^.character^.constants.class <> MCStruct.Warrior THEN
        MCSpells.CalculatePlayerSpells (player);
        MCSpells.CalculatePlayerMana (player);
      END; (* IF *)
      
      ResetCurrentExperience (player^.character^.variables.experCUR,MCSActions.ExperienceNeededToAdvance (player^.character));
    END IncrementPlayerLevel;
    
  BEGIN (* IncreasePlayerExperience *)
    player^.character^.variables.experCUR := WMacro.MinReal (player^.character^.variables.experCUR + change,MCStruct.MaxPlayerExperience);
    
    WHILE ((player^.character^.variables.level < MCStruct.MaxPlayerLevel) AND (MCSActions.ExperienceNeededToAdvance (player^.character) <= player^.character^.variables.experCUR)) DO
      IncrementPlayerLevel (player);
    END; (* WHILE *)
    
    MSUpdate.UpdateCurrentExperienceWindow (player);
    
    IF player^.character^.variables.experCUR > player^.character^.variables.experMAX THEN
      player^.character^.variables.experMAX := player^.character^.variables.experCUR;
    END; (* IF *)
  END IncreasePlayerExperience;
  
  PROCEDURE IncrementStatistic (player : MStruct.PlayerInfoPointer; statistic : MCStruct.PlayerStatisticMnemonic; VAR done : BOOLEAN);
    PROCEDURE RandomStatisticIncrease (value : MCStruct.PlayerStatisticRange) : INTEGER;
      VAR
          temp : INTEGER;
      
    BEGIN (* RandomStatisticIncrease *)
      temp := (((MAX (MCStruct.PlayerStatisticRange) - value) DIV 3 + 1) DIV 2);
      RETURN (temp + MRandom.IntegerRandomRangeValue (1,temp));
    END RandomStatisticIncrease;
    
  BEGIN (* IncrementStatistic *)
    done := (player^.character^.statistics.current [statistic] < MAX (MCStruct.PlayerStatisticRange));
    
    IF done THEN
      CASE player^.character^.statistics.current [statistic] OF
        3..17,116,117 : player^.character^.statistics.current [statistic] := player^.character^.statistics.current [statistic] + 1;                                                                           |
        18..115       : player^.character^.statistics.current [statistic] := player^.character^.statistics.current [statistic] + RandomStatisticIncrease (player^.character^.statistics.current [statistic]); |
        118           : player^.character^.statistics.current [statistic] := player^.character^.statistics.current [statistic];                                                                               |
      END; (* CASE *)
      
      IF player^.character^.statistics.current [statistic] > player^.character^.statistics.maximum [statistic] THEN
        player^.character^.statistics.maximum [statistic] := player^.character^.statistics.current [statistic];
      END; (* IF *)
      
      MSActions.ComputePlayerUseStatistic (player,statistic);
      MSUpdate.UpdateStatisticWindow (player,statistic);
    END; (* IF *)
  END IncrementStatistic;
  
  PROCEDURE InitializeGamingWindows (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* InitializeGamingWindows *)
    WITH player^.windows DO
      frame := window;
      
      MDWindow.CreateDungeonWindow (window,dungeon);
      MMWindow.CreateMessageWindow (window,message);
      MSWindow.CreateStatusWindow (window,status);
    END; (* WITH *)
    
    MDWindow.CenterDungeonOnLocation (player,player^.character^.line,player^.character^.column,TRUE);
    MSUpdate.InitializeStatusWindows (player);
  END InitializeGamingWindows;
  
  PROCEDURE RestoreStatisticToMaximum (player : MStruct.PlayerInfoPointer; statistic : MCStruct.PlayerStatisticMnemonic; VAR done : BOOLEAN);
  BEGIN (* RestoreStatisticToMaximum *)
    done := (player^.character^.statistics.current [statistic] <> player^.character^.statistics.maximum [statistic]);
    
    IF done THEN
      player^.character^.statistics.current [statistic] := player^.character^.statistics.maximum [statistic];
      
      MSActions.ComputePlayerUseStatistic (player,statistic);
      MSUpdate.UpdateStatisticWindow (player,statistic);
    END; (* IF *)
  END RestoreStatisticToMaximum;
END MSActs2.
