IMPLEMENTATION MODULE MSActs3;
  (*/WIN:A*)
  
  IMPORT Windows;
  
  IMPORT DSActions,MCSActions,MSActions,MSActs2,OSActions;
  IMPORT CStruct,DStruct,MCStruct,MStruct,OStruct;
  IMPORT MDPainting,MDWindow,MInventory,MMWindow;
  
  
  PROCEDURE AlterPlayerSpeed (player : MStruct.PlayerInfoPointer; change : INTEGER);
    PROCEDURE AlterDungeonCreatureSpeed (VAR creatures : ARRAY OF DStruct.DungeonCreatureRecord; change : INTEGER);
      VAR
          index : CARDINAL;
      
    BEGIN (* AlterDungeonCreatureSpeed *)
      FOR index := 0 TO HIGH (creatures) DO
        IF creatures [index].cursor <> CStruct.InvalidCreatureCursor THEN
          creatures [index].speed := creatures [index].speed + change;
        END; (* IF *)
      END; (* FOR *)
    END AlterDungeonCreatureSpeed;
    
  BEGIN (* AlterPlayerSpeed *)
    player^.character^.variables.speed := player^.character^.variables.speed + change;
    AlterDungeonCreatureSpeed (player^.dungeon^.creatures,change);
    
    INCL (player^.character^.variables.status,MCStruct.SpeedFLAG);
  END AlterPlayerSpeed;
  
  PROCEDURE CheckBackpackStrength (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
    VAR
        change : INTEGER;
        limit  : CARDINAL;
    
  BEGIN (* CheckBackpackStrength *)
    limit := MSActions.PlayerBackpackWeightLimit (player);
    
    IF limit < player^.character^.inventory.weight THEN
      change := player^.character^.inventory.weight DIV (limit + 1);
    ELSE
      change := 0;
    END; (* IF *)
    
    IF player^.character^.inventory.heavyPACK <> change THEN
      IF player^.character^.inventory.heavyPACK < change THEN
        MMWindow.DisplayPopupMessage (window,player,"Your pack is so heavy that it slows you down.");
      ELSE
        MMWindow.DisplayPopupMessage (window,player,"You move more easily under the weight of your pack.");
      END; (* IF *)
      
      AlterPlayerSpeed (player,change - player^.character^.inventory.heavyPACK);
      player^.character^.inventory.heavyPACK := change;
    END; (* IF *)
  END CheckBackpackStrength;
  
  PROCEDURE CheckWeaponStrength (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* CheckWeaponStrength *)
    IF ((player^.character^.inventory.equipment [MCStruct.Weapon1].object.class <> OStruct.Nothing) AND (player^.character^.statistics.used [MCStruct.str] * 15 < player^.character^.inventory.equipment [MCStruct.Weapon1].object.weight)) THEN
      IF NOT (MCStruct.WeaponHeavyFLAG IN player^.character^.variables.status) THEN
        INCL (player^.character^.variables.status,MCStruct.WeaponHeavyFLAG);
        
        MMWindow.DisplayPopupMessage (window,player,"You have trouble wielding such a heavy weapon.");
        MCSActions.CalculatePlayerBonuses (player^.character);
      END; (* IF *)
    ELSIF MCStruct.WeaponHeavyFLAG IN player^.character^.variables.status THEN
      EXCL (player^.character^.variables.status,MCStruct.WeaponHeavyFLAG);
      
      IF player^.character^.inventory.equipment [MCStruct.Weapon1].object.class <> OStruct.Nothing THEN
        MMWindow.DisplayPopupMessage (window,player,"You are strong enough to wield your weapon.");
      END; (* IF *)
      
      MCSActions.CalculatePlayerBonuses (player^.character);
    END; (* IF *)
  END CheckWeaponStrength;
  
  PROCEDURE DeleteArtifactAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
  BEGIN (* DeleteArtifactAtLocation *)
    DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
    MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
  END DeleteArtifactAtLocation;
  
  PROCEDURE DropBackpackItem (window : Windows.HWND; player : MStruct.PlayerInfoPointer; position : CARDINAL; dropALL : BOOLEAN);
    VAR
        deleted : BOOLEAN;
        item    : OStruct.InventoryItemRecord;
    
  BEGIN (* DropBackpackItem *)
    item := player^.character^.inventory.backpack [position];
    
    IF (dropALL OR (item.object.quantity = 1)) THEN
      MInventory.DeleteInventoryItem (player,position);
    ELSE
      MInventory.DecrementInventoryItemQuantity (player,position,deleted);
      item.object.quantity := 1;
    END; (* IF *)
    
    DSActions.PlaceDungeonArtifact (player^.dungeon^,player^.character^.line,player^.character^.column,item);
    MSActs2.CheckStrength (window,player);
    
    OSActions.DisplayObjectMessage (window,player,"Dropped %OBJECT","%OBJECT",item,TRUE,TRUE);
  END DropBackpackItem;
END MSActs3.
