IMPLEMENTATION MODULE MSave;
  (*/WIN:A*)
  
  IMPORT WCursor,Win31,Windows,WinFiles;
  IMPORT FileSystem,Strings;
  
  IMPORT MCStruct,MStruct;
  IMPORT MMWindow;
  IMPORT MSave2;
  
  
  PROCEDURE DeterminePlayerSaveFileName (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
    CONST
          MoriaSaveFlags = Win31.OFN_NOREADONLYRETURN + Win31.OFN_OVERWRITEPROMPT + Win31.OFN_PATHMUSTEXIST + Win31.OFN_HIDEREADONLY;
    
    VAR
        directory : ARRAY [0..127] OF CHAR;
        title     : ARRAY [0..15] OF CHAR;
    
  BEGIN (* DeterminePlayerSaveFileName *)
    WinFiles.DetermineFileDirectory (player^.fileNAME,directory);
    
    WinFiles.GetSaveFileName (player^.windows.frame,"Save Character As",directory,MStruct.MoriaFileFilters,MStruct.MoriaFileExtension,MoriaSaveFlags,player^.fileNAME,title,done);
  END DeterminePlayerSaveFileName;
  
  PROCEDURE SaveCharacterInformation (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
    VAR
        previous : Windows.HCURSOR;
    
    PROCEDURE OutputPlayerInformationFile (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
      VAR
          f : FileSystem.File;
      
      PROCEDURE WritePlayerInformationFile (VAR f : FileSystem.File; player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
        PROCEDURE WriteCharacterInformation (VAR f : FileSystem.File; character : MCStruct.CharacterInfoPointer; VAR done : BOOLEAN);
        BEGIN (* WriteCharacterInformation *)
          WinFiles.WriteDataStructure (f,character^);
          done := (f.res = FileSystem.done);
        END WriteCharacterInformation;
        
        PROCEDURE WriteVersionInformation (VAR f : FileSystem.File; VAR done : BOOLEAN);
        BEGIN (* WriteVersionInformation *)
          WinFiles.WriteFileStringLn (f,MStruct.CurrentVersionInformation);
          done := (f.res = FileSystem.done);
        END WriteVersionInformation;
        
      BEGIN (* WritePlayerInformationFile *)
        WriteVersionInformation (f,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        WriteCharacterInformation (f,player^.character,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        MSave2.WriteCreatureInformation (f,player^.creatures,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        MSave2.WriteTreasureInformation (f,player^.treasures,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        MSave2.WriteDungeonInformation (f,player^.dungeon,done);
      END WritePlayerInformationFile;
      
    BEGIN (* OutputPlayerInformationFile *)
      WinFiles.CreateFile (f,player^.fileNAME);
      
      IF f.res = FileSystem.done THEN
        WritePlayerInformationFile (f,player,done);
        
        IF NOT (done) THEN
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Unable to write character file.");
        END; (* IF *)
        
        WinFiles.CloseFile (f);
      ELSE
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Unable to create character file.");
      END; (* IF *)
    END OutputPlayerInformationFile;
    
  BEGIN (* SaveCharacterInformation *)
    IF Strings.Length (player^.fileNAME) = 0 THEN
      DeterminePlayerSaveFileName (player,done);
    ELSE
      done := TRUE;
    END; (* IF *)
    
    IF done THEN
      WCursor.SetCursor (WCursor.StandardCursorHandle (Windows.IDC_WAIT),previous);
      OutputPlayerInformationFile (player,done);
      WCursor.SetCursor (previous,previous);
    END; (* IF *)
  END SaveCharacterInformation;

  PROCEDURE UpdateCreatureMemoryInformation (player : MStruct.PlayerInfoPointer);
    VAR
        previous : Windows.HCURSOR;
        done     : BOOLEAN;
        f        : FileSystem.File;
    
  BEGIN (* UpdateCreatureMemoryInformation *)
    WCursor.SetCursor (WCursor.StandardCursorHandle (Windows.IDC_WAIT),previous);
    
    WinFiles.OpenFile (f,player^.fileNAME);
    
    WinFiles.SetCurrentFilePosition (f,SIZE (MCStruct.CharacterInformation) + Strings.Length (MStruct.CurrentVersionInformation) + 2);
    MSave2.WriteCreatureInformation (f,player^.creatures,done);
    
    WinFiles.CloseFile (f);
    
    WCursor.SetCursor (previous,previous);
  END UpdateCreatureMemoryInformation;
END MSave.
