IMPLEMENTATION MODULE MSave2;
  (*/WIN:A*)
  
  IMPORT FileSystem;
  IMPORT WinFiles;
  
  IMPORT CStruct,DStruct,OStruct;
  
  
  PROCEDURE WriteCreatureInformation (VAR f : FileSystem.File; creatures : CStruct.CreatureInfoPointer; VAR done : BOOLEAN);
    VAR
        index : CARDINAL;
    
  BEGIN (* WriteCreatureInformation *)
    index := 0;
    
    REPEAT
      WinFiles.WriteDataStructure (f,creatures^.table [index].memory);
      INC (index);
    UNTIL ((index = CStruct.MaxNumberCreatures) OR (f.res <> FileSystem.done));
    
    done := (f.res = FileSystem.done);
  END WriteCreatureInformation;
        
  PROCEDURE WriteDungeonInformation (VAR f : FileSystem.File; dungeon : DStruct.DungeonInfoPointer; VAR done : BOOLEAN);
    PROCEDURE WriteOtherDungeonInformation (VAR f : FileSystem.File; VAR dungeon : DStruct.DungeonInformation; VAR done : BOOLEAN);
    BEGIN (* WriteOtherDungeonInformation *)
      done := FALSE;
      
      WinFiles.WriteDataStructure (f,dungeon.columns);
      
      IF f.res <> FileSystem.done THEN
        RETURN;
      END; (* IF *)
      
      WinFiles.WriteDataStructure (f,dungeon.lines);
      
      IF f.res <> FileSystem.done THEN
        RETURN;
      END; (* IF *)
      
      WinFiles.WriteDataStructure (f,dungeon.artifacts);
      
      IF f.res <> FileSystem.done THEN
        RETURN;
      END; (* IF *)
      
      WinFiles.WriteDataStructure (f,dungeon.creatures);
      
      IF f.res <> FileSystem.done THEN
        RETURN;
      END; (* IF *)
      
      WinFiles.WriteDataStructure (f,dungeon.multipliedCreatures);
      
      IF f.res <> FileSystem.done THEN
        RETURN;
      END; (* IF *)
      
      WinFiles.WriteDataStructure (f,dungeon.firstCOLUMN);
      
      IF f.res <> FileSystem.done THEN
        RETURN;
      END; (* IF *)
      
      WinFiles.WriteDataStructure (f,dungeon.firstLINE);
      
      IF f.res <> FileSystem.done THEN
        RETURN;
      END; (* IF *)
      
      WinFiles.WriteDataStructure (f,dungeon.town);
      
      IF f.res <> FileSystem.done THEN
        RETURN;
      END; (* IF *)
      
      done := TRUE;
    END WriteOtherDungeonInformation;
    
    PROCEDURE WritePhysicalDungeonInformation (VAR f : FileSystem.File; VAR lines : ARRAY OF DStruct.PhysicalDungeonLinePointer; VAR done : BOOLEAN);
      VAR
          index : CARDINAL;
      
    BEGIN (* WritePhysicalDungeonInformation *)
      index := 0;
      
      REPEAT
        WinFiles.WriteDataStructure (f,lines [index]^);
        INC (index);
      UNTIL ((index > HIGH (lines)) OR (f.res <> FileSystem.done));
      
      done := (f.res = FileSystem.done);
    END WritePhysicalDungeonInformation;
    
  BEGIN (* WriteDungeonInformation *)
    WritePhysicalDungeonInformation (f,dungeon^.physical,done);
    
    IF done THEN
      WriteOtherDungeonInformation (f,dungeon^,done);
    END; (* IF *)
  END WriteDungeonInformation;
  
  PROCEDURE WriteTreasureInformation (VAR f : FileSystem.File; treasures : OStruct.TreasureInfoPointer; VAR done : BOOLEAN);
  BEGIN (* WriteTreasureInformation *)
    WinFiles.WriteDataStructure (f,treasures^.identification);
    
    IF f.res = FileSystem.done THEN
      WinFiles.WriteDataStructure (f,treasures^.seed);
    END; (* IF *)
    
    done := (f.res = FileSystem.done);
  END WriteTreasureInformation;
END MSave2.
