IMPLEMENTATION MODULE MScribe;
  (*/WIN:A*)
  
  IMPORT MDialogs,MInventory,MISelect,MMWindow,MPInven2,ODescriptions;
  IMPORT WDialog,WEditText,Windows;
  IMPORT MStruct,OStruct;
  IMPORT SYSTEM;
  
  
  CONST
        InscriptionEditTextControl = 1204;
  
  TYPE
       ObjectInfoPointer = POINTER TO OStruct.InventoryItemRecord;
  
  
  PROCEDURE CloseScribeDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
  BEGIN (* CloseScribeDialog *)
    WDialog.EndDialog (window,Windows.FALSE_BOOL);
  END CloseScribeDialog;
  
  PROCEDURE ExecuteInscribeObjectCommand (player : MStruct.PlayerInfoPointer);
    VAR
        position : CARDINAL;
        result   : INTEGER;
        done     : BOOLEAN;
    
  BEGIN (* ExecuteInscribeObjectCommand *)
    IF player^.character^.inventory.counter > 0 THEN
      MISelect.SelectInventoryItem (player,"Inscribe which object?",OStruct.AllBackpackObjects,position,done);
      
      IF done THEN
        MDialogs.ExecuteMoriaDialogBoxParam (player^.windows.frame,"Scribe_Dialog",player,SYSTEM.ADR (player^.character^.inventory.backpack [position]),InitializeScribeDialog,ExecuteScribeDialogCommand,CloseScribeDialog,result);
      END; (* IF *)
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are not carrying anything to inscribe.");
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteInscribeObjectCommand;
  
  PROCEDURE ExecuteScribeDialogCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS; control : CARDINAL; command : CARDINAL);
    CONST
          AcceptPushButtonControl = 1205;
          CancelPushButtonControl = 1206;
    
    PROCEDURE ExecuteAcceptButtonAction (window : Windows.HWND; object : ObjectInfoPointer; command : CARDINAL);
      VAR
          length : CARDINAL;
      
    BEGIN (* ExecuteAcceptButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        WDialog.GetDlgItemText (window,InscriptionEditTextControl,object^.inscription,length);
        WDialog.EndDialog (window,Windows.TRUE_BOOL);
      END; (* IF *)
    END ExecuteAcceptButtonAction;
    
    PROCEDURE ExecuteCancelButtonAction (window : Windows.HWND; object : ObjectInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteCancelButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        WDialog.EndDialog (window,Windows.FALSE_BOOL);
      END; (* IF *)
    END ExecuteCancelButtonAction;
    
  BEGIN (* ExecuteScribeDialogCommand *)
    CASE control OF
      CancelPushButtonControl,Windows.IDCANCEL : ExecuteCancelButtonAction (window,ObjectInfoPointer (data),command); |
      AcceptPushButtonControl,Windows.IDOK     : ExecuteAcceptButtonAction (window,ObjectInfoPointer (data),command); |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteScribeDialogCommand;
  
  PROCEDURE InitializeScribeDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
    CONST
          DescriptionTextControl = 1202;
    
    VAR
        description : ARRAY [0..127] OF CHAR;
        item        : ObjectInfoPointer;
    
  BEGIN (* InitializeScribeDialog *)
    item := ObjectInfoPointer (data);
    
    ODescriptions.ReturnObjectDescription (player,item^,TRUE,description);
    
    WDialog.SetDlgItemText (window,InscriptionEditTextControl,item^.inscription);
    WDialog.SetDlgItemText (window,DescriptionTextControl,description);
    
    WEditText.LimitText (WDialog.GetDlgItem (window,InscriptionEditTextControl),OStruct.MaxInscriptionLength);
  END InitializeScribeDialog;
END MScribe.
