IMPLEMENTATION MODULE MScrl2;
  (*/WIN:A*)
  
  IMPORT MDGenerator,MInventory,MISelect,MMWindow,MPMovement,MRandom,MSpells,MSpells2,MSpells3,MSUpdate;
  IMPORT DStruct,MCStruct,MStruct,OStruct;
  IMPORT DSActions,OSActions;
  IMPORT WMacro;
  
  
  PROCEDURE ExecuteBlessingScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteBlessingScroll *)
    INC (player^.character^.variables.counters [MCStruct.BlessedCOUNT],MRandom.CardinalRandomRangeValue (1,12) + 6);
    
    identified := TRUE;
    executed   := TRUE;
  END ExecuteBlessingScroll;
  
  PROCEDURE ExecuteCreateFoodScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteCreateFoodScroll *)
    ExecuteCreateFoodScrollAction (player,executed);
    identified := TRUE;
  END ExecuteCreateFoodScroll;
  
  PROCEDURE ExecuteHolyChantScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteHolyChantScroll *)
    INC (player^.character^.variables.counters [MCStruct.BlessedCOUNT],MRandom.CardinalRandomRangeValue (1,24) + 12);
    
    identified := TRUE;
    executed   := TRUE;
  END ExecuteHolyChantScroll;
  
  PROCEDURE ExecuteHolyPrayerScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteHolyPrayerScroll *)
    INC (player^.character^.variables.counters [MCStruct.BlessedCOUNT],MRandom.CardinalRandomRangeValue (1,48) + 24);
    
    identified := TRUE;
    executed   := TRUE;
  END ExecuteHolyPrayerScroll;
  
  PROCEDURE ExecuteIdentifyScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteIdentifyScroll *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"This is an identify scroll.");
    ExecuteIdentifyScrollAction (player,executed);
    
    identified := TRUE;
  END ExecuteIdentifyScroll;
  
  PROCEDURE ExecuteMonsterConfusionScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteMonsterConfusionScroll *)
    identified := NOT (MCStruct.ConfuseMonsterFLAG IN player^.character^.variables.status);
    executed   := TRUE;
    
    IF identified THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Your hands begin to glow.");
      INCL (player^.character^.variables.status,MCStruct.ConfuseMonsterFLAG);
    END; (* IF *)
  END ExecuteMonsterConfusionScroll;
  
  PROCEDURE ExecutePhaseDoorScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecutePhaseDoorScroll *)
    ExecuteTeleportScrollAction (player,10);
    
    identified := TRUE;
    executed   := TRUE;
  END ExecutePhaseDoorScroll;
  
  PROCEDURE ExecuteProtectionFromEvilScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteProtectionFromEvilScroll *)
    MSpells.ExecuteProtectionFromEvilSpell (player,identified);
    executed := TRUE;
  END ExecuteProtectionFromEvilScroll;
  
  PROCEDURE ExecuteRechargingScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteRechargingScroll *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"This is a Recharge-Item scroll.");
    ExecuteRechargeScrollAction (player,60,executed);
    
    identified := TRUE;
  END ExecuteRechargingScroll;
  
  PROCEDURE ExecuteRuneOfProtectionScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteRuneOfProtectionScroll *)
    MSpells3.CreateGlyphOfWarding (player);
    
    identified := TRUE;
    executed   := TRUE;
  END ExecuteRuneOfProtectionScroll;
  
  PROCEDURE ExecuteTeleportLevelScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteTeleportLevelScroll *)
    player^.character^.variables.depthCUR := WMacro.MaxInteger (VAL (INTEGER,player^.character^.variables.depthCUR) + (2 * MRandom.IntegerRandomRangeValue (1,2) - 3),1);
    
    MDGenerator.GeneratePlayerDungeon (player);
    MSUpdate.UpdateCurrentDepthWindow (player);
        
    identified := TRUE;
    executed   := TRUE;
  END ExecuteTeleportLevelScroll;
  
  PROCEDURE ExecuteTeleportScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteTeleportScroll *)
    ExecuteTeleportScrollAction (player,100);
    
    identified := TRUE;
    executed   := TRUE;
  END ExecuteTeleportScroll;
  
  PROCEDURE ExecuteWordOfRecallScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteWordOfRecallScroll *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The air around you becomes charged.");
    
    IF player^.character^.variables.counters [MCStruct.WordOfRecallCOUNT] = 0 THEN
      player^.character^.variables.counters [MCStruct.WordOfRecallCOUNT] := MRandom.CardinalRandomRangeValue (1,30) + 25;
    END; (* IF *)
    
    identified := TRUE;
    executed   := TRUE;
  END ExecuteWordOfRecallScroll;
  
  
  PROCEDURE ExecuteCreateFoodScrollAction (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
    PROCEDURE CreateMagicFood (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
      VAR
          item : OStruct.InventoryItemRecord;
      
    BEGIN (* CreateMagicFood *)
      OSActions.ReturnInventoryItemRecord (player^.treasures,397,item);
      DSActions.PlaceDungeonArtifact (player^.dungeon^,line,column,item);
    END CreateMagicFood;
    
  BEGIN (* ExecuteCreateFoodScrollAction *)
    done := (player^.dungeon^.physical [player^.character^.line]^ [player^.character^.column].artifact = DStruct.InvalidArtifactCursor);
    
    IF done THEN
      CreateMagicFood (player,player^.character^.line,player^.character^.column);
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"There is already an object under you.");
      MStruct.CharacterTurnExecuted := FALSE;
    END; (* IF *)
  END ExecuteCreateFoodScrollAction;
  
  PROCEDURE ExecuteIdentifyScrollAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        selection : CARDINAL;
    
  BEGIN (* ExecuteIdentifyScrollAction *)
    MISelect.SelectInventoryItem (player,"Identify which object?",OStruct.ObjectClassSet {OStruct.Miscellaneous..OStruct.PrayerBook},selection,identified);
    
    IF identified THEN
      MSpells2.IdentifyPlayerInventoryItem (player,selection);
      OSActions.IdentifyObjectAsKnown2 (player^.treasures,player^.character^.inventory.backpack [selection]);
      
      OSActions.DisplayObjectMessage (player^.windows.frame,player,"Object identified: %OBJECT","%OBJECT",player^.character^.inventory.backpack [selection],TRUE,TRUE);
    END; (* IF *)
  END ExecuteIdentifyScrollAction;
  
  PROCEDURE ExecuteRechargeScrollAction (player : MStruct.PlayerInfoPointer; chance : CARDINAL; VAR done : BOOLEAN);
    VAR
        selection : CARDINAL;
        deleted   : BOOLEAN;
    
    PROCEDURE RechargeInventoryItem (VAR item : OStruct.InventoryItemRecord; chance : CARDINAL);
    BEGIN (* RechargeInventoryItem *)
      INC (item.object.miscellaneous,MRandom.CardinalRandomRangeValue (1,chance DIV (item.object.depth + 2) + 1));
      
      IF OSActions.InventoryItemIsKnown2 (item) THEN
        EXCL (item.identification,OStruct.IdentKnown2);
      END; (* IF *)
      
      EXCL (item.identification,OStruct.IdentEmpty);
    END RechargeInventoryItem;
    
    PROCEDURE SelectItemToRecharge (player : MStruct.PlayerInfoPointer; VAR selection : CARDINAL; VAR done : BOOLEAN);
      CONST
            RechargeItemClasses = OStruct.ObjectClassSet {OStruct.Staff,OStruct.Wand};
      
    BEGIN (* SelectItemToRecharge *)
      IF MInventory.AnyObjectsWithClasses (player^.character^.inventory.backpack,RechargeItemClasses) THEN
        MISelect.SelectInventoryItem (player,"Recharge which item?",RechargeItemClasses,selection,done);
      ELSE
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You have nothing to recharge.");
        done := FALSE;
      END; (* IF *)
    END SelectItemToRecharge;
    
    PROCEDURE SuccessfulRechargeAttempt (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; chance : CARDINAL) : BOOLEAN;
      VAR
          value : CARDINAL;
      
    BEGIN (* SuccessfulRechargeAttempt *)
      value := chance + 50 - item.object.depth + VAL (CARDINAL,item.object.miscellaneous);
      RETURN ((value >= 20) AND (MRandom.CardinalRandomRangeValue (1,value DIV 10) > 1));
    END SuccessfulRechargeAttempt;
    
  BEGIN (* ExecuteRechargeScrollAction *)
    SelectItemToRecharge (player,selection,done);
    
    IF done THEN
      IF SuccessfulRechargeAttempt (player,player^.character^.inventory.backpack [selection],chance) THEN
        RechargeInventoryItem (player^.character^.inventory.backpack [selection],chance);
      ELSE
        MInventory.DecrementInventoryItemQuantity (player,selection,deleted);
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"There is a blinding flash of light.");
      END; (* IF *)
    END; (* IF *)
  END ExecuteRechargeScrollAction;
  
  PROCEDURE ExecuteTeleportScrollAction (player : MStruct.PlayerInfoPointer; distance : CARDINAL);
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
    
    PROCEDURE DetermineNewPlayerLocation (VAR dungeon : DStruct.DungeonInformation; currentLINE : DStruct.DungeonLineRange; currentCOLUMN : DStruct.DungeonColumnRange; distance : CARDINAL; VAR resultLINE : DStruct.DungeonLineRange; VAR resultCOLUMN : DStruct.DungeonColumnRange);
      PROCEDURE GenerateLocationWithinDistance (VAR dungeon : DStruct.DungeonInformation; currentLINE : DStruct.DungeonLineRange; currentCOLUMN : DStruct.DungeonColumnRange; distance : CARDINAL; VAR resultLINE : DStruct.DungeonLineRange; VAR resultCOLUMN : DStruct.DungeonColumnRange);
      BEGIN (* GenerateLocationWithinDistance *)
        resultCOLUMN := MRandom.IntegerRandomRangeValue (1,dungeon.columns - 2);
        resultLINE   := MRandom.IntegerRandomRangeValue (1,dungeon.lines - 2);
        
        WHILE DSActions.QuickDistance (currentLINE,currentCOLUMN,resultLINE,resultCOLUMN) > distance DO
          resultCOLUMN := resultCOLUMN + (currentCOLUMN - resultCOLUMN) DIV 2;
          resultLINE   := resultLINE + (currentLINE - resultLINE) DIV 2;
        END; (* WHILE *)
      END GenerateLocationWithinDistance;
      
      PROCEDURE ValidCharacterLocation (location : DStruct.PhysicalDungeonUnit) : BOOLEAN;
        CONST
              InvalidPlayerLocations = DStruct.DungeonWallElements + DStruct.DungeonElementSet {DStruct.BlockedFloor};
        
      BEGIN (* ValidCharacterLocation *)
        RETURN ((location.creature = DStruct.InvalidCreatureCursor) AND (location.elements * InvalidPlayerLocations = DStruct.EmptyDungeonElementSet));
      END ValidCharacterLocation;
      
    BEGIN (* DetermineNewPlayerLocation *)
      REPEAT
        GenerateLocationWithinDistance (dungeon,currentLINE,currentCOLUMN,distance,resultLINE,resultCOLUMN);
      UNTIL ValidCharacterLocation (dungeon.physical [resultLINE]^ [resultCOLUMN]);
    END DetermineNewPlayerLocation;
    
  BEGIN (* ExecuteTeleportScrollAction *)
    DetermineNewPlayerLocation (player^.dungeon^,player^.character^.line,player^.character^.column,distance,line,column);
    MPMovement.MoveCharacterToLocation (player,line,column);
  END ExecuteTeleportScrollAction;
END MScrl2.
