IMPLEMENTATION MODULE MScrl3;
  (*/WIN:A*)
  
  IMPORT MCreatures,MDPainting,MDWindow,MGenocide,MMWindow,MPMovement,MRandom,MSpells,MSpells3;
  IMPORT CStruct,DStruct,MCStruct,MStruct,OStruct;
  IMPORT DSActions,OSActions;
  
  
  PROCEDURE ExecuteAggravateMonsterScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteAggravateMonsterScroll *)
    MSpells.AggravateCreatures (player,20,identified);
    
    IF identified THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"There is a high pitched humming noise.");
    END; (* IF *)
    
    executed := TRUE;
  END ExecuteAggravateMonsterScroll;
  
  PROCEDURE ExecuteDarknessScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteDarknessScroll *)
    MSpells3.ExecuteDarknessAction (player,player^.character^.line,player^.character^.column,identified);
    executed := TRUE;
  END ExecuteDarknessScroll;
  
  PROCEDURE ExecuteDestructionScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteDestructionScroll *)
    MSpells3.ExecuteDestructionAction (player,player^.character^.line,player^.character^.column);
    
    identified := TRUE;
    executed   := TRUE;
  END ExecuteDestructionScroll;
  
  PROCEDURE ExecuteDetectInvisibleScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteDetectInvisibleScroll *)
    MSpells.ExecuteDetectInvisibleAction (player,identified);
    executed := TRUE;
  END ExecuteDetectInvisibleScroll;
  
  PROCEDURE ExecuteDispelUndeadScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteDispelUndeadScroll *)
    MSpells.DispelCreatures (player,CStruct.HurtBySlayUndead,60,identified);
    executed := TRUE;
  END ExecuteDispelUndeadScroll;
  
  PROCEDURE ExecuteDoorCreationScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteDoorCreationScroll *)
    MSpells3.ExecuteDoorCreationAction (player,identified);
    executed := TRUE;
  END ExecuteDoorCreationScroll;
  
  PROCEDURE ExecuteDoorStairLocationScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteDoorStairLocationScroll *)
    MSpells.DetectHiddenDoors (player,identified,TRUE);
    executed := TRUE;
  END ExecuteDoorStairLocationScroll;
  
  PROCEDURE ExecuteGenocideScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
    VAR
        symbol : CHAR;
    
  BEGIN (* ExecuteGenocideScroll *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"This is a genocide scroll.");
    
    MGenocide.ExecuteGenocideSelectDialog (player,symbol,executed);
    
    IF executed THEN
      MSpells3.ExterminateCreatureClass (player,symbol);
    END; (* IF *)
    
    identified := TRUE;
  END ExecuteGenocideScroll;
  
  PROCEDURE ExecuteLightScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteLightScroll *)
    ExecuteLightAreaScrollAction (player);
    
    identified := TRUE;
    executed   := TRUE;
  END ExecuteLightScroll;
  
  PROCEDURE ExecuteMagicMappingScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteMagicMappingScroll *)
    ExecuteMapAreaScrollAction (player);
    
    identified := TRUE;
    executed   := TRUE;
  END ExecuteMagicMappingScroll;
  
  PROCEDURE ExecuteMassGenocideScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteMassGenocideScroll *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"This is a mass genocide scroll.");
    
    identified := TRUE;
    executed   := TRUE;
    
    ExecuteMassGenocideScrollAction (player);
  END ExecuteMassGenocideScroll;
  
  PROCEDURE ExecuteObjectDetectionScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteObjectDetectionScroll *)
    MSpells3.ExecuteDetectObjectsAction (player,identified);
    executed := TRUE;
  END ExecuteObjectDetectionScroll;
  
  PROCEDURE ExecuteSleepMonsterScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteSleepMonsterScroll *)
    MSpells.SleepAdjacentCreatures (player,identified);
    executed := TRUE;
  END ExecuteSleepMonsterScroll;
  
  PROCEDURE ExecuteSummonMonsterScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
    VAR
        count : CARDINAL;
        done  : BOOLEAN;
    
  BEGIN (* ExecuteSummonMonsterScroll *)
    identified := FALSE;
    executed   := TRUE;
    
    FOR count := 1 TO MRandom.CardinalRandomRangeValue (1,3) DO
      MCreatures.SummonRandomMonster (player,player^.character^.line,player^.character^.column,FALSE,done);
      identified := (identified OR done);
    END; (* FOR *)
  END ExecuteSummonMonsterScroll;
  
  PROCEDURE ExecuteSummonUndeadScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
    VAR
        count : CARDINAL;
        done  : BOOLEAN;
    
  BEGIN (* ExecuteSummonUndeadScroll *)
    identified := FALSE;
    executed   := TRUE;
    
    FOR count := 1 TO MRandom.CardinalRandomRangeValue (1,3) DO
      MCreatures.SummonRandomUndead (player,player^.character^.line,player^.character^.column,FALSE,done);
      identified := (identified OR done);
    END; (* FOR *)
  END ExecuteSummonUndeadScroll;
  
  PROCEDURE ExecuteTrapCreationScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteTrapCreationScroll *)
    MSpells3.ExecuteTrapCreationAction (player);
    
    identified := TRUE;
    executed   := TRUE;
  END ExecuteTrapCreationScroll;
  
  PROCEDURE ExecuteTrapDetectionScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteTrapDetectionScroll *)
    MSpells.DetectHiddenTraps (player,identified,TRUE);
    executed := TRUE;
  END ExecuteTrapDetectionScroll;
  
  PROCEDURE ExecuteTrapDoorDestructionScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteTrapDoorDestructionScroll *)
    ExecuteTrapDoorDestructionAction (player,identified);
    executed := TRUE;
  END ExecuteTrapDoorDestructionScroll;
  
  PROCEDURE ExecuteTreasureDetectionScroll (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* ExecuteTreasureDetectionScroll *)
    MSpells3.ExecuteTreasureDetectionAction (player,identified);
    executed := TRUE;
  END ExecuteTreasureDetectionScroll;
  
  
  PROCEDURE ExecuteLightAreaScrollAction (player : MStruct.PlayerInfoPointer);
    PROCEDURE LightImmediateArea (player : MStruct.PlayerInfoPointer);
      VAR
          column : DStruct.DungeonColumnRange;
          line   : DStruct.DungeonLineRange;
      
    BEGIN (* LightImmediateArea *)
      FOR line := player^.character^.line - 1 TO player^.character^.line + 1 DO
        FOR column := player^.character^.column - 1 TO player^.character^.column + 1 DO
          INCL (player^.dungeon^.physical [line]^ [column].elements,DStruct.plFLAG);
          MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,FALSE);
        END; (* FOR *)
      END; (* FOR *)
    END LightImmediateArea;
    
  BEGIN (* ExecuteLightAreaScrollAction *)
    IF player^.character^.variables.counters [MCStruct.BlindCOUNT] = 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are surrounded by a white light.");
    END; (* IF *)
    
    LightImmediateArea (player);
    
    IF ((player^.character^.variables.depthCUR > 0) AND (DStruct.lrFLAG IN player^.dungeon^.physical [player^.character^.line]^ [player^.character^.column].elements)) THEN
      MPMovement.LightDungeonRoom (player,player^.character^.line,player^.character^.column);
    END; (* IF *)
  END ExecuteLightAreaScrollAction;
  
  PROCEDURE ExecuteMapAreaScrollAction (player : MStruct.PlayerInfoPointer);
    VAR
        column,minX,maxX : INTEGER;
        line,minY,maxY   : INTEGER;
    
    PROCEDURE LightAreaAroundLocation (VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange);
      VAR
          column : DStruct.DungeonColumnRange;
          line   : DStruct.DungeonLineRange;
      
      PROCEDURE UpdateDungeonLightInformation (VAR dungeon : DStruct.DungeonInformation; VAR location : DStruct.PhysicalDungeonUnit);
      BEGIN (* UpdateDungeonLightInformation *)
        IF location.elements * DStruct.DungeonWallElements <> DStruct.EmptyDungeonElementSet THEN
          INCL (location.elements,DStruct.plFLAG);
        ELSIF ((location.artifact <> DStruct.InvalidArtifactCursor) AND (dungeon.artifacts [location.artifact].object.class >= OStruct.FirstAlwaysVisibleObject) AND (dungeon.artifacts [location.artifact].object.class <= OStruct.FinalAlwaysVisibleObject)) THEN
          INCL (location.elements,DStruct.fmFLAG);
        END; (* IF *)
      END UpdateDungeonLightInformation;
      
    BEGIN (* LightAreaAroundLocation *)
      FOR line := centerLINE - 1 TO centerLINE + 1 DO
        FOR column := centerCOLUMN - 1 TO centerCOLUMN + 1 DO
          UpdateDungeonLightInformation (dungeon,dungeon.physical [line]^ [column]);
        END; (* FOR *)
      END; (* FOR *)
    END LightAreaAroundLocation;
    
  BEGIN (* ExecuteMapAreaScrollAction *)
    MDWindow.DetermineDungeonWindowExtent (player,minX,maxX,minY,maxY,TRUE,TRUE);
    
    maxX := maxX + MRandom.IntegerRandomRangeValue (1,20);
    maxY := maxY + MRandom.IntegerRandomRangeValue (1,10);
    minX := minX - MRandom.IntegerRandomRangeValue (1,20);
    minY := minY - MRandom.IntegerRandomRangeValue (1,10);
    
    FOR line := minY TO maxY DO
      FOR column := minX TO maxX DO
        IF (DSActions.LocationInBounds (player^.dungeon^,line,column) AND (player^.dungeon^.physical [line]^ [column].elements * DStruct.DungeonFloorElements <> DStruct.EmptyDungeonElementSet)) THEN
          LightAreaAroundLocation (player^.dungeon^,line,column);
        END; (* IF *)
      END; (* IF *)
    END; (* FOR *)
    
    MDPainting.InvalidateDungeonWindow (player);
  END ExecuteMapAreaScrollAction;
  
  PROCEDURE ExecuteMassGenocideScrollAction (player : MStruct.PlayerInfoPointer);
    VAR
        index : CARDINAL;
    
    PROCEDURE KillCreatureAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    BEGIN (* KillCreatureAtLocation *)
      DSActions.DeleteCreatureAtLocation (player^.dungeon^,line,column);
      MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
    END KillCreatureAtLocation;
    
  BEGIN (* ExecuteMassGenocideScrollAction *)
    FOR index := 0 TO DStruct.MaxDungeonCreatures - 1 DO
      IF ((player^.dungeon^.creatures [index].cursor <> CStruct.InvalidCreatureCursor) AND (player^.dungeon^.creatures [index].distance <= MCStruct.MaxCharacterSightDistance) AND NOT (player^.creatures^.table [player^.dungeon^.creatures [index].cursor].balrog)) THEN
        KillCreatureAtLocation (player,player^.dungeon^.creatures [index].line,player^.dungeon^.creatures [index].column);
      END; (* IF *)
    END; (* FOR *)
  END ExecuteMassGenocideScrollAction;
  
  PROCEDURE ExecuteTrapDoorDestructionAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
    
    PROCEDURE DestroyTrapsAndDoors (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR artifact : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
      CONST
            DoorsAndTraps = OStruct.ObjectClassSet {OStruct.InvisibleTrap,OStruct.VisibleTrap,OStruct.OpenDoor,OStruct.ClosedDoor,OStruct.SecretDoor};
      
    BEGIN (* DestroyTrapsAndDoors *)
      IF artifact.object.class IN DoorsAndTraps THEN
        DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
        
        identified := TRUE;
      ELSIF artifact.object.class = OStruct.Chest THEN
        artifact.object.attributes := artifact.object.attributes - OStruct.ObjectAttributeFlags {OStruct.ChestLocked,OStruct.ChestTrapped};
        artifact.special           := OStruct.NameUnlocked;
        identified                 := TRUE;
        
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You have disarmed the chest.");
        OSActions.IdentifyObjectAsKnown2 (player^.treasures,artifact);
      END; (* IF *)
    END DestroyTrapsAndDoors;
    
  BEGIN (* ExecuteTrapDoorDestructionAction *)
    identified := FALSE;
    
    FOR line := player^.character^.line - 1 TO player^.character^.line + 1 DO
      FOR column := player^.character^.column - 1 TO player^.character^.column + 1 DO
        IF player^.dungeon^.physical [line]^ [column].artifact <> DStruct.InvalidArtifactCursor THEN
          DestroyTrapsAndDoors (player,line,column,player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact],identified);
        END; (* IF *)
      END; (* FOR *)
    END; (* FOR *)
  END ExecuteTrapDoorDestructionAction;
END MScrl3.
