IMPLEMENTATION MODULE MScrolls;
  (*/WIN:A *)
  
  IMPORT MInventory,MISelect,MMWindow,MScrl2,MScrl3,MScrl4,MSpells2;
  IMPORT DSActions,MSActs2,OSActions;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT WDebugging;
  
  
  TYPE
       ScrollActionRange = [0..41];
  
  VAR
      ExecuteScrollAction : ARRAY ScrollActionRange OF PROCEDURE (MStruct.PlayerInfoPointer,VAR BOOLEAN,VAR BOOLEAN);
  
  
  PROCEDURE ExecuteReadScrollCommand (player : MStruct.PlayerInfoPointer);
    CONST
          ScrollClasses = OStruct.ObjectClassSet {OStruct.Scroll1,OStruct.Scroll2};
    
    PROCEDURE SelectAndExecuteScroll (player : MStruct.PlayerInfoPointer);
      VAR
          position : CARDINAL;
      
      PROCEDURE ExecuteScrollActions (player : MStruct.PlayerInfoPointer; position : CARDINAL; scroll : OStruct.InventoryItemRecord);
        CONST
              IdentifyScrollAction = 3;
        
        TYPE
             ScrollActionFlags = SET OF ScrollActionRange;
        
        VAR
            identified : BOOLEAN;
            executed   : BOOLEAN;
            deleted    : BOOLEAN;
            index      : ScrollActionRange;
            flags      : ScrollActionFlags;
        
        PROCEDURE DetermineIdentifyScrollPosition (VAR inventory : ARRAY OF OStruct.InventoryItemRecord; VAR position : CARDINAL);
          PROCEDURE IsIdentifyScroll (item : OStruct.InventoryItemRecord) : BOOLEAN;
            VAR
                flags : ScrollActionFlags;
            
          BEGIN (* IsIdentifyScroll *)
            IF item.object.class = OStruct.Scroll1 THEN
              DetermineScrollFlags (item,flags);
              RETURN (IdentifyScrollAction IN flags);
            ELSE
              RETURN (FALSE);
            END; (* IF *)
          END IsIdentifyScroll;
          
        BEGIN (* DetermineIdentifyScrollPosition *)
          WHILE NOT (IsIdentifyScroll (inventory [position])) DO
            DEC (position);
          END; (* WHILE *)
        END DetermineIdentifyScrollPosition;
        
        PROCEDURE DetermineScrollFlags (scroll : OStruct.InventoryItemRecord; VAR result : ScrollActionFlags);
          VAR
              index : CARDINAL;
          
        BEGIN (* DetermineScrollFlags *)
          result := ScrollActionFlags {};
          
          FOR index := 0 TO 31 DO
            IF VAL (OStruct.ObjectAttributeMnemonic,index) IN scroll.object.attributes THEN
              IF scroll.object.class = OStruct.Scroll2 THEN
                INCL (result,index + 32);
              ELSE
                INCL (result,index);
              END; (* IF *)
            END; (* IF *)
          END; (* FOR *)
        END DetermineScrollFlags;
        
      BEGIN (* ExecuteScrollActions *)
        DetermineScrollFlags (scroll,flags);
        
        identified := FALSE;
        executed   := TRUE;
        
        FOR index := MIN (ScrollActionRange) TO MAX (ScrollActionRange) DO
          IF index IN flags THEN
            ExecuteScrollAction [index] (player,identified,executed);
            
            IF (executed AND (index = IdentifyScrollAction)) THEN
              DetermineIdentifyScrollPosition (player^.character^.inventory.backpack,position);
            END; (* IF *)
          END; (* IF *)
        END; (* FOR *)
        
        IF executed THEN
          IF NOT (OSActions.InventoryItemIsKnown1 (player^.treasures,scroll)) THEN
            IF identified THEN
              MSpells2.IdentifyPlayerInventoryItem (player,position);
              MSActs2.IncreasePlayerExperience (player,FLOAT (scroll.object.depth + VAL (CARDINAL,player^.character^.variables.level DIV 2)) / FLOAT (player^.character^.variables.level));
            ELSE
              OSActions.SampleInventoryItem (player^.treasures,scroll);
            END; (* IF *)
          END; (* IF *)
          
          OSActions.DescribeRemainingObjectQuantity (player,player^.character^.inventory.backpack [position]);
          MInventory.DecrementInventoryItemQuantity (player,position,deleted);
        END; (* IF *)
      END ExecuteScrollActions;
      
    BEGIN (* SelectAndExecuteScroll *)
      MISelect.SelectInventoryItem (player,"Read which scroll?",ScrollClasses,position,MStruct.CharacterTurnExecuted);
      
      IF MStruct.CharacterTurnExecuted THEN
        ExecuteScrollActions (player,position,player^.character^.inventory.backpack [position]);
      END; (* IF *)
    END SelectAndExecuteScroll;
    
  BEGIN (* ExecuteReadScrollCommand *)
    MStruct.CharacterTurnExecuted := FALSE;
    
    IF player^.character^.variables.counters [MCStruct.BlindCOUNT] > 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You can't see to read a scroll.");
    ELSIF NOT (DSActions.PlayerHasLight (player)) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You have no light to read by.");
    ELSIF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are too confused to read a scroll.");
    ELSIF NOT (MInventory.AnyObjectsWithClasses (player^.character^.inventory.backpack,ScrollClasses)) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are not carrying any scrolls!");
    ELSE
      SelectAndExecuteScroll (player);
    END; (* IF *)
  END ExecuteReadScrollCommand;
  
  PROCEDURE InitializeExecuteScrollActionTable;
    VAR
        index : ScrollActionRange;
    
  BEGIN (* InitializeExecuteScrollActionTable *)
    FOR index := MIN (ScrollActionRange) TO MAX (ScrollActionRange) DO
      ExecuteScrollAction [index] := InvalidScrollAction;
    END; (* FOR *)
    
    ExecuteScrollAction [ 0] := MScrl4.ExecuteEnchantWeaponToHitScroll;
    ExecuteScrollAction [ 1] := MScrl4.ExecuteEnchantWeaponToDamScroll;
    ExecuteScrollAction [ 2] := MScrl4.ExecuteEnchantArmorScroll;
    ExecuteScrollAction [ 3] := MScrl2.ExecuteIdentifyScroll;
    ExecuteScrollAction [ 4] := MScrl4.ExecuteRemoveCurseScroll;
    ExecuteScrollAction [ 5] := MScrl3.ExecuteLightScroll;
    ExecuteScrollAction [ 6] := MScrl3.ExecuteSummonMonsterScroll;
    ExecuteScrollAction [ 7] := MScrl2.ExecutePhaseDoorScroll;
    ExecuteScrollAction [ 8] := MScrl2.ExecuteTeleportScroll;
    ExecuteScrollAction [ 9] := MScrl2.ExecuteTeleportLevelScroll;
    ExecuteScrollAction [10] := MScrl2.ExecuteMonsterConfusionScroll;
    ExecuteScrollAction [11] := MScrl3.ExecuteMagicMappingScroll;
    ExecuteScrollAction [12] := MScrl3.ExecuteSleepMonsterScroll;
    ExecuteScrollAction [13] := MScrl2.ExecuteRuneOfProtectionScroll;
    ExecuteScrollAction [14] := MScrl3.ExecuteTreasureDetectionScroll;
    ExecuteScrollAction [15] := MScrl3.ExecuteObjectDetectionScroll;
    ExecuteScrollAction [16] := MScrl3.ExecuteTrapDetectionScroll;
    ExecuteScrollAction [17] := MScrl3.ExecuteDoorStairLocationScroll;
    ExecuteScrollAction [18] := MScrl3.ExecuteMassGenocideScroll;
    ExecuteScrollAction [19] := MScrl3.ExecuteDetectInvisibleScroll;
    ExecuteScrollAction [20] := MScrl3.ExecuteAggravateMonsterScroll;
    ExecuteScrollAction [21] := MScrl3.ExecuteTrapCreationScroll;
    ExecuteScrollAction [22] := MScrl3.ExecuteTrapDoorDestructionScroll;
    ExecuteScrollAction [23] := MScrl3.ExecuteDoorCreationScroll;
    ExecuteScrollAction [24] := MScrl2.ExecuteRechargingScroll;
    ExecuteScrollAction [25] := MScrl3.ExecuteGenocideScroll;
    ExecuteScrollAction [26] := MScrl3.ExecuteDarknessScroll;
    ExecuteScrollAction [27] := MScrl2.ExecuteProtectionFromEvilScroll;
    ExecuteScrollAction [28] := MScrl2.ExecuteCreateFoodScroll;
    ExecuteScrollAction [29] := MScrl3.ExecuteDispelUndeadScroll;
    ExecuteScrollAction [32] := MScrl4.ExecuteEnchantWeaponScroll;
    ExecuteScrollAction [33] := MScrl4.ExecuteCurseWeaponScroll;
    ExecuteScrollAction [34] := MScrl4.ExecuteEnchantArmor2Scroll;
    ExecuteScrollAction [35] := MScrl4.ExecuteCurseArmorScroll;
    ExecuteScrollAction [36] := MScrl3.ExecuteSummonUndeadScroll;
    ExecuteScrollAction [37] := MScrl2.ExecuteBlessingScroll;
    ExecuteScrollAction [38] := MScrl2.ExecuteHolyChantScroll;
    ExecuteScrollAction [39] := MScrl2.ExecuteHolyPrayerScroll;
    ExecuteScrollAction [40] := MScrl2.ExecuteWordOfRecallScroll;
    ExecuteScrollAction [41] := MScrl3.ExecuteDestructionScroll;
  END InitializeExecuteScrollActionTable;
  
  PROCEDURE InvalidScrollAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN; VAR executed : BOOLEAN);
  BEGIN (* InvalidScrollAction *)
    WDebugging.FatalAppExit ("Attempt to use un-initialize scroll.");
  END InvalidScrollAction;
  
BEGIN (* MScrolls *)
  InitializeExecuteScrollActionTable;
END MScrolls.
