IMPLEMENTATION MODULE MSpells;
  (*/WIN:A*)
  
  IMPORT MCreatures,MDPainting,MDWindow,MMWindow,MPAttk2,MRandom,MSight,MSpells2;
  IMPORT CStruct,DStruct,MCStruct,MStruct,OStruct;
  IMPORT OSActions;
  
  
  PROCEDURE AggravateCreatures (player : MStruct.PlayerInfoPointer; distance : CARDINAL; VAR done : BOOLEAN);
    VAR
        index : CARDINAL;
    
    PROCEDURE AggravateCreature (VAR creature : DStruct.DungeonCreatureRecord; distance : CARDINAL; VAR done : BOOLEAN);
    BEGIN (* AggravateCreature *)
      creature.sleep := 0;
      
      IF ((creature.distance <= distance) AND (creature.speed < 2)) THEN
        creature.speed := creature.speed + 1;
        done           := TRUE;
      END; (* IF *)
    END AggravateCreature;
    
  BEGIN (* AggravateCreatures *)
    done := FALSE;
    
    FOR index := 0 TO DStruct.MaxDungeonCreatures - 1 DO
      IF player^.dungeon^.creatures [index].cursor <> CStruct.InvalidCreatureCursor THEN
        AggravateCreature (player^.dungeon^.creatures [index],distance,done);
      END; (* IF *)
    END; (* FOR *)
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You hear a sudden stirring in the distance!");
    END; (* IF *)
  END AggravateCreatures;
  
  PROCEDURE AlterVisibleCreaturesSpeed (player : MStruct.PlayerInfoPointer; change : INTEGER; VAR done : BOOLEAN);
    VAR
        index : CARDINAL;
    
  BEGIN (* AlterVisibleCreaturesSpeed *)
    done := FALSE;
    
    FOR index := 0 TO DStruct.MaxDungeonCreatures - 1 DO
      IF ((player^.dungeon^.creatures [index].cursor <> CStruct.InvalidCreatureCursor) AND (player^.dungeon^.creatures [index].distance <= MCStruct.MaxCharacterSightDistance) AND MSight.ClearLineOfSight (player,player^.character^.line,player^.character^.column,player^.dungeon^.creatures [index].line,player^.dungeon^.creatures [index].column)) THEN
        MSpells2.AttemptCreatureSpeedChange (player,player^.dungeon^.creatures [index],player^.creatures^.table [player^.dungeon^.creatures [index].cursor],change);
        done := TRUE;
      END; (* IF *)
    END; (* FOR *)
  END AlterVisibleCreaturesSpeed;
  
  PROCEDURE DetectEvilCreatures (player : MStruct.PlayerInfoPointer; VAR detected : BOOLEAN);
    PROCEDURE ShowAnyEvilCreatures (player : MStruct.PlayerInfoPointer; VAR detected : BOOLEAN);
      VAR
          index : [0..DStruct.MaxDungeonCreatures - 1];
      
      PROCEDURE ShouldShowCreature (player : MStruct.PlayerInfoPointer; creature : DStruct.DungeonCreatureRecord) : BOOLEAN;
      BEGIN (* ShouldShowCreature *)
        RETURN ((CStruct.HurtBySlayEvil IN player^.creatures^.table [creature.cursor].defense) AND MDWindow.LocationIsInWindow (player,creature.line,creature.column));
      END ShouldShowCreature;
      
    BEGIN (* ShowAnyEvilCreatures *)
      detected := FALSE;
      
      FOR index := 0 TO DStruct.MaxDungeonCreatures - 1 DO
        IF ((player^.dungeon^.creatures [index].cursor <> CStruct.InvalidCreatureCursor) AND ShouldShowCreature (player,player^.dungeon^.creatures [index])) THEN
          player^.dungeon^.creatures [index].visible := TRUE;
          detected                                   := TRUE;
          
          MDPainting.InvalidateDungeonLocation (player,player^.dungeon^.creatures [index].line,player^.dungeon^.creatures [index].column,FALSE,TRUE);
        END; (* IF *)
      END; (* FOR *)
    END ShowAnyEvilCreatures;
    
  BEGIN (* DetectEvilCreatures *)
    ShowAnyEvilCreatures (player,detected);
    
    IF detected THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You sense the presence of evil!");
      MCreatures.ComputeCreatureVisibility (player,TRUE);
    END; (* IF *)
  END DetectEvilCreatures;
  
  PROCEDURE DetectHiddenDoors (player : MStruct.PlayerInfoPointer; VAR detected : BOOLEAN; redraw : BOOLEAN);
    VAR
        column,minX,maxX : DStruct.DungeonColumnRange;
        line,minY,maxY   : DStruct.DungeonLineRange;
    
    PROCEDURE DisplayHiddenDoorsAndStairs (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR item : OStruct.InventoryItemRecord; VAR detected : BOOLEAN);
    BEGIN (* DisplayHiddenDoorsAndStairs *)
      IF ((item.object.class = OStruct.DownStair) OR (item.object.class = OStruct.UpStair)) THEN
        INCL (player^.dungeon^.physical [line]^ [column].elements,DStruct.fmFLAG);
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
        
        detected := TRUE;
      ELSIF item.object.class = OStruct.SecretDoor THEN
        INCL (player^.dungeon^.physical [line]^ [column].elements,DStruct.fmFLAG);
        
        item.object.symbol := player^.treasures^.table [OStruct.ClosedDoorObjectCursor].symbol;
        item.object.class  := player^.treasures^.table [OStruct.ClosedDoorObjectCursor].class;
        item.cursor        := OStruct.ClosedDoorObjectCursor;
        detected           := TRUE;
        
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
      END; (* IF *)
    END DisplayHiddenDoorsAndStairs;
    
  BEGIN (* DetectHiddenDoors *)
    MDWindow.DetermineDungeonWindowExtent (player,minX,maxX,minY,maxY,TRUE,redraw);
    
    detected := FALSE;
    
    FOR line := minY TO maxY DO
      FOR column := minX TO maxX DO
        IF player^.dungeon^.physical [line]^ [column].artifact <> DStruct.InvalidArtifactCursor THEN
          DisplayHiddenDoorsAndStairs (player,line,column,player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact],detected);
        END; (* IF *)
      END; (* FOR *)
    END; (* FOR *)
  END DetectHiddenDoors;
  
  PROCEDURE DetectHiddenTraps (player : MStruct.PlayerInfoPointer; VAR detected : BOOLEAN; redraw : BOOLEAN);
    VAR
        column,minX,maxX : DStruct.DungeonColumnRange;
        line,minY,maxY   : DStruct.DungeonLineRange;
    
    PROCEDURE DisplayHiddenTraps (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR item : OStruct.InventoryItemRecord; VAR detected : BOOLEAN);
    BEGIN (* DisplayHiddenTraps *)
      IF item.object.class = OStruct.InvisibleTrap THEN
        INCL (player^.dungeon^.physical [line]^ [column].elements,DStruct.fmFLAG);
        
        item.object.class := OStruct.VisibleTrap;
        detected          := TRUE;
        
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
      ELSIF item.object.class = OStruct.Chest THEN
        OSActions.IdentifyObjectAsKnown2 (player^.treasures,item);
      END; (* IF *)
    END DisplayHiddenTraps;
    
  BEGIN (* DetectHiddenTraps *)
    MDWindow.DetermineDungeonWindowExtent (player,minX,maxX,minY,maxY,TRUE,redraw);
    
    detected := FALSE;
    
    FOR line := minY TO maxY DO
      FOR column := minX TO maxX DO
        IF player^.dungeon^.physical [line]^ [column].artifact <> DStruct.InvalidArtifactCursor THEN
          DisplayHiddenTraps (player,line,column,player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact],detected);
        END; (* IF *)
      END; (* FOR *)
    END; (* FOR *)
  END DetectHiddenTraps;
  
  PROCEDURE DetectMonsters (player : MStruct.PlayerInfoPointer; VAR detected : BOOLEAN);
    PROCEDURE ShowAnyMonsters (player : MStruct.PlayerInfoPointer; VAR detected : BOOLEAN);
      VAR
          index : [0..DStruct.MaxDungeonCreatures - 1];
      
      PROCEDURE ShouldShowCreature (player : MStruct.PlayerInfoPointer; creature : DStruct.DungeonCreatureRecord) : BOOLEAN;
      BEGIN (* ShouldShowCreature *)
        RETURN (NOT (CStruct.MoveInvisible IN player^.creatures^.table [creature.cursor].movement) AND MDWindow.LocationIsInWindow (player,creature.line,creature.column));
      END ShouldShowCreature;
      
    BEGIN (* ShowAnyMonsters *)
      detected := FALSE;
      
      FOR index := 0 TO DStruct.MaxDungeonCreatures - 1 DO
        IF ((player^.dungeon^.creatures [index].cursor <> CStruct.InvalidCreatureCursor) AND ShouldShowCreature (player,player^.dungeon^.creatures [index])) THEN
          player^.dungeon^.creatures [index].visible := TRUE;
          detected                                   := TRUE;
          
          MDPainting.InvalidateDungeonLocation (player,player^.dungeon^.creatures [index].line,player^.dungeon^.creatures [index].column,FALSE,TRUE);
        END; (* IF *)
      END; (* FOR *)
    END ShowAnyMonsters;
    
  BEGIN (* DetectMonsters *)
    ShowAnyMonsters (player,detected);
    
    IF detected THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You sense the presence of monsters!");
      MCreatures.ComputeCreatureVisibility (player,TRUE);
    END; (* IF *)
  END DetectMonsters;
  
  PROCEDURE DispelCreatures (player : MStruct.PlayerInfoPointer; class : CStruct.CreatureDefenseMnemonic; damage : CARDINAL; VAR done : BOOLEAN);
    VAR
        index : CARDINAL;
    
    PROCEDURE DisolveCreature (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; damage : CARDINAL; class : CStruct.CreatureDefenseMnemonic);
    BEGIN (* DisolveCreature *)
      MPAttk2.DamageCreature (creature,MRandom.CardinalRandomRangeValue (1,damage));
      
      IF creature.hitpoints > 0 THEN
        MMWindow.DisplayCreatureMessage (player,"The %CREATURE shudders.",player^.creatures^.table [creature.cursor].description,creature.visible,TRUE);
      ELSE
        MMWindow.DisplayCreatureMessage (player,"The %CREATURE disolves.",player^.creatures^.table [creature.cursor].description,creature.visible,TRUE);
        MPAttk2.KillCreatureAtLocation (player,creature.line,creature.column,player^.creatures^.table [creature.cursor],creature.visible,TRUE);
      END; (* IF *)
      
      INCL (player^.creatures^.table [creature.cursor].memory.defense,class);
    END DisolveCreature;
    
    PROCEDURE ShouldDisolveCreature (player : MStruct.PlayerInfoPointer; creature : DStruct.DungeonCreatureRecord; class : CStruct.CreatureDefenseMnemonic) : BOOLEAN;
    BEGIN (* ShouldDisolveCreature *)
      RETURN ((creature.distance < MCStruct.MaxCharacterSightDistance) AND (class IN player^.creatures^.table [creature.cursor].defense) AND MSight.ClearLineOfSight (player,player^.character^.line,player^.character^.column,creature.line,creature.column));
    END ShouldDisolveCreature;
    
  BEGIN (* DispelCreatures *)
    done := FALSE;
    
    FOR index := 0 TO DStruct.MaxDungeonCreatures - 1 DO
      IF ((player^.dungeon^.creatures [index].cursor <> CStruct.InvalidCreatureCursor) AND ShouldDisolveCreature (player,player^.dungeon^.creatures [index],class)) THEN
        DisolveCreature (player,player^.dungeon^.creatures [index],damage,class);
        done := TRUE;
      END; (* IF *)
    END; (* FOR *)
  END DispelCreatures;
  
  PROCEDURE ExecuteDetectInvisibleAction (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
    PROCEDURE ShowAnyInvisibleCreatures (player : MStruct.PlayerInfoPointer; VAR detected : BOOLEAN);
      VAR
          index : [0..DStruct.MaxDungeonCreatures - 1];
      
      PROCEDURE ShouldShowCreature (player : MStruct.PlayerInfoPointer; creature : DStruct.DungeonCreatureRecord) : BOOLEAN;
      BEGIN (* ShouldShowCreature *)
        RETURN ((CStruct.MoveInvisible IN player^.creatures^.table [creature.cursor].movement) AND MDWindow.LocationIsInWindow (player,creature.line,creature.column));
      END ShouldShowCreature;
      
    BEGIN (* ShowAnyInvisibleCreatures *)
      detected := FALSE;
      
      FOR index := 0 TO DStruct.MaxDungeonCreatures - 1 DO
        IF ((player^.dungeon^.creatures [index].cursor <> CStruct.InvalidCreatureCursor) AND ShouldShowCreature (player,player^.dungeon^.creatures [index])) THEN
          player^.dungeon^.creatures [index].visible := TRUE;
          detected                                   := TRUE;
          
          MDPainting.InvalidateDungeonLocation (player,player^.dungeon^.creatures [index].line,player^.dungeon^.creatures [index].column,FALSE,TRUE);
        END; (* IF *)
      END; (* FOR *)
    END ShowAnyInvisibleCreatures;
    
  BEGIN (* ExecuteDetectInvisibleAction *)
    ShowAnyInvisibleCreatures (player,done);
    
    IF done THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You sense the presence of invisible creatures!");
      MCreatures.ComputeCreatureVisibility (player,TRUE);
    END; (* IF *)
  END ExecuteDetectInvisibleAction;
  
  PROCEDURE ExecuteProtectionFromEvilSpell (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
  BEGIN (* ExecuteProtectionFromEvilSpell *)
    done := (player^.character^.variables.counters [MCStruct.ProtEvilCOUNT] = 0);
    INC (player^.character^.variables.counters [MCStruct.ProtEvilCOUNT],3 * player^.character^.variables.level + MRandom.IntegerRandomRangeValue (1,25));
  END ExecuteProtectionFromEvilSpell;
  
  PROCEDURE SleepAdjacentCreatures (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
    VAR
        column : DStruct.DungeonColumnRange;
        asleep : BOOLEAN;
        line   : DStruct.DungeonLineRange;
    
  BEGIN (* SleepAdjacentCreatures *)
    done := FALSE;
    
    FOR line := player^.character^.line - 1 TO player^.character^.line + 1 DO
      FOR column := player^.character^.column - 1 TO player^.character^.column + 1 DO
        IF player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor THEN
          MSpells2.AttemptCreatureSleep (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],player^.creatures^.table [player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].cursor],asleep);
          done := (done OR asleep);
        END; (* IF *)
      END; (* FOR *)
    END; (* FOR *)
  END SleepAdjacentCreatures;
  
  PROCEDURE SleepAllVisibleCreatures (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
    VAR
        index : [0..DStruct.MaxDungeonCreatures - 1];
        sleep : BOOLEAN;
    
  BEGIN (* SleepAllVisibleCreatures *)
    done := FALSE;
    
    FOR index := 0 TO DStruct.MaxDungeonCreatures - 1 DO
      IF ((player^.dungeon^.creatures [index].cursor <> CStruct.InvalidCreatureCursor) AND (player^.dungeon^.creatures [index].distance <= MCStruct.MaxCharacterSightDistance) AND MSight.ClearLineOfSight (player,player^.character^.line,player^.character^.column,player^.dungeon^.creatures [index].line,player^.dungeon^.creatures [index].column)) THEN
        MSpells2.AttemptCreatureSleep (player,player^.dungeon^.creatures [index],player^.creatures^.table [player^.dungeon^.creatures [index].cursor],sleep);
        done := (done OR sleep);
      END; (* IF *)
    END; (* FOR *)
  END SleepAllVisibleCreatures;
  
  PROCEDURE TurnUndeadCreatures (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
    VAR
        index : CARDINAL;
    
    PROCEDURE AttemptToTurnUndeadCreature (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; VAR done : BOOLEAN);
    BEGIN (* AttemptToTurnUndeadCreature *)
      IF ((VAL (CARDINAL,player^.character^.variables.level + 1) > player^.creatures^.table [creature.cursor].depth) OR (MRandom.CardinalRandomRangeValue (1,5) = 1)) THEN
        IF creature.visible THEN
          MMWindow.DisplayCreatureMessage (player,"The %CREATURE runs frantically!",player^.creatures^.table [creature.cursor].description,creature.visible,TRUE);
          INCL (player^.creatures^.table [creature.cursor].memory.defense,CStruct.HurtBySlayUndead);
          done := TRUE;
        END; (* IF *)
        
        creature.confused := TRUE;
      ELSIF creature.visible THEN
        MMWindow.DisplayCreatureMessage (player,"The %CREATURE is unaffected.",player^.creatures^.table [creature.cursor].description,creature.visible,TRUE);
      END; (* IF *)
    END AttemptToTurnUndeadCreature;
    
    PROCEDURE ShouldAttemptToTurnUndead (player : MStruct.PlayerInfoPointer; creature : DStruct.DungeonCreatureRecord) : BOOLEAN;
    BEGIN (* ShouldAttemptToTurnUndead *)
      RETURN ((creature.distance <= MCStruct.MaxCharacterSightDistance) AND (CStruct.HurtBySlayUndead IN player^.creatures^.table [creature.cursor].defense) AND MSight.ClearLineOfSight (player,player^.character^.line,player^.character^.column,creature.line,creature.column));
    END ShouldAttemptToTurnUndead;
    
  BEGIN (* TurnUndeadCreatures *)
    done := FALSE;
    
    FOR index := 0 TO DStruct.MaxDungeonCreatures - 1 DO
      IF ((player^.dungeon^.creatures [index].cursor <> CStruct.InvalidCreatureCursor) AND ShouldAttemptToTurnUndead (player,player^.dungeon^.creatures [index])) THEN
        AttemptToTurnUndeadCreature (player,player^.dungeon^.creatures [index],done);
      END; (* IF *)
    END; (* FOR *)
  END TurnUndeadCreatures;
END MSpells.
