IMPLEMENTATION MODULE MSpells2;
  (*/WIN:A*)
  
  IMPORT MBolts,MCMove2,MCSpells,MMWindow,MRandom,MSUpdate;
  IMPORT CStruct,DStruct,MCStruct,MStruct,OStruct;
  IMPORT DSActions,MCSActions,MSActs2,OSActions;
  IMPORT WMacro;
  
  
  PROCEDURE AttemptCreatureSleep (player : MStruct.PlayerInfoPointer; VAR creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord; VAR done : BOOLEAN);
  BEGIN (* AttemptCreatureSleep *)
    done := FALSE;
    
    IF ((CStruct.ResistCharms IN creaturePASSIVE.defense) OR (MRandom.CardinalRandomRangeValue (1,CStruct.MaxCreatureDepth) < creaturePASSIVE.depth)) THEN
      IF CStruct.ResistCharms IN creaturePASSIVE.defense THEN
        IF creatureACTIVE.visible THEN
          INCL (creaturePASSIVE.memory.defense,CStruct.ResistCharms);
        END; (* IF *)
      END; (* IF *)
      
      MMWindow.DisplayCreatureMessage (player,"The %CREATURE is unaffected.",creaturePASSIVE.description,creatureACTIVE.visible,TRUE);
    ELSE
      MMWindow.DisplayCreatureMessage (player,"The %CREATURE falls asleep.",creaturePASSIVE.description,creatureACTIVE.visible,TRUE);
      
      creatureACTIVE.sleep := 500;
      done                 := TRUE;
    END; (* IF *)
  END AttemptCreatureSleep;
  
  PROCEDURE AttemptCreatureSpeedChange (player : MStruct.PlayerInfoPointer; VAR creatureACTIVE : DStruct.DungeonCreatureRecord; VAR creaturePASSIVE : CStruct.PassiveCreatureInfoRecord; change : INTEGER);
  BEGIN (* AttemptCreatureSpeedChange *)
    IF change > 0 THEN
      MMWindow.DisplayCreatureMessage (player,"The %CREATURE starts moving faster.",creaturePASSIVE.description,creatureACTIVE.visible,TRUE);
      creatureACTIVE.speed := creatureACTIVE.speed + change;
    ELSIF MRandom.CardinalRandomRangeValue (1,CStruct.MaxCreatureDepth) > creaturePASSIVE.depth THEN
      MMWindow.DisplayCreatureMessage (player,"The %CREATURE starts moving slower.",creaturePASSIVE.description,creatureACTIVE.visible,TRUE);
      creatureACTIVE.speed := creatureACTIVE.speed + change;
    ELSE
      MMWindow.DisplayCreatureMessage (player,"The %CREATURE is unaffected.",creaturePASSIVE.description,creatureACTIVE.visible,TRUE);
    END; (* IF *)
    
    creatureACTIVE.sleep := 0;
  END AttemptCreatureSpeedChange;
  
  PROCEDURE CureBlindness (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
  BEGIN (* CureBlindness *)
    done := (player^.character^.variables.counters [MCStruct.BlindCOUNT] > 1);
    
    IF done THEN
      player^.character^.variables.counters [MCStruct.BlindCOUNT] := 1;
    END; (* IF *)
  END CureBlindness;
  
  PROCEDURE CureConfusion (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
  BEGIN (* CureConfusion *)
    done := (player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 1);
    
    IF done THEN
      player^.character^.variables.counters [MCStruct.ConfusedCOUNT] := 1;
    END; (* IF *)
  END CureConfusion;
  
  PROCEDURE CureFear (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
  BEGIN (* CureFear *)
    done := (player^.character^.variables.counters [MCStruct.AfraidCOUNT] > 1);
    
    IF done THEN
      player^.character^.variables.counters [MCStruct.AfraidCOUNT] := 1;
    END; (* IF *)
  END CureFear;
  
  PROCEDURE CurePoison (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
  BEGIN (* CurePoison *)
    done := (player^.character^.variables.counters [MCStruct.PoisonedCOUNT] > 1);
    
    IF done THEN
      player^.character^.variables.counters [MCStruct.PoisonedCOUNT] := 1;
    END; (* IF *)
  END CurePoison;
  
  PROCEDURE DecreasePlayerCharisma (player : MStruct.PlayerInfoPointer);
  BEGIN (* DecreasePlayerCharisma *)
    IF MCStruct.SustainChrFLAG IN player^.character^.variables.status THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Your skin starts to itch, but it feels better now.");
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Your skin starts to itch.");
      MSActs2.DecrementStatistic (player,MCStruct.chr);
    END; (* IF *)
  END DecreasePlayerCharisma;
  
  PROCEDURE DecreasePlayerConstitution (player : MStruct.PlayerInfoPointer);
  BEGIN (* DecreasePlayerConstitution *)
    IF MCStruct.SustainConFLAG IN player^.character^.variables.status THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel sick for a moment, it passes.");
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel very sick.");
      MSActs2.DecrementStatistic (player,MCStruct.con);
    END; (* IF *)
  END DecreasePlayerConstitution;
  
  PROCEDURE DecreasePlayerIntelligence (player : MStruct.PlayerInfoPointer);
  BEGIN (* DecreasePlayerIntelligence *)
    IF MCStruct.SustainIntFLAG IN player^.character^.variables.status THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel dizzy for a moment, it passes.");
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You become very dizzy.");
      MSActs2.DecrementStatistic (player,MCStruct.int);
    END; (* IF *)
  END DecreasePlayerIntelligence;
  
  PROCEDURE DecreasePlayerStrength (player : MStruct.PlayerInfoPointer);
  BEGIN (* DecreasePlayerStrength *)
    IF MCStruct.SustainStrFLAG IN player^.character^.variables.status THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel sick for a moment, it passes.");
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel very sick.");
      MSActs2.DecrementStatistic (player,MCStruct.str);
    END; (* IF *)
  END DecreasePlayerStrength;
  
  PROCEDURE DecreasePlayerWisdom (player : MStruct.PlayerInfoPointer);
  BEGIN (* DecreasePlayerWisdom *)
    IF MCStruct.SustainWisFLAG IN player^.character^.variables.status THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel naive for a moment, it passes.");
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel very naive.");
      MSActs2.DecrementStatistic (player,MCStruct.wis);
    END; (* IF *)
  END DecreasePlayerWisdom;
  
  PROCEDURE IdentifyPlayerInventoryItem (player : MStruct.PlayerInfoPointer; VAR position : CARDINAL);
    PROCEDURE MergeSimilarInventoryItems (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR position : CARDINAL);
      VAR
          index : CARDINAL;
      
      PROCEDURE ItemsShouldBeMerged (item1,item2 : OStruct.InventoryItemRecord) : BOOLEAN;
      BEGIN (* ItemsShouldBeMerged *)
        RETURN ((item1.object.class = item2.object.class) AND (item1.object.subclass = item2.object.subclass) AND (item1.object.quantity + item2.object.quantity < 256));
      END ItemsShouldBeMerged;
      
      PROCEDURE MergeInventoryItems (player : MStruct.PlayerInfoPointer; position1,position2 : CARDINAL; VAR result : CARDINAL);
        PROCEDURE ShiftInventoryItemsLeft (treasures : OStruct.TreasureInfoPointer; VAR inventory : ARRAY OF OStruct.InventoryItemRecord; VAR counter : CARDINAL; position : CARDINAL);
          VAR
              index : CARDINAL;
          
        BEGIN (* ShiftInventoryItemsLeft *)
          FOR index := position + 1 TO counter - 1 DO
            inventory [index - 1] := inventory [index];
          END; (* FOR *)
          
          OSActions.ReturnInventoryItemRecord (treasures,OStruct.EmptyObjectCursor,inventory [counter - 1]);
          DEC (counter);
        END ShiftInventoryItemsLeft;
        
        PROCEDURE SwapCardinalValues (VAR value1,value2 : CARDINAL);
          VAR
              temp : CARDINAL;
          
        BEGIN (* SwapCardinalValues *)
          temp   := value1;
          value1 := value2;
          value2 := temp;
        END SwapCardinalValues;
        
      BEGIN (* MergeInventoryItems *)
        MMWindow.AddMessageToList (player,"You merge similar objects from the shop and dungeon.");
        
        IF position1 > position2 THEN
          SwapCardinalValues (position1,position2);
        END; (* IF *)
        
        INC (player^.character^.inventory.backpack [position1].object.quantity,player^.character^.inventory.backpack [position2].object.quantity);
        ShiftInventoryItemsLeft (player^.treasures,player^.character^.inventory.backpack,player^.character^.inventory.counter,position2);
        
        result := position1;
      END MergeInventoryItems;
      
    BEGIN (* MergeSimilarInventoryItems *)
      index := 0;
      
      WHILE index < player^.character^.inventory.counter DO
        IF ((index <> position) AND ItemsShouldBeMerged (player^.character^.inventory.backpack [index],item)) THEN
          MergeInventoryItems (player,index,position,position);
        END; (* IF *)
        
        INC (index);
      END; (* WHILE *)
    END MergeSimilarInventoryItems;
    
  BEGIN (* IdentifyPlayerInventoryItem *)
    IF OStruct.Cursed IN player^.character^.inventory.backpack [position].object.attributes THEN
      INCL (player^.character^.inventory.backpack [position].identification,OStruct.IdentDamaged);
    END; (* IF *)
    
    IF NOT (OSActions.InventoryItemIsKnown1 (player^.treasures,player^.character^.inventory.backpack [position])) THEN
      OSActions.IdentifyInventoryItemAsKnown1 (player^.treasures,player^.character^.inventory.backpack [position]);
      
      IF ((player^.character^.inventory.backpack [position].object.subclass >= OStruct.ObjectMinimumSingleStackSubclass) AND (player^.character^.inventory.backpack [position].object.subclass < OStruct.ObjectMinimumItemGroupSubclass)) THEN
        MergeSimilarInventoryItems (player,player^.character^.inventory.backpack [position],position);
      END; (* IF *)
    END; (* IF *)
  END IdentifyPlayerInventoryItem;
  
  PROCEDURE MagicallyHealPlayer (player : MStruct.PlayerInfoPointer; amount : CARDINAL; VAR noticed : BOOLEAN);
    PROCEDURE DisplayHealingMessage (player : MStruct.PlayerInfoPointer; amount : CARDINAL);
    BEGIN (* DisplayHealingMessage *)
      CASE amount OF
        0    : MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel a little better."); |
        1,2  : MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel better.");          |
        3..6 : MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel much better.");     |
      ELSE
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You feel very good.");
      END; (* CASE *)
    END DisplayHealingMessage;
    
  BEGIN (* MagicallyHealPlayer *)
    noticed := (player^.character^.variables.hpCUR < player^.character^.variables.hpMAX);
    
    IF noticed THEN
      player^.character^.variables.hpCUR := WMacro.MinReal (player^.character^.variables.hpCUR + FLOAT (amount),player^.character^.variables.hpMAX);
      
      MSUpdate.UpdateCurrentHitPointsWindow (player);
      DisplayHealingMessage (player,amount DIV 5);
    END; (* IF *)
  END MagicallyHealPlayer;
  
  PROCEDURE ReduceCharacterExperience (player : MStruct.PlayerInfoPointer; amount : REAL);
    PROCEDURE ExperienceForLevel (player : MStruct.PlayerInfoPointer; level : CARDINAL) : REAL;
    BEGIN (* ExperienceForLevel *)
      IF level > 1 THEN
        RETURN (LONGFLOAT (player^.character^.constants.experience [level - 1] * player^.character^.constants.factor DIV 100));
      ELSE
        RETURN (0.0);
      END; (* IF *)
    END ExperienceForLevel;
    
    PROCEDURE LevelForExperience (player : MStruct.PlayerInfoPointer; experience : REAL) : CARDINAL;
      VAR
          level : CARDINAL;
      
    BEGIN (* LevelForExperience *)
      level := 1;
      
      WHILE ExperienceForLevel (player,level) < experience DO
        INC (level);
      END; (* WHILE *)
      
      RETURN (level);
    END LevelForExperience;
    
    PROCEDURE ReduceCharacterLevel (player : MStruct.PlayerInfoPointer; level : CARDINAL);
    BEGIN (* ReduceCharacterLevel *)
      player^.character^.variables.level := level;
      
      IF player^.character^.constants.class <> MCStruct.Warrior THEN
        MCSpells.CalculatePlayerSpells (player);
        MCSpells.CalculatePlayerMana (player);
      END; (* IF *)
      
      MCSActions.CalculatePlayerHitPoints (player^.character);
      MSUpdate.UpdateCurrentLevelWindows (player);
    END ReduceCharacterLevel;
    
  BEGIN (* ReduceCharacterExperience *)
    player^.character^.variables.experCUR := player^.character^.variables.experCUR - WMacro.MinReal (amount,player^.character^.variables.experCUR);
    
    IF player^.character^.variables.experCUR < ExperienceForLevel (player,player^.character^.variables.level) THEN
      ReduceCharacterLevel (player,LevelForExperience (player,player^.character^.variables.experCUR));
    END; (* IF *)
    
    MSUpdate.UpdateCurrentExperienceWindow (player);
  END ReduceCharacterExperience;
  
  PROCEDURE SlowPoison (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
  BEGIN (* SlowPoison *)
    done := (player^.character^.variables.counters [MCStruct.PoisonedCOUNT] > 0);
    
    IF done THEN
      player^.character^.variables.counters [MCStruct.PoisonedCOUNT] := WMacro.MaxCardinal (player^.character^.variables.counters [MCStruct.PoisonedCOUNT] DIV 2,1);
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The effect of the poison has been reduced.");
    END; (* IF *)
  END SlowPoison;
  
  PROCEDURE TeleportCreatureAway (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord; distance : CARDINAL);
    VAR
        column,line : INTEGER;
        movement    : CStruct.CreatureMovementInformation;
    
    PROCEDURE DetermineNewCreatureLocation (VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; distance : INTEGER; VAR resultLINE : INTEGER; VAR resultCOLUMN : INTEGER);
      VAR
          attempts : CARDINAL;
      
      PROCEDURE ValidCreatureLocation (location : DStruct.PhysicalDungeonUnit) : BOOLEAN;
        CONST
              CreatureBlockLocation = DStruct.DungeonWallElements + DStruct.DungeonElementSet {DStruct.BlockedFloor};
        
      BEGIN (* ValidCreatureLocation *)
        RETURN ((location.elements * CreatureBlockLocation = DStruct.EmptyDungeonElementSet) AND (location.creature = DStruct.InvalidCreatureCursor));
      END ValidCreatureLocation;
      
    BEGIN (* DetermineNewCreatureLocation *)
      attempts := 0;
      
      REPEAT
        REPEAT
          resultCOLUMN := centerCOLUMN + MRandom.IntegerRandomRangeValue (1,2 * distance + 1) - (distance + 1);
          resultLINE   := centerLINE + MRandom.IntegerRandomRangeValue (1,2 * distance + 1) - (distance + 1);
        UNTIL DSActions.LocationInBounds (dungeon,resultLINE,resultCOLUMN);
        
        attempts := (attempts + 1) MOD 10;
        
        IF attempts = 0 THEN
          INC (distance,5);
        END; (* IF *)
      UNTIL ValidCreatureLocation (dungeon.physical [resultLINE]^ [resultCOLUMN]);
    END DetermineNewCreatureLocation;
    
  BEGIN (* TeleportCreatureAway *)
    DetermineNewCreatureLocation (player^.dungeon^,creature.line,creature.column,distance,line,column);
    MCMove2.MoveCreatureToLocation (player,creature,line,column,movement);
  END TeleportCreatureAway;
END MSpells2.
