IMPLEMENTATION MODULE MSpells3;
  (*/WIN:A*)
  
  IMPORT MDGAlloc,MDGDoors,MDPainting,MDWindow,MMWindow,MPAttk2,MRandom;
  IMPORT CStruct,DStruct,MCStruct,MStruct,OStruct;
  IMPORT DSActions,OSActions;
  
  
  PROCEDURE CreateGlyphOfWarding (player : MStruct.PlayerInfoPointer);
    VAR
        item : OStruct.InventoryItemRecord;
    
  BEGIN (* CreateGlyphOfWarding *)
    IF player^.dungeon^.physical [player^.character^.line]^ [player^.character^.column].artifact = DStruct.InvalidArtifactCursor THEN
      OSActions.ReturnInventoryItemRecord (player^.treasures,398,item);
      DSActions.PlaceDungeonArtifact (player^.dungeon^,player^.character^.line,player^.character^.column,item);
    END; (* IF *)
  END CreateGlyphOfWarding;
  
  PROCEDURE ExecuteDarknessAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
    PROCEDURE DarkenCorridorFloor (player : MStruct.PlayerInfoPointer; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
      VAR
          column : DStruct.DungeonColumnRange;
          line   : DStruct.DungeonLineRange;
      
      PROCEDURE DarkenCorridorLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : DStruct.PhysicalDungeonUnit; VAR done : BOOLEAN);
      BEGIN (* DarkenCorridorLocation *)
        IF location.elements * DStruct.DungeonElementSet {DStruct.CorridorFloor,DStruct.plFLAG} = DStruct.DungeonElementSet {DStruct.CorridorFloor,DStruct.plFLAG} THEN
          EXCL (location.elements,DStruct.plFLAG);
          done := TRUE;
          
          MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,FALSE);
        END; (* IF *)
      END DarkenCorridorLocation;
      
    BEGIN (* DarkenCorridorFloor *)
      done := FALSE;
      
      FOR line := centerLINE - 1 TO centerLINE + 1 DO
        FOR column := centerCOLUMN - 1 TO centerCOLUMN + 1 DO
          DarkenCorridorLocation (player,line,column,player^.dungeon^.physical [line]^ [column],done);
        END; (* FOR *)
      END; (* FOR *)
    END DarkenCorridorFloor;
    
    PROCEDURE DarkenDungeonRoom (player : MStruct.PlayerInfoPointer; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
      VAR
          column,minX,maxX : DStruct.DungeonColumnRange;
          line,minY,maxY   : DStruct.DungeonLineRange;
      
      PROCEDURE DarkenDungeonLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : DStruct.PhysicalDungeonUnit; VAR done : BOOLEAN);
      BEGIN (* DarkenDungeonLocation *)
        IF ((DStruct.lrFLAG IN location.elements) AND (location.elements * DStruct.DungeonFloorElements <> DStruct.EmptyDungeonElementSet)) THEN
          DSActions.SetDungeonLocationFVal (location,DStruct.DarkFloor);
          EXCL (location.elements,DStruct.plFLAG);
          
          done := TRUE;
          
          MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,FALSE);
        END; (* IF *)
      END DarkenDungeonLocation;
      
    BEGIN (* DarkenDungeonRoom *)
      done := FALSE;
      
      minX := (centerCOLUMN DIV DStruct.AverageRoomWidth) * DStruct.AverageRoomWidth;
      maxX := minX + DStruct.AverageRoomWidth - 1;
      
      minY := (centerLINE DIV DStruct.AverageRoomHeight) * DStruct.AverageRoomHeight;
      maxY := minY + DStruct.AverageRoomHeight - 1;
      
      FOR line := minY TO maxY DO
        FOR column := minX TO maxX DO
          DarkenDungeonLocation (player,line,column,player^.dungeon^.physical [line]^ [column],done);
        END; (* FOR *)
      END; (* FOR *)
    END DarkenDungeonRoom;
    
  BEGIN (* ExecuteDarknessAction *)
    IF ((player^.character^.variables.depthCUR > 0) AND (DStruct.lrFLAG IN player^.dungeon^.physical [line]^ [column].elements)) THEN
      DarkenDungeonRoom (player,line,column,done);
    ELSE
      DarkenCorridorFloor (player,line,column,done);
    END; (* IF *)
    
    IF (done AND (player^.character^.variables.counters [MCStruct.BlindCOUNT] = 0)) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Darkness surrounds you.");
    END; (* IF *)
  END ExecuteDarknessAction;
  
  PROCEDURE ExecuteDestructionAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    PROCEDURE DestroyAreaAroundLocation (player : MStruct.PlayerInfoPointer; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange);
      VAR
          column,line : INTEGER;
      
      PROCEDURE DestroyLocation (VAR dungeon : DStruct.DungeonInformation; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : DStruct.PhysicalDungeonUnit; class : CARDINAL);
      BEGIN (* DestroyLocation *)
        CASE class OF
          1,2,3  : location.elements := DStruct.DungeonElementSet {DStruct.CorridorFloor}; |
          4,7,10 : location.elements := DStruct.DungeonElementSet {DStruct.GraniteWall};   |
          5,8,11 : location.elements := DStruct.DungeonElementSet {DStruct.MagmaWall};     |
          6,9,12 : location.elements := DStruct.DungeonElementSet {DStruct.QuartzWall};    |
        END; (* CASE *)
        
        IF location.artifact <> DStruct.InvalidArtifactCursor THEN
          DSActions.DeleteArtifactInformation (dungeon,line,column);
        END; (* IF *)
        
        IF location.creature <> DStruct.InvalidCreatureCursor THEN
          DSActions.DeleteCreatureAtLocation (dungeon,line,column);
        END; (* IF *)
      END DestroyLocation;
      
    BEGIN (* DestroyAreaAroundLocation *)
      FOR line := centerLINE - 15 TO centerLINE + 15 DO
        FOR column := centerCOLUMN - 15 TO centerCOLUMN + 15 DO
          IF (DSActions.LocationInBounds (player^.dungeon^,line,column) AND NOT (DStruct.BoundaryWall IN player^.dungeon^.physical [line]^ [column].elements)) THEN
            CASE DSActions.QuickDistance (player^.character^.line,player^.character^.column,line,column) OF
              13..15 : DestroyLocation (player^.dungeon^,line,column,player^.dungeon^.physical [line]^ [column],MRandom.CardinalRandomRangeValue (1,9)); |
              1..12  : DestroyLocation (player^.dungeon^,line,column,player^.dungeon^.physical [line]^ [column],MRandom.CardinalRandomRangeValue (1,6)); |
              0      : DestroyLocation (player^.dungeon^,line,column,player^.dungeon^.physical [line]^ [column],1);                                      |
            ELSE
              (* no action *)
            END; (* CASE *)
          END; (* IF *)
        END; (* FOR *)
      END; (* FOR *)
    END DestroyAreaAroundLocation;
    
  BEGIN (* ExecuteDestructionAction *)
    IF player^.character^.variables.depthCUR > 0 THEN
      DestroyAreaAroundLocation (player,line,column);
    END; (* IF *)
    
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"There is a blinding flash of light!");
    INC (player^.character^.variables.counters [MCStruct.BlindCOUNT],MRandom.CardinalRandomRangeValue (1,10) + 10);
  END ExecuteDestructionAction;
  
  PROCEDURE ExecuteDetectObjectsAction (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
    VAR
        column,minX,maxX : DStruct.DungeonColumnRange;
        line,minY,maxY   : DStruct.DungeonLineRange;
    
    PROCEDURE DisplayAnyObjects (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : DStruct.PhysicalDungeonUnit; VAR done : BOOLEAN);
    BEGIN (* DisplayAnyObjects *)
      IF ((player^.dungeon^.artifacts [location.artifact].object.class IN OStruct.ObjectClassSet {OStruct.Miscellaneous..OStruct.PrayerBook}) AND NOT (DSActions.LocationHasLight (player^.dungeon^,line,column))) THEN
        INCL (location.elements,DStruct.fmFLAG);
        done := TRUE;
        
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
      END; (* IF *)
    END DisplayAnyObjects;
    
  BEGIN (* ExecuteDetectObjectsAction *)
    MDWindow.DetermineDungeonWindowExtent (player,minX,maxX,minY,maxY,TRUE,TRUE);
    
    done := FALSE;
    
    FOR line := minY TO maxY DO
      FOR column := minX TO maxX DO
        IF player^.dungeon^.physical [line]^ [column].artifact <> DStruct.InvalidArtifactCursor THEN
          DisplayAnyObjects (player,line,column,player^.dungeon^.physical [line]^ [column],done);
        END; (* IF *)
      END; (* FOR *)
    END; (* FOR *)
  END ExecuteDetectObjectsAction;
  
  PROCEDURE ExecuteDoorCreationAction (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
    
    PROCEDURE AttemptToPlaceDoorAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : DStruct.PhysicalDungeonUnit; VAR done : BOOLEAN);
    BEGIN (* AttemptToPlaceDoorAtLocation *)
      IF location.elements * DStruct.DungeonFloorElements <> DStruct.EmptyDungeonElementSet THEN
        IF location.artifact <> DStruct.InvalidArtifactCursor THEN
          DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
        END; (* IF *)
        
        MDGDoors.PlaceClosedDoor (player^.treasures,player^.dungeon^,line,column);
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
        
        done := TRUE;
      END; (* IF *)
    END AttemptToPlaceDoorAtLocation;
    
  BEGIN (* ExecuteDoorCreationAction *)
    done := FALSE;
    
    FOR line := player^.character^.line - 1 TO player^.character^.line + 1 DO
      FOR column := player^.character^.column - 1 TO player^.character^.column + 1 DO
        IF ((line <> player^.character^.line) OR (column <> player^.character^.column)) THEN
          AttemptToPlaceDoorAtLocation (player,line,column,player^.dungeon^.physical [line]^ [column],done);
        END; (* IF *)
      END; (* FOR *)
    END; (* FOR *)
  END ExecuteDoorCreationAction;
  
  PROCEDURE ExecuteEarthquakeSpell (player : MStruct.PlayerInfoPointer);
    VAR
        column : INTEGER;
        line   : INTEGER;
    
    PROCEDURE QuakeLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : DStruct.PhysicalDungeonUnit);
      PROCEDURE QuakeCreatureAtLocation (player : MStruct.PlayerInfoPointer; VAR creatureACTIVE : DStruct.DungeonCreatureRecord; creaturePASSIVE : CStruct.PassiveCreatureInfoRecord);
        PROCEDURE QuakeDamageForCreature (immobile : BOOLEAN) : CARDINAL;
        BEGIN (* QuakeDamageForCreature *)
          IF immobile THEN
            RETURN (3000);
          ELSE
            RETURN (MRandom.CardinalRandomRangeValue (4,32));
          END; (* IF *)
        END QuakeDamageForCreature;
        
      BEGIN (* QuakeCreatureAtLocation *)
        IF NOT (CStruct.MoveThroughWall IN creaturePASSIVE.movement) THEN
          MMWindow.DisplayCreatureMessage (player,"The %CREATURE wails out in pain!",creaturePASSIVE.description,creatureACTIVE.visible,TRUE);
          MPAttk2.DamageCreature (creatureACTIVE,QuakeDamageForCreature (CStruct.AttackOnly IN creaturePASSIVE.movement));
          
          IF creatureACTIVE.hitpoints = 0 THEN
            MMWindow.DisplayCreatureMessage (player,"The %CREATURE is embedded in the rock.",creaturePASSIVE.description,creatureACTIVE.visible,TRUE);
            MPAttk2.KillCreatureAtLocation (player,creatureACTIVE.line,creatureACTIVE.column,creaturePASSIVE,creatureACTIVE.visible,TRUE);
          END; (* IF *)
        ELSIF ((creatureACTIVE.symbol = 'E') OR (creatureACTIVE.symbol = 'X')) THEN
          INC (creatureACTIVE.hitpoints,MRandom.CardinalRandomRangeValue (4,32));
        END; (* IF *)
      END QuakeCreatureAtLocation;
      
      PROCEDURE QuakedLocationWall () : DStruct.DungeonElementMnemonic;
      BEGIN (* QuakedLocationWall *)
        CASE MRandom.CardinalRandomRangeValue (1,10) OF
          1..5 : RETURN (DStruct.QuartzWall);  |
          6..8 : RETURN (DStruct.MagmaWall);   |
          9,10 : RETURN (DStruct.GraniteWall); |
        END; (* CASE *)
      END QuakedLocationWall;
      
    BEGIN (* QuakeLocation *)
      IF location.artifact <> DStruct.InvalidArtifactCursor THEN
        DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
      END; (* IF *)
      
      IF location.creature <> DStruct.InvalidCreatureCursor THEN
        QuakeCreatureAtLocation (player,player^.dungeon^.creatures [location.creature],player^.creatures^.table [player^.dungeon^.creatures [location.creature].cursor]);
      END; (* IF *)
      
      IF NOT (DStruct.BoundaryWall IN location.elements) THEN
        IF location.elements * DStruct.DungeonWallElements <> DStruct.EmptyDungeonElementSet THEN
          DSActions.SetDungeonLocationFVal (location,DStruct.CorridorFloor);
          EXCL (location.elements,DStruct.plFLAG);
        ELSE
          DSActions.SetDungeonLocationFVal (location,QuakedLocationWall ());
        END; (* IF *)
        
        EXCL (location.elements,DStruct.fmFLAG);
      END; (* IF *)
      
      MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,FALSE);
    END QuakeLocation;
    
  BEGIN (* ExecuteEarthquakeSpell *)
    FOR line := player^.character^.line - 8 TO player^.character^.line + 8 DO
      FOR column := player^.character^.column - 8 TO player^.character^.column + 8 DO
        IF (((line <> player^.character^.line) OR (column <> player^.character^.column)) AND DSActions.LocationInBounds (player^.dungeon^,line,column)) THEN
          QuakeLocation (player,line,column,player^.dungeon^.physical [line]^ [column]);
        END; (* IF *)
      END; (* FOR *)
    END; (* FOR *)
  END ExecuteEarthquakeSpell;
  
  PROCEDURE ExecuteTrapCreationAction (player : MStruct.PlayerInfoPointer);
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
    
    PROCEDURE AttemptToPlaceTrap (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : DStruct.PhysicalDungeonUnit);
    BEGIN (* AttemptToPlaceTrap *)
      IF location.elements * DStruct.DungeonFloorElements <> DStruct.EmptyDungeonElementSet THEN
        IF location.artifact <> DStruct.InvalidArtifactCursor THEN
          DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
        END; (* IF *)
        
        MDGAlloc.PlaceTrapAtLocation (player^.treasures,player^.dungeon^,line,column);
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,FALSE);
        
        player^.dungeon^.artifacts [location.artifact].object.miscellaneous := 0;
      END; (* IF *)
    END AttemptToPlaceTrap;
    
  BEGIN (* ExecuteTrapCreationAction *)
    FOR line := player^.character^.line - 1 TO player^.character^.line + 1 DO
      FOR column := player^.character^.column - 1 TO player^.character^.column + 1 DO
        IF ((line <> player^.character^.line) OR (column <> player^.character^.column)) THEN
          AttemptToPlaceTrap (player,line,column,player^.dungeon^.physical [line]^ [column]);
        END; (* IF *)
      END; (* FOR *)
    END; (* FOR *)
  END ExecuteTrapCreationAction;
  
  PROCEDURE ExecuteTreasureDetectionAction (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
    VAR
        column,minX,maxX : DStruct.DungeonColumnRange;
        line,minY,maxY   : DStruct.DungeonLineRange;
    
    PROCEDURE DisplayAnyTreasures (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : DStruct.PhysicalDungeonUnit; VAR done : BOOLEAN);
    BEGIN (* DisplayAnyTreasures *)
      IF ((player^.dungeon^.artifacts [location.artifact].object.class = OStruct.Gold) AND NOT (DSActions.LocationHasLight (player^.dungeon^,line,column))) THEN
        INCL (location.elements,DStruct.fmFLAG);
        done := TRUE;
        
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
      END; (* IF *)
    END DisplayAnyTreasures;
    
  BEGIN (* ExecuteTreasureDetectionAction *)
    MDWindow.DetermineDungeonWindowExtent (player,minX,maxX,minY,maxY,TRUE,TRUE);
    
    done := FALSE;
    
    FOR line := minY TO maxY DO
      FOR column := minX TO maxX DO
        IF player^.dungeon^.physical [line]^ [column].artifact <> DStruct.InvalidArtifactCursor THEN
          DisplayAnyTreasures (player,line,column,player^.dungeon^.physical [line]^ [column],done);
        END; (* IF *)
      END; (* FOR *)
    END; (* FOR *)
  END ExecuteTreasureDetectionAction;
  
  PROCEDURE ExterminateCreatureClass (player : MStruct.PlayerInfoPointer; symbol : CHAR);
    VAR
        index : [0..DStruct.MaxDungeonCreatures - 1];
    
    PROCEDURE ExterminateCreatureAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    BEGIN (* ExterminateCreatureAtLocation *)
      DSActions.DeleteCreatureAtLocation (player^.dungeon^,player^.dungeon^.creatures [index].line,player^.dungeon^.creatures [index].column);
      MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
    END ExterminateCreatureAtLocation;
    
  BEGIN (* ExterminateCreatureClass *)
    FOR index := 0 TO DStruct.MaxDungeonCreatures - 1 DO
      IF ((player^.dungeon^.creatures [index].cursor <> CStruct.InvalidCreatureCursor) AND (player^.dungeon^.creatures [index].symbol = symbol)) THEN
        IF player^.creatures^.table [player^.dungeon^.creatures [index].cursor].balrog THEN
          MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The Balrog is unaffected.");
        ELSE
          ExterminateCreatureAtLocation (player,player^.dungeon^.creatures [index].line,player^.dungeon^.creatures [index].column);
        END; (* IF *)
      END; (* IF *)
    END; (* FOR *)
  END ExterminateCreatureClass;
END MSpells3.
