IMPLEMENTATION MODULE MStaff;
  (*/WIN:A*)
  
  IMPORT MCreatures,MInventory,MISelect,MMWindow,MRandom,MScrl2,MScrl3,MScrl4,MSpells,MSpells2,MSpells3,MStaff2;
  IMPORT CStruct,MCStruct,MStruct,OStruct;
  IMPORT MCSActions,MSActs2,OSActions;
  IMPORT WDebugging,WMacro;
  
  
  TYPE
       StaffFlagRange = [0..24];
  
  VAR
      ExecuteStaffAction : ARRAY StaffFlagRange OF PROCEDURE (MStruct.PlayerInfoPointer,VAR BOOLEAN);
  
  
  PROCEDURE ExecuteUseStaffCommand (player : MStruct.PlayerInfoPointer);
    VAR
        selection : CARDINAL;
    
    PROCEDURE AttemptToUseStaff (player : MStruct.PlayerInfoPointer; selection : CARDINAL);
      TYPE
           StaffExecutionFlags = SET OF StaffFlagRange;
      
      PROCEDURE ExecuteStaffActions (player : MStruct.PlayerInfoPointer; flags : StaffExecutionFlags; selection : CARDINAL);
        VAR
            identified : BOOLEAN;
            index      : StaffFlagRange;
        
        PROCEDURE ExperienceForStaffIdentification (player : MStruct.PlayerInfoPointer; staff : OStruct.InventoryItemRecord) : REAL;
        BEGIN (* ExperienceForStaffIdentification *)
          RETURN (FLOAT (VAL (CARDINAL,player^.character^.variables.level DIV 2) + staff.object.depth) / FLOAT (player^.character^.variables.level));
        END ExperienceForStaffIdentification;
        
      BEGIN (* ExecuteStaffActions *)
        identified := FALSE;
        
        FOR index := MIN (StaffFlagRange) TO MAX (StaffFlagRange) DO
          IF index IN flags THEN
            ExecuteStaffAction [index] (player,identified);
          END; (* IF *)
        END; (* FOR *)
        
        IF NOT (OSActions.InventoryItemIsKnown1 (player^.treasures,player^.character^.inventory.backpack [selection])) THEN
          IF identified THEN
            MSActs2.IncreasePlayerExperience (player,ExperienceForStaffIdentification (player,player^.character^.inventory.backpack [selection]));
            MSpells2.IdentifyPlayerInventoryItem (player,selection);
          ELSE
            OSActions.SampleInventoryItem (player^.treasures,player^.character^.inventory.backpack [selection]);
          END; (* IF *)
        END; (* IF *)
        
        OSActions.DecrementItemCharges (player,player^.character^.inventory.backpack [selection]);
      END ExecuteStaffActions;
      
      PROCEDURE StaffActionFlags (staff : OStruct.InventoryItemRecord) : StaffExecutionFlags;
        VAR
            result : StaffExecutionFlags;
            index  : StaffFlagRange;
        
      BEGIN (* StaffActionFlags *)
        result := StaffExecutionFlags {};
        
        FOR index := MIN (StaffFlagRange) TO MAX (StaffFlagRange) DO
          IF VAL (OStruct.ObjectAttributeMnemonic,index) IN staff.object.attributes THEN
            INCL (result,index);
          END; (* IF *)
        END; (* FOR *)
        
        RETURN (result);
      END StaffActionFlags;
      
      PROCEDURE SuccessfullyUsesStaff (player : MStruct.PlayerInfoPointer; staff : OStruct.InventoryItemRecord) : BOOLEAN;
        PROCEDURE PlayerStaffAbility (player : MStruct.PlayerInfoPointer; staff : OStruct.InventoryItemRecord) : CARDINAL;
          VAR
              ability : INTEGER;
          
        BEGIN (* PlayerStaffAbility *)
          ability := player^.character^.abilities.save + MCSActions.CharacterStatisticAdjustment (player^.character,MCStruct.int) - VAL (INTEGER,staff.object.depth) - 5 + MCSActions.ClassDeviceLevelAdjustment (player^.character^.constants.class) * player^.character^.variables.level DIV 3;
          
          IF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0 THEN
            ability := ability DIV 2;
          END; (* IF *)
          
          IF ((ability < OStruct.DeviceUseChance) AND (MRandom.CardinalRandomRangeValue (1,OStruct.DeviceUseChance - ability + 1) = 1)) THEN
            ability := OStruct.DeviceUseChance;
          END; (* IF *)
          
          RETURN (WMacro.MaxInteger (ability,1));
        END PlayerStaffAbility;
        
      BEGIN (* SuccessfullyUsesStaff *)
        RETURN (MRandom.CardinalRandomRangeValue (1,PlayerStaffAbility (player,staff)) > OStruct.DeviceUseChance);
      END SuccessfullyUsesStaff;
      
    BEGIN (* AttemptToUseStaff *)
      IF NOT (SuccessfullyUsesStaff (player,player^.character^.inventory.backpack [selection])) THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You failed to use the staff properly.");
      ELSIF player^.character^.inventory.backpack [selection].object.miscellaneous = 0 THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The staff has no charges left.");
        
        IF NOT (OSActions.InventoryItemIsKnown2 (player^.character^.inventory.backpack [selection])) THEN
          INCL (player^.character^.inventory.backpack [selection].identification,OStruct.IdentEmpty);
        END; (* IF *)
      ELSE
        ExecuteStaffActions (player,StaffActionFlags (player^.character^.inventory.backpack [selection]),selection);
      END; (* IF *)
    END AttemptToUseStaff;
    
  BEGIN (* ExecuteUseStaffCommand *)
    IF MInventory.AnyObjectsWithClasses (player^.character^.inventory.backpack,OStruct.ObjectClassSet {OStruct.Staff}) THEN
      MISelect.SelectInventoryItem (player,"Use which staff?",OStruct.ObjectClassSet {OStruct.Staff},selection,MStruct.CharacterTurnExecuted);
      
      IF MStruct.CharacterTurnExecuted THEN
        AttemptToUseStaff (player,selection);
      END; (* IF *)
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are not carrying any staves.");
      MStruct.CharacterTurnExecuted := FALSE;
    END; (* IF *)
  END ExecuteUseStaffCommand;
  
  
  PROCEDURE ExecuteCureLightWoundsStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteCureLightWoundsStaffAction *)
    MSpells2.MagicallyHealPlayer (player,MRandom.CardinalRandomRangeValue (1,8),identified);
  END ExecuteCureLightWoundsStaffAction;
  
  PROCEDURE ExecuteCuringStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        cured1,cured2,cured3 : BOOLEAN;
    
  BEGIN (* ExecuteCuringStaffAction *)
    MSpells2.CureBlindness (player,cured1);
    MSpells2.CureConfusion (player,cured2);
    MSpells2.CurePoison (player,cured3);
    
    identified := (cured1 OR cured2 OR cured3);
  END ExecuteCuringStaffAction;
  
  PROCEDURE ExecuteDarknessStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteDarknessStaffAction *)
    MSpells3.ExecuteDarknessAction (player,player^.character^.line,player^.character^.column,identified);
  END ExecuteDarknessStaffAction;
  
  PROCEDURE ExecuteDestructionStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteDestructionStaffAction *)
    MSpells3.ExecuteDestructionAction (player,player^.character^.line,player^.character^.column);
    identified := TRUE;
  END ExecuteDestructionStaffAction;
  
  PROCEDURE ExecuteDetectHiddenDoorsAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteDetectHiddenDoorsAction *)
    MSpells.DetectHiddenDoors (player,identified,TRUE);
  END ExecuteDetectHiddenDoorsAction;
  
  PROCEDURE ExecuteDetectHiddenTrapsAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteDetectHiddenTrapsAction *)
    MSpells.DetectHiddenTraps (player,identified,TRUE);
  END ExecuteDetectHiddenTrapsAction;
  
  PROCEDURE ExecuteDispelEvilStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteDispelEvilStaffAction *)
    MSpells.DispelCreatures (player,CStruct.HurtBySlayEvil,60,identified);
  END ExecuteDispelEvilStaffAction;
  
  PROCEDURE ExecuteEarthquakeStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteEarthquakeStaffAction *)
    MSpells3.ExecuteEarthquakeSpell (player);
    identified := TRUE;
  END ExecuteEarthquakeStaffAction;
  
  PROCEDURE ExecuteLightAreaStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteLightAreaStaffAction *)
    MScrl3.ExecuteLightAreaScrollAction (player);
    identified := TRUE;
  END ExecuteLightAreaStaffAction;
  
  PROCEDURE ExecuteRemoveCurseStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteRemoveCurseStaffAction *)
    MScrl4.ExecuteRemoveCurseScrollAction (player,identified);
    
    IF (identified AND (player^.character^.variables.counters [MCStruct.BlindCOUNT] = 0)) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The staff glows blue for a moment...");
    END; (* IF *)
  END ExecuteRemoveCurseStaffAction;
  
  PROCEDURE ExecuteSlowMonstersStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSlowMonstersStaffAction *)
    MSpells.AlterVisibleCreaturesSpeed (player,-1,identified);
  END ExecuteSlowMonstersStaffAction;
  
  PROCEDURE ExecuteSlowStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSlowStaffAction *)
    identified := (player^.character^.variables.counters [MCStruct.SlowCOUNT] = 0);
    INC (player^.character^.variables.counters [MCStruct.SlowCOUNT],MRandom.CardinalRandomRangeValue (1,30) + 15);
  END ExecuteSlowStaffAction;
  
  PROCEDURE ExecuteSpeedMonstersStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSpeedMonstersStaffAction *)
    MSpells.AlterVisibleCreaturesSpeed (player,+1,identified);
  END ExecuteSpeedMonstersStaffAction;
  
  PROCEDURE ExecuteSpeedStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSpeedStaffAction *)
    identified := (player^.character^.variables.counters [MCStruct.FastCOUNT] = 0);
    INC (player^.character^.variables.counters [MCStruct.FastCOUNT],MRandom.CardinalRandomRangeValue (1,30) + 15);
  END ExecuteSpeedStaffAction;
  
  PROCEDURE ExecuteSummonMonsterStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        count : CARDINAL;
        done  : BOOLEAN;
    
  BEGIN (* ExecuteSummonMonsterStaffAction *)
    identified := FALSE;
    
    FOR count := 1 TO MRandom.CardinalRandomRangeValue (1,4) DO
      MCreatures.SummonRandomMonster (player,player^.character^.line,player^.character^.column,FALSE,done);
      identified := (identified OR done);
    END; (* FOR *)
  END ExecuteSummonMonsterStaffAction;
  
  PROCEDURE ExecuteTeleportStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* ExecuteTeleportStaffAction *)
    MScrl2.ExecuteTeleportScrollAction (player,100);
    identified := TRUE;
  END ExecuteTeleportStaffAction;
  
  PROCEDURE InitializeExecuteStaffActionTable;
    VAR
        index : StaffFlagRange;
    
  BEGIN (* InitializeExecuteStaffActionTable *)
    FOR index := MIN (StaffFlagRange) TO MAX (StaffFlagRange) DO
      ExecuteStaffAction [index] := InvalidStaffProcedure;
    END; (* FOR *)
    
    ExecuteStaffAction [ 0] := ExecuteLightAreaStaffAction;
    ExecuteStaffAction [ 1] := ExecuteDetectHiddenDoorsAction;
    ExecuteStaffAction [ 2] := ExecuteDetectHiddenTrapsAction;
    ExecuteStaffAction [ 3] := MSpells3.ExecuteTreasureDetectionAction;
    ExecuteStaffAction [ 4] := MSpells3.ExecuteDetectObjectsAction;
    ExecuteStaffAction [ 5] := ExecuteTeleportStaffAction;
    ExecuteStaffAction [ 6] := ExecuteEarthquakeStaffAction;
    ExecuteStaffAction [ 7] := ExecuteSummonMonsterStaffAction;
    ExecuteStaffAction [ 9] := ExecuteDestructionStaffAction;
    ExecuteStaffAction [10] := MStaff2.ExecuteStarlightStaffAction;
    ExecuteStaffAction [11] := ExecuteSpeedMonstersStaffAction;
    ExecuteStaffAction [12] := ExecuteSlowMonstersStaffAction;
    ExecuteStaffAction [13] := MSpells.SleepAllVisibleCreatures;
    ExecuteStaffAction [14] := ExecuteCureLightWoundsStaffAction;
    ExecuteStaffAction [15] := MSpells.ExecuteDetectInvisibleAction;
    ExecuteStaffAction [16] := ExecuteSpeedStaffAction;
    ExecuteStaffAction [17] := ExecuteSlowStaffAction;
    ExecuteStaffAction [18] := MStaff2.ExecuteMassPolymorphStaffAction;
    ExecuteStaffAction [19] := ExecuteRemoveCurseStaffAction;
    ExecuteStaffAction [20] := MSpells.DetectEvilCreatures;
    ExecuteStaffAction [21] := ExecuteCuringStaffAction;
    ExecuteStaffAction [22] := ExecuteDispelEvilStaffAction;
    ExecuteStaffAction [24] := ExecuteDarknessStaffAction;
  END InitializeExecuteStaffActionTable;
  
  PROCEDURE InvalidStaffProcedure (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
  BEGIN (* InvalidStaffProcedure *)
    WDebugging.FatalAppExit ("Attempt to use un-recognized staff.");
  END InvalidStaffProcedure;

BEGIN (* MStaff *)
  InitializeExecuteStaffActionTable;
END MStaff.
