IMPLEMENTATION MODULE MStaff2;
  (*/WIN:A*)
  
  IMPORT MCreatures,MDPainting,MDWindow,MMWindow,MWands2;
  IMPORT CStruct,DStruct,MCStruct,MStruct;
  IMPORT DSActions;
  
  
  PROCEDURE ExecuteMassPolymorphStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        index : CARDINAL;
    
    PROCEDURE PolymorphCreature (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
      VAR
          creature : DStruct.DungeonCreatureRecord;
          position : CARDINAL;
          done     : BOOLEAN;
      
    BEGIN (* PolymorphCreature *)
      MCreatures.DetermineRandomCreatureForDepth (player^.creatures,CStruct.MaxCreatureDepth,FALSE,player^.character^.variables.speed,creature);
      DSActions.DeleteCreatureAtLocation (player^.dungeon^,line,column);
      
      DSActions.PlaceCreatureAtLocation (player,player^.dungeon^,line,column,creature,position,done);
      MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
    END PolymorphCreature;
    
  BEGIN (* ExecuteMassPolymorphStaffAction *)
    identified := FALSE;
    
    FOR index := 0 TO DStruct.MaxDungeonCreatures - 1 DO
      IF ((player^.dungeon^.creatures [index].cursor <> CStruct.InvalidCreatureCursor) AND (player^.dungeon^.creatures [index].distance <= MCStruct.MaxCharacterSightDistance) AND NOT (player^.creatures^.table [player^.dungeon^.creatures [index].cursor].balrog)) THEN
        PolymorphCreature (player,player^.dungeon^.creatures [index].line,player^.dungeon^.creatures [index].column);
        identified := TRUE;
      END; (* IF *)
    END; (* FOR *)
  END ExecuteMassPolymorphStaffAction;
  
  PROCEDURE ExecuteStarlightStaffAction (player : MStruct.PlayerInfoPointer; VAR identified : BOOLEAN);
    VAR
        direction : CARDINAL;
    
  BEGIN (* ExecuteStarlightStaffAction *)
    IF player^.character^.variables.counters [MCStruct.BlindCOUNT] = 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The end of the staff bursts into a blue shimmering light.");
    END; (* IF *)
    
    FOR direction := 1 TO 9 DO
      IF direction <> 5 THEN
        MWands2.GenerateLightRay (player,player^.character^.line,player^.character^.column,direction);
      END; (* IF *)
    END; (* FOR *)
    
    identified := TRUE;
  END ExecuteStarlightStaffAction;
END MStaff2.
