IMPLEMENTATION MODULE MStores;
  (*/WIN:A*)
  
  IMPORT MDialogs,MDistMove,MMWindow,MRandom,MStores2,OMagic;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT MSActions,OSActions;
  IMPORT WMacro;
  IMPORT SYSTEM;
  
  
  PROCEDURE AddItemToStoreInventory (treasures : OStruct.TreasureInfoPointer; VAR store : MCStruct.PlayerStoreRecord; item : OStruct.InventoryItemRecord; VAR position : CARDINAL);
    VAR
        storeITEM : MCStruct.StoreInventoryItem;
        done      : BOOLEAN;
    
    PROCEDURE AddStoreObjects (treasures : OStruct.TreasureInfoPointer; owner : MCStruct.StoreOwnerRecord; item1,item2 : MCStruct.StoreInventoryItem; VAR result : MCStruct.StoreInventoryItem);
      VAR
          dummy : LONGINT;
      
    BEGIN (* AddStoreObjects *)
      result := item1;
      
      INC (result.item.object.quantity,item2.item.object.quantity);
      
      IF result.item.object.subclass > OStruct.ObjectMinimumItemGroupSubclass THEN
        DeterminePriceInformation (treasures,owner,result.item,dummy,result.price,dummy);
        result.price := -result.price;
      ELSIF result.item.object.quantity > 24 THEN
        result.item.object.quantity := 24;
      END; (* IF *)
    END AddStoreObjects;
    
    PROCEDURE ConvertToStoreInventoryItem (treasures : OStruct.TreasureInfoPointer; owner : MCStruct.StoreOwnerRecord; item : OStruct.InventoryItemRecord; VAR result : MCStruct.StoreInventoryItem);
      VAR
          dummy,min : LONGINT;
      
    BEGIN (* ConvertToStoreInventoryItem *)
      OSActions.IdentifyObjectAsStoreBought (treasures,item);
      DeterminePriceInformation (treasures,owner,item,min,result.price,dummy);
      
      result.item := item;
    END ConvertToStoreInventoryItem;
    
    PROCEDURE InsertStoreObject (item : MCStruct.StoreInventoryItem; position : CARDINAL; VAR inventory : ARRAY OF MCStruct.StoreInventoryItem; VAR number : CARDINAL);
      VAR
          index : CARDINAL;
      
    BEGIN (* InsertStoreObject *)
      item.price := -item.price;
      
      FOR index := number TO position + 1 BY -1 DO
        inventory [index] := inventory [index - 1];
      END; (* FOR *)
      
      inventory [position] := item;
      number               := number + 1;
    END InsertStoreObject;
    
    PROCEDURE StoreObjectsCanBeAdded (item1,item2 : OStruct.InventoryItemRecord) : BOOLEAN;
    BEGIN (* StoreObjectsCanBeAdded *)
      RETURN ((item1.object.class = item2.object.class) AND (item1.object.subclass = item2.object.subclass) AND (item1.object.subclass >= OStruct.ObjectMinimumSingleStackSubclass) AND ((item1.object.subclass < OStruct.ObjectMinimumItemGroupSubclass) OR (item1.object.miscellaneous = item2.object.miscellaneous)));
    END StoreObjectsCanBeAdded;
    
    PROCEDURE StoreObjectShouldBeInserted (item1,item2 : OStruct.InventoryItemRecord) : BOOLEAN;
    BEGIN (* StoreObjectShouldBeInserted *)
      RETURN (item1.object.class > item2.object.class);
    END StoreObjectShouldBeInserted;
    
  BEGIN (* AddItemToStoreInventory *)
    ConvertToStoreInventoryItem (treasures,store.owner,item,storeITEM);
    
    position := 0;
    done     := FALSE;
    
    REPEAT
      IF StoreObjectsCanBeAdded (storeITEM.item,store.inventory [position].item) THEN
        AddStoreObjects (treasures,store.owner,store.inventory [position],storeITEM,store.inventory [position]);
        done := TRUE;
      ELSIF ((position = store.counter) OR StoreObjectShouldBeInserted (storeITEM.item,store.inventory [position].item)) THEN
        InsertStoreObject (storeITEM,position,store.inventory,store.counter);
        done := TRUE;
      ELSE
        INC (position);
      END; (* IF *)
    UNTIL done;
  END AddItemToStoreInventory;
  
  PROCEDURE BasicItemValue (treasures : OStruct.TreasureInfoPointer; item : OStruct.InventoryItemRecord) : LONGINT;
    VAR
        value : LONGINT;
    
    PROCEDURE AmuletValue (treasures : OStruct.TreasureInfoPointer; item : OStruct.InventoryItemRecord) : LONGINT;
    BEGIN (* AmuletValue *)
      IF NOT (OSActions.InventoryItemIsKnown1 (treasures,item)) THEN
        RETURN (45);
      ELSIF NOT (OSActions.InventoryItemIsKnown2 (item)) THEN
        RETURN (treasures^.table [item.cursor].value);
      ELSE
        RETURN (item.object.value);
      END; (* IF *)
    END AmuletValue;
    
    PROCEDURE DiggingToolValue (treasures : OStruct.TreasureInfoPointer; item : OStruct.InventoryItemRecord) : LONGINT;
    BEGIN (* DiggingToolValue *)
      IF NOT (OSActions.InventoryItemIsKnown2 (item)) THEN
        RETURN (treasures^.table [item.cursor].value);
      ELSIF item.object.miscellaneous >= 0 THEN
        RETURN (WMacro.MaxLongInt (item.object.value + VAL (LONGINT,100 * (item.object.miscellaneous - treasures^.table [item.cursor].miscellaneous)),0));
      ELSE
        RETURN (0);
      END; (* IF *)
    END DiggingToolValue;
    
    PROCEDURE FoodValue (treasures : OStruct.TreasureInfoPointer; item : OStruct.InventoryItemRecord) : LONGINT;
    BEGIN (* FoodValue *)
      IF ((item.object.subclass < OStruct.ObjectMinimumSingleStackSubclass + OStruct.NumberMushroomDescriptions) AND NOT (OSActions.InventoryItemIsKnown1 (treasures,item))) THEN
        RETURN (1);
      ELSE
        RETURN (item.object.value);
      END; (* IF *)
    END FoodValue;
    
    PROCEDURE GeneralArmorValue (treasures : OStruct.TreasureInfoPointer; item : OStruct.InventoryItemRecord) : LONGINT;
    BEGIN (* GeneralArmorValue *)
      IF NOT (OSActions.InventoryItemIsKnown2 (item)) THEN
        RETURN (treasures^.table [item.cursor].value);
      ELSIF item.object.armorMOD >= 0 THEN
        RETURN (item.object.value + VAL (LONGINT,100 * item.object.armorMOD));
      ELSE
        RETURN (0);
      END; (* IF *)
    END GeneralArmorValue;
    
    PROCEDURE GeneralMissileValue (treasures : OStruct.TreasureInfoPointer; item : OStruct.InventoryItemRecord) : LONGINT;
    BEGIN (* GeneralMissileValue *)
      IF NOT (OSActions.InventoryItemIsKnown2 (item)) THEN
        RETURN (treasures^.table [item.cursor].value);
      ELSIF ((item.object.armorMOD >= 0) AND (item.object.damageMOD >= 0) AND (item.object.strikeMOD >= 0)) THEN
        RETURN (item.object.value + VAL (LONGINT,5 * (item.object.armorMOD + item.object.damageMOD + item.object.strikeMOD)));
      ELSE
        RETURN (0);
      END; (* IF *)
    END GeneralMissileValue;
    
    PROCEDURE GeneralWeaponValue (treasures : OStruct.TreasureInfoPointer; item : OStruct.InventoryItemRecord) : LONGINT;
    BEGIN (* GeneralWeaponValue *)
      IF NOT (OSActions.InventoryItemIsKnown2 (item)) THEN
        RETURN (treasures^.table [item.cursor].value);
      ELSIF ((item.object.armorMOD >= 0) AND (item.object.damageMOD >= 0) AND (item.object.strikeMOD >= 0)) THEN
        RETURN (item.object.value + VAL (LONGINT,100 * (item.object.armorMOD + item.object.damageMOD + item.object.strikeMOD)));
      ELSE
        RETURN (0);
      END; (* IF *)
    END GeneralWeaponValue;
    
    PROCEDURE PotionValue (treasures : OStruct.TreasureInfoPointer; item : OStruct.InventoryItemRecord) : LONGINT;
    BEGIN (* PotionValue *)
      IF NOT (OSActions.InventoryItemIsKnown1 (treasures,item)) THEN
        RETURN (20);
      ELSE
        RETURN (item.object.value);
      END; (* IF *)
    END PotionValue;
    
    PROCEDURE RingValue (treasures : OStruct.TreasureInfoPointer; item : OStruct.InventoryItemRecord) : LONGINT;
    BEGIN (* RingValue *)
      IF NOT (OSActions.InventoryItemIsKnown1 (treasures,item)) THEN
        RETURN (45);
      ELSIF NOT (OSActions.InventoryItemIsKnown2 (item)) THEN
        RETURN (treasures^.table [item.cursor].value);
      ELSE
        RETURN (item.object.value);
      END; (* IF *)
    END RingValue;
    
    PROCEDURE ScrollValue (treasures : OStruct.TreasureInfoPointer; item : OStruct.InventoryItemRecord) : LONGINT;
    BEGIN (* ScrollValue *)
      IF NOT (OSActions.InventoryItemIsKnown1 (treasures,item)) THEN
        RETURN (20);
      ELSE
        RETURN (item.object.value);
      END; (* IF *)
    END ScrollValue;
    
    PROCEDURE StaffValue (treasures : OStruct.TreasureInfoPointer; item : OStruct.InventoryItemRecord) : LONGINT;
    BEGIN (* StaffValue *)
      IF NOT (OSActions.InventoryItemIsKnown1 (treasures,item)) THEN
        RETURN (70);
      ELSIF NOT (OSActions.InventoryItemIsKnown2 (item)) THEN
        RETURN (item.object.value + VAL (LONGINT,item.object.miscellaneous) * (item.object.value DIV 20));
      ELSE
        RETURN (item.object.value);
      END; (* IF *)
    END StaffValue;
    
    PROCEDURE WandValue (treasures : OStruct.TreasureInfoPointer; item : OStruct.InventoryItemRecord) : LONGINT;
    BEGIN (* WandValue *)
      IF NOT (OSActions.InventoryItemIsKnown1 (treasures,item)) THEN
        RETURN (50);
      ELSIF NOT (OSActions.InventoryItemIsKnown2 (item)) THEN
        RETURN (item.object.value + VAL (LONGINT,item.object.miscellaneous) * (item.object.value DIV 20));
      ELSE
        RETURN (item.object.value);
      END; (* IF *)
    END WandValue;
    
  BEGIN (* BasicItemValue *)
    IF OStruct.IdentDamaged IN item.identification THEN
      RETURN (0);
    END; (* IF *)
    
    CASE item.object.class OF
      OStruct.MissileWeapon..OStruct.BladeWeapon : value := GeneralWeaponValue (treasures,item);  |
      OStruct.Boots..OStruct.SoftBodyArmor       : value := GeneralArmorValue (treasures,item);   |
      OStruct.SlingAmmo..OStruct.Spike           : value := GeneralMissileValue (treasures,item); |
      OStruct.Potion1,OStruct.Potion2            : value := PotionValue (treasures,item);         |
      OStruct.Scroll1,OStruct.Scroll2            : value := ScrollValue (treasures,item);         |
      OStruct.DiggingTool                        : value := DiggingToolValue (treasures,item);    |
      OStruct.Amulet                             : value := AmuletValue (treasures,item);         |
      OStruct.Staff                              : value := StaffValue (treasures,item);          |
      OStruct.Food                               : value := FoodValue (treasures,item);           |
      OStruct.Ring                               : value := RingValue (treasures,item);           |
      OStruct.Wand                               : value := WandValue (treasures,item);           |
    ELSE
      value := item.object.value;
    END; (* CASE *)
    
    IF item.object.subclass > OStruct.ObjectMinimumItemGroupSubclass THEN
      value := value * VAL (LONGINT,item.object.quantity);
    END; (* IF *)
    
    RETURN (value);
  END BasicItemValue;
  
  PROCEDURE DestroyStoreInventoryObject (treasures : OStruct.TreasureInfoPointer; VAR store : MCStruct.PlayerStoreRecord; selection : CARDINAL; one : BOOLEAN; VAR deleted : BOOLEAN);
    VAR
        quantity : CARDINAL;
    
    PROCEDURE DeleteSelectedStoreItem (treasures : OStruct.TreasureInfoPointer; VAR inventory : ARRAY OF MCStruct.StoreInventoryItem; VAR counter : CARDINAL; position : CARDINAL);
      VAR
          index : CARDINAL;
      
    BEGIN (* DeleteSelectedStoreItem *)
      FOR index := position + 1 TO counter - 1 DO
        inventory [index - 1] := inventory [index];
      END; (* FOR *)
      
      OSActions.ReturnInventoryItemRecord (treasures,OStruct.EmptyObjectCursor,inventory [HIGH (inventory)].item);
      inventory [HIGH (inventory)].price := 0;
      
      DEC (counter);
    END DeleteSelectedStoreItem;
    
  BEGIN (* DestroyStoreInventoryObject *)
    IF ((store.inventory [selection].item.object.subclass < OStruct.ObjectMinimumSingleStackSubclass) OR (store.inventory [selection].item.object.subclass > OStruct.ObjectMaximumSingleStackSubclass)) THEN
      quantity := store.inventory [selection].item.object.quantity;
    ELSIF one THEN
      quantity := 1;
    ELSE
      quantity := MRandom.CardinalRandomRangeValue (1,store.inventory [selection].item.object.quantity);
    END; (* IF *)
    
    deleted := (store.inventory [selection].item.object.quantity = quantity);
    
    IF deleted THEN
      DeleteSelectedStoreItem (treasures,store.inventory,store.counter,selection);
    ELSE
      DEC (store.inventory [selection].item.object.quantity,quantity);
    END; (* IF *)
  END DestroyStoreInventoryObject;
  
  PROCEDURE DeterminePriceInformation (treasures : OStruct.TreasureInfoPointer; owner : MCStruct.StoreOwnerRecord; item : OStruct.InventoryItemRecord; VAR min,max : LONGINT; VAR value : LONGINT);
  BEGIN (* DeterminePriceInformation *)
    value := BasicItemValue (treasures,item);
    
    IF value > 0 THEN
      value := WMacro.MaxLongInt (value * owner.raceADJ DIV 100,1);
      
      min := value * owner.inflateMIN DIV 100;
      max := value * owner.inflateMAX DIV 100;
    ELSE
      min := 0;
      max := 0;
    END; (* IF *)
  END DeterminePriceInformation;
  
  PROCEDURE EnterDungeonStore (player : MStruct.PlayerInfoPointer);
    VAR
        result : INTEGER;
        data   : StoreDialogInformation;
    
    PROCEDURE StoreAtPlayerLocation (player : MStruct.PlayerInfoPointer) : StoreInfoPointer;
      CONST
            StoreDoorBaseSubclass = 101;
      
    BEGIN (* StoreAtPlayerLocation *)
      RETURN (SYSTEM.ADR (player^.character^.stores [VAL (MCStruct.PlayerStoreMnemonic,player^.dungeon^.artifacts [player^.dungeon^.physical [player^.character^.line]^ [player^.character^.column].artifact].object.subclass - StoreDoorBaseSubclass)]));
    END StoreAtPlayerLocation;
    
  BEGIN (* EnterDungeonStore *)
    data.player := player;
    data.store  := StoreAtPlayerLocation (player);
    
    MDistMove.EndDistanceMovement (player);
    
    IF data.store^.openTURN < player^.character^.turn THEN
      MDialogs.ExecuteMoriaDialogBoxParam (player^.windows.frame,"Store_Dialog",player,SYSTEM.ADR (data),MStores2.InitializeStoreDialog,MStores2.ExecuteStoreDialogCommand,MStores2.CloseStoreDialog,result);
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The doors are locked.");
    END; (* IF *)
  END EnterDungeonStore;
  
  PROCEDURE ExecuteStoreMaintainance (player : MStruct.PlayerInfoPointer);
    VAR
        index : MCStruct.PlayerStoreMnemonic;
    
    PROCEDURE MaintainStoreInventory (treasures : OStruct.TreasureInfoPointer; VAR store : MCStruct.PlayerStoreRecord);
      CONST
            MinimumStoreInventory = 10;
            MaximumStoreInventory = 18;
      
      CONST
            StoreTurnover = 9;
      
      PROCEDURE CreateStoreItems (treasures : OStruct.TreasureInfoPointer; VAR store : MCStruct.PlayerStoreRecord; number : CARDINAL);
        VAR
            item : OStruct.InventoryItemRecord;
        
        PROCEDURE CreateStoreItem (treasures : OStruct.TreasureInfoPointer; VAR store : MCStruct.PlayerStoreRecord);
          VAR
              position : CARDINAL;
              attempts : CARDINAL;
              done     : BOOLEAN;
          
          PROCEDURE ReturnRandomStoreItem (treasures : OStruct.TreasureInfoPointer; VAR store : MCStruct.PlayerStoreRecord; VAR result : OStruct.InventoryItemRecord);
            CONST
                  StoreDepthMagicEquivalent = 7;
            
          BEGIN (* ReturnRandomStoreItem *)
            OSActions.ReturnInventoryItemRecord (treasures,store.stock [MRandom.CardinalRandomRangeValue (0,MCStruct.MaxStoreStockItems - 1)],result);
            OMagic.DetermineObjectMagic (result,StoreDepthMagicEquivalent);
          END ReturnRandomStoreItem;
          
          PROCEDURE StoreWillAcceptItem (VAR store : MCStruct.PlayerStoreRecord; item : OStruct.InventoryItemRecord) : BOOLEAN;
          BEGIN (* StoreWillAcceptItem *)
            RETURN ((item.object.value > 0) AND (item.object.value <= store.owner.priceLIMIT) AND ItemCanBeAddedToStoreInventory (store.inventory,store.counter,item));
          END StoreWillAcceptItem;
          
        BEGIN (* CreateStoreItem *)
          attempts := 0;
          
          REPEAT
            ReturnRandomStoreItem (treasures,store,item);
            
            attempts := attempts + 1;
            done     := StoreWillAcceptItem (store,item);
          UNTIL (done OR (attempts = 4));
          
          IF done THEN
            AddItemToStoreInventory (treasures,store,item,position);
          END; (* IF *)
        END CreateStoreItem;
        
      BEGIN (* CreateStoreItems *)
        WHILE number > 0 DO
          CreateStoreItem (treasures,store);
          DEC (number);
        END; (* WHILE *)
      END CreateStoreItems;
      
      PROCEDURE DestroyStoreItems (treasures : OStruct.TreasureInfoPointer; VAR store : MCStruct.PlayerStoreRecord; number : CARDINAL);
        VAR
            deleted : BOOLEAN;
        
      BEGIN (* DestroyStoreItems *)
        WHILE number > 0 DO
          DestroyStoreInventoryObject (treasures,store,MRandom.CardinalRandomRangeValue (0,store.counter - 1),FALSE,deleted);
          DEC (number);
        END; (* WHILE *)
      END DestroyStoreItems;
      
      PROCEDURE NumberItemsToCreate (VAR store : MCStruct.PlayerStoreRecord) : CARDINAL;
      BEGIN (* NumberItemsToCreate *)
        IF store.counter < MinimumStoreInventory THEN
          RETURN (MRandom.CardinalRandomRangeValue (1,StoreTurnover) + (MinimumStoreInventory - store.counter));
        ELSE
          RETURN (MRandom.CardinalRandomRangeValue (1,StoreTurnover));
        END; (* IF *)
      END NumberItemsToCreate;
      
      PROCEDURE NumberItemsToDestroy (VAR store : MCStruct.PlayerStoreRecord) : CARDINAL;
        VAR
            number : CARDINAL;
        
      BEGIN (* NumberItemsToDestroy *)
        number := MRandom.CardinalRandomRangeValue (1,StoreTurnover);
        
        IF store.counter >= MaximumStoreInventory THEN
          INC (number,1 + store.counter - MaximumStoreInventory);
        END; (* IF *)
        
        RETURN (number - 1);
      END NumberItemsToDestroy;
      
    BEGIN (* MaintainStoreInventory *)
      store.insultsCUR := 0;
      
      IF store.counter >= MinimumStoreInventory THEN
        DestroyStoreItems (treasures,store,NumberItemsToDestroy (store));
      END; (* IF *)
      
      IF store.counter <= MaximumStoreInventory THEN
        CreateStoreItems (treasures,store,NumberItemsToCreate (store));
      END; (* IF *)
    END MaintainStoreInventory;
    
  BEGIN (* ExecuteStoreMaintainance *)
    FOR index := MIN (MCStruct.PlayerStoreMnemonic) TO MAX (MCStruct.PlayerStoreMnemonic) DO
      MaintainStoreInventory (player^.treasures,player^.character^.stores [index]);
    END; (* FOR *)
  END ExecuteStoreMaintainance;
  
  PROCEDURE ItemCanBeAddedToStoreInventory (VAR inventory : ARRAY OF MCStruct.StoreInventoryItem; counter : CARDINAL; item : OStruct.InventoryItemRecord) : BOOLEAN;
    VAR
        index : CARDINAL;
    
    PROCEDURE StoreItemsCanBeAdded (item1,item2 : OStruct.InventoryItemRecord) : BOOLEAN;
    BEGIN (* StoreItemsCanBeAdded *)
      IF ((item1.object.class <> item2.object.class) OR (item1.object.subclass <> item2.object.subclass)) THEN
        RETURN (FALSE);
      ELSIF item1.object.quantity + item2.object.quantity >= 256 THEN
        RETURN (FALSE);
      ELSE
        RETURN ((item1.object.subclass < OStruct.ObjectMinimumItemGroupSubclass) OR (item1.object.miscellaneous = item2.object.miscellaneous));
      END; (* IF *)
    END StoreItemsCanBeAdded;
    
  BEGIN (* ItemCanBeAddedToStoreInventory *)
    IF counter <= HIGH (inventory) THEN
      RETURN (TRUE);
    ELSIF item.object.subclass < OStruct.ObjectMinimumSingleStackSubclass THEN
      RETURN (FALSE);
    END; (* IF *)
    
    FOR index := 0 TO HIGH (inventory) DO
      IF StoreItemsCanBeAdded (inventory [index].item,item) THEN
        RETURN (TRUE);
      END; (* IF *)
    END; (* FOR *)
    
    RETURN (FALSE);
  END ItemCanBeAddedToStoreInventory;

  PROCEDURE NoNeedToBargain (store : MCStruct.PlayerStoreRecord; minPRICE : LONGINT) : BOOLEAN;
  BEGIN (* NoNeedToBargain *)
    RETURN ((store.goodBUYS = MAX (LONGINT)) OR (store.goodBUYS > 3 * store.badBUYS + 5 + minPRICE DIV 50));
  END NoNeedToBargain;
  
  PROCEDURE UpdateBargainInformation (VAR store : MCStruct.PlayerStoreRecord; price : LONGINT; minimum : LONGINT);
  BEGIN (* UpdateBargainInformation *)
    IF minimum > 9 THEN
      IF price = minimum THEN
        INC (store.goodBUYS);
      ELSE
        INC (store.badBUYS);
      END; (* IF *)
    END; (* IF *)
  END UpdateBargainInformation;
END MStores.
