IMPLEMENTATION MODULE MStores2;
  (*/WIN:A*)
  
  IMPORT WDialog,WDisplay,Windows,WListBox;
  IMPORT SYSTEM;
  
  IMPORT MPInventory,MPInven2,MStores,MStores3,MStores4,MStores5;
  IMPORT MStruct,OStruct;
  
  
  PROCEDURE CloseStoreDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
  BEGIN (* CloseStoreDialog *)
    ExecuteExitButtonCommand (window,Windows.BN_CLICKED);
  END CloseStoreDialog;
  
  PROCEDURE ExecuteExitButtonCommand (window : Windows.HWND; command : CARDINAL);
  BEGIN (* ExecuteExitButtonCommand *)
    IF command = Windows.BN_CLICKED THEN
      WDialog.EndDialog (window,0);
    END; (* IF *)
  END ExecuteExitButtonCommand;
  
  PROCEDURE ExecuteStoreDialogCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS; control : CARDINAL; command : CARDINAL);
    VAR
        info : MStores.StoreDialogInfoPointer;
    
    PROCEDURE ExecuteInventoryButtonCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteInventoryButtonCommand *)
      IF command = Windows.BN_CLICKED THEN
        WListBox.ResetContent (WDialog.GetDlgItem (window,BackpackListBoxControl));
        
        MPInventory.ExecuteInventoryDialog (window,player);
        MPInven2.InitializeBackpackListBox (WDialog.GetDlgItem (window,BackpackListBoxControl),player,OStruct.AllBackpackObjects);
      END; (* IF *)
    END ExecuteInventoryButtonCommand;
    
    PROCEDURE ExecuteStoreListBoxCommand (window : Windows.HWND; info : MStores.StoreDialogInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteStoreListBoxCommand *)
      IF command = Windows.LBN_SELCHANGE THEN
        WDialog.EnableDialogControl (window,PurchasePushButtonControl,TRUE);
      ELSIF command = Windows.LBN_DBLCLK THEN
        MStores3.ExecutePurchaseButtonCommand (window,info,Windows.BN_CLICKED);
      END; (* IF *)
    END ExecuteStoreListBoxCommand;
    
  BEGIN (* ExecuteStoreDialogCommand *)
    info := MStores.StoreDialogInfoPointer (data);
    
    CASE control OF
      BackpackListBoxControl : MStores4.ExecuteBackpackListBoxCommand (window,info,command); |
      StoreListBoxControl    : ExecuteStoreListBoxCommand (window,info,command);             |

      ExitPushButtonControl,Windows.IDCANCEL : ExecuteExitButtonCommand (window,command);                     |
      InventoryPushButtonControl             : ExecuteInventoryButtonCommand (window,info^.player,command);   |
      
      PurchasePushButtonControl : MStores3.ExecutePurchaseButtonCommand (window,info,command); |
      SellPushButtonControl     : MStores4.ExecuteSellButtonCommand (window,info,command);     |
      
      Windows.IDOK : (* no action *) |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteStoreDialogCommand;
  
  PROCEDURE InitializeStoreDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
    VAR
        info : MStores.StoreDialogInfoPointer;
    
    PROCEDURE InitializeStoreListBox (control : Windows.HWND; info : MStores.StoreDialogInformation);
      CONST
            StoreListBoxTabDistance = 32;
      
      VAR
          index : CARDINAL;
          done  : BOOLEAN;
      
    BEGIN (* InitializeStoreListBox *)
      WListBox.SetTabDistance (control,StoreListBoxTabDistance,done);
      
      index := 0;
      
      WHILE index < info.store^.counter DO
        MStores5.InsertStoreInventoryItem (control,info.player,info.store^,info.store^.inventory [index],index);
        INC (index);
      END; (* WHILE *)
      
      WListBox.SetHorizontalExtent (control,1024);
    END InitializeStoreListBox;
    
  BEGIN (* InitializeStoreDialog *)
    info := MStores.StoreDialogInfoPointer (data);
    
    WDisplay.SetWindowText (window,info^.store^.owner.description);
    
    MPInven2.InitializeBackpackListBox (WDialog.GetDlgItem (window,BackpackListBoxControl),info^.player,OStruct.AllBackpackObjects);
    InitializeStoreListBox (WDialog.GetDlgItem (window,StoreListBoxControl),info^);
    
    WDialog.SetDlgItemLongCard (window,CurrentGoldStaticTextControl,info^.player^.character^.variables.currentGOLD);
  END InitializeStoreDialog;
END MStores2.
