IMPLEMENTATION MODULE MStores3;
  (*/WIN:A*)
  
  IMPORT MDialogs,MInventory,MMWindow,MPInven2,MStores,MStores2,MStores5,MStores6,MStores7,MStores9,MSUpdate;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT WDialog,Windows,WListBox;
  IMPORT MSActs2,OSActions;
  
  
  PROCEDURE ExecutePurchaseButtonCommand (window : Windows.HWND; info : MStores.StoreDialogInfoPointer; command : CARDINAL);
    VAR
        ejected : BOOLEAN;
        price   : LONGINT;
        done    : BOOLEAN;
    
    PROCEDURE DetermineObjectOfInterest (window : Windows.HWND; VAR info : MStores.StoreDialogInformation);
      VAR
          result : Windows.LRESULT;
      
    BEGIN (* DetermineObjectOfInterest *)
      info.selection := WListBox.GetCurSel (WDialog.GetDlgItem (window,MStores2.StoreListBoxControl));
      
      info.price := info.store^.inventory [info.selection].price;
      info.item  := info.store^.inventory [info.selection].item;
      
      IF ((info.item.object.quantity > 1) AND (info.item.object.subclass >= OStruct.ObjectMinimumSingleStackSubclass) AND (info.item.object.subclass <= OStruct.ObjectMaximumSingleStackSubclass)) THEN
        info.item.object.quantity := 1;
      END; (* IF *)
      
      WListBox.SetCurSel (WDialog.GetDlgItem (window,MStores2.StoreListBoxControl),-1,result);
    END DetermineObjectOfInterest;
    
    PROCEDURE DeterminePurchasePrice (window : Windows.HWND; info : MStores.StoreDialogInfoPointer; VAR result : LONGINT; VAR done : BOOLEAN);
    BEGIN (* DeterminePurchasePrice *)
      IF info^.price > 0 THEN
        result := info^.price;
        done   := TRUE;
      ELSE
        MStores6.HaggleOverPurchasePrice (window,info,result,done);
      END; (* IF *)
      
      IF done THEN
        MStores7.DisplaySuccessfulTransactionMessage (window,info^.player,info^.store^.owner.description);
      END; (* IF *)
    END DeterminePurchasePrice;
    
    PROCEDURE TransferStoreObjectToPlayer (window : Windows.HWND; info : MStores.StoreDialogInformation; price : LONGINT);
      PROCEDURE AddObjectToPlayerInventory (window : Windows.HWND; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; price : LONGINT);
        VAR
            location : CARDINAL;
            result   : Windows.LRESULT;
        
      BEGIN (* AddObjectToPlayerInventory *)
        MInventory.AddObjectToPlayerInventory (player,item,location);
        DEC (player^.character^.variables.currentGOLD,price);
        
        MPInven2.InitializeBackpackListBox (WDialog.GetDlgItem (window,MStores2.BackpackListBoxControl),player,OStruct.AllBackpackObjects);
        OSActions.DisplayObjectMessage (window,player,"You have %OBJECT","%OBJECT",player^.character^.inventory.backpack [location],TRUE,TRUE);
        UpdateCurrentPlayerGold (window,player);
        
        MSActs2.CheckStrength (window,player);
      END AddObjectToPlayerInventory;
      
      PROCEDURE RemoveObjectFromStoreInventory (control : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR store : MCStruct.PlayerStoreRecord; selection : CARDINAL; price : LONGINT);
        VAR
            deleted : BOOLEAN;
            result  : Windows.LRESULT;
        
      BEGIN (* RemoveObjectFromStoreInventory *)
        MStores.DestroyStoreInventoryObject (player^.treasures,store,selection,TRUE,deleted);
        WListBox.DeleteString (control,selection,result);
        
        IF NOT (deleted) THEN
          store.inventory [selection].price := price;
          MStores5.InsertStoreInventoryItem (control,player,store,store.inventory [selection],selection);
        END; (* IF *)
      END RemoveObjectFromStoreInventory;
      
    BEGIN (* TransferStoreObjectToPlayer *)
      MStores7.DecreaseStoreInsults (info.store^);
      
      RemoveObjectFromStoreInventory (WDialog.GetDlgItem (window,MStores2.StoreListBoxControl),info.player,info.store^,info.selection,info.price);
      AddObjectToPlayerInventory (window,info.player,info.item,info.price);
    END TransferStoreObjectToPlayer;
    
  BEGIN (* ExecutePurchaseButtonCommand *)
    IF command = Windows.BN_CLICKED THEN
      DetermineObjectOfInterest (window,info^);
      
      IF MInventory.ObjectFitsInInventory (info^.player^.treasures,info^.item,info^.player^.character^.inventory.backpack) THEN
        DeterminePurchasePrice (window,info,price,done);
        
        IF done THEN
          IF price > info^.player^.character^.variables.currentGOLD THEN
            MMWindow.DisplayStoreMessage (window,info^.player,info^.store^.owner.description,"Liar!  You have not the gold!");
            MStores7.IncreaseStoreInsults (window,info^.player,info^.store^,ejected);
          ELSE
            TransferStoreObjectToPlayer (window,info^,price);
          END; (* IF *)
        END; (* IF *)
      ELSE
        MMWindow.DisplayPopupMessage (window,info^.player,"You cannot carry that many different items.");
      END; (* IF *)
      
      IF ejected THEN
        WDialog.EndDialog (window,Windows.FALSE_BOOL);
      ELSE
        WDialog.EnableDialogControl (window,MStores2.PurchasePushButtonControl,FALSE);
      END; (* IF *)
    END; (* IF *)
  END ExecutePurchaseButtonCommand;
  
  PROCEDURE UpdateCurrentPlayerGold (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* UpdateCurrentPlayerGold *)
    WDialog.SetDlgItemLongInt (window,MStores2.CurrentGoldStaticTextControl,player^.character^.variables.currentGOLD);
    MSUpdate.UpdateCurrentGoldWindow (player);
  END UpdateCurrentPlayerGold;
END MStores3.
