IMPLEMENTATION MODULE MStores4;
  (*/WIN:A*)
  
  IMPORT MDialogs,MInventory,MMWindow,MPInven2,MSpells2,MStores,MStores2,MStores3,MStores5,MStores7,MStores9;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT WDialog,WListBox,Windows;
  IMPORT MSActs2,OSActions;
  
  
  PROCEDURE ExecuteBackpackListBoxCommand (window : Windows.HWND; info : MStores.StoreDialogInfoPointer; command : CARDINAL);
  BEGIN (* ExecuteBackpackListBoxCommand *)
    IF command = Windows.LBN_SELCHANGE THEN
      WDialog.EnableDialogControl (window,MStores2.SellPushButtonControl,TRUE);
    ELSIF command = Windows.LBN_DBLCLK THEN
      ExecuteSellButtonCommand (window,info,Windows.BN_CLICKED);
    END; (* IF *)
  END ExecuteBackpackListBoxCommand;
  
  PROCEDURE ExecuteSellButtonCommand (window : Windows.HWND; info : MStores.StoreDialogInfoPointer; command : CARDINAL);
    VAR
        ejected : BOOLEAN;
        done    : BOOLEAN;
    
    PROCEDURE DetermineItemToSell (window : Windows.HWND; VAR info : MStores.StoreDialogInformation; VAR done : BOOLEAN);
      VAR
          result : Windows.LRESULT;
      
      PROCEDURE StoreWillAcceptObjectClass (VAR store : MCStruct.PlayerStoreRecord; item : OStruct.InventoryItemRecord) : BOOLEAN;
      BEGIN (* StoreWillAcceptObjectClass *)
        RETURN (item.object.class IN store.acceptable);
      END StoreWillAcceptObjectClass;
      
    BEGIN (* DetermineItemToSell *)
      info.selection := WListBox.GetCurSel (WDialog.GetDlgItem (window,MStores2.BackpackListBoxControl));
      done           := StoreWillAcceptObjectClass (info.store^,info.player^.character^.inventory.backpack [info.selection]);
      
      IF done THEN
        info.item := info.player^.character^.inventory.backpack [info.selection];
        
        IF ((info.item.object.quantity > 1) AND (info.item.object.subclass >= OStruct.ObjectMinimumSingleStackSubclass) AND (info.item.object.subclass <= OStruct.ObjectMaximumSingleStackSubclass)) THEN
          info.item.object.quantity := 1;
        END; (* IF *)
      ELSE
        MMWindow.DisplayStoreMessage (window,info.player,info.store^.owner.description,"I do not buy that type of object.");
      END; (* IF *)
      
      WListBox.SetCurSel (WDialog.GetDlgItem (window,MStores2.BackpackListBoxControl),-1,result);
    END DetermineItemToSell;
    
    PROCEDURE DisplayDamagedObjectMessage (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR store : MCStruct.PlayerStoreRecord);
      VAR
          ejected : BOOLEAN;
      
    BEGIN (* DisplayDamagedObjectMessage *)
      MMWindow.DisplayStoreMessage (window,player,store.owner.description,"How dare you!");
      MMWindow.DisplayStoreMessage (window,player,store.owner.description,"I will not buy that!");
      
      MStores7.IncreaseStoreInsults (window,player,store,ejected);
      
      IF ejected THEN
        WDialog.EndDialog (window,Windows.FALSE_BOOL);
      END; (* IF *)
    END DisplayDamagedObjectMessage;
    
    PROCEDURE ExecuteSaleTransaction (window : Windows.HWND; info : MStores.StoreDialogInfoPointer);
      VAR
          price : LONGINT;
          done  : BOOLEAN;
      
      PROCEDURE TransferItemToStore (window : Windows.HWND; VAR info : MStores.StoreDialogInformation; price : LONGINT);
        VAR
            item : OStruct.InventoryItemRecord;
        
        PROCEDURE AddObjectToStoreInventory (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR store : MCStruct.PlayerStoreRecord; item : OStruct.InventoryItemRecord);
          VAR
              position : CARDINAL;
              result   : Windows.LRESULT;
          
          PROCEDURE StoreWillDisplayItem (treasures : OStruct.TreasureInfoPointer; VAR store : MCStruct.PlayerStoreRecord; item : OStruct.InventoryItemRecord) : BOOLEAN;
            VAR
                min,max : LONGINT;
                value   : LONGINT;
            
          BEGIN (* StoreWillDisplayItem *)
            MStores.DeterminePriceInformation (treasures,store.owner,item,min,max,value);
            RETURN (value > 0);
          END StoreWillDisplayItem;
          
        BEGIN (* AddObjectToStoreInventory *)
          OSActions.IdentifyObjectAsKnown2 (player^.treasures,item);
          
          IF StoreWillDisplayItem (player^.treasures,store,item) THEN
            MStores.AddItemToStoreInventory (player^.treasures,store,item,position);
            
            IF store.inventory [position].item.object.quantity <> item.object.quantity THEN
              WListBox.DeleteString (WDialog.GetDlgItem (window,MStores2.StoreListBoxControl),position,result);
            END; (* IF *)
            
            MStores5.InsertStoreInventoryItem (WDialog.GetDlgItem (window,MStores2.StoreListBoxControl),player,store,store.inventory [position],position);
          END; (* IF *)
        END AddObjectToStoreInventory;
        
        PROCEDURE RemoveObjectFromPlayerInventory (window : Windows.HWND; player : MStruct.PlayerInfoPointer; position : CARDINAL; price : LONGINT; VAR item : OStruct.InventoryItemRecord);
          VAR
              deleted : BOOLEAN;
          
        BEGIN (* RemoveObjectFromPlayerInventory *)
          MSpells2.IdentifyPlayerInventoryItem (player,position);
          
          item := info.player^.character^.inventory.backpack [position];
          
          IF ((item.object.quantity > 1) AND (item.object.subclass >= OStruct.ObjectMinimumSingleStackSubclass) AND (item.object.subclass <= OStruct.ObjectMaximumSingleStackSubclass)) THEN
            item.object.quantity := 1;
          END; (* IF *)
          
          MInventory.DecrementInventoryItemQuantity (player,position,deleted);
          
          MPInven2.InitializeBackpackListBox (WDialog.GetDlgItem (window,MStores2.BackpackListBoxControl),player,OStruct.AllBackpackObjects);
          MSActs2.CheckStrength (window,player);
          
          INC (player^.character^.variables.currentGOLD,price);
          
          MStores3.UpdateCurrentPlayerGold (window,player);
        END RemoveObjectFromPlayerInventory;
        
      BEGIN (* TransferItemToStore *)
        MStores7.DecreaseStoreInsults (info.store^);
        
        RemoveObjectFromPlayerInventory (window,info.player,info.selection,price,item);
        AddObjectToStoreInventory (window,info.player,info.store^,item);
      END TransferItemToStore;
      
    BEGIN (* ExecuteSaleTransaction *)
      MStores9.DetermineItemSalePrice (window,info,price,done);
      
      IF done THEN
        TransferItemToStore (window,info^,price);
      END; (* IF *)
    END ExecuteSaleTransaction;
    
  BEGIN (* ExecuteSellButtonCommand *)
    IF command = Windows.BN_CLICKED THEN
      DetermineItemToSell (window,info^,done);
      
      IF done THEN
        IF MStores.BasicItemValue (info^.player^.treasures,info^.item) < 1 THEN
          DisplayDamagedObjectMessage (window,info^.player,info^.store^);
        ELSIF NOT (MStores.ItemCanBeAddedToStoreInventory (info^.store^.inventory,info^.store^.counter,info^.item)) THEN
          MMWindow.DisplayStoreMessage (window,info^.player,info^.store^.owner.description,"I have not the room in my store to keep it.");
        ELSE
          ExecuteSaleTransaction (window,info);
        END; (* IF *)
      END; (* IF *)
      
      WDialog.EnableDialogControl (window,MStores2.SellPushButtonControl,FALSE);
    END; (* IF *)
  END ExecuteSellButtonCommand;
END MStores4.
