IMPLEMENTATION MODULE MStores5;
  (*/WIN:A*)
  
  IMPORT WDialog,Windows,WListBox,WString;
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT ODescriptions;
  IMPORT MCSActions;
  IMPORT ASCII;
  
  
  PROCEDURE InitializeObjectDescription (window : Windows.HWND; control : CARDINAL; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord);
    VAR
        text : ARRAY [0..127] OF CHAR;
    
  BEGIN (* InitializeObjectDescription *)
    ODescriptions.ReturnObjectDescription (player,item,TRUE,text);
    WDialog.SetDlgItemText (window,control,text);
  END InitializeObjectDescription;
  
  PROCEDURE InsertStoreInventoryItem (control : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR store : MCStruct.PlayerStoreRecord; data : MCStruct.StoreInventoryItem; position : CARDINAL);
    VAR
        result : Windows.LRESULT;
        text   : ARRAY [0..127] OF CHAR;
    
    PROCEDURE FormatStoreInventoryItemDescription (player : MStruct.PlayerInfoPointer; VAR store : MCStruct.PlayerStoreRecord; data : MCStruct.StoreInventoryItem; VAR result : ARRAY OF CHAR);
      PROCEDURE ReplaceFixedPriceParameter (text : ARRAY OF CHAR; formal : ARRAY OF CHAR; data : MCStruct.StoreInventoryItem; VAR result : ARRAY OF CHAR);
      BEGIN (* ReplaceFixedPriceParameter *)
        IF data.price > 0 THEN
          WString.ReplaceStringParameter (text,formal,"FIXED",result);
        ELSE
          WString.ReplaceStringParameter (text,formal,"",result);
        END; (* IF *)
      END ReplaceFixedPriceParameter;
      
      PROCEDURE ReplaceStoreInventoryItemPrice (text : ARRAY OF CHAR; formal : ARRAY OF CHAR; player : MStruct.PlayerInfoPointer; VAR store : MCStruct.PlayerStoreRecord; data : MCStruct.StoreInventoryItem; VAR result : ARRAY OF CHAR);
      BEGIN (* ReplaceStoreInventoryItemPrice *)
        IF data.price <= 0 THEN
          WString.ReplaceLongIntParameter (text,formal,-data.price * MCSActions.CharacterCharismaAdjustment (player^.character) DIV 100,result);
        ELSE
          WString.ReplaceLongIntParameter (text,formal,data.price,result);
        END; (* IF *)
      END ReplaceStoreInventoryItemPrice;
      
    BEGIN (* FormatStoreInventoryItemDescription *)
      IF ((data.item.object.subclass >= OStruct.ObjectMinimumSingleStackSubclass) AND (data.item.object.subclass <= OStruct.ObjectMaximumSingleStackSubclass)) THEN
        data.item.object.quantity := 1;
      END; (* IF *)
      
      ODescriptions.ReplaceObjectDescription ("%PRICE|%FIXED|%DESCRIPTION","%DESCRIPTION",player,data.item,TRUE,result);
      ReplaceStoreInventoryItemPrice (result,"%PRICE",player,store,data,result);
      ReplaceFixedPriceParameter (result,"%FIXED",data,result);
      
      WString.ReplaceCharParameter (result,"|",ASCII.ht,result);
    END FormatStoreInventoryItemDescription;
    
  BEGIN (* InsertStoreInventoryItem *)
    FormatStoreInventoryItemDescription (player,store,data,text);
    WListBox.InsertString (control,position,text,result);
  END InsertStoreInventoryItem;
END MStores5.
