IMPLEMENTATION MODULE MStores6;
  (*/WIN:A*)
  
  IMPORT MDialogs,MMWindow,MRandom,MSHaggle,MStores,MStores5,MStores7,MStores8;
  IMPORT WDialog,Windows,WMacro;
  IMPORT MCSActions;
  IMPORT MStruct;
  IMPORT SYSTEM;
  
  
  PROCEDURE ClosePurchaseHaggleDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
  BEGIN (* ClosePurchaseHaggleDialog *)
    ExecuteCancelButton (window,Windows.BN_CLICKED);
  END ClosePurchaseHaggleDialog;
  
  PROCEDURE HaggleOverPurchasePrice (window : Windows.HWND; info : MStores.StoreDialogInfoPointer; VAR price : LONGINT; VAR done : BOOLEAN);
  BEGIN (* HaggleOverPurchasePrice *)
    MSHaggle.ExecuteHaggleDialog (window,info,InitializePurchaseHaggleDialog,ExecutePurchaseHaggleCommand,ClosePurchaseHaggleDialog,price,done);
    
    IF info^.ejected THEN
      WDialog.EndDialog (window,Windows.FALSE_BOOL);
    END; (* IF *)
  END HaggleOverPurchasePrice;
  
  PROCEDURE ExecuteCancelButton (window : Windows.HWND; command : CARDINAL);
  BEGIN (* ExecuteCancelButton *)
    IF command = Windows.BN_CLICKED THEN
      WDialog.EndDialog (window,Windows.FALSE_BOOL);
    END; (* IF *)
  END ExecuteCancelButton;
  
  PROCEDURE ExecutePurchaseHaggleCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS; control : CARDINAL; command : CARDINAL);
    VAR
        haggle : MSHaggle.StoreHaggleInfoPointer;
    
    PROCEDURE ExecutePurchaseHaggleAcceptButtonCommand (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation; command : CARDINAL);
    BEGIN (* ExecutePurchaseHaggleAcceptButtonCommand *)
      IF command = Windows.BN_CLICKED THEN
        haggle.info^.price := haggle.currentASK;
        
        IF haggle.haggled THEN
          MStores.UpdateBargainInformation (haggle.info^.store^,haggle.currentASK,haggle.finalASK);
        END; (* IF *)
        
        WDialog.EndDialog (window,Windows.TRUE_BOOL);
      END; (* IF *)
    END ExecutePurchaseHaggleAcceptButtonCommand;
    
    PROCEDURE ExecutePurchaseHaggleOfferButtonCommand (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation; command : CARDINAL);
      VAR
          offer : LONGINT;
          done  : BOOLEAN;
      
      PROCEDURE DetermineCounterOffer (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation; offer : LONGINT);
        PROCEDURE ComputeNewAskingPrice (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation; offer : LONGINT);
          VAR
              accepted : BOOLEAN;
              change   : LONGINT;
          
          PROCEDURE DetermineAskingPriceAdjustment (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation; offer : LONGINT; VAR change : LONGINT);
            VAR
                rate : LONGINT;
            
          BEGIN (* DetermineAskingPriceAdjustment *)
            rate := (offer - haggle.prevOFFER) * 100 DIV (haggle.currentASK - haggle.prevOFFER);
            
            IF ((rate < haggle.minCHANGE) AND (offer >= haggle.prevOFFER)) THEN
              MStores7.ExecuteInsultingOfferAction (window,haggle.info^.player,haggle.info^.store^,haggle.info^.ejected);
            ELSIF rate > haggle.maxCHANGE THEN
              rate := WMacro.MinLongInt (rate * 75 DIV 100,haggle.maxCHANGE);
            END; (* IF *)
            
            IF NOT (haggle.info^.ejected) THEN
              change := WMacro.MaxLongInt ((haggle.currentASK - offer) * (rate + VAL (LONGINT,MRandom.CardinalRandomRangeValue (1,5)) - 3) DIV 100 + 1,0);
            END; (* IF *)
          END DetermineAskingPriceAdjustment;
          
          PROCEDURE DisplayPurchaseHagglingMessage (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation);
          BEGIN (* DisplayPurchaseHagglingMessage *)
            IF haggle.finalCOUNT > 0 THEN
              MStores7.DisplayTwoParameterStoreMessage (window,haggle.info^.player,haggle.info^.store^.owner.description,160 + MRandom.CardinalRandomRangeValue (0,2),haggle.prevOFFER,haggle.currentASK);
            ELSE
              MStores7.DisplayTwoParameterStoreMessage (window,haggle.info^.player,haggle.info^.store^.owner.description,170 + MRandom.CardinalRandomRangeValue (0,15),haggle.prevOFFER,haggle.currentASK);
            END; (* IF *)
          END DisplayPurchaseHagglingMessage;
          
        BEGIN (* ComputeNewAskingPrice *)
          DetermineAskingPriceAdjustment (window,haggle,offer,change);
          
          IF NOT (haggle.info^.ejected) THEN
            haggle.currentASK := haggle.currentASK - change;
            
            IF haggle.currentASK < haggle.finalASK THEN
              MSHaggle.UpdateFinalAskingInformation (window,haggle);
              
              accepted := FALSE;
            ELSIF haggle.currentASK <= offer THEN
              haggle.currentASK := offer;
              accepted          := TRUE;
              
              ExecutePurchaseHaggleAcceptButtonCommand (window,haggle,Windows.BN_CLICKED);
            ELSE
              accepted := FALSE;
            END; (* IF *)
          END; (* IF *)
          
          IF (haggle.info^.ejected OR (haggle.finalCOUNT > MSHaggle.MaxFinalOffers)) THEN
            WDialog.EndDialog (window,Windows.FALSE_BOOL);
          ELSIF NOT (accepted) THEN
            haggle.offerCOUNT := haggle.offerCOUNT + 1;
            haggle.prevOFFER  := offer;
            
            WDialog.SetDlgItemLongInt (window,MSHaggle.AskingPriceDisplayStaticTextControl,haggle.currentASK);
            WDialog.SetDlgItemLongInt (window,MSHaggle.PreviousPlayerOfferDisplayStaticTextControl,offer);
            
            DisplayPurchaseHagglingMessage (window,haggle);
          END; (* IF *)
        END ComputeNewAskingPrice;
        
      BEGIN (* DetermineCounterOffer *)
        IF offer > haggle.currentASK THEN
          MStores7.DisplayStoreResourceMessage (window,haggle.info^.player,haggle.info^.store^.owner.description,150 + MRandom.CardinalRandomRangeValue (0,4));
        ELSIF offer = haggle.currentASK THEN
          ExecutePurchaseHaggleAcceptButtonCommand (window,haggle,Windows.BN_CLICKED);
        ELSE
          ComputeNewAskingPrice (window,haggle,offer);
        END; (* IF *)
      END DetermineCounterOffer;
      
    BEGIN (* ExecutePurchaseHaggleOfferButtonCommand *)
      IF command = Windows.BN_CLICKED THEN
        MStores8.DetermineNewPlayerOffer (window,MSHaggle.CurrentOfferEditTextControl,haggle,+1,offer,done);
        
        IF done THEN
          DetermineCounterOffer (window,haggle,offer);
        END; (* IF *)
      END; (* IF *)
    END ExecutePurchaseHaggleOfferButtonCommand;
    
  BEGIN (* ExecutePurchaseHaggleCommand *)
    haggle := MSHaggle.StoreHaggleInfoPointer (data);
    
    CASE control OF
      MSHaggle.MakeOfferPushButtonControl,Windows.IDOK : ExecutePurchaseHaggleOfferButtonCommand (window,haggle^,command);  |
      MSHaggle.AcceptPushButtonControl                 : ExecutePurchaseHaggleAcceptButtonCommand (window,haggle^,command); |
      
      MSHaggle.CancelPushButtonControl,Windows.IDCANCEL : ExecuteCancelButton (window,command); |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecutePurchaseHaggleCommand;
  
  PROCEDURE InitializePurchaseHaggleDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
    VAR
        haggle : MSHaggle.StoreHaggleInfoPointer;
    
    PROCEDURE InitializeStoreHaggleInformation (window : Windows.HWND; VAR result : MSHaggle.StoreHaggleInformation);
    BEGIN (* InitializeStoreHaggleInformation *)
      WITH result DO
        MStores.DeterminePriceInformation (info^.player^.treasures,info^.store^.owner,info^.item,finalASK,currentASK,prevOFFER);
        
        currentOFFER := 0;
        currentASK   := WMacro.MaxLongInt (currentASK * MCSActions.CharacterCharismaAdjustment (info^.player^.character) DIV 100,1);
        finalCOUNT   := 0;
        offerCOUNT   := 0;
        prevOFFER    := WMacro.MaxLongInt (prevOFFER * (200 - info^.store^.owner.inflateMAX) DIV 100,1);
        finalASK     := WMacro.MaxLongInt (finalASK * MCSActions.CharacterCharismaAdjustment (info^.player^.character) DIV 100,1);
        
        maxCHANGE := info^.store^.owner.haggleRATE * 3;
        minCHANGE := info^.store^.owner.haggleRATE;
        
        info^.ejected := FALSE;
        haggled       := TRUE;
      END; (* WITH *)
      
      IF MStores.NoNeedToBargain (result.info^.store^,result.finalASK) THEN
        MMWindow.DisplayPopupMessage (window,result.info^.player,"After a long bargaining session, you agree upon the price.");
        
        result.currentASK := result.finalASK;
        result.haggled    := FALSE;
        
        WDialog.SetDlgItemText (window,MSHaggle.AskingPricePromptStaticTextControl,"Final offer:");
      END; (* IF *)
    END InitializeStoreHaggleInformation;
    
  BEGIN (* InitializePurchaseHaggleDialog *)
    haggle := MSHaggle.StoreHaggleInfoPointer (data);
    
    InitializeStoreHaggleInformation (window,haggle^);
    
    MStores5.InitializeObjectDescription (window,MSHaggle.ItemDescriptionEditTextControl,player,haggle^.info^.item);
    MSHaggle.InitializeHaggleTitle (window,haggle^.info^.store^.owner.description);
    
    WDialog.SetDlgItemLongInt (window,MSHaggle.AskingPriceDisplayStaticTextControl,haggle^.currentASK);
    WDialog.SetDlgItemText (window,MSHaggle.PreviousPlayerOfferDisplayStaticTextControl,"");
  END InitializePurchaseHaggleDialog;
END MStores6.
