IMPLEMENTATION MODULE MStores7;
  (*/WIN:A*)
  
  IMPORT Windows,WinStart,WResource,WString;
  IMPORT MCStruct,MStruct;
  IMPORT MMWindow,MRandom;
  
  
  PROCEDURE DecreaseStoreInsults (VAR store : MCStruct.PlayerStoreRecord);
  BEGIN (* DecreaseStoreInsults *)
    IF store.insultsCUR > 0 THEN
      DEC (store.insultsCUR);
    END; (* IF *)
  END DecreaseStoreInsults;
  
  PROCEDURE DisplayStoreResourceMessage (window : Windows.HWND; player : MStruct.PlayerInfoPointer; owner : ARRAY OF CHAR; cursor : CARDINAL);
    VAR
        message : ARRAY [0..127] OF CHAR;
        length  : CARDINAL;
    
  BEGIN (* DisplayStoreResourceMessage *)
    WResource.LoadString (WinStart.hInstance,cursor,message,length);
    MMWindow.DisplayStoreMessage (window,player,owner,message);
  END DisplayStoreResourceMessage;

  PROCEDURE DisplaySuccessfulTransactionMessage (window : Windows.HWND; player : MStruct.PlayerInfoPointer; owner : ARRAY OF CHAR);
  BEGIN (* DisplaySuccessfulTransactionMessage *)
    DisplayStoreResourceMessage (window,player,owner,100 + MRandom.CardinalRandomRangeValue (0,13));
  END DisplaySuccessfulTransactionMessage;
  
  PROCEDURE DisplayTwoParameterStoreMessage (window : Windows.HWND; player : MStruct.PlayerInfoPointer; owner : ARRAY OF CHAR; cursor : CARDINAL; value1,value2 : LONGINT);
    VAR
        message : ARRAY [0..127] OF CHAR;
        length  : CARDINAL;
    
  BEGIN (* DisplayTwoParameterStoreMessage *)
    WResource.LoadString (WinStart.hInstance,cursor,message,length);
    
    WString.ReplaceLongIntParameter (message,"%A1",value1,message);
    WString.ReplaceLongIntParameter (message,"%A2",value2,message);
    
    MMWindow.DisplayStoreMessage (window,player,owner,message);
  END DisplayTwoParameterStoreMessage;
  
  PROCEDURE ExecuteInsultingOfferAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR store : MCStruct.PlayerStoreRecord; VAR ejected : BOOLEAN);
  BEGIN (* ExecuteInsultingOfferAction *)
    IncreaseStoreInsults (window,player,store,ejected);
    
    IF NOT (ejected) THEN
      DisplayStoreResourceMessage (window,player,store.owner.description,140 + MRandom.CardinalRandomRangeValue (0,9));
    END; (* IF *)
  END ExecuteInsultingOfferAction;
  
  PROCEDURE IncreaseStoreInsults (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR store : MCStruct.PlayerStoreRecord; VAR ejected : BOOLEAN);
    PROCEDURE DisplayStoreEjectionMessage (window : Windows.HWND; player : MStruct.PlayerInfoPointer; owner : ARRAY OF CHAR);
      VAR
          comment : CARDINAL;
      
    BEGIN (* DisplayStoreEjectionMessage *)
      comment := MRandom.CardinalRandomRangeValue (0,4);
      
      DisplayStoreResourceMessage (window,player,owner,120 + comment);
      DisplayStoreResourceMessage (window,player,owner,130 + comment);
    END DisplayStoreEjectionMessage;
    
  BEGIN (* IncreaseStoreInsults *)
    store.insultsCUR := store.insultsCUR + 1;
    ejected          := (store.insultsCUR > store.owner.insultLIMIT);
    
    IF ejected THEN
      DisplayStoreEjectionMessage (window,player,store.owner.description);
      
      store.insultsCUR := 0;
      store.goodBUYS   := 0;
      store.openTURN   := player^.character^.turn + 2500 + VAL (LONGCARD,MRandom.CardinalRandomRangeValue (1,2500));
      store.badBUYS    := 0;
    END; (* IF *)
  END IncreaseStoreInsults;
END MStores7.
