IMPLEMENTATION MODULE MStores9;
  (*/WIN:A*)
  
  IMPORT MDialogs,MMWindow,MRandom,MSHaggle,MStores,MStores5,MStores7,MStores8;
  IMPORT WDialog,Windows,WMacro;
  IMPORT MCSActions;
  IMPORT MStruct;
  IMPORT SYSTEM;
  
  
  PROCEDURE CloseSellHaggleDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
  BEGIN (* CloseSellHaggleDialog *)
    ExecuteCancelButton (window,Windows.BN_CLICKED);
  END CloseSellHaggleDialog;
  
  PROCEDURE DetermineItemSalePrice (window : Windows.HWND; info : MStores.StoreDialogInfoPointer; VAR price : LONGINT; VAR accepted : BOOLEAN);
    VAR
        result : INTEGER;
    
  BEGIN (* DetermineItemSalePrice *)
    MSHaggle.ExecuteHaggleDialog (window,info,InitializeSellHaggleDialog,ExecuteSellHaggleCommand,CloseSellHaggleDialog,price,accepted);
    
    IF info^.ejected THEN
      WDialog.EndDialog (window,Windows.FALSE_BOOL);
    END; (* IF *)
  END DetermineItemSalePrice;
  
  PROCEDURE ExecuteCancelButton (window : Windows.HWND; command : CARDINAL);
  BEGIN (* ExecuteCancelButton *)
    IF command = Windows.BN_CLICKED THEN
      WDialog.EndDialog (window,Windows.FALSE_BOOL);
    END; (* IF *)
  END ExecuteCancelButton;
  
  PROCEDURE ExecuteSellHaggleCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS; control : CARDINAL; command : CARDINAL);
    VAR
        haggle : MSHaggle.StoreHaggleInfoPointer;
    
    PROCEDURE ExecuteSellHaggleAcceptButtonCommand (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation; command : CARDINAL);
    BEGIN (* ExecuteSellHaggleAcceptButtonCommand *)
      IF command = Windows.BN_CLICKED THEN
        MStores7.DisplaySuccessfulTransactionMessage (window,haggle.info^.player,haggle.info^.store^.owner.description);
        haggle.info^.price := haggle.currentASK;
        
        IF haggle.haggled THEN
          MStores.UpdateBargainInformation (haggle.info^.store^,haggle.currentASK,haggle.finalASK);
        END; (* IF *)
        
        WDialog.EndDialog (window,Windows.TRUE_BOOL);
      END; (* IF *)
    END ExecuteSellHaggleAcceptButtonCommand;
    
    PROCEDURE ExecuteSellHaggleOfferButtonCommand (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation; command : CARDINAL);
      VAR
          offer : LONGINT;
          done  : BOOLEAN;
      
      PROCEDURE DetermineCounterOffer (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation; offer : LONGINT);
        PROCEDURE ComputeNewAskingPrice (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation; offer : LONGINT);
          VAR
              accepted : BOOLEAN;
              change   : LONGINT;
          
          PROCEDURE DetermineAskingPriceAdjustment (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation; offer : LONGINT; VAR change : LONGINT);
            VAR
                rate : LONGINT;
            
          BEGIN (* DetermineAskingPriceAdjustment *)
            rate := (haggle.prevOFFER - offer) * 100 DIV (haggle.prevOFFER - haggle.currentASK);
            
            IF ((rate < haggle.minCHANGE) AND (offer <= haggle.prevOFFER)) THEN
              MStores7.ExecuteInsultingOfferAction (window,haggle.info^.player,haggle.info^.store^,haggle.info^.ejected);
            ELSIF rate > haggle.maxCHANGE THEN
              rate := WMacro.MinLongInt (rate * 75 DIV 100,haggle.maxCHANGE);
            END; (* IF *)
            
            IF NOT (haggle.info^.ejected) THEN
              change := WMacro.MaxLongInt ((offer - haggle.currentASK) * (rate + VAL (LONGINT,MRandom.IntegerRandomRangeValue (1,5) - 3)) DIV 100 + 1,0);
            END; (* IF *)
          END DetermineAskingPriceAdjustment;
          
          PROCEDURE DisplaySellHagglingMessage (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation);
          BEGIN (* DisplaySellHagglingMessage *)
            IF haggle.finalCOUNT > 0 THEN
              MStores7.DisplayTwoParameterStoreMessage (window,haggle.info^.player,haggle.info^.store^.owner.description,190 + MRandom.CardinalRandomRangeValue (0,2),haggle.currentASK,haggle.prevOFFER);
            ELSE
              MStores7.DisplayTwoParameterStoreMessage (window,haggle.info^.player,haggle.info^.store^.owner.description,200 + MRandom.CardinalRandomRangeValue (0,14),haggle.currentASK,haggle.prevOFFER);
            END; (* IF *)
          END DisplaySellHagglingMessage;
          
        BEGIN (* ComputeNewAskingPrice *)
          DetermineAskingPriceAdjustment (window,haggle,offer,change);
          
          IF NOT (haggle.info^.ejected) THEN
            haggle.currentASK := haggle.currentASK + change;
            
            IF haggle.currentASK > haggle.finalASK THEN
              MSHaggle.UpdateFinalAskingInformation (window,haggle);
              
              accepted := FALSE;
            ELSIF haggle.currentASK >= offer THEN
              haggle.currentASK := offer;
              accepted          := TRUE;
              
              ExecuteSellHaggleAcceptButtonCommand (window,haggle,Windows.BN_CLICKED);
            ELSE
              accepted := FALSE;
            END; (* IF *)
          END; (* IF *)
          
          IF (haggle.info^.ejected OR (haggle.finalCOUNT > MSHaggle.MaxFinalOffers)) THEN
            WDialog.EndDialog (window,Windows.FALSE_BOOL);
          ELSIF NOT (accepted) THEN
            haggle.offerCOUNT := haggle.offerCOUNT + 1;
            haggle.prevOFFER  := offer;
            
            WDialog.SetDlgItemLongInt (window,MSHaggle.AskingPriceDisplayStaticTextControl,haggle.currentASK);
            WDialog.SetDlgItemLongInt (window,MSHaggle.PreviousPlayerOfferDisplayStaticTextControl,offer);
            
            DisplaySellHagglingMessage (window,haggle);
          END; (* IF *)
        END ComputeNewAskingPrice;
        
      BEGIN (* DetermineCounterOffer *)
        IF offer < haggle.currentASK THEN
          MStores7.DisplayStoreResourceMessage (window,haggle.info^.player,haggle.info^.store^.owner.description,150 + MRandom.CardinalRandomRangeValue (0,4));
        ELSIF offer = haggle.currentASK THEN
          ExecuteSellHaggleAcceptButtonCommand (window,haggle,Windows.BN_CLICKED);
        ELSE
          ComputeNewAskingPrice (window,haggle,offer);
        END; (* IF *)
      END DetermineCounterOffer;
      
    BEGIN (* ExecuteSellHaggleOfferButtonCommand *)
      IF command = Windows.BN_CLICKED THEN
        MStores8.DetermineNewPlayerOffer (window,MSHaggle.CurrentOfferEditTextControl,haggle,-1,offer,done);
        
        IF done THEN
          DetermineCounterOffer (window,haggle,offer);
        END; (* IF *)
      END; (* IF *)
    END ExecuteSellHaggleOfferButtonCommand;
  
  BEGIN (* ExecuteSellHaggleCommand *)
    haggle := MSHaggle.StoreHaggleInfoPointer (data);
    
    CASE control OF
      MSHaggle.MakeOfferPushButtonControl,Windows.IDOK : ExecuteSellHaggleOfferButtonCommand (window,haggle^,command);  |
      MSHaggle.AcceptPushButtonControl                 : ExecuteSellHaggleAcceptButtonCommand (window,haggle^,command); |
      
      MSHaggle.CancelPushButtonControl,Windows.IDCANCEL : ExecuteCancelButton (window,command); |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteSellHaggleCommand;
  
  PROCEDURE InitializeSellHaggleDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
    VAR
        result : MSHaggle.StoreHaggleInfoPointer;
        value  : LONGINT;
    
    PROCEDURE InitializeSellHaggleDialogDisplay (window : Windows.HWND; VAR haggle : MSHaggle.StoreHaggleInformation);
    BEGIN (* InitializeSellHaggleDialogDisplay *)
      MStores5.InitializeObjectDescription (window,MSHaggle.ItemDescriptionEditTextControl,haggle.info^.player,haggle.info^.item);
      
      WDialog.SetDlgItemLongInt (window,MSHaggle.AskingPriceDisplayStaticTextControl,haggle.currentASK);
      
      WDialog.SetDlgItemText (window,MSHaggle.CurrentOfferPromptStaticTextControl,"What price do you ask?");
      WDialog.SetDlgItemText (window,MSHaggle.PreviousPlayerOfferPromptStaticTextControl,"Your last bid:");
      WDialog.SetDlgItemText (window,MSHaggle.PreviousPlayerOfferDisplayStaticTextControl,"");
    END InitializeSellHaggleDialogDisplay;
    
  BEGIN (* InitializeSellHaggleDialog *)
    result := MSHaggle.StoreHaggleInfoPointer (data);
    value  := WMacro.MaxLongInt ((MStores.BasicItemValue (result^.info^.player^.treasures,result^.info^.item) * (200 - MCSActions.CharacterCharismaAdjustment (result^.info^.player^.character)) DIV 100) * (200 - result^.info^.store^.owner.raceADJ) DIV 100,1);
    
    WITH result^ DO
      maxCHANGE := 3 * info^.store^.owner.haggleRATE;
      minCHANGE := info^.store^.owner.haggleRATE;
      
      currentASK := WMacro.MaxLongInt (value * (200 - info^.store^.owner.inflateMAX) DIV 100,1);
      prevOFFER  := WMacro.MaxLongInt (value * info^.store^.owner.inflateMAX DIV 100,currentASK + 1);
      finalASK   := WMacro.MaxLongInt (value * (200 - info^.store^.owner.inflateMIN) DIV 100,1);
      
      finalCOUNT := 0;
      offerCOUNT := 0;
      
      IF currentASK > info^.store^.owner.priceLIMIT THEN
        MMWindow.DisplayStoreMessage (window,info^.player,info^.store^.owner.description,"I am sorry, but I have not the money to afford such a fine item.");
        WDialog.SetDlgItemText (window,MSHaggle.AskingPricePromptStaticTextControl,"Final offer:");
        
        currentASK := info^.store^.owner.priceLIMIT;
        finalCOUNT := 1;
        finalASK   := currentASK;
        
        haggled := FALSE;
      ELSIF MStores.NoNeedToBargain (info^.store^,finalASK) THEN
        MMWindow.DisplayPopupMessage (window,info^.player,"After a long bargaining session, you agree upon the price.");
        WDialog.SetDlgItemText (window,MSHaggle.AskingPricePromptStaticTextControl,"Final offer:");
        
        currentASK := finalASK;
        haggled    := FALSE;
      ELSE
        WDialog.SetDlgItemText (window,MSHaggle.AskingPricePromptStaticTextControl,"Offer:");
        
        haggled := TRUE;
      END; (* IF *)
      
      MSHaggle.InitializeHaggleTitle (window,info^.store^.owner.description);
      
      info^.ejected := FALSE;
    END; (* WITH *)
    
    InitializeSellHaggleDialogDisplay (window,result^);
  END InitializeSellHaggleDialog;
END MStores9.
