IMPLEMENTATION MODULE MSUpdate;
  (*/WIN:A*)
  
  IMPORT WPainting;
  
  IMPORT MCStruct,MStruct;
  IMPORT MCSActs2;
  IMPORT MSText;
  
  
  PROCEDURE InitializeStatusWindows (player : MStruct.PlayerInfoPointer);
    PROCEDURE SetClassControlText (player : MStruct.PlayerInfoPointer);
      CONST
            ClassControlColumn = 0;
            ClassControlLine   = 1;
      
      VAR
          text : ARRAY [0..15] OF CHAR;
      
    BEGIN (* SetClassControlText *)
      MCSActs2.ReturnClassMnemonicString (player^.character^.constants.class,text);
      MSText.SetStatusControlText (player,ClassControlLine,ClassControlColumn,text,MStruct.NormalValue);
    END SetClassControlText;
    
    PROCEDURE SetRaceControlText (player : MStruct.PlayerInfoPointer);
      CONST
            RaceControlColumn = 0;
            RaceControlLine   = 0;
      
      VAR
          text : ARRAY [0..15] OF CHAR;
      
    BEGIN (* SetRaceControlText *)
      MCSActs2.ReturnRaceMnemonicString (player^.character^.constants.race,text);
      MSText.SetStatusControlText (player,RaceControlLine,RaceControlColumn,text,MStruct.NormalValue);
    END SetRaceControlText;
    
    PROCEDURE UpdateAllStatisticWindows (player : MStruct.PlayerInfoPointer);
      VAR
          index : MCStruct.PlayerStatisticMnemonic;
      
    BEGIN (* UpdateAllStatisticWindows *)
      FOR index := MIN (MCStruct.PlayerStatisticMnemonic) TO MAX (MCStruct.PlayerStatisticMnemonic) DO
        UpdateStatisticWindow (player,index);
      END; (* FOR *)
    END UpdateAllStatisticWindows;
    
  BEGIN (* InitializeStatusWindows *)
    SetClassControlText (player);
    SetRaceControlText (player);
    
    UpdateCurrentLevelWindows (player);
    UpdateAllStatisticWindows (player);
    
    UpdateCurrentArmorClassWindow (player);
    UpdateCurrentExperienceWindow (player);
    UpdateMaximumHitPointsWindow (player);
    UpdateCurrentHitPointsWindow (player);
    UpdateCurrentGoldWindow (player);
    UpdateCurrentManaWindow (player);
    
    UpdateTotalWinnerStatusWindow (player);
    UpdateSearchRestStatusWindow (player);
    UpdateBlindnessStatusWindow (player);
    UpdateConfusedStatusWindow (player);
    UpdatePoisonedStatusWindow (player);
    UpdateAfraidStatusWindow (player);
    UpdateHungerStatusWindow (player);
    UpdateCurrentSpeedWindow (player);
    UpdateWizardStatusWindow (player);
    UpdateStudyStatusWindow (player);
    
    UpdateCurrentDepthWindow (player);
  END InitializeStatusWindows;
  
  PROCEDURE InvalidateStatusWindows (player : MStruct.PlayerInfoPointer);
    VAR
        line,column : CARDINAL;
    
  BEGIN (* InvalidateStatusWindows *)
    WPainting.InvalidateEntireWindow (player^.windows.status.handle,TRUE);
    
    FOR line := 0 TO MStruct.MaxStatusDisplayLines - 1 DO
      FOR column := 0 TO MStruct.MaxStatusDisplayColumns - 1 DO
        WPainting.InvalidateEntireWindow (player^.windows.status.table [line,column].handle,TRUE);
      END; (* FOR *)
    END; (* FOR *)
  END InvalidateStatusWindows;
  
  PROCEDURE UpdateAfraidStatusWindow (player : MStruct.PlayerInfoPointer);
    CONST
          AfraidControlColumn = 1;
          AfraidControlLine   = 20;
    
  BEGIN (* UpdateAfraidStatusWindow *)
    IF MCStruct.FearFLAG IN player^.character^.variables.status THEN
      MSText.SetStatusControlText (player,AfraidControlLine,AfraidControlColumn,"Afraid",MStruct.WarningValue);
    ELSE
      MSText.SetStatusControlText (player,AfraidControlLine,AfraidControlColumn,"",MStruct.NormalValue);
    END; (* IF *)
  END UpdateAfraidStatusWindow;
  
  PROCEDURE UpdateBlindnessStatusWindow (player : MStruct.PlayerInfoPointer);
    CONST
          BlindControlColumn = 0;
          BlindControlLine   = 19;
    
  BEGIN (* UpdateBlindnessStatusWindow *)
    IF MCStruct.BlindFLAG IN player^.character^.variables.status THEN
      MSText.SetStatusControlText (player,BlindControlLine,BlindControlColumn,"Blind",MStruct.WarningValue);
    ELSE
      MSText.SetStatusControlText (player,BlindControlLine,BlindControlColumn,"",MStruct.NormalValue);
    END; (* IF *)
  END UpdateBlindnessStatusWindow;
  
  PROCEDURE UpdateConfusedStatusWindow (player : MStruct.PlayerInfoPointer);
    CONST
          ConfusedControlColumn = 0;
          ConfusedControlLine   = 20;
    
  BEGIN (* UpdateConfusedStatusWindow *)
    IF MCStruct.ConfusedFLAG IN player^.character^.variables.status THEN
      MSText.SetStatusControlText (player,ConfusedControlLine,ConfusedControlColumn,"Confused",MStruct.WarningValue);
    ELSE
      MSText.SetStatusControlText (player,ConfusedControlLine,ConfusedControlColumn,"",MStruct.NormalValue);
    END; (* IF *)
  END UpdateConfusedStatusWindow;
  
  PROCEDURE UpdateCurrentArmorClassWindow (player : MStruct.PlayerInfoPointer);
    CONST
          ArmorClassControlColumn = 0;
          ArmorClassControlLine   = 16;
    
  BEGIN (* UpdateCurrentArmorClassWindow *)
    MSText.SetStatusControlInteger (player,ArmorClassControlLine,ArmorClassControlColumn,"AC:   %VALUE","%VALUE",player^.character^.variables.armorDISP,MStruct.NormalValue);
  END UpdateCurrentArmorClassWindow;
  
  PROCEDURE UpdateCurrentDepthWindow (player : MStruct.PlayerInfoPointer);
    CONST
          CurrentDepthControlColumn = 0;
          CurrentDepthControlLine   = 25;
    
  BEGIN (* UpdateCurrentDepthWindow *)
    IF player^.character^.variables.depthCUR > 0 THEN
      MSText.SetStatusControlCardinal (player,CurrentDepthControlLine,CurrentDepthControlColumn,"%VALUE feet","%VALUE",player^.character^.variables.depthCUR * 50,MStruct.NormalValue);
    ELSE
      MSText.SetStatusControlText (player,CurrentDepthControlLine,CurrentDepthControlColumn,"Town Level",MStruct.NormalValue);
    END; (* IF *)
  END UpdateCurrentDepthWindow;
  
  PROCEDURE UpdateCurrentExperienceWindow (player : MStruct.PlayerInfoPointer);
    CONST
          CurrentExperienceControlColumn = 0;
          CurrentExperienceControlLine   = 12;
    
  BEGIN (* UpdateCurrentExperienceWindow *)
    IF player^.character^.variables.experCUR < player^.character^.variables.experMAX THEN
      MSText.SetStatusControlLongInt (player,CurrentExperienceControlLine,CurrentExperienceControlColumn,"EXP:  %VALUE","%VALUE",LONGTRUNC (player^.character^.variables.experCUR),MStruct.WarningValue);
    ELSE
      MSText.SetStatusControlLongInt (player,CurrentExperienceControlLine,CurrentExperienceControlColumn,"EXP:  %VALUE","%VALUE",LONGTRUNC (player^.character^.variables.experCUR),MStruct.NormalValue);
    END; (* IF *)
  END UpdateCurrentExperienceWindow;
  
  PROCEDURE UpdateCurrentGoldWindow (player : MStruct.PlayerInfoPointer);
    CONST
          CurrentGoldControlColumn = 0;
          CurrentGoldControlLine   = 17;
    
  BEGIN (* UpdateCurrentGoldWindow *)
    MSText.SetStatusControlLongInt (player,CurrentGoldControlLine,CurrentGoldControlColumn,"GOLD: %VALUE","%VALUE",player^.character^.variables.currentGOLD,MStruct.NormalValue);
  END UpdateCurrentGoldWindow;
  
  PROCEDURE UpdateCurrentHitPointsWindow (player : MStruct.PlayerInfoPointer);
    CONST
          CurrentHitPointsControlColumn = 0;
          CurrentHitPointsControlLine   = 15;
    
  BEGIN (* UpdateCurrentHitPointsWindow *)
    IF player^.character^.variables.hpCUR < player^.character^.variables.hpMAX / 2.0 THEN
      MSText.SetStatusControlCardinal (player,CurrentHitPointsControlLine,CurrentHitPointsControlColumn,"CHP:  %VALUE","%VALUE",TRUNC (player^.character^.variables.hpCUR),MStruct.WarningValue);
    ELSE
      MSText.SetStatusControlCardinal (player,CurrentHitPointsControlLine,CurrentHitPointsControlColumn,"CHP:  %VALUE","%VALUE",TRUNC (player^.character^.variables.hpCUR),MStruct.NormalValue);
    END; (* IF *)
  END UpdateCurrentHitPointsWindow;
  
  PROCEDURE UpdateCurrentLevelWindows (player : MStruct.PlayerInfoPointer);
    PROCEDURE SetCurrentLevelControlWindow (player : MStruct.PlayerInfoPointer);
      CONST
            CurrentLevelControlColumn = 0;
            CurrentLevelControlLine   = 11;
      
    BEGIN (* SetCurrentLevelControlWindow *)
      MSText.SetStatusControlCardinal (player,CurrentLevelControlLine,CurrentLevelControlColumn,"LEV:  %VALUE","%VALUE",player^.character^.variables.level,MStruct.NormalValue);
    END SetCurrentLevelControlWindow;
    
    PROCEDURE SetCurrentTitleControlWindow (player : MStruct.PlayerInfoPointer);
      CONST
            CurrentTitleControlColumn = 0;
            CurrentTitleControlLine   = 2;
      
    BEGIN (* SetCurrentTitleControlWindow *)
      MSText.SetStatusControlText (player,CurrentTitleControlLine,CurrentTitleControlColumn,player^.character^.constants.titleTABLE [player^.character^.variables.level],MStruct.NormalValue);
    END SetCurrentTitleControlWindow;
    
  BEGIN (* UpdateCurrentLevelWindows *)
    SetCurrentTitleControlWindow (player);
    SetCurrentLevelControlWindow (player);
  END UpdateCurrentLevelWindows;
  
  PROCEDURE UpdateCurrentManaWindow (player : MStruct.PlayerInfoPointer);
    CONST
          CurrentManaControlColumn = 0;
          CurrentManaControlLine   = 13;
    
  BEGIN (* UpdateCurrentManaWindow *)
    IF player^.character^.variables.manaCUR < player^.character^.variables.manaMAX / 2.0 THEN
      MSText.SetStatusControlCardinal (player,CurrentManaControlLine,CurrentManaControlColumn,"MANA: %VALUE","%VALUE",TRUNC (player^.character^.variables.manaCUR),MStruct.WarningValue);
    ELSE
      MSText.SetStatusControlCardinal (player,CurrentManaControlLine,CurrentManaControlColumn,"MANA: %VALUE","%VALUE",TRUNC (player^.character^.variables.manaCUR),MStruct.NormalValue);
    END; (* IF *)
  END UpdateCurrentManaWindow;
  
  PROCEDURE UpdateCurrentSpeedWindow (player : MStruct.PlayerInfoPointer);
    CONST
          CurrentSpeedStatusControlColumn = 1;
          CurrentSpeedStatusControlLine   = 22;
    
    VAR
        speed : INTEGER;
    
  BEGIN (* UpdateCurrentSpeedWindow *)
    IF MCStruct.SearchFLAG IN player^.character^.variables.status THEN
      speed := player^.character^.variables.speed - 1;
    ELSE
      speed := player^.character^.variables.speed;
    END; (* IF *)
    
    IF speed > +1 THEN
      MSText.SetStatusControlText (player,CurrentSpeedStatusControlLine,CurrentSpeedStatusControlColumn,"Very Slow",MStruct.WarningValue);
    ELSIF speed = +1 THEN
      MSText.SetStatusControlText (player,CurrentSpeedStatusControlLine,CurrentSpeedStatusControlColumn,"Slow",MStruct.WarningValue);
    ELSIF speed = 0 THEN
      MSText.SetStatusControlText (player,CurrentSpeedStatusControlLine,CurrentSpeedStatusControlColumn,"",MStruct.NormalValue);
    ELSIF speed = -1 THEN
      MSText.SetStatusControlText (player,CurrentSpeedStatusControlLine,CurrentSpeedStatusControlColumn,"Fast",MStruct.NormalValue);
    ELSE
      MSText.SetStatusControlText (player,CurrentSpeedStatusControlLine,CurrentSpeedStatusControlColumn,"Very Fast",MStruct.WarningValue);
    END; (* IF *)
  END UpdateCurrentSpeedWindow;
  
  PROCEDURE UpdateHungerStatusWindow (player : MStruct.PlayerInfoPointer);
    CONST
          HungerStatusControlColumn = 1;
          HungerStatusControlLine   = 19;
    
  BEGIN (* UpdateHungerStatusWindow *)
    IF MCStruct.WeakFLAG IN player^.character^.variables.status THEN
      MSText.SetStatusControlText (player,HungerStatusControlLine,HungerStatusControlColumn,"Weak",MStruct.WarningValue);
    ELSIF MCStruct.HungryFLAG IN player^.character^.variables.status THEN
      MSText.SetStatusControlText (player,HungerStatusControlLine,HungerStatusControlColumn,"Hungry",MStruct.WarningValue);
    ELSE
      MSText.SetStatusControlText (player,HungerStatusControlLine,HungerStatusControlColumn,"",MStruct.NormalValue);
    END; (* IF *)
  END UpdateHungerStatusWindow;
  
  PROCEDURE UpdateMarkedStatisticWindows (player : MStruct.PlayerInfoPointer);
    TYPE
         StatusStatisticRange = [MCStruct.StrFLAG..MCStruct.ChrFLAG];
    
    VAR
        index : StatusStatisticRange;
    
  BEGIN (* UpdateMarkedStatisticWindows *)
    FOR index := MIN (StatusStatisticRange) TO MAX (StatusStatisticRange) DO
      IF index IN player^.character^.variables.status THEN
        UpdateStatisticWindow (player,VAL (MCStruct.PlayerStatisticMnemonic,ORD (index) - ORD (MIN (StatusStatisticRange))));
      END; (* IF *)
    END; (* FOR *)
  END UpdateMarkedStatisticWindows;
  
  PROCEDURE UpdateMaximumHitPointsWindow (player : MStruct.PlayerInfoPointer);
    CONST
          MaximumHitPointsColumn = 0;
          MaximumHitPointsLine   = 14;
    
  BEGIN (* UpdateMaximumHitPointsWindow *)
    MSText.SetStatusControlCardinal (player,MaximumHitPointsLine,MaximumHitPointsColumn,"MHP:  %VALUE","%VALUE",TRUNC (player^.character^.variables.hpMAX),MStruct.NormalValue);
  END UpdateMaximumHitPointsWindow;
  
  PROCEDURE UpdatePoisonedStatusWindow (player : MStruct.PlayerInfoPointer);
    CONST
          PoisonedControlColumn = 0;
          PoisonedControlLine   = 21;
    
  BEGIN (* UpdatePoisonedStatusWindow *)
    IF MCStruct.PoisonedFLAG IN player^.character^.variables.status THEN
      MSText.SetStatusControlText (player,PoisonedControlLine,PoisonedControlColumn,"Poisoned",MStruct.WarningValue);
    ELSE
      MSText.SetStatusControlText (player,PoisonedControlLine,PoisonedControlColumn,"",MStruct.NormalValue);
    END; (* IF *)
  END UpdatePoisonedStatusWindow;
  
  PROCEDURE UpdateSearchRestStatusWindow (player : MStruct.PlayerInfoPointer);
    CONST
          SearchRestStatusColumn = 1;
          SearchRestStatusLine   = 21;
    
  BEGIN (* UpdateSearchRestStatusWindow *)
    IF player^.character^.variables.counters [MCStruct.ParalysisCOUNT] > 1 THEN
      MSText.SetStatusControlText (player,SearchRestStatusLine,SearchRestStatusColumn,"Paralysed",MStruct.WarningValue);
    ELSIF MCStruct.SearchFLAG IN player^.character^.variables.status THEN
      MSText.SetStatusControlText (player,SearchRestStatusLine,SearchRestStatusColumn,"Searching",MStruct.NormalValue);
    ELSIF MCStruct.RestFLAG IN player^.character^.variables.status THEN
      MSText.SetStatusControlText (player,SearchRestStatusLine,SearchRestStatusColumn,"Resting",MStruct.NormalValue);
    ELSE
      MSText.SetStatusControlText (player,SearchRestStatusLine,SearchRestStatusColumn,"",MStruct.NormalValue);
    END; (* IF *)
  END UpdateSearchRestStatusWindow;
  
  PROCEDURE UpdateStatisticWindow (player : MStruct.PlayerInfoPointer; statistic : MCStruct.PlayerStatisticMnemonic);
    CONST
          StatisticControlBaseLine = 4;
          StatisticControlColumn   = 0;
    
    VAR
        color : MStruct.StatusControlColorMnemonic;
    
    PROCEDURE ColorMnemonicForStatistic (player : MStruct.PlayerInfoPointer; statistic : MCStruct.PlayerStatisticMnemonic) : MStruct.StatusControlColorMnemonic;
    BEGIN (* ColorMnemonicForStatistic *)
      IF player^.character^.statistics.current [statistic] < player^.character^.statistics.maximum [statistic] THEN
        RETURN (MStruct.WarningValue);
      ELSE
        RETURN (MStruct.NormalValue);
      END; (* IF *)
    END ColorMnemonicForStatistic;
    
  BEGIN (* UpdateStatisticWindow *)
    color := ColorMnemonicForStatistic (player,statistic);
    
    CASE statistic OF
      MCStruct.str : MSText.SetStatusControlStatistic (player,StatisticControlBaseLine + ORD (statistic),StatisticControlColumn,"STR: %VALUE","%VALUE",player^.character^.statistics.used [statistic],color); |
      MCStruct.int : MSText.SetStatusControlStatistic (player,StatisticControlBaseLine + ORD (statistic),StatisticControlColumn,"INT: %VALUE","%VALUE",player^.character^.statistics.used [statistic],color); |
      MCStruct.wis : MSText.SetStatusControlStatistic (player,StatisticControlBaseLine + ORD (statistic),StatisticControlColumn,"WIS: %VALUE","%VALUE",player^.character^.statistics.used [statistic],color); |
      MCStruct.dex : MSText.SetStatusControlStatistic (player,StatisticControlBaseLine + ORD (statistic),StatisticControlColumn,"DEX: %VALUE","%VALUE",player^.character^.statistics.used [statistic],color); |
      MCStruct.con : MSText.SetStatusControlStatistic (player,StatisticControlBaseLine + ORD (statistic),StatisticControlColumn,"CON: %VALUE","%VALUE",player^.character^.statistics.used [statistic],color); |
      MCStruct.chr : MSText.SetStatusControlStatistic (player,StatisticControlBaseLine + ORD (statistic),StatisticControlColumn,"CHR: %VALUE","%VALUE",player^.character^.statistics.used [statistic],color); |
    END; (* CASE *)
    
    EXCL (player^.character^.variables.status,VAL (MCStruct.PlayerStatusMnemonic,ORD (MCStruct.StrFLAG) + ORD (statistic)));
  END UpdateStatisticWindow;
  
  PROCEDURE UpdateStudyStatusWindow (player : MStruct.PlayerInfoPointer);
    CONST
          StudyControlColumn = 0;
          StudyControlLine   = 22;
    
  BEGIN (* UpdateStudyStatusWindow *)
    IF MCStruct.StudyFLAG IN player^.character^.variables.status THEN
      MSText.SetStatusControlText (player,StudyControlLine,StudyControlColumn,"Study",MStruct.WarningValue);
    ELSE
      MSText.SetStatusControlText (player,StudyControlLine,StudyControlColumn,"",MStruct.NormalValue);
    END; (* IF *)
  END UpdateStudyStatusWindow;
  
  PROCEDURE UpdateTotalWinnerStatusWindow (player : MStruct.PlayerInfoPointer);
    CONST
          TotalWinnerControlColumn = 1;
          TotalWinnerControlLine   = 24;
    
  BEGIN (* UpdateTotalWinnerStatusWindow *)
    IF MCStruct.TotalWinnerFLAG IN player^.character^.variables.status THEN
      MSText.SetStatusControlText (player,TotalWinnerControlLine,TotalWinnerControlColumn,"*Winner*",MStruct.WarningValue);
    ELSE
      MSText.SetStatusControlText (player,TotalWinnerControlLine,TotalWinnerControlColumn,"",MStruct.NormalValue);
    END; (* IF *)
  END UpdateTotalWinnerStatusWindow;
  
  PROCEDURE UpdateWizardStatusWindow (player : MStruct.PlayerInfoPointer);
    CONST
          WizardControlColumn = 0;
          WizardControlLine   = 24;
    
  BEGIN (* UpdateWizardStatusWindow *)
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      MSText.SetStatusControlText (player,WizardControlLine,WizardControlColumn,"Wizard",MStruct.WarningValue);
    ELSIF MCStruct.FormerWizardFLAG IN player^.character^.variables.status THEN
      MSText.SetStatusControlText (player,WizardControlLine,WizardControlColumn,"Former Wizard",MStruct.NormalValue);
    ELSE
      MSText.SetStatusControlText (player,WizardControlLine,WizardControlColumn,"",MStruct.NormalValue);
    END; (* IF *)
  END UpdateWizardStatusWindow;
END MSUpdate.
