IMPLEMENTATION MODULE MTitle;
  (*/WIN:A*)
  
  IMPORT WBitmap,WDisplay,WDTool,Win31,Windows,WinStart,WPainting,WPalette,WResource;
  IMPORT SYSTEM;
  
  
  VAR
      TitleBitmapPaletteHandle : Windows.HPALETTE;
      TitleBitmapHandle        : Windows.HGLOBAL;
  
  VAR
      NumberBitmapColors : CARDINAL;
  
  
  PROCEDURE DestroyTitleBitmap;
    VAR
        done : BOOLEAN;
    
  BEGIN (* DestroyTitleBitmap *)
    WDTool.DeleteObject (TitleBitmapPaletteHandle,done);
    WResource.FreeResource (TitleBitmapHandle,done);
  END DestroyTitleBitmap;
  
  PROCEDURE DisplayTitleBitmap (window : Windows.HWND);
    VAR
        previousPALETTE : Windows.HPALETTE;
        context         : Windows.HDC;
        struct          : Windows.PAINTSTRUCT;
        mapped          : CARDINAL;
    
    PROCEDURE SelectDIBitmap (window : Windows.HWND; context : Windows.HDC; handle : Windows.HGLOBAL; colors : CARDINAL);
      VAR
          client : Windows.RECT;
          result : INTEGER;
          done   : BOOLEAN;
          ptr    : Windows.LPBITMAPINFO;
      
    BEGIN (* SelectDIBitmap *)
      ptr := Windows.LPBITMAPINFO (WResource.LockResource (handle));
      WDisplay.GetClientRect (window,client);
      
      WBitmap.SetDIBitsToDevice (context,client.right DIV 2 - VAL (INTEGER,ptr^.bmiHeader.biWidth DIV 2),client.bottom DIV 2 - VAL (INTEGER,ptr^.bmiHeader.biHeight DIV 2),ptr^.bmiHeader.biWidth,ptr^.bmiHeader.biHeight,0,0,0,ptr^.bmiHeader.biHeight,SYSTEM.ADDRESS (ptr) + ptr^.bmiHeader.biSize + colors * SIZE (Windows.RGBQUAD),ptr,Windows.DIB_RGB_COLORS,result);
      
      WResource.UnlockResource (handle,done);
    END SelectDIBitmap;
    
  BEGIN (* DisplayTitleBitmap *)
    WPainting.BeginPaint (window,struct,context);
    
    WPalette.SelectPalette (context,TitleBitmapPaletteHandle,FALSE,previousPALETTE);
    WPalette.RealizePalette (context,mapped);
    
    SelectDIBitmap (window,context,TitleBitmapHandle,NumberBitmapColors);
    
    WPainting.EndPaint (window,struct);
  END DisplayTitleBitmap;
  
  PROCEDURE InitializeTitleBitmap;
    VAR
        bitmap : Windows.LPBITMAPINFO;
        done   : BOOLEAN;
    
    PROCEDURE LoadTitleBitmapResource (VAR handle : Windows.HGLOBAL; VAR ptr : Windows.LPBITMAPINFO);
    BEGIN (* LoadTitleBitmapResource *)
      WResource.LoadResource (WinStart.hInstance,WResource.FindStandardResource (WinStart.hInstance,"Title_Page",Win31.RT_BITMAP),handle);
      ptr := Windows.LPBITMAPINFO (WResource.LockResource (handle));
    END LoadTitleBitmapResource;
    
  BEGIN (* InitializeTitleBitmap *)
    LoadTitleBitmapResource (TitleBitmapHandle,bitmap);
    
    WPalette.CreateBitmapPalette (bitmap,TitleBitmapPaletteHandle,NumberBitmapColors);
    
    WResource.UnlockResource (TitleBitmapHandle,done);
  END InitializeTitleBitmap;
END MTitle.
