IMPLEMENTATION MODULE MTraps;
  (*/WIN:A*)
  
  IMPORT MCreatures,MDistMove,MDGAlloc,MDGenerator,MDPainting,MDWindow,MMWindow,MPAttacks,MPDamage,MPMovement,MRandom,MScrl2,ODescriptions;
  IMPORT DSActions,MCSActions,MSActs2,OSActions;
  IMPORT DStruct,MCStruct,MStruct,OStruct;
  IMPORT WDebugging;
  
  
  CONST
        NumberStandardTraps = 18;
  
  VAR
      ExecuteTrapActions : ARRAY [1..NumberStandardTraps] OF PROCEDURE (MStruct.PlayerInfoPointer,CARDINAL,ARRAY OF CHAR);
  
  
  PROCEDURE DisarmFloorTrapAtLocation (player : MStruct.PlayerInfoPointer; ability : INTEGER; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; trap : OStruct.InventoryItemRecord);
  BEGIN (* DisarmFloorTrapAtLocation *)
    IF ability + 100 - VAL (INTEGER,trap.object.depth) > MRandom.IntegerRandomRangeValue (1,100) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You have disarmed the trap.");
      
      DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
      MPMovement.MoveCharacterToLocation (player,line,column);
      
      MSActs2.IncreasePlayerExperience (player,FLOAT (trap.object.miscellaneous));
    ELSIF ((ability > 5) AND (MRandom.CardinalRandomRangeValue (1,ability) > 5)) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You failed to disarm the trap.");
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You set off the trap.");
      
      MPMovement.MoveCharacterToLocation (player,line,column);
    END; (* IF *)
  END DisarmFloorTrapAtLocation;
  
  PROCEDURE ExecuteTrapAction (player : MStruct.PlayerInfoPointer; VAR trap : OStruct.InventoryItemRecord);
    VAR
        description : ARRAY [0..127] OF CHAR;
    
  BEGIN (* ExecuteTrapAction *)
    MDistMove.EndDistanceMovement (player);
    MakeTrapVisible (player,player^.character^.line,player^.character^.column,trap);
    
    IF trap.object.subclass <> RuneOfProtectionSubclass THEN
      ODescriptions.ReturnObjectDescription (player,trap,TRUE,description);
      ExecuteTrapActions [trap.object.subclass] (player,MRandom.CardinalRandomRangeValue (trap.object.damage.min,trap.object.damage.max),description);
    END; (* IF *)
  END ExecuteTrapAction;
  
  PROCEDURE MakeTrapVisible (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR trap : OStruct.InventoryItemRecord);
  BEGIN (* MakeTrapVisible *)
    IF trap.object.class = OStruct.InvisibleTrap THEN
      trap.object.class := OStruct.VisibleTrap;
      MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
    END; (* IF *)
  END MakeTrapVisible;
  
  PROCEDURE TrapStrikesPlayer (player : MStruct.PlayerInfoPointer) : BOOLEAN;
  BEGIN (* TrapStrikesPlayer *)
    RETURN (MPAttacks.SuccessfulAttack (player,125,0,0,player^.character^.variables.armorREAL + player^.character^.variables.bonusREAL.armor,MCSActions.ClassSaveLevelAdjustment (player^.character^.constants.class)));
  END TrapStrikesPlayer;
  

  PROCEDURE ExecuteAcidTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteAcidTrapAction *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are splashed with acid!");
    MPDamage.DamagePlayerWithAcid (player,damage,"an acid trap");
  END ExecuteAcidTrapAction;
  
  PROCEDURE ExecuteArrowTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteArrowTrapAction *)
    IF TrapStrikesPlayer (player) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"An arrow hits you.");
      MPDamage.ReduceCharacterHitPoints (player,damage,description);
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"An arrow barely misses you.");
    END; (* IF *)
  END ExecuteArrowTrapAction;
  
  PROCEDURE ExecuteBlindGasTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteBlindGasTrapAction *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A black gas surrounds you!");
    INC (player^.character^.variables.counters [MCStruct.BlindCOUNT],MRandom.CardinalRandomRangeValue (1,50) + 50);
  END ExecuteBlindGasTrapAction;
  
  PROCEDURE ExecuteConfusionGasTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteConfusionGasTrapAction *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A gas of scintillating colors surrounds you!");
    INC (player^.character^.variables.counters [MCStruct.ConfusedCOUNT],MRandom.CardinalRandomRangeValue (1,15) + 15);
  END ExecuteConfusionGasTrapAction;
  
  PROCEDURE ExecuteConstitutionDartTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteConstitutionDartTrapAction *)
    IF NOT (TrapStrikesPlayer (player)) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A small dart barely misses you!");
    ELSIF MCStruct.SustainConFLAG IN player^.character^.variables.status THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A small dart hits you.");
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A small dart saps your health!");
      
      MPDamage.ReduceCharacterHitPoints (player,damage,description);
      MSActs2.DecrementStatistic (player,MCStruct.con);
    END; (* IF *)
  END ExecuteConstitutionDartTrapAction;
  
  PROCEDURE ExecuteCorrodeGasTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteCorrodeGasTrapAction *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A strange red gas surrounds you.");
    MPDamage.DamagePlayerWithCorrosion (player,"corrosion gas");
  END ExecuteCorrodeGasTrapAction;
  
  PROCEDURE ExecuteCoveredPitTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
    CONST
          OpenPitTrapCursor = 378;
    
  BEGIN (* ExecuteCoveredPitTrapAction *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You fell into a covered pit.");
    
    IF MCStruct.FeatherFallingFLAG IN player^.character^.variables.status THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You float gently down.");
    ELSE
      MPDamage.ReduceCharacterHitPoints (player,damage,description);
    END; (* IF *)
    
    OSActions.ReturnInventoryItemRecord (player^.treasures,OpenPitTrapCursor,player^.dungeon^.artifacts [player^.dungeon^.physical [player^.character^.line]^ [player^.character^.column].artifact]);
  END ExecuteCoveredPitTrapAction;
  
  PROCEDURE ExecuteFireTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteFireTrapAction *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are enveloped in flames!");
    MPDamage.DamagePlayerWithFire (player,damage,"a fire trap");
  END ExecuteFireTrapAction;
  
  PROCEDURE ExecuteHiddenObjectTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteHiddenObjectTrapAction *)
    DSActions.DeleteArtifactInformation (player^.dungeon^,player^.character^.line,player^.character^.column);
    MDGAlloc.PlaceRandomObject (player,player^.dungeon^,player^.character^.line,player^.character^.column,player^.character^.variables.depthCUR,FALSE);
    
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Hmmm, there was something under this rock.");
  END ExecuteHiddenObjectTrapAction;
  
  PROCEDURE ExecuteOpenPitTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteOpenPitTrapAction *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You fell into an open pit.");
    
    IF MCStruct.FeatherFallingFLAG IN player^.character^.variables.status THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You float gently down.");
    ELSE
      MPDamage.ReduceCharacterHitPoints (player,damage,description);
    END; (* IF *)
  END ExecuteOpenPitTrapAction;
  
  PROCEDURE ExecutePoisonGasTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecutePoisonGasTrapAction *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A pugent green gas surrounds you!");
    MPDamage.DamagePlayerWithPoisonGas (player,damage,"a poison gas trap");
  END ExecutePoisonGasTrapAction;
  
  PROCEDURE ExecuteRockfallTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteRockfallTrapAction *)
    MDGAlloc.PlaceRubbleAtLocation (player^.treasures,player^.dungeon^,player^.character^.line,player^.character^.column);
    MPDamage.ReduceCharacterHitPoints (player,damage,"a falling rock");
    
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are hit by falling rock!");
  END ExecuteRockfallTrapAction;
  
  PROCEDURE ExecuteSleepGasTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteSleepGasTrapAction *)
    IF player^.character^.variables.counters [MCStruct.ParalysisCOUNT] = 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A strange white mist surrounds you!");
      
      IF NOT (MCStruct.FreeActionFLAG IN player^.character^.variables.status) THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You fall asleep.");
        player^.character^.variables.counters [MCStruct.ParalysisCOUNT] := MRandom.CardinalRandomRangeValue (1,10) + 4;
      ELSE
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are unaffected.");
      END; (* IF *)
    END; (* IF *)
  END ExecuteSleepGasTrapAction;
  
  PROCEDURE ExecuteSlowDartTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteSlowDartTrapAction *)
    IF TrapStrikesPlayer (player) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A small dart hits you.");
      
      IF MCStruct.FreeActionFLAG IN player^.character^.variables.status THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are unaffected.");
      ELSE
        MPDamage.ReduceCharacterHitPoints (player,damage,description);
        INC (player^.character^.variables.counters [MCStruct.SlowCOUNT],MRandom.CardinalRandomRangeValue (1,20) + 10);
      END; (* IF *)
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A small dart barely misses you.");
    END; (* IF *)
  END ExecuteSlowDartTrapAction;
  
  PROCEDURE ExecuteStrengthDartTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteStrengthDartTrapAction *)
    IF NOT (TrapStrikesPlayer (player)) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A small dart barely misses you.");
    ELSIF MCStruct.SustainStrFLAG IN player^.character^.variables.status THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A small dart hits you.");
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A small dart weakens you!");
      
      MPDamage.ReduceCharacterHitPoints (player,damage,description);
      MSActs2.DecrementStatistic (player,MCStruct.str);
    END; (* IF *)
  END ExecuteStrengthDartTrapAction;
  
  PROCEDURE ExecuteSummonMonsterTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
    VAR
        count : CARDINAL;
        done  : BOOLEAN;
    
  BEGIN (* ExecuteSummonMonsterTrapAction *)
    DSActions.DeleteArtifactInformation (player^.dungeon^,player^.character^.line,player^.character^.column);
    
    FOR count := 1 TO MRandom.CardinalRandomRangeValue (3,5) DO
      MCreatures.SummonRandomMonster (player,player^.character^.line,player^.character^.column,FALSE,done);
    END; (* FOR *)
  END ExecuteSummonMonsterTrapAction;
  
  PROCEDURE ExecuteTeleportTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteTeleportTrapAction *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You hit a teleport trap!");
    MScrl2.ExecuteTeleportScrollAction (player,100);
  END ExecuteTeleportTrapAction;
  
  PROCEDURE ExecuteTrapDoorTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* ExecuteTrapDoorTrapAction *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You fell through a trap door!");
    INC (player^.character^.variables.depthCUR);
    
    IF MCStruct.FeatherFallingFLAG IN player^.character^.variables.status THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You float gently down.");
    ELSE
      MPDamage.ReduceCharacterHitPoints (player,damage,description);
    END; (* IF *)
    
    MDGenerator.GeneratePlayerDungeon (player);
  END ExecuteTrapDoorTrapAction;
  
  
  PROCEDURE InitializeExecuteTrapActionsTable;
    VAR
        index : CARDINAL;
    
  BEGIN (* InitializeExecuteTrapActionsTable *)
    FOR index := 1 TO NumberStandardTraps DO
      ExecuteTrapActions [index] := InvalidTrapAction;
    END; (* FOR *)
    
    ExecuteTrapActions [ 1] := ExecuteOpenPitTrapAction;
    ExecuteTrapActions [ 2] := ExecuteArrowTrapAction;
    ExecuteTrapActions [ 3] := ExecuteCoveredPitTrapAction;
    ExecuteTrapActions [ 4] := ExecuteTrapDoorTrapAction;
    ExecuteTrapActions [ 5] := ExecuteSleepGasTrapAction;
    ExecuteTrapActions [ 6] := ExecuteHiddenObjectTrapAction;
    ExecuteTrapActions [ 7] := ExecuteStrengthDartTrapAction;
    ExecuteTrapActions [ 8] := ExecuteTeleportTrapAction;
    ExecuteTrapActions [ 9] := ExecuteRockfallTrapAction;
    ExecuteTrapActions [10] := ExecuteCorrodeGasTrapAction;
    ExecuteTrapActions [11] := ExecuteSummonMonsterTrapAction;
    ExecuteTrapActions [12] := ExecuteFireTrapAction;
    ExecuteTrapActions [13] := ExecuteAcidTrapAction;
    ExecuteTrapActions [14] := ExecutePoisonGasTrapAction;
    ExecuteTrapActions [15] := ExecuteBlindGasTrapAction;
    ExecuteTrapActions [16] := ExecuteConfusionGasTrapAction;
    ExecuteTrapActions [17] := ExecuteSlowDartTrapAction;
    ExecuteTrapActions [18] := ExecuteConstitutionDartTrapAction;
  END InitializeExecuteTrapActionsTable;
  
  PROCEDURE InvalidTrapAction (player : MStruct.PlayerInfoPointer; damage : CARDINAL; description : ARRAY OF CHAR);
  BEGIN (* InvalidTrapAction *)
    WDebugging.FatalAppExit ("Call to un-initialized trap action.");
  END InvalidTrapAction;
  
BEGIN (* MTraps *)
  InitializeExecuteTrapActionsTable;
END MTraps.
