IMPLEMENTATION MODULE MWands;
  (*/WIN:A*)
  
  IMPORT MBolts,MCSpell3,MCSpell4,MInventory,MISelect,MMTranslator,MMWindow,MPThrow,MRandom,MSpells2,MWands2;
  IMPORT DStruct,MCStruct,MStruct,OStruct;
  IMPORT MCSActions,MSActs2,OSActions;
  IMPORT WDebugging,WMacro;
  
  
  TYPE
       WandActionRange = [0..23];
  
  VAR
      ExecuteWandAction : ARRAY WandActionRange OF PROCEDURE (MStruct.PlayerInfoPointer,DStruct.DungeonLineRange,DStruct.DungeonColumnRange,VAR BOOLEAN);
  
  
  PROCEDURE ExecuteUseWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    TYPE
         WandActionFlags = SET OF WandActionRange;
    
    PROCEDURE ExecuteWandActions (player : MStruct.PlayerInfoPointer; selection : CARDINAL; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; flags : WandActionFlags);
      VAR
          identified : BOOLEAN;
          index      : WandActionRange;
      
      PROCEDURE ExperienceForWand (player : MStruct.PlayerInfoPointer; wand : OStruct.InventoryItemRecord) : REAL;
      BEGIN (* ExperienceForWand *)
        RETURN (FLOAT (VAL (CARDINAL,player^.character^.variables.level DIV 2) + wand.object.depth) / FLOAT (player^.character^.variables.level));
      END ExperienceForWand;
      
    BEGIN (* ExecuteWandActions *)
      identified := FALSE;
      
      FOR index := MIN (WandActionRange) TO MAX (WandActionRange) DO
        IF index IN flags THEN
          ExecuteWandAction [index] (player,line,column,identified);
        END; (* IF *)
      END; (* FOR *)
      
      IF NOT (OSActions.InventoryItemIsKnown1 (player^.treasures,player^.character^.inventory.backpack [selection])) THEN
        IF identified THEN
          MSActs2.IncreasePlayerExperience (player,ExperienceForWand (player,player^.character^.inventory.backpack [selection]));
          MSpells2.IdentifyPlayerInventoryItem (player,selection);
        ELSE
          OSActions.SampleInventoryItem (player^.treasures,player^.character^.inventory.backpack [selection]);
        END; (* IF *)
      END; (* IF *)
      
      OSActions.DecrementItemCharges (player,player^.character^.inventory.backpack [selection]);
    END ExecuteWandActions;
    
    PROCEDURE SuccessfullyUsesWand (player : MStruct.PlayerInfoPointer; wand : OStruct.InventoryItemRecord) : BOOLEAN;
      PROCEDURE PlayerWandAbility (player : MStruct.PlayerInfoPointer; wand : OStruct.InventoryItemRecord) : CARDINAL;
        VAR
            ability : INTEGER;
        
      BEGIN (* PlayerWandAbility *)
        ability := player^.character^.abilities.save + MCSActions.CharacterStatisticAdjustment (player^.character,MCStruct.int) - VAL (INTEGER,wand.object.depth) - 5 + MCSActions.ClassDeviceLevelAdjustment (player^.character^.constants.class) * player^.character^.variables.level DIV 3;
        
        IF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0 THEN
          ability := ability DIV 2;
        END; (* IF *)
        
        IF ((ability < OStruct.DeviceUseChance) AND (MRandom.CardinalRandomRangeValue (1,OStruct.DeviceUseChance - ability + 1) = 1)) THEN
          ability := OStruct.DeviceUseChance;
        END; (* IF *)
        
        RETURN (WMacro.MaxInteger (ability,1));
      END PlayerWandAbility;
      
    BEGIN (* SuccessfullyUsesWand *)
      RETURN (MRandom.CardinalRandomRangeValue (1,PlayerWandAbility (player,wand)) > OStruct.DeviceUseChance);
    END SuccessfullyUsesWand;
    
    PROCEDURE WandExecutionFlags (wand : OStruct.InventoryItemRecord) : WandActionFlags;
      VAR
          result : WandActionFlags;
          index  : WandActionRange;
      
    BEGIN (* WandExecutionFlags *)
      result := WandActionFlags {};
      
      FOR index := MIN (WandActionRange) TO MAX (WandActionRange) DO
        IF VAL (OStruct.ObjectAttributeMnemonic,index) IN wand.object.attributes THEN
          INCL (result,index);
        END; (* IF *)
      END; (* FOR *)
      
      RETURN (result);
    END WandExecutionFlags;
    
  BEGIN (* ExecuteUseWandAction *)
    IF player^.character^.variables.counters [MCStruct.ConfusedCOUNT] > 0 THEN
      MPThrow.DetermineConfusedLocation (player,line,column);
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := TRUE;
    
    IF NOT (SuccessfullyUsesWand (player,player^.character^.inventory.backpack [player^.character^.inventory.selection])) THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You fail to use the wand properly.");
    ELSIF player^.character^.inventory.backpack [player^.character^.inventory.selection].object.miscellaneous = 0 THEN
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"The wand has no charges left.");
      
      IF NOT (OSActions.InventoryItemIsKnown2 (player^.character^.inventory.backpack [player^.character^.inventory.selection])) THEN
        INCL (player^.character^.inventory.backpack [player^.character^.inventory.selection].identification,OStruct.IdentEmpty);
      END; (* IF *)
    ELSE
      ExecuteWandActions (player,player^.character^.inventory.selection,line,column,WandExecutionFlags (player^.character^.inventory.backpack [player^.character^.inventory.selection]));
    END; (* IF *)
  END ExecuteUseWandAction;
  
  PROCEDURE ExecuteUseWandCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteUseWandCommand *)
    IF MInventory.AnyObjectsWithClasses (player^.character^.inventory.backpack,OStruct.ObjectClassSet {OStruct.Wand}) THEN
      MISelect.SelectInventoryItem (player,"Aim which wand?",OStruct.ObjectClassSet {OStruct.Wand},player^.character^.inventory.selection,MStruct.CharacterTurnExecuted);
      
      IF MStruct.CharacterTurnExecuted THEN
        MMTranslator.ExecuteTargetedCommand (player,"Aim wand at what?",ExecuteUseWandAction);
      END; (* IF *)
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"You are not carrying any wands.");
      MStruct.CharacterTurnExecuted := FALSE;
    END; (* IF *)
  END ExecuteUseWandCommand;
  
  
  PROCEDURE ExecuteAcidBallWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteAcidBallWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MWands2.ExecuteAcidBallDamage,identified);
    identified := TRUE;
  END ExecuteAcidBallWandAction;
  
  PROCEDURE ExecuteCloneMonsterWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteCloneMonsterWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MWands2.ExecuteCloneMonsterDamage,identified);
  END ExecuteCloneMonsterWandAction;
  
  PROCEDURE ExecuteConfuseMonsterWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteConfuseMonsterWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell3.ExecuteConfusionDamage,identified);
  END ExecuteConfuseMonsterWandAction;
  
  PROCEDURE ExecuteDisarmTrapsWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteDisarmTrapsWandAction *)
    MWands2.TraceMagicWandBeam (player,player^.character^.line,player^.character^.column,line,column,MWands2.PlotDisarmLocation,identified);
  END ExecuteDisarmTrapsWandAction;
  
  PROCEDURE ExecuteDrainLifeWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteDrainLifeWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MWands2.ExecuteDrainLineDamage,identified);
  END ExecuteDrainLifeWandAction;
  
  PROCEDURE ExecuteFireBallWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteFireBallWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell4.ExecuteFireBallDamage,identified);
    identified := TRUE;
  END ExecuteFireBallWandAction;
  
  PROCEDURE ExecuteFireBoltWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteFireBoltWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell3.ExecuteFireBoltDamage,identified);
    identified := TRUE;
  END ExecuteFireBoltWandAction;
  
  PROCEDURE ExecuteFrostBallWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteFrostBallWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell4.ExecuteFrostBallDamage,identified);
    identified := TRUE;
  END ExecuteFrostBallWandAction;
  
  PROCEDURE ExecuteFrostBoltWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteFrostBoltWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell3.ExecuteFrostBoltDamage,identified);
    identified := TRUE;
  END ExecuteFrostBoltWandAction;
  
  PROCEDURE ExecuteHealMonsterWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteHealMonsterWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MWands2.ExecuteHealMonsterDamage,identified);
  END ExecuteHealMonsterWandAction;
  
  PROCEDURE ExecuteLightningBallWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteLightningBallWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MWands2.ExecuteLightningBallDamage,identified);
    identified := TRUE;
  END ExecuteLightningBallWandAction;
  
  PROCEDURE ExecuteLightningBoltWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteLightningBoltWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell3.ExecuteLightningBoltDamage,identified);
    identified := TRUE;
  END ExecuteLightningBoltWandAction;
  
  PROCEDURE ExecuteLightWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteLightWandAction *)
    MMWindow.DisplayPopupMessage (player^.windows.frame,player,"A line of shimmering blue light appears.");
    MWands2.TraceMagicWandBeam (player,player^.character^.line,player^.character^.column,line,column,MWands2.PlotLightWandLocation,identified);
    
    identified := TRUE;
  END ExecuteLightWandAction;
  
  PROCEDURE ExecuteMagicMissileWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteMagicMissileWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell3.ExecuteMagicMissileDamage,identified);
    identified := TRUE;
  END ExecuteMagicMissileWandAction;
  
  PROCEDURE ExecutePolymorphOtherWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecutePolymorphOtherWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell3.ExecutePloymorphOtherDamage,identified);
  END ExecutePolymorphOtherWandAction;
  
  PROCEDURE ExecuteSleepMonsterWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSleepMonsterWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell3.ExecuteSleep1Damage,identified);
  END ExecuteSleepMonsterWandAction;
  
  PROCEDURE ExecuteSlowMonsterWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSlowMonsterWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell3.ExecuteSlowMonsterDamage,identified);
  END ExecuteSlowMonsterWandAction;
  
  PROCEDURE ExecuteSpeedMonsterWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSpeedMonsterWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MWands2.ExecuteSpeedMonsterDamage,identified);
  END ExecuteSpeedMonsterWandAction;
  
  PROCEDURE ExecuteStinkingCloudWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteStinkingCloudWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell4.ExecuteStinkingCloudDamage,identified);
    identified := TRUE;
  END ExecuteStinkingCloudWandAction;
  
  PROCEDURE ExecuteStoneToMudWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteStoneToMudWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell3.ExecuteStoneToMudDamage,identified);
  END ExecuteStoneToMudWandAction;
  
  PROCEDURE ExecuteTeleportAwayWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteTeleportAwayWandAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell3.ExecuteTeleportOtherDamage,identified);
  END ExecuteTeleportAwayWandAction;
  
  PROCEDURE ExecuteTrapDoorDestructionWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteTrapDoorDestructionWandAction *)
    MWands2.TraceMagicWandBeam (player,player^.character^.line,player^.character^.column,line,column,MWands2.PlotTrapDoorDestructionLocation,identified);
  END ExecuteTrapDoorDestructionWandAction;
  
  PROCEDURE ExecuteWallBuildingWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteWallBuildingWandAction *)
    MWands2.TraceMagicWandBeam (player,player^.character^.line,player^.character^.column,line,column,MWands2.PlotWallBuildingLocation,identified);
  END ExecuteWallBuildingWandAction;
  
  PROCEDURE ExecuteWonderWandAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteWonderWandAction *)
    ExecuteWandAction [MRandom.CardinalRandomRangeValue (MIN (WandActionRange),MAX (WandActionRange))] (player,line,column,identified);
  END ExecuteWonderWandAction;
  
  
  PROCEDURE InitializeExecuteWandActionTable;
    VAR
        index : WandActionRange;
    
  BEGIN (* InitializeExecuteWandActionTable *)
    FOR index := MIN (WandActionRange) TO MAX (WandActionRange) DO
      ExecuteWandAction [index] := InvalidWandActionProcedure;
    END; (* FOR *)
    
    ExecuteWandAction [ 0] := ExecuteLightWandAction;
    ExecuteWandAction [ 1] := ExecuteLightningBoltWandAction;
    ExecuteWandAction [ 2] := ExecuteFrostBoltWandAction;
    ExecuteWandAction [ 3] := ExecuteFireBoltWandAction;
    ExecuteWandAction [ 4] := ExecuteStoneToMudWandAction;
    ExecuteWandAction [ 5] := ExecutePolymorphOtherWandAction;
    ExecuteWandAction [ 6] := ExecuteHealMonsterWandAction;
    ExecuteWandAction [ 7] := ExecuteSpeedMonsterWandAction;
    ExecuteWandAction [ 8] := ExecuteSlowMonsterWandAction;
    ExecuteWandAction [ 9] := ExecuteConfuseMonsterWandAction;
    ExecuteWandAction [10] := ExecuteSleepMonsterWandAction;
    ExecuteWandAction [11] := ExecuteDrainLifeWandAction;
    ExecuteWandAction [12] := ExecuteTrapDoorDestructionWandAction;
    ExecuteWandAction [13] := ExecuteMagicMissileWandAction;
    ExecuteWandAction [14] := ExecuteWallBuildingWandAction;
    ExecuteWandAction [15] := ExecuteCloneMonsterWandAction;
    ExecuteWandAction [16] := ExecuteTeleportAwayWandAction;
    ExecuteWandAction [17] := ExecuteDisarmTrapsWandAction;
    ExecuteWandAction [18] := ExecuteLightningBallWandAction;
    ExecuteWandAction [19] := ExecuteFrostBallWandAction;
    ExecuteWandAction [20] := ExecuteFireBallWandAction;
    ExecuteWandAction [21] := ExecuteStinkingCloudWandAction;
    ExecuteWandAction [22] := ExecuteAcidBallWandAction;
    ExecuteWandAction [23] := ExecuteWonderWandAction;
  END InitializeExecuteWandActionTable;
  
  PROCEDURE InvalidWandActionProcedure (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* InvalidWandActionProcedure *)
    WDebugging.FatalAppExit ("Call to un-initialized wand procedure.");
  END InvalidWandActionProcedure;


BEGIN (* MWands *)
  InitializeExecuteWandActionTable;
END MWands.
