IMPLEMENTATION MODULE MWands2;
  (*/WIN:A*)
  
  IMPORT DLineDDA,MBalls,MCMovement,MCSpell4,MDPainting,MDWindow,MMWindow,MPAttk2,MPMovement,MRandom,MSpells2;
  IMPORT CStruct,DStruct,MStruct,OStruct;
  IMPORT DSActions,OSActions;
  
  
  CONST
        MaximumBeamDistance = 18;
  
  VAR
      CurrentBeamDistance : CARDINAL;
      WandBeamTerminated  : BOOLEAN;
  
  
  PROCEDURE ExecuteAcidBallDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteAcidBallDamage *)
    MCSpell4.ExecutePlayerMagicBallDamage (player,line,column,60,MBalls.ExecuteAcidDamage,"Collateral Acid Ball Damage","Acid Ball");
  END ExecuteAcidBallDamage;
  
  PROCEDURE ExecuteCloneMonsterDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
    VAR
        movement : CStruct.CreatureMovementInformation;
    
  BEGIN (* ExecuteCloneMonsterDamage *)
    identified := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF identified THEN
      MCMovement.MultiplyCreature (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],movement,identified);
    END; (* IF *)
  END ExecuteCloneMonsterDamage;
  
  PROCEDURE ExecuteDrainLineDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
    PROCEDURE DrainCreatureLife (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
    BEGIN (* DrainCreatureLife *)
      IF CStruct.HurtBySlayUndead IN player^.creatures^.table [creature.cursor].defense THEN
        INCL (player^.creatures^.table [creature.cursor].memory.defense,CStruct.HurtBySlayUndead);
      ELSE
        MPAttk2.DamageCreature (creature,75);
        
        IF creature.hitpoints > 0 THEN
          MMWindow.DisplayCreatureMessage (player,"The %CREATURE screams in agony!",player^.creatures^.table [creature.cursor].description,creature.visible,TRUE);
        ELSE
          MMWindow.DisplayCreatureMessage (player,"The %CREATURE dies in a fit of agony.",player^.creatures^.table [creature.cursor].description,creature.visible,TRUE);
          MPAttk2.KillCreatureAtLocation (player,creature.line,creature.column,player^.creatures^.table [creature.cursor],creature.visible,TRUE);
        END; (* IF *)
      END; (* IF *)
    END DrainCreatureLife;
    
  BEGIN (* ExecuteDrainLineDamage *)
    identified := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF identified THEN
      DrainCreatureLife (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature]);
    END; (* IF *)
  END ExecuteDrainLineDamage;
  
  PROCEDURE ExecuteHealMonsterDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteHealMonsterDamage *)
    identified := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF identified THEN
      INC (player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].hitpoints,MRandom.CardinalRandomRangeValue (4,24));
    END; (* IF *)
  END ExecuteHealMonsterDamage;
  
  PROCEDURE ExecuteLightningBallDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteLightningBallDamage *)
    MCSpell4.ExecutePlayerMagicBallDamage (player,line,column,32,MBalls.ExecuteLightningDamage,"Collateral Lightning Ball Damage","Lightning Ball");
    identified := TRUE;
  END ExecuteLightningBallDamage;
  
  PROCEDURE ExecuteSpeedMonsterDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
  BEGIN (* ExecuteSpeedMonsterDamage *)
    identified := (player^.dungeon^.physical [line]^ [column].creature <> DStruct.InvalidCreatureCursor);
    
    IF identified THEN
      MSpells2.AttemptCreatureSpeedChange (player,player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature],player^.creatures^.table [player^.dungeon^.creatures [player^.dungeon^.physical [line]^ [column].creature].cursor],+1);
    END; (* IF *)
  END ExecuteSpeedMonsterDamage;
  
  PROCEDURE GenerateLightRay (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; direction : CARDINAL);
    CONST
          MaxLightDistance = 18;
    
    CONST
          BlockedFloor = DStruct.DungeonWallElements + DStruct.DungeonElementSet {DStruct.BlockedFloor};
    
    VAR
        distance : CARDINAL;
        done     : BOOLEAN;
    
  BEGIN (* GenerateLightRay *)
    WandBeamTerminated := FALSE;
    distance           := 0;
    
    LOOP
      PlotLightWandLocation (player,line,column,done);
      
      IF ((distance = MaxLightDistance) OR (player^.dungeon^.physical [line]^ [column].elements * BlockedFloor <> DStruct.EmptyDungeonElementSet)) THEN
        EXIT;
      END; (* IF *)
      
      DSActions.DetermineDungeonLocation (line,column,direction,line,column);
      INC (distance);
    END; (* LOOP *)
  END GenerateLightRay;
  
  PROCEDURE PlotDisarmLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
    PROCEDURE DisarmArtifactAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR artifact : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    BEGIN (* DisarmArtifactAtLocation *)
      IF ((artifact.object.class = OStruct.Chest) AND (artifact.object.attributes <> OStruct.ObjectAttributeFlags {})) THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Click!");
        
        EXCL (artifact.object.attributes,OStruct.ChestTrapped);
        EXCL (artifact.object.attributes,OStruct.ChestLocked);
        
        artifact.special := OStruct.NameUnlocked;
        identified       := TRUE;
        
        OSActions.IdentifyObjectAsKnown2 (player^.treasures,artifact);
      ELSIF ((artifact.object.class = OStruct.InvisibleTrap) OR (artifact.object.class = OStruct.VisibleTrap)) THEN
        DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
        
        identified := TRUE;
      ELSIF artifact.object.class = OStruct.ClosedDoor THEN
        artifact.object.miscellaneous := 0;
      ELSIF artifact.object.class = OStruct.SecretDoor THEN
        INCL (player^.dungeon^.physical [line]^ [column].elements,DStruct.fmFLAG);
        
        artifact.object.symbol := player^.treasures^.table [OStruct.ClosedDoorObjectCursor].symbol;
        artifact.object.class  := player^.treasures^.table [OStruct.ClosedDoorObjectCursor].class;
        artifact.cursor        := OStruct.ClosedDoorObjectCursor;
        identified             := TRUE;
        
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
      END; (* IF *)
    END DisarmArtifactAtLocation;
    
  BEGIN (* PlotDisarmLocation *)
    IF NOT (WandBeamTerminated) THEN
      CurrentBeamDistance := CurrentBeamDistance + 1;
      WandBeamTerminated  := ((CurrentBeamDistance = MaximumBeamDistance) OR (player^.dungeon^.physical [line]^ [column].elements * (DStruct.DungeonWallElements + DStruct.DungeonElementSet {DStruct.BlockedFloor}) <> DStruct.EmptyDungeonElementSet));
      
      IF player^.dungeon^.physical [line]^ [column].artifact <> DStruct.InvalidArtifactCursor THEN
        DisarmArtifactAtLocation (player,line,column,player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact],identified);
      END; (* IF *)
    END; (* IF *)
  END PlotDisarmLocation;
  
  PROCEDURE PlotLightWandLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
    PROCEDURE BeamLightLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : DStruct.PhysicalDungeonUnit);
      PROCEDURE DamageCreatureWithLightWand (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
      BEGIN (* DamageCreatureWithLightWand *)
        IF CStruct.HurtByLightWand IN player^.creatures^.table [creature.cursor].defense THEN
          IF creature.visible THEN
            INCL (player^.creatures^.table [creature.cursor].memory.defense,CStruct.HurtByLightWand);
          END; (* IF *)
          
          MPAttk2.DamageCreature (creature,MRandom.CardinalRandomRangeValue (2,16));
          
          IF creature.hitpoints > 0 THEN
            MMWindow.DisplayCreatureMessage (player,"The %CREATURE cringes from the light!",player^.creatures^.table [creature.cursor].description,creature.visible,TRUE);
          ELSE
            MMWindow.DisplayCreatureMessage (player,"The %CREATURE shrivels away in the light!",player^.creatures^.table [creature.cursor].description,creature.visible,TRUE);
            MPAttk2.KillCreatureAtLocation (player,creature.line,creature.column,player^.creatures^.table [creature.cursor],creature.visible,TRUE);
          END; (* IF *)
        END; (* IF *)
      END DamageCreatureWithLightWand;
      
    BEGIN (* BeamLightLocation *)
      IF location.elements * DStruct.DungeonElementSet {DStruct.plFLAG,DStruct.tlFLAG} = DStruct.EmptyDungeonElementSet THEN
        INCL (location.elements,DStruct.plFLAG);
        
        IF DStruct.LightFloor IN location.elements THEN
          MPMovement.LightDungeonRoom (player,line,column);
        END; (* IF *)
      ELSE
        INCL (location.elements,DStruct.plFLAG);
      END; (* IF *)
      
      MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
      
      IF location.creature <> DStruct.InvalidCreatureCursor THEN
        DamageCreatureWithLightWand (player,player^.dungeon^.creatures [location.creature]);
      END; (* IF *)
    END BeamLightLocation;
    
  BEGIN (* PlotLightWandLocation *)
    IF NOT (WandBeamTerminated) THEN
      CurrentBeamDistance := CurrentBeamDistance + 1;
      WandBeamTerminated  := ((CurrentBeamDistance = MaximumBeamDistance) OR (player^.dungeon^.physical [line]^ [column].elements * (DStruct.DungeonWallElements + DStruct.DungeonElementSet {DStruct.BlockedFloor}) <> DStruct.EmptyDungeonElementSet));
      
      BeamLightLocation (player,line,column,player^.dungeon^.physical [line]^ [column]);
    END; (* IF *)
    
    identified := TRUE;
  END PlotLightWandLocation;
  
  PROCEDURE PlotTrapDoorDestructionLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
    PROCEDURE DestroyTrapsAndDoors (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR artifact : OStruct.InventoryItemRecord; VAR identified : BOOLEAN);
    BEGIN (* DestroyTrapsAndDoors *)
      IF artifact.object.class IN OStruct.ObjectClassSet {OStruct.InvisibleTrap,OStruct.VisibleTrap,OStruct.ClosedDoor,OStruct.OpenDoor,OStruct.SecretDoor} THEN
        DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
        MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,TRUE);
        
        identified := TRUE;
      ELSIF artifact.object.class = OStruct.Chest THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"Click!");
        
        EXCL (artifact.object.attributes,OStruct.ChestTrapped);
        EXCL (artifact.object.attributes,OStruct.ChestLocked);
        
        artifact.special := OStruct.NameUnlocked;
        identified       := TRUE;
        
        OSActions.IdentifyObjectAsKnown2 (player^.treasures,artifact);
      END; (* IF *)
    END DestroyTrapsAndDoors;
    
  BEGIN (* PlotTrapDoorDestructionLocation *)
    IF NOT (WandBeamTerminated) THEN
      CurrentBeamDistance := CurrentBeamDistance + 1;
      WandBeamTerminated  := ((CurrentBeamDistance = MaximumBeamDistance) OR (player^.dungeon^.physical [line]^ [column].elements * (DStruct.DungeonWallElements + DStruct.DungeonElementSet {DStruct.BlockedFloor}) <> DStruct.EmptyDungeonElementSet));
      
      IF player^.dungeon^.physical [line]^ [column].artifact <> DStruct.InvalidArtifactCursor THEN
        DestroyTrapsAndDoors (player,line,column,player^.dungeon^.artifacts [player^.dungeon^.physical [line]^ [column].artifact],identified);
      END; (* IF *)
    END; (* IF *)
  END PlotTrapDoorDestructionLocation;
  
  PROCEDURE PlotWallBuildingLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR identified : BOOLEAN);
    PROCEDURE BuildWallAtLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR location : DStruct.PhysicalDungeonUnit; VAR terminated : BOOLEAN);
      PROCEDURE DamageCreatureWithWall (player : MStruct.PlayerInfoPointer; VAR creature : DStruct.DungeonCreatureRecord);
        PROCEDURE WallBuildingCreatureDamage (creature : CStruct.PassiveCreatureInfoRecord) : CARDINAL;
        BEGIN (* WallBuildingCreatureDamage *)
          IF CStruct.AttackOnly IN creature.movement THEN
            RETURN (3000);
          ELSE
            RETURN (MRandom.CardinalRandomRangeValue (4,32));
          END; (* IF *)
        END WallBuildingCreatureDamage;
        
      BEGIN (* DamageCreatureWithWall *)
        IF NOT (CStruct.MoveThroughWall IN player^.creatures^.table [creature.cursor].movement) THEN
          MMWindow.DisplayCreatureMessage (player,"The %CREATURE wails out in pain!",player^.creatures^.table [creature.cursor].description,creature.visible,TRUE);
          MPAttk2.DamageCreature (creature,WallBuildingCreatureDamage (player^.creatures^.table [creature.cursor]));
          
          IF creature.hitpoints = 0 THEN
            MMWindow.DisplayCreatureMessage (player,"The %CREATURE is embedded in the rock.",player^.creatures^.table [creature.cursor].description,creature.visible,TRUE);
            MPAttk2.KillCreatureAtLocation (player,creature.line,creature.column,player^.creatures^.table [creature.cursor],creature.visible,TRUE);
          END; (* IF *)
        ELSIF ((creature.symbol = 'X') OR (creature.symbol = 'E')) THEN
          INC (creature.hitpoints,MRandom.CardinalRandomRangeValue (4,32));
        END; (* IF *)
      END DamageCreatureWithWall;
      
    BEGIN (* BuildWallAtLocation *)
      IF location.artifact <> DStruct.InvalidArtifactCursor THEN
        DSActions.DeleteArtifactInformation (player^.dungeon^,line,column);
      END; (* IF *)
      
      IF location.creature <> DStruct.InvalidCreatureCursor THEN
        DamageCreatureWithWall (player,player^.dungeon^.creatures [location.creature]);
        terminated := TRUE;
      END; (* IF *)
      
      DSActions.SetDungeonLocationFVal (location,DStruct.MagmaWall);
      
      IF DStruct.tlFLAG IN location.elements THEN
        INCL (location.elements,DStruct.plFLAG);
      END; (* IF *)
      
      EXCL (location.elements,DStruct.fmFLAG);
      
      MDPainting.InvalidateDungeonLocation (player,line,column,FALSE,FALSE);
    END BuildWallAtLocation;
    
  BEGIN (* PlotWallBuildingLocation *)
    IF NOT (WandBeamTerminated) THEN
      CurrentBeamDistance := CurrentBeamDistance + 1;
      WandBeamTerminated  := ((CurrentBeamDistance = MaximumBeamDistance) OR (player^.dungeon^.physical [line]^ [column].elements * (DStruct.DungeonWallElements + DStruct.DungeonElementSet {DStruct.BlockedFloor}) <> DStruct.EmptyDungeonElementSet));
      
      IF NOT (WandBeamTerminated) THEN
        BuildWallAtLocation (player,line,column,player^.dungeon^.physical [line]^ [column],WandBeamTerminated);
        identified := TRUE;
      END; (* IF *)
    END; (* IF *)
  END PlotWallBuildingLocation;

  PROCEDURE TraceMagicWandBeam (player : MStruct.PlayerInfoPointer; line1 : DStruct.DungeonLineRange; column1 : DStruct.DungeonColumnRange; line2 : DStruct.DungeonLineRange; column2 : DStruct.DungeonColumnRange; action : DLineDDA.PlotLocationProcedure; VAR identified : BOOLEAN);
  BEGIN (* TraceMagicWandBeam *)
    CurrentBeamDistance := 0;
    WandBeamTerminated  := FALSE;
    identified          := FALSE;
    
    DLineDDA.ExecuteDungeonTraceProcedure (player,line1,column1,line2,column2,action,identified);
    
    IF NOT (WandBeamTerminated) THEN
      action (player,line2,column2,identified);
    END; (* IF *)
  END TraceMagicWandBeam;
END MWands2.
