IMPLEMENTATION MODULE MWChange;
  (*/WIN:A*)
  
  IMPORT WDialog,WEditText,WError,Windows;
  IMPORT MSActions,MSActs2,MSActs3;
  IMPORT MCStruct,MStruct;
  IMPORT MSUpdate;
  
  
  CONST
        BaseStatisticEditTextControl = 608;
  
  CONST
        ManaStaticTextControl = 616;
  
  CONST
        HitPointsEditTextControl = 617;
        ManaEditTextControl      = 618;
        GoldEditTextControl      = 620;
        WeightEditTextControl    = 635;
  
  CONST
        SearchEditTextControl    = 628;
        StealthEditTextControl   = 629;
        DisarmingEditTextControl = 630;
        SaveEditTextControl      = 631;
        BaseToHitEditTextControl = 632;
        BowsThrowEditTextControl = 633;
  
  CONST
        IncreaseSpeedPushButtonControl = 636;
        DecreaseSpeedPushButtonControl = 637;
        ChangeAcceptPushButtonControl  = 638;
        ChangeCancelPushButtonControl  = 639;
  
  
  PROCEDURE CloseCharChangeDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* CloseCharChangeDialog *)
    ExecuteChangeCancelButton (window,Windows.BN_CLICKED);
  END CloseCharChangeDialog;
  
  PROCEDURE ExecuteChangeCancelButton (window : Windows.HWND; command : CARDINAL);
  BEGIN (* ExecuteChangeCancelButton *)
    IF command = Windows.BN_CLICKED THEN
      WDialog.EndDialog (window,Windows.FALSE_BOOL);
    END; (* IF *)
  END ExecuteChangeCancelButton;
  
  PROCEDURE ExecuteCharChangeCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; command : CARDINAL);
    PROCEDURE ExecuteAcceptButton (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
      VAR
          done : BOOLEAN;
      
      PROCEDURE GetDlgItemCardinalRangeValue (window : Windows.HWND; control : CARDINAL; min,max : CARDINAL; VAR result : CARDINAL; VAR done : BOOLEAN);
        VAR
            temp : CARDINAL;
        
      BEGIN (* GetDlgItemCardinalRangeValue *)
        WDialog.GetDlgItemCardinal (window,control,temp,done);
        
        IF NOT (done) THEN
          WError.DisplayInformationBox (window,MStruct.MainWindowTitle,"Invalid cardinal value for this field.");
        ELSIF ((temp < min) OR (temp > max)) THEN
          WError.DisplayInformationBox (window,MStruct.MainWindowTitle,"Value out of range for this field.");
          done := FALSE;
        END; (* IF *)
        
        IF done THEN
          result := temp;
        ELSE
          WEditText.HighlightEditTextControl (window,control);
        END; (* IF *)
      END GetDlgItemCardinalRangeValue;
      
      PROCEDURE GetDlgItemIntegerRangeValue (window : Windows.HWND; control : CARDINAL; min,max : INTEGER; VAR result : INTEGER; VAR done : BOOLEAN);
        VAR
            temp : INTEGER;
        
      BEGIN (* GetDlgItemIntegerRangeValue *)
        WDialog.GetDlgItemInteger (window,control,temp,done);
        
        IF NOT (done) THEN
          WError.DisplayInformationBox (window,MStruct.MainWindowTitle,"Invalid integer value for this field.");
        ELSIF ((temp < min) OR (temp > max)) THEN
          WError.DisplayInformationBox (window,MStruct.MainWindowTitle,"Value out of range for this field.");
          done := FALSE;
        END; (* IF *)
        
        IF done THEN
          result := temp;
        ELSE
          WEditText.HighlightEditTextControl (window,control);
        END; (* IF *)
      END GetDlgItemIntegerRangeValue;
      
      PROCEDURE UpdateAttributesInformation (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
      BEGIN (* UpdateAttributesInformation *)
        GetDlgItemIntegerRangeValue (window,SearchEditTextControl,0,200,player^.character^.abilities.search,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        GetDlgItemIntegerRangeValue (window,StealthEditTextControl,-1,18,player^.character^.abilities.stealth,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        GetDlgItemIntegerRangeValue (window,DisarmingEditTextControl,0,200,player^.character^.abilities.disarm,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        GetDlgItemIntegerRangeValue (window,SaveEditTextControl,0,200,player^.character^.abilities.save,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        GetDlgItemIntegerRangeValue (window,BaseToHitEditTextControl,0,200,player^.character^.abilities.martial,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        GetDlgItemIntegerRangeValue (window,BowsThrowEditTextControl,0,200,player^.character^.abilities.missile,done);
      END UpdateAttributesInformation;
      
      PROCEDURE UpdateMiscellaneousInformation (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
        PROCEDURE UpdateGoldInformation (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
          PROCEDURE GetDlgItemLongIntRangeValue (window : Windows.HWND; control : CARDINAL; min,max : LONGINT; VAR result : LONGINT; VAR done : BOOLEAN);
            VAR
                temp : LONGINT;
            
          BEGIN (* GetDlgItemLongIntRangeValue *)
            WDialog.GetDlgItemLongInt (window,control,temp,done);
            
            IF NOT (done) THEN
              WError.DisplayInformationBox (window,MStruct.MainWindowTitle,"Invalid long integer value for this field.");
            ELSIF ((temp < min) OR (temp > max)) THEN
              WError.DisplayInformationBox (window,MStruct.MainWindowTitle,"Value out of range for this field.");
              done := FALSE;
            END; (* IF *)
            
            IF done THEN
              result := temp;
            ELSE
              WEditText.HighlightEditTextControl (window,control);
            END; (* IF *)
          END GetDlgItemLongIntRangeValue;
          
        BEGIN (* UpdateGoldInformation *)
          GetDlgItemLongIntRangeValue (window,GoldEditTextControl,0,MAX (LONGINT),player^.character^.variables.currentGOLD,done);
          
          IF done THEN
            MSUpdate.UpdateCurrentGoldWindow (player);
          END; (* IF *)
        END UpdateGoldInformation;
        
        PROCEDURE UpdateHitPointsInformation (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
          VAR
              hitpoints : INTEGER;
          
        BEGIN (* UpdateHitPointsInformation *)
          GetDlgItemIntegerRangeValue (window,HitPointsEditTextControl,1,MAX (INTEGER),hitpoints,done);
          
          IF done THEN
            player^.character^.variables.hpCUR := FLOAT (hitpoints);
            player^.character^.variables.hpMAX := FLOAT (hitpoints);
            
            MSUpdate.UpdateCurrentHitPointsWindow (player);
            MSUpdate.UpdateMaximumHitPointsWindow (player);
          END; (* IF *)
        END UpdateHitPointsInformation;
        
        PROCEDURE UpdateManaInformation (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
          VAR
              mana : INTEGER;
          
        BEGIN (* UpdateManaInformation *)
          GetDlgItemIntegerRangeValue (window,ManaEditTextControl,0,MAX (INTEGER),mana,done);
          
          IF done THEN
            player^.character^.variables.manaCUR := FLOAT (mana);
            player^.character^.variables.manaMAX := FLOAT (mana);
            
            MSUpdate.UpdateCurrentManaWindow (player);
          END; (* IF *)
        END UpdateManaInformation;
        
      BEGIN (* UpdateMiscellaneousInformation *)
        UpdateHitPointsInformation (window,player,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        UpdateManaInformation (window,player,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        UpdateGoldInformation (window,player,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        GetDlgItemCardinalRangeValue (window,WeightEditTextControl,0,MAX (INTEGER),player^.character^.constants.weight,done);
      END UpdateMiscellaneousInformation;
      
      PROCEDURE UpdateStatisticsInformation (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
        VAR
            index : MCStruct.PlayerStatisticMnemonic;
            dummy : BOOLEAN;
        
      BEGIN (* UpdateStatisticsInformation *)
        FOR index := MIN (MCStruct.PlayerStatisticMnemonic) TO MAX (MCStruct.PlayerStatisticMnemonic) DO
          GetDlgItemIntegerRangeValue (window,BaseStatisticEditTextControl + ORD (index),3,118,player^.character^.statistics.maximum [index],done);
          
          IF NOT (done) THEN
            RETURN;
          END; (* IF *)
          
          MSActs2.RestoreStatisticToMaximum (player,index,dummy);
        END; (* FOR *)
      END UpdateStatisticsInformation;
      
    BEGIN (* ExecuteAcceptButton *)
      IF command = Windows.BN_CLICKED THEN
        UpdateStatisticsInformation (window,player,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        UpdateMiscellaneousInformation (window,player,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        UpdateAttributesInformation (window,player,done);
        
        IF NOT (done) THEN
          RETURN;
        END; (* IF *)
        
        WDialog.EndDialog (window,Windows.TRUE_BOOL);
      END; (* IF *)
    END ExecuteAcceptButton;
    
    PROCEDURE ExecuteDecreaseSpeedButton (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteDecreaseSpeedButton *)
      IF command = Windows.BN_CLICKED THEN
        MSActs3.AlterPlayerSpeed (player,+1);
        MSUpdate.UpdateCurrentSpeedWindow (player);
      END; (* IF *)
    END ExecuteDecreaseSpeedButton;
    
    PROCEDURE ExecuteIncreaseSpeedButton (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteIncreaseSpeedButton *)
      IF command = Windows.BN_CLICKED THEN
        MSActs3.AlterPlayerSpeed (player,-1);
        MSUpdate.UpdateCurrentSpeedWindow (player);
      END; (* IF *)
    END ExecuteIncreaseSpeedButton;
    
  BEGIN (* ExecuteCharChangeCommand *)
    CASE control OF
      IncreaseSpeedPushButtonControl : ExecuteIncreaseSpeedButton (window,player,command); |
      DecreaseSpeedPushButtonControl : ExecuteDecreaseSpeedButton (window,player,command); |
      
      ChangeCancelPushButtonControl,Windows.IDCANCEL : ExecuteChangeCancelButton (window,command);  |
      ChangeAcceptPushButtonControl,Windows.IDOK     : ExecuteAcceptButton (window,player,command); |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteCharChangeCommand;
  
  PROCEDURE InitializeCharChangeDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
    PROCEDURE InitializeCharacterStatistics (window : Windows.HWND; control : CARDINAL; statistics : ARRAY OF MCStruct.PlayerStatisticRange);
      VAR
          index : CARDINAL;
      
    BEGIN (* InitializeCharacterStatistics *)
      FOR index := 0 TO HIGH (statistics) DO
        WDialog.SetDlgItemCardinal (window,control + index,statistics [index]);
      END; (* FOR *)
    END InitializeCharacterStatistics;
    
  BEGIN (* InitializeCharChangeDialog *)
    InitializeCharacterStatistics (window,BaseStatisticEditTextControl,player^.character^.statistics.maximum);
    
    WDialog.SetDlgItemCardinal (window,HitPointsEditTextControl,TRUNC (player^.character^.variables.hpMAX));
    WDialog.SetDlgItemCardinal (window,ManaEditTextControl,TRUNC (player^.character^.variables.manaMAX));
    WDialog.SetDlgItemCardinal (window,GoldEditTextControl,player^.character^.variables.currentGOLD);
    WDialog.SetDlgItemCardinal (window,WeightEditTextControl,player^.character^.constants.weight);
    
    WDialog.SetDlgItemInteger (window,SearchEditTextControl,player^.character^.abilities.search);
    WDialog.SetDlgItemInteger (window,StealthEditTextControl,player^.character^.abilities.stealth);
    WDialog.SetDlgItemInteger (window,DisarmingEditTextControl,player^.character^.abilities.disarm);
    WDialog.SetDlgItemInteger (window,SaveEditTextControl,player^.character^.abilities.save);
    WDialog.SetDlgItemInteger (window,BaseToHitEditTextControl,player^.character^.abilities.martial);
    WDialog.SetDlgItemInteger (window,BowsThrowEditTextControl,player^.character^.abilities.missile);
    
    IF player^.character^.constants.class = MCStruct.Warrior THEN
      WDialog.EnableDialogControl (window,ManaStaticTextControl,FALSE);
      WDialog.EnableDialogControl (window,ManaEditTextControl,FALSE);
    END; (* IF *)
  END InitializeCharChangeDialog;
END MWChange.
