IMPLEMENTATION MODULE MWizard;
  (*/WIN:A*)
  
  IMPORT MDGenerator,MDialogs,MMenu,MMWindow,MSUpdate,MWChange,MWDepth,MWObject,MWSummon;
  IMPORT DStruct,MCStruct,MStruct;
  
  
  PROCEDURE ExecuteWizardCreateObjectCommand (player : MStruct.PlayerInfoPointer);
    VAR
        result : INTEGER;
    
  BEGIN (* ExecuteWizardCreateObjectCommand *)
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      IF player^.dungeon^.physical [player^.character^.line]^ [player^.character^.column].artifact <> DStruct.InvalidArtifactCursor THEN
        MMWindow.DisplayPopupMessage (player^.windows.frame,player,"There's no room to create anything here.");
      ELSE
        MDialogs.ExecuteMoriaDialogBox (player^.windows.frame,"Wizard_Create_Dialog",player,MWObject.InitializeWizardCreateDialog,MWObject.ExecuteWizardCreateDialogCommand,MWObject.CloseWizardCreateDialog,result);
      END; (* IF *)
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteWizardCreateObjectCommand;
  
  PROCEDURE ExecuteWizardSummonCommand (player : MStruct.PlayerInfoPointer);
    VAR
        result : INTEGER;
    
  BEGIN (* ExecuteWizardSummonCommand *)
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      MDialogs.ExecuteMoriaDialogBox (player^.windows.frame,"Wizard_Summon_Dialog",player,MWSummon.InitializeWizardSummonDialog,MWSummon.ExecuteWizardSummonDialogCommnd,MWSummon.CloseWizardSummonDialog,result);
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteWizardSummonCommand;
  
  PROCEDURE ToggleWizardMode (player : MStruct.PlayerInfoPointer);
    VAR
        changed : BOOLEAN;
    
  BEGIN (* ToggleWizardMode *)
    MStruct.CharacterTurnExecuted := FALSE;
    
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      EXCL (player^.character^.variables.status,MCStruct.WizardFLAG);
      changed := TRUE;
    ELSIF ((MCStruct.FormerWizardFLAG IN player^.character^.variables.status) OR MMWindow.QueryYesNo (player^.windows.frame,player,"Wizard mode is for debugging and experimenting.  The game will not be scored if you enter wizard mode. Are you sure?",TRUE)) THEN
      INCL (player^.character^.variables.status,MCStruct.FormerWizardFLAG);
      INCL (player^.character^.variables.status,MCStruct.WizardFLAG);
      changed := TRUE;
    ELSE
      changed := FALSE;
    END; (* IF *)
    
    IF changed THEN
      MSUpdate.UpdateWizardStatusWindow (player);
      MMenu.UpdateWizardMenu (player);
    END; (* IF *)
  END ToggleWizardMode;
  
  PROCEDURE WizardChangeCharacter (player : MStruct.PlayerInfoPointer);
    VAR
        result : INTEGER;
    
  BEGIN (* WizardChangeCharacter *)
    MStruct.CharacterTurnExecuted := FALSE;
    
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      MDialogs.ExecuteMoriaDialogBox (player^.windows.frame,"Wizard_Change_Character",player,MWChange.InitializeCharChangeDialog,MWChange.ExecuteCharChangeCommand,MWChange.CloseCharChangeDialog,result);
    END; (* IF *)
  END WizardChangeCharacter;
  
  PROCEDURE WizardDepthChange (player : MStruct.PlayerInfoPointer);
    VAR
        done : BOOLEAN;
    
    PROCEDURE DetermineNewDungeonDepth (player : MStruct.PlayerInfoPointer; VAR done : BOOLEAN);
      VAR
          result : INTEGER;
      
    BEGIN (* DetermineNewDungeonDepth *)
      MDialogs.ExecuteMoriaDialogBox (player^.windows.frame,"Wizard_Depth_Change",player,MWDepth.InitializeDepthChangeDialog,MWDepth.ExecuteDepthChangeCommand,MWDepth.CloseDepthChangeDialog,result);
      done := ((result >= 0) AND (result <= 99));
      
      IF done THEN
        player^.character^.variables.depthCUR := result;
      END; (* IF *)
    END DetermineNewDungeonDepth;
    
  BEGIN (* WizardDepthChange *)
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      DetermineNewDungeonDepth (player,done);
      
      IF done THEN
        MDGenerator.GeneratePlayerDungeon (player);
        MSUpdate.UpdateCurrentDepthWindow (player);
      END; (* IF *)
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END WizardDepthChange;
END MWizard.
