IMPLEMENTATION MODULE MWizard2;
  (*/WIN:A*)
  
  IMPORT MCreatures,MDGAlloc,MDPainting,MDWindow,MPotions,MRandom,MScrl2,MScrl3,MScrl4,MSpells2;
  IMPORT DStruct,MCStruct,MStruct;
  IMPORT DSActions,MSActs2;
  
  
  PROCEDURE ExecuteWizardCureAllCommand (player : MStruct.PlayerInfoPointer);
    VAR
        identified : BOOLEAN;
        done       : BOOLEAN;
    
    PROCEDURE RestoreAllStatistics (player : MStruct.PlayerInfoPointer);
      VAR
          index : MCStruct.PlayerStatisticMnemonic;
          done  : BOOLEAN;
      
    BEGIN (* RestoreAllStatistics *)
      FOR index := MIN (MCStruct.PlayerStatisticMnemonic) TO MAX (MCStruct.PlayerStatisticMnemonic) DO
        MSActs2.RestoreStatisticToMaximum (player,index,done);
      END; (* FOR *)
    END RestoreAllStatistics;
    
  BEGIN (* ExecuteWizardCureAllCommand *)
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      MScrl4.ExecuteRemoveCurseScrollAction (player,done);
      MSpells2.CureFear (player,done);
      
      MPotions.ExecuteCureBlindnessPotion (player,identified);
      MPotions.ExecuteCureConfusionPotion (player,identified);
      MPotions.ExecuteCurePoisonPotion (player,identified);
      
      RestoreAllStatistics (player);
      
      IF player^.character^.variables.counters [MCStruct.SlowCOUNT] > 1 THEN
        player^.character^.variables.counters [MCStruct.SlowCOUNT] := 1;
      END; (* IF *)
      
      IF player^.character^.variables.counters [MCStruct.ImageCOUNT] > 1 THEN
        player^.character^.variables.counters [MCStruct.ImageCOUNT] := 1;
      END; (* IF *)
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteWizardCureAllCommand;
  
  PROCEDURE ExecuteWizardExperienceCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteWizardExperienceCommand *)
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      IF player^.character^.variables.experCUR > 0.0 THEN
        MSActs2.IncreasePlayerExperience (player,player^.character^.variables.experCUR);
      ELSE
        MSActs2.IncreasePlayerExperience (player,1.0);
      END; (* IF *)
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteWizardExperienceCommand;
  
  PROCEDURE ExecuteWizardGenocideCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteWizardGenocideCommand *)
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      MScrl3.ExecuteMassGenocideScrollAction (player);
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteWizardGenocideCommand;
  
  PROCEDURE ExecuteWizardIdentifyCommand (player : MStruct.PlayerInfoPointer);
    VAR
        identified : BOOLEAN;
    
  BEGIN (* ExecuteWizardIdentifyCommand *)
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      MScrl2.ExecuteIdentifyScrollAction (player,identified);
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteWizardIdentifyCommand;
  
  PROCEDURE ExecuteWizardMapCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteWizardMapCommand *)
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      MScrl3.ExecuteMapAreaScrollAction (player);
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteWizardMapCommand;
  
  PROCEDURE ExecuteWizardTeleportCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteWizardTeleportCommand *)
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      MScrl2.ExecuteTeleportScrollAction (player,100);
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteWizardTeleportCommand;
  
  PROCEDURE ExecuteWizardTreasureCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteWizardTreasureCommand *)
    IF MCStruct.WizardFLAG IN player^.character^.variables.status THEN
      MDGAlloc.GenerateRandomTreasures (player,player^.dungeon^,player^.character^.line,player^.character^.column,player^.character^.variables.depthCUR,1);
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteWizardTreasureCommand;
  
  PROCEDURE WizardDungeonLight (player : MStruct.PlayerInfoPointer);
    VAR
        column : DStruct.DungeonColumnRange;
        line   : DStruct.DungeonLineRange;
        flag   : BOOLEAN;
    
    PROCEDURE WizardLightSurroundingLocations (VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; flag : BOOLEAN);
      VAR
          column : DStruct.DungeonColumnRange;
          line   : DStruct.DungeonLineRange;
      
    BEGIN (* WizardLightSurroundingLocations *)
      FOR line := centerLINE - 1 TO centerLINE + 1 DO
        FOR column := centerCOLUMN - 1 TO centerCOLUMN + 1 DO
          IF flag THEN
            INCL (dungeon.physical [line]^ [column].elements,DStruct.plFLAG);
          ELSE
            EXCL (dungeon.physical [line]^ [column].elements,DStruct.plFLAG);
            INCL (dungeon.physical [line]^ [column].elements,DStruct.fmFLAG);
          END; (* IF *)
        END; (* FOR *)
      END; (* FOR *)
    END WizardLightSurroundingLocations;
    
  BEGIN (* WizardDungeonLight *)
    MStruct.CharacterTurnExecuted := FALSE;
    flag                          := (DStruct.plFLAG IN player^.dungeon^.physical [player^.character^.line]^ [player^.character^.column].elements);
    
    FOR line := 0 TO player^.dungeon^.lines - 1 DO
      FOR column := 0 TO player^.dungeon^.columns - 1 DO
        IF player^.dungeon^.physical [line]^ [column].elements * DStruct.DungeonFloorElements <> DStruct.EmptyDungeonElementSet THEN
          WizardLightSurroundingLocations (player^.dungeon^,line,column,flag);
        END; (* IF *)
      END; (* FOR *)
    END; (* FOR *)
    
    MDPainting.InvalidateDungeonWindow (player);
  END WizardDungeonLight;
END MWizard2.
