IMPLEMENTATION MODULE MWObject;
  (*/WIN:A*)
  
  IMPORT WDialog,WEditText,Windows,WListBox;
  IMPORT MMWindow,ODescriptions,OMagic;
  IMPORT DSActions,OSActions;
  IMPORT MStruct,OStruct;
  
  
  CONST
        ObjectDepthEditTextControl = 1504;
        ObjectListBoxControl       = 1502;
  
  
  PROCEDURE CloseWizardCreateDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* CloseWizardCreateDialog *)
    WDialog.EndDialog (window,Windows.FALSE_BOOL);
  END CloseWizardCreateDialog;
  
  PROCEDURE ExecuteWizardCreateDialogCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; command : CARDINAL);
    CONST
          CancelPushButtonControl = Windows.IDCANCEL;
          CreatePushButtonControl = Windows.IDOK;
    
    PROCEDURE ExecuteCancelPushButtonAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteCancelPushButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        CloseWizardCreateDialog (window,player);
      END; (* IF *)
    END ExecuteCancelPushButtonAction;
    
    PROCEDURE ExecuteCreatePushButtonAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
      VAR
          cursor : CARDINAL;
          depth  : CARDINAL;
          item   : OStruct.InventoryItemRecord;
          done   : BOOLEAN;
      
      PROCEDURE DetermineObjectInformation (window : Windows.HWND; player : MStruct.PlayerInfoPointer; VAR cursor : CARDINAL; VAR depth : CARDINAL; VAR done : BOOLEAN);
      BEGIN (* DetermineObjectInformation *)
        WDialog.GetDlgItemCardinal (window,ObjectDepthEditTextControl,depth,done);
        
        IF NOT (done) THEN
          MMWindow.DisplayPopupMessage (window,player,"Invalid or missing object depth.");
          WEditText.HighlightEditTextControl (window,ObjectDepthEditTextControl);
        END; (* IF *)
        
        cursor := WListBox.GetCurSel (WDialog.GetDlgItem (window,ObjectListBoxControl));
      END DetermineObjectInformation;
      
    BEGIN (* ExecuteCreatePushButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        DetermineObjectInformation (window,player,cursor,depth,done);
        
        IF done THEN
          OSActions.ReturnInventoryItemRecord (player^.treasures,cursor,item);
          OMagic.DetermineObjectMagic (item,depth);
          
          DSActions.PlaceDungeonArtifact (player^.dungeon^,player^.character^.line,player^.character^.column,item);
          
          WDialog.EndDialog (window,Windows.TRUE_BOOL);
        END; (* IF *)
      END; (* IF *)
    END ExecuteCreatePushButtonAction;
    
    PROCEDURE ExecuteObjectListBoxAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteObjectListBoxAction *)
      IF command = Windows.LBN_SELCHANGE THEN
        WDialog.EnableDialogControl (window,CreatePushButtonControl,TRUE);
      ELSIF command = Windows.LBN_DBLCLK THEN
        ExecuteCreatePushButtonAction (window,player,Windows.BN_CLICKED);
      END; (* IF *)
    END ExecuteObjectListBoxAction;
    
  BEGIN (* ExecuteWizardCreateDialogCommand *)
    CASE control OF
      CreatePushButtonControl : ExecuteCreatePushButtonAction (window,player,command); |
      CancelPushButtonControl : ExecuteCancelPushButtonAction (window,player,command); |
      
      ObjectListBoxControl : ExecuteObjectListBoxAction (window,player,command); |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteWizardCreateDialogCommand;
  
  PROCEDURE InitializeWizardCreateDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
    PROCEDURE InitializeObjectListBox (control : Windows.HWND; player : MStruct.PlayerInfoPointer);
      VAR
          index : CARDINAL;
      
      PROCEDURE AddObjectToListBox (control : Windows.HWND; player : MStruct.PlayerInfoPointer; cursor : CARDINAL);
        VAR
            description : ARRAY [0..127] OF CHAR;
            position    : Windows.LRESULT;
            item        : OStruct.InventoryItemRecord;
        
      BEGIN (* AddObjectToListBox *)
        OSActions.ReturnInventoryItemRecord (player^.treasures,cursor,item);
        ODescriptions.ReturnIdentifiedDescription (player,item,TRUE,description);
        
        WListBox.AddString (control,description,position);
      END AddObjectToListBox;
      
    BEGIN (* InitializeObjectListBox *)
      WListBox.SetRedraw (control,FALSE);
      
      FOR index := 0 TO OStruct.MaxNumberObjects - 1 DO
        AddObjectToListBox (control,player,index);
      END; (* FOR *)
      
      WListBox.SetRedraw (control,TRUE);
    END InitializeObjectListBox;
    
  BEGIN (* InitializeWizardCreateDialog *)
    WDialog.SetDlgItemCardinal (window,ObjectDepthEditTextControl,player^.character^.variables.depthCUR);
    InitializeObjectListBox (WDialog.GetDlgItem (window,ObjectListBoxControl),player);
  END InitializeWizardCreateDialog;
END MWObject.
