IMPLEMENTATION MODULE MWSummon;
  (*/WIN:A*)
  
  IMPORT WDialog,Windows,WListBox;
  
  IMPORT MCreatures,MMWindow,MRandom;
  IMPORT CStruct,DStruct,MStruct;
  IMPORT DSActions;
  
  
  PROCEDURE CloseWizardSummonDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* CloseWizardSummonDialog *)
    WDialog.EndDialog (window,Windows.FALSE_BOOL);
  END CloseWizardSummonDialog;
  
  PROCEDURE ExecuteWizardSummonDialogCommnd (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; command : CARDINAL);
    PROCEDURE AsleepBoxChecked (window : Windows.HWND) : BOOLEAN;
    BEGIN (* AsleepBoxChecked *)
      RETURN (WDialog.IsDlgButtonChecked (window,AsleepCheckBoxControl) <> Windows.FALSE_BOOL);
    END AsleepBoxChecked;
    
    PROCEDURE ExecuteCancelButtonAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteCancelButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        CloseWizardSummonDialog (window,player);
      END; (* IF *)
    END ExecuteCancelButtonAction;
    
    PROCEDURE ExecuteCreatureListBoxAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteCreatureListBoxAction *)
      IF command = Windows.LBN_SELCHANGE THEN
        WDialog.EnableDialogControl (window,SummonPushButtonControl,TRUE);
      ELSIF command = Windows.LBN_DBLCLK THEN
        ExecuteSummonButtonAction (window,player,Windows.BN_CLICKED);
      END; (* IF *)
    END ExecuteCreatureListBoxAction;
    
    PROCEDURE ExecuteRandomButtonAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
      VAR
          creature : DStruct.DungeonCreatureRecord;
      
    BEGIN (* ExecuteRandomButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        MCreatures.DetermineRandomCreatureForDepth (player^.creatures,player^.character^.variables.depthCUR,AsleepBoxChecked (window),player^.character^.variables.speed,creature);
        PlaceSummonedCreature (window,player,creature);
      END; (* IF *)
    END ExecuteRandomButtonAction;
    
    PROCEDURE ExecuteSummonButtonAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
      VAR
          creature : DStruct.DungeonCreatureRecord;
      
    BEGIN (* ExecuteSummonButtonAction *)
      IF command = Windows.BN_CLICKED THEN
        MCreatures.DetermineCreatureInformation (player^.creatures,WListBox.GetCurSel (WDialog.GetDlgItem (window,CreatureListBoxControl)),AsleepBoxChecked (window),player^.character^.variables.speed,creature);
        PlaceSummonedCreature (window,player,creature);
      END; (* IF *)
    END ExecuteSummonButtonAction;
    
    PROCEDURE PlaceSummonedCreature (window : Windows.HWND; player : MStruct.PlayerInfoPointer; creature : DStruct.DungeonCreatureRecord);
      VAR
          position : CARDINAL;
          column   : DStruct.DungeonColumnRange;
          line     : DStruct.DungeonLineRange;
          done     : BOOLEAN;
      
      PROCEDURE DetermineCreatureLocation (player : MStruct.PlayerInfoPointer; VAR dungeon : DStruct.DungeonInformation; centerLINE : DStruct.DungeonLineRange; centerCOLUMN : DStruct.DungeonColumnRange; VAR resultLINE : INTEGER; VAR resultCOLUMN : INTEGER; VAR done : BOOLEAN);
        VAR
            count : CARDINAL;
        
      BEGIN (* DetermineCreatureLocation *)
        count := 0;
        
        REPEAT
          resultCOLUMN := centerCOLUMN - 2 + MRandom.IntegerRandomRangeValue (1,3);
          resultLINE   := centerLINE - 2 + MRandom.IntegerRandomRangeValue (1,3);
          
          count := count + 1;
          done  := (DSActions.LocationInBounds (dungeon,resultLINE,resultCOLUMN) AND MCreatures.ValidCreaturePlacementLocation (player,resultLINE,resultCOLUMN,dungeon.physical [resultLINE]^ [resultCOLUMN]));
        UNTIL (done OR (count = 10));
      END DetermineCreatureLocation;
      
    BEGIN (* PlaceSummonedCreature *)
      DetermineCreatureLocation (player,player^.dungeon^,player^.character^.line,player^.character^.column,line,column,done);
      
      IF done THEN
        DSActions.PlaceCreatureAtLocation (player,player^.dungeon^,line,column,creature,position,done);
        MCreatures.UpdateCreatureDisplayInformation (player,player^.dungeon^.creatures [position],TRUE);
      ELSE
        MMWindow.DisplayPopupMessage (window,player,"Unable to locate a place for summoned creature.");
      END; (* IF *)
      
      WDialog.EndDialog (window,ORD (done));
    END PlaceSummonedCreature;
    
  BEGIN (* ExecuteWizardSummonDialogCommnd *)
    CASE control OF
      CancelPushButtonControl : ExecuteCancelButtonAction (window,player,command); |
      RandomPushButtonControl : ExecuteRandomButtonAction (window,player,command); |
      SummonPushButtonControl : ExecuteSummonButtonAction (window,player,command); |
      
      CreatureListBoxControl : ExecuteCreatureListBoxAction (window,player,command); |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteWizardSummonDialogCommnd;
  
  PROCEDURE InitializeWizardSummonDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
    VAR
        position : Windows.LRESULT;
        control  : Windows.HWND;
        index    : CARDINAL;
    
  BEGIN (* InitializeWizardSummonDialog *)
    control := WDialog.GetDlgItem (window,CreatureListBoxControl);
    
    WListBox.SetRedraw (control,FALSE);
    
    FOR index := 0 TO CStruct.MaxNumberCreatures - 1 DO
      WListBox.AddString (control,player^.creatures^.table [index].description,position);
    END; (* FOR *)
    
    WListBox.SetRedraw (control,TRUE);
  END InitializeWizardSummonDialog;
END MWSummon.
