IMPLEMENTATION MODULE ODescriptions;
  (*/WIN:A*)
  
  IMPORT MRandom,MStruct,OSActions,OStruct;
  IMPORT NumberConversion,Strings;
  IMPORT WDebugging,WString;
  
  
  PROCEDURE IsVowel (ch : CHAR) : BOOLEAN;
  BEGIN (* IsVowel *)
    ch := CAP (ch);
    
    RETURN ((ch = 'A') OR (ch = 'E') OR (ch = 'I') OR (ch = 'O') OR (ch = 'U'));
  END IsVowel;
  
  PROCEDURE ReplaceObjectDescription (text : ARRAY OF CHAR; formal : ARRAY OF CHAR; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    VAR
        actual : ARRAY [0..127] OF CHAR;
    
  BEGIN (* ReplaceObjectDescription *)
    ReturnObjectDescription (player,item,prefix,actual);
    WString.ReplaceStringParameter (text,formal,actual,result);
  END ReplaceObjectDescription;
  
  PROCEDURE ReturnIdentifiedDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    VAR
        known1,tried : BOOLEAN;
    
  BEGIN (* ReturnIdentifiedDescription *)
    known1 := OSActions.InventoryItemIsKnown1 (player^.treasures,item);
    tried  := OSActions.InventoryItemHasBeenTried (player^.treasures,item);
    
    IF NOT (known1) THEN
      OSActions.IdentifyInventoryItemAsKnown1 (player^.treasures,item);
    END; (* IF *)
    
    ReturnObjectDescription (player,item,prefix,result);
    
    IF NOT (known1) THEN
      OSActions.ClearInventoryItemKnown1 (player^.treasures,item,tried);
    END; (* IF *)
  END ReturnIdentifiedDescription;
  
  PROCEDURE ReturnObjectDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    TYPE
         MiscellaneousUseMnemonic = (AlwaysShowSignedBonus,IgnoreMiscellaneous,OptionalShowSignedBonus,ShowCharges,ShowLightLife,ShowObjectAttributeBonus);
    
    PROCEDURE ReplaceDamageParameters (text : ARRAY OF CHAR; damage : MRandom.RandomRangeSpecification; VAR result : ARRAY OF CHAR);
    BEGIN (* ReplaceDamageParameters *)
      WString.ReplaceCardinalParameter (text,"%NUMBER",damage.min,result);
      WString.ReplaceCardinalParameter (result,"%SIZE",damage.max DIV damage.min,result);
    END ReplaceDamageParameters;
    
    PROCEDURE ReturnAmuletDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnAmuletDescription *)
      IF OSActions.InventoryItemIsKnown1 (player^.treasures,item) THEN
        WString.ReplaceStringParameter ("& Amulet of %s","%s",player^.treasures^.table [item.cursor].description,result);
      ELSE
        WString.ReplaceStringParameter ("& %s Amulet","%s",player^.treasures^.amulets [item.object.subclass MOD OStruct.ObjectMinimumSingleStackSubclass],result);
      END; (* IF *)
      
      UpdatePrefixInformation (player,item,prefix,OptionalShowSignedBonus,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnAmuletDescription;
    
    PROCEDURE ReturnDiggingToolDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
      VAR
          damage : ARRAY [0..31] OF CHAR;
      
    BEGIN (* ReturnDiggingToolDescription *)
      Strings.Assign (player^.treasures^.table [item.cursor].description,result);
      ReplaceDamageParameters (" (%NUMBERd%SIZE)",item.object.damage,damage);
      
      UpdatePrefixInformation (player,item,prefix,AlwaysShowSignedBonus,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnDiggingToolDescription;
    
    PROCEDURE ReturnDownStairDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnDownStairDescription *)
      Strings.Concat (player^.treasures^.table [item.cursor].description,".",result);
    END ReturnDownStairDescription;
    
    PROCEDURE ReturnFoodDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
      VAR
          color : CARDINAL;
      
    BEGIN (* ReturnFoodDescription *)
      Strings.Assign (player^.treasures^.table [item.cursor].description,result);
      
      color := item.object.subclass MOD OStruct.ObjectMinimumSingleStackSubclass;
      
      IF OSActions.InventoryItemIsKnown1 (player^.treasures,item) THEN
        IF color <= 15 THEN
          WString.ReplaceStringParameter ("& Mushroom~ of %DESC","%DESC",item.object.description,result);
        ELSIF color <= 20 THEN
          WString.ReplaceStringParameter ("& Harry Mold~ of %DESC","%DESC",item.object.description,result);
        END; (* IF *)
      ELSIF color <= 15 THEN
        WString.ReplaceStringParameter ("& %COLOR Mushroom~","%COLOR",player^.treasures^.mushrooms [color],result);
      ELSIF color <= 20 THEN
        WString.ReplaceStringParameter ("& %COLOR Harry Mold~","%COLOR",player^.treasures^.mushrooms [color],result);
      END; (* IF *)
      
      UpdatePrefixInformation (player,item,prefix,IgnoreMiscellaneous,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnFoodDescription;
    
    PROCEDURE ReturnGeneralMissileDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
      VAR
          damage : ARRAY [0..31] OF CHAR;
      
    BEGIN (* ReturnGeneralMissileDescription *)
      Strings.Assign (player^.treasures^.table [item.cursor].description,result);
      ReplaceDamageParameters (" (%NUMBERd%SIZE)",item.object.damage,damage);
      
      UpdatePrefixInformation (player,item,prefix,IgnoreMiscellaneous,damage,result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnGeneralMissileDescription;
    
    PROCEDURE ReturnGeneralWeaponDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
      VAR
          damage : ARRAY [0..31] OF CHAR;
      
    BEGIN (* ReturnGeneralWeaponDescription *)
      Strings.Assign (player^.treasures^.table [item.cursor].description,result);
      ReplaceDamageParameters (" (%NUMBERd%SIZE)",item.object.damage,damage);
      
      UpdatePrefixInformation (player,item,prefix,ShowObjectAttributeBonus,damage,result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnGeneralWeaponDescription;
    
    PROCEDURE ReturnGoldDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnGoldDescription *)
      Strings.Concat (player^.treasures^.table [item.cursor].description,".",result);
    END ReturnGoldDescription;
    
    PROCEDURE ReturnInvisibleTrapDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnInvisibleTrapDescription *)
      Strings.Concat (player^.treasures^.table [item.cursor].description,".",result);
    END ReturnInvisibleTrapDescription;
    
    PROCEDURE ReturnLightDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnLightDescription *)
      Strings.Assign (player^.treasures^.table [item.cursor].description,result);
      
      UpdatePrefixInformation (player,item,prefix,ShowLightLife,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnLightDescription;
    
    PROCEDURE ReturnMagicBookDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnMagicBookDescription *)
      WString.ReplaceStringParameter ("& Book~ of Magic Spells %s","%s",player^.treasures^.table [item.cursor].description,result);
      
      UpdatePrefixInformation (player,item,prefix,IgnoreMiscellaneous,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnMagicBookDescription;
    
    PROCEDURE ReturnMissileWeaponDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
      VAR
          damage : ARRAY [0..31] OF CHAR;
      
      PROCEDURE MissileWeaponModifier (value : INTEGER) : INTEGER;
      BEGIN (* MissileWeaponModifier *)
        CASE value OF
          1,2 : RETURN (2); |
          3,5 : RETURN (3); |
          4,6 : RETURN (4); |
        ELSE
          RETURN (-1);
        END; (* CASE *)
      END MissileWeaponModifier;
      
    BEGIN (* ReturnMissileWeaponDescription *)
      WString.ReplaceIntegerParameter (" (x%d)","%d",MissileWeaponModifier (item.object.miscellaneous),damage);
      Strings.Assign (player^.treasures^.table [item.cursor].description,result);
      
      UpdatePrefixInformation (player,item,prefix,IgnoreMiscellaneous,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnMissileWeaponDescription;
    
    PROCEDURE ReturnPotionDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnPotionDescription *)
      IF OSActions.InventoryItemIsKnown1 (player^.treasures,item) THEN
        WString.ReplaceStringParameter ("& Potion~ of %s","%s",player^.treasures^.table [item.cursor].description,result);
      ELSE
        WString.ReplaceStringParameter ("& %s Potion~","%s",player^.treasures^.potions [item.object.subclass MOD OStruct.ObjectMinimumSingleStackSubclass],result);
      END; (* IF *)
      
      UpdatePrefixInformation (player,item,prefix,IgnoreMiscellaneous,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnPotionDescription;
    
    PROCEDURE ReturnPrayerBookDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnPrayerBookDescription *)
      WString.ReplaceStringParameter ("& Holy Book~ of Prayers %s","%s",player^.treasures^.table [item.cursor].description,result);
      
      UpdatePrefixInformation (player,item,prefix,IgnoreMiscellaneous,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnPrayerBookDescription;
    
    PROCEDURE ReturnRingDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnRingDescription *)
      IF OSActions.InventoryItemIsKnown1 (player^.treasures,item) THEN
        WString.ReplaceStringParameter ("& Ring of %s","%s",player^.treasures^.table [item.cursor].description,result);
      ELSE
        WString.ReplaceStringParameter ("& %s Ring","%s",player^.treasures^.rings [item.object.subclass MOD OStruct.ObjectMinimumSingleStackSubclass],result);
      END; (* IF *)
      
      UpdatePrefixInformation (player,item,prefix,OptionalShowSignedBonus,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnRingDescription;
    
    PROCEDURE ReturnScrollDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnScrollDescription *)
      IF OSActions.InventoryItemIsKnown1 (player^.treasures,item) THEN
        WString.ReplaceStringParameter ("& Scroll~ of %s","%s",player^.treasures^.table [item.cursor].description,result);
      ELSE
        WString.ReplaceStringParameter ('& Scroll~ titled "%s"',"%s",player^.treasures^.titles [item.object.subclass MOD OStruct.ObjectMinimumSingleStackSubclass],result);
      END; (* IF *)
      
      UpdatePrefixInformation (player,item,prefix,IgnoreMiscellaneous,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnScrollDescription;
    
    PROCEDURE ReturnStaffDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnStaffDescription *)
      IF OSActions.InventoryItemIsKnown1 (player^.treasures,item) THEN
        WString.ReplaceStringParameter ("& Staff of %s","%s",player^.treasures^.table [item.cursor].description,result);
      ELSE
        WString.ReplaceStringParameter ("& %s Staff","%s",player^.treasures^.staves [item.object.subclass MOD OStruct.ObjectMinimumSingleStackSubclass],result);
      END; (* IF *)
      
      UpdatePrefixInformation (player,item,prefix,ShowCharges,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnStaffDescription;
    
    PROCEDURE ReturnStandardObjectDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnStandardObjectDescription *)
      Strings.Assign (player^.treasures^.table [item.cursor].description,result);
      
      UpdatePrefixInformation (player,item,prefix,IgnoreMiscellaneous,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnStandardObjectDescription;
    
    PROCEDURE ReturnStoreDoorDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnStoreDoorDescription *)
      WString.ReplaceStringParameter ("the entrance to the %STORE.","%STORE",player^.treasures^.table [item.cursor].description,result);
    END ReturnStoreDoorDescription;
    
    PROCEDURE ReturnUpStairDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnUpStairDescription *)
      Strings.Concat (player^.treasures^.table [item.cursor].description,".",result);
    END ReturnUpStairDescription;
    
    PROCEDURE ReturnVisibleTrapDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnVisibleTrapDescription *)
      Strings.Concat (player^.treasures^.table [item.cursor].description,".",result);
    END ReturnVisibleTrapDescription;
    
    PROCEDURE ReturnWandDescription (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; VAR result : ARRAY OF CHAR);
    BEGIN (* ReturnWandDescription *)
      IF OSActions.InventoryItemIsKnown1 (player^.treasures,item) THEN
        WString.ReplaceStringParameter ("& Wand of %s","%s",player^.treasures^.table [item.cursor].description,result);
      ELSE
        WString.ReplaceStringParameter ("& %s Wand","%s",player^.treasures^.wands [item.object.subclass MOD OStruct.ObjectMinimumSingleStackSubclass],result);
      END; (* IF *)
      
      UpdatePrefixInformation (player,item,prefix,ShowCharges,"",result);
      UpdateQuantitySuffix (result,item.object.quantity,result);
    END ReturnWandDescription;
    
    PROCEDURE UpdatePrefixInformation (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; prefix : BOOLEAN; miscellaneous : MiscellaneousUseMnemonic; damage : ARRAY OF CHAR; VAR result : ARRAY OF CHAR);
      PROCEDURE AppendAttackBonuses (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR result : ARRAY OF CHAR);
        VAR
            temp : ARRAY [0..31] OF CHAR;
        
      BEGIN (* AppendAttackBonuses *)
        IF OSActions.InventoryItemIsKnown2 (item) THEN
          IF OStruct.IdentShowHitDam IN item.identification THEN
            ReplaceSignedIntegerParameter (" (%STRIKE,%DAMAGE)","%STRIKE",item.object.strikeMOD,temp);
            ReplaceSignedIntegerParameter (temp,"%DAMAGE",item.object.damageMOD,temp);
          ELSIF item.object.strikeMOD <> 0 THEN
            ReplaceSignedIntegerParameter (" (%VALUE)","%VALUE",item.object.strikeMOD,temp);
          ELSIF item.object.damageMOD <> 0 THEN
            ReplaceSignedIntegerParameter (" (%VALUE)","%VALUE",item.object.damageMOD,temp);
          ELSE
            temp [0] := 0C;
          END; (* IF *)
          
          Strings.Insert (temp,result,HIGH (result));
        END; (* IF *)
      END AppendAttackBonuses;
      
      PROCEDURE AppendDamageText (damage : ARRAY OF CHAR; VAR result : ARRAY OF CHAR);
      BEGIN (* AppendDamageText *)
        Strings.Insert (damage,result,HIGH (result));
      END AppendDamageText;
      
      PROCEDURE AppendDefenseBonuses (item : OStruct.InventoryItemRecord; VAR result : ARRAY OF CHAR);
        VAR
            temp : ARRAY [0..31] OF CHAR;
        
      BEGIN (* AppendDefenseBonuses *)
        IF ((item.object.armor <> 0) OR (item.object.class = OStruct.Helm)) THEN
          IF OSActions.InventoryItemIsKnown2 (item) THEN
            ReplaceSignedIntegerParameter (" [%ARMOR,%MODIFIER]","%MODIFIER",item.object.armorMOD,temp);
          ELSE
            Strings.Assign (" [%ARMOR]",temp);
          END; (* IF *)
          
          WString.ReplaceIntegerParameter (temp,"%ARMOR",item.object.armor,temp);
        ELSIF ((item.object.armorMOD <> 0) AND OSActions.InventoryItemIsKnown2 (item)) THEN
          ReplaceSignedIntegerParameter (" [%MODIFIER]","%MODIFIER",item.object.armorMOD,temp);
        ELSE
          temp [0] := 0C;
        END; (* IF *)
        
        Strings.Insert (temp,result,HIGH (result));
      END AppendDefenseBonuses;
      
      PROCEDURE AppendMiscellaneousValue (item : OStruct.InventoryItemRecord; miscellaneous : MiscellaneousUseMnemonic; VAR result : ARRAY OF CHAR);
        VAR
            temp : ARRAY [0..31] OF CHAR;
        
      BEGIN (* AppendMiscellaneousValue *)
        IF OStruct.IdentHideP1 IN item.identification THEN
          miscellaneous := IgnoreMiscellaneous;
        ELSIF OStruct.IdentShowP1 IN item.identification THEN
          miscellaneous := AlwaysShowSignedBonus;
        END; (* IF *)
        
        IF miscellaneous = ShowLightLife THEN
          WString.ReplaceCardinalParameter (" with %VALUE turns of light","%VALUE",item.object.miscellaneous,temp);
        ELSIF ((miscellaneous <> IgnoreMiscellaneous) AND OSActions.InventoryItemIsKnown2 (item)) THEN
          IF miscellaneous = AlwaysShowSignedBonus THEN
            ReplaceSignedIntegerParameter (" (%VALUE)","%VALUE",item.object.miscellaneous,temp);
          ELSIF miscellaneous = ShowCharges THEN
            WString.ReplaceCardinalParameter (" (%VALUE charges)","%VALUE",item.object.miscellaneous,temp);
          ELSIF item.object.miscellaneous <> 0 THEN
            IF miscellaneous = OptionalShowSignedBonus THEN
              ReplaceSignedIntegerParameter (" (%VALUE)","%VALUE",item.object.miscellaneous,temp);
            ELSIF miscellaneous = ShowObjectAttributeBonus THEN
              IF OStruct.Strength IN item.object.attributes THEN
                ReplaceSignedIntegerParameter (" (%VALUE to STR)","%VALUE",item.object.miscellaneous,temp);
              ELSIF OStruct.Stealth IN item.object.attributes THEN
                ReplaceSignedIntegerParameter (" (%VALUE to stealth)","%VALUE",item.object.miscellaneous,temp);
              END; (* IF *)
            END; (* IF *)
          END; (* IF *)
        ELSE
          temp [0] := 0C;
        END; (* IF *)
        
        Strings.Insert (temp,result,HIGH (result));
      END AppendMiscellaneousValue;
      
      PROCEDURE AppendSpecialName (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR result : ARRAY OF CHAR);
      BEGIN (* AppendSpecialName *)
        IF ((item.special <> OStruct.NameNull) AND OSActions.InventoryItemIsKnown2 (item)) THEN
          Strings.Insert (" ",result,HIGH (result));
          Strings.Insert (player^.treasures^.specials [item.special],result,HIGH (result));
        END; (* IF *)
      END AppendSpecialName;
      
      PROCEDURE RemoveDescriptionPrefix (VAR result : ARRAY OF CHAR);
      BEGIN (* RemoveDescriptionPrefix *)
        IF Strings.Pos ("some",result) = 0 THEN
          Strings.Delete (result,0,5);
        ELSIF result [0] = '&' THEN
          Strings.Delete (result,0,2);
        END; (* IF *)
      END RemoveDescriptionPrefix;
      
      PROCEDURE ReplaceSignedIntegerParameter (text : ARRAY OF CHAR; formal : ARRAY OF CHAR; actual : INTEGER; VAR result : ARRAY OF CHAR);
        VAR
            temp : ARRAY [0..15] OF CHAR;
        
      BEGIN (* ReplaceSignedIntegerParameter *)
        NumberConversion.IntToString (actual,temp,0);
        
        IF actual >= 0 THEN
          Strings.Insert ("+",temp,0);
        END; (* IF *)
        
        WString.ReplaceStringParameter (text,formal,temp,result);
      END ReplaceSignedIntegerParameter;
      
      PROCEDURE UpdateQuantityPrefix (item : OStruct.InventoryItemRecord; VAR result : ARRAY OF CHAR);
      BEGIN (* UpdateQuantityPrefix *)
        IF result [0] = '&' THEN
          IF item.object.quantity > 1 THEN
            WString.ReplaceCardinalParameter (result,"&",item.object.quantity,result);
          ELSIF item.object.quantity = 0 THEN
            WString.ReplaceStringParameter (result,"&","no more",result);
          ELSIF IsVowel (result [2]) THEN
            WString.ReplaceStringParameter (result,"&","an",result);
          ELSE
            WString.ReplaceStringParameter (result,"&","a",result);
          END; (* IF *)
        ELSIF item.object.quantity = 0 THEN
          IF Strings.Pos ("some",result) = 0 THEN
            WString.ReplaceStringParameter (result,"some","no more",result);
          ELSE
            Strings.Insert ("no more ",result,0);
          END; (* IF *)
        END; (* IF *)
      END UpdateQuantityPrefix;
      
      PROCEDURE UpdateIdentificationInformation (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; VAR result : ARRAY OF CHAR);
        VAR
            temp : ARRAY [0..127] OF CHAR;
        
        PROCEDURE ShouldAddTriedString (player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord) : BOOLEAN;
          VAR
              index : INTEGER;
          
        BEGIN (* ShouldAddTriedString *)
          index := OSActions.GlobalIdentificationIndex (item.object);
          
          RETURN ((index <> OStruct.InvalidGlobalIdentIndex) AND (OStruct.GlobalIdentTried IN player^.treasures^.identification [index]) AND NOT (OStruct.IdentStoreBought IN item.identification));
        END ShouldAddTriedString;
        
      BEGIN (* UpdateIdentificationInformation *)
        IF ShouldAddTriedString (player,item) THEN
          Strings.Assign ("tried ",temp);
        ELSE
          Strings.Assign ("",temp);
        END; (* IF *)
        
        IF OStruct.IdentMagic IN item.identification THEN
          Strings.Concat (temp,"magik ",temp);
        END; (* IF *)
        
        IF OStruct.IdentEmpty IN item.identification THEN
          Strings.Concat (temp,"empty ",temp);
        END; (* IF *)
        
        IF OStruct.IdentDamaged IN item.identification THEN
          Strings.Concat (temp,"damaged ",temp);
        END; (* IF *)
        
        IF Strings.Length (item.inscription) > 0 THEN
          Strings.Concat (temp,item.inscription,temp);
        END; (* IF *)
        
        IF Strings.Length (temp) > 0 THEN
          IF temp [Strings.Length (temp) - 1] = ' ' THEN
            temp [Strings.Length (temp) - 1] := 0C;
          END; (* IF *)
          
          WString.ReplaceStringParameter (" {%TEXT}","%TEXT",temp,temp);
          Strings.Insert (temp,result,HIGH (result));
        END; (* IF *)
      END UpdateIdentificationInformation;
      
    BEGIN (* UpdatePrefixInformation *)
      IF prefix THEN
        AppendSpecialName (player,item,result);
        AppendDamageText (damage,result);
        AppendAttackBonuses (player,item,result);
        AppendDefenseBonuses (item,result);
        AppendMiscellaneousValue (item,miscellaneous,result);
        UpdateQuantityPrefix (item,result);
        UpdateIdentificationInformation (player,item,result);
        
        Strings.Insert (".",result,HIGH (result));
      ELSE
        RemoveDescriptionPrefix (result);
      END; (* IF *)
    END UpdatePrefixInformation;
    
    PROCEDURE UpdateQuantitySuffix (text : ARRAY OF CHAR; quantity : CARDINAL; VAR result : ARRAY OF CHAR);
    BEGIN (* UpdateQuantitySuffix *)
      IF quantity <> 1 THEN
        WString.ReplaceStringParameter (text,"ch~","ches",result);
        WString.ReplaceStringParameter (result,"~","s",result);
      ELSE
        Strings.Delete (text,Strings.Pos ("~",text),1);
        Strings.Assign (text,result);
      END; (* IF *)
    END UpdateQuantitySuffix;
    
  BEGIN (* ReturnObjectDescription *)
    CASE item.object.class OF
       OStruct.HardBodyArmor : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.Miscellaneous : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.MissileWeapon : ReturnMissileWeaponDescription (player,item,prefix,result);  |
       OStruct.SoftBodyArmor : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.HaftedWeapon  : ReturnGeneralWeaponDescription (player,item,prefix,result);  |
       OStruct.BladeWeapon   : ReturnGeneralWeaponDescription (player,item,prefix,result);  |
       OStruct.DiggingTool   : ReturnDiggingToolDescription (player,item,prefix,result);    |
       OStruct.ClosedDoor    : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.PoleWeapon    : ReturnGeneralWeaponDescription (player,item,prefix,result);  |
       OStruct.PrayerBook    : ReturnPrayerBookDescription (player,item,prefix,result);     |
       OStruct.SecretDoor    : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.MagicBook     : ReturnMagicBookDescription (player,item,prefix,result);      |
       OStruct.SlingAmmo     : ReturnGeneralMissileDescription (player,item,prefix,result); |
       OStruct.Nothing       : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.OpenDoor      : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.Potion1       : ReturnPotionDescription (player,item,prefix,result);         |
       OStruct.Potion2       : ReturnPotionDescription (player,item,prefix,result);         |
       OStruct.Scroll1       : ReturnScrollDescription (player,item,prefix,result);         |
       OStruct.Scroll2       : ReturnScrollDescription (player,item,prefix,result);         |
       OStruct.Amulet        : ReturnAmuletDescription (player,item,prefix,result);         |
       OStruct.Gloves        : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.Rubble        : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.Shield        : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.Arrow         : ReturnGeneralMissileDescription (player,item,prefix,result); |
       OStruct.Boots         : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.Chest         : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.Cloak         : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.Flask         : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.Light         : ReturnLightDescription (player,item,prefix,result);          |
       OStruct.Spike         : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.Staff         : ReturnStaffDescription (player,item,prefix,result);          |
       OStruct.Bolt          : ReturnGeneralMissileDescription (player,item,prefix,result); |
       OStruct.Food          : ReturnFoodDescription (player,item,prefix,result);           |
       OStruct.Helm          : ReturnStandardObjectDescription (player,item,prefix,result); |
       OStruct.Ring          : ReturnRingDescription (player,item,prefix,result);           |
       OStruct.Wand          : ReturnWandDescription (player,item,prefix,result);           |
    
       OStruct.Gold : ReturnGoldDescription (player,item,result); |
       
       OStruct.InvisibleTrap : ReturnInvisibleTrapDescription (player,item,prefix,result); |
       OStruct.VisibleTrap   : ReturnVisibleTrapDescription (player,item,prefix,result); |
       
       OStruct.UpStair       : ReturnUpStairDescription (player,item,prefix,result); |
       OStruct.DownStair     : ReturnDownStairDescription (player,item,prefix,result); |
       OStruct.StoreDoor     : ReturnStoreDoorDescription (player,item,prefix,result); |
    ELSE
      WDebugging.FatalAppExit ("Unrecognized object class in ReturnObjectDescription.");
    END; (* IF *)
  END ReturnObjectDescription;
END ODescriptions.
